/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the ARM target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 85;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(ARMInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(ARMInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static ARMInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static ARMInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s1,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 16;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_NoHonorSignDependentRoundingBit = 75,
  Feature_HasV4TBit = 6,
  Feature_NoV4TBit = 7,
  Feature_HasV5TBit = 13,
  Feature_NoV5TBit = 65,
  Feature_HasV5TEBit = 11,
  Feature_HasV6Bit = 0,
  Feature_NoV6Bit = 9,
  Feature_HasV6MBit = 28,
  Feature_HasV8MBaselineBit = 35,
  Feature_HasV8_1MMainlineBit = 41,
  Feature_HasMVEIntBit = 63,
  Feature_HasMVEFloatBit = 64,
  Feature_HasCDEBit = 84,
  Feature_HasFPRegsBit = 42,
  Feature_HasFPRegs16Bit = 43,
  Feature_HasFPRegs64Bit = 76,
  Feature_HasV6T2Bit = 8,
  Feature_HasV6KBit = 18,
  Feature_HasV7Bit = 3,
  Feature_HasV8Bit = 55,
  Feature_PreV8Bit = 19,
  Feature_HasV8_1aBit = 78,
  Feature_HasV8_3aBit = 79,
  Feature_NoVFPBit = 22,
  Feature_HasVFP2Bit = 21,
  Feature_HasVFP3Bit = 52,
  Feature_HasVFP4Bit = 50,
  Feature_HasDPVFPBit = 44,
  Feature_HasFPARMv8Bit = 47,
  Feature_HasNEONBit = 53,
  Feature_HasSHA2Bit = 62,
  Feature_HasAESBit = 54,
  Feature_HasDotProdBit = 56,
  Feature_HasCRCBit = 14,
  Feature_HasLOBBit = 40,
  Feature_HasFP16Bit = 61,
  Feature_HasFullFP16Bit = 46,
  Feature_HasMatMulInt8Bit = 57,
  Feature_HasDivideInThumbBit = 37,
  Feature_HasDivideInARMBit = 12,
  Feature_HasDSPBit = 36,
  Feature_HasDBBit = 15,
  Feature_HasV7ClrexBit = 17,
  Feature_HasAcquireReleaseBit = 16,
  Feature_HasMPBit = 2,
  Feature_Has8MSecExtBit = 29,
  Feature_HasZCZBit = 58,
  Feature_UseNEONForFPBit = 82,
  Feature_DontUseNEONForFPBit = 45,
  Feature_IsThumbBit = 26,
  Feature_IsThumb1OnlyBit = 27,
  Feature_IsThumb2Bit = 34,
  Feature_IsNotMClassBit = 38,
  Feature_IsARMBit = 1,
  Feature_IsWindowsBit = 30,
  Feature_IsNotWindowsBit = 31,
  Feature_IsReadTPTPIDRURWBit = 68,
  Feature_IsReadTPTPIDRUROBit = 69,
  Feature_IsReadTPTPIDRPRWBit = 70,
  Feature_IsReadTPSoftBit = 20,
  Feature_UseNaClTrapBit = 4,
  Feature_DontUseNaClTrapBit = 5,
  Feature_UseMovtBit = 39,
  Feature_DontUseMovtBit = 23,
  Feature_UseMovtInPicBit = 24,
  Feature_DontUseMovtInPicBit = 25,
  Feature_UseFPVMLxBit = 49,
  Feature_SLSBLRMitigationBit = 67,
  Feature_NoSLSBLRMitigationBit = 66,
  Feature_UseMulOpsBit = 10,
  Feature_UseFusedMACBit = 51,
  Feature_HasFastVGETLNi32Bit = 59,
  Feature_HasSlowVGETLNi32Bit = 80,
  Feature_HasFastVDUP32Bit = 60,
  Feature_HasSlowVDUP32Bit = 81,
  Feature_UseVMOVSRBit = 48,
  Feature_DontUseVMOVSRBit = 83,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 77,
  Feature_GenExecuteOnlyBit = 33,
  Feature_DontGenExecuteOnlyBit = 32,
  Feature_GenT1ExecuteOnlyBit = 73,
  Feature_SignRetAddrBit = 72,
  Feature_NoSignRetAddrBit = 71,
};

PredicateBitset ARMInstructionSelector::
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!TM.Options.HonorSignDependentRoundingFPMath())
    Features.set(Feature_NoHonorSignDependentRoundingBit);
  if (Subtarget->hasV4TOps())
    Features.set(Feature_HasV4TBit);
  if (!Subtarget->hasV4TOps())
    Features.set(Feature_NoV4TBit);
  if (Subtarget->hasV5TOps())
    Features.set(Feature_HasV5TBit);
  if (!Subtarget->hasV5TOps())
    Features.set(Feature_NoV5TBit);
  if (Subtarget->hasV5TEOps())
    Features.set(Feature_HasV5TEBit);
  if (Subtarget->hasV6Ops())
    Features.set(Feature_HasV6Bit);
  if (!Subtarget->hasV6Ops())
    Features.set(Feature_NoV6Bit);
  if (Subtarget->hasV6MOps())
    Features.set(Feature_HasV6MBit);
  if (Subtarget->hasV8MBaselineOps())
    Features.set(Feature_HasV8MBaselineBit);
  if (Subtarget->hasV8_1MMainlineOps())
    Features.set(Feature_HasV8_1MMainlineBit);
  if (Subtarget->hasMVEIntegerOps())
    Features.set(Feature_HasMVEIntBit);
  if (Subtarget->hasMVEFloatOps())
    Features.set(Feature_HasMVEFloatBit);
  if (Subtarget->hasCDEOps())
    Features.set(Feature_HasCDEBit);
  if (Subtarget->hasFPRegs())
    Features.set(Feature_HasFPRegsBit);
  if (Subtarget->hasFPRegs16())
    Features.set(Feature_HasFPRegs16Bit);
  if (Subtarget->hasFPRegs64())
    Features.set(Feature_HasFPRegs64Bit);
  if (Subtarget->hasV6T2Ops())
    Features.set(Feature_HasV6T2Bit);
  if (Subtarget->hasV6KOps())
    Features.set(Feature_HasV6KBit);
  if (Subtarget->hasV7Ops())
    Features.set(Feature_HasV7Bit);
  if (Subtarget->hasV8Ops())
    Features.set(Feature_HasV8Bit);
  if (!Subtarget->hasV8Ops())
    Features.set(Feature_PreV8Bit);
  if (Subtarget->hasV8_1aOps())
    Features.set(Feature_HasV8_1aBit);
  if (Subtarget->hasV8_3aOps())
    Features.set(Feature_HasV8_3aBit);
  if (!Subtarget->hasVFP2Base())
    Features.set(Feature_NoVFPBit);
  if (Subtarget->hasVFP2Base())
    Features.set(Feature_HasVFP2Bit);
  if (Subtarget->hasVFP3Base())
    Features.set(Feature_HasVFP3Bit);
  if (Subtarget->hasVFP4Base())
    Features.set(Feature_HasVFP4Bit);
  if (Subtarget->hasFP64())
    Features.set(Feature_HasDPVFPBit);
  if (Subtarget->hasFPARMv8Base())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasLOB())
    Features.set(Feature_HasLOBBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasDivideInThumbMode())
    Features.set(Feature_HasDivideInThumbBit);
  if (Subtarget->hasDivideInARMMode())
    Features.set(Feature_HasDivideInARMBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDataBarrier())
    Features.set(Feature_HasDBBit);
  if (Subtarget->hasV7Clrex())
    Features.set(Feature_HasV7ClrexBit);
  if (Subtarget->hasAcquireRelease())
    Features.set(Feature_HasAcquireReleaseBit);
  if (Subtarget->hasMPExtension())
    Features.set(Feature_HasMPBit);
  if (Subtarget->has8MSecExt())
    Features.set(Feature_Has8MSecExtBit);
  if (Subtarget->hasZeroCycleZeroing())
    Features.set(Feature_HasZCZBit);
  if (Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseNEONForFPBit);
  if (!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseNEONForFPBit);
  if (Subtarget->isThumb())
    Features.set(Feature_IsThumbBit);
  if (Subtarget->isThumb1Only())
    Features.set(Feature_IsThumb1OnlyBit);
  if (Subtarget->isThumb2())
    Features.set(Feature_IsThumb2Bit);
  if (!Subtarget->isMClass())
    Features.set(Feature_IsNotMClassBit);
  if (!Subtarget->isThumb())
    Features.set(Feature_IsARMBit);
  if (Subtarget->isTargetWindows())
    Features.set(Feature_IsWindowsBit);
  if (!Subtarget->isTargetWindows())
    Features.set(Feature_IsNotWindowsBit);
  if (Subtarget->isReadTPTPIDRURW())
    Features.set(Feature_IsReadTPTPIDRURWBit);
  if (Subtarget->isReadTPTPIDRURO())
    Features.set(Feature_IsReadTPTPIDRUROBit);
  if (Subtarget->isReadTPTPIDRPRW())
    Features.set(Feature_IsReadTPTPIDRPRWBit);
  if (Subtarget->isReadTPSoft())
    Features.set(Feature_IsReadTPSoftBit);
  if (Subtarget->useNaClTrap())
    Features.set(Feature_UseNaClTrapBit);
  if (!Subtarget->useNaClTrap())
    Features.set(Feature_DontUseNaClTrapBit);
  if (Subtarget->useMulOps())
    Features.set(Feature_UseMulOpsBit);
  if (TM.Options.AllowFPOpFusion ==  FPOpFusion::Fast && Subtarget->useFPVFMx())
    Features.set(Feature_UseFusedMACBit);
  if (!Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasFastVGETLNi32Bit);
  if (Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasSlowVGETLNi32Bit);
  if (!Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasFastVDUP32Bit);
  if (Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasSlowVDUP32Bit);
  if (Subtarget->preferVMOVSR() ||!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseVMOVSRBit);
  if (!Subtarget->preferVMOVSR() &&Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseVMOVSRBit);
  if (Subtarget->genExecuteOnly())
    Features.set(Feature_GenExecuteOnlyBit);
  if (!Subtarget->genExecuteOnly())
    Features.set(Feature_DontGenExecuteOnlyBit);
  if (Subtarget->genExecuteOnly() && Subtarget->isThumb1Only() && !Subtarget->hasV8MBaselineOps())
    Features.set(Feature_GenT1ExecuteOnlyBit);
  return Features;
}

void ARMInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const ARMSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset ARMInstructionSelector::
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (Subtarget->useMovt())
    Features.set(Feature_UseMovtBit);
  if (!Subtarget->useMovt())
    Features.set(Feature_DontUseMovtBit);
  if (Subtarget->useMovt() && Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_UseMovtInPicBit);
  if (!Subtarget->useMovt() || !Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_DontUseMovtInPicBit);
  if (((Subtarget->useFPVMLx() &&  TM.Options.AllowFPOpFusion != FPOpFusion::Fast) ||Subtarget->hasMinSize()))
    Features.set(Feature_UseFPVMLxBit);
  if ( MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (MF->getDataLayout().isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (MF->getDataLayout().isBigEndian())
    Features.set(Feature_IsBEBit);
  if ( MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_SignRetAddrBit);
  if ( !MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_NoSignRetAddrBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
  GIFBS_HasFP16,
  GIFBS_HasFPARMv8,
  GIFBS_HasFPRegs,
  GIFBS_HasFullFP16,
  GIFBS_HasMVEFloat,
  GIFBS_HasMVEInt,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasVFP2,
  GIFBS_HasVFP3,
  GIFBS_HasVFP4,
  GIFBS_IsARM,
  GIFBS_IsThumb,
  GIFBS_IsThumb2,
  GIFBS_NoHonorSignDependentRounding,
  GIFBS_DontUseNEONForFP_HasVFP2,
  GIFBS_DontUseNaClTrap_IsARM,
  GIFBS_DontUseVMOVSR_HasNEON,
  GIFBS_Has8MSecExt_IsThumb,
  GIFBS_HasAES_HasV8,
  GIFBS_HasCRC_IsARM,
  GIFBS_HasCRC_IsThumb2,
  GIFBS_HasDB_IsARM,
  GIFBS_HasDB_IsThumb,
  GIFBS_HasDPVFP_HasFPARMv8,
  GIFBS_HasDPVFP_HasVFP2,
  GIFBS_HasDPVFP_HasVFP3,
  GIFBS_HasDPVFP_HasVFP4,
  GIFBS_HasDPVFP_NoHonorSignDependentRounding,
  GIFBS_HasDSP_IsThumb2,
  GIFBS_HasDivideInARM_IsARM,
  GIFBS_HasFP16_HasNEON,
  GIFBS_HasFPARMv8_HasNEON,
  GIFBS_HasFPRegs_HasFastVGETLNi32,
  GIFBS_HasFPRegs_UseVMOVSR,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasMVEInt_HasV8_1MMainline,
  GIFBS_HasMVEInt_IsBE,
  GIFBS_HasMVEInt_IsLE,
  GIFBS_HasNEON_HasV8,
  GIFBS_HasNEON_HasV8_1a,
  GIFBS_HasNEON_HasV8_3a,
  GIFBS_HasNEON_HasVFP4,
  GIFBS_HasNEON_IsBE,
  GIFBS_HasNEON_IsLE,
  GIFBS_HasNEON_UseNEONForFP,
  GIFBS_HasSHA2_HasV8,
  GIFBS_HasV5T_IsARM,
  GIFBS_HasV5T_IsThumb,
  GIFBS_HasV5TE_IsARM,
  GIFBS_HasV6_IsARM,
  GIFBS_HasV6K_IsARM,
  GIFBS_HasV6M_IsThumb,
  GIFBS_HasV6T2_IsARM,
  GIFBS_HasV7_IsARM,
  GIFBS_HasV7Clrex_IsThumb,
  GIFBS_HasV8MBaseline_IsThumb,
  GIFBS_IsARM_NoV5T,
  GIFBS_IsARM_NoV6,
  GIFBS_IsARM_PreV8,
  GIFBS_IsARM_UseNaClTrap,
  GIFBS_IsThumb_IsThumb1Only,
  GIFBS_IsThumb_IsWindows,
  GIFBS_IsThumb_NoV5T,
  GIFBS_IsThumb_UseMovt,
  GIFBS_IsThumb2_PreV8,
  GIFBS_IsThumb2_UseMulOps,
  GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only,
  GIFBS_HasDSP_IsThumb2_UseMulOps,
  GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb,
  GIFBS_HasFPARMv8_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEON_HasV8,
  GIFBS_HasFullFP16_HasNEON_HasV8_3a,
  GIFBS_HasFullFP16_HasNEON_UseFPVMLx,
  GIFBS_HasFullFP16_HasNEON_UseFusedMAC,
  GIFBS_HasLOB_HasV8_1MMainline_IsThumb2,
  GIFBS_HasNEON_UseFPVMLx_UseNEONForFP,
  GIFBS_HasV5TE_IsARM_UseMulOps,
  GIFBS_HasV6_IsARM_UseMulOps,
  GIFBS_HasV6_IsThumb_IsThumb1Only,
  GIFBS_HasV6T2_IsARM_UseMulOps,
  GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP,
  GIFBS_IsARM_NoV6_UseMulOps,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFPRegsBit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasMVEFloatBit, },
  {Feature_HasMVEIntBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasVFP2Bit, },
  {Feature_HasVFP3Bit, },
  {Feature_HasVFP4Bit, },
  {Feature_IsARMBit, },
  {Feature_IsThumbBit, },
  {Feature_IsThumb2Bit, },
  {Feature_NoHonorSignDependentRoundingBit, },
  {Feature_DontUseNEONForFPBit, Feature_HasVFP2Bit, },
  {Feature_DontUseNaClTrapBit, Feature_IsARMBit, },
  {Feature_DontUseVMOVSRBit, Feature_HasNEONBit, },
  {Feature_Has8MSecExtBit, Feature_IsThumbBit, },
  {Feature_HasAESBit, Feature_HasV8Bit, },
  {Feature_HasCRCBit, Feature_IsARMBit, },
  {Feature_HasCRCBit, Feature_IsThumb2Bit, },
  {Feature_HasDBBit, Feature_IsARMBit, },
  {Feature_HasDBBit, Feature_IsThumbBit, },
  {Feature_HasDPVFPBit, Feature_HasFPARMv8Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP2Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP3Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP4Bit, },
  {Feature_HasDPVFPBit, Feature_NoHonorSignDependentRoundingBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, },
  {Feature_HasDivideInARMBit, Feature_IsARMBit, },
  {Feature_HasFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasNEONBit, },
  {Feature_HasFPRegsBit, Feature_HasFastVGETLNi32Bit, },
  {Feature_HasFPRegsBit, Feature_UseVMOVSRBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasMVEIntBit, Feature_HasV8_1MMainlineBit, },
  {Feature_HasMVEIntBit, Feature_IsBEBit, },
  {Feature_HasMVEIntBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasNEONBit, Feature_HasV8_1aBit, },
  {Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasNEONBit, Feature_HasVFP4Bit, },
  {Feature_HasNEONBit, Feature_IsBEBit, },
  {Feature_HasNEONBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_UseNEONForFPBit, },
  {Feature_HasSHA2Bit, Feature_HasV8Bit, },
  {Feature_HasV5TBit, Feature_IsARMBit, },
  {Feature_HasV5TBit, Feature_IsThumbBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, },
  {Feature_HasV6KBit, Feature_IsARMBit, },
  {Feature_HasV6MBit, Feature_IsThumbBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, },
  {Feature_HasV7Bit, Feature_IsARMBit, },
  {Feature_HasV7ClrexBit, Feature_IsThumbBit, },
  {Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_IsARMBit, Feature_NoV5TBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, },
  {Feature_IsARMBit, Feature_PreV8Bit, },
  {Feature_IsARMBit, Feature_UseNaClTrapBit, },
  {Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_IsThumbBit, Feature_IsWindowsBit, },
  {Feature_IsThumbBit, Feature_NoV5TBit, },
  {Feature_IsThumbBit, Feature_UseMovtBit, },
  {Feature_IsThumb2Bit, Feature_PreV8Bit, },
  {Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_DontUseMovtBit, Feature_GenExecuteOnlyBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_HasDivideInThumbBit, Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_HasFPARMv8Bit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFPVMLxBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFusedMACBit, },
  {Feature_HasLOBBit, Feature_HasV8_1MMainlineBit, Feature_IsThumb2Bit, },
  {Feature_HasNEONBit, Feature_UseFPVMLxBit, Feature_UseNEONForFPBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasVFP4Bit, Feature_UseFusedMACBit, Feature_UseNEONForFPBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, Feature_UseMulOpsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

ARMInstructionSelector::ComplexMatcherMemFn
ARMInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_bf_inv_mask_imm = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_vfp_f32imm,
  GICXXPred_MI_Predicate_vfp_f64imm,
};
bool ARMInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_bf_inv_mask_imm: {
    
        // There's better methods of implementing this check. IntImmLeaf<> would be
        // equivalent and have less boilerplate but we need a test for C++
        // predicates and this one causes new rules to be imported into GlobalISel
        // without requiring additional features first.
        const auto &MO = MI.getOperand(1);
        if (!MO.isCImm())
          return false;
        return ARM::isBitFieldInvertedMask(MO.getCImm()->getZExtValue());
      
    llvm_unreachable("bf_inv_mask_imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f32imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP32Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f32imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f64imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP64Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f64imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex16,
  GICXXPred_I64_Predicate_VectorIndex32,
  GICXXPred_I64_Predicate_VectorIndex64,
  GICXXPred_I64_Predicate_asr_imm,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_32,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_239,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm0_255_expr,
  GICXXPred_I64_Predicate_imm0_4095,
  GICXXPred_I64_Predicate_imm0_65535,
  GICXXPred_I64_Predicate_imm0_65535_expr,
  GICXXPred_I64_Predicate_imm0_65535_neg,
  GICXXPred_I64_Predicate_imm1_7,
  GICXXPred_I64_Predicate_imm1_15,
  GICXXPred_I64_Predicate_imm1_16,
  GICXXPred_I64_Predicate_imm1_31,
  GICXXPred_I64_Predicate_imm8,
  GICXXPred_I64_Predicate_imm8_255,
  GICXXPred_I64_Predicate_imm8_or_16,
  GICXXPred_I64_Predicate_imm16,
  GICXXPred_I64_Predicate_imm16_31,
  GICXXPred_I64_Predicate_imm24b,
  GICXXPred_I64_Predicate_imm32,
  GICXXPred_I64_Predicate_imm256_510,
  GICXXPred_I64_Predicate_imm_3b,
  GICXXPred_I64_Predicate_imm_4b,
  GICXXPred_I64_Predicate_imm_6b,
  GICXXPred_I64_Predicate_imm_7b,
  GICXXPred_I64_Predicate_imm_9b,
  GICXXPred_I64_Predicate_imm_11b,
  GICXXPred_I64_Predicate_imm_12b,
  GICXXPred_I64_Predicate_imm_13b,
  GICXXPred_I64_Predicate_imm_even,
  GICXXPred_I64_Predicate_imm_odd,
  GICXXPred_I64_Predicate_imm_sr,
  GICXXPred_I64_Predicate_long_shift,
  GICXXPred_I64_Predicate_mod_imm,
  GICXXPred_I64_Predicate_mod_imm_not,
  GICXXPred_I64_Predicate_pkh_asr_amt,
  GICXXPred_I64_Predicate_pkh_lsl_amt,
  GICXXPred_I64_Predicate_shr_imm8,
  GICXXPred_I64_Predicate_shr_imm16,
  GICXXPred_I64_Predicate_shr_imm32,
  GICXXPred_I64_Predicate_shr_imm64,
  GICXXPred_I64_Predicate_t2_so_imm,
  GICXXPred_I64_Predicate_t2_so_imm_neg,
};
bool ARMInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex8: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex16: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex32: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex64: {
    
      return ((uint64_t)Imm) < 1;
    
  }
  case GICXXPred_I64_Predicate_asr_imm: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return Imm >= 0 && Imm < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return Imm >= 0 && Imm < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return Imm >= 0 && Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_32: {
    
      return Imm >= 0 && Imm < 33;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return Imm >= 0 && Imm < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_239: {
     return Imm >= 0 && Imm < 240; 
  }
  case GICXXPred_I64_Predicate_imm0_255: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_255_expr: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_4095: {
    
      return Imm >= 0 && Imm < 4096;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_expr: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_neg: {
    
      return -Imm >= 0 && -Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm1_7: {
     return Imm > 0 && Imm < 8; 
  }
  case GICXXPred_I64_Predicate_imm1_15: {
     return Imm > 0 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_imm1_16: {
    
        return Imm > 0 && Imm <= 16;
      
  }
  case GICXXPred_I64_Predicate_imm1_31: {
     return Imm > 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_imm8: {
     return Imm == 8; 
  }
  case GICXXPred_I64_Predicate_imm8_255: {
    
      return Imm >= 8 && Imm < 256;
    
  }
  case GICXXPred_I64_Predicate_imm8_or_16: {
     return Imm == 8 || Imm == 16;
  }
  case GICXXPred_I64_Predicate_imm16: {
     return Imm == 16; 
  }
  case GICXXPred_I64_Predicate_imm16_31: {
    
      return (int32_t)Imm >= 16 && (int32_t)Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm24b: {
    
      return Imm >= 0 && Imm <= 0xffffff;
    
  }
  case GICXXPred_I64_Predicate_imm32: {
     return Imm == 32; 
  }
  case GICXXPred_I64_Predicate_imm256_510: {
    
      return Imm >= 256 && Imm < 511;
    
  }
  case GICXXPred_I64_Predicate_imm_3b: {
    { return Imm >= 0 && Imm < (1 << 3); }
    llvm_unreachable("imm_3b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_4b: {
    { return Imm >= 0 && Imm < (1 << 4); }
    llvm_unreachable("imm_4b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_6b: {
    { return Imm >= 0 && Imm < (1 << 6); }
    llvm_unreachable("imm_6b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_7b: {
    { return Imm >= 0 && Imm < (1 << 7); }
    llvm_unreachable("imm_7b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_9b: {
    { return Imm >= 0 && Imm < (1 << 9); }
    llvm_unreachable("imm_9b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_11b: {
    { return Imm >= 0 && Imm < (1 << 11); }
    llvm_unreachable("imm_11b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_12b: {
    { return Imm >= 0 && Imm < (1 << 12); }
    llvm_unreachable("imm_12b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_13b: {
    { return Imm >= 0 && Imm < (1 << 13); }
    llvm_unreachable("imm_13b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_even: {
     return (Imm & 1) == 0; 
  }
  case GICXXPred_I64_Predicate_imm_odd: {
     return (Imm & 1) == 1; 
  }
  case GICXXPred_I64_Predicate_imm_sr: {
    
      return Imm > 0 && Imm <= 32;
    
  }
  case GICXXPred_I64_Predicate_long_shift: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_mod_imm: {
    
        return ARM_AM::getSOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_mod_imm_not: {
    
        return ARM_AM::getSOImmVal(~(uint32_t)Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_pkh_asr_amt: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_pkh_lsl_amt: {
     return Imm >= 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm8: {
     return Imm > 0 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_shr_imm16: {
     return Imm > 0 && Imm <= 16; 
  }
  case GICXXPred_I64_Predicate_shr_imm32: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm64: {
     return Imm > 0 && Imm <= 64; 
  }
  case GICXXPred_I64_Predicate_t2_so_imm: {
    
        return ARM_AM::getT2SOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_t2_so_imm_neg: {
    
      return Imm && ARM_AM::getT2SOImmVal(-(uint32_t)Imm) != -1;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_arm_i32imm = GICXXPred_Invalid + 1,
};
bool ARMInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_arm_i32imm: {
    
      if (Subtarget->useMovt())
        return true;
      if (ARM_AM::isSOImmTwoPartVal(Imm.getZExtValue()))
        return true;
      return ARM_AM::isSOImmTwoPartValNeg(Imm.getZExtValue());
    
    llvm_unreachable("arm_i32imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool ARMInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("ARMInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderInvertedImm,
  GICR_renderVFPF32Imm,
  GICR_renderVFPF64Imm,
};
ARMInstructionSelector::CustomRendererFn
ARMInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &ARMInstructionSelector::renderInvertedImm,
  &ARMInstructionSelector::renderVFPF32Imm,
  &ARMInstructionSelector::renderVFPF64Imm,
};

bool ARMInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool ARMInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("ARMInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *ARMInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(308), /*)*//*default:*//*Label 79*/ GIMT_Encode4(131027),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1030),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(10357),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(13601),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15305),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(15401), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(15497),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(18677),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(24486), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(26181), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(26568), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(35580),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(35876), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 12*/ GIMT_Encode4(36139), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 13*/ GIMT_Encode4(36244), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 14*/ GIMT_Encode4(36407), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 15*/ GIMT_Encode4(36428),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 16*/ GIMT_Encode4(91600), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 17*/ GIMT_Encode4(99262),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 18*/ GIMT_Encode4(99420),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 19*/ GIMT_Encode4(99578),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 20*/ GIMT_Encode4(99899), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 21*/ GIMT_Encode4(99995),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 22*/ GIMT_Encode4(100153),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 23*/ GIMT_Encode4(100758),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 24*/ GIMT_Encode4(100916),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 25*/ GIMT_Encode4(101132),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 26*/ GIMT_Encode4(101240), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 27*/ GIMT_Encode4(101513), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 28*/ GIMT_Encode4(101845),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 29*/ GIMT_Encode4(102093),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 30*/ GIMT_Encode4(102462),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 31*/ GIMT_Encode4(103107),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 32*/ GIMT_Encode4(104407),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 33*/ GIMT_Encode4(105052), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 34*/ GIMT_Encode4(106072),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 35*/ GIMT_Encode4(108425),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 36*/ GIMT_Encode4(110102),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 37*/ GIMT_Encode4(111083), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 38*/ GIMT_Encode4(113174), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 39*/ GIMT_Encode4(113339),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 40*/ GIMT_Encode4(114870),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 41*/ GIMT_Encode4(115106),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 42*/ GIMT_Encode4(115378),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 43*/ GIMT_Encode4(116712),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 44*/ GIMT_Encode4(118046),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 45*/ GIMT_Encode4(118698), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 46*/ GIMT_Encode4(119350), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 47*/ GIMT_Encode4(120126),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 48*/ GIMT_Encode4(120718), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 49*/ GIMT_Encode4(121310),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 50*/ GIMT_Encode4(122044), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    670 */ /*TargetOpcode::G_GET_FPENV*//*Label 51*/ GIMT_Encode4(122778),
     /*    674 */ /*TargetOpcode::G_SET_FPENV*//*Label 52*/ GIMT_Encode4(122811),
     /*    678 */ /*TargetOpcode::G_RESET_FPENV*//*Label 53*/ GIMT_Encode4(122847),
     /*    682 */ /*TargetOpcode::G_GET_FPMODE*//*Label 54*/ GIMT_Encode4(122976), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 55*/ GIMT_Encode4(123009),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 56*/ GIMT_Encode4(123552),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 57*/ GIMT_Encode4(124095),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 58*/ GIMT_Encode4(125016),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 59*/ GIMT_Encode4(125937), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 60*/ GIMT_Encode4(126408), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 61*/ GIMT_Encode4(126481),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 62*/ GIMT_Encode4(126781), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 63*/ GIMT_Encode4(126838), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 64*/ GIMT_Encode4(127399),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 65*/ GIMT_Encode4(127507),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 66*/ GIMT_Encode4(127797),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 67*/ GIMT_Encode4(128229), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 68*/ GIMT_Encode4(128492),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 69*/ GIMT_Encode4(128630),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 70*/ GIMT_Encode4(128893),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 71*/ GIMT_Encode4(129189), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 72*/ GIMT_Encode4(129327),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 73*/ GIMT_Encode4(129373), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 74*/ GIMT_Encode4(129460), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 75*/ GIMT_Encode4(129881),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 76*/ GIMT_Encode4(130161),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 77*/ GIMT_Encode4(130450),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 78*/ GIMT_Encode4(130731),
     /*   1030 */ // Label 0: @1030
     /*   1030 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 89*/ GIMT_Encode4(10356),
     /*   1041 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(1101),
     /*   1045 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(6877), GIMT_Encode4(0),
     /*   1053 */ /*GILLT_v2s32*//*Label 82*/ GIMT_Encode4(6924),
     /*   1057 */ /*GILLT_v2s64*//*Label 83*/ GIMT_Encode4(7109), GIMT_Encode4(0),
     /*   1065 */ /*GILLT_v4s16*//*Label 84*/ GIMT_Encode4(7820),
     /*   1069 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(8005), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1081 */ /*GILLT_v8s8*//*Label 86*/ GIMT_Encode4(8961),
     /*   1085 */ /*GILLT_v8s16*//*Label 87*/ GIMT_Encode4(9146), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1097 */ /*GILLT_v16s8*//*Label 88*/ GIMT_Encode4(10102),
     /*   1101 */ // Label 80: @1101
     /*   1101 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(6876),
     /*   1106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1112 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1187), // Rule ID 5670 //
     /*   1117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1145 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1162 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1185 */     GIR_RootConstrainSelectedInstOperands,
     /*   1186 */     // GIR_Coverage, 5670,
     /*   1186 */     GIR_EraseRootFromParent_Done,
     /*   1187 */   // Label 91: @1187
     /*   1187 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1262), // Rule ID 5671 //
     /*   1192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1220 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1237 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1260 */     GIR_RootConstrainSelectedInstOperands,
     /*   1261 */     // GIR_Coverage, 5671,
     /*   1261 */     GIR_EraseRootFromParent_Done,
     /*   1262 */   // Label 92: @1262
     /*   1262 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1337), // Rule ID 5705 //
     /*   1267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1295 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1312 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1335 */     GIR_RootConstrainSelectedInstOperands,
     /*   1336 */     // GIR_Coverage, 5705,
     /*   1336 */     GIR_EraseRootFromParent_Done,
     /*   1337 */   // Label 93: @1337
     /*   1337 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1412), // Rule ID 5706 //
     /*   1342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1370 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1387 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1410 */     GIR_RootConstrainSelectedInstOperands,
     /*   1411 */     // GIR_Coverage, 5706,
     /*   1411 */     GIR_EraseRootFromParent_Done,
     /*   1412 */   // Label 94: @1412
     /*   1412 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1487), // Rule ID 2000 //
     /*   1417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1449 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1462 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1485 */     GIR_RootConstrainSelectedInstOperands,
     /*   1486 */     // GIR_Coverage, 2000,
     /*   1486 */     GIR_EraseRootFromParent_Done,
     /*   1487 */   // Label 95: @1487
     /*   1487 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1562), // Rule ID 2001 //
     /*   1492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1524 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1537 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1560 */     GIR_RootConstrainSelectedInstOperands,
     /*   1561 */     // GIR_Coverage, 2001,
     /*   1561 */     GIR_EraseRootFromParent_Done,
     /*   1562 */   // Label 96: @1562
     /*   1562 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1637), // Rule ID 2239 //
     /*   1567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1599 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1612 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1635 */     GIR_RootConstrainSelectedInstOperands,
     /*   1636 */     // GIR_Coverage, 2239,
     /*   1636 */     GIR_EraseRootFromParent_Done,
     /*   1637 */   // Label 97: @1637
     /*   1637 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1712), // Rule ID 2240 //
     /*   1642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1674 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1687 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1710 */     GIR_RootConstrainSelectedInstOperands,
     /*   1711 */     // GIR_Coverage, 2240,
     /*   1711 */     GIR_EraseRootFromParent_Done,
     /*   1712 */   // Label 98: @1712
     /*   1712 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1840), // Rule ID 5681 //
     /*   1717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1773 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   1777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1789 */     // MIs[4] Rm
     /*   1789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1794 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   1798 */     // MIs[1] Operand 2
     /*   1798 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1815 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1838 */     GIR_RootConstrainSelectedInstOperands,
     /*   1839 */     // GIR_Coverage, 5681,
     /*   1839 */     GIR_EraseRootFromParent_Done,
     /*   1840 */   // Label 99: @1840
     /*   1840 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1968), // Rule ID 5682 //
     /*   1845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1901 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   1905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1913 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1917 */     // MIs[4] Rm
     /*   1917 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1922 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   1926 */     // MIs[1] Operand 2
     /*   1926 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1943 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1966 */     GIR_RootConstrainSelectedInstOperands,
     /*   1967 */     // GIR_Coverage, 5682,
     /*   1967 */     GIR_EraseRootFromParent_Done,
     /*   1968 */   // Label 100: @1968
     /*   1968 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2096), // Rule ID 2106 //
     /*   1973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2028 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2033 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   2037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2041 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2045 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2049 */     // MIs[4] Rm
     /*   2049 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2054 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   2058 */     // MIs[1] Operand 2
     /*   2058 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2071 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2094 */     GIR_RootConstrainSelectedInstOperands,
     /*   2095 */     // GIR_Coverage, 2106,
     /*   2095 */     GIR_EraseRootFromParent_Done,
     /*   2096 */   // Label 101: @2096
     /*   2096 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2224), // Rule ID 5680 //
     /*   2101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   2104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2161 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   2165 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2169 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2173 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2177 */     // MIs[4] Rm
     /*   2177 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2182 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   2186 */     // MIs[1] Operand 2
     /*   2186 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2197 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2199 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2222 */     GIR_RootConstrainSelectedInstOperands,
     /*   2223 */     // GIR_Coverage, 5680,
     /*   2223 */     GIR_EraseRootFromParent_Done,
     /*   2224 */   // Label 102: @2224
     /*   2224 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2334), // Rule ID 5449 //
     /*   2229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2273 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2289 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2298 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2308 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2332 */     GIR_RootConstrainSelectedInstOperands,
     /*   2333 */     // GIR_Coverage, 5449,
     /*   2333 */     GIR_EraseRootFromParent_Done,
     /*   2334 */   // Label 103: @2334
     /*   2334 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2444), // Rule ID 5486 //
     /*   2339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2383 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2408 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2418 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2442 */     GIR_RootConstrainSelectedInstOperands,
     /*   2443 */     // GIR_Coverage, 5486,
     /*   2443 */     GIR_EraseRootFromParent_Done,
     /*   2444 */   // Label 104: @2444
     /*   2444 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2554), // Rule ID 192 //
     /*   2449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2509 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2517 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2522 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2528 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2552 */     GIR_RootConstrainSelectedInstOperands,
     /*   2553 */     // GIR_Coverage, 192,
     /*   2553 */     GIR_EraseRootFromParent_Done,
     /*   2554 */   // Label 105: @2554
     /*   2554 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2664), // Rule ID 521 //
     /*   2559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2607 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2632 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2638 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2662 */     GIR_RootConstrainSelectedInstOperands,
     /*   2663 */     // GIR_Coverage, 521,
     /*   2663 */     GIR_EraseRootFromParent_Done,
     /*   2664 */   // Label 106: @2664
     /*   2664 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2777), // Rule ID 5448 //
     /*   2669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2734 */     // MIs[3] Operand 2
     /*   2734 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2751 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2775 */     GIR_RootConstrainSelectedInstOperands,
     /*   2776 */     // GIR_Coverage, 5448,
     /*   2776 */     GIR_EraseRootFromParent_Done,
     /*   2777 */   // Label 107: @2777
     /*   2777 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2890), // Rule ID 5485 //
     /*   2782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2842 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2847 */     // MIs[3] Operand 2
     /*   2847 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2864 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   2867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2888 */     GIR_RootConstrainSelectedInstOperands,
     /*   2889 */     // GIR_Coverage, 5485,
     /*   2889 */     GIR_EraseRootFromParent_Done,
     /*   2890 */   // Label 108: @2890
     /*   2890 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(3003), // Rule ID 5447 //
     /*   2895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2935 */     // MIs[2] Operand 2
     /*   2935 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   2946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2962 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2967 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2977 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3001 */     GIR_RootConstrainSelectedInstOperands,
     /*   3002 */     // GIR_Coverage, 5447,
     /*   3002 */     GIR_EraseRootFromParent_Done,
     /*   3003 */   // Label 109: @3003
     /*   3003 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3116), // Rule ID 5484 //
     /*   3008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3048 */     // MIs[2] Operand 2
     /*   3048 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3080 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3090 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3114 */     GIR_RootConstrainSelectedInstOperands,
     /*   3115 */     // GIR_Coverage, 5484,
     /*   3115 */     GIR_EraseRootFromParent_Done,
     /*   3116 */   // Label 110: @3116
     /*   3116 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3229), // Rule ID 191 //
     /*   3121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3169 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3190 */     // MIs[3] Operand 2
     /*   3190 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3203 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLATB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*   3206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3227 */     GIR_RootConstrainSelectedInstOperands,
     /*   3228 */     // GIR_Coverage, 191,
     /*   3228 */     GIR_EraseRootFromParent_Done,
     /*   3229 */   // Label 111: @3229
     /*   3229 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3342), // Rule ID 520 //
     /*   3234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3282 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3294 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3303 */     // MIs[3] Operand 2
     /*   3303 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3316 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLATB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*   3319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3340 */     GIR_RootConstrainSelectedInstOperands,
     /*   3341 */     // GIR_Coverage, 520,
     /*   3341 */     GIR_EraseRootFromParent_Done,
     /*   3342 */   // Label 112: @3342
     /*   3342 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3455), // Rule ID 190 //
     /*   3347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3391 */     // MIs[2] Operand 2
     /*   3391 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3414 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3418 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3423 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3429 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   3432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3453 */     GIR_RootConstrainSelectedInstOperands,
     /*   3454 */     // GIR_Coverage, 190,
     /*   3454 */     GIR_EraseRootFromParent_Done,
     /*   3455 */   // Label 113: @3455
     /*   3455 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(3568), // Rule ID 519 //
     /*   3460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3504 */     // MIs[2] Operand 2
     /*   3504 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3531 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3536 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3542 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3566 */     GIR_RootConstrainSelectedInstOperands,
     /*   3567 */     // GIR_Coverage, 519,
     /*   3567 */     GIR_EraseRootFromParent_Done,
     /*   3568 */   // Label 114: @3568
     /*   3568 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(3659), // Rule ID 5679 //
     /*   3573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3613 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3617 */     // MIs[1] Operand 2
     /*   3617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3634 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3657 */     GIR_RootConstrainSelectedInstOperands,
     /*   3658 */     // GIR_Coverage, 5679,
     /*   3658 */     GIR_EraseRootFromParent_Done,
     /*   3659 */   // Label 115: @3659
     /*   3659 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(3750), // Rule ID 2105 //
     /*   3664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3708 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3712 */     // MIs[1] Operand 2
     /*   3712 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3725 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3748 */     GIR_RootConstrainSelectedInstOperands,
     /*   3749 */     // GIR_Coverage, 2105,
     /*   3749 */     GIR_EraseRootFromParent_Done,
     /*   3750 */   // Label 116: @3750
     /*   3750 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3866), // Rule ID 5446 //
     /*   3755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3795 */     // MIs[2] Operand 2
     /*   3795 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3823 */     // MIs[3] Operand 2
     /*   3823 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3840 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   3843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3864 */     GIR_RootConstrainSelectedInstOperands,
     /*   3865 */     // GIR_Coverage, 5446,
     /*   3865 */     GIR_EraseRootFromParent_Done,
     /*   3866 */   // Label 117: @3866
     /*   3866 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(3982), // Rule ID 5483 //
     /*   3871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3911 */     // MIs[2] Operand 2
     /*   3911 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3939 */     // MIs[3] Operand 2
     /*   3939 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3956 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   3959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3980 */     GIR_RootConstrainSelectedInstOperands,
     /*   3981 */     // GIR_Coverage, 5483,
     /*   3981 */     GIR_EraseRootFromParent_Done,
     /*   3982 */   // Label 118: @3982
     /*   3982 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(4098), // Rule ID 189 //
     /*   3987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4031 */     // MIs[2] Operand 2
     /*   4031 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4059 */     // MIs[3] Operand 2
     /*   4059 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4072 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   4072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   4075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4096 */     GIR_RootConstrainSelectedInstOperands,
     /*   4097 */     // GIR_Coverage, 189,
     /*   4097 */     GIR_EraseRootFromParent_Done,
     /*   4098 */   // Label 119: @4098
     /*   4098 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(4214), // Rule ID 518 //
     /*   4103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   4106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4147 */     // MIs[2] Operand 2
     /*   4147 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4175 */     // MIs[3] Operand 2
     /*   4175 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4188 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   4188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   4191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4212 */     GIR_RootConstrainSelectedInstOperands,
     /*   4213 */     // GIR_Coverage, 518,
     /*   4213 */     GIR_EraseRootFromParent_Done,
     /*   4214 */   // Label 120: @4214
     /*   4214 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(4302), // Rule ID 3248 //
     /*   4219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4270 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4300 */     GIR_RootConstrainSelectedInstOperands,
     /*   4301 */     // GIR_Coverage, 3248,
     /*   4301 */     GIR_EraseRootFromParent_Done,
     /*   4302 */   // Label 121: @4302
     /*   4302 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(4390), // Rule ID 3249 //
     /*   4307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4358 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4388 */     GIR_RootConstrainSelectedInstOperands,
     /*   4389 */     // GIR_Coverage, 3249,
     /*   4389 */     GIR_EraseRootFromParent_Done,
     /*   4390 */   // Label 122: @4390
     /*   4390 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(4478), // Rule ID 3252 //
     /*   4395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4446 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4476 */     GIR_RootConstrainSelectedInstOperands,
     /*   4477 */     // GIR_Coverage, 3252,
     /*   4477 */     GIR_EraseRootFromParent_Done,
     /*   4478 */   // Label 123: @4478
     /*   4478 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(4566), // Rule ID 5950 //
     /*   4483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4534 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)))  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4564 */     GIR_RootConstrainSelectedInstOperands,
     /*   4565 */     // GIR_Coverage, 5950,
     /*   4565 */     GIR_EraseRootFromParent_Done,
     /*   4566 */   // Label 124: @4566
     /*   4566 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(4654), // Rule ID 5951 //
     /*   4571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4622 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)))  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4652 */     GIR_RootConstrainSelectedInstOperands,
     /*   4653 */     // GIR_Coverage, 5951,
     /*   4653 */     GIR_EraseRootFromParent_Done,
     /*   4654 */   // Label 125: @4654
     /*   4654 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(4742), // Rule ID 5954 //
     /*   4659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4710 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)))  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4740 */     GIR_RootConstrainSelectedInstOperands,
     /*   4741 */     // GIR_Coverage, 5954,
     /*   4741 */     GIR_EraseRootFromParent_Done,
     /*   4742 */   // Label 126: @4742
     /*   4742 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(4799), // Rule ID 72 //
     /*   4747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   4750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*   4770 */     // MIs[1] Operand 1
     /*   4770 */     // No operand predicates
     /*   4770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4772 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ADDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDri),
     /*   4775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4797 */     GIR_RootConstrainSelectedInstOperands,
     /*   4798 */     // GIR_Coverage, 72,
     /*   4798 */     GIR_EraseRootFromParent_Done,
     /*   4799 */   // Label 127: @4799
     /*   4799 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(4856), // Rule ID 303 //
     /*   4804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*   4827 */     // MIs[1] Operand 1
     /*   4827 */     // No operand predicates
     /*   4827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4829 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm3)  =>  (tADDi3:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm3)
     /*   4829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi3),
     /*   4832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   4842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm3
     /*   4845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4854 */     GIR_RootConstrainSelectedInstOperands,
     /*   4855 */     // GIR_Coverage, 303,
     /*   4855 */     GIR_EraseRootFromParent_Done,
     /*   4856 */   // Label 128: @4856
     /*   4856 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(4913), // Rule ID 304 //
     /*   4861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*   4884 */     // MIs[1] Operand 1
     /*   4884 */     // No operand predicates
     /*   4884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4886 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8)  =>  (tADDi8:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm8)
     /*   4886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi8),
     /*   4889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   4891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*   4902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4911 */     GIR_RootConstrainSelectedInstOperands,
     /*   4912 */     // GIR_Coverage, 304,
     /*   4912 */     GIR_EraseRootFromParent_Done,
     /*   4913 */   // Label 129: @4913
     /*   4913 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(4970), // Rule ID 407 //
     /*   4918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*   4941 */     // MIs[1] Operand 1
     /*   4941 */     // No operand predicates
     /*   4941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4943 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ADDri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri),
     /*   4946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4968 */     GIR_RootConstrainSelectedInstOperands,
     /*   4969 */     // GIR_Coverage, 407,
     /*   4969 */     GIR_EraseRootFromParent_Done,
     /*   4970 */   // Label 130: @4970
     /*   4970 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(5021), // Rule ID 408 //
     /*   4975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*   4998 */     // MIs[1] Operand 1
     /*   4998 */     // No operand predicates
     /*   4998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5000 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2ADDri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   5000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri12),
     /*   5003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   5010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5019 */     GIR_RootConstrainSelectedInstOperands,
     /*   5020 */     // GIR_Coverage, 408,
     /*   5020 */     GIR_EraseRootFromParent_Done,
     /*   5021 */   // Label 131: @5021
     /*   5021 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(5097), // Rule ID 171 //
     /*   5026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5065 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5095 */     GIR_RootConstrainSelectedInstOperands,
     /*   5096 */     // GIR_Coverage, 171,
     /*   5096 */     GIR_EraseRootFromParent_Done,
     /*   5097 */   // Label 132: @5097
     /*   5097 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(5173), // Rule ID 172 //
     /*   5102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5141 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5171 */     GIR_RootConstrainSelectedInstOperands,
     /*   5172 */     // GIR_Coverage, 172,
     /*   5172 */     GIR_EraseRootFromParent_Done,
     /*   5173 */   // Label 133: @5173
     /*   5173 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(5243), // Rule ID 503 //
     /*   5178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   5181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5217 */     // (add:{ *:[i32] } (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm), rGPR:{ *:[i32] }:$Ra)  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   5220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5241 */     GIR_RootConstrainSelectedInstOperands,
     /*   5242 */     // GIR_Coverage, 503,
     /*   5242 */     GIR_EraseRootFromParent_Done,
     /*   5243 */   // Label 134: @5243
     /*   5243 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(5314), // Rule ID 5672 //
     /*   5248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5272 */     // MIs[1] Operand 2
     /*   5272 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5289 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   5292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5312 */     GIR_RootConstrainSelectedInstOperands,
     /*   5313 */     // GIR_Coverage, 5672,
     /*   5313 */     GIR_EraseRootFromParent_Done,
     /*   5314 */   // Label 135: @5314
     /*   5314 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(5385), // Rule ID 5673 //
     /*   5319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5343 */     // MIs[1] Operand 2
     /*   5343 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5360 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   5363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5383 */     GIR_RootConstrainSelectedInstOperands,
     /*   5384 */     // GIR_Coverage, 5673,
     /*   5384 */     GIR_EraseRootFromParent_Done,
     /*   5385 */   // Label 136: @5385
     /*   5385 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(5456), // Rule ID 5707 //
     /*   5390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5414 */     // MIs[1] Operand 2
     /*   5414 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5431 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   5434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5454 */     GIR_RootConstrainSelectedInstOperands,
     /*   5455 */     // GIR_Coverage, 5707,
     /*   5455 */     GIR_EraseRootFromParent_Done,
     /*   5456 */   // Label 137: @5456
     /*   5456 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(5527), // Rule ID 5708 //
     /*   5461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5485 */     // MIs[1] Operand 2
     /*   5485 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5502 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   5505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5525 */     GIR_RootConstrainSelectedInstOperands,
     /*   5526 */     // GIR_Coverage, 5708,
     /*   5526 */     GIR_EraseRootFromParent_Done,
     /*   5527 */   // Label 138: @5527
     /*   5527 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(5597), // Rule ID 180 //
     /*   5532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5571 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm), GPR:{ *:[i32] }:$Ra)  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   5571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   5574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5595 */     GIR_RootConstrainSelectedInstOperands,
     /*   5596 */     // GIR_Coverage, 180,
     /*   5596 */     GIR_EraseRootFromParent_Done,
     /*   5597 */   // Label 139: @5597
     /*   5597 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(5667), // Rule ID 509 //
     /*   5602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   5605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5641 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   5644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   5650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5665 */     GIR_RootConstrainSelectedInstOperands,
     /*   5666 */     // GIR_Coverage, 509,
     /*   5666 */     GIR_EraseRootFromParent_Done,
     /*   5667 */   // Label 140: @5667
     /*   5667 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(5730), // Rule ID 3053 //
     /*   5672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5702 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   5702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   5705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5707 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5728 */     GIR_RootConstrainSelectedInstOperands,
     /*   5729 */     // GIR_Coverage, 3053,
     /*   5729 */     GIR_EraseRootFromParent_Done,
     /*   5730 */   // Label 141: @5730
     /*   5730 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(5793), // Rule ID 3081 //
     /*   5735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5765 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   5765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   5768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5770 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5791 */     GIR_RootConstrainSelectedInstOperands,
     /*   5792 */     // GIR_Coverage, 3081,
     /*   5792 */     GIR_EraseRootFromParent_Done,
     /*   5793 */   // Label 142: @5793
     /*   5793 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(5856), // Rule ID 3091 //
     /*   5798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5828 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   5828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   5831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5833 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5854 */     GIR_RootConstrainSelectedInstOperands,
     /*   5855 */     // GIR_Coverage, 3091,
     /*   5855 */     GIR_EraseRootFromParent_Done,
     /*   5856 */   // Label 143: @5856
     /*   5856 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(5932), // Rule ID 5443 //
     /*   5861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5900 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5930 */     GIR_RootConstrainSelectedInstOperands,
     /*   5931 */     // GIR_Coverage, 5443,
     /*   5931 */     GIR_EraseRootFromParent_Done,
     /*   5932 */   // Label 144: @5932
     /*   5932 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(6008), // Rule ID 5444 //
     /*   5937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5976 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6006 */     GIR_RootConstrainSelectedInstOperands,
     /*   6007 */     // GIR_Coverage, 5444,
     /*   6007 */     GIR_EraseRootFromParent_Done,
     /*   6008 */   // Label 145: @6008
     /*   6008 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(6078), // Rule ID 5481 //
     /*   6013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   6016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6052 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   6055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6076 */     GIR_RootConstrainSelectedInstOperands,
     /*   6077 */     // GIR_Coverage, 5481,
     /*   6077 */     GIR_EraseRootFromParent_Done,
     /*   6078 */   // Label 146: @6078
     /*   6078 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(6149), // Rule ID 2004 //
     /*   6083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6111 */     // MIs[1] Operand 2
     /*   6111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6124 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   6127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6147 */     GIR_RootConstrainSelectedInstOperands,
     /*   6148 */     // GIR_Coverage, 2004,
     /*   6148 */     GIR_EraseRootFromParent_Done,
     /*   6149 */   // Label 147: @6149
     /*   6149 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(6220), // Rule ID 2005 //
     /*   6154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6182 */     // MIs[1] Operand 2
     /*   6182 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6195 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6218 */     GIR_RootConstrainSelectedInstOperands,
     /*   6219 */     // GIR_Coverage, 2005,
     /*   6219 */     GIR_EraseRootFromParent_Done,
     /*   6220 */   // Label 148: @6220
     /*   6220 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(6291), // Rule ID 2243 //
     /*   6225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6253 */     // MIs[1] Operand 2
     /*   6253 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6266 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   6269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6289 */     GIR_RootConstrainSelectedInstOperands,
     /*   6290 */     // GIR_Coverage, 2243,
     /*   6290 */     GIR_EraseRootFromParent_Done,
     /*   6291 */   // Label 149: @6291
     /*   6291 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(6362), // Rule ID 2244 //
     /*   6296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6324 */     // MIs[1] Operand 2
     /*   6324 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6337 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   6340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6360 */     GIR_RootConstrainSelectedInstOperands,
     /*   6361 */     // GIR_Coverage, 2244,
     /*   6361 */     GIR_EraseRootFromParent_Done,
     /*   6362 */   // Label 150: @6362
     /*   6362 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(6432), // Rule ID 5445 //
     /*   6367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   6370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6406 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   6406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   6409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6430 */     GIR_RootConstrainSelectedInstOperands,
     /*   6431 */     // GIR_Coverage, 5445,
     /*   6431 */     GIR_EraseRootFromParent_Done,
     /*   6432 */   // Label 151: @6432
     /*   6432 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(6502), // Rule ID 5482 //
     /*   6437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6476 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn))  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   6479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   6485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6500 */     GIR_RootConstrainSelectedInstOperands,
     /*   6501 */     // GIR_Coverage, 5482,
     /*   6501 */     GIR_EraseRootFromParent_Done,
     /*   6502 */   // Label 152: @6502
     /*   6502 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(6565), // Rule ID 5926 //
     /*   6507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   6530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6537 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec))  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   6537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   6540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6542 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6563 */     GIR_RootConstrainSelectedInstOperands,
     /*   6564 */     // GIR_Coverage, 5926,
     /*   6564 */     GIR_EraseRootFromParent_Done,
     /*   6565 */   // Label 153: @6565
     /*   6565 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(6628), // Rule ID 5940 //
     /*   6570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   6593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6600 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec))  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   6600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   6603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6605 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6626 */     GIR_RootConstrainSelectedInstOperands,
     /*   6627 */     // GIR_Coverage, 5940,
     /*   6627 */     GIR_EraseRootFromParent_Done,
     /*   6628 */   // Label 154: @6628
     /*   6628 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(6691), // Rule ID 5945 //
     /*   6633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6663 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec))  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   6663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   6666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6668 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6689 */     GIR_RootConstrainSelectedInstOperands,
     /*   6690 */     // GIR_Coverage, 5945,
     /*   6690 */     GIR_EraseRootFromParent_Done,
     /*   6691 */   // Label 155: @6691
     /*   6691 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(6737), // Rule ID 73 //
     /*   6696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   6699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6711 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ADDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*   6711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDrr),
     /*   6714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6735 */     GIR_RootConstrainSelectedInstOperands,
     /*   6736 */     // GIR_Coverage, 73,
     /*   6736 */     GIR_EraseRootFromParent_Done,
     /*   6737 */   // Label 156: @6737
     /*   6737 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(6783), // Rule ID 305 //
     /*   6742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6757 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tADDrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*   6757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDrr),
     /*   6760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   6768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6781 */     GIR_RootConstrainSelectedInstOperands,
     /*   6782 */     // GIR_Coverage, 305,
     /*   6782 */     GIR_EraseRootFromParent_Done,
     /*   6783 */   // Label 157: @6783
     /*   6783 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(6829), // Rule ID 409 //
     /*   6788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6803 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6827 */     GIR_RootConstrainSelectedInstOperands,
     /*   6828 */     // GIR_Coverage, 409,
     /*   6828 */     GIR_EraseRootFromParent_Done,
     /*   6829 */   // Label 158: @6829
     /*   6829 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(6875), // Rule ID 5463 //
     /*   6834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6849 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   6858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6873 */     GIR_RootConstrainSelectedInstOperands,
     /*   6874 */     // GIR_Coverage, 5463,
     /*   6874 */     GIR_EraseRootFromParent_Done,
     /*   6875 */   // Label 159: @6875
     /*   6875 */   GIM_Reject,
     /*   6876 */ // Label 90: @6876
     /*   6876 */ GIM_Reject,
     /*   6877 */ // Label 81: @6877
     /*   6877 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(6923), // Rule ID 762 //
     /*   6882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6903 */   // (add:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VADDv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*   6903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv1i64),
     /*   6906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   6910 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   6912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6915 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6921 */   GIR_RootConstrainSelectedInstOperands,
     /*   6922 */   // GIR_Coverage, 762,
     /*   6922 */   GIR_EraseRootFromParent_Done,
     /*   6923 */ // Label 160: @6923
     /*   6923 */ GIM_Reject,
     /*   6924 */ // Label 82: @6924
     /*   6924 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(7108),
     /*   6929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6939 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(7005), // Rule ID 5532 //
     /*   6944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6979 */     // (add:{ *:[v2i32] } (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), DPR:{ *:[v2i32] }:$src1)  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   6979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   6982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   6990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   6994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7003 */     GIR_RootConstrainSelectedInstOperands,
     /*   7004 */     // GIR_Coverage, 5532,
     /*   7004 */     GIR_EraseRootFromParent_Done,
     /*   7005 */   // Label 162: @7005
     /*   7005 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(7071), // Rule ID 889 //
     /*   7010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7045 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   7048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7069 */     GIR_RootConstrainSelectedInstOperands,
     /*   7070 */     // GIR_Coverage, 889,
     /*   7070 */     GIR_EraseRootFromParent_Done,
     /*   7071 */   // Label 163: @7071
     /*   7071 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(7107), // Rule ID 758 //
     /*   7076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7087 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VADDv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i32),
     /*   7090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7105 */     GIR_RootConstrainSelectedInstOperands,
     /*   7106 */     // GIR_Coverage, 758,
     /*   7106 */     GIR_EraseRootFromParent_Done,
     /*   7107 */   // Label 164: @7107
     /*   7107 */   GIM_Reject,
     /*   7108 */ // Label 161: @7108
     /*   7108 */ GIM_Reject,
     /*   7109 */ // Label 83: @7109
     /*   7109 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(7819),
     /*   7114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   7120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7124 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(7192), // Rule ID 782 //
     /*   7129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7168 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7190 */     GIR_RootConstrainSelectedInstOperands,
     /*   7191 */     // GIR_Coverage, 782,
     /*   7191 */     GIR_EraseRootFromParent_Done,
     /*   7192 */   // Label 166: @7192
     /*   7192 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(7260), // Rule ID 781 //
     /*   7197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7236 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7258 */     GIR_RootConstrainSelectedInstOperands,
     /*   7259 */     // GIR_Coverage, 781,
     /*   7259 */     GIR_EraseRootFromParent_Done,
     /*   7260 */   // Label 167: @7260
     /*   7260 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(7328), // Rule ID 770 //
     /*   7265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7304 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv2i64),
     /*   7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7326 */     GIR_RootConstrainSelectedInstOperands,
     /*   7327 */     // GIR_Coverage, 770,
     /*   7327 */     GIR_EraseRootFromParent_Done,
     /*   7328 */   // Label 168: @7328
     /*   7328 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(7396), // Rule ID 780 //
     /*   7333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7372 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7394 */     GIR_RootConstrainSelectedInstOperands,
     /*   7395 */     // GIR_Coverage, 780,
     /*   7395 */     GIR_EraseRootFromParent_Done,
     /*   7396 */   // Label 169: @7396
     /*   7396 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(7464), // Rule ID 779 //
     /*   7401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7440 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7462 */     GIR_RootConstrainSelectedInstOperands,
     /*   7463 */     // GIR_Coverage, 779,
     /*   7463 */     GIR_EraseRootFromParent_Done,
     /*   7464 */   // Label 170: @7464
     /*   7464 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(7517), // Rule ID 5511 //
     /*   7469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7495 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7515 */     GIR_RootConstrainSelectedInstOperands,
     /*   7516 */     // GIR_Coverage, 5511,
     /*   7516 */     GIR_EraseRootFromParent_Done,
     /*   7517 */   // Label 171: @7517
     /*   7517 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(7570), // Rule ID 5505 //
     /*   7522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7548 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7568 */     GIR_RootConstrainSelectedInstOperands,
     /*   7569 */     // GIR_Coverage, 5505,
     /*   7569 */     GIR_EraseRootFromParent_Done,
     /*   7570 */   // Label 172: @7570
     /*   7570 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(7623), // Rule ID 5510 //
     /*   7575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7601 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7621 */     GIR_RootConstrainSelectedInstOperands,
     /*   7622 */     // GIR_Coverage, 5510,
     /*   7622 */     GIR_EraseRootFromParent_Done,
     /*   7623 */   // Label 173: @7623
     /*   7623 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7676), // Rule ID 791 //
     /*   7628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7654 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7674 */     GIR_RootConstrainSelectedInstOperands,
     /*   7675 */     // GIR_Coverage, 791,
     /*   7675 */     GIR_EraseRootFromParent_Done,
     /*   7676 */   // Label 174: @7676
     /*   7676 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(7729), // Rule ID 785 //
     /*   7681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7707 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7727 */     GIR_RootConstrainSelectedInstOperands,
     /*   7728 */     // GIR_Coverage, 785,
     /*   7728 */     GIR_EraseRootFromParent_Done,
     /*   7729 */   // Label 175: @7729
     /*   7729 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(7782), // Rule ID 790 //
     /*   7734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7760 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7780 */     GIR_RootConstrainSelectedInstOperands,
     /*   7781 */     // GIR_Coverage, 790,
     /*   7781 */     GIR_EraseRootFromParent_Done,
     /*   7782 */   // Label 176: @7782
     /*   7782 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(7818), // Rule ID 763 //
     /*   7787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7798 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VADDv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*   7798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i64),
     /*   7801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7816 */     GIR_RootConstrainSelectedInstOperands,
     /*   7817 */     // GIR_Coverage, 763,
     /*   7817 */     GIR_EraseRootFromParent_Done,
     /*   7818 */   // Label 177: @7818
     /*   7818 */   GIM_Reject,
     /*   7819 */ // Label 165: @7819
     /*   7819 */ GIM_Reject,
     /*   7820 */ // Label 84: @7820
     /*   7820 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(8004),
     /*   7825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7835 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(7901), // Rule ID 5531 //
     /*   7840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7875 */     // (add:{ *:[v4i16] } (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), DPR:{ *:[v4i16] }:$src1)  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7899 */     GIR_RootConstrainSelectedInstOperands,
     /*   7900 */     // GIR_Coverage, 5531,
     /*   7900 */     GIR_EraseRootFromParent_Done,
     /*   7901 */   // Label 179: @7901
     /*   7901 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(7967), // Rule ID 888 //
     /*   7906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7941 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7965 */     GIR_RootConstrainSelectedInstOperands,
     /*   7966 */     // GIR_Coverage, 888,
     /*   7966 */     GIR_EraseRootFromParent_Done,
     /*   7967 */   // Label 180: @7967
     /*   7967 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(8003), // Rule ID 757 //
     /*   7972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7983 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VADDv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i16),
     /*   7986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8001 */     GIR_RootConstrainSelectedInstOperands,
     /*   8002 */     // GIR_Coverage, 757,
     /*   8002 */     GIR_EraseRootFromParent_Done,
     /*   8003 */   // Label 181: @8003
     /*   8003 */   GIM_Reject,
     /*   8004 */ // Label 178: @8004
     /*   8004 */ GIM_Reject,
     /*   8005 */ // Label 85: @8005
     /*   8005 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(8960),
     /*   8010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8016 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(8088), // Rule ID 778 //
     /*   8021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8064 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8086 */     GIR_RootConstrainSelectedInstOperands,
     /*   8087 */     // GIR_Coverage, 778,
     /*   8087 */     GIR_EraseRootFromParent_Done,
     /*   8088 */   // Label 183: @8088
     /*   8088 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(8160), // Rule ID 777 //
     /*   8093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8136 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8158 */     GIR_RootConstrainSelectedInstOperands,
     /*   8159 */     // GIR_Coverage, 777,
     /*   8159 */     GIR_EraseRootFromParent_Done,
     /*   8160 */   // Label 184: @8160
     /*   8160 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(8232), // Rule ID 769 //
     /*   8165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8208 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv4i32),
     /*   8211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8230 */     GIR_RootConstrainSelectedInstOperands,
     /*   8231 */     // GIR_Coverage, 769,
     /*   8231 */     GIR_EraseRootFromParent_Done,
     /*   8232 */   // Label 185: @8232
     /*   8232 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(8304), // Rule ID 776 //
     /*   8237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8280 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8302 */     GIR_RootConstrainSelectedInstOperands,
     /*   8303 */     // GIR_Coverage, 776,
     /*   8303 */     GIR_EraseRootFromParent_Done,
     /*   8304 */   // Label 186: @8304
     /*   8304 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(8376), // Rule ID 775 //
     /*   8309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8352 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8374 */     GIR_RootConstrainSelectedInstOperands,
     /*   8375 */     // GIR_Coverage, 775,
     /*   8375 */     GIR_EraseRootFromParent_Done,
     /*   8376 */   // Label 187: @8376
     /*   8376 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(8446), // Rule ID 5535 //
     /*   8381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8420 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8444 */     GIR_RootConstrainSelectedInstOperands,
     /*   8445 */     // GIR_Coverage, 5535,
     /*   8445 */     GIR_EraseRootFromParent_Done,
     /*   8446 */   // Label 188: @8446
     /*   8446 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(8503), // Rule ID 5509 //
     /*   8451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8481 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 5509,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 189: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(8560), // Rule ID 5504 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8538 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8558 */     GIR_RootConstrainSelectedInstOperands,
     /*   8559 */     // GIR_Coverage, 5504,
     /*   8559 */     GIR_EraseRootFromParent_Done,
     /*   8560 */   // Label 190: @8560
     /*   8560 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(8617), // Rule ID 5508 //
     /*   8565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8595 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8615 */     GIR_RootConstrainSelectedInstOperands,
     /*   8616 */     // GIR_Coverage, 5508,
     /*   8616 */     GIR_EraseRootFromParent_Done,
     /*   8617 */   // Label 191: @8617
     /*   8617 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(8687), // Rule ID 892 //
     /*   8622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8661 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8685 */     GIR_RootConstrainSelectedInstOperands,
     /*   8686 */     // GIR_Coverage, 892,
     /*   8686 */     GIR_EraseRootFromParent_Done,
     /*   8687 */   // Label 192: @8687
     /*   8687 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(8744), // Rule ID 789 //
     /*   8692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8722 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8742 */     GIR_RootConstrainSelectedInstOperands,
     /*   8743 */     // GIR_Coverage, 789,
     /*   8743 */     GIR_EraseRootFromParent_Done,
     /*   8744 */   // Label 193: @8744
     /*   8744 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(8801), // Rule ID 784 //
     /*   8749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8779 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8799 */     GIR_RootConstrainSelectedInstOperands,
     /*   8800 */     // GIR_Coverage, 784,
     /*   8800 */     GIR_EraseRootFromParent_Done,
     /*   8801 */   // Label 194: @8801
     /*   8801 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(8858), // Rule ID 788 //
     /*   8806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8836 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8856 */     GIR_RootConstrainSelectedInstOperands,
     /*   8857 */     // GIR_Coverage, 788,
     /*   8857 */     GIR_EraseRootFromParent_Done,
     /*   8858 */   // Label 195: @8858
     /*   8858 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(8898), // Rule ID 761 //
     /*   8863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8878 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VADDv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i32),
     /*   8881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8896 */     GIR_RootConstrainSelectedInstOperands,
     /*   8897 */     // GIR_Coverage, 761,
     /*   8897 */     GIR_EraseRootFromParent_Done,
     /*   8898 */   // Label 196: @8898
     /*   8898 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(8959), // Rule ID 3496 //
     /*   8903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   8906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8918 */     // (add:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*   8918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*   8921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi32),
     /*   8933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*   8935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*   8937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*   8939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   8942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8957 */     GIR_RootConstrainSelectedInstOperands,
     /*   8958 */     // GIR_Coverage, 3496,
     /*   8958 */     GIR_EraseRootFromParent_Done,
     /*   8959 */   // Label 197: @8959
     /*   8959 */   GIM_Reject,
     /*   8960 */ // Label 182: @8960
     /*   8960 */ GIM_Reject,
     /*   8961 */ // Label 86: @8961
     /*   8961 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(9145),
     /*   8966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8976 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(9042), // Rule ID 5530 //
     /*   8981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9016 */     // (add:{ *:[v8i8] } (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm), DPR:{ *:[v8i8] }:$src1)  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9040 */     GIR_RootConstrainSelectedInstOperands,
     /*   9041 */     // GIR_Coverage, 5530,
     /*   9041 */     GIR_EraseRootFromParent_Done,
     /*   9042 */   // Label 199: @9042
     /*   9042 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(9108), // Rule ID 887 //
     /*   9047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9082 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9106 */     GIR_RootConstrainSelectedInstOperands,
     /*   9107 */     // GIR_Coverage, 887,
     /*   9107 */     GIR_EraseRootFromParent_Done,
     /*   9108 */   // Label 200: @9108
     /*   9108 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(9144), // Rule ID 756 //
     /*   9113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9124 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VADDv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i8),
     /*   9127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   9133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9142 */     GIR_RootConstrainSelectedInstOperands,
     /*   9143 */     // GIR_Coverage, 756,
     /*   9143 */     GIR_EraseRootFromParent_Done,
     /*   9144 */   // Label 201: @9144
     /*   9144 */   GIM_Reject,
     /*   9145 */ // Label 198: @9145
     /*   9145 */ GIM_Reject,
     /*   9146 */ // Label 87: @9146
     /*   9146 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(10101),
     /*   9151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9157 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(9229), // Rule ID 774 //
     /*   9162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9205 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9227 */     GIR_RootConstrainSelectedInstOperands,
     /*   9228 */     // GIR_Coverage, 774,
     /*   9228 */     GIR_EraseRootFromParent_Done,
     /*   9229 */   // Label 203: @9229
     /*   9229 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(9301), // Rule ID 773 //
     /*   9234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9277 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9299 */     GIR_RootConstrainSelectedInstOperands,
     /*   9300 */     // GIR_Coverage, 773,
     /*   9300 */     GIR_EraseRootFromParent_Done,
     /*   9301 */   // Label 204: @9301
     /*   9301 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(9373), // Rule ID 768 //
     /*   9306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9349 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv8i16),
     /*   9352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9371 */     GIR_RootConstrainSelectedInstOperands,
     /*   9372 */     // GIR_Coverage, 768,
     /*   9372 */     GIR_EraseRootFromParent_Done,
     /*   9373 */   // Label 205: @9373
     /*   9373 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(9445), // Rule ID 772 //
     /*   9378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9421 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9443 */     GIR_RootConstrainSelectedInstOperands,
     /*   9444 */     // GIR_Coverage, 772,
     /*   9444 */     GIR_EraseRootFromParent_Done,
     /*   9445 */   // Label 206: @9445
     /*   9445 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(9517), // Rule ID 771 //
     /*   9450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9493 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9515 */     GIR_RootConstrainSelectedInstOperands,
     /*   9516 */     // GIR_Coverage, 771,
     /*   9516 */     GIR_EraseRootFromParent_Done,
     /*   9517 */   // Label 207: @9517
     /*   9517 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(9587), // Rule ID 5534 //
     /*   9522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9561 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm), QPR:{ *:[v8i16] }:$src1)  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9585 */     GIR_RootConstrainSelectedInstOperands,
     /*   9586 */     // GIR_Coverage, 5534,
     /*   9586 */     GIR_EraseRootFromParent_Done,
     /*   9587 */   // Label 208: @9587
     /*   9587 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(9644), // Rule ID 5507 //
     /*   9592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9622 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9642 */     GIR_RootConstrainSelectedInstOperands,
     /*   9643 */     // GIR_Coverage, 5507,
     /*   9643 */     GIR_EraseRootFromParent_Done,
     /*   9644 */   // Label 209: @9644
     /*   9644 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(9701), // Rule ID 5503 //
     /*   9649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9679 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9699 */     GIR_RootConstrainSelectedInstOperands,
     /*   9700 */     // GIR_Coverage, 5503,
     /*   9700 */     GIR_EraseRootFromParent_Done,
     /*   9701 */   // Label 210: @9701
     /*   9701 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(9758), // Rule ID 5506 //
     /*   9706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9736 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9756 */     GIR_RootConstrainSelectedInstOperands,
     /*   9757 */     // GIR_Coverage, 5506,
     /*   9757 */     GIR_EraseRootFromParent_Done,
     /*   9758 */   // Label 211: @9758
     /*   9758 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(9828), // Rule ID 891 //
     /*   9763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9802 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9826 */     GIR_RootConstrainSelectedInstOperands,
     /*   9827 */     // GIR_Coverage, 891,
     /*   9827 */     GIR_EraseRootFromParent_Done,
     /*   9828 */   // Label 212: @9828
     /*   9828 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(9885), // Rule ID 787 //
     /*   9833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9863 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9883 */     GIR_RootConstrainSelectedInstOperands,
     /*   9884 */     // GIR_Coverage, 787,
     /*   9884 */     GIR_EraseRootFromParent_Done,
     /*   9885 */   // Label 213: @9885
     /*   9885 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(9942), // Rule ID 783 //
     /*   9890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9920 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9940 */     GIR_RootConstrainSelectedInstOperands,
     /*   9941 */     // GIR_Coverage, 783,
     /*   9941 */     GIR_EraseRootFromParent_Done,
     /*   9942 */   // Label 214: @9942
     /*   9942 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(9999), // Rule ID 786 //
     /*   9947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9977 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9997 */     GIR_RootConstrainSelectedInstOperands,
     /*   9998 */     // GIR_Coverage, 786,
     /*   9998 */     GIR_EraseRootFromParent_Done,
     /*   9999 */   // Label 215: @9999
     /*   9999 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(10039), // Rule ID 760 //
     /*  10004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10019 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VADDv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  10019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i16),
     /*  10022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10037 */     GIR_RootConstrainSelectedInstOperands,
     /*  10038 */     // GIR_Coverage, 760,
     /*  10038 */     GIR_EraseRootFromParent_Done,
     /*  10039 */   // Label 216: @10039
     /*  10039 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(10100), // Rule ID 3492 //
     /*  10044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10059 */     // (add:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  10059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi16),
     /*  10074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10098 */     GIR_RootConstrainSelectedInstOperands,
     /*  10099 */     // GIR_Coverage, 3492,
     /*  10099 */     GIR_EraseRootFromParent_Done,
     /*  10100 */   // Label 217: @10100
     /*  10100 */   GIM_Reject,
     /*  10101 */ // Label 202: @10101
     /*  10101 */ GIM_Reject,
     /*  10102 */ // Label 88: @10102
     /*  10102 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(10355),
     /*  10107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10113 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(10183), // Rule ID 5533 //
     /*  10118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10157 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm), QPR:{ *:[v16i8] }:$src1)  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10181 */     GIR_RootConstrainSelectedInstOperands,
     /*  10182 */     // GIR_Coverage, 5533,
     /*  10182 */     GIR_EraseRootFromParent_Done,
     /*  10183 */   // Label 219: @10183
     /*  10183 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(10253), // Rule ID 890 //
     /*  10188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10227 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10251 */     GIR_RootConstrainSelectedInstOperands,
     /*  10252 */     // GIR_Coverage, 890,
     /*  10252 */     GIR_EraseRootFromParent_Done,
     /*  10253 */   // Label 220: @10253
     /*  10253 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(10293), // Rule ID 759 //
     /*  10258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10273 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VADDv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv16i8),
     /*  10276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10291 */     GIR_RootConstrainSelectedInstOperands,
     /*  10292 */     // GIR_Coverage, 759,
     /*  10292 */     GIR_EraseRootFromParent_Done,
     /*  10293 */   // Label 221: @10293
     /*  10293 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(10354), // Rule ID 3488 //
     /*  10298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10313 */     // (add:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  10313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi8),
     /*  10328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10352 */     GIR_RootConstrainSelectedInstOperands,
     /*  10353 */     // GIR_Coverage, 3488,
     /*  10353 */     GIR_EraseRootFromParent_Done,
     /*  10354 */   // Label 222: @10354
     /*  10354 */   GIM_Reject,
     /*  10355 */ // Label 218: @10355
     /*  10355 */ GIM_Reject,
     /*  10356 */ // Label 89: @10356
     /*  10356 */ GIM_Reject,
     /*  10357 */ // Label 1: @10357
     /*  10357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 232*/ GIMT_Encode4(13600),
     /*  10368 */ /*GILLT_s32*//*Label 223*/ GIMT_Encode4(10428),
     /*  10372 */ /*GILLT_s64*//*Label 224*/ GIMT_Encode4(11042), GIMT_Encode4(0),
     /*  10380 */ /*GILLT_v2s32*//*Label 225*/ GIMT_Encode4(11089),
     /*  10384 */ /*GILLT_v2s64*//*Label 226*/ GIMT_Encode4(11204), GIMT_Encode4(0),
     /*  10392 */ /*GILLT_v4s16*//*Label 227*/ GIMT_Encode4(11756),
     /*  10396 */ /*GILLT_v4s32*//*Label 228*/ GIMT_Encode4(11871), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10408 */ /*GILLT_v8s8*//*Label 229*/ GIMT_Encode4(12586),
     /*  10412 */ /*GILLT_v8s16*//*Label 230*/ GIMT_Encode4(12701), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10424 */ /*GILLT_v16s8*//*Label 231*/ GIMT_Encode4(13416),
     /*  10428 */ // Label 223: @10428
     /*  10428 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(11041),
     /*  10433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  10436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  10439 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10483), // Rule ID 330 //
     /*  10444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  10455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10459 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, tGPR:{ *:[i32] }:$Rn)  =>  (tRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  10459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tRSB),
     /*  10462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10481 */     GIR_RootConstrainSelectedInstOperands,
     /*  10482 */     // GIR_Coverage, 330,
     /*  10482 */     GIR_EraseRootFromParent_Done,
     /*  10483 */   // Label 234: @10483
     /*  10483 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10540), // Rule ID 96 //
     /*  10488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10507 */     // MIs[1] Operand 1
     /*  10507 */     // No operand predicates
     /*  10507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10513 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, GPR:{ *:[i32] }:$Rn)  =>  (RSBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RSBri),
     /*  10516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10538 */     GIR_RootConstrainSelectedInstOperands,
     /*  10539 */     // GIR_Coverage, 96,
     /*  10539 */     GIR_EraseRootFromParent_Done,
     /*  10540 */   // Label 235: @10540
     /*  10540 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10597), // Rule ID 427 //
     /*  10545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10564 */     // MIs[1] Operand 1
     /*  10564 */     // No operand predicates
     /*  10564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10570 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, rGPR:{ *:[i32] }:$Rn)  =>  (t2RSBri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RSBri),
     /*  10573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10595 */     GIR_RootConstrainSelectedInstOperands,
     /*  10596 */     // GIR_Coverage, 427,
     /*  10596 */     GIR_EraseRootFromParent_Done,
     /*  10597 */   // Label 236: @10597
     /*  10597 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10654), // Rule ID 76 //
     /*  10602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10625 */     // MIs[1] Operand 1
     /*  10625 */     // No operand predicates
     /*  10625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10627 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (SUBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBri),
     /*  10630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10652 */     GIR_RootConstrainSelectedInstOperands,
     /*  10653 */     // GIR_Coverage, 76,
     /*  10653 */     GIR_EraseRootFromParent_Done,
     /*  10654 */   // Label 237: @10654
     /*  10654 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10711), // Rule ID 411 //
     /*  10659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10682 */     // MIs[1] Operand 1
     /*  10682 */     // No operand predicates
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2SUBri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri),
     /*  10687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10709 */     GIR_RootConstrainSelectedInstOperands,
     /*  10710 */     // GIR_Coverage, 411,
     /*  10710 */     GIR_EraseRootFromParent_Done,
     /*  10711 */   // Label 238: @10711
     /*  10711 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10762), // Rule ID 412 //
     /*  10716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*  10739 */     // MIs[1] Operand 1
     /*  10739 */     // No operand predicates
     /*  10739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10741 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2SUBri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri12),
     /*  10744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10760 */     GIR_RootConstrainSelectedInstOperands,
     /*  10761 */     // GIR_Coverage, 412,
     /*  10761 */     GIR_EraseRootFromParent_Done,
     /*  10762 */   // Label 239: @10762
     /*  10762 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10832), // Rule ID 173 //
     /*  10767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM_UseMulOps),
     /*  10770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10806 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (MLS:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  10806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLS),
     /*  10809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10830 */     GIR_RootConstrainSelectedInstOperands,
     /*  10831 */     // GIR_Coverage, 173,
     /*  10831 */     GIR_EraseRootFromParent_Done,
     /*  10832 */   // Label 240: @10832
     /*  10832 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10902), // Rule ID 504 //
     /*  10837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*  10840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10876 */     // (sub:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLS:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  10876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLS),
     /*  10879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10900 */     GIR_RootConstrainSelectedInstOperands,
     /*  10901 */     // GIR_Coverage, 504,
     /*  10901 */     GIR_EraseRootFromParent_Done,
     /*  10902 */   // Label 241: @10902
     /*  10902 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10948), // Rule ID 77 //
     /*  10907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10922 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SUBrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBrr),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10946 */     GIR_RootConstrainSelectedInstOperands,
     /*  10947 */     // GIR_Coverage, 77,
     /*  10947 */     GIR_EraseRootFromParent_Done,
     /*  10948 */   // Label 242: @10948
     /*  10948 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10994), // Rule ID 333 //
     /*  10953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10968 */     // (sub:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tSUBrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  10968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSUBrr),
     /*  10971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10992 */     GIR_RootConstrainSelectedInstOperands,
     /*  10993 */     // GIR_Coverage, 333,
     /*  10993 */     GIR_EraseRootFromParent_Done,
     /*  10994 */   // Label 243: @10994
     /*  10994 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11040), // Rule ID 413 //
     /*  10999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  11002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  11014 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SUBrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  11014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBrr),
     /*  11017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  11023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11038 */     GIR_RootConstrainSelectedInstOperands,
     /*  11039 */     // GIR_Coverage, 413,
     /*  11039 */     GIR_EraseRootFromParent_Done,
     /*  11040 */   // Label 244: @11040
     /*  11040 */   GIM_Reject,
     /*  11041 */ // Label 233: @11041
     /*  11041 */ GIM_Reject,
     /*  11042 */ // Label 224: @11042
     /*  11042 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11088), // Rule ID 966 //
     /*  11047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11068 */   // (sub:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VSUBv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  11068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv1i64),
     /*  11071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11075 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11080 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11086 */   GIR_RootConstrainSelectedInstOperands,
     /*  11087 */   // GIR_Coverage, 966,
     /*  11087 */   GIR_EraseRootFromParent_Done,
     /*  11088 */ // Label 245: @11088
     /*  11088 */ GIM_Reject,
     /*  11089 */ // Label 225: @11089
     /*  11089 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11203),
     /*  11094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11108 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11170), // Rule ID 917 //
     /*  11113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11144 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv2i32),
     /*  11147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11168 */     GIR_RootConstrainSelectedInstOperands,
     /*  11169 */     // GIR_Coverage, 917,
     /*  11169 */     GIR_EraseRootFromParent_Done,
     /*  11170 */   // Label 247: @11170
     /*  11170 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11202), // Rule ID 962 //
     /*  11175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11182 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VSUBv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i32),
     /*  11185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11200 */     GIR_RootConstrainSelectedInstOperands,
     /*  11201 */     // GIR_Coverage, 962,
     /*  11201 */     GIR_EraseRootFromParent_Done,
     /*  11202 */   // Label 248: @11202
     /*  11202 */   GIM_Reject,
     /*  11203 */ // Label 246: @11203
     /*  11203 */ GIM_Reject,
     /*  11204 */ // Label 226: @11204
     /*  11204 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11755),
     /*  11209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  11212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  11215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11219 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11287), // Rule ID 986 //
     /*  11224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11263 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11285 */     GIR_RootConstrainSelectedInstOperands,
     /*  11286 */     // GIR_Coverage, 986,
     /*  11286 */     GIR_EraseRootFromParent_Done,
     /*  11287 */   // Label 250: @11287
     /*  11287 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11355), // Rule ID 985 //
     /*  11292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11331 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11353 */     GIR_RootConstrainSelectedInstOperands,
     /*  11354 */     // GIR_Coverage, 985,
     /*  11354 */     GIR_EraseRootFromParent_Done,
     /*  11355 */   // Label 251: @11355
     /*  11355 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11423), // Rule ID 974 //
     /*  11360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11399 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv2i64),
     /*  11402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11421 */     GIR_RootConstrainSelectedInstOperands,
     /*  11422 */     // GIR_Coverage, 974,
     /*  11422 */     GIR_EraseRootFromParent_Done,
     /*  11423 */   // Label 252: @11423
     /*  11423 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11491), // Rule ID 984 //
     /*  11428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11467 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11489 */     GIR_RootConstrainSelectedInstOperands,
     /*  11490 */     // GIR_Coverage, 984,
     /*  11490 */     GIR_EraseRootFromParent_Done,
     /*  11491 */   // Label 253: @11491
     /*  11491 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11559), // Rule ID 983 //
     /*  11496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11535 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11557 */     GIR_RootConstrainSelectedInstOperands,
     /*  11558 */     // GIR_Coverage, 983,
     /*  11558 */     GIR_EraseRootFromParent_Done,
     /*  11559 */   // Label 254: @11559
     /*  11559 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11612), // Rule ID 995 //
     /*  11564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11590 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11610 */     GIR_RootConstrainSelectedInstOperands,
     /*  11611 */     // GIR_Coverage, 995,
     /*  11611 */     GIR_EraseRootFromParent_Done,
     /*  11612 */   // Label 255: @11612
     /*  11612 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11665), // Rule ID 989 //
     /*  11617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11643 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv2i64),
     /*  11646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11663 */     GIR_RootConstrainSelectedInstOperands,
     /*  11664 */     // GIR_Coverage, 989,
     /*  11664 */     GIR_EraseRootFromParent_Done,
     /*  11665 */   // Label 256: @11665
     /*  11665 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11718), // Rule ID 994 //
     /*  11670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11696 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11716 */     GIR_RootConstrainSelectedInstOperands,
     /*  11717 */     // GIR_Coverage, 994,
     /*  11717 */     GIR_EraseRootFromParent_Done,
     /*  11718 */   // Label 257: @11718
     /*  11718 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11754), // Rule ID 967 //
     /*  11723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11734 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VSUBv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  11734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i64),
     /*  11737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11752 */     GIR_RootConstrainSelectedInstOperands,
     /*  11753 */     // GIR_Coverage, 967,
     /*  11753 */     GIR_EraseRootFromParent_Done,
     /*  11754 */   // Label 258: @11754
     /*  11754 */   GIM_Reject,
     /*  11755 */ // Label 249: @11755
     /*  11755 */ GIM_Reject,
     /*  11756 */ // Label 227: @11756
     /*  11756 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11870),
     /*  11761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11775 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11837), // Rule ID 916 //
     /*  11780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11811 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i16),
     /*  11814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11835 */     GIR_RootConstrainSelectedInstOperands,
     /*  11836 */     // GIR_Coverage, 916,
     /*  11836 */     GIR_EraseRootFromParent_Done,
     /*  11837 */   // Label 260: @11837
     /*  11837 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11869), // Rule ID 961 //
     /*  11842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11849 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VSUBv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i16),
     /*  11852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11867 */     GIR_RootConstrainSelectedInstOperands,
     /*  11868 */     // GIR_Coverage, 961,
     /*  11868 */     GIR_EraseRootFromParent_Done,
     /*  11869 */   // Label 261: @11869
     /*  11869 */   GIM_Reject,
     /*  11870 */ // Label 259: @11870
     /*  11870 */ GIM_Reject,
     /*  11871 */ // Label 228: @11871
     /*  11871 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12585),
     /*  11876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11882 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11954), // Rule ID 982 //
     /*  11887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11930 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11952 */     GIR_RootConstrainSelectedInstOperands,
     /*  11953 */     // GIR_Coverage, 982,
     /*  11953 */     GIR_EraseRootFromParent_Done,
     /*  11954 */   // Label 263: @11954
     /*  11954 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12026), // Rule ID 981 //
     /*  11959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12002 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12024 */     GIR_RootConstrainSelectedInstOperands,
     /*  12025 */     // GIR_Coverage, 981,
     /*  12025 */     GIR_EraseRootFromParent_Done,
     /*  12026 */   // Label 264: @12026
     /*  12026 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12098), // Rule ID 973 //
     /*  12031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12074 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv4i32),
     /*  12077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12096 */     GIR_RootConstrainSelectedInstOperands,
     /*  12097 */     // GIR_Coverage, 973,
     /*  12097 */     GIR_EraseRootFromParent_Done,
     /*  12098 */   // Label 265: @12098
     /*  12098 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12170), // Rule ID 980 //
     /*  12103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12146 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12168 */     GIR_RootConstrainSelectedInstOperands,
     /*  12169 */     // GIR_Coverage, 980,
     /*  12169 */     GIR_EraseRootFromParent_Done,
     /*  12170 */   // Label 266: @12170
     /*  12170 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12242), // Rule ID 979 //
     /*  12175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12218 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12240 */     GIR_RootConstrainSelectedInstOperands,
     /*  12241 */     // GIR_Coverage, 979,
     /*  12241 */     GIR_EraseRootFromParent_Done,
     /*  12242 */   // Label 267: @12242
     /*  12242 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12312), // Rule ID 920 //
     /*  12247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12286 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i32),
     /*  12289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12310 */     GIR_RootConstrainSelectedInstOperands,
     /*  12311 */     // GIR_Coverage, 920,
     /*  12311 */     GIR_EraseRootFromParent_Done,
     /*  12312 */   // Label 268: @12312
     /*  12312 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12369), // Rule ID 993 //
     /*  12317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12347 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12367 */     GIR_RootConstrainSelectedInstOperands,
     /*  12368 */     // GIR_Coverage, 993,
     /*  12368 */     GIR_EraseRootFromParent_Done,
     /*  12369 */   // Label 269: @12369
     /*  12369 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12426), // Rule ID 988 //
     /*  12374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12404 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv4i32),
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12424 */     GIR_RootConstrainSelectedInstOperands,
     /*  12425 */     // GIR_Coverage, 988,
     /*  12425 */     GIR_EraseRootFromParent_Done,
     /*  12426 */   // Label 270: @12426
     /*  12426 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12483), // Rule ID 992 //
     /*  12431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12461 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12481 */     GIR_RootConstrainSelectedInstOperands,
     /*  12482 */     // GIR_Coverage, 992,
     /*  12482 */     GIR_EraseRootFromParent_Done,
     /*  12483 */   // Label 271: @12483
     /*  12483 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12523), // Rule ID 965 //
     /*  12488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12503 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VSUBv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i32),
     /*  12506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12521 */     GIR_RootConstrainSelectedInstOperands,
     /*  12522 */     // GIR_Coverage, 965,
     /*  12522 */     GIR_EraseRootFromParent_Done,
     /*  12523 */   // Label 272: @12523
     /*  12523 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12584), // Rule ID 3508 //
     /*  12528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  12531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12543 */     // (sub:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VSUBi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  12543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi32),
     /*  12558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  12560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  12562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  12564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  12567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  12582 */     GIR_RootConstrainSelectedInstOperands,
     /*  12583 */     // GIR_Coverage, 3508,
     /*  12583 */     GIR_EraseRootFromParent_Done,
     /*  12584 */   // Label 273: @12584
     /*  12584 */   GIM_Reject,
     /*  12585 */ // Label 262: @12585
     /*  12585 */ GIM_Reject,
     /*  12586 */ // Label 229: @12586
     /*  12586 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12700),
     /*  12591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12605 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12667), // Rule ID 915 //
     /*  12610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12641 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i8),
     /*  12644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12665 */     GIR_RootConstrainSelectedInstOperands,
     /*  12666 */     // GIR_Coverage, 915,
     /*  12666 */     GIR_EraseRootFromParent_Done,
     /*  12667 */   // Label 275: @12667
     /*  12667 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(12699), // Rule ID 960 //
     /*  12672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12679 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSUBv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i8),
     /*  12682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12697 */     GIR_RootConstrainSelectedInstOperands,
     /*  12698 */     // GIR_Coverage, 960,
     /*  12698 */     GIR_EraseRootFromParent_Done,
     /*  12699 */   // Label 276: @12699
     /*  12699 */   GIM_Reject,
     /*  12700 */ // Label 274: @12700
     /*  12700 */ GIM_Reject,
     /*  12701 */ // Label 230: @12701
     /*  12701 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13415),
     /*  12706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  12709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  12712 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12784), // Rule ID 978 //
     /*  12717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12760 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12782 */     GIR_RootConstrainSelectedInstOperands,
     /*  12783 */     // GIR_Coverage, 978,
     /*  12783 */     GIR_EraseRootFromParent_Done,
     /*  12784 */   // Label 278: @12784
     /*  12784 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12856), // Rule ID 977 //
     /*  12789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12832 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12854 */     GIR_RootConstrainSelectedInstOperands,
     /*  12855 */     // GIR_Coverage, 977,
     /*  12855 */     GIR_EraseRootFromParent_Done,
     /*  12856 */   // Label 279: @12856
     /*  12856 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(12928), // Rule ID 972 //
     /*  12861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12904 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv8i16),
     /*  12907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12926 */     GIR_RootConstrainSelectedInstOperands,
     /*  12927 */     // GIR_Coverage, 972,
     /*  12927 */     GIR_EraseRootFromParent_Done,
     /*  12928 */   // Label 280: @12928
     /*  12928 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13000), // Rule ID 976 //
     /*  12933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12976 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12998 */     GIR_RootConstrainSelectedInstOperands,
     /*  12999 */     // GIR_Coverage, 976,
     /*  12999 */     GIR_EraseRootFromParent_Done,
     /*  13000 */   // Label 281: @13000
     /*  13000 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13072), // Rule ID 975 //
     /*  13005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13048 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  13051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13070 */     GIR_RootConstrainSelectedInstOperands,
     /*  13071 */     // GIR_Coverage, 975,
     /*  13071 */     GIR_EraseRootFromParent_Done,
     /*  13072 */   // Label 282: @13072
     /*  13072 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13142), // Rule ID 919 //
     /*  13077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13116 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i16),
     /*  13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13121 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13140 */     GIR_RootConstrainSelectedInstOperands,
     /*  13141 */     // GIR_Coverage, 919,
     /*  13141 */     GIR_EraseRootFromParent_Done,
     /*  13142 */   // Label 283: @13142
     /*  13142 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13199), // Rule ID 991 //
     /*  13147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13177 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13197 */     GIR_RootConstrainSelectedInstOperands,
     /*  13198 */     // GIR_Coverage, 991,
     /*  13198 */     GIR_EraseRootFromParent_Done,
     /*  13199 */   // Label 284: @13199
     /*  13199 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13256), // Rule ID 987 //
     /*  13204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13234 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv8i16),
     /*  13237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13254 */     GIR_RootConstrainSelectedInstOperands,
     /*  13255 */     // GIR_Coverage, 987,
     /*  13255 */     GIR_EraseRootFromParent_Done,
     /*  13256 */   // Label 285: @13256
     /*  13256 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13313), // Rule ID 990 //
     /*  13261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13291 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13311 */     GIR_RootConstrainSelectedInstOperands,
     /*  13312 */     // GIR_Coverage, 990,
     /*  13312 */     GIR_EraseRootFromParent_Done,
     /*  13313 */   // Label 286: @13313
     /*  13313 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13353), // Rule ID 964 //
     /*  13318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13333 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VSUBv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i16),
     /*  13336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13351 */     GIR_RootConstrainSelectedInstOperands,
     /*  13352 */     // GIR_Coverage, 964,
     /*  13352 */     GIR_EraseRootFromParent_Done,
     /*  13353 */   // Label 287: @13353
     /*  13353 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13414), // Rule ID 3504 //
     /*  13358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13373 */     // (sub:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VSUBi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  13373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi16),
     /*  13388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13412 */     GIR_RootConstrainSelectedInstOperands,
     /*  13413 */     // GIR_Coverage, 3504,
     /*  13413 */     GIR_EraseRootFromParent_Done,
     /*  13414 */   // Label 288: @13414
     /*  13414 */   GIM_Reject,
     /*  13415 */ // Label 277: @13415
     /*  13415 */ GIM_Reject,
     /*  13416 */ // Label 231: @13416
     /*  13416 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13599),
     /*  13421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13427 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13497), // Rule ID 918 //
     /*  13432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13471 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv16i8),
     /*  13474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13495 */     GIR_RootConstrainSelectedInstOperands,
     /*  13496 */     // GIR_Coverage, 918,
     /*  13496 */     GIR_EraseRootFromParent_Done,
     /*  13497 */   // Label 290: @13497
     /*  13497 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13537), // Rule ID 963 //
     /*  13502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13517 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSUBv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv16i8),
     /*  13520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13535 */     GIR_RootConstrainSelectedInstOperands,
     /*  13536 */     // GIR_Coverage, 963,
     /*  13536 */     GIR_EraseRootFromParent_Done,
     /*  13537 */   // Label 291: @13537
     /*  13537 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(13598), // Rule ID 3500 //
     /*  13542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13557 */     // (sub:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VSUBi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  13557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi8),
     /*  13572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13596 */     GIR_RootConstrainSelectedInstOperands,
     /*  13597 */     // GIR_Coverage, 3500,
     /*  13597 */     GIR_EraseRootFromParent_Done,
     /*  13598 */   // Label 292: @13598
     /*  13598 */   GIM_Reject,
     /*  13599 */ // Label 289: @13599
     /*  13599 */ GIM_Reject,
     /*  13600 */ // Label 232: @13600
     /*  13600 */ GIM_Reject,
     /*  13601 */ // Label 2: @13601
     /*  13601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 300*/ GIMT_Encode4(15304),
     /*  13612 */ /*GILLT_s32*//*Label 293*/ GIMT_Encode4(13672), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13624 */ /*GILLT_v2s32*//*Label 294*/ GIMT_Encode4(14591), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13636 */ /*GILLT_v4s16*//*Label 295*/ GIMT_Encode4(14638),
     /*  13640 */ /*GILLT_v4s32*//*Label 296*/ GIMT_Encode4(14685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13652 */ /*GILLT_v8s8*//*Label 297*/ GIMT_Encode4(14914),
     /*  13656 */ /*GILLT_v8s16*//*Label 298*/ GIMT_Encode4(14961), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13668 */ /*GILLT_v16s8*//*Label 299*/ GIMT_Encode4(15190),
     /*  13672 */ // Label 293: @13672
     /*  13672 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(14590),
     /*  13677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  13680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  13683 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(13771), // Rule ID 186 //
     /*  13688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13747 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  13750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13769 */     GIR_RootConstrainSelectedInstOperands,
     /*  13770 */     // GIR_Coverage, 186,
     /*  13770 */     GIR_EraseRootFromParent_Done,
     /*  13771 */   // Label 302: @13771
     /*  13771 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(13859), // Rule ID 515 //
     /*  13776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13829 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13835 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  13835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  13838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13857 */     GIR_RootConstrainSelectedInstOperands,
     /*  13858 */     // GIR_Coverage, 515,
     /*  13858 */     GIR_EraseRootFromParent_Done,
     /*  13859 */   // Label 303: @13859
     /*  13859 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(13950), // Rule ID 185 //
     /*  13864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13913 */     // MIs[2] Operand 2
     /*  13913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13926 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  13929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13948 */     GIR_RootConstrainSelectedInstOperands,
     /*  13949 */     // GIR_Coverage, 185,
     /*  13949 */     GIR_EraseRootFromParent_Done,
     /*  13950 */   // Label 304: @13950
     /*  13950 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(14041), // Rule ID 514 //
     /*  13955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14004 */     // MIs[2] Operand 2
     /*  14004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14017 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  14020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14039 */     GIR_RootConstrainSelectedInstOperands,
     /*  14040 */     // GIR_Coverage, 514,
     /*  14040 */     GIR_EraseRootFromParent_Done,
     /*  14041 */   // Label 305: @14041
     /*  14041 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(14132), // Rule ID 184 //
     /*  14046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14070 */     // MIs[1] Operand 2
     /*  14070 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14108 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  14111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14130 */     GIR_RootConstrainSelectedInstOperands,
     /*  14131 */     // GIR_Coverage, 184,
     /*  14131 */     GIR_EraseRootFromParent_Done,
     /*  14132 */   // Label 306: @14132
     /*  14132 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14223), // Rule ID 513 //
     /*  14137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14161 */     // MIs[1] Operand 2
     /*  14161 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14199 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  14202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14221 */     GIR_RootConstrainSelectedInstOperands,
     /*  14222 */     // GIR_Coverage, 513,
     /*  14222 */     GIR_EraseRootFromParent_Done,
     /*  14223 */   // Label 307: @14223
     /*  14223 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(14317), // Rule ID 183 //
     /*  14228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14252 */     // MIs[1] Operand 2
     /*  14252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14280 */     // MIs[2] Operand 2
     /*  14280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14293 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  14296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14315 */     GIR_RootConstrainSelectedInstOperands,
     /*  14316 */     // GIR_Coverage, 183,
     /*  14316 */     GIR_EraseRootFromParent_Done,
     /*  14317 */   // Label 308: @14317
     /*  14317 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(14411), // Rule ID 512 //
     /*  14322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14346 */     // MIs[1] Operand 2
     /*  14346 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14374 */     // MIs[2] Operand 2
     /*  14374 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14387 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  14390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14409 */     GIR_RootConstrainSelectedInstOperands,
     /*  14410 */     // GIR_Coverage, 512,
     /*  14410 */     GIR_EraseRootFromParent_Done,
     /*  14411 */   // Label 309: @14411
     /*  14411 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(14457), // Rule ID 169 //
     /*  14416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  14419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14431 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MUL:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MUL),
     /*  14434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14455 */     GIR_RootConstrainSelectedInstOperands,
     /*  14456 */     // GIR_Coverage, 169,
     /*  14456 */     GIR_EraseRootFromParent_Done,
     /*  14457 */   // Label 310: @14457
     /*  14457 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(14503), // Rule ID 170 //
     /*  14462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6_UseMulOps),
     /*  14465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14477 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MULv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MULv5),
     /*  14480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14501 */     GIR_RootConstrainSelectedInstOperands,
     /*  14502 */     // GIR_Coverage, 170,
     /*  14502 */     GIR_EraseRootFromParent_Done,
     /*  14503 */   // Label 311: @14503
     /*  14503 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(14549), // Rule ID 323 //
     /*  14508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  14511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14523 */     // (mul:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tMUL:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  14523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMUL),
     /*  14526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  14534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14547 */     GIR_RootConstrainSelectedInstOperands,
     /*  14548 */     // GIR_Coverage, 323,
     /*  14548 */     GIR_EraseRootFromParent_Done,
     /*  14549 */   // Label 312: @14549
     /*  14549 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(14589), // Rule ID 502 //
     /*  14554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  14557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14569 */     // (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2MUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MUL),
     /*  14572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14587 */     GIR_RootConstrainSelectedInstOperands,
     /*  14588 */     // GIR_Coverage, 502,
     /*  14588 */     GIR_EraseRootFromParent_Done,
     /*  14589 */   // Label 313: @14589
     /*  14589 */   GIM_Reject,
     /*  14590 */ // Label 301: @14590
     /*  14590 */ GIM_Reject,
     /*  14591 */ // Label 294: @14591
     /*  14591 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(14637), // Rule ID 837 //
     /*  14596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14617 */   // (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMULv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  14617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv2i32),
     /*  14620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14624 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14629 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14635 */   GIR_RootConstrainSelectedInstOperands,
     /*  14636 */   // GIR_Coverage, 837,
     /*  14636 */   GIR_EraseRootFromParent_Done,
     /*  14637 */ // Label 314: @14637
     /*  14637 */ GIM_Reject,
     /*  14638 */ // Label 295: @14638
     /*  14638 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(14684), // Rule ID 836 //
     /*  14643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14664 */   // (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMULv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  14664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i16),
     /*  14667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14669 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14671 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14676 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14682 */   GIR_RootConstrainSelectedInstOperands,
     /*  14683 */   // GIR_Coverage, 836,
     /*  14683 */   GIR_EraseRootFromParent_Done,
     /*  14684 */ // Label 315: @14684
     /*  14684 */ GIM_Reject,
     /*  14685 */ // Label 296: @14685
     /*  14685 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(14913),
     /*  14690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14696 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(14811), // Rule ID 4421 //
     /*  14701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14725 */     // MIs[1] Operand 2
     /*  14725 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14753 */     // MIs[2] Operand 2
     /*  14753 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14766 */     // (mul:{ *:[v4i32] } (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, v4i16:{ *:[Other] }), (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src2, v4i16:{ *:[Other] }))  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)
     /*  14766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  14781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  14791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14809 */     GIR_RootConstrainSelectedInstOperands,
     /*  14810 */     // GIR_Coverage, 4421,
     /*  14810 */     GIR_EraseRootFromParent_Done,
     /*  14811 */   // Label 317: @14811
     /*  14811 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(14851), // Rule ID 840 //
     /*  14816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14831 */     // (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMULv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  14831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i32),
     /*  14834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14849 */     GIR_RootConstrainSelectedInstOperands,
     /*  14850 */     // GIR_Coverage, 840,
     /*  14850 */     GIR_EraseRootFromParent_Done,
     /*  14851 */   // Label 318: @14851
     /*  14851 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(14912), // Rule ID 3466 //
     /*  14856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14871 */     // (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  14871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi32),
     /*  14886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  14890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  14892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14910 */     GIR_RootConstrainSelectedInstOperands,
     /*  14911 */     // GIR_Coverage, 3466,
     /*  14911 */     GIR_EraseRootFromParent_Done,
     /*  14912 */   // Label 319: @14912
     /*  14912 */   GIM_Reject,
     /*  14913 */ // Label 316: @14913
     /*  14913 */ GIM_Reject,
     /*  14914 */ // Label 297: @14914
     /*  14914 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(14960), // Rule ID 835 //
     /*  14919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  14925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  14928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14940 */   // (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  14940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i8),
     /*  14943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14945 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14947 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14952 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14958 */   GIR_RootConstrainSelectedInstOperands,
     /*  14959 */   // GIR_Coverage, 835,
     /*  14959 */   GIR_EraseRootFromParent_Done,
     /*  14960 */ // Label 320: @14960
     /*  14960 */ GIM_Reject,
     /*  14961 */ // Label 298: @14961
     /*  14961 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(15189),
     /*  14966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  14972 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(15087), // Rule ID 4426 //
     /*  14977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15001 */     // MIs[1] Operand 2
     /*  15001 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*  15012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15029 */     // MIs[2] Operand 2
     /*  15029 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  15040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15042 */     // (mul:{ *:[v8i16] } (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, v8i8:{ *:[Other] }), (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src2, v8i8:{ *:[Other] }))  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)
     /*  15042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  15057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  15067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15085 */     GIR_RootConstrainSelectedInstOperands,
     /*  15086 */     // GIR_Coverage, 4426,
     /*  15086 */     GIR_EraseRootFromParent_Done,
     /*  15087 */   // Label 322: @15087
     /*  15087 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(15127), // Rule ID 839 //
     /*  15092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15107 */     // (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMULv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  15107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i16),
     /*  15110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15125 */     GIR_RootConstrainSelectedInstOperands,
     /*  15126 */     // GIR_Coverage, 839,
     /*  15126 */     GIR_EraseRootFromParent_Done,
     /*  15127 */   // Label 323: @15127
     /*  15127 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(15188), // Rule ID 3462 //
     /*  15132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15147 */     // (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  15147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi16),
     /*  15162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15186 */     GIR_RootConstrainSelectedInstOperands,
     /*  15187 */     // GIR_Coverage, 3462,
     /*  15187 */     GIR_EraseRootFromParent_Done,
     /*  15188 */   // Label 324: @15188
     /*  15188 */   GIM_Reject,
     /*  15189 */ // Label 321: @15189
     /*  15189 */ GIM_Reject,
     /*  15190 */ // Label 299: @15190
     /*  15190 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(15303),
     /*  15195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  15198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  15201 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(15241), // Rule ID 838 //
     /*  15206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15221 */     // (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  15221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv16i8),
     /*  15224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15239 */     GIR_RootConstrainSelectedInstOperands,
     /*  15240 */     // GIR_Coverage, 838,
     /*  15240 */     GIR_EraseRootFromParent_Done,
     /*  15241 */   // Label 326: @15241
     /*  15241 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(15302), // Rule ID 3458 //
     /*  15246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15261 */     // (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  15261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi8),
     /*  15276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15300 */     GIR_RootConstrainSelectedInstOperands,
     /*  15301 */     // GIR_Coverage, 3458,
     /*  15301 */     GIR_EraseRootFromParent_Done,
     /*  15302 */   // Label 327: @15302
     /*  15302 */   GIM_Reject,
     /*  15303 */ // Label 325: @15303
     /*  15303 */ GIM_Reject,
     /*  15304 */ // Label 300: @15304
     /*  15304 */ GIM_Reject,
     /*  15305 */ // Label 3: @15305
     /*  15305 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(15400),
     /*  15310 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15319 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(15359), // Rule ID 195 //
     /*  15324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15339 */     // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SDIV),
     /*  15342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15357 */     GIR_RootConstrainSelectedInstOperands,
     /*  15358 */     // GIR_Coverage, 195,
     /*  15358 */     GIR_EraseRootFromParent_Done,
     /*  15359 */   // Label 329: @15359
     /*  15359 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(15399), // Rule ID 532 //
     /*  15364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15379 */     // (sdiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SDIV),
     /*  15382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15397 */     GIR_RootConstrainSelectedInstOperands,
     /*  15398 */     // GIR_Coverage, 532,
     /*  15398 */     GIR_EraseRootFromParent_Done,
     /*  15399 */   // Label 330: @15399
     /*  15399 */   GIM_Reject,
     /*  15400 */ // Label 328: @15400
     /*  15400 */ GIM_Reject,
     /*  15401 */ // Label 4: @15401
     /*  15401 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(15496),
     /*  15406 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15415 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15455), // Rule ID 196 //
     /*  15420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15435 */     // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (UDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDIV),
     /*  15438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15453 */     GIR_RootConstrainSelectedInstOperands,
     /*  15454 */     // GIR_Coverage, 196,
     /*  15454 */     GIR_EraseRootFromParent_Done,
     /*  15455 */   // Label 332: @15455
     /*  15455 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15495), // Rule ID 533 //
     /*  15460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15475 */     // (udiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDIV),
     /*  15478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15493 */     GIR_RootConstrainSelectedInstOperands,
     /*  15494 */     // GIR_Coverage, 533,
     /*  15494 */     GIR_EraseRootFromParent_Done,
     /*  15495 */   // Label 333: @15495
     /*  15495 */   GIM_Reject,
     /*  15496 */ // Label 331: @15496
     /*  15496 */ GIM_Reject,
     /*  15497 */ // Label 5: @15497
     /*  15497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 347*/ GIMT_Encode4(18676),
     /*  15508 */ /*GILLT_s32*//*Label 334*/ GIMT_Encode4(15568),
     /*  15512 */ /*GILLT_s64*//*Label 335*/ GIMT_Encode4(17560),
     /*  15516 */ /*GILLT_v2s1*//*Label 336*/ GIMT_Encode4(17607),
     /*  15520 */ /*GILLT_v2s32*//*Label 337*/ GIMT_Encode4(17725),
     /*  15524 */ /*GILLT_v2s64*//*Label 338*/ GIMT_Encode4(17772),
     /*  15528 */ /*GILLT_v4s1*//*Label 339*/ GIMT_Encode4(17886),
     /*  15532 */ /*GILLT_v4s16*//*Label 340*/ GIMT_Encode4(18004),
     /*  15536 */ /*GILLT_v4s32*//*Label 341*/ GIMT_Encode4(18051), GIMT_Encode4(0),
     /*  15544 */ /*GILLT_v8s1*//*Label 342*/ GIMT_Encode4(18165),
     /*  15548 */ /*GILLT_v8s8*//*Label 343*/ GIMT_Encode4(18283),
     /*  15552 */ /*GILLT_v8s16*//*Label 344*/ GIMT_Encode4(18330), GIMT_Encode4(0),
     /*  15560 */ /*GILLT_v16s1*//*Label 345*/ GIMT_Encode4(18444),
     /*  15564 */ /*GILLT_v16s8*//*Label 346*/ GIMT_Encode4(18562),
     /*  15568 */ // Label 334: @15568
     /*  15568 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17559),
     /*  15573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15579 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15652), // Rule ID 1855 //
     /*  15584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15616 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15629 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15650 */     GIR_RootConstrainSelectedInstOperands,
     /*  15651 */     // GIR_Coverage, 1855,
     /*  15651 */     GIR_EraseRootFromParent_Done,
     /*  15652 */   // Label 349: @15652
     /*  15652 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15725), // Rule ID 2112 //
     /*  15657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15689 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15702 */     // (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15723 */     GIR_RootConstrainSelectedInstOperands,
     /*  15724 */     // GIR_Coverage, 2112,
     /*  15724 */     GIR_EraseRootFromParent_Done,
     /*  15725 */   // Label 350: @15725
     /*  15725 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15773), // Rule ID 1997 //
     /*  15730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15741 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15752 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 255:{ *:[i32] })  =>  (UXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB),
     /*  15755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15771 */     GIR_RootConstrainSelectedInstOperands,
     /*  15772 */     // GIR_Coverage, 1997,
     /*  15772 */     GIR_EraseRootFromParent_Done,
     /*  15773 */   // Label 351: @15773
     /*  15773 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15821), // Rule ID 1998 //
     /*  15778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15789 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15800 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 65535:{ *:[i32] })  =>  (UXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTH),
     /*  15803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15819 */     GIR_RootConstrainSelectedInstOperands,
     /*  15820 */     // GIR_Coverage, 1998,
     /*  15820 */     GIR_EraseRootFromParent_Done,
     /*  15821 */   // Label 352: @15821
     /*  15821 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15869), // Rule ID 1999 //
     /*  15826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15837 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15848 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15867 */     GIR_RootConstrainSelectedInstOperands,
     /*  15868 */     // GIR_Coverage, 1999,
     /*  15868 */     GIR_EraseRootFromParent_Done,
     /*  15869 */   // Label 353: @15869
     /*  15869 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15917), // Rule ID 2236 //
     /*  15874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15885 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15896 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (t2UXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB),
     /*  15899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15915 */     GIR_RootConstrainSelectedInstOperands,
     /*  15916 */     // GIR_Coverage, 2236,
     /*  15916 */     GIR_EraseRootFromParent_Done,
     /*  15917 */   // Label 354: @15917
     /*  15917 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15965), // Rule ID 2237 //
     /*  15922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15933 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15944 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (t2UXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTH),
     /*  15947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15963 */     GIR_RootConstrainSelectedInstOperands,
     /*  15964 */     // GIR_Coverage, 2237,
     /*  15964 */     GIR_EraseRootFromParent_Done,
     /*  15965 */   // Label 355: @15965
     /*  15965 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16013), // Rule ID 2238 //
     /*  15970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15981 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15992 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16011 */     GIR_RootConstrainSelectedInstOperands,
     /*  16012 */     // GIR_Coverage, 2238,
     /*  16012 */     GIR_EraseRootFromParent_Done,
     /*  16013 */   // Label 356: @16013
     /*  16013 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16090), // Rule ID 5439 //
     /*  16018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16057 */     // MIs[2] Operand 1
     /*  16057 */     // No operand predicates
     /*  16057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16063 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16088 */     GIR_RootConstrainSelectedInstOperands,
     /*  16089 */     // GIR_Coverage, 5439,
     /*  16089 */     GIR_EraseRootFromParent_Done,
     /*  16090 */   // Label 357: @16090
     /*  16090 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16167), // Rule ID 5472 //
     /*  16095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16134 */     // MIs[2] Operand 1
     /*  16134 */     // No operand predicates
     /*  16134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16140 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16165 */     GIR_RootConstrainSelectedInstOperands,
     /*  16166 */     // GIR_Coverage, 5472,
     /*  16166 */     GIR_EraseRootFromParent_Done,
     /*  16167 */   // Label 358: @16167
     /*  16167 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16244), // Rule ID 5438 //
     /*  16172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16207 */     // MIs[2] Operand 1
     /*  16207 */     // No operand predicates
     /*  16207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16217 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16242 */     GIR_RootConstrainSelectedInstOperands,
     /*  16243 */     // GIR_Coverage, 5438,
     /*  16243 */     GIR_EraseRootFromParent_Done,
     /*  16244 */   // Label 359: @16244
     /*  16244 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16321), // Rule ID 5471 //
     /*  16249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16284 */     // MIs[2] Operand 1
     /*  16284 */     // No operand predicates
     /*  16284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16294 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16319 */     GIR_RootConstrainSelectedInstOperands,
     /*  16320 */     // GIR_Coverage, 5471,
     /*  16320 */     GIR_EraseRootFromParent_Done,
     /*  16321 */   // Label 360: @16321
     /*  16321 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16398), // Rule ID 5437 //
     /*  16326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16353 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16369 */     // MIs[2] Operand 1
     /*  16369 */     // No operand predicates
     /*  16369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16371 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16396 */     GIR_RootConstrainSelectedInstOperands,
     /*  16397 */     // GIR_Coverage, 5437,
     /*  16397 */     GIR_EraseRootFromParent_Done,
     /*  16398 */   // Label 361: @16398
     /*  16398 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16475), // Rule ID 5470 //
     /*  16403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16446 */     // MIs[2] Operand 1
     /*  16446 */     // No operand predicates
     /*  16446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16448 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16473 */     GIR_RootConstrainSelectedInstOperands,
     /*  16474 */     // GIR_Coverage, 5470,
     /*  16474 */     GIR_EraseRootFromParent_Done,
     /*  16475 */   // Label 362: @16475
     /*  16475 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16552), // Rule ID 159 //
     /*  16480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16519 */     // MIs[2] Operand 1
     /*  16519 */     // No operand predicates
     /*  16519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16525 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16550 */     GIR_RootConstrainSelectedInstOperands,
     /*  16551 */     // GIR_Coverage, 159,
     /*  16551 */     GIR_EraseRootFromParent_Done,
     /*  16552 */   // Label 363: @16552
     /*  16552 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16629), // Rule ID 490 //
     /*  16557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16596 */     // MIs[2] Operand 1
     /*  16596 */     // No operand predicates
     /*  16596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16602 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16627 */     GIR_RootConstrainSelectedInstOperands,
     /*  16628 */     // GIR_Coverage, 490,
     /*  16628 */     GIR_EraseRootFromParent_Done,
     /*  16629 */   // Label 364: @16629
     /*  16629 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16700), // Rule ID 5440 //
     /*  16634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16672 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16698 */     GIR_RootConstrainSelectedInstOperands,
     /*  16699 */     // GIR_Coverage, 5440,
     /*  16699 */     GIR_EraseRootFromParent_Done,
     /*  16700 */   // Label 365: @16700
     /*  16700 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16771), // Rule ID 5461 //
     /*  16705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16743 */     // (and:{ *:[i32] } (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), tGPR:{ *:[i32] }:$Rn)  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16769 */     GIR_RootConstrainSelectedInstOperands,
     /*  16770 */     // GIR_Coverage, 5461,
     /*  16770 */     GIR_EraseRootFromParent_Done,
     /*  16771 */   // Label 366: @16771
     /*  16771 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16842), // Rule ID 5473 //
     /*  16776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16814 */     // (and:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  16814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  16817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16840 */     GIR_RootConstrainSelectedInstOperands,
     /*  16841 */     // GIR_Coverage, 5473,
     /*  16841 */     GIR_EraseRootFromParent_Done,
     /*  16842 */   // Label 367: @16842
     /*  16842 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16913), // Rule ID 160 //
     /*  16847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16879 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16885 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16911 */     GIR_RootConstrainSelectedInstOperands,
     /*  16912 */     // GIR_Coverage, 160,
     /*  16912 */     GIR_EraseRootFromParent_Done,
     /*  16913 */   // Label 368: @16913
     /*  16913 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16984), // Rule ID 313 //
     /*  16918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16956 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16982 */     GIR_RootConstrainSelectedInstOperands,
     /*  16983 */     // GIR_Coverage, 313,
     /*  16983 */     GIR_EraseRootFromParent_Done,
     /*  16984 */   // Label 369: @16984
     /*  16984 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17055), // Rule ID 491 //
     /*  16989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17027 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  17030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  17038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17053 */     GIR_RootConstrainSelectedInstOperands,
     /*  17054 */     // GIR_Coverage, 491,
     /*  17054 */     GIR_EraseRootFromParent_Done,
     /*  17055 */   // Label 370: @17055
     /*  17055 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17100), // Rule ID 345 //
     /*  17060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17071 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17082 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (tUXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTB),
     /*  17085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17098 */     GIR_RootConstrainSelectedInstOperands,
     /*  17099 */     // GIR_Coverage, 345,
     /*  17099 */     GIR_EraseRootFromParent_Done,
     /*  17100 */   // Label 371: @17100
     /*  17100 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17145), // Rule ID 346 //
     /*  17105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17116 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17127 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (tUXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTH),
     /*  17130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17143 */     GIR_RootConstrainSelectedInstOperands,
     /*  17144 */     // GIR_Coverage, 346,
     /*  17144 */     GIR_EraseRootFromParent_Done,
     /*  17145 */   // Label 372: @17145
     /*  17145 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17204), // Rule ID 1894 //
     /*  17150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  17173 */     // MIs[1] Operand 1
     /*  17173 */     // No operand predicates
     /*  17173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17175 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>>:$imm))
     /*  17175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  17178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17182 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  17187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17202 */     GIR_RootConstrainSelectedInstOperands,
     /*  17203 */     // GIR_Coverage, 1894,
     /*  17203 */     GIR_EraseRootFromParent_Done,
     /*  17204 */   // Label 373: @17204
     /*  17204 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17261), // Rule ID 147 //
     /*  17209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  17232 */     // MIs[1] Operand 1
     /*  17232 */     // No operand predicates
     /*  17232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17234 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ANDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDri),
     /*  17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17259 */     GIR_RootConstrainSelectedInstOperands,
     /*  17260 */     // GIR_Coverage, 147,
     /*  17260 */     GIR_EraseRootFromParent_Done,
     /*  17261 */   // Label 374: @17261
     /*  17261 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17318), // Rule ID 481 //
     /*  17266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  17289 */     // MIs[1] Operand 1
     /*  17289 */     // No operand predicates
     /*  17289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17291 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ANDri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDri),
     /*  17294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17316 */     GIR_RootConstrainSelectedInstOperands,
     /*  17317 */     // GIR_Coverage, 481,
     /*  17317 */     GIR_EraseRootFromParent_Done,
     /*  17318 */   // Label 375: @17318
     /*  17318 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17369), // Rule ID 163 //
     /*  17323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  17326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17342 */     // MIs[1] Operand 1
     /*  17342 */     // No operand predicates
     /*  17342 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17348 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (BFC:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BFC),
     /*  17351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17367 */     GIR_RootConstrainSelectedInstOperands,
     /*  17368 */     // GIR_Coverage, 163,
     /*  17368 */     GIR_EraseRootFromParent_Done,
     /*  17369 */   // Label 376: @17369
     /*  17369 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17420), // Rule ID 493 //
     /*  17374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17393 */     // MIs[1] Operand 1
     /*  17393 */     // No operand predicates
     /*  17393 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17399 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (t2BFC:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BFC),
     /*  17402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17418 */     GIR_RootConstrainSelectedInstOperands,
     /*  17419 */     // GIR_Coverage, 493,
     /*  17419 */     GIR_EraseRootFromParent_Done,
     /*  17420 */   // Label 377: @17420
     /*  17420 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17466), // Rule ID 148 //
     /*  17425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17440 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ANDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  17440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDrr),
     /*  17443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17464 */     GIR_RootConstrainSelectedInstOperands,
     /*  17465 */     // GIR_Coverage, 148,
     /*  17465 */     GIR_EraseRootFromParent_Done,
     /*  17466 */   // Label 378: @17466
     /*  17466 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17512), // Rule ID 310 //
     /*  17471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  17474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17486 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tAND:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  17486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tAND),
     /*  17489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  17491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  17497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17510 */     GIR_RootConstrainSelectedInstOperands,
     /*  17511 */     // GIR_Coverage, 310,
     /*  17511 */     GIR_EraseRootFromParent_Done,
     /*  17512 */   // Label 379: @17512
     /*  17512 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17558), // Rule ID 482 //
     /*  17517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17532 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ANDrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17556 */     GIR_RootConstrainSelectedInstOperands,
     /*  17557 */     // GIR_Coverage, 482,
     /*  17557 */     GIR_EraseRootFromParent_Done,
     /*  17558 */   // Label 380: @17558
     /*  17558 */   GIM_Reject,
     /*  17559 */ // Label 348: @17559
     /*  17559 */ GIM_Reject,
     /*  17560 */ // Label 335: @17560
     /*  17560 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17606), // Rule ID 2526 //
     /*  17565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17586 */   // (and:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VANDd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  17586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17591 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17593 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17604 */   GIR_RootConstrainSelectedInstOperands,
     /*  17605 */   // GIR_Coverage, 2526,
     /*  17605 */   GIR_EraseRootFromParent_Done,
     /*  17606 */ // Label 381: @17606
     /*  17606 */ GIM_Reject,
     /*  17607 */ // Label 336: @17607
     /*  17607 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17724), // Rule ID 1826 //
     /*  17612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  17618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  17621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17633 */   // (and:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17633 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17636 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17640 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17645 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17666 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17670 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17690 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17693 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17696 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17702 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17723 */   // GIR_Coverage, 1826,
     /*  17723 */   GIR_EraseRootFromParent_Done,
     /*  17724 */ // Label 382: @17724
     /*  17724 */ GIM_Reject,
     /*  17725 */ // Label 337: @17725
     /*  17725 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17771), // Rule ID 1133 //
     /*  17730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17751 */   // (and:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VANDd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  17751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17756 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  17758 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  17760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17763 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17769 */   GIR_RootConstrainSelectedInstOperands,
     /*  17770 */   // GIR_Coverage, 1133,
     /*  17770 */   GIR_EraseRootFromParent_Done,
     /*  17771 */ // Label 383: @17771
     /*  17771 */ GIM_Reject,
     /*  17772 */ // Label 338: @17772
     /*  17772 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17885),
     /*  17777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  17783 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17823), // Rule ID 2529 //
     /*  17788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17803 */     // (and:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VANDq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  17803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  17806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17808 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17810 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17821 */     GIR_RootConstrainSelectedInstOperands,
     /*  17822 */     // GIR_Coverage, 2529,
     /*  17822 */     GIR_EraseRootFromParent_Done,
     /*  17823 */   // Label 385: @17823
     /*  17823 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17884), // Rule ID 3370 //
     /*  17828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17843 */     // (and:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VAND:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  17843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  17846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  17858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  17860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  17862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  17864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17882 */     GIR_RootConstrainSelectedInstOperands,
     /*  17883 */     // GIR_Coverage, 3370,
     /*  17883 */     GIR_EraseRootFromParent_Done,
     /*  17884 */   // Label 386: @17884
     /*  17884 */   GIM_Reject,
     /*  17885 */ // Label 384: @17885
     /*  17885 */ GIM_Reject,
     /*  17886 */ // Label 339: @17886
     /*  17886 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18003), // Rule ID 1827 //
     /*  17891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  17897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  17900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17912 */   // (and:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17912 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17915 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17919 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17924 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17928 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17972 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17975 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17981 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18002 */   // GIR_Coverage, 1827,
     /*  18002 */   GIR_EraseRootFromParent_Done,
     /*  18003 */ // Label 387: @18003
     /*  18003 */ GIM_Reject,
     /*  18004 */ // Label 340: @18004
     /*  18004 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18050), // Rule ID 2525 //
     /*  18009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  18015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  18018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18030 */   // (and:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VANDd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  18030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18035 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18037 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18048 */   GIR_RootConstrainSelectedInstOperands,
     /*  18049 */   // GIR_Coverage, 2525,
     /*  18049 */   GIR_EraseRootFromParent_Done,
     /*  18050 */ // Label 388: @18050
     /*  18050 */ GIM_Reject,
     /*  18051 */ // Label 341: @18051
     /*  18051 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18164),
     /*  18056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18062 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18102), // Rule ID 1134 //
     /*  18067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18082 */     // (and:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VANDq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  18082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  18089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  18091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18100 */     GIR_RootConstrainSelectedInstOperands,
     /*  18101 */     // GIR_Coverage, 1134,
     /*  18101 */     GIR_EraseRootFromParent_Done,
     /*  18102 */   // Label 390: @18102
     /*  18102 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18163), // Rule ID 3366 //
     /*  18107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18122 */     // (and:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VAND:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  18122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18161 */     GIR_RootConstrainSelectedInstOperands,
     /*  18162 */     // GIR_Coverage, 3366,
     /*  18162 */     GIR_EraseRootFromParent_Done,
     /*  18163 */   // Label 391: @18163
     /*  18163 */   GIM_Reject,
     /*  18164 */ // Label 389: @18164
     /*  18164 */ GIM_Reject,
     /*  18165 */ // Label 342: @18165
     /*  18165 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18282), // Rule ID 1828 //
     /*  18170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  18176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  18179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18191 */   // (and:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18191 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18194 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18198 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18203 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18207 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18224 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18228 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18245 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18248 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18251 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18254 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18260 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18281 */   // GIR_Coverage, 1828,
     /*  18281 */   GIR_EraseRootFromParent_Done,
     /*  18282 */ // Label 392: @18282
     /*  18282 */ GIM_Reject,
     /*  18283 */ // Label 343: @18283
     /*  18283 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18329), // Rule ID 2524 //
     /*  18288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  18294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  18297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18309 */   // (and:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VANDd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  18309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18314 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18316 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18327 */   GIR_RootConstrainSelectedInstOperands,
     /*  18328 */   // GIR_Coverage, 2524,
     /*  18328 */   GIR_EraseRootFromParent_Done,
     /*  18329 */ // Label 393: @18329
     /*  18329 */ GIM_Reject,
     /*  18330 */ // Label 344: @18330
     /*  18330 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18443),
     /*  18335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  18338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  18341 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18381), // Rule ID 2528 //
     /*  18346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18361 */     // (and:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VANDq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  18361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18366 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18368 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18379 */     GIR_RootConstrainSelectedInstOperands,
     /*  18380 */     // GIR_Coverage, 2528,
     /*  18380 */     GIR_EraseRootFromParent_Done,
     /*  18381 */   // Label 395: @18381
     /*  18381 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18442), // Rule ID 3362 //
     /*  18386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18401 */     // (and:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VAND:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  18401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18440 */     GIR_RootConstrainSelectedInstOperands,
     /*  18441 */     // GIR_Coverage, 3362,
     /*  18441 */     GIR_EraseRootFromParent_Done,
     /*  18442 */   // Label 396: @18442
     /*  18442 */   GIM_Reject,
     /*  18443 */ // Label 394: @18443
     /*  18443 */ GIM_Reject,
     /*  18444 */ // Label 345: @18444
     /*  18444 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18561), // Rule ID 1829 //
     /*  18449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  18455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  18458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18470 */   // (and:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18470 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18473 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18477 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18482 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18486 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18491 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18494 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18498 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18503 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18507 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18533 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18539 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18560 */   // GIR_Coverage, 1829,
     /*  18560 */   GIR_EraseRootFromParent_Done,
     /*  18561 */ // Label 397: @18561
     /*  18561 */ GIM_Reject,
     /*  18562 */ // Label 346: @18562
     /*  18562 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18675),
     /*  18567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  18570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  18573 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18613), // Rule ID 2527 //
     /*  18578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18593 */     // (and:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VANDq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  18593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18598 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18600 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18611 */     GIR_RootConstrainSelectedInstOperands,
     /*  18612 */     // GIR_Coverage, 2527,
     /*  18612 */     GIR_EraseRootFromParent_Done,
     /*  18613 */   // Label 399: @18613
     /*  18613 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(18674), // Rule ID 3358 //
     /*  18618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18633 */     // (and:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VAND:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  18633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18672 */     GIR_RootConstrainSelectedInstOperands,
     /*  18673 */     // GIR_Coverage, 3358,
     /*  18673 */     GIR_EraseRootFromParent_Done,
     /*  18674 */   // Label 400: @18674
     /*  18674 */   GIM_Reject,
     /*  18675 */ // Label 398: @18675
     /*  18675 */ GIM_Reject,
     /*  18676 */ // Label 347: @18676
     /*  18676 */ GIM_Reject,
     /*  18677 */ // Label 6: @18677
     /*  18677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 414*/ GIMT_Encode4(24485),
     /*  18688 */ /*GILLT_s32*//*Label 401*/ GIMT_Encode4(18748),
     /*  18692 */ /*GILLT_s64*//*Label 402*/ GIMT_Encode4(23369),
     /*  18696 */ /*GILLT_v2s1*//*Label 403*/ GIMT_Encode4(23416),
     /*  18700 */ /*GILLT_v2s32*//*Label 404*/ GIMT_Encode4(23534),
     /*  18704 */ /*GILLT_v2s64*//*Label 405*/ GIMT_Encode4(23581),
     /*  18708 */ /*GILLT_v4s1*//*Label 406*/ GIMT_Encode4(23695),
     /*  18712 */ /*GILLT_v4s16*//*Label 407*/ GIMT_Encode4(23813),
     /*  18716 */ /*GILLT_v4s32*//*Label 408*/ GIMT_Encode4(23860), GIMT_Encode4(0),
     /*  18724 */ /*GILLT_v8s1*//*Label 409*/ GIMT_Encode4(23974),
     /*  18728 */ /*GILLT_v8s8*//*Label 410*/ GIMT_Encode4(24092),
     /*  18732 */ /*GILLT_v8s16*//*Label 411*/ GIMT_Encode4(24139), GIMT_Encode4(0),
     /*  18740 */ /*GILLT_v16s1*//*Label 412*/ GIMT_Encode4(24253),
     /*  18744 */ /*GILLT_v16s8*//*Label 413*/ GIMT_Encode4(24371),
     /*  18748 */ // Label 401: @18748
     /*  18748 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(23368),
     /*  18753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  18756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18759 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(18886), // Rule ID 5655 //
     /*  18764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  18767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18812 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18839 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18843 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18847 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18851 */     // MIs[4] Rm
     /*  18851 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18856 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18860 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18864 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18866 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  18866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  18869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18884 */     GIR_RootConstrainSelectedInstOperands,
     /*  18885 */     // GIR_Coverage, 5655,
     /*  18885 */     GIR_EraseRootFromParent_Done,
     /*  18886 */   // Label 416: @18886
     /*  18886 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19013), // Rule ID 5697 //
     /*  18891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  18894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18935 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18939 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18978 */     // MIs[4] Rm
     /*  18978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18983 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18987 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18993 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  18993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  18996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19011 */     GIR_RootConstrainSelectedInstOperands,
     /*  19012 */     // GIR_Coverage, 5697,
     /*  19012 */     GIR_EraseRootFromParent_Done,
     /*  19013 */   // Label 417: @19013
     /*  19013 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19140), // Rule ID 1914 //
     /*  19018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19066 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19094 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19098 */     // MIs[4] Rm
     /*  19098 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19103 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19107 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19120 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  19120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  19123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19138 */     GIR_RootConstrainSelectedInstOperands,
     /*  19139 */     // GIR_Coverage, 1914,
     /*  19139 */     GIR_EraseRootFromParent_Done,
     /*  19140 */   // Label 418: @19140
     /*  19140 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19267), // Rule ID 2196 //
     /*  19145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  19148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19225 */     // MIs[4] Rm
     /*  19225 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19230 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19234 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19247 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19265 */     GIR_RootConstrainSelectedInstOperands,
     /*  19266 */     // GIR_Coverage, 2196,
     /*  19266 */     GIR_EraseRootFromParent_Done,
     /*  19267 */   // Label 419: @19267
     /*  19267 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19400), // Rule ID 5453 //
     /*  19272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19324 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19328 */     // MIs[3] Operand 1
     /*  19328 */     // No operand predicates
     /*  19328 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19351 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19355 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19360 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19371 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19373 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19398 */     GIR_RootConstrainSelectedInstOperands,
     /*  19399 */     // GIR_Coverage, 5453,
     /*  19399 */     GIR_EraseRootFromParent_Done,
     /*  19400 */   // Label 420: @19400
     /*  19400 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19533), // Rule ID 5490 //
     /*  19405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19461 */     // MIs[3] Operand 1
     /*  19461 */     // No operand predicates
     /*  19461 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19484 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19493 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19504 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19506 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19531 */     GIR_RootConstrainSelectedInstOperands,
     /*  19532 */     // GIR_Coverage, 5490,
     /*  19532 */     GIR_EraseRootFromParent_Done,
     /*  19533 */   // Label 421: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19666), // Rule ID 5660 //
     /*  19538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19594 */     // MIs[3] Operand 1
     /*  19594 */     // No operand predicates
     /*  19594 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19605 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19609 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19613 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19617 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19621 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19626 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19639 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19664 */     GIR_RootConstrainSelectedInstOperands,
     /*  19665 */     // GIR_Coverage, 5660,
     /*  19665 */     GIR_EraseRootFromParent_Done,
     /*  19666 */   // Label 422: @19666
     /*  19666 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(19799), // Rule ID 5702 //
     /*  19671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19727 */     // MIs[3] Operand 1
     /*  19727 */     // No operand predicates
     /*  19727 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19746 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19750 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19759 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19772 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19797 */     GIR_RootConstrainSelectedInstOperands,
     /*  19798 */     // GIR_Coverage, 5702,
     /*  19798 */     GIR_EraseRootFromParent_Done,
     /*  19799 */   // Label 423: @19799
     /*  19799 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(19932), // Rule ID 5452 //
     /*  19804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19856 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19860 */     // MIs[3] Operand 1
     /*  19860 */     // No operand predicates
     /*  19860 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19871 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19875 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19879 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19883 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19887 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19892 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  19903 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19905 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  19908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19930 */     GIR_RootConstrainSelectedInstOperands,
     /*  19931 */     // GIR_Coverage, 5452,
     /*  19931 */     GIR_EraseRootFromParent_Done,
     /*  19932 */   // Label 424: @19932
     /*  19932 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20065), // Rule ID 5489 //
     /*  19937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19993 */     // MIs[3] Operand 1
     /*  19993 */     // No operand predicates
     /*  19993 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20004 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20008 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20012 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20016 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20020 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20025 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  20036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20038 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  20047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  20054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20063 */     GIR_RootConstrainSelectedInstOperands,
     /*  20064 */     // GIR_Coverage, 5489,
     /*  20064 */     GIR_EraseRootFromParent_Done,
     /*  20065 */   // Label 425: @20065
     /*  20065 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20198), // Rule ID 203 //
     /*  20070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20098 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20133 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20137 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20141 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20150 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20154 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20158 */     // MIs[4] Operand 1
     /*  20158 */     // No operand predicates
     /*  20158 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20169 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20171 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20196 */     GIR_RootConstrainSelectedInstOperands,
     /*  20197 */     // GIR_Coverage, 203,
     /*  20197 */     GIR_EraseRootFromParent_Done,
     /*  20198 */   // Label 426: @20198
     /*  20198 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20331), // Rule ID 540 //
     /*  20203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20231 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20279 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20283 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20287 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20291 */     // MIs[4] Operand 1
     /*  20291 */     // No operand predicates
     /*  20291 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20304 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20329 */     GIR_RootConstrainSelectedInstOperands,
     /*  20330 */     // GIR_Coverage, 540,
     /*  20330 */     GIR_EraseRootFromParent_Done,
     /*  20331 */   // Label 427: @20331
     /*  20331 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20464), // Rule ID 1919 //
     /*  20336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20364 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20399 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20407 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20420 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20424 */     // MIs[4] Operand 1
     /*  20424 */     // No operand predicates
     /*  20424 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20435 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20437 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20462 */     GIR_RootConstrainSelectedInstOperands,
     /*  20463 */     // GIR_Coverage, 1919,
     /*  20463 */     GIR_EraseRootFromParent_Done,
     /*  20464 */   // Label 428: @20464
     /*  20464 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20597), // Rule ID 2201 //
     /*  20469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20497 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20553 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20557 */     // MIs[4] Operand 1
     /*  20557 */     // No operand predicates
     /*  20557 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20570 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20595 */     GIR_RootConstrainSelectedInstOperands,
     /*  20596 */     // GIR_Coverage, 2201,
     /*  20596 */     GIR_EraseRootFromParent_Done,
     /*  20597 */   // Label 429: @20597
     /*  20597 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20730), // Rule ID 202 //
     /*  20602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20630 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20686 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20690 */     // MIs[4] Operand 1
     /*  20690 */     // No operand predicates
     /*  20690 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20701 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20703 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20728 */     GIR_RootConstrainSelectedInstOperands,
     /*  20729 */     // GIR_Coverage, 202,
     /*  20729 */     GIR_EraseRootFromParent_Done,
     /*  20730 */   // Label 430: @20730
     /*  20730 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20863), // Rule ID 539 //
     /*  20735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20763 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20806 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20811 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20815 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20819 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20823 */     // MIs[4] Operand 1
     /*  20823 */     // No operand predicates
     /*  20823 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20836 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20861 */     GIR_RootConstrainSelectedInstOperands,
     /*  20862 */     // GIR_Coverage, 539,
     /*  20862 */     GIR_EraseRootFromParent_Done,
     /*  20863 */   // Label 431: @20863
     /*  20863 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(20968), // Rule ID 1915 //
     /*  20868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20896 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20928 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20941 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  20941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20966 */     GIR_RootConstrainSelectedInstOperands,
     /*  20967 */     // GIR_Coverage, 1915,
     /*  20967 */     GIR_EraseRootFromParent_Done,
     /*  20968 */   // Label 432: @20968
     /*  20968 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21073), // Rule ID 2197 //
     /*  20973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21001 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21033 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21046 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21071 */     GIR_RootConstrainSelectedInstOperands,
     /*  21072 */     // GIR_Coverage, 2197,
     /*  21072 */     GIR_EraseRootFromParent_Done,
     /*  21073 */   // Label 433: @21073
     /*  21073 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21178), // Rule ID 5656 //
     /*  21078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21106 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21138 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21151 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  21151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21176 */     GIR_RootConstrainSelectedInstOperands,
     /*  21177 */     // GIR_Coverage, 5656,
     /*  21177 */     GIR_EraseRootFromParent_Done,
     /*  21178 */   // Label 434: @21178
     /*  21178 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21283), // Rule ID 5698 //
     /*  21183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21211 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21243 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21256 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  21265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21281 */     GIR_RootConstrainSelectedInstOperands,
     /*  21282 */     // GIR_Coverage, 5698,
     /*  21282 */     GIR_EraseRootFromParent_Done,
     /*  21283 */   // Label 435: @21283
     /*  21283 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21389), // Rule ID 1918 //
     /*  21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21316 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21360 */     // MIs[3] Operand 1
     /*  21360 */     // No operand predicates
     /*  21360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21362 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21387 */     GIR_RootConstrainSelectedInstOperands,
     /*  21388 */     // GIR_Coverage, 1918,
     /*  21388 */     GIR_EraseRootFromParent_Done,
     /*  21389 */   // Label 436: @21389
     /*  21389 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21495), // Rule ID 2200 //
     /*  21394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21422 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21466 */     // MIs[3] Operand 1
     /*  21466 */     // No operand predicates
     /*  21466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21468 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21493 */     GIR_RootConstrainSelectedInstOperands,
     /*  21494 */     // GIR_Coverage, 2200,
     /*  21494 */     GIR_EraseRootFromParent_Done,
     /*  21495 */   // Label 437: @21495
     /*  21495 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21601), // Rule ID 1917 //
     /*  21500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21528 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21568 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21572 */     // MIs[3] Operand 1
     /*  21572 */     // No operand predicates
     /*  21572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21574 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21599 */     GIR_RootConstrainSelectedInstOperands,
     /*  21600 */     // GIR_Coverage, 1917,
     /*  21600 */     GIR_EraseRootFromParent_Done,
     /*  21601 */   // Label 438: @21601
     /*  21601 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21707), // Rule ID 2199 //
     /*  21606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21634 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21678 */     // MIs[3] Operand 1
     /*  21678 */     // No operand predicates
     /*  21678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21680 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21705 */     GIR_RootConstrainSelectedInstOperands,
     /*  21706 */     // GIR_Coverage, 2199,
     /*  21706 */     GIR_EraseRootFromParent_Done,
     /*  21707 */   // Label 439: @21707
     /*  21707 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21813), // Rule ID 1916 //
     /*  21712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21740 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21784 */     // MIs[3] Operand 1
     /*  21784 */     // No operand predicates
     /*  21784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21786 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21811 */     GIR_RootConstrainSelectedInstOperands,
     /*  21812 */     // GIR_Coverage, 1916,
     /*  21812 */     GIR_EraseRootFromParent_Done,
     /*  21813 */   // Label 440: @21813
     /*  21813 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(21919), // Rule ID 2198 //
     /*  21818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21846 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21886 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21890 */     // MIs[3] Operand 1
     /*  21890 */     // No operand predicates
     /*  21890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21892 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21917 */     GIR_RootConstrainSelectedInstOperands,
     /*  21918 */     // GIR_Coverage, 2198,
     /*  21918 */     GIR_EraseRootFromParent_Done,
     /*  21919 */   // Label 441: @21919
     /*  21919 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22025), // Rule ID 5659 //
     /*  21924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21964 */     // MIs[2] Operand 1
     /*  21964 */     // No operand predicates
     /*  21964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21980 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21985 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21998 */     // (or:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22023 */     GIR_RootConstrainSelectedInstOperands,
     /*  22024 */     // GIR_Coverage, 5659,
     /*  22024 */     GIR_EraseRootFromParent_Done,
     /*  22025 */   // Label 442: @22025
     /*  22025 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22131), // Rule ID 5701 //
     /*  22030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  22045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22066 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22070 */     // MIs[2] Operand 1
     /*  22070 */     // No operand predicates
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22086 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22091 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22104 */     // (or:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22129 */     GIR_RootConstrainSelectedInstOperands,
     /*  22130 */     // GIR_Coverage, 5701,
     /*  22130 */     GIR_EraseRootFromParent_Done,
     /*  22131 */   // Label 443: @22131
     /*  22131 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22237), // Rule ID 5658 //
     /*  22136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22176 */     // MIs[2] Operand 1
     /*  22176 */     // No operand predicates
     /*  22176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22192 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22197 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22210 */     // (or:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22235 */     GIR_RootConstrainSelectedInstOperands,
     /*  22236 */     // GIR_Coverage, 5658,
     /*  22236 */     GIR_EraseRootFromParent_Done,
     /*  22237 */   // Label 444: @22237
     /*  22237 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22343), // Rule ID 5700 //
     /*  22242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22282 */     // MIs[2] Operand 1
     /*  22282 */     // No operand predicates
     /*  22282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22303 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22316 */     // (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22341 */     GIR_RootConstrainSelectedInstOperands,
     /*  22342 */     // GIR_Coverage, 5700,
     /*  22342 */     GIR_EraseRootFromParent_Done,
     /*  22343 */   // Label 445: @22343
     /*  22343 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22449), // Rule ID 5657 //
     /*  22348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22388 */     // MIs[2] Operand 1
     /*  22388 */     // No operand predicates
     /*  22388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22409 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22422 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  22425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  22431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22447 */     GIR_RootConstrainSelectedInstOperands,
     /*  22448 */     // GIR_Coverage, 5657,
     /*  22448 */     GIR_EraseRootFromParent_Done,
     /*  22449 */   // Label 446: @22449
     /*  22449 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22555), // Rule ID 5699 //
     /*  22454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22494 */     // MIs[2] Operand 1
     /*  22494 */     // No operand predicates
     /*  22494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22510 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22515 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22528 */     // (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  22531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22553 */     GIR_RootConstrainSelectedInstOperands,
     /*  22554 */     // GIR_Coverage, 5699,
     /*  22554 */     GIR_EraseRootFromParent_Done,
     /*  22555 */   // Label 447: @22555
     /*  22555 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22632), // Rule ID 5477 //
     /*  22560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22583 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22599 */     // MIs[2] Operand 1
     /*  22599 */     // No operand predicates
     /*  22599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22605 */     // (or:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22630 */     GIR_RootConstrainSelectedInstOperands,
     /*  22631 */     // GIR_Coverage, 5477,
     /*  22631 */     GIR_EraseRootFromParent_Done,
     /*  22632 */   // Label 448: @22632
     /*  22632 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22709), // Rule ID 5476 //
     /*  22637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22672 */     // MIs[2] Operand 1
     /*  22672 */     // No operand predicates
     /*  22672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22682 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22707 */     GIR_RootConstrainSelectedInstOperands,
     /*  22708 */     // GIR_Coverage, 5476,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 449: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22786), // Rule ID 5475 //
     /*  22714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22741 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22757 */     // MIs[2] Operand 1
     /*  22757 */     // No operand predicates
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22759 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22784 */     GIR_RootConstrainSelectedInstOperands,
     /*  22785 */     // GIR_Coverage, 5475,
     /*  22785 */     GIR_EraseRootFromParent_Done,
     /*  22786 */   // Label 450: @22786
     /*  22786 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22863), // Rule ID 496 //
     /*  22791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22830 */     // MIs[2] Operand 1
     /*  22830 */     // No operand predicates
     /*  22830 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22836 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22861 */     GIR_RootConstrainSelectedInstOperands,
     /*  22862 */     // GIR_Coverage, 496,
     /*  22862 */     GIR_EraseRootFromParent_Done,
     /*  22863 */   // Label 451: @22863
     /*  22863 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22934), // Rule ID 5478 //
     /*  22868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22906 */     // (or:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22932 */     GIR_RootConstrainSelectedInstOperands,
     /*  22933 */     // GIR_Coverage, 5478,
     /*  22933 */     GIR_EraseRootFromParent_Done,
     /*  22934 */   // Label 452: @22934
     /*  22934 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23005), // Rule ID 497 //
     /*  22939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22971 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22977 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23003 */     GIR_RootConstrainSelectedInstOperands,
     /*  23004 */     // GIR_Coverage, 497,
     /*  23004 */     GIR_EraseRootFromParent_Done,
     /*  23005 */   // Label 453: @23005
     /*  23005 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23060), // Rule ID 1848 //
     /*  23010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  23013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  23017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23021 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23032 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (MOVTi16:{ *:[i32] } GPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVTi16),
     /*  23035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23039 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23058 */     GIR_RootConstrainSelectedInstOperands,
     /*  23059 */     // GIR_Coverage, 1848,
     /*  23059 */     GIR_EraseRootFromParent_Done,
     /*  23060 */   // Label 454: @23060
     /*  23060 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23115), // Rule ID 2094 //
     /*  23065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23076 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23087 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (t2MOVTi16:{ *:[i32] } rGPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVTi16),
     /*  23090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23113 */     GIR_RootConstrainSelectedInstOperands,
     /*  23114 */     // GIR_Coverage, 2094,
     /*  23114 */     GIR_EraseRootFromParent_Done,
     /*  23115 */   // Label 455: @23115
     /*  23115 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23172), // Rule ID 151 //
     /*  23120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  23143 */     // MIs[1] Operand 1
     /*  23143 */     // No operand predicates
     /*  23143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23145 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ORRri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRri),
     /*  23148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23170 */     GIR_RootConstrainSelectedInstOperands,
     /*  23171 */     // GIR_Coverage, 151,
     /*  23171 */     GIR_EraseRootFromParent_Done,
     /*  23172 */   // Label 456: @23172
     /*  23172 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23229), // Rule ID 484 //
     /*  23177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  23200 */     // MIs[1] Operand 1
     /*  23200 */     // No operand predicates
     /*  23200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23202 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ORRri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRri),
     /*  23205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23227 */     GIR_RootConstrainSelectedInstOperands,
     /*  23228 */     // GIR_Coverage, 484,
     /*  23228 */     GIR_EraseRootFromParent_Done,
     /*  23229 */   // Label 457: @23229
     /*  23229 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23275), // Rule ID 152 //
     /*  23234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23249 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ORRrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  23249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRrr),
     /*  23252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23273 */     GIR_RootConstrainSelectedInstOperands,
     /*  23274 */     // GIR_Coverage, 152,
     /*  23274 */     GIR_EraseRootFromParent_Done,
     /*  23275 */   // Label 458: @23275
     /*  23275 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23321), // Rule ID 325 //
     /*  23280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  23283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23295 */     // (or:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tORR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  23295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tORR),
     /*  23298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  23300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  23306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23319 */     GIR_RootConstrainSelectedInstOperands,
     /*  23320 */     // GIR_Coverage, 325,
     /*  23320 */     GIR_EraseRootFromParent_Done,
     /*  23321 */   // Label 459: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23367), // Rule ID 485 //
     /*  23326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23341 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ORRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  23341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 485,
     /*  23366 */     GIR_EraseRootFromParent_Done,
     /*  23367 */   // Label 460: @23367
     /*  23367 */   GIM_Reject,
     /*  23368 */ // Label 415: @23368
     /*  23368 */ GIM_Reject,
     /*  23369 */ // Label 402: @23369
     /*  23369 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23415), // Rule ID 2532 //
     /*  23374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  23380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  23383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23395 */   // (or:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VORRd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  23395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23400 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23402 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23413 */   GIR_RootConstrainSelectedInstOperands,
     /*  23414 */   // GIR_Coverage, 2532,
     /*  23414 */   GIR_EraseRootFromParent_Done,
     /*  23415 */ // Label 461: @23415
     /*  23415 */ GIM_Reject,
     /*  23416 */ // Label 403: @23416
     /*  23416 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23533), // Rule ID 1834 //
     /*  23421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  23427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  23430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23442 */   // (or:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23442 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23445 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23449 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23454 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23458 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23475 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23496 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23502 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23505 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23511 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23532 */   // GIR_Coverage, 1834,
     /*  23532 */   GIR_EraseRootFromParent_Done,
     /*  23533 */ // Label 462: @23533
     /*  23533 */ GIM_Reject,
     /*  23534 */ // Label 404: @23534
     /*  23534 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23580), // Rule ID 1137 //
     /*  23539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  23545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  23548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23560 */   // (or:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VORRd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  23560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23565 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23567 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23572 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23578 */   GIR_RootConstrainSelectedInstOperands,
     /*  23579 */   // GIR_Coverage, 1137,
     /*  23579 */   GIR_EraseRootFromParent_Done,
     /*  23580 */ // Label 463: @23580
     /*  23580 */ GIM_Reject,
     /*  23581 */ // Label 405: @23581
     /*  23581 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23694),
     /*  23586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  23589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  23592 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23632), // Rule ID 2535 //
     /*  23597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23612 */     // (or:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VORRq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23619 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23630 */     GIR_RootConstrainSelectedInstOperands,
     /*  23631 */     // GIR_Coverage, 2535,
     /*  23631 */     GIR_EraseRootFromParent_Done,
     /*  23632 */   // Label 465: @23632
     /*  23632 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(23693), // Rule ID 3384 //
     /*  23637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23652 */     // (or:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VORR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  23652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23691 */     GIR_RootConstrainSelectedInstOperands,
     /*  23692 */     // GIR_Coverage, 3384,
     /*  23692 */     GIR_EraseRootFromParent_Done,
     /*  23693 */   // Label 466: @23693
     /*  23693 */   GIM_Reject,
     /*  23694 */ // Label 464: @23694
     /*  23694 */ GIM_Reject,
     /*  23695 */ // Label 406: @23695
     /*  23695 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(23812), // Rule ID 1835 //
     /*  23700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  23706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  23709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23721 */   // (or:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23733 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23737 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23758 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23775 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23781 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23784 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23790 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23811 */   // GIR_Coverage, 1835,
     /*  23811 */   GIR_EraseRootFromParent_Done,
     /*  23812 */ // Label 467: @23812
     /*  23812 */ GIM_Reject,
     /*  23813 */ // Label 407: @23813
     /*  23813 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(23859), // Rule ID 2531 //
     /*  23818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23839 */   // (or:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VORRd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  23839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23844 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23846 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23851 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23857 */   GIR_RootConstrainSelectedInstOperands,
     /*  23858 */   // GIR_Coverage, 2531,
     /*  23858 */   GIR_EraseRootFromParent_Done,
     /*  23859 */ // Label 468: @23859
     /*  23859 */ GIM_Reject,
     /*  23860 */ // Label 408: @23860
     /*  23860 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(23973),
     /*  23865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23871 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(23911), // Rule ID 1138 //
     /*  23876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23891 */     // (or:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VORRq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  23891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23909 */     GIR_RootConstrainSelectedInstOperands,
     /*  23910 */     // GIR_Coverage, 1138,
     /*  23910 */     GIR_EraseRootFromParent_Done,
     /*  23911 */   // Label 470: @23911
     /*  23911 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(23972), // Rule ID 3380 //
     /*  23916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23931 */     // (or:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VORR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  23931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23970 */     GIR_RootConstrainSelectedInstOperands,
     /*  23971 */     // GIR_Coverage, 3380,
     /*  23971 */     GIR_EraseRootFromParent_Done,
     /*  23972 */   // Label 471: @23972
     /*  23972 */   GIM_Reject,
     /*  23973 */ // Label 469: @23973
     /*  23973 */ GIM_Reject,
     /*  23974 */ // Label 409: @23974
     /*  23974 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24091), // Rule ID 1836 //
     /*  23979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  23985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  23988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24000 */   // (or:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24012 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24016 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24057 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24060 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24063 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24069 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24090 */   // GIR_Coverage, 1836,
     /*  24090 */   GIR_EraseRootFromParent_Done,
     /*  24091 */ // Label 472: @24091
     /*  24091 */ GIM_Reject,
     /*  24092 */ // Label 410: @24092
     /*  24092 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24138), // Rule ID 2530 //
     /*  24097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24118 */   // (or:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VORRd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  24118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  24121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24123 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24125 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24136 */   GIR_RootConstrainSelectedInstOperands,
     /*  24137 */   // GIR_Coverage, 2530,
     /*  24137 */   GIR_EraseRootFromParent_Done,
     /*  24138 */ // Label 473: @24138
     /*  24138 */ GIM_Reject,
     /*  24139 */ // Label 411: @24139
     /*  24139 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24252),
     /*  24144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  24150 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24190), // Rule ID 2534 //
     /*  24155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24170 */     // (or:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VORRq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  24170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24175 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24177 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24188 */     GIR_RootConstrainSelectedInstOperands,
     /*  24189 */     // GIR_Coverage, 2534,
     /*  24189 */     GIR_EraseRootFromParent_Done,
     /*  24190 */   // Label 475: @24190
     /*  24190 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24251), // Rule ID 3376 //
     /*  24195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24210 */     // (or:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VORR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  24210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24249 */     GIR_RootConstrainSelectedInstOperands,
     /*  24250 */     // GIR_Coverage, 3376,
     /*  24250 */     GIR_EraseRootFromParent_Done,
     /*  24251 */   // Label 476: @24251
     /*  24251 */   GIM_Reject,
     /*  24252 */ // Label 474: @24252
     /*  24252 */ GIM_Reject,
     /*  24253 */ // Label 412: @24253
     /*  24253 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24370), // Rule ID 1837 //
     /*  24258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  24264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  24267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24279 */   // (or:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24279 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24282 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24286 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24291 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24295 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24300 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24303 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24307 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24312 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24316 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24336 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24339 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24342 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24348 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24369 */   // GIR_Coverage, 1837,
     /*  24369 */   GIR_EraseRootFromParent_Done,
     /*  24370 */ // Label 477: @24370
     /*  24370 */ GIM_Reject,
     /*  24371 */ // Label 413: @24371
     /*  24371 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24484),
     /*  24376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  24379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  24382 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24422), // Rule ID 2533 //
     /*  24387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24402 */     // (or:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VORRq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  24402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24407 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24409 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24420 */     GIR_RootConstrainSelectedInstOperands,
     /*  24421 */     // GIR_Coverage, 2533,
     /*  24421 */     GIR_EraseRootFromParent_Done,
     /*  24422 */   // Label 479: @24422
     /*  24422 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24483), // Rule ID 3372 //
     /*  24427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24442 */     // (or:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VORR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  24442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24481 */     GIR_RootConstrainSelectedInstOperands,
     /*  24482 */     // GIR_Coverage, 3372,
     /*  24482 */     GIR_EraseRootFromParent_Done,
     /*  24483 */   // Label 480: @24483
     /*  24483 */   GIM_Reject,
     /*  24484 */ // Label 478: @24484
     /*  24484 */ GIM_Reject,
     /*  24485 */ // Label 414: @24485
     /*  24485 */ GIM_Reject,
     /*  24486 */ // Label 7: @24486
     /*  24486 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 494*/ GIMT_Encode4(26180),
     /*  24497 */ /*GILLT_s32*//*Label 481*/ GIMT_Encode4(24557),
     /*  24501 */ /*GILLT_s64*//*Label 482*/ GIMT_Encode4(25064),
     /*  24505 */ /*GILLT_v2s1*//*Label 483*/ GIMT_Encode4(25111),
     /*  24509 */ /*GILLT_v2s32*//*Label 484*/ GIMT_Encode4(25229),
     /*  24513 */ /*GILLT_v2s64*//*Label 485*/ GIMT_Encode4(25276),
     /*  24517 */ /*GILLT_v4s1*//*Label 486*/ GIMT_Encode4(25390),
     /*  24521 */ /*GILLT_v4s16*//*Label 487*/ GIMT_Encode4(25508),
     /*  24525 */ /*GILLT_v4s32*//*Label 488*/ GIMT_Encode4(25555), GIMT_Encode4(0),
     /*  24533 */ /*GILLT_v8s1*//*Label 489*/ GIMT_Encode4(25669),
     /*  24537 */ /*GILLT_v8s8*//*Label 490*/ GIMT_Encode4(25787),
     /*  24541 */ /*GILLT_v8s16*//*Label 491*/ GIMT_Encode4(25834), GIMT_Encode4(0),
     /*  24549 */ /*GILLT_v16s1*//*Label 492*/ GIMT_Encode4(25948),
     /*  24553 */ /*GILLT_v16s8*//*Label 493*/ GIMT_Encode4(26066),
     /*  24557 */ // Label 481: @24557
     /*  24557 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(25063),
     /*  24562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  24565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  24568 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(24623), // Rule ID 5480 //
     /*  24573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, uint8_t(-1),
     /*  24584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24596 */     // MIs[1] Operand 1
     /*  24596 */     // No operand predicates
     /*  24596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24598 */     // (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24621 */     GIR_RootConstrainSelectedInstOperands,
     /*  24622 */     // GIR_Coverage, 5480,
     /*  24622 */     GIR_EraseRootFromParent_Done,
     /*  24623 */   // Label 496: @24623
     /*  24623 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(24678), // Rule ID 499 //
     /*  24628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24647 */     // MIs[1] Operand 1
     /*  24647 */     // No operand predicates
     /*  24647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24653 */     // (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] })  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24676 */     GIR_RootConstrainSelectedInstOperands,
     /*  24677 */     // GIR_Coverage, 499,
     /*  24677 */     GIR_EraseRootFromParent_Done,
     /*  24678 */   // Label 497: @24678
     /*  24678 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(24722), // Rule ID 500 //
     /*  24683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24698 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (t2MVNr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  24698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNr),
     /*  24701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24720 */     GIR_RootConstrainSelectedInstOperands,
     /*  24721 */     // GIR_Coverage, 500,
     /*  24721 */     GIR_EraseRootFromParent_Done,
     /*  24722 */   // Label 498: @24722
     /*  24722 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(24766), // Rule ID 165 //
     /*  24727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24742 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (MVNr:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  24742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNr),
     /*  24745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24764 */     GIR_RootConstrainSelectedInstOperands,
     /*  24765 */     // GIR_Coverage, 165,
     /*  24765 */     GIR_EraseRootFromParent_Done,
     /*  24766 */   // Label 499: @24766
     /*  24766 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(24810), // Rule ID 324 //
     /*  24771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24786 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, -1:{ *:[i32] })  =>  (tMVN:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  24786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMVN),
     /*  24789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24808 */     GIR_RootConstrainSelectedInstOperands,
     /*  24809 */     // GIR_Coverage, 324,
     /*  24809 */     GIR_EraseRootFromParent_Done,
     /*  24810 */   // Label 500: @24810
     /*  24810 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(24867), // Rule ID 155 //
     /*  24815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  24838 */     // MIs[1] Operand 1
     /*  24838 */     // No operand predicates
     /*  24838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24840 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (EORri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORri),
     /*  24843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24865 */     GIR_RootConstrainSelectedInstOperands,
     /*  24866 */     // GIR_Coverage, 155,
     /*  24866 */     GIR_EraseRootFromParent_Done,
     /*  24867 */   // Label 501: @24867
     /*  24867 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(24924), // Rule ID 487 //
     /*  24872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24895 */     // MIs[1] Operand 1
     /*  24895 */     // No operand predicates
     /*  24895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24897 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2EORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORri),
     /*  24900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24922 */     GIR_RootConstrainSelectedInstOperands,
     /*  24923 */     // GIR_Coverage, 487,
     /*  24923 */     GIR_EraseRootFromParent_Done,
     /*  24924 */   // Label 502: @24924
     /*  24924 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(24970), // Rule ID 156 //
     /*  24929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24944 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (EORrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  24944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORrr),
     /*  24947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24968 */     GIR_RootConstrainSelectedInstOperands,
     /*  24969 */     // GIR_Coverage, 156,
     /*  24969 */     GIR_EraseRootFromParent_Done,
     /*  24970 */   // Label 503: @24970
     /*  24970 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(25016), // Rule ID 317 //
     /*  24975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24990 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tEOR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  24990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tEOR),
     /*  24993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  24995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  25001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25014 */     GIR_RootConstrainSelectedInstOperands,
     /*  25015 */     // GIR_Coverage, 317,
     /*  25015 */     GIR_EraseRootFromParent_Done,
     /*  25016 */   // Label 504: @25016
     /*  25016 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(25062), // Rule ID 488 //
     /*  25021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  25024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25036 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2EORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  25036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  25041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25060 */     GIR_RootConstrainSelectedInstOperands,
     /*  25061 */     // GIR_Coverage, 488,
     /*  25061 */     GIR_EraseRootFromParent_Done,
     /*  25062 */   // Label 505: @25062
     /*  25062 */   GIM_Reject,
     /*  25063 */ // Label 495: @25063
     /*  25063 */ GIM_Reject,
     /*  25064 */ // Label 482: @25064
     /*  25064 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(25110), // Rule ID 2538 //
     /*  25069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  25075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  25078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25090 */   // (xor:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VEORd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  25090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25095 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25097 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25102 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25108 */   GIR_RootConstrainSelectedInstOperands,
     /*  25109 */   // GIR_Coverage, 2538,
     /*  25109 */   GIR_EraseRootFromParent_Done,
     /*  25110 */ // Label 506: @25110
     /*  25110 */ GIM_Reject,
     /*  25111 */ // Label 483: @25111
     /*  25111 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(25228), // Rule ID 1830 //
     /*  25116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  25122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  25125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25137 */   // (xor:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25137 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25140 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25144 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25149 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25153 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25170 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25174 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25191 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25194 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25197 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25200 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25206 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25227 */   // GIR_Coverage, 1830,
     /*  25227 */   GIR_EraseRootFromParent_Done,
     /*  25228 */ // Label 507: @25228
     /*  25228 */ GIM_Reject,
     /*  25229 */ // Label 484: @25229
     /*  25229 */ GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(25275), // Rule ID 1135 //
     /*  25234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  25240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  25243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25255 */   // (xor:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VEORd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  25255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25260 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25262 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25267 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25273 */   GIR_RootConstrainSelectedInstOperands,
     /*  25274 */   // GIR_Coverage, 1135,
     /*  25274 */   GIR_EraseRootFromParent_Done,
     /*  25275 */ // Label 508: @25275
     /*  25275 */ GIM_Reject,
     /*  25276 */ // Label 485: @25276
     /*  25276 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(25389),
     /*  25281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  25284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  25287 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(25327), // Rule ID 2541 //
     /*  25292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25307 */     // (xor:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VEORq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  25307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25312 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25314 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25325 */     GIR_RootConstrainSelectedInstOperands,
     /*  25326 */     // GIR_Coverage, 2541,
     /*  25326 */     GIR_EraseRootFromParent_Done,
     /*  25327 */   // Label 510: @25327
     /*  25327 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(25388), // Rule ID 3398 //
     /*  25332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25347 */     // (xor:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VEOR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  25347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25386 */     GIR_RootConstrainSelectedInstOperands,
     /*  25387 */     // GIR_Coverage, 3398,
     /*  25387 */     GIR_EraseRootFromParent_Done,
     /*  25388 */   // Label 511: @25388
     /*  25388 */   GIM_Reject,
     /*  25389 */ // Label 509: @25389
     /*  25389 */ GIM_Reject,
     /*  25390 */ // Label 486: @25390
     /*  25390 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(25507), // Rule ID 1831 //
     /*  25395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  25401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  25404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25416 */   // (xor:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25416 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25419 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25423 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25428 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25432 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25437 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25440 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25444 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25449 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25453 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25470 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25473 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25476 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25479 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25485 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25506 */   // GIR_Coverage, 1831,
     /*  25506 */   GIR_EraseRootFromParent_Done,
     /*  25507 */ // Label 512: @25507
     /*  25507 */ GIM_Reject,
     /*  25508 */ // Label 487: @25508
     /*  25508 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(25554), // Rule ID 2537 //
     /*  25513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25534 */   // (xor:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VEORd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  25534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25539 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25541 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25552 */   GIR_RootConstrainSelectedInstOperands,
     /*  25553 */   // GIR_Coverage, 2537,
     /*  25553 */   GIR_EraseRootFromParent_Done,
     /*  25554 */ // Label 513: @25554
     /*  25554 */ GIM_Reject,
     /*  25555 */ // Label 488: @25555
     /*  25555 */ GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(25668),
     /*  25560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25566 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(25606), // Rule ID 1136 //
     /*  25571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25586 */     // (xor:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VEORq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  25586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25604 */     GIR_RootConstrainSelectedInstOperands,
     /*  25605 */     // GIR_Coverage, 1136,
     /*  25605 */     GIR_EraseRootFromParent_Done,
     /*  25606 */   // Label 515: @25606
     /*  25606 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(25667), // Rule ID 3394 //
     /*  25611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25626 */     // (xor:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VEOR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  25626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25665 */     GIR_RootConstrainSelectedInstOperands,
     /*  25666 */     // GIR_Coverage, 3394,
     /*  25666 */     GIR_EraseRootFromParent_Done,
     /*  25667 */   // Label 516: @25667
     /*  25667 */   GIM_Reject,
     /*  25668 */ // Label 514: @25668
     /*  25668 */ GIM_Reject,
     /*  25669 */ // Label 489: @25669
     /*  25669 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(25786), // Rule ID 1832 //
     /*  25674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  25680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  25683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25695 */   // (xor:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25695 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25698 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25702 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25707 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25711 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25732 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25752 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25755 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25758 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25764 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25785 */   // GIR_Coverage, 1832,
     /*  25785 */   GIR_EraseRootFromParent_Done,
     /*  25786 */ // Label 517: @25786
     /*  25786 */ GIM_Reject,
     /*  25787 */ // Label 490: @25787
     /*  25787 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(25833), // Rule ID 2536 //
     /*  25792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  25801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25813 */   // (xor:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VEORd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  25813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25818 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25820 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25825 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25831 */   GIR_RootConstrainSelectedInstOperands,
     /*  25832 */   // GIR_Coverage, 2536,
     /*  25832 */   GIR_EraseRootFromParent_Done,
     /*  25833 */ // Label 518: @25833
     /*  25833 */ GIM_Reject,
     /*  25834 */ // Label 491: @25834
     /*  25834 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(25947),
     /*  25839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  25845 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(25885), // Rule ID 2540 //
     /*  25850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25865 */     // (xor:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VEORq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  25865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25870 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25872 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25883 */     GIR_RootConstrainSelectedInstOperands,
     /*  25884 */     // GIR_Coverage, 2540,
     /*  25884 */     GIR_EraseRootFromParent_Done,
     /*  25885 */   // Label 520: @25885
     /*  25885 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(25946), // Rule ID 3390 //
     /*  25890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25905 */     // (xor:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VEOR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  25905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25944 */     GIR_RootConstrainSelectedInstOperands,
     /*  25945 */     // GIR_Coverage, 3390,
     /*  25945 */     GIR_EraseRootFromParent_Done,
     /*  25946 */   // Label 521: @25946
     /*  25946 */   GIM_Reject,
     /*  25947 */ // Label 519: @25947
     /*  25947 */ GIM_Reject,
     /*  25948 */ // Label 492: @25948
     /*  25948 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(26065), // Rule ID 1833 //
     /*  25953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  25959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  25962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25974 */   // (xor:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25974 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25977 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25981 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25986 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25990 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25995 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25998 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26002 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26007 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  26011 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  26019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  26023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26028 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  26034 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26037 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26043 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  26064 */   // GIR_Coverage, 1833,
     /*  26064 */   GIR_EraseRootFromParent_Done,
     /*  26065 */ // Label 522: @26065
     /*  26065 */ GIM_Reject,
     /*  26066 */ // Label 493: @26066
     /*  26066 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(26179),
     /*  26071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  26074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  26077 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(26117), // Rule ID 2539 //
     /*  26082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26097 */     // (xor:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VEORq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  26097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  26100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  26102 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  26104 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  26106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26115 */     GIR_RootConstrainSelectedInstOperands,
     /*  26116 */     // GIR_Coverage, 2539,
     /*  26116 */     GIR_EraseRootFromParent_Done,
     /*  26117 */   // Label 524: @26117
     /*  26117 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(26178), // Rule ID 3386 //
     /*  26122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  26125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26137 */     // (xor:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VEOR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  26137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  26140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  26152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  26154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  26156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  26158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26176 */     GIR_RootConstrainSelectedInstOperands,
     /*  26177 */     // GIR_Coverage, 3386,
     /*  26177 */     GIR_EraseRootFromParent_Done,
     /*  26178 */   // Label 525: @26178
     /*  26178 */   GIM_Reject,
     /*  26179 */ // Label 523: @26179
     /*  26179 */ GIM_Reject,
     /*  26180 */ // Label 494: @26180
     /*  26180 */ GIM_Reject,
     /*  26181 */ // Label 8: @26181
     /*  26181 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(26567),
     /*  26186 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  26189 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(16), /*)*//*default:*//*Label 531*/ GIMT_Encode4(26566),
     /*  26200 */   /*GILLT_v2s64*//*Label 527*/ GIMT_Encode4(26244), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26212 */   /*GILLT_v4s32*//*Label 528*/ GIMT_Encode4(26302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26228 */   /*GILLT_v8s16*//*Label 529*/ GIMT_Encode4(26405), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26240 */   /*GILLT_v16s8*//*Label 530*/ GIMT_Encode4(26508),
     /*  26244 */   // Label 527: @26244
     /*  26244 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(26301), // Rule ID 3024 //
     /*  26249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26252 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  26258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26270 */     // (concat_vectors:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Dn, DPR:{ *:[v1i64] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v2i64] } QPR:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dm, dsub_1:{ *:[i32] })
     /*  26270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26277 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26282 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26300 */     // GIR_Coverage, 3024,
     /*  26300 */     GIR_EraseRootFromParent_Done,
     /*  26301 */   // Label 532: @26301
     /*  26301 */   GIM_Reject,
     /*  26302 */   // Label 528: @26302
     /*  26302 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(26404),
     /*  26307 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  26313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26325 */     GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(26364), // Rule ID 3025 //
     /*  26330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26333 */       // (concat_vectors:{ *:[v4i32] } DPR:{ *:[v2i32] }:$Dn, DPR:{ *:[v2i32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4i32] } QPR:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26333 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26336 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26338 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26340 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26343 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26345 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26348 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26353 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26358 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26363 */       // GIR_Coverage, 3025,
     /*  26363 */       GIR_EraseRootFromParent_Done,
     /*  26364 */     // Label 534: @26364
     /*  26364 */     GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(26403), // Rule ID 3028 //
     /*  26369 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26372 */       // (concat_vectors:{ *:[v4f32] } DPR:{ *:[v2f32] }:$Dn, DPR:{ *:[v2f32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4f32] } QPR:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26372 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26375 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26377 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26379 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26382 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26384 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26387 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26392 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26397 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26402 */       // GIR_Coverage, 3028,
     /*  26402 */       GIR_EraseRootFromParent_Done,
     /*  26403 */     // Label 535: @26403
     /*  26403 */     GIM_Reject,
     /*  26404 */   // Label 533: @26404
     /*  26404 */   GIM_Reject,
     /*  26405 */   // Label 529: @26405
     /*  26405 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(26507),
     /*  26410 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26428 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(26467), // Rule ID 3026 //
     /*  26433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26436 */       // (concat_vectors:{ *:[v8i16] } DPR:{ *:[v4i16] }:$Dn, DPR:{ *:[v4i16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8i16] } QPR:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26436 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26439 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26441 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26443 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26446 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26448 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26451 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26456 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26461 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26466 */       // GIR_Coverage, 3026,
     /*  26466 */       GIR_EraseRootFromParent_Done,
     /*  26467 */     // Label 537: @26467
     /*  26467 */     GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(26506), // Rule ID 3029 //
     /*  26472 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26475 */       // (concat_vectors:{ *:[v8f16] } DPR:{ *:[v4f16] }:$Dn, DPR:{ *:[v4f16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8f16] } QPR:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26475 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26478 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26480 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26482 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26485 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26487 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26490 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26495 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26500 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26505 */       // GIR_Coverage, 3029,
     /*  26505 */       GIR_EraseRootFromParent_Done,
     /*  26506 */     // Label 538: @26506
     /*  26506 */     GIM_Reject,
     /*  26507 */   // Label 536: @26507
     /*  26507 */   GIM_Reject,
     /*  26508 */   // Label 530: @26508
     /*  26508 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(26565), // Rule ID 3027 //
     /*  26513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26516 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  26522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26534 */     // (concat_vectors:{ *:[v16i8] } DPR:{ *:[v8i8] }:$Dn, DPR:{ *:[v8i8] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v16i8] } QPR:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dm, dsub_1:{ *:[i32] })
     /*  26534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26541 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26546 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26564 */     // GIR_Coverage, 3027,
     /*  26564 */     GIR_EraseRootFromParent_Done,
     /*  26565 */   // Label 539: @26565
     /*  26565 */   GIM_Reject,
     /*  26566 */   // Label 531: @26566
     /*  26566 */   GIM_Reject,
     /*  26567 */ // Label 526: @26567
     /*  26567 */ GIM_Reject,
     /*  26568 */ // Label 9: @26568
     /*  26568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 549*/ GIMT_Encode4(35579),
     /*  26579 */ /*GILLT_s32*//*Label 540*/ GIMT_Encode4(26639),
     /*  26583 */ /*GILLT_s64*//*Label 541*/ GIMT_Encode4(26787), GIMT_Encode4(0),
     /*  26591 */ /*GILLT_v2s32*//*Label 542*/ GIMT_Encode4(27542),
     /*  26595 */ /*GILLT_v2s64*//*Label 543*/ GIMT_Encode4(28297), GIMT_Encode4(0),
     /*  26603 */ /*GILLT_v4s16*//*Label 544*/ GIMT_Encode4(30016),
     /*  26607 */ /*GILLT_v4s32*//*Label 545*/ GIMT_Encode4(30771), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26619 */ /*GILLT_v8s8*//*Label 546*/ GIMT_Encode4(32490),
     /*  26623 */ /*GILLT_v8s16*//*Label 547*/ GIMT_Encode4(32905), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26635 */ /*GILLT_v16s8*//*Label 548*/ GIMT_Encode4(34624),
     /*  26639 */ // Label 540: @26639
     /*  26639 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(26786),
     /*  26644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26647 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(26681), // Rule ID 692 //
     /*  26652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  26655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26663 */     // (bitconvert:{ *:[i32] } SPR:{ *:[f32] }:$Sn)  =>  (VMOVRS:{ *:[i32] } SPR:{ *:[f32] }:$Sn)
     /*  26663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVRS),
     /*  26666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  26668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /*  26670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26679 */     GIR_RootConstrainSelectedInstOperands,
     /*  26680 */     // GIR_Coverage, 692,
     /*  26680 */     GIR_EraseRootFromParent_Done,
     /*  26681 */   // Label 551: @26681
     /*  26681 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(26715), // Rule ID 693 //
     /*  26686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_UseVMOVSR),
     /*  26689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26697 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$Rt)  =>  (VMOVSR:{ *:[f32] } GPR:{ *:[i32] }:$Rt)
     /*  26697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVSR),
     /*  26700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sn]
     /*  26702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  26704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26713 */     GIR_RootConstrainSelectedInstOperands,
     /*  26714 */     // GIR_Coverage, 693,
     /*  26714 */     GIR_EraseRootFromParent_Done,
     /*  26715 */   // Label 552: @26715
     /*  26715 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(26785), // Rule ID 2718 //
     /*  26720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseVMOVSR_HasNEON),
     /*  26723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26731 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VMOVDRR:{ *:[f64] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$a), ssub_0:{ *:[i32] })
     /*  26731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  26734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VMOVDRR),
     /*  26738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26754 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  26774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  26779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /*  26784 */     // GIR_Coverage, 2718,
     /*  26784 */     GIR_EraseRootFromParent_Done,
     /*  26785 */   // Label 553: @26785
     /*  26785 */   GIM_Reject,
     /*  26786 */ // Label 550: @26786
     /*  26786 */ GIM_Reject,
     /*  26787 */ // Label 541: @26787
     /*  26787 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(26819), // Rule ID 2720 //
     /*  26792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26806 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26818 */   // GIR_Coverage, 2720,
     /*  26818 */   GIR_EraseRootFromParent_Done,
     /*  26819 */ // Label 554: @26819
     /*  26819 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(26851), // Rule ID 2721 //
     /*  26824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26838 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  26838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26850 */   // GIR_Coverage, 2721,
     /*  26850 */   GIR_EraseRootFromParent_Done,
     /*  26851 */ // Label 555: @26851
     /*  26851 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(26883), // Rule ID 2732 //
     /*  26856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26870 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26882 */   // GIR_Coverage, 2732,
     /*  26882 */   GIR_EraseRootFromParent_Done,
     /*  26883 */ // Label 556: @26883
     /*  26883 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(26915), // Rule ID 2733 //
     /*  26888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26902 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26914 */   // GIR_Coverage, 2733,
     /*  26914 */   GIR_EraseRootFromParent_Done,
     /*  26915 */ // Label 557: @26915
     /*  26915 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(26947), // Rule ID 2734 //
     /*  26920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26934 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26946 */   // GIR_Coverage, 2734,
     /*  26946 */   GIR_EraseRootFromParent_Done,
     /*  26947 */ // Label 558: @26947
     /*  26947 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(26979), // Rule ID 2735 //
     /*  26952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26966 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26978 */   // GIR_Coverage, 2735,
     /*  26978 */   GIR_EraseRootFromParent_Done,
     /*  26979 */ // Label 559: @26979
     /*  26979 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(27011), // Rule ID 2736 //
     /*  26984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26998 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27010 */   // GIR_Coverage, 2736,
     /*  27010 */   GIR_EraseRootFromParent_Done,
     /*  27011 */ // Label 560: @27011
     /*  27011 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(27043), // Rule ID 2737 //
     /*  27016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27030 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27042 */   // GIR_Coverage, 2737,
     /*  27042 */   GIR_EraseRootFromParent_Done,
     /*  27043 */ // Label 561: @27043
     /*  27043 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(27075), // Rule ID 2738 //
     /*  27048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27062 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27074 */   // GIR_Coverage, 2738,
     /*  27074 */   GIR_EraseRootFromParent_Done,
     /*  27075 */ // Label 562: @27075
     /*  27075 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(27107), // Rule ID 2739 //
     /*  27080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27094 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27106 */   // GIR_Coverage, 2739,
     /*  27106 */   GIR_EraseRootFromParent_Done,
     /*  27107 */ // Label 563: @27107
     /*  27107 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(27139), // Rule ID 2740 //
     /*  27112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27126 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27129 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27138 */   // GIR_Coverage, 2740,
     /*  27138 */   GIR_EraseRootFromParent_Done,
     /*  27139 */ // Label 564: @27139
     /*  27139 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(27171), // Rule ID 2741 //
     /*  27144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27158 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27161 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27170 */   // GIR_Coverage, 2741,
     /*  27170 */   GIR_EraseRootFromParent_Done,
     /*  27171 */ // Label 565: @27171
     /*  27171 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(27208), // Rule ID 2804 //
     /*  27176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27190 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2f32] }:$src)
     /*  27190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27206 */   GIR_RootConstrainSelectedInstOperands,
     /*  27207 */   // GIR_Coverage, 2804,
     /*  27207 */   GIR_EraseRootFromParent_Done,
     /*  27208 */ // Label 566: @27208
     /*  27208 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(27245), // Rule ID 2805 //
     /*  27213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27227 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2i32] }:$src)
     /*  27227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27237 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27243 */   GIR_RootConstrainSelectedInstOperands,
     /*  27244 */   // GIR_Coverage, 2805,
     /*  27244 */   GIR_EraseRootFromParent_Done,
     /*  27245 */ // Label 567: @27245
     /*  27245 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(27282), // Rule ID 2806 //
     /*  27250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27264 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4f16] }:$src)
     /*  27264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27274 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27280 */   GIR_RootConstrainSelectedInstOperands,
     /*  27281 */   // GIR_Coverage, 2806,
     /*  27281 */   GIR_EraseRootFromParent_Done,
     /*  27282 */ // Label 568: @27282
     /*  27282 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(27319), // Rule ID 2807 //
     /*  27287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27301 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4i16] }:$src)
     /*  27301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27306 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27311 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27317 */   GIR_RootConstrainSelectedInstOperands,
     /*  27318 */   // GIR_Coverage, 2807,
     /*  27318 */   GIR_EraseRootFromParent_Done,
     /*  27319 */ // Label 569: @27319
     /*  27319 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(27356), // Rule ID 2808 //
     /*  27324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27338 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[f64] } DPR:{ *:[v8i8] }:$src)
     /*  27338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27348 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27354 */   GIR_RootConstrainSelectedInstOperands,
     /*  27355 */   // GIR_Coverage, 2808,
     /*  27355 */   GIR_EraseRootFromParent_Done,
     /*  27356 */ // Label 570: @27356
     /*  27356 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(27393), // Rule ID 2809 //
     /*  27361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27375 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)
     /*  27375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27380 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27385 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27391 */   GIR_RootConstrainSelectedInstOperands,
     /*  27392 */   // GIR_Coverage, 2809,
     /*  27392 */   GIR_EraseRootFromParent_Done,
     /*  27393 */ // Label 571: @27393
     /*  27393 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(27430), // Rule ID 2810 //
     /*  27398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27412 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)
     /*  27412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27422 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27428 */   GIR_RootConstrainSelectedInstOperands,
     /*  27429 */   // GIR_Coverage, 2810,
     /*  27429 */   GIR_EraseRootFromParent_Done,
     /*  27430 */ // Label 572: @27430
     /*  27430 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(27467), // Rule ID 2811 //
     /*  27435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27449 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)
     /*  27449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27459 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27465 */   GIR_RootConstrainSelectedInstOperands,
     /*  27466 */   // GIR_Coverage, 2811,
     /*  27466 */   GIR_EraseRootFromParent_Done,
     /*  27467 */ // Label 573: @27467
     /*  27467 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(27504), // Rule ID 2812 //
     /*  27472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27486 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)
     /*  27486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27502 */   GIR_RootConstrainSelectedInstOperands,
     /*  27503 */   // GIR_Coverage, 2812,
     /*  27503 */   GIR_EraseRootFromParent_Done,
     /*  27504 */ // Label 574: @27504
     /*  27504 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(27541), // Rule ID 2813 //
     /*  27509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27523 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)
     /*  27523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27528 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27533 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27539 */   GIR_RootConstrainSelectedInstOperands,
     /*  27540 */   // GIR_Coverage, 2813,
     /*  27540 */   GIR_EraseRootFromParent_Done,
     /*  27541 */ // Label 575: @27541
     /*  27541 */ GIM_Reject,
     /*  27542 */ // Label 542: @27542
     /*  27542 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(27574), // Rule ID 2722 //
     /*  27547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27561 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27564 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27566 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27573 */   // GIR_Coverage, 2722,
     /*  27573 */   GIR_EraseRootFromParent_Done,
     /*  27574 */ // Label 576: @27574
     /*  27574 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(27606), // Rule ID 2723 //
     /*  27579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27593 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27605 */   // GIR_Coverage, 2723,
     /*  27605 */   GIR_EraseRootFromParent_Done,
     /*  27606 */ // Label 577: @27606
     /*  27606 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(27638), // Rule ID 2742 //
     /*  27611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27625 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27637 */   // GIR_Coverage, 2742,
     /*  27637 */   GIR_EraseRootFromParent_Done,
     /*  27638 */ // Label 578: @27638
     /*  27638 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(27670), // Rule ID 2743 //
     /*  27643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27657 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27669 */   // GIR_Coverage, 2743,
     /*  27669 */   GIR_EraseRootFromParent_Done,
     /*  27670 */ // Label 579: @27670
     /*  27670 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(27702), // Rule ID 2744 //
     /*  27675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27689 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27701 */   // GIR_Coverage, 2744,
     /*  27701 */   GIR_EraseRootFromParent_Done,
     /*  27702 */ // Label 580: @27702
     /*  27702 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(27734), // Rule ID 2745 //
     /*  27707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27721 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27724 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27733 */   // GIR_Coverage, 2745,
     /*  27733 */   GIR_EraseRootFromParent_Done,
     /*  27734 */ // Label 581: @27734
     /*  27734 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(27766), // Rule ID 2746 //
     /*  27739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27753 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27756 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27765 */   // GIR_Coverage, 2746,
     /*  27765 */   GIR_EraseRootFromParent_Done,
     /*  27766 */ // Label 582: @27766
     /*  27766 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(27798), // Rule ID 2747 //
     /*  27771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27785 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27788 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27790 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27797 */   // GIR_Coverage, 2747,
     /*  27797 */   GIR_EraseRootFromParent_Done,
     /*  27798 */ // Label 583: @27798
     /*  27798 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(27830), // Rule ID 2748 //
     /*  27803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27817 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27829 */   // GIR_Coverage, 2748,
     /*  27829 */   GIR_EraseRootFromParent_Done,
     /*  27830 */ // Label 584: @27830
     /*  27830 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(27862), // Rule ID 2749 //
     /*  27835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27849 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27852 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27861 */   // GIR_Coverage, 2749,
     /*  27861 */   GIR_EraseRootFromParent_Done,
     /*  27862 */ // Label 585: @27862
     /*  27862 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(27894), // Rule ID 2750 //
     /*  27867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27881 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27884 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27886 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27893 */   // GIR_Coverage, 2750,
     /*  27893 */   GIR_EraseRootFromParent_Done,
     /*  27894 */ // Label 586: @27894
     /*  27894 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(27926), // Rule ID 2751 //
     /*  27899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27913 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27916 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27918 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27925 */   // GIR_Coverage, 2751,
     /*  27925 */   GIR_EraseRootFromParent_Done,
     /*  27926 */ // Label 587: @27926
     /*  27926 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(27963), // Rule ID 2814 //
     /*  27931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27945 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[f64] }:$src)
     /*  27945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27950 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27955 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27961 */   GIR_RootConstrainSelectedInstOperands,
     /*  27962 */   // GIR_Coverage, 2814,
     /*  27962 */   GIR_EraseRootFromParent_Done,
     /*  27963 */ // Label 588: @27963
     /*  27963 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(28000), // Rule ID 2815 //
     /*  27968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27982 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)
     /*  27982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27998 */   GIR_RootConstrainSelectedInstOperands,
     /*  27999 */   // GIR_Coverage, 2815,
     /*  27999 */   GIR_EraseRootFromParent_Done,
     /*  28000 */ // Label 589: @28000
     /*  28000 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(28037), // Rule ID 2816 //
     /*  28005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28019 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)
     /*  28019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28024 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28029 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28035 */   GIR_RootConstrainSelectedInstOperands,
     /*  28036 */   // GIR_Coverage, 2816,
     /*  28036 */   GIR_EraseRootFromParent_Done,
     /*  28037 */ // Label 590: @28037
     /*  28037 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(28074), // Rule ID 2817 //
     /*  28042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28056 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)
     /*  28056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28072 */   GIR_RootConstrainSelectedInstOperands,
     /*  28073 */   // GIR_Coverage, 2817,
     /*  28073 */   GIR_EraseRootFromParent_Done,
     /*  28074 */ // Label 591: @28074
     /*  28074 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(28111), // Rule ID 2818 //
     /*  28079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28093 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)
     /*  28093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28103 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28109 */   GIR_RootConstrainSelectedInstOperands,
     /*  28110 */   // GIR_Coverage, 2818,
     /*  28110 */   GIR_EraseRootFromParent_Done,
     /*  28111 */ // Label 592: @28111
     /*  28111 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(28148), // Rule ID 2819 //
     /*  28116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28130 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[f64] }:$src)
     /*  28130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28140 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28146 */   GIR_RootConstrainSelectedInstOperands,
     /*  28147 */   // GIR_Coverage, 2819,
     /*  28147 */   GIR_EraseRootFromParent_Done,
     /*  28148 */ // Label 593: @28148
     /*  28148 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(28185), // Rule ID 2820 //
     /*  28153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28167 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)
     /*  28167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28177 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28183 */   GIR_RootConstrainSelectedInstOperands,
     /*  28184 */   // GIR_Coverage, 2820,
     /*  28184 */   GIR_EraseRootFromParent_Done,
     /*  28185 */ // Label 594: @28185
     /*  28185 */ GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(28222), // Rule ID 2821 //
     /*  28190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28204 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)
     /*  28204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28214 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28220 */   GIR_RootConstrainSelectedInstOperands,
     /*  28221 */   // GIR_Coverage, 2821,
     /*  28221 */   GIR_EraseRootFromParent_Done,
     /*  28222 */ // Label 595: @28222
     /*  28222 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(28259), // Rule ID 2822 //
     /*  28227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28241 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)
     /*  28241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28251 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28257 */   GIR_RootConstrainSelectedInstOperands,
     /*  28258 */   // GIR_Coverage, 2822,
     /*  28258 */   GIR_EraseRootFromParent_Done,
     /*  28259 */ // Label 596: @28259
     /*  28259 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(28296), // Rule ID 2823 //
     /*  28264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28278 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)
     /*  28278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28288 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28294 */   GIR_RootConstrainSelectedInstOperands,
     /*  28295 */   // GIR_Coverage, 2823,
     /*  28295 */   GIR_EraseRootFromParent_Done,
     /*  28296 */ // Label 597: @28296
     /*  28296 */ GIM_Reject,
     /*  28297 */ // Label 543: @28297
     /*  28297 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(28329), // Rule ID 2726 //
     /*  28302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28316 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28319 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28321 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28328 */   // GIR_Coverage, 2726,
     /*  28328 */   GIR_EraseRootFromParent_Done,
     /*  28329 */ // Label 598: @28329
     /*  28329 */ GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(28361), // Rule ID 2727 //
     /*  28334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28348 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28351 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28353 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28360 */   // GIR_Coverage, 2727,
     /*  28360 */   GIR_EraseRootFromParent_Done,
     /*  28361 */ // Label 599: @28361
     /*  28361 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(28393), // Rule ID 2768 //
     /*  28366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28380 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28383 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28392 */   // GIR_Coverage, 2768,
     /*  28392 */   GIR_EraseRootFromParent_Done,
     /*  28393 */ // Label 600: @28393
     /*  28393 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(28425), // Rule ID 2769 //
     /*  28398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28412 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28415 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28424 */   // GIR_Coverage, 2769,
     /*  28424 */   GIR_EraseRootFromParent_Done,
     /*  28425 */ // Label 601: @28425
     /*  28425 */ GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(28457), // Rule ID 2770 //
     /*  28430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28444 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28447 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28449 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28456 */   // GIR_Coverage, 2770,
     /*  28456 */   GIR_EraseRootFromParent_Done,
     /*  28457 */ // Label 602: @28457
     /*  28457 */ GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(28489), // Rule ID 2771 //
     /*  28462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28476 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28479 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28481 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28488 */   // GIR_Coverage, 2771,
     /*  28488 */   GIR_EraseRootFromParent_Done,
     /*  28489 */ // Label 603: @28489
     /*  28489 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(28521), // Rule ID 2772 //
     /*  28494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28508 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28511 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28520 */   // GIR_Coverage, 2772,
     /*  28520 */   GIR_EraseRootFromParent_Done,
     /*  28521 */ // Label 604: @28521
     /*  28521 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(28553), // Rule ID 2773 //
     /*  28526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28540 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28543 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28552 */   // GIR_Coverage, 2773,
     /*  28552 */   GIR_EraseRootFromParent_Done,
     /*  28553 */ // Label 605: @28553
     /*  28553 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(28585), // Rule ID 2774 //
     /*  28558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28572 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28575 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28577 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28584 */   // GIR_Coverage, 2774,
     /*  28584 */   GIR_EraseRootFromParent_Done,
     /*  28585 */ // Label 606: @28585
     /*  28585 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(28617), // Rule ID 2775 //
     /*  28590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28604 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28607 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28616 */   // GIR_Coverage, 2775,
     /*  28616 */   GIR_EraseRootFromParent_Done,
     /*  28617 */ // Label 607: @28617
     /*  28617 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(28649), // Rule ID 2776 //
     /*  28622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28636 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28639 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28641 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28648 */   // GIR_Coverage, 2776,
     /*  28648 */   GIR_EraseRootFromParent_Done,
     /*  28649 */ // Label 608: @28649
     /*  28649 */ GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(28681), // Rule ID 2777 //
     /*  28654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28668 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28680 */   // GIR_Coverage, 2777,
     /*  28680 */   GIR_EraseRootFromParent_Done,
     /*  28681 */ // Label 609: @28681
     /*  28681 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(28718), // Rule ID 2840 //
     /*  28686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28700 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)
     /*  28700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28716 */   GIR_RootConstrainSelectedInstOperands,
     /*  28717 */   // GIR_Coverage, 2840,
     /*  28717 */   GIR_EraseRootFromParent_Done,
     /*  28718 */ // Label 610: @28718
     /*  28718 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(28755), // Rule ID 2841 //
     /*  28723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28737 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)
     /*  28737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28753 */   GIR_RootConstrainSelectedInstOperands,
     /*  28754 */   // GIR_Coverage, 2841,
     /*  28754 */   GIR_EraseRootFromParent_Done,
     /*  28755 */ // Label 611: @28755
     /*  28755 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(28792), // Rule ID 2842 //
     /*  28760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28774 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)
     /*  28774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28784 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28790 */   GIR_RootConstrainSelectedInstOperands,
     /*  28791 */   // GIR_Coverage, 2842,
     /*  28791 */   GIR_EraseRootFromParent_Done,
     /*  28792 */ // Label 612: @28792
     /*  28792 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(28829), // Rule ID 2843 //
     /*  28797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28811 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)
     /*  28811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28821 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28827 */   GIR_RootConstrainSelectedInstOperands,
     /*  28828 */   // GIR_Coverage, 2843,
     /*  28828 */   GIR_EraseRootFromParent_Done,
     /*  28829 */ // Label 613: @28829
     /*  28829 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(28866), // Rule ID 2844 //
     /*  28834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28848 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)
     /*  28848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  28851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28858 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28864 */   GIR_RootConstrainSelectedInstOperands,
     /*  28865 */   // GIR_Coverage, 2844,
     /*  28865 */   GIR_EraseRootFromParent_Done,
     /*  28866 */ // Label 614: @28866
     /*  28866 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(28903), // Rule ID 2845 //
     /*  28871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28885 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)
     /*  28885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28895 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28901 */   GIR_RootConstrainSelectedInstOperands,
     /*  28902 */   // GIR_Coverage, 2845,
     /*  28902 */   GIR_EraseRootFromParent_Done,
     /*  28903 */ // Label 615: @28903
     /*  28903 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(28940), // Rule ID 2846 //
     /*  28908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28922 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)
     /*  28922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28927 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28932 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28938 */   GIR_RootConstrainSelectedInstOperands,
     /*  28939 */   // GIR_Coverage, 2846,
     /*  28939 */   GIR_EraseRootFromParent_Done,
     /*  28940 */ // Label 616: @28940
     /*  28940 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(28977), // Rule ID 2847 //
     /*  28945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28959 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)
     /*  28959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28969 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28975 */   GIR_RootConstrainSelectedInstOperands,
     /*  28976 */   // GIR_Coverage, 2847,
     /*  28976 */   GIR_EraseRootFromParent_Done,
     /*  28977 */ // Label 617: @28977
     /*  28977 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(29014), // Rule ID 2848 //
     /*  28982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28996 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)
     /*  28996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29012 */   GIR_RootConstrainSelectedInstOperands,
     /*  29013 */   // GIR_Coverage, 2848,
     /*  29013 */   GIR_EraseRootFromParent_Done,
     /*  29014 */ // Label 618: @29014
     /*  29014 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(29051), // Rule ID 2849 //
     /*  29019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  29022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29033 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)
     /*  29033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  29036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29043 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29049 */   GIR_RootConstrainSelectedInstOperands,
     /*  29050 */   // GIR_Coverage, 2849,
     /*  29050 */   GIR_EraseRootFromParent_Done,
     /*  29051 */ // Label 619: @29051
     /*  29051 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(29083), // Rule ID 5283 //
     /*  29056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29070 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29073 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29075 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29082 */   // GIR_Coverage, 5283,
     /*  29082 */   GIR_EraseRootFromParent_Done,
     /*  29083 */ // Label 620: @29083
     /*  29083 */ GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(29115), // Rule ID 5284 //
     /*  29088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29102 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29114 */   // GIR_Coverage, 5284,
     /*  29114 */   GIR_EraseRootFromParent_Done,
     /*  29115 */ // Label 621: @29115
     /*  29115 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(29147), // Rule ID 5289 //
     /*  29120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29134 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29137 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29139 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29146 */   // GIR_Coverage, 5289,
     /*  29146 */   GIR_EraseRootFromParent_Done,
     /*  29147 */ // Label 622: @29147
     /*  29147 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(29179), // Rule ID 5290 //
     /*  29152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29166 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29169 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29178 */   // GIR_Coverage, 5290,
     /*  29178 */   GIR_EraseRootFromParent_Done,
     /*  29179 */ // Label 623: @29179
     /*  29179 */ GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(29211), // Rule ID 5291 //
     /*  29184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29198 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29201 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29203 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29210 */   // GIR_Coverage, 5291,
     /*  29210 */   GIR_EraseRootFromParent_Done,
     /*  29211 */ // Label 624: @29211
     /*  29211 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(29243), // Rule ID 5292 //
     /*  29216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29230 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29233 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29242 */   // GIR_Coverage, 5292,
     /*  29242 */   GIR_EraseRootFromParent_Done,
     /*  29243 */ // Label 625: @29243
     /*  29243 */ GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(29275), // Rule ID 5293 //
     /*  29248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29262 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29265 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29274 */   // GIR_Coverage, 5293,
     /*  29274 */   GIR_EraseRootFromParent_Done,
     /*  29275 */ // Label 626: @29275
     /*  29275 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(29307), // Rule ID 5294 //
     /*  29280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29294 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29297 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29299 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29306 */   // GIR_Coverage, 5294,
     /*  29306 */   GIR_EraseRootFromParent_Done,
     /*  29307 */ // Label 627: @29307
     /*  29307 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(29339), // Rule ID 5295 //
     /*  29312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29326 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29338 */   // GIR_Coverage, 5295,
     /*  29338 */   GIR_EraseRootFromParent_Done,
     /*  29339 */ // Label 628: @29339
     /*  29339 */ GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(29371), // Rule ID 5296 //
     /*  29344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29358 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29361 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29370 */   // GIR_Coverage, 5296,
     /*  29370 */   GIR_EraseRootFromParent_Done,
     /*  29371 */ // Label 629: @29371
     /*  29371 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(29403), // Rule ID 5297 //
     /*  29376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29390 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29393 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29395 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29402 */   // GIR_Coverage, 5297,
     /*  29402 */   GIR_EraseRootFromParent_Done,
     /*  29403 */ // Label 630: @29403
     /*  29403 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(29435), // Rule ID 5298 //
     /*  29408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29422 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29434 */   // GIR_Coverage, 5298,
     /*  29434 */   GIR_EraseRootFromParent_Done,
     /*  29435 */ // Label 631: @29435
     /*  29435 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(29493), // Rule ID 5325 //
     /*  29440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29454 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)
     /*  29454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29476 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29491 */   GIR_RootConstrainSelectedInstOperands,
     /*  29492 */   // GIR_Coverage, 5325,
     /*  29492 */   GIR_EraseRootFromParent_Done,
     /*  29493 */ // Label 632: @29493
     /*  29493 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(29551), // Rule ID 5326 //
     /*  29498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29512 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)
     /*  29512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29529 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29534 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29549 */   GIR_RootConstrainSelectedInstOperands,
     /*  29550 */   // GIR_Coverage, 5326,
     /*  29550 */   GIR_EraseRootFromParent_Done,
     /*  29551 */ // Label 633: @29551
     /*  29551 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(29609), // Rule ID 5327 //
     /*  29556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29570 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)
     /*  29570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29592 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29607 */   GIR_RootConstrainSelectedInstOperands,
     /*  29608 */   // GIR_Coverage, 5327,
     /*  29608 */   GIR_EraseRootFromParent_Done,
     /*  29609 */ // Label 634: @29609
     /*  29609 */ GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(29667), // Rule ID 5328 //
     /*  29614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29628 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)
     /*  29628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29656 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29665 */   GIR_RootConstrainSelectedInstOperands,
     /*  29666 */   // GIR_Coverage, 5328,
     /*  29666 */   GIR_EraseRootFromParent_Done,
     /*  29667 */ // Label 635: @29667
     /*  29667 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(29725), // Rule ID 5329 //
     /*  29672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29686 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)
     /*  29686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29703 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29714 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29723 */   GIR_RootConstrainSelectedInstOperands,
     /*  29724 */   // GIR_Coverage, 5329,
     /*  29724 */   GIR_EraseRootFromParent_Done,
     /*  29725 */ // Label 636: @29725
     /*  29725 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(29783), // Rule ID 5330 //
     /*  29730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29744 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)
     /*  29744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29761 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29766 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29772 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29781 */   GIR_RootConstrainSelectedInstOperands,
     /*  29782 */   // GIR_Coverage, 5330,
     /*  29782 */   GIR_EraseRootFromParent_Done,
     /*  29783 */ // Label 637: @29783
     /*  29783 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(29841), // Rule ID 5331 //
     /*  29788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29802 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)
     /*  29802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29824 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29830 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29839 */   GIR_RootConstrainSelectedInstOperands,
     /*  29840 */   // GIR_Coverage, 5331,
     /*  29840 */   GIR_EraseRootFromParent_Done,
     /*  29841 */ // Label 638: @29841
     /*  29841 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(29899), // Rule ID 5332 //
     /*  29846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29860 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)
     /*  29860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29888 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29897 */   GIR_RootConstrainSelectedInstOperands,
     /*  29898 */   // GIR_Coverage, 5332,
     /*  29898 */   GIR_EraseRootFromParent_Done,
     /*  29899 */ // Label 639: @29899
     /*  29899 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(29957), // Rule ID 5333 //
     /*  29904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29918 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)
     /*  29918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29946 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29955 */   GIR_RootConstrainSelectedInstOperands,
     /*  29956 */   // GIR_Coverage, 5333,
     /*  29956 */   GIR_EraseRootFromParent_Done,
     /*  29957 */ // Label 640: @29957
     /*  29957 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(30015), // Rule ID 5334 //
     /*  29962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29976 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)
     /*  29976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30013 */   GIR_RootConstrainSelectedInstOperands,
     /*  30014 */   // GIR_Coverage, 5334,
     /*  30014 */   GIR_EraseRootFromParent_Done,
     /*  30015 */ // Label 641: @30015
     /*  30015 */ GIM_Reject,
     /*  30016 */ // Label 544: @30016
     /*  30016 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(30048), // Rule ID 2724 //
     /*  30021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30035 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30047 */   // GIR_Coverage, 2724,
     /*  30047 */   GIR_EraseRootFromParent_Done,
     /*  30048 */ // Label 642: @30048
     /*  30048 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(30080), // Rule ID 2725 //
     /*  30053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30067 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30070 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30072 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30079 */   // GIR_Coverage, 2725,
     /*  30079 */   GIR_EraseRootFromParent_Done,
     /*  30080 */ // Label 643: @30080
     /*  30080 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(30112), // Rule ID 2752 //
     /*  30085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30099 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30102 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30104 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30111 */   // GIR_Coverage, 2752,
     /*  30111 */   GIR_EraseRootFromParent_Done,
     /*  30112 */ // Label 644: @30112
     /*  30112 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(30144), // Rule ID 2753 //
     /*  30117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30131 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30143 */   // GIR_Coverage, 2753,
     /*  30143 */   GIR_EraseRootFromParent_Done,
     /*  30144 */ // Label 645: @30144
     /*  30144 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(30176), // Rule ID 2754 //
     /*  30149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30163 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30166 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30168 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30175 */   // GIR_Coverage, 2754,
     /*  30175 */   GIR_EraseRootFromParent_Done,
     /*  30176 */ // Label 646: @30176
     /*  30176 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(30208), // Rule ID 2755 //
     /*  30181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30195 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30207 */   // GIR_Coverage, 2755,
     /*  30207 */   GIR_EraseRootFromParent_Done,
     /*  30208 */ // Label 647: @30208
     /*  30208 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(30240), // Rule ID 2756 //
     /*  30213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30227 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30230 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30239 */   // GIR_Coverage, 2756,
     /*  30239 */   GIR_EraseRootFromParent_Done,
     /*  30240 */ // Label 648: @30240
     /*  30240 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(30272), // Rule ID 2757 //
     /*  30245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30259 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30271 */   // GIR_Coverage, 2757,
     /*  30271 */   GIR_EraseRootFromParent_Done,
     /*  30272 */ // Label 649: @30272
     /*  30272 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(30304), // Rule ID 2758 //
     /*  30277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30291 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30303 */   // GIR_Coverage, 2758,
     /*  30303 */   GIR_EraseRootFromParent_Done,
     /*  30304 */ // Label 650: @30304
     /*  30304 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(30336), // Rule ID 2759 //
     /*  30309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30323 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30335 */   // GIR_Coverage, 2759,
     /*  30335 */   GIR_EraseRootFromParent_Done,
     /*  30336 */ // Label 651: @30336
     /*  30336 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(30368), // Rule ID 2760 //
     /*  30341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30355 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30367 */   // GIR_Coverage, 2760,
     /*  30367 */   GIR_EraseRootFromParent_Done,
     /*  30368 */ // Label 652: @30368
     /*  30368 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(30400), // Rule ID 2761 //
     /*  30373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30387 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30399 */   // GIR_Coverage, 2761,
     /*  30399 */   GIR_EraseRootFromParent_Done,
     /*  30400 */ // Label 653: @30400
     /*  30400 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(30437), // Rule ID 2824 //
     /*  30405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30419 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[f64] }:$src)
     /*  30419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30435 */   GIR_RootConstrainSelectedInstOperands,
     /*  30436 */   // GIR_Coverage, 2824,
     /*  30436 */   GIR_EraseRootFromParent_Done,
     /*  30437 */ // Label 654: @30437
     /*  30437 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(30474), // Rule ID 2825 //
     /*  30442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30456 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)
     /*  30456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30472 */   GIR_RootConstrainSelectedInstOperands,
     /*  30473 */   // GIR_Coverage, 2825,
     /*  30473 */   GIR_EraseRootFromParent_Done,
     /*  30474 */ // Label 655: @30474
     /*  30474 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(30511), // Rule ID 2826 //
     /*  30479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30493 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)
     /*  30493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30509 */   GIR_RootConstrainSelectedInstOperands,
     /*  30510 */   // GIR_Coverage, 2826,
     /*  30510 */   GIR_EraseRootFromParent_Done,
     /*  30511 */ // Label 656: @30511
     /*  30511 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(30548), // Rule ID 2827 //
     /*  30516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30530 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)
     /*  30530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30546 */   GIR_RootConstrainSelectedInstOperands,
     /*  30547 */   // GIR_Coverage, 2827,
     /*  30547 */   GIR_EraseRootFromParent_Done,
     /*  30548 */ // Label 657: @30548
     /*  30548 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(30585), // Rule ID 2828 //
     /*  30553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30567 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)
     /*  30567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30583 */   GIR_RootConstrainSelectedInstOperands,
     /*  30584 */   // GIR_Coverage, 2828,
     /*  30584 */   GIR_EraseRootFromParent_Done,
     /*  30585 */ // Label 658: @30585
     /*  30585 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(30622), // Rule ID 2829 //
     /*  30590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30604 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[f64] }:$src)
     /*  30604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30620 */   GIR_RootConstrainSelectedInstOperands,
     /*  30621 */   // GIR_Coverage, 2829,
     /*  30621 */   GIR_EraseRootFromParent_Done,
     /*  30622 */ // Label 659: @30622
     /*  30622 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(30659), // Rule ID 2830 //
     /*  30627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30641 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)
     /*  30641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30657 */   GIR_RootConstrainSelectedInstOperands,
     /*  30658 */   // GIR_Coverage, 2830,
     /*  30658 */   GIR_EraseRootFromParent_Done,
     /*  30659 */ // Label 660: @30659
     /*  30659 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(30696), // Rule ID 2831 //
     /*  30664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30678 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)
     /*  30678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30688 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30694 */   GIR_RootConstrainSelectedInstOperands,
     /*  30695 */   // GIR_Coverage, 2831,
     /*  30695 */   GIR_EraseRootFromParent_Done,
     /*  30696 */ // Label 661: @30696
     /*  30696 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(30733), // Rule ID 2832 //
     /*  30701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30715 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)
     /*  30715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30725 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30731 */   GIR_RootConstrainSelectedInstOperands,
     /*  30732 */   // GIR_Coverage, 2832,
     /*  30732 */   GIR_EraseRootFromParent_Done,
     /*  30733 */ // Label 662: @30733
     /*  30733 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(30770), // Rule ID 2833 //
     /*  30738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30752 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)
     /*  30752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30757 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30762 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30768 */   GIR_RootConstrainSelectedInstOperands,
     /*  30769 */   // GIR_Coverage, 2833,
     /*  30769 */   GIR_EraseRootFromParent_Done,
     /*  30770 */ // Label 663: @30770
     /*  30770 */ GIM_Reject,
     /*  30771 */ // Label 545: @30771
     /*  30771 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(30803), // Rule ID 2728 //
     /*  30776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30790 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30802 */   // GIR_Coverage, 2728,
     /*  30802 */   GIR_EraseRootFromParent_Done,
     /*  30803 */ // Label 664: @30803
     /*  30803 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(30835), // Rule ID 2729 //
     /*  30808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30822 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30834 */   // GIR_Coverage, 2729,
     /*  30834 */   GIR_EraseRootFromParent_Done,
     /*  30835 */ // Label 665: @30835
     /*  30835 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(30867), // Rule ID 2778 //
     /*  30840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30854 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30866 */   // GIR_Coverage, 2778,
     /*  30866 */   GIR_EraseRootFromParent_Done,
     /*  30867 */ // Label 666: @30867
     /*  30867 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(30899), // Rule ID 2779 //
     /*  30872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30886 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30898 */   // GIR_Coverage, 2779,
     /*  30898 */   GIR_EraseRootFromParent_Done,
     /*  30899 */ // Label 667: @30899
     /*  30899 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(30931), // Rule ID 2780 //
     /*  30904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30918 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30930 */   // GIR_Coverage, 2780,
     /*  30930 */   GIR_EraseRootFromParent_Done,
     /*  30931 */ // Label 668: @30931
     /*  30931 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(30963), // Rule ID 2781 //
     /*  30936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30950 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30962 */   // GIR_Coverage, 2781,
     /*  30962 */   GIR_EraseRootFromParent_Done,
     /*  30963 */ // Label 669: @30963
     /*  30963 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(30995), // Rule ID 2782 //
     /*  30968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30982 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30994 */   // GIR_Coverage, 2782,
     /*  30994 */   GIR_EraseRootFromParent_Done,
     /*  30995 */ // Label 670: @30995
     /*  30995 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(31027), // Rule ID 2783 //
     /*  31000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31014 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31026 */   // GIR_Coverage, 2783,
     /*  31026 */   GIR_EraseRootFromParent_Done,
     /*  31027 */ // Label 671: @31027
     /*  31027 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(31059), // Rule ID 2784 //
     /*  31032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31046 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31058 */   // GIR_Coverage, 2784,
     /*  31058 */   GIR_EraseRootFromParent_Done,
     /*  31059 */ // Label 672: @31059
     /*  31059 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(31091), // Rule ID 2785 //
     /*  31064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31078 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31090 */   // GIR_Coverage, 2785,
     /*  31090 */   GIR_EraseRootFromParent_Done,
     /*  31091 */ // Label 673: @31091
     /*  31091 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(31123), // Rule ID 2786 //
     /*  31096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31110 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31122 */   // GIR_Coverage, 2786,
     /*  31122 */   GIR_EraseRootFromParent_Done,
     /*  31123 */ // Label 674: @31123
     /*  31123 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(31155), // Rule ID 2787 //
     /*  31128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31142 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31154 */   // GIR_Coverage, 2787,
     /*  31154 */   GIR_EraseRootFromParent_Done,
     /*  31155 */ // Label 675: @31155
     /*  31155 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(31192), // Rule ID 2850 //
     /*  31160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31174 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)
     /*  31174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31184 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31190 */   GIR_RootConstrainSelectedInstOperands,
     /*  31191 */   // GIR_Coverage, 2850,
     /*  31191 */   GIR_EraseRootFromParent_Done,
     /*  31192 */ // Label 676: @31192
     /*  31192 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(31229), // Rule ID 2851 //
     /*  31197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31211 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)
     /*  31211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31216 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31227 */   GIR_RootConstrainSelectedInstOperands,
     /*  31228 */   // GIR_Coverage, 2851,
     /*  31228 */   GIR_EraseRootFromParent_Done,
     /*  31229 */ // Label 677: @31229
     /*  31229 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(31266), // Rule ID 2852 //
     /*  31234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31248 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)
     /*  31248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31264 */   GIR_RootConstrainSelectedInstOperands,
     /*  31265 */   // GIR_Coverage, 2852,
     /*  31265 */   GIR_EraseRootFromParent_Done,
     /*  31266 */ // Label 678: @31266
     /*  31266 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(31303), // Rule ID 2853 //
     /*  31271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31285 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)
     /*  31285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31295 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31301 */   GIR_RootConstrainSelectedInstOperands,
     /*  31302 */   // GIR_Coverage, 2853,
     /*  31302 */   GIR_EraseRootFromParent_Done,
     /*  31303 */ // Label 679: @31303
     /*  31303 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(31340), // Rule ID 2854 //
     /*  31308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31322 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)
     /*  31322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31332 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31338 */   GIR_RootConstrainSelectedInstOperands,
     /*  31339 */   // GIR_Coverage, 2854,
     /*  31339 */   GIR_EraseRootFromParent_Done,
     /*  31340 */ // Label 680: @31340
     /*  31340 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(31377), // Rule ID 2855 //
     /*  31345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31359 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)
     /*  31359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31369 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31375 */   GIR_RootConstrainSelectedInstOperands,
     /*  31376 */   // GIR_Coverage, 2855,
     /*  31376 */   GIR_EraseRootFromParent_Done,
     /*  31377 */ // Label 681: @31377
     /*  31377 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(31414), // Rule ID 2856 //
     /*  31382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31396 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)
     /*  31396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31412 */   GIR_RootConstrainSelectedInstOperands,
     /*  31413 */   // GIR_Coverage, 2856,
     /*  31413 */   GIR_EraseRootFromParent_Done,
     /*  31414 */ // Label 682: @31414
     /*  31414 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(31451), // Rule ID 2857 //
     /*  31419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31433 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)
     /*  31433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31443 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31449 */   GIR_RootConstrainSelectedInstOperands,
     /*  31450 */   // GIR_Coverage, 2857,
     /*  31450 */   GIR_EraseRootFromParent_Done,
     /*  31451 */ // Label 683: @31451
     /*  31451 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(31488), // Rule ID 2858 //
     /*  31456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31470 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)
     /*  31470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31480 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31486 */   GIR_RootConstrainSelectedInstOperands,
     /*  31487 */   // GIR_Coverage, 2858,
     /*  31487 */   GIR_EraseRootFromParent_Done,
     /*  31488 */ // Label 684: @31488
     /*  31488 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(31525), // Rule ID 2859 //
     /*  31493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31507 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)
     /*  31507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31517 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31523 */   GIR_RootConstrainSelectedInstOperands,
     /*  31524 */   // GIR_Coverage, 2859,
     /*  31524 */   GIR_EraseRootFromParent_Done,
     /*  31525 */ // Label 685: @31525
     /*  31525 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(31557), // Rule ID 5285 //
     /*  31530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31544 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31556 */   // GIR_Coverage, 5285,
     /*  31556 */   GIR_EraseRootFromParent_Done,
     /*  31557 */ // Label 686: @31557
     /*  31557 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(31589), // Rule ID 5286 //
     /*  31562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31576 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31588 */   // GIR_Coverage, 5286,
     /*  31588 */   GIR_EraseRootFromParent_Done,
     /*  31589 */ // Label 687: @31589
     /*  31589 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(31621), // Rule ID 5299 //
     /*  31594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31608 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31611 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31620 */   // GIR_Coverage, 5299,
     /*  31620 */   GIR_EraseRootFromParent_Done,
     /*  31621 */ // Label 688: @31621
     /*  31621 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(31653), // Rule ID 5300 //
     /*  31626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31640 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31643 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31652 */   // GIR_Coverage, 5300,
     /*  31652 */   GIR_EraseRootFromParent_Done,
     /*  31653 */ // Label 689: @31653
     /*  31653 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(31685), // Rule ID 5301 //
     /*  31658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31672 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31675 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31677 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31684 */   // GIR_Coverage, 5301,
     /*  31684 */   GIR_EraseRootFromParent_Done,
     /*  31685 */ // Label 690: @31685
     /*  31685 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(31717), // Rule ID 5302 //
     /*  31690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31704 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31707 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31709 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31716 */   // GIR_Coverage, 5302,
     /*  31716 */   GIR_EraseRootFromParent_Done,
     /*  31717 */ // Label 691: @31717
     /*  31717 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(31749), // Rule ID 5303 //
     /*  31722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31736 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31748 */   // GIR_Coverage, 5303,
     /*  31748 */   GIR_EraseRootFromParent_Done,
     /*  31749 */ // Label 692: @31749
     /*  31749 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(31781), // Rule ID 5304 //
     /*  31754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31768 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31780 */   // GIR_Coverage, 5304,
     /*  31780 */   GIR_EraseRootFromParent_Done,
     /*  31781 */ // Label 693: @31781
     /*  31781 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(31813), // Rule ID 5305 //
     /*  31786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31800 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31812 */   // GIR_Coverage, 5305,
     /*  31812 */   GIR_EraseRootFromParent_Done,
     /*  31813 */ // Label 694: @31813
     /*  31813 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(31845), // Rule ID 5306 //
     /*  31818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31832 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31844 */   // GIR_Coverage, 5306,
     /*  31844 */   GIR_EraseRootFromParent_Done,
     /*  31845 */ // Label 695: @31845
     /*  31845 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(31877), // Rule ID 5307 //
     /*  31850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31864 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31876 */   // GIR_Coverage, 5307,
     /*  31876 */   GIR_EraseRootFromParent_Done,
     /*  31877 */ // Label 696: @31877
     /*  31877 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(31909), // Rule ID 5308 //
     /*  31882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31896 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31908 */   // GIR_Coverage, 5308,
     /*  31908 */   GIR_EraseRootFromParent_Done,
     /*  31909 */ // Label 697: @31909
     /*  31909 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(31967), // Rule ID 5335 //
     /*  31914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31928 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)
     /*  31928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31950 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  31965 */   GIR_RootConstrainSelectedInstOperands,
     /*  31966 */   // GIR_Coverage, 5335,
     /*  31966 */   GIR_EraseRootFromParent_Done,
     /*  31967 */ // Label 698: @31967
     /*  31967 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(32025), // Rule ID 5336 //
     /*  31972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31986 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)
     /*  31986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32008 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32014 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32023 */   GIR_RootConstrainSelectedInstOperands,
     /*  32024 */   // GIR_Coverage, 5336,
     /*  32024 */   GIR_EraseRootFromParent_Done,
     /*  32025 */ // Label 699: @32025
     /*  32025 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(32083), // Rule ID 5337 //
     /*  32030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32044 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)
     /*  32044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32072 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32081 */   GIR_RootConstrainSelectedInstOperands,
     /*  32082 */   // GIR_Coverage, 5337,
     /*  32082 */   GIR_EraseRootFromParent_Done,
     /*  32083 */ // Label 700: @32083
     /*  32083 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(32141), // Rule ID 5338 //
     /*  32088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32102 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)
     /*  32102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32124 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32139 */   GIR_RootConstrainSelectedInstOperands,
     /*  32140 */   // GIR_Coverage, 5338,
     /*  32140 */   GIR_EraseRootFromParent_Done,
     /*  32141 */ // Label 701: @32141
     /*  32141 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(32199), // Rule ID 5339 //
     /*  32146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32160 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)
     /*  32160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32182 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32188 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32197 */   GIR_RootConstrainSelectedInstOperands,
     /*  32198 */   // GIR_Coverage, 5339,
     /*  32198 */   GIR_EraseRootFromParent_Done,
     /*  32199 */ // Label 702: @32199
     /*  32199 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(32257), // Rule ID 5340 //
     /*  32204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32218 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)
     /*  32218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32240 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32246 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32255 */   GIR_RootConstrainSelectedInstOperands,
     /*  32256 */   // GIR_Coverage, 5340,
     /*  32256 */   GIR_EraseRootFromParent_Done,
     /*  32257 */ // Label 703: @32257
     /*  32257 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(32315), // Rule ID 5341 //
     /*  32262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32276 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)
     /*  32276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32298 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32304 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32313 */   GIR_RootConstrainSelectedInstOperands,
     /*  32314 */   // GIR_Coverage, 5341,
     /*  32314 */   GIR_EraseRootFromParent_Done,
     /*  32315 */ // Label 704: @32315
     /*  32315 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(32373), // Rule ID 5342 //
     /*  32320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32334 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)
     /*  32334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32356 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32362 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32371 */   GIR_RootConstrainSelectedInstOperands,
     /*  32372 */   // GIR_Coverage, 5342,
     /*  32372 */   GIR_EraseRootFromParent_Done,
     /*  32373 */ // Label 705: @32373
     /*  32373 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(32431), // Rule ID 5343 //
     /*  32378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32392 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  32392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32409 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32420 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32429 */   GIR_RootConstrainSelectedInstOperands,
     /*  32430 */   // GIR_Coverage, 5343,
     /*  32430 */   GIR_EraseRootFromParent_Done,
     /*  32431 */ // Label 706: @32431
     /*  32431 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(32489), // Rule ID 5344 //
     /*  32436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32450 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)
     /*  32450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32487 */   GIR_RootConstrainSelectedInstOperands,
     /*  32488 */   // GIR_Coverage, 5344,
     /*  32488 */   GIR_EraseRootFromParent_Done,
     /*  32489 */ // Label 707: @32489
     /*  32489 */ GIM_Reject,
     /*  32490 */ // Label 546: @32490
     /*  32490 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(32522), // Rule ID 2762 //
     /*  32495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32509 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32521 */   // GIR_Coverage, 2762,
     /*  32521 */   GIR_EraseRootFromParent_Done,
     /*  32522 */ // Label 708: @32522
     /*  32522 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(32554), // Rule ID 2763 //
     /*  32527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32541 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32544 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32546 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32553 */   // GIR_Coverage, 2763,
     /*  32553 */   GIR_EraseRootFromParent_Done,
     /*  32554 */ // Label 709: @32554
     /*  32554 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(32586), // Rule ID 2764 //
     /*  32559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32573 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32576 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32578 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32585 */   // GIR_Coverage, 2764,
     /*  32585 */   GIR_EraseRootFromParent_Done,
     /*  32586 */ // Label 710: @32586
     /*  32586 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(32618), // Rule ID 2765 //
     /*  32591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32605 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32608 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32610 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32617 */   // GIR_Coverage, 2765,
     /*  32617 */   GIR_EraseRootFromParent_Done,
     /*  32618 */ // Label 711: @32618
     /*  32618 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(32650), // Rule ID 2766 //
     /*  32623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32637 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32640 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32642 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32649 */   // GIR_Coverage, 2766,
     /*  32649 */   GIR_EraseRootFromParent_Done,
     /*  32650 */ // Label 712: @32650
     /*  32650 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(32682), // Rule ID 2767 //
     /*  32655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32669 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32672 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32674 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32681 */   // GIR_Coverage, 2767,
     /*  32681 */   GIR_EraseRootFromParent_Done,
     /*  32682 */ // Label 713: @32682
     /*  32682 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(32719), // Rule ID 2834 //
     /*  32687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32701 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[f64] }:$src)
     /*  32701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32711 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32717 */   GIR_RootConstrainSelectedInstOperands,
     /*  32718 */   // GIR_Coverage, 2834,
     /*  32718 */   GIR_EraseRootFromParent_Done,
     /*  32719 */ // Label 714: @32719
     /*  32719 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(32756), // Rule ID 2835 //
     /*  32724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32738 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)
     /*  32738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32754 */   GIR_RootConstrainSelectedInstOperands,
     /*  32755 */   // GIR_Coverage, 2835,
     /*  32755 */   GIR_EraseRootFromParent_Done,
     /*  32756 */ // Label 715: @32756
     /*  32756 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(32793), // Rule ID 2836 //
     /*  32761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32775 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)
     /*  32775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32791 */   GIR_RootConstrainSelectedInstOperands,
     /*  32792 */   // GIR_Coverage, 2836,
     /*  32792 */   GIR_EraseRootFromParent_Done,
     /*  32793 */ // Label 716: @32793
     /*  32793 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(32830), // Rule ID 2837 //
     /*  32798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32812 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)
     /*  32812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32822 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32828 */   GIR_RootConstrainSelectedInstOperands,
     /*  32829 */   // GIR_Coverage, 2837,
     /*  32829 */   GIR_EraseRootFromParent_Done,
     /*  32830 */ // Label 717: @32830
     /*  32830 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(32867), // Rule ID 2838 //
     /*  32835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32849 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)
     /*  32849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32859 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32865 */   GIR_RootConstrainSelectedInstOperands,
     /*  32866 */   // GIR_Coverage, 2838,
     /*  32866 */   GIR_EraseRootFromParent_Done,
     /*  32867 */ // Label 718: @32867
     /*  32867 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(32904), // Rule ID 2839 //
     /*  32872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32886 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)
     /*  32886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32896 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32902 */   GIR_RootConstrainSelectedInstOperands,
     /*  32903 */   // GIR_Coverage, 2839,
     /*  32903 */   GIR_EraseRootFromParent_Done,
     /*  32904 */ // Label 719: @32904
     /*  32904 */ GIM_Reject,
     /*  32905 */ // Label 547: @32905
     /*  32905 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(32937), // Rule ID 2730 //
     /*  32910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32924 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  32924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32936 */   // GIR_Coverage, 2730,
     /*  32936 */   GIR_EraseRootFromParent_Done,
     /*  32937 */ // Label 720: @32937
     /*  32937 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(32969), // Rule ID 2731 //
     /*  32942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32956 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32968 */   // GIR_Coverage, 2731,
     /*  32968 */   GIR_EraseRootFromParent_Done,
     /*  32969 */ // Label 721: @32969
     /*  32969 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(33001), // Rule ID 2788 //
     /*  32974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32988 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33000 */   // GIR_Coverage, 2788,
     /*  33000 */   GIR_EraseRootFromParent_Done,
     /*  33001 */ // Label 722: @33001
     /*  33001 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(33033), // Rule ID 2789 //
     /*  33006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33020 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33032 */   // GIR_Coverage, 2789,
     /*  33032 */   GIR_EraseRootFromParent_Done,
     /*  33033 */ // Label 723: @33033
     /*  33033 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(33065), // Rule ID 2790 //
     /*  33038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33052 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33055 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33064 */   // GIR_Coverage, 2790,
     /*  33064 */   GIR_EraseRootFromParent_Done,
     /*  33065 */ // Label 724: @33065
     /*  33065 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(33097), // Rule ID 2791 //
     /*  33070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33084 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33087 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33089 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33096 */   // GIR_Coverage, 2791,
     /*  33096 */   GIR_EraseRootFromParent_Done,
     /*  33097 */ // Label 725: @33097
     /*  33097 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(33129), // Rule ID 2792 //
     /*  33102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33116 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33119 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33128 */   // GIR_Coverage, 2792,
     /*  33128 */   GIR_EraseRootFromParent_Done,
     /*  33129 */ // Label 726: @33129
     /*  33129 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(33161), // Rule ID 2793 //
     /*  33134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33148 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33151 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33160 */   // GIR_Coverage, 2793,
     /*  33160 */   GIR_EraseRootFromParent_Done,
     /*  33161 */ // Label 727: @33161
     /*  33161 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(33193), // Rule ID 2794 //
     /*  33166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33180 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33192 */   // GIR_Coverage, 2794,
     /*  33192 */   GIR_EraseRootFromParent_Done,
     /*  33193 */ // Label 728: @33193
     /*  33193 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(33225), // Rule ID 2795 //
     /*  33198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33212 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33215 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33217 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33224 */   // GIR_Coverage, 2795,
     /*  33224 */   GIR_EraseRootFromParent_Done,
     /*  33225 */ // Label 729: @33225
     /*  33225 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(33257), // Rule ID 2796 //
     /*  33230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33244 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33247 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33256 */   // GIR_Coverage, 2796,
     /*  33256 */   GIR_EraseRootFromParent_Done,
     /*  33257 */ // Label 730: @33257
     /*  33257 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(33289), // Rule ID 2797 //
     /*  33262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33276 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33288 */   // GIR_Coverage, 2797,
     /*  33288 */   GIR_EraseRootFromParent_Done,
     /*  33289 */ // Label 731: @33289
     /*  33289 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(33326), // Rule ID 2860 //
     /*  33294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33308 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)
     /*  33308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33313 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33318 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33324 */   GIR_RootConstrainSelectedInstOperands,
     /*  33325 */   // GIR_Coverage, 2860,
     /*  33325 */   GIR_EraseRootFromParent_Done,
     /*  33326 */ // Label 732: @33326
     /*  33326 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(33363), // Rule ID 2861 //
     /*  33331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33345 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)
     /*  33345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33350 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33355 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33361 */   GIR_RootConstrainSelectedInstOperands,
     /*  33362 */   // GIR_Coverage, 2861,
     /*  33362 */   GIR_EraseRootFromParent_Done,
     /*  33363 */ // Label 733: @33363
     /*  33363 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(33400), // Rule ID 2862 //
     /*  33368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33382 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)
     /*  33382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33398 */   GIR_RootConstrainSelectedInstOperands,
     /*  33399 */   // GIR_Coverage, 2862,
     /*  33399 */   GIR_EraseRootFromParent_Done,
     /*  33400 */ // Label 734: @33400
     /*  33400 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(33437), // Rule ID 2863 //
     /*  33405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33419 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)
     /*  33419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33435 */   GIR_RootConstrainSelectedInstOperands,
     /*  33436 */   // GIR_Coverage, 2863,
     /*  33436 */   GIR_EraseRootFromParent_Done,
     /*  33437 */ // Label 735: @33437
     /*  33437 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(33474), // Rule ID 2864 //
     /*  33442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33456 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)
     /*  33456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33472 */   GIR_RootConstrainSelectedInstOperands,
     /*  33473 */   // GIR_Coverage, 2864,
     /*  33473 */   GIR_EraseRootFromParent_Done,
     /*  33474 */ // Label 736: @33474
     /*  33474 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(33511), // Rule ID 2865 //
     /*  33479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33493 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)
     /*  33493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33509 */   GIR_RootConstrainSelectedInstOperands,
     /*  33510 */   // GIR_Coverage, 2865,
     /*  33510 */   GIR_EraseRootFromParent_Done,
     /*  33511 */ // Label 737: @33511
     /*  33511 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(33548), // Rule ID 2866 //
     /*  33516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33530 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)
     /*  33530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33546 */   GIR_RootConstrainSelectedInstOperands,
     /*  33547 */   // GIR_Coverage, 2866,
     /*  33547 */   GIR_EraseRootFromParent_Done,
     /*  33548 */ // Label 738: @33548
     /*  33548 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(33585), // Rule ID 2867 //
     /*  33553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33567 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)
     /*  33567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33583 */   GIR_RootConstrainSelectedInstOperands,
     /*  33584 */   // GIR_Coverage, 2867,
     /*  33584 */   GIR_EraseRootFromParent_Done,
     /*  33585 */ // Label 739: @33585
     /*  33585 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(33622), // Rule ID 2868 //
     /*  33590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33604 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)
     /*  33604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33620 */   GIR_RootConstrainSelectedInstOperands,
     /*  33621 */   // GIR_Coverage, 2868,
     /*  33621 */   GIR_EraseRootFromParent_Done,
     /*  33622 */ // Label 740: @33622
     /*  33622 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(33659), // Rule ID 2869 //
     /*  33627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33641 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)
     /*  33641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33657 */   GIR_RootConstrainSelectedInstOperands,
     /*  33658 */   // GIR_Coverage, 2869,
     /*  33658 */   GIR_EraseRootFromParent_Done,
     /*  33659 */ // Label 741: @33659
     /*  33659 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(33691), // Rule ID 5287 //
     /*  33664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33678 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33690 */   // GIR_Coverage, 5287,
     /*  33690 */   GIR_EraseRootFromParent_Done,
     /*  33691 */ // Label 742: @33691
     /*  33691 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(33723), // Rule ID 5288 //
     /*  33696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33710 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33722 */   // GIR_Coverage, 5288,
     /*  33722 */   GIR_EraseRootFromParent_Done,
     /*  33723 */ // Label 743: @33723
     /*  33723 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(33755), // Rule ID 5309 //
     /*  33728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33742 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33754 */   // GIR_Coverage, 5309,
     /*  33754 */   GIR_EraseRootFromParent_Done,
     /*  33755 */ // Label 744: @33755
     /*  33755 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(33787), // Rule ID 5310 //
     /*  33760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33774 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33786 */   // GIR_Coverage, 5310,
     /*  33786 */   GIR_EraseRootFromParent_Done,
     /*  33787 */ // Label 745: @33787
     /*  33787 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(33819), // Rule ID 5311 //
     /*  33792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33806 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33818 */   // GIR_Coverage, 5311,
     /*  33818 */   GIR_EraseRootFromParent_Done,
     /*  33819 */ // Label 746: @33819
     /*  33819 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(33851), // Rule ID 5312 //
     /*  33824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33838 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33850 */   // GIR_Coverage, 5312,
     /*  33850 */   GIR_EraseRootFromParent_Done,
     /*  33851 */ // Label 747: @33851
     /*  33851 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(33883), // Rule ID 5313 //
     /*  33856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33870 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33882 */   // GIR_Coverage, 5313,
     /*  33882 */   GIR_EraseRootFromParent_Done,
     /*  33883 */ // Label 748: @33883
     /*  33883 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(33915), // Rule ID 5314 //
     /*  33888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33902 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33914 */   // GIR_Coverage, 5314,
     /*  33914 */   GIR_EraseRootFromParent_Done,
     /*  33915 */ // Label 749: @33915
     /*  33915 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(33947), // Rule ID 5315 //
     /*  33920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33934 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33946 */   // GIR_Coverage, 5315,
     /*  33946 */   GIR_EraseRootFromParent_Done,
     /*  33947 */ // Label 750: @33947
     /*  33947 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(33979), // Rule ID 5316 //
     /*  33952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33966 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33978 */   // GIR_Coverage, 5316,
     /*  33978 */   GIR_EraseRootFromParent_Done,
     /*  33979 */ // Label 751: @33979
     /*  33979 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(34011), // Rule ID 5317 //
     /*  33984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33998 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34010 */   // GIR_Coverage, 5317,
     /*  34010 */   GIR_EraseRootFromParent_Done,
     /*  34011 */ // Label 752: @34011
     /*  34011 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(34043), // Rule ID 5318 //
     /*  34016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  34019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34030 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34042 */   // GIR_Coverage, 5318,
     /*  34042 */   GIR_EraseRootFromParent_Done,
     /*  34043 */ // Label 753: @34043
     /*  34043 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(34101), // Rule ID 5345 //
     /*  34048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34062 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)
     /*  34062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34090 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34099 */   GIR_RootConstrainSelectedInstOperands,
     /*  34100 */   // GIR_Coverage, 5345,
     /*  34100 */   GIR_EraseRootFromParent_Done,
     /*  34101 */ // Label 754: @34101
     /*  34101 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(34159), // Rule ID 5346 //
     /*  34106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34120 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)
     /*  34120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34137 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34148 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34157 */   GIR_RootConstrainSelectedInstOperands,
     /*  34158 */   // GIR_Coverage, 5346,
     /*  34158 */   GIR_EraseRootFromParent_Done,
     /*  34159 */ // Label 755: @34159
     /*  34159 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(34217), // Rule ID 5347 //
     /*  34164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34178 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)
     /*  34178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34206 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34215 */   GIR_RootConstrainSelectedInstOperands,
     /*  34216 */   // GIR_Coverage, 5347,
     /*  34216 */   GIR_EraseRootFromParent_Done,
     /*  34217 */ // Label 756: @34217
     /*  34217 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(34275), // Rule ID 5348 //
     /*  34222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34236 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)
     /*  34236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34273 */   GIR_RootConstrainSelectedInstOperands,
     /*  34274 */   // GIR_Coverage, 5348,
     /*  34274 */   GIR_EraseRootFromParent_Done,
     /*  34275 */ // Label 757: @34275
     /*  34275 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(34333), // Rule ID 5349 //
     /*  34280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34294 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)
     /*  34294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34316 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34322 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34331 */   GIR_RootConstrainSelectedInstOperands,
     /*  34332 */   // GIR_Coverage, 5349,
     /*  34332 */   GIR_EraseRootFromParent_Done,
     /*  34333 */ // Label 758: @34333
     /*  34333 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(34391), // Rule ID 5350 //
     /*  34338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34352 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)
     /*  34352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34374 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34380 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34389 */   GIR_RootConstrainSelectedInstOperands,
     /*  34390 */   // GIR_Coverage, 5350,
     /*  34390 */   GIR_EraseRootFromParent_Done,
     /*  34391 */ // Label 759: @34391
     /*  34391 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(34449), // Rule ID 5351 //
     /*  34396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34410 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)
     /*  34410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34432 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34438 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34447 */   GIR_RootConstrainSelectedInstOperands,
     /*  34448 */   // GIR_Coverage, 5351,
     /*  34448 */   GIR_EraseRootFromParent_Done,
     /*  34449 */ // Label 760: @34449
     /*  34449 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(34507), // Rule ID 5352 //
     /*  34454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34468 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)
     /*  34468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34505 */   GIR_RootConstrainSelectedInstOperands,
     /*  34506 */   // GIR_Coverage, 5352,
     /*  34506 */   GIR_EraseRootFromParent_Done,
     /*  34507 */ // Label 761: @34507
     /*  34507 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(34565), // Rule ID 5353 //
     /*  34512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34526 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)
     /*  34526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34543 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34554 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34563 */   GIR_RootConstrainSelectedInstOperands,
     /*  34564 */   // GIR_Coverage, 5353,
     /*  34564 */   GIR_EraseRootFromParent_Done,
     /*  34565 */ // Label 762: @34565
     /*  34565 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(34623), // Rule ID 5354 //
     /*  34570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34584 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  34584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34621 */   GIR_RootConstrainSelectedInstOperands,
     /*  34622 */   // GIR_Coverage, 5354,
     /*  34622 */   GIR_EraseRootFromParent_Done,
     /*  34623 */ // Label 763: @34623
     /*  34623 */ GIM_Reject,
     /*  34624 */ // Label 548: @34624
     /*  34624 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(34656), // Rule ID 2798 //
     /*  34629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34643 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34646 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34655 */   // GIR_Coverage, 2798,
     /*  34655 */   GIR_EraseRootFromParent_Done,
     /*  34656 */ // Label 764: @34656
     /*  34656 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(34688), // Rule ID 2799 //
     /*  34661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34675 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34687 */   // GIR_Coverage, 2799,
     /*  34687 */   GIR_EraseRootFromParent_Done,
     /*  34688 */ // Label 765: @34688
     /*  34688 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(34720), // Rule ID 2800 //
     /*  34693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34707 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34710 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34719 */   // GIR_Coverage, 2800,
     /*  34719 */   GIR_EraseRootFromParent_Done,
     /*  34720 */ // Label 766: @34720
     /*  34720 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(34752), // Rule ID 2801 //
     /*  34725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34739 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34742 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34744 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34751 */   // GIR_Coverage, 2801,
     /*  34751 */   GIR_EraseRootFromParent_Done,
     /*  34752 */ // Label 767: @34752
     /*  34752 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(34784), // Rule ID 2802 //
     /*  34757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34771 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34783 */   // GIR_Coverage, 2802,
     /*  34783 */   GIR_EraseRootFromParent_Done,
     /*  34784 */ // Label 768: @34784
     /*  34784 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(34816), // Rule ID 2803 //
     /*  34789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34803 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34815 */   // GIR_Coverage, 2803,
     /*  34815 */   GIR_EraseRootFromParent_Done,
     /*  34816 */ // Label 769: @34816
     /*  34816 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(34853), // Rule ID 2870 //
     /*  34821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34835 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)
     /*  34835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34840 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34845 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34851 */   GIR_RootConstrainSelectedInstOperands,
     /*  34852 */   // GIR_Coverage, 2870,
     /*  34852 */   GIR_EraseRootFromParent_Done,
     /*  34853 */ // Label 770: @34853
     /*  34853 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(34890), // Rule ID 2871 //
     /*  34858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34872 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)
     /*  34872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34888 */   GIR_RootConstrainSelectedInstOperands,
     /*  34889 */   // GIR_Coverage, 2871,
     /*  34889 */   GIR_EraseRootFromParent_Done,
     /*  34890 */ // Label 771: @34890
     /*  34890 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(34927), // Rule ID 2872 //
     /*  34895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34909 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)
     /*  34909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34914 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34919 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34925 */   GIR_RootConstrainSelectedInstOperands,
     /*  34926 */   // GIR_Coverage, 2872,
     /*  34926 */   GIR_EraseRootFromParent_Done,
     /*  34927 */ // Label 772: @34927
     /*  34927 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(34964), // Rule ID 2873 //
     /*  34932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34946 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)
     /*  34946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34962 */   GIR_RootConstrainSelectedInstOperands,
     /*  34963 */   // GIR_Coverage, 2873,
     /*  34963 */   GIR_EraseRootFromParent_Done,
     /*  34964 */ // Label 773: @34964
     /*  34964 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(35001), // Rule ID 2874 //
     /*  34969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34983 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)
     /*  34983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  34986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34993 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34999 */   GIR_RootConstrainSelectedInstOperands,
     /*  35000 */   // GIR_Coverage, 2874,
     /*  35000 */   GIR_EraseRootFromParent_Done,
     /*  35001 */ // Label 774: @35001
     /*  35001 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(35038), // Rule ID 2875 //
     /*  35006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  35009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35020 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)
     /*  35020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  35023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35030 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35036 */   GIR_RootConstrainSelectedInstOperands,
     /*  35037 */   // GIR_Coverage, 2875,
     /*  35037 */   GIR_EraseRootFromParent_Done,
     /*  35038 */ // Label 775: @35038
     /*  35038 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(35070), // Rule ID 5319 //
     /*  35043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35057 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35060 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35062 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35069 */   // GIR_Coverage, 5319,
     /*  35069 */   GIR_EraseRootFromParent_Done,
     /*  35070 */ // Label 776: @35070
     /*  35070 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(35102), // Rule ID 5320 //
     /*  35075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35089 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35101 */   // GIR_Coverage, 5320,
     /*  35101 */   GIR_EraseRootFromParent_Done,
     /*  35102 */ // Label 777: @35102
     /*  35102 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(35134), // Rule ID 5321 //
     /*  35107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35121 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35133 */   // GIR_Coverage, 5321,
     /*  35133 */   GIR_EraseRootFromParent_Done,
     /*  35134 */ // Label 778: @35134
     /*  35134 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(35166), // Rule ID 5322 //
     /*  35139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35153 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35165 */   // GIR_Coverage, 5322,
     /*  35165 */   GIR_EraseRootFromParent_Done,
     /*  35166 */ // Label 779: @35166
     /*  35166 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(35198), // Rule ID 5323 //
     /*  35171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35185 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35197 */   // GIR_Coverage, 5323,
     /*  35197 */   GIR_EraseRootFromParent_Done,
     /*  35198 */ // Label 780: @35198
     /*  35198 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(35230), // Rule ID 5324 //
     /*  35203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35217 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35229 */   // GIR_Coverage, 5324,
     /*  35229 */   GIR_EraseRootFromParent_Done,
     /*  35230 */ // Label 781: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(35288), // Rule ID 5355 //
     /*  35235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35249 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)
     /*  35249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35271 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35277 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35286 */   GIR_RootConstrainSelectedInstOperands,
     /*  35287 */   // GIR_Coverage, 5355,
     /*  35287 */   GIR_EraseRootFromParent_Done,
     /*  35288 */ // Label 782: @35288
     /*  35288 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(35346), // Rule ID 5356 //
     /*  35293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35307 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)
     /*  35307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35324 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35335 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35344 */   GIR_RootConstrainSelectedInstOperands,
     /*  35345 */   // GIR_Coverage, 5356,
     /*  35345 */   GIR_EraseRootFromParent_Done,
     /*  35346 */ // Label 783: @35346
     /*  35346 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(35404), // Rule ID 5357 //
     /*  35351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35365 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)
     /*  35365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35387 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35393 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35402 */   GIR_RootConstrainSelectedInstOperands,
     /*  35403 */   // GIR_Coverage, 5357,
     /*  35403 */   GIR_EraseRootFromParent_Done,
     /*  35404 */ // Label 784: @35404
     /*  35404 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(35462), // Rule ID 5358 //
     /*  35409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35423 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)
     /*  35423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35460 */   GIR_RootConstrainSelectedInstOperands,
     /*  35461 */   // GIR_Coverage, 5358,
     /*  35461 */   GIR_EraseRootFromParent_Done,
     /*  35462 */ // Label 785: @35462
     /*  35462 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(35520), // Rule ID 5359 //
     /*  35467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35481 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)
     /*  35481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35509 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35518 */   GIR_RootConstrainSelectedInstOperands,
     /*  35519 */   // GIR_Coverage, 5359,
     /*  35519 */   GIR_EraseRootFromParent_Done,
     /*  35520 */ // Label 786: @35520
     /*  35520 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(35578), // Rule ID 5360 //
     /*  35525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35539 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)
     /*  35539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35561 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35567 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35576 */   GIR_RootConstrainSelectedInstOperands,
     /*  35577 */   // GIR_Coverage, 5360,
     /*  35577 */   GIR_EraseRootFromParent_Done,
     /*  35578 */ // Label 787: @35578
     /*  35578 */ GIM_Reject,
     /*  35579 */ // Label 549: @35579
     /*  35579 */ GIM_Reject,
     /*  35580 */ // Label 10: @35580
     /*  35580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 793*/ GIMT_Encode4(35875),
     /*  35591 */ /*GILLT_s16*//*Label 788*/ GIMT_Encode4(35643),
     /*  35595 */ /*GILLT_s32*//*Label 789*/ GIMT_Encode4(35681),
     /*  35599 */ /*GILLT_s64*//*Label 790*/ GIMT_Encode4(35719), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35623 */ /*GILLT_v4s32*//*Label 791*/ GIMT_Encode4(35757), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35639 */ /*GILLT_v8s16*//*Label 792*/ GIMT_Encode4(35816),
     /*  35643 */ // Label 788: @35643
     /*  35643 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(35680), // Rule ID 665 //
     /*  35648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35662 */   // (ftrunc:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTZH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZH),
     /*  35665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35678 */   GIR_RootConstrainSelectedInstOperands,
     /*  35679 */   // GIR_Coverage, 665,
     /*  35679 */   GIR_EraseRootFromParent_Done,
     /*  35680 */ // Label 794: @35680
     /*  35680 */ GIM_Reject,
     /*  35681 */ // Label 789: @35681
     /*  35681 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(35718), // Rule ID 666 //
     /*  35686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35700 */   // (ftrunc:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTZS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZS),
     /*  35703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35716 */   GIR_RootConstrainSelectedInstOperands,
     /*  35717 */   // GIR_Coverage, 666,
     /*  35717 */   GIR_EraseRootFromParent_Done,
     /*  35718 */ // Label 795: @35718
     /*  35718 */ GIM_Reject,
     /*  35719 */ // Label 790: @35719
     /*  35719 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(35756), // Rule ID 667 //
     /*  35724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35738 */   // (ftrunc:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTZD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZD),
     /*  35741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  35743 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /*  35745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35754 */   GIR_RootConstrainSelectedInstOperands,
     /*  35755 */   // GIR_Coverage, 667,
     /*  35755 */   GIR_EraseRootFromParent_Done,
     /*  35756 */ // Label 796: @35756
     /*  35756 */ GIM_Reject,
     /*  35757 */ // Label 791: @35757
     /*  35757 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(35815), // Rule ID 3982 //
     /*  35762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35776 */   // (ftrunc:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32Z:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  35776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32Z),
     /*  35791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35793 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35798 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35804 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35813 */   GIR_RootConstrainSelectedInstOperands,
     /*  35814 */   // GIR_Coverage, 3982,
     /*  35814 */   GIR_EraseRootFromParent_Done,
     /*  35815 */ // Label 797: @35815
     /*  35815 */ GIM_Reject,
     /*  35816 */ // Label 792: @35816
     /*  35816 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(35874), // Rule ID 3970 //
     /*  35821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35835 */   // (ftrunc:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16Z:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  35835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16Z),
     /*  35850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35852 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35857 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35863 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35872 */   GIR_RootConstrainSelectedInstOperands,
     /*  35873 */   // GIR_Coverage, 3970,
     /*  35873 */   GIR_EraseRootFromParent_Done,
     /*  35874 */ // Label 798: @35874
     /*  35874 */ GIM_Reject,
     /*  35875 */ // Label 793: @35875
     /*  35875 */ GIM_Reject,
     /*  35876 */ // Label 11: @35876
     /*  35876 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 804*/ GIMT_Encode4(36138),
     /*  35887 */ /*GILLT_s16*//*Label 799*/ GIMT_Encode4(35939),
     /*  35891 */ /*GILLT_s32*//*Label 800*/ GIMT_Encode4(35966),
     /*  35895 */ /*GILLT_s64*//*Label 801*/ GIMT_Encode4(35993), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35919 */ /*GILLT_v4s32*//*Label 802*/ GIMT_Encode4(36020), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35935 */ /*GILLT_v8s16*//*Label 803*/ GIMT_Encode4(36079),
     /*  35939 */ // Label 799: @35939
     /*  35939 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(35965), // Rule ID 674 //
     /*  35944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35958 */   // (fround:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTAH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAH),
     /*  35963 */   GIR_RootConstrainSelectedInstOperands,
     /*  35964 */   // GIR_Coverage, 674,
     /*  35964 */   GIR_Done,
     /*  35965 */ // Label 805: @35965
     /*  35965 */ GIM_Reject,
     /*  35966 */ // Label 800: @35966
     /*  35966 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(35992), // Rule ID 675 //
     /*  35971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35985 */   // (fround:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTAS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAS),
     /*  35990 */   GIR_RootConstrainSelectedInstOperands,
     /*  35991 */   // GIR_Coverage, 675,
     /*  35991 */   GIR_Done,
     /*  35992 */ // Label 806: @35992
     /*  35992 */ GIM_Reject,
     /*  35993 */ // Label 801: @35993
     /*  35993 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(36019), // Rule ID 676 //
     /*  35998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36012 */   // (fround:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTAD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAD),
     /*  36017 */   GIR_RootConstrainSelectedInstOperands,
     /*  36018 */   // GIR_Coverage, 676,
     /*  36018 */   GIR_Done,
     /*  36019 */ // Label 807: @36019
     /*  36019 */ GIM_Reject,
     /*  36020 */ // Label 802: @36020
     /*  36020 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(36078), // Rule ID 3980 //
     /*  36025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36039 */   // (fround:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32A:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32A),
     /*  36054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36056 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36061 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36067 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36076 */   GIR_RootConstrainSelectedInstOperands,
     /*  36077 */   // GIR_Coverage, 3980,
     /*  36077 */   GIR_EraseRootFromParent_Done,
     /*  36078 */ // Label 808: @36078
     /*  36078 */ GIM_Reject,
     /*  36079 */ // Label 803: @36079
     /*  36079 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(36137), // Rule ID 3968 //
     /*  36084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36098 */   // (fround:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16A:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16A),
     /*  36113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36115 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36120 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36126 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36135 */   GIR_RootConstrainSelectedInstOperands,
     /*  36136 */   // GIR_Coverage, 3968,
     /*  36136 */   GIR_EraseRootFromParent_Done,
     /*  36137 */ // Label 809: @36137
     /*  36137 */ GIM_Reject,
     /*  36138 */ // Label 804: @36138
     /*  36138 */ GIM_Reject,
     /*  36139 */ // Label 12: @36139
     /*  36139 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 813*/ GIMT_Encode4(36243),
     /*  36150 */ /*GILLT_s16*//*Label 810*/ GIMT_Encode4(36162),
     /*  36154 */ /*GILLT_s32*//*Label 811*/ GIMT_Encode4(36189),
     /*  36158 */ /*GILLT_s64*//*Label 812*/ GIMT_Encode4(36216),
     /*  36162 */ // Label 810: @36162
     /*  36162 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(36188), // Rule ID 678 //
     /*  36167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  36173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36181 */   // (froundeven:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36186 */   GIR_RootConstrainSelectedInstOperands,
     /*  36187 */   // GIR_Coverage, 678,
     /*  36187 */   GIR_Done,
     /*  36188 */ // Label 814: @36188
     /*  36188 */ GIM_Reject,
     /*  36189 */ // Label 811: @36189
     /*  36189 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(36215), // Rule ID 680 //
     /*  36194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36208 */   // (froundeven:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36213 */   GIR_RootConstrainSelectedInstOperands,
     /*  36214 */   // GIR_Coverage, 680,
     /*  36214 */   GIR_Done,
     /*  36215 */ // Label 815: @36215
     /*  36215 */ GIM_Reject,
     /*  36216 */ // Label 812: @36216
     /*  36216 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(36242), // Rule ID 682 //
     /*  36221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36235 */   // (froundeven:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36240 */   GIR_RootConstrainSelectedInstOperands,
     /*  36241 */   // GIR_Coverage, 682,
     /*  36241 */   GIR_Done,
     /*  36242 */ // Label 816: @36242
     /*  36242 */ GIM_Reject,
     /*  36243 */ // Label 813: @36243
     /*  36243 */ GIM_Reject,
     /*  36244 */ // Label 13: @36244
     /*  36244 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(36406),
     /*  36249 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36252 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36255 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(36330), // Rule ID 2053 //
     /*  36260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  36270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36274 */     // MIs[0] Rn
     /*  36274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36282 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (tLDRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36294 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36300 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36306 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSB),
     /*  36317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36328 */     GIR_RootConstrainSelectedInstOperands,
     /*  36329 */     // GIR_Coverage, 2053,
     /*  36329 */     GIR_EraseRootFromParent_Done,
     /*  36330 */   // Label 818: @36330
     /*  36330 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(36405), // Rule ID 2054 //
     /*  36335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  36345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36349 */     // MIs[0] Rn
     /*  36349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36357 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (tLDRSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36369 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36375 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36378 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36381 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSH),
     /*  36392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36403 */     GIR_RootConstrainSelectedInstOperands,
     /*  36404 */     // GIR_Coverage, 2054,
     /*  36404 */     GIR_EraseRootFromParent_Done,
     /*  36405 */   // Label 819: @36405
     /*  36405 */   GIM_Reject,
     /*  36406 */ // Label 817: @36406
     /*  36406 */ GIM_Reject,
     /*  36407 */ // Label 14: @36407
     /*  36407 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(36427), // Rule ID 5421 //
     /*  36412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36415 */   // MIs[0] Operand 0
     /*  36415 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  36418 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36422 */   // (atomic_fence (timm:{ *:[i32] }), 0:{ *:[i32] })  =>  (MEMBARRIER)
     /*  36422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::MEMBARRIER),
     /*  36425 */   GIR_RootConstrainSelectedInstOperands,
     /*  36426 */   // GIR_Coverage, 5421,
     /*  36426 */   GIR_EraseRootFromParent_Done,
     /*  36427 */ // Label 820: @36427
     /*  36427 */ GIM_Reject,
     /*  36428 */ // Label 15: @36428
     /*  36428 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(42243),
     /*  36433 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  36436 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(36484), // Rule ID 1856 //
     /*  36441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  36444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  36459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  36463 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  36463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  36466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  36470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36482 */     GIR_RootConstrainSelectedInstOperands,
     /*  36483 */     // GIR_Coverage, 1856,
     /*  36483 */     GIR_EraseRootFromParent_Done,
     /*  36484 */   // Label 822: @36484
     /*  36484 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(36532), // Rule ID 2110 //
     /*  36489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  36492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36511 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  36511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  36514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  36518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36530 */     GIR_RootConstrainSelectedInstOperands,
     /*  36531 */     // GIR_Coverage, 2110,
     /*  36531 */     GIR_EraseRootFromParent_Done,
     /*  36532 */   // Label 823: @36532
     /*  36532 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(36568), // Rule ID 677 //
     /*  36537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  36548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  36551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36559 */     // (intrinsic_wo_chain:{ *:[f16] } 3812:{ *:[iPTR] }, HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36566 */     GIR_RootConstrainSelectedInstOperands,
     /*  36567 */     // GIR_Coverage, 677,
     /*  36567 */     GIR_EraseRootFromParent_Done,
     /*  36568 */   // Label 824: @36568
     /*  36568 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(36604), // Rule ID 679 //
     /*  36573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36595 */     // (intrinsic_wo_chain:{ *:[f32] } 3812:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36602 */     GIR_RootConstrainSelectedInstOperands,
     /*  36603 */     // GIR_Coverage, 679,
     /*  36603 */     GIR_EraseRootFromParent_Done,
     /*  36604 */   // Label 825: @36604
     /*  36604 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(36640), // Rule ID 681 //
     /*  36609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36631 */     // (intrinsic_wo_chain:{ *:[f64] } 3812:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  36636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36638 */     GIR_RootConstrainSelectedInstOperands,
     /*  36639 */     // GIR_Coverage, 681,
     /*  36639 */     GIR_EraseRootFromParent_Done,
     /*  36640 */   // Label 826: @36640
     /*  36640 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(36685), // Rule ID 696 //
     /*  36645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36667 */     // (intrinsic_wo_chain:{ *:[f32] } 3927:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOSIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRD),
     /*  36670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36683 */     GIR_RootConstrainSelectedInstOperands,
     /*  36684 */     // GIR_Coverage, 696,
     /*  36684 */     GIR_EraseRootFromParent_Done,
     /*  36685 */   // Label 827: @36685
     /*  36685 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(36730), // Rule ID 697 //
     /*  36690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36712 */     // (intrinsic_wo_chain:{ *:[f32] } 3927:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOSIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRS),
     /*  36715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36728 */     GIR_RootConstrainSelectedInstOperands,
     /*  36729 */     // GIR_Coverage, 697,
     /*  36729 */     GIR_EraseRootFromParent_Done,
     /*  36730 */   // Label 828: @36730
     /*  36730 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(36775), // Rule ID 698 //
     /*  36735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36757 */     // (intrinsic_wo_chain:{ *:[f32] } 3928:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOUIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRD),
     /*  36760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36773 */     GIR_RootConstrainSelectedInstOperands,
     /*  36774 */     // GIR_Coverage, 698,
     /*  36774 */     GIR_EraseRootFromParent_Done,
     /*  36775 */   // Label 829: @36775
     /*  36775 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(36820), // Rule ID 699 //
     /*  36780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36802 */     // (intrinsic_wo_chain:{ *:[f32] } 3928:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOUIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRS),
     /*  36805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36818 */     GIR_RootConstrainSelectedInstOperands,
     /*  36819 */     // GIR_Coverage, 699,
     /*  36819 */     GIR_EraseRootFromParent_Done,
     /*  36820 */   // Label 830: @36820
     /*  36820 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(36865), // Rule ID 1242 //
     /*  36825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  36836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  36839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36847 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3778:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLsv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  36847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i8),
     /*  36850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36863 */     GIR_RootConstrainSelectedInstOperands,
     /*  36864 */     // GIR_Coverage, 1242,
     /*  36864 */     GIR_EraseRootFromParent_Done,
     /*  36865 */   // Label 831: @36865
     /*  36865 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(36910), // Rule ID 1243 //
     /*  36870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  36881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  36884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36892 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3778:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLsv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  36892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i16),
     /*  36895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36908 */     GIR_RootConstrainSelectedInstOperands,
     /*  36909 */     // GIR_Coverage, 1243,
     /*  36909 */     GIR_EraseRootFromParent_Done,
     /*  36910 */   // Label 832: @36910
     /*  36910 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(36955), // Rule ID 1244 //
     /*  36915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  36929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36937 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3778:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLsv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  36937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv2i32),
     /*  36940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36953 */     GIR_RootConstrainSelectedInstOperands,
     /*  36954 */     // GIR_Coverage, 1244,
     /*  36954 */     GIR_EraseRootFromParent_Done,
     /*  36955 */   // Label 833: @36955
     /*  36955 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(37000), // Rule ID 1245 //
     /*  36960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  36971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36982 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3778:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLsv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  36982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv16i8),
     /*  36985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36998 */     GIR_RootConstrainSelectedInstOperands,
     /*  36999 */     // GIR_Coverage, 1245,
     /*  36999 */     GIR_EraseRootFromParent_Done,
     /*  37000 */   // Label 834: @37000
     /*  37000 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(37045), // Rule ID 1246 //
     /*  37005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37027 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3778:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLsv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i16),
     /*  37030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37043 */     GIR_RootConstrainSelectedInstOperands,
     /*  37044 */     // GIR_Coverage, 1246,
     /*  37044 */     GIR_EraseRootFromParent_Done,
     /*  37045 */   // Label 835: @37045
     /*  37045 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(37090), // Rule ID 1247 //
     /*  37050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37072 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3778:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLsv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i32),
     /*  37075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37088 */     GIR_RootConstrainSelectedInstOperands,
     /*  37089 */     // GIR_Coverage, 1247,
     /*  37089 */     GIR_EraseRootFromParent_Done,
     /*  37090 */   // Label 836: @37090
     /*  37090 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(37135), // Rule ID 1248 //
     /*  37095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37117 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3779:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLuv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i8),
     /*  37120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37133 */     GIR_RootConstrainSelectedInstOperands,
     /*  37134 */     // GIR_Coverage, 1248,
     /*  37134 */     GIR_EraseRootFromParent_Done,
     /*  37135 */   // Label 837: @37135
     /*  37135 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(37180), // Rule ID 1249 //
     /*  37140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37162 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3779:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLuv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i16),
     /*  37165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37178 */     GIR_RootConstrainSelectedInstOperands,
     /*  37179 */     // GIR_Coverage, 1249,
     /*  37179 */     GIR_EraseRootFromParent_Done,
     /*  37180 */   // Label 838: @37180
     /*  37180 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(37225), // Rule ID 1250 //
     /*  37185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37207 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3779:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLuv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv2i32),
     /*  37210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37223 */     GIR_RootConstrainSelectedInstOperands,
     /*  37224 */     // GIR_Coverage, 1250,
     /*  37224 */     GIR_EraseRootFromParent_Done,
     /*  37225 */   // Label 839: @37225
     /*  37225 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(37270), // Rule ID 1251 //
     /*  37230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37252 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3779:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLuv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv16i8),
     /*  37255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37268 */     GIR_RootConstrainSelectedInstOperands,
     /*  37269 */     // GIR_Coverage, 1251,
     /*  37269 */     GIR_EraseRootFromParent_Done,
     /*  37270 */   // Label 840: @37270
     /*  37270 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(37315), // Rule ID 1252 //
     /*  37275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37297 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3779:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLuv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i16),
     /*  37300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37313 */     GIR_RootConstrainSelectedInstOperands,
     /*  37314 */     // GIR_Coverage, 1252,
     /*  37314 */     GIR_EraseRootFromParent_Done,
     /*  37315 */   // Label 841: @37315
     /*  37315 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(37360), // Rule ID 1253 //
     /*  37320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37342 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3779:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLuv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i32),
     /*  37345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37358 */     GIR_RootConstrainSelectedInstOperands,
     /*  37359 */     // GIR_Coverage, 1253,
     /*  37359 */     GIR_EraseRootFromParent_Done,
     /*  37360 */   // Label 842: @37360
     /*  37360 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(37405), // Rule ID 1282 //
     /*  37365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37387 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3806:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRECPEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEd),
     /*  37390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37403 */     GIR_RootConstrainSelectedInstOperands,
     /*  37404 */     // GIR_Coverage, 1282,
     /*  37404 */     GIR_EraseRootFromParent_Done,
     /*  37405 */   // Label 843: @37405
     /*  37405 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(37450), // Rule ID 1283 //
     /*  37410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37432 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3806:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRECPEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEq),
     /*  37435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37448 */     GIR_RootConstrainSelectedInstOperands,
     /*  37449 */     // GIR_Coverage, 1283,
     /*  37449 */     GIR_EraseRootFromParent_Done,
     /*  37450 */   // Label 844: @37450
     /*  37450 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(37495), // Rule ID 1284 //
     /*  37455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37477 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3806:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfd),
     /*  37480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37493 */     GIR_RootConstrainSelectedInstOperands,
     /*  37494 */     // GIR_Coverage, 1284,
     /*  37494 */     GIR_EraseRootFromParent_Done,
     /*  37495 */   // Label 845: @37495
     /*  37495 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(37540), // Rule ID 1285 //
     /*  37500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37522 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3806:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfq),
     /*  37525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37538 */     GIR_RootConstrainSelectedInstOperands,
     /*  37539 */     // GIR_Coverage, 1285,
     /*  37539 */     GIR_EraseRootFromParent_Done,
     /*  37540 */   // Label 846: @37540
     /*  37540 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(37585), // Rule ID 1286 //
     /*  37545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37567 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3806:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhd),
     /*  37570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37583 */     GIR_RootConstrainSelectedInstOperands,
     /*  37584 */     // GIR_Coverage, 1286,
     /*  37584 */     GIR_EraseRootFromParent_Done,
     /*  37585 */   // Label 847: @37585
     /*  37585 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(37630), // Rule ID 1287 //
     /*  37590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37612 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3806:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhq),
     /*  37615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37628 */     GIR_RootConstrainSelectedInstOperands,
     /*  37629 */     // GIR_Coverage, 1287,
     /*  37629 */     GIR_EraseRootFromParent_Done,
     /*  37630 */   // Label 848: @37630
     /*  37630 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(37675), // Rule ID 1292 //
     /*  37635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37657 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3819:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRSQRTEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEd),
     /*  37660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37673 */     GIR_RootConstrainSelectedInstOperands,
     /*  37674 */     // GIR_Coverage, 1292,
     /*  37674 */     GIR_EraseRootFromParent_Done,
     /*  37675 */   // Label 849: @37675
     /*  37675 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(37720), // Rule ID 1293 //
     /*  37680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37702 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3819:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSQRTEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEq),
     /*  37705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37718 */     GIR_RootConstrainSelectedInstOperands,
     /*  37719 */     // GIR_Coverage, 1293,
     /*  37719 */     GIR_EraseRootFromParent_Done,
     /*  37720 */   // Label 850: @37720
     /*  37720 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(37765), // Rule ID 1294 //
     /*  37725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37747 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3819:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfd),
     /*  37750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37763 */     GIR_RootConstrainSelectedInstOperands,
     /*  37764 */     // GIR_Coverage, 1294,
     /*  37764 */     GIR_EraseRootFromParent_Done,
     /*  37765 */   // Label 851: @37765
     /*  37765 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(37810), // Rule ID 1295 //
     /*  37770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37792 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3819:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfq),
     /*  37795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37808 */     GIR_RootConstrainSelectedInstOperands,
     /*  37809 */     // GIR_Coverage, 1295,
     /*  37809 */     GIR_EraseRootFromParent_Done,
     /*  37810 */   // Label 852: @37810
     /*  37810 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(37855), // Rule ID 1296 //
     /*  37815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37837 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3819:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhd),
     /*  37840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37853 */     GIR_RootConstrainSelectedInstOperands,
     /*  37854 */     // GIR_Coverage, 1296,
     /*  37854 */     GIR_EraseRootFromParent_Done,
     /*  37855 */   // Label 853: @37855
     /*  37855 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(37900), // Rule ID 1297 //
     /*  37860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37882 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3819:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhq),
     /*  37885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37898 */     GIR_RootConstrainSelectedInstOperands,
     /*  37899 */     // GIR_Coverage, 1297,
     /*  37899 */     GIR_EraseRootFromParent_Done,
     /*  37900 */   // Label 854: @37900
     /*  37900 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(37945), // Rule ID 1518 //
     /*  37905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  37916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37927 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3784:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  37927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i8),
     /*  37930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37943 */     GIR_RootConstrainSelectedInstOperands,
     /*  37944 */     // GIR_Coverage, 1518,
     /*  37944 */     GIR_EraseRootFromParent_Done,
     /*  37945 */   // Label 855: @37945
     /*  37945 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(37990), // Rule ID 1519 //
     /*  37950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37972 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3784:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  37972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i16),
     /*  37975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37988 */     GIR_RootConstrainSelectedInstOperands,
     /*  37989 */     // GIR_Coverage, 1519,
     /*  37989 */     GIR_EraseRootFromParent_Done,
     /*  37990 */   // Label 856: @37990
     /*  37990 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(38035), // Rule ID 1520 //
     /*  37995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38017 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3784:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv2i32),
     /*  38020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38033 */     GIR_RootConstrainSelectedInstOperands,
     /*  38034 */     // GIR_Coverage, 1520,
     /*  38034 */     GIR_EraseRootFromParent_Done,
     /*  38035 */   // Label 857: @38035
     /*  38035 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(38080), // Rule ID 1521 //
     /*  38040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38062 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3784:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv16i8),
     /*  38065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38078 */     GIR_RootConstrainSelectedInstOperands,
     /*  38079 */     // GIR_Coverage, 1521,
     /*  38079 */     GIR_EraseRootFromParent_Done,
     /*  38080 */   // Label 858: @38080
     /*  38080 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(38125), // Rule ID 1522 //
     /*  38085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38107 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3784:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i16),
     /*  38110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38123 */     GIR_RootConstrainSelectedInstOperands,
     /*  38124 */     // GIR_Coverage, 1522,
     /*  38124 */     GIR_EraseRootFromParent_Done,
     /*  38125 */   // Label 859: @38125
     /*  38125 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(38170), // Rule ID 1523 //
     /*  38130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38152 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3784:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i32),
     /*  38155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38168 */     GIR_RootConstrainSelectedInstOperands,
     /*  38169 */     // GIR_Coverage, 1523,
     /*  38169 */     GIR_EraseRootFromParent_Done,
     /*  38170 */   // Label 860: @38170
     /*  38170 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(38215), // Rule ID 1534 //
     /*  38175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38197 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3790:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQNEGv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i8),
     /*  38200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38213 */     GIR_RootConstrainSelectedInstOperands,
     /*  38214 */     // GIR_Coverage, 1534,
     /*  38214 */     GIR_EraseRootFromParent_Done,
     /*  38215 */   // Label 861: @38215
     /*  38215 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(38260), // Rule ID 1535 //
     /*  38220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38242 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3790:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQNEGv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i16),
     /*  38245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38258 */     GIR_RootConstrainSelectedInstOperands,
     /*  38259 */     // GIR_Coverage, 1535,
     /*  38259 */     GIR_EraseRootFromParent_Done,
     /*  38260 */   // Label 862: @38260
     /*  38260 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(38305), // Rule ID 1536 //
     /*  38265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38287 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3790:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQNEGv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv2i32),
     /*  38290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38303 */     GIR_RootConstrainSelectedInstOperands,
     /*  38304 */     // GIR_Coverage, 1536,
     /*  38304 */     GIR_EraseRootFromParent_Done,
     /*  38305 */   // Label 863: @38305
     /*  38305 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(38350), // Rule ID 1537 //
     /*  38310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38332 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3790:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQNEGv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv16i8),
     /*  38335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38348 */     GIR_RootConstrainSelectedInstOperands,
     /*  38349 */     // GIR_Coverage, 1537,
     /*  38349 */     GIR_EraseRootFromParent_Done,
     /*  38350 */   // Label 864: @38350
     /*  38350 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(38395), // Rule ID 1538 //
     /*  38355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38377 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3790:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQNEGv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i16),
     /*  38380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38393 */     GIR_RootConstrainSelectedInstOperands,
     /*  38394 */     // GIR_Coverage, 1538,
     /*  38394 */     GIR_EraseRootFromParent_Done,
     /*  38395 */   // Label 865: @38395
     /*  38395 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(38440), // Rule ID 1539 //
     /*  38400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38422 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3790:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQNEGv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i32),
     /*  38425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38438 */     GIR_RootConstrainSelectedInstOperands,
     /*  38439 */     // GIR_Coverage, 1539,
     /*  38439 */     GIR_EraseRootFromParent_Done,
     /*  38440 */   // Label 866: @38440
     /*  38440 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(38485), // Rule ID 1540 //
     /*  38445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38467 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3731:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VCLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i8),
     /*  38470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38483 */     GIR_RootConstrainSelectedInstOperands,
     /*  38484 */     // GIR_Coverage, 1540,
     /*  38484 */     GIR_EraseRootFromParent_Done,
     /*  38485 */   // Label 867: @38485
     /*  38485 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(38530), // Rule ID 1541 //
     /*  38490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38512 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3731:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i16),
     /*  38515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38528 */     GIR_RootConstrainSelectedInstOperands,
     /*  38529 */     // GIR_Coverage, 1541,
     /*  38529 */     GIR_EraseRootFromParent_Done,
     /*  38530 */   // Label 868: @38530
     /*  38530 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(38575), // Rule ID 1542 //
     /*  38535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38557 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3731:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VCLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv2i32),
     /*  38560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38573 */     GIR_RootConstrainSelectedInstOperands,
     /*  38574 */     // GIR_Coverage, 1542,
     /*  38574 */     GIR_EraseRootFromParent_Done,
     /*  38575 */   // Label 869: @38575
     /*  38575 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(38620), // Rule ID 1543 //
     /*  38580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38602 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3731:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VCLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv16i8),
     /*  38605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38618 */     GIR_RootConstrainSelectedInstOperands,
     /*  38619 */     // GIR_Coverage, 1543,
     /*  38619 */     GIR_EraseRootFromParent_Done,
     /*  38620 */   // Label 870: @38620
     /*  38620 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(38665), // Rule ID 1544 //
     /*  38625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38647 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3731:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VCLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i16),
     /*  38650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38663 */     GIR_RootConstrainSelectedInstOperands,
     /*  38664 */     // GIR_Coverage, 1544,
     /*  38664 */     GIR_EraseRootFromParent_Done,
     /*  38665 */   // Label 871: @38665
     /*  38665 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(38710), // Rule ID 1545 //
     /*  38670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38692 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3731:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VCLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i32),
     /*  38695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38708 */     GIR_RootConstrainSelectedInstOperands,
     /*  38709 */     // GIR_Coverage, 1545,
     /*  38709 */     GIR_EraseRootFromParent_Done,
     /*  38710 */   // Label 872: @38710
     /*  38710 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(38755), // Rule ID 1589 //
     /*  38715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38737 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3787:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv8i8),
     /*  38740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38753 */     GIR_RootConstrainSelectedInstOperands,
     /*  38754 */     // GIR_Coverage, 1589,
     /*  38754 */     GIR_EraseRootFromParent_Done,
     /*  38755 */   // Label 873: @38755
     /*  38755 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(38800), // Rule ID 1590 //
     /*  38760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38782 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3787:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv4i16),
     /*  38785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38798 */     GIR_RootConstrainSelectedInstOperands,
     /*  38799 */     // GIR_Coverage, 1590,
     /*  38799 */     GIR_EraseRootFromParent_Done,
     /*  38800 */   // Label 874: @38800
     /*  38800 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(38845), // Rule ID 1591 //
     /*  38805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38827 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3787:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv2i32),
     /*  38830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38843 */     GIR_RootConstrainSelectedInstOperands,
     /*  38844 */     // GIR_Coverage, 1591,
     /*  38844 */     GIR_EraseRootFromParent_Done,
     /*  38845 */   // Label 875: @38845
     /*  38845 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(38890), // Rule ID 1592 //
     /*  38850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38872 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3789:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv8i8),
     /*  38875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38888 */     GIR_RootConstrainSelectedInstOperands,
     /*  38889 */     // GIR_Coverage, 1592,
     /*  38889 */     GIR_EraseRootFromParent_Done,
     /*  38890 */   // Label 876: @38890
     /*  38890 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(38935), // Rule ID 1593 //
     /*  38895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38917 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3789:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv4i16),
     /*  38920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38933 */     GIR_RootConstrainSelectedInstOperands,
     /*  38934 */     // GIR_Coverage, 1593,
     /*  38934 */     GIR_EraseRootFromParent_Done,
     /*  38935 */   // Label 877: @38935
     /*  38935 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(38980), // Rule ID 1594 //
     /*  38940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38962 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3789:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv2i32),
     /*  38965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38978 */     GIR_RootConstrainSelectedInstOperands,
     /*  38979 */     // GIR_Coverage, 1594,
     /*  38979 */     GIR_EraseRootFromParent_Done,
     /*  38980 */   // Label 878: @38980
     /*  38980 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(39025), // Rule ID 1595 //
     /*  38985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  38993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39007 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3788:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv8i8),
     /*  39010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39023 */     GIR_RootConstrainSelectedInstOperands,
     /*  39024 */     // GIR_Coverage, 1595,
     /*  39024 */     GIR_EraseRootFromParent_Done,
     /*  39025 */   // Label 879: @39025
     /*  39025 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(39070), // Rule ID 1596 //
     /*  39030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39052 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3788:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv4i16),
     /*  39055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39068 */     GIR_RootConstrainSelectedInstOperands,
     /*  39069 */     // GIR_Coverage, 1596,
     /*  39069 */     GIR_EraseRootFromParent_Done,
     /*  39070 */   // Label 880: @39070
     /*  39070 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(39115), // Rule ID 1597 //
     /*  39075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39097 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3788:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv2i32),
     /*  39100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39113 */     GIR_RootConstrainSelectedInstOperands,
     /*  39114 */     // GIR_Coverage, 1597,
     /*  39114 */     GIR_EraseRootFromParent_Done,
     /*  39115 */   // Label 881: @39115
     /*  39115 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(39151), // Rule ID 1620 //
     /*  39120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39142 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3732:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDf),
     /*  39145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39149 */     GIR_RootConstrainSelectedInstOperands,
     /*  39150 */     // GIR_Coverage, 1620,
     /*  39150 */     GIR_EraseRootFromParent_Done,
     /*  39151 */   // Label 882: @39151
     /*  39151 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(39187), // Rule ID 1621 //
     /*  39156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39178 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3732:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQf),
     /*  39181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39185 */     GIR_RootConstrainSelectedInstOperands,
     /*  39186 */     // GIR_Coverage, 1621,
     /*  39186 */     GIR_EraseRootFromParent_Done,
     /*  39187 */   // Label 883: @39187
     /*  39187 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(39223), // Rule ID 1622 //
     /*  39192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39214 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3733:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDf),
     /*  39217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39221 */     GIR_RootConstrainSelectedInstOperands,
     /*  39222 */     // GIR_Coverage, 1622,
     /*  39222 */     GIR_EraseRootFromParent_Done,
     /*  39223 */   // Label 884: @39223
     /*  39223 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(39259), // Rule ID 1623 //
     /*  39228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39250 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3733:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQf),
     /*  39253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39257 */     GIR_RootConstrainSelectedInstOperands,
     /*  39258 */     // GIR_Coverage, 1623,
     /*  39258 */     GIR_EraseRootFromParent_Done,
     /*  39259 */   // Label 885: @39259
     /*  39259 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(39295), // Rule ID 1624 //
     /*  39264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39286 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3732:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDh),
     /*  39289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39293 */     GIR_RootConstrainSelectedInstOperands,
     /*  39294 */     // GIR_Coverage, 1624,
     /*  39294 */     GIR_EraseRootFromParent_Done,
     /*  39295 */   // Label 886: @39295
     /*  39295 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(39331), // Rule ID 1625 //
     /*  39300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39322 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3732:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQh),
     /*  39325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39329 */     GIR_RootConstrainSelectedInstOperands,
     /*  39330 */     // GIR_Coverage, 1625,
     /*  39330 */     GIR_EraseRootFromParent_Done,
     /*  39331 */   // Label 887: @39331
     /*  39331 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(39367), // Rule ID 1626 //
     /*  39336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39358 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3733:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDh),
     /*  39361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39365 */     GIR_RootConstrainSelectedInstOperands,
     /*  39366 */     // GIR_Coverage, 1626,
     /*  39366 */     GIR_EraseRootFromParent_Done,
     /*  39367 */   // Label 888: @39367
     /*  39367 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(39403), // Rule ID 1627 //
     /*  39372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39394 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3733:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQh),
     /*  39397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39401 */     GIR_RootConstrainSelectedInstOperands,
     /*  39402 */     // GIR_Coverage, 1627,
     /*  39402 */     GIR_EraseRootFromParent_Done,
     /*  39403 */   // Label 889: @39403
     /*  39403 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(39439), // Rule ID 1628 //
     /*  39408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39430 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3744:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDf),
     /*  39433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39437 */     GIR_RootConstrainSelectedInstOperands,
     /*  39438 */     // GIR_Coverage, 1628,
     /*  39438 */     GIR_EraseRootFromParent_Done,
     /*  39439 */   // Label 890: @39439
     /*  39439 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(39475), // Rule ID 1629 //
     /*  39444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39466 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3744:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQf),
     /*  39469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39473 */     GIR_RootConstrainSelectedInstOperands,
     /*  39474 */     // GIR_Coverage, 1629,
     /*  39474 */     GIR_EraseRootFromParent_Done,
     /*  39475 */   // Label 891: @39475
     /*  39475 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(39511), // Rule ID 1630 //
     /*  39480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39502 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3745:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDf),
     /*  39505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39509 */     GIR_RootConstrainSelectedInstOperands,
     /*  39510 */     // GIR_Coverage, 1630,
     /*  39510 */     GIR_EraseRootFromParent_Done,
     /*  39511 */   // Label 892: @39511
     /*  39511 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(39547), // Rule ID 1631 //
     /*  39516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39538 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3745:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQf),
     /*  39541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39545 */     GIR_RootConstrainSelectedInstOperands,
     /*  39546 */     // GIR_Coverage, 1631,
     /*  39546 */     GIR_EraseRootFromParent_Done,
     /*  39547 */   // Label 893: @39547
     /*  39547 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(39583), // Rule ID 1632 //
     /*  39552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39574 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3744:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDh),
     /*  39577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39581 */     GIR_RootConstrainSelectedInstOperands,
     /*  39582 */     // GIR_Coverage, 1632,
     /*  39582 */     GIR_EraseRootFromParent_Done,
     /*  39583 */   // Label 894: @39583
     /*  39583 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(39619), // Rule ID 1633 //
     /*  39588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39610 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3744:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQh),
     /*  39613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39617 */     GIR_RootConstrainSelectedInstOperands,
     /*  39618 */     // GIR_Coverage, 1633,
     /*  39618 */     GIR_EraseRootFromParent_Done,
     /*  39619 */   // Label 895: @39619
     /*  39619 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(39655), // Rule ID 1634 //
     /*  39624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39646 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3745:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDh),
     /*  39649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39653 */     GIR_RootConstrainSelectedInstOperands,
     /*  39654 */     // GIR_Coverage, 1634,
     /*  39654 */     GIR_EraseRootFromParent_Done,
     /*  39655 */   // Label 896: @39655
     /*  39655 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(39691), // Rule ID 1635 //
     /*  39660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39682 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3745:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQh),
     /*  39685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39689 */     GIR_RootConstrainSelectedInstOperands,
     /*  39690 */     // GIR_Coverage, 1635,
     /*  39690 */     GIR_EraseRootFromParent_Done,
     /*  39691 */   // Label 897: @39691
     /*  39691 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(39727), // Rule ID 1636 //
     /*  39696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39718 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3746:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDf),
     /*  39721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39725 */     GIR_RootConstrainSelectedInstOperands,
     /*  39726 */     // GIR_Coverage, 1636,
     /*  39726 */     GIR_EraseRootFromParent_Done,
     /*  39727 */   // Label 898: @39727
     /*  39727 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(39763), // Rule ID 1637 //
     /*  39732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39754 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3746:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQf),
     /*  39757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39761 */     GIR_RootConstrainSelectedInstOperands,
     /*  39762 */     // GIR_Coverage, 1637,
     /*  39762 */     GIR_EraseRootFromParent_Done,
     /*  39763 */   // Label 899: @39763
     /*  39763 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(39799), // Rule ID 1638 //
     /*  39768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39790 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3747:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDf),
     /*  39793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39797 */     GIR_RootConstrainSelectedInstOperands,
     /*  39798 */     // GIR_Coverage, 1638,
     /*  39798 */     GIR_EraseRootFromParent_Done,
     /*  39799 */   // Label 900: @39799
     /*  39799 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(39835), // Rule ID 1639 //
     /*  39804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39826 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3747:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQf),
     /*  39829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39833 */     GIR_RootConstrainSelectedInstOperands,
     /*  39834 */     // GIR_Coverage, 1639,
     /*  39834 */     GIR_EraseRootFromParent_Done,
     /*  39835 */   // Label 901: @39835
     /*  39835 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(39871), // Rule ID 1640 //
     /*  39840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39862 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3746:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDh),
     /*  39865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39869 */     GIR_RootConstrainSelectedInstOperands,
     /*  39870 */     // GIR_Coverage, 1640,
     /*  39870 */     GIR_EraseRootFromParent_Done,
     /*  39871 */   // Label 902: @39871
     /*  39871 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(39907), // Rule ID 1641 //
     /*  39876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39898 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3746:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQh),
     /*  39901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39905 */     GIR_RootConstrainSelectedInstOperands,
     /*  39906 */     // GIR_Coverage, 1641,
     /*  39906 */     GIR_EraseRootFromParent_Done,
     /*  39907 */   // Label 903: @39907
     /*  39907 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(39943), // Rule ID 1642 //
     /*  39912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39934 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3747:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDh),
     /*  39937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39941 */     GIR_RootConstrainSelectedInstOperands,
     /*  39942 */     // GIR_Coverage, 1642,
     /*  39942 */     GIR_EraseRootFromParent_Done,
     /*  39943 */   // Label 904: @39943
     /*  39943 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(39979), // Rule ID 1643 //
     /*  39948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39970 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3747:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQh),
     /*  39973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39977 */     GIR_RootConstrainSelectedInstOperands,
     /*  39978 */     // GIR_Coverage, 1643,
     /*  39978 */     GIR_EraseRootFromParent_Done,
     /*  39979 */   // Label 905: @39979
     /*  39979 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(40015), // Rule ID 1644 //
     /*  39984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  39992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40006 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3742:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDf),
     /*  40009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40013 */     GIR_RootConstrainSelectedInstOperands,
     /*  40014 */     // GIR_Coverage, 1644,
     /*  40014 */     GIR_EraseRootFromParent_Done,
     /*  40015 */   // Label 906: @40015
     /*  40015 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(40051), // Rule ID 1645 //
     /*  40020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40042 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3742:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQf),
     /*  40045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40049 */     GIR_RootConstrainSelectedInstOperands,
     /*  40050 */     // GIR_Coverage, 1645,
     /*  40050 */     GIR_EraseRootFromParent_Done,
     /*  40051 */   // Label 907: @40051
     /*  40051 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(40087), // Rule ID 1646 //
     /*  40056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40078 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3743:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDf),
     /*  40081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40085 */     GIR_RootConstrainSelectedInstOperands,
     /*  40086 */     // GIR_Coverage, 1646,
     /*  40086 */     GIR_EraseRootFromParent_Done,
     /*  40087 */   // Label 908: @40087
     /*  40087 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(40123), // Rule ID 1647 //
     /*  40092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40114 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3743:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQf),
     /*  40117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40121 */     GIR_RootConstrainSelectedInstOperands,
     /*  40122 */     // GIR_Coverage, 1647,
     /*  40122 */     GIR_EraseRootFromParent_Done,
     /*  40123 */   // Label 909: @40123
     /*  40123 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(40159), // Rule ID 1648 //
     /*  40128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40150 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3742:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDh),
     /*  40153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40157 */     GIR_RootConstrainSelectedInstOperands,
     /*  40158 */     // GIR_Coverage, 1648,
     /*  40158 */     GIR_EraseRootFromParent_Done,
     /*  40159 */   // Label 910: @40159
     /*  40159 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(40195), // Rule ID 1649 //
     /*  40164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40186 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3742:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQh),
     /*  40189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40193 */     GIR_RootConstrainSelectedInstOperands,
     /*  40194 */     // GIR_Coverage, 1649,
     /*  40194 */     GIR_EraseRootFromParent_Done,
     /*  40195 */   // Label 911: @40195
     /*  40195 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(40231), // Rule ID 1650 //
     /*  40200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40222 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3743:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDh),
     /*  40225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40229 */     GIR_RootConstrainSelectedInstOperands,
     /*  40230 */     // GIR_Coverage, 1650,
     /*  40230 */     GIR_EraseRootFromParent_Done,
     /*  40231 */   // Label 912: @40231
     /*  40231 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(40267), // Rule ID 1651 //
     /*  40236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40258 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3743:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQh),
     /*  40261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40265 */     GIR_RootConstrainSelectedInstOperands,
     /*  40266 */     // GIR_Coverage, 1651,
     /*  40266 */     GIR_EraseRootFromParent_Done,
     /*  40267 */   // Label 913: @40267
     /*  40267 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(40312), // Rule ID 1668 //
     /*  40272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2hf),
     /*  40280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40294 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3738:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2h:{ *:[v4i16] } QPR:{ *:[v4f32] }:$Vm)
     /*  40294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /*  40297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40310 */     GIR_RootConstrainSelectedInstOperands,
     /*  40311 */     // GIR_Coverage, 1668,
     /*  40311 */     GIR_EraseRootFromParent_Done,
     /*  40312 */   // Label 914: @40312
     /*  40312 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(40357), // Rule ID 1669 //
     /*  40317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvthf2fp),
     /*  40325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40339 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3741:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4i16] }:$Vm)
     /*  40339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /*  40342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40349 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40355 */     GIR_RootConstrainSelectedInstOperands,
     /*  40356 */     // GIR_Coverage, 1669,
     /*  40356 */     GIR_EraseRootFromParent_Done,
     /*  40357 */   // Label 915: @40357
     /*  40357 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(40393), // Rule ID 1691 //
     /*  40362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40384 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3812:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTNNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDf),
     /*  40387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40391 */     GIR_RootConstrainSelectedInstOperands,
     /*  40392 */     // GIR_Coverage, 1691,
     /*  40392 */     GIR_EraseRootFromParent_Done,
     /*  40393 */   // Label 916: @40393
     /*  40393 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(40429), // Rule ID 1692 //
     /*  40398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40420 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3812:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTNNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQf),
     /*  40423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40427 */     GIR_RootConstrainSelectedInstOperands,
     /*  40428 */     // GIR_Coverage, 1692,
     /*  40428 */     GIR_EraseRootFromParent_Done,
     /*  40429 */   // Label 917: @40429
     /*  40429 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(40465), // Rule ID 1693 //
     /*  40434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40456 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3812:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTNNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDh),
     /*  40459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40463 */     GIR_RootConstrainSelectedInstOperands,
     /*  40464 */     // GIR_Coverage, 1693,
     /*  40464 */     GIR_EraseRootFromParent_Done,
     /*  40465 */   // Label 918: @40465
     /*  40465 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(40501), // Rule ID 1694 //
     /*  40470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40492 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3812:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTNNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQh),
     /*  40495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40499 */     GIR_RootConstrainSelectedInstOperands,
     /*  40500 */     // GIR_Coverage, 1694,
     /*  40500 */     GIR_EraseRootFromParent_Done,
     /*  40501 */   // Label 919: @40501
     /*  40501 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(40537), // Rule ID 1695 //
     /*  40506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40528 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3814:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTXNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDf),
     /*  40531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40535 */     GIR_RootConstrainSelectedInstOperands,
     /*  40536 */     // GIR_Coverage, 1695,
     /*  40536 */     GIR_EraseRootFromParent_Done,
     /*  40537 */   // Label 920: @40537
     /*  40537 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(40573), // Rule ID 1696 //
     /*  40542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40564 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3814:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTXNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQf),
     /*  40567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40571 */     GIR_RootConstrainSelectedInstOperands,
     /*  40572 */     // GIR_Coverage, 1696,
     /*  40572 */     GIR_EraseRootFromParent_Done,
     /*  40573 */   // Label 921: @40573
     /*  40573 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(40609), // Rule ID 1697 //
     /*  40578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40600 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3814:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTXNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDh),
     /*  40603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40607 */     GIR_RootConstrainSelectedInstOperands,
     /*  40608 */     // GIR_Coverage, 1697,
     /*  40608 */     GIR_EraseRootFromParent_Done,
     /*  40609 */   // Label 922: @40609
     /*  40609 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(40645), // Rule ID 1698 //
     /*  40614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40636 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3814:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTXNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQh),
     /*  40639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40643 */     GIR_RootConstrainSelectedInstOperands,
     /*  40644 */     // GIR_Coverage, 1698,
     /*  40644 */     GIR_EraseRootFromParent_Done,
     /*  40645 */   // Label 923: @40645
     /*  40645 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(40681), // Rule ID 1699 //
     /*  40650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40672 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3810:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTANDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDf),
     /*  40675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40679 */     GIR_RootConstrainSelectedInstOperands,
     /*  40680 */     // GIR_Coverage, 1699,
     /*  40680 */     GIR_EraseRootFromParent_Done,
     /*  40681 */   // Label 924: @40681
     /*  40681 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(40717), // Rule ID 1700 //
     /*  40686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40708 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3810:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTANQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQf),
     /*  40711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40715 */     GIR_RootConstrainSelectedInstOperands,
     /*  40716 */     // GIR_Coverage, 1700,
     /*  40716 */     GIR_EraseRootFromParent_Done,
     /*  40717 */   // Label 925: @40717
     /*  40717 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(40753), // Rule ID 1701 //
     /*  40722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40744 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3810:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTANDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDh),
     /*  40747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40751 */     GIR_RootConstrainSelectedInstOperands,
     /*  40752 */     // GIR_Coverage, 1701,
     /*  40752 */     GIR_EraseRootFromParent_Done,
     /*  40753 */   // Label 926: @40753
     /*  40753 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(40789), // Rule ID 1702 //
     /*  40758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40780 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3810:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTANQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQh),
     /*  40783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40787 */     GIR_RootConstrainSelectedInstOperands,
     /*  40788 */     // GIR_Coverage, 1702,
     /*  40788 */     GIR_EraseRootFromParent_Done,
     /*  40789 */   // Label 927: @40789
     /*  40789 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(40825), // Rule ID 1703 //
     /*  40794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40816 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3815:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTZNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDf),
     /*  40819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40823 */     GIR_RootConstrainSelectedInstOperands,
     /*  40824 */     // GIR_Coverage, 1703,
     /*  40824 */     GIR_EraseRootFromParent_Done,
     /*  40825 */   // Label 928: @40825
     /*  40825 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(40861), // Rule ID 1704 //
     /*  40830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40852 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3815:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTZNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQf),
     /*  40855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40859 */     GIR_RootConstrainSelectedInstOperands,
     /*  40860 */     // GIR_Coverage, 1704,
     /*  40860 */     GIR_EraseRootFromParent_Done,
     /*  40861 */   // Label 929: @40861
     /*  40861 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(40897), // Rule ID 1705 //
     /*  40866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40888 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3815:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTZNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDh),
     /*  40891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40895 */     GIR_RootConstrainSelectedInstOperands,
     /*  40896 */     // GIR_Coverage, 1705,
     /*  40896 */     GIR_EraseRootFromParent_Done,
     /*  40897 */   // Label 930: @40897
     /*  40897 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(40933), // Rule ID 1706 //
     /*  40902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40924 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3815:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTZNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQh),
     /*  40927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40931 */     GIR_RootConstrainSelectedInstOperands,
     /*  40932 */     // GIR_Coverage, 1706,
     /*  40932 */     GIR_EraseRootFromParent_Done,
     /*  40933 */   // Label 931: @40933
     /*  40933 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(40969), // Rule ID 1707 //
     /*  40938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40960 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3811:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDf),
     /*  40963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40967 */     GIR_RootConstrainSelectedInstOperands,
     /*  40968 */     // GIR_Coverage, 1707,
     /*  40968 */     GIR_EraseRootFromParent_Done,
     /*  40969 */   // Label 932: @40969
     /*  40969 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(41005), // Rule ID 1708 //
     /*  40974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40996 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3811:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQf),
     /*  40999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41003 */     GIR_RootConstrainSelectedInstOperands,
     /*  41004 */     // GIR_Coverage, 1708,
     /*  41004 */     GIR_EraseRootFromParent_Done,
     /*  41005 */   // Label 933: @41005
     /*  41005 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(41041), // Rule ID 1709 //
     /*  41010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  41018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41032 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3811:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDh),
     /*  41035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41039 */     GIR_RootConstrainSelectedInstOperands,
     /*  41040 */     // GIR_Coverage, 1709,
     /*  41040 */     GIR_EraseRootFromParent_Done,
     /*  41041 */   // Label 934: @41041
     /*  41041 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(41077), // Rule ID 1710 //
     /*  41046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  41054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41068 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3811:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQh),
     /*  41071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41075 */     GIR_RootConstrainSelectedInstOperands,
     /*  41076 */     // GIR_Coverage, 1710,
     /*  41076 */     GIR_EraseRootFromParent_Done,
     /*  41077 */   // Label 935: @41077
     /*  41077 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(41113), // Rule ID 1711 //
     /*  41082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  41093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41104 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3813:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTPNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  41104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDf),
     /*  41107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41111 */     GIR_RootConstrainSelectedInstOperands,
     /*  41112 */     // GIR_Coverage, 1711,
     /*  41112 */     GIR_EraseRootFromParent_Done,
     /*  41113 */   // Label 936: @41113
     /*  41113 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(41149), // Rule ID 1712 //
     /*  41118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41140 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3813:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTPNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  41140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQf),
     /*  41143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41147 */     GIR_RootConstrainSelectedInstOperands,
     /*  41148 */     // GIR_Coverage, 1712,
     /*  41148 */     GIR_EraseRootFromParent_Done,
     /*  41149 */   // Label 937: @41149
     /*  41149 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(41185), // Rule ID 1713 //
     /*  41154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41176 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3813:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTPNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDh),
     /*  41179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41183 */     GIR_RootConstrainSelectedInstOperands,
     /*  41184 */     // GIR_Coverage, 1713,
     /*  41184 */     GIR_EraseRootFromParent_Done,
     /*  41185 */   // Label 938: @41185
     /*  41185 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(41221), // Rule ID 1714 //
     /*  41190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41212 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3813:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTPNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQh),
     /*  41215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41219 */     GIR_RootConstrainSelectedInstOperands,
     /*  41220 */     // GIR_Coverage, 1714,
     /*  41220 */     GIR_EraseRootFromParent_Done,
     /*  41221 */   // Label 939: @41221
     /*  41221 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(41257), // Rule ID 1717 //
     /*  41226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesimc),
     /*  41234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41248 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3701:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESIMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESIMC),
     /*  41251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41255 */     GIR_RootConstrainSelectedInstOperands,
     /*  41256 */     // GIR_Coverage, 1717,
     /*  41256 */     GIR_EraseRootFromParent_Done,
     /*  41257 */   // Label 940: @41257
     /*  41257 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(41293), // Rule ID 1718 //
     /*  41262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesmc),
     /*  41270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41284 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3702:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESMC),
     /*  41287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41291 */     GIR_RootConstrainSelectedInstOperands,
     /*  41292 */     // GIR_Coverage, 1718,
     /*  41292 */     GIR_EraseRootFromParent_Done,
     /*  41293 */   // Label 941: @41293
     /*  41293 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(41341), // Rule ID 1851 //
     /*  41298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41320 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (SXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  41320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB16),
     /*  41323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  41327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41339 */     GIR_RootConstrainSelectedInstOperands,
     /*  41340 */     // GIR_Coverage, 1851,
     /*  41340 */     GIR_EraseRootFromParent_Done,
     /*  41341 */   // Label 942: @41341
     /*  41341 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(41389), // Rule ID 2099 //
     /*  41346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41368 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 0:{ *:[i32] })
     /*  41368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB16),
     /*  41371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41387 */     GIR_RootConstrainSelectedInstOperands,
     /*  41388 */     // GIR_Coverage, 2099,
     /*  41388 */     GIR_EraseRootFromParent_Done,
     /*  41389 */   // Label 943: @41389
     /*  41389 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(41455), // Rule ID 3648 //
     /*  41394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41416 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3583:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLSs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /*  41416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs8),
     /*  41431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41433 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41453 */     GIR_RootConstrainSelectedInstOperands,
     /*  41454 */     // GIR_Coverage, 3648,
     /*  41454 */     GIR_EraseRootFromParent_Done,
     /*  41455 */   // Label 944: @41455
     /*  41455 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(41521), // Rule ID 3650 //
     /*  41460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41482 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3583:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLSs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /*  41482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs16),
     /*  41497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41499 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41519 */     GIR_RootConstrainSelectedInstOperands,
     /*  41520 */     // GIR_Coverage, 3650,
     /*  41520 */     GIR_EraseRootFromParent_Done,
     /*  41521 */   // Label 945: @41521
     /*  41521 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(41587), // Rule ID 3652 //
     /*  41526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41548 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3583:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLSs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /*  41548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs32),
     /*  41563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41565 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41585 */     GIR_RootConstrainSelectedInstOperands,
     /*  41586 */     // GIR_Coverage, 3652,
     /*  41586 */     GIR_EraseRootFromParent_Done,
     /*  41587 */   // Label 946: @41587
     /*  41587 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(41653), // Rule ID 3964 //
     /*  41592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  41595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrintn),
     /*  41600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41614 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3665:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16N:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  41614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16N),
     /*  41629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41631 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41651 */     GIR_RootConstrainSelectedInstOperands,
     /*  41652 */     // GIR_Coverage, 3964,
     /*  41652 */     GIR_EraseRootFromParent_Done,
     /*  41653 */   // Label 947: @41653
     /*  41653 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(41719), // Rule ID 3976 //
     /*  41658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  41661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrintn),
     /*  41666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41680 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3665:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32N:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  41680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32N),
     /*  41695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41697 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41717 */     GIR_RootConstrainSelectedInstOperands,
     /*  41718 */     // GIR_Coverage, 3976,
     /*  41718 */     GIR_EraseRootFromParent_Done,
     /*  41719 */   // Label 948: @41719
     /*  41719 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(41770), // Rule ID 4864 //
     /*  41724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp8),
     /*  41732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s1,
     /*  41735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41746 */     // (intrinsic_wo_chain:{ *:[v16i1] } 3591:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP8:{ *:[v16i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP8),
     /*  41749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41768 */     GIR_RootConstrainSelectedInstOperands,
     /*  41769 */     // GIR_Coverage, 4864,
     /*  41769 */     GIR_EraseRootFromParent_Done,
     /*  41770 */   // Label 949: @41770
     /*  41770 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(41821), // Rule ID 4866 //
     /*  41775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp16),
     /*  41783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s1,
     /*  41786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41797 */     // (intrinsic_wo_chain:{ *:[v8i1] } 3588:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP16:{ *:[v8i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP16),
     /*  41800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41819 */     GIR_RootConstrainSelectedInstOperands,
     /*  41820 */     // GIR_Coverage, 4866,
     /*  41820 */     GIR_EraseRootFromParent_Done,
     /*  41821 */   // Label 950: @41821
     /*  41821 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(41872), // Rule ID 4868 //
     /*  41826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp32),
     /*  41834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s1,
     /*  41837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41848 */     // (intrinsic_wo_chain:{ *:[v4i1] } 3589:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP32:{ *:[v4i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP32),
     /*  41851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41870 */     GIR_RootConstrainSelectedInstOperands,
     /*  41871 */     // GIR_Coverage, 4868,
     /*  41871 */     GIR_EraseRootFromParent_Done,
     /*  41872 */   // Label 951: @41872
     /*  41872 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(41923), // Rule ID 4870 //
     /*  41877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp64),
     /*  41885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s1,
     /*  41888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41899 */     // (intrinsic_wo_chain:{ *:[v2i1] } 3590:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP64:{ *:[v2i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP64),
     /*  41902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41921 */     GIR_RootConstrainSelectedInstOperands,
     /*  41922 */     // GIR_Coverage, 4870,
     /*  41922 */     GIR_EraseRootFromParent_Done,
     /*  41923 */   // Label 952: @41923
     /*  41923 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(41969), // Rule ID 600 //
     /*  41928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tt),
     /*  41936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41943 */     // MIs[0] Rn
     /*  41943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41951 */     // (intrinsic_wo_chain:{ *:[i32] } 3473:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TT),
     /*  41954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41967 */     GIR_RootConstrainSelectedInstOperands,
     /*  41968 */     // GIR_Coverage, 600,
     /*  41968 */     GIR_EraseRootFromParent_Done,
     /*  41969 */   // Label 953: @41969
     /*  41969 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(42015), // Rule ID 601 //
     /*  41974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttt),
     /*  41982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41989 */     // MIs[0] Rn
     /*  41989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41997 */     // (intrinsic_wo_chain:{ *:[i32] } 3476:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTT),
     /*  42000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  42002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42013 */     GIR_RootConstrainSelectedInstOperands,
     /*  42014 */     // GIR_Coverage, 601,
     /*  42014 */     GIR_EraseRootFromParent_Done,
     /*  42015 */   // Label 954: @42015
     /*  42015 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(42061), // Rule ID 602 //
     /*  42020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  42023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tta),
     /*  42028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42035 */     // MIs[0] Rn
     /*  42035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  42039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42043 */     // (intrinsic_wo_chain:{ *:[i32] } 3474:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  42043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTA),
     /*  42046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  42048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42059 */     GIR_RootConstrainSelectedInstOperands,
     /*  42060 */     // GIR_Coverage, 602,
     /*  42060 */     GIR_EraseRootFromParent_Done,
     /*  42061 */   // Label 955: @42061
     /*  42061 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(42107), // Rule ID 603 //
     /*  42066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  42069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttat),
     /*  42074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42081 */     // MIs[0] Rn
     /*  42081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  42085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42089 */     // (intrinsic_wo_chain:{ *:[i32] } 3475:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTAT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  42089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTAT),
     /*  42092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  42094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42105 */     GIR_RootConstrainSelectedInstOperands,
     /*  42106 */     // GIR_Coverage, 603,
     /*  42106 */     GIR_EraseRootFromParent_Done,
     /*  42107 */   // Label 956: @42107
     /*  42107 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(42242), // Rule ID 2693 //
     /*  42112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1h),
     /*  42120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  42130 */     // (intrinsic_wo_chain:{ *:[i32] } 3709:{ *:[iPTR] }, i32:{ *:[i32] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f32] } (SHA1H:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$Rn, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] }), GPR:{ *:[i32] })
     /*  42130 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  42133 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42137 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42142 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  42146 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42151 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  42154 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  42158 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42163 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  42166 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  42169 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /*  42172 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  42177 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42182 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  42185 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::SHA1H),
     /*  42189 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42194 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  42199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  42202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42211 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  42218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /*  42241 */     // GIR_Coverage, 2693,
     /*  42241 */     GIR_EraseRootFromParent_Done,
     /*  42242 */   // Label 957: @42242
     /*  42242 */   GIM_Reject,
     /*  42243 */ // Label 821: @42243
     /*  42243 */ GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(62797),
     /*  42248 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  42251 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(42308), // Rule ID 2117 //
     /*  42256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  42264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42285 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  42285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB16),
     /*  42288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42306 */     GIR_RootConstrainSelectedInstOperands,
     /*  42307 */     // GIR_Coverage, 2117,
     /*  42307 */     GIR_EraseRootFromParent_Done,
     /*  42308 */   // Label 959: @42308
     /*  42308 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(42407), // Rule ID 1888 //
     /*  42313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  42316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42363 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42367 */     // MIs[2] Operand 1
     /*  42367 */     // No operand predicates
     /*  42367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42375 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42379 */     // MIs[3] Operand 1
     /*  42379 */     // No operand predicates
     /*  42379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42381 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  42384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42405 */     GIR_RootConstrainSelectedInstOperands,
     /*  42406 */     // GIR_Coverage, 1888,
     /*  42406 */     GIR_EraseRootFromParent_Done,
     /*  42407 */   // Label 960: @42407
     /*  42407 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(42506), // Rule ID 2154 //
     /*  42412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  42415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42462 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42466 */     // MIs[2] Operand 1
     /*  42466 */     // No operand predicates
     /*  42466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42474 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42478 */     // MIs[3] Operand 1
     /*  42478 */     // No operand predicates
     /*  42478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42480 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  42483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42504 */     GIR_RootConstrainSelectedInstOperands,
     /*  42505 */     // GIR_Coverage, 2154,
     /*  42505 */     GIR_EraseRootFromParent_Done,
     /*  42506 */   // Label 961: @42506
     /*  42506 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(42590), // Rule ID 5430 //
     /*  42511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42540 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42543 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42557 */     // MIs[1] Rn
     /*  42557 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42568 */     // (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn), GPRnopc:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42588 */     GIR_RootConstrainSelectedInstOperands,
     /*  42589 */     // GIR_Coverage, 5430,
     /*  42589 */     GIR_EraseRootFromParent_Done,
     /*  42590 */   // Label 962: @42590
     /*  42590 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(42674), // Rule ID 5687 //
     /*  42595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42624 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42627 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42641 */     // MIs[1] Rn
     /*  42641 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42652 */     // (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42672 */     GIR_RootConstrainSelectedInstOperands,
     /*  42673 */     // GIR_Coverage, 5687,
     /*  42673 */     GIR_EraseRootFromParent_Done,
     /*  42674 */   // Label 963: @42674
     /*  42674 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(42758), // Rule ID 109 //
     /*  42679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42712 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42715 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42729 */     // MIs[1] Rn
     /*  42729 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42736 */     // (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42756 */     GIR_RootConstrainSelectedInstOperands,
     /*  42757 */     // GIR_Coverage, 109,
     /*  42757 */     GIR_EraseRootFromParent_Done,
     /*  42758 */   // Label 964: @42758
     /*  42758 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(42842), // Rule ID 110 //
     /*  42763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42796 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42799 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42813 */     // MIs[1] Rn
     /*  42813 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42820 */     // (intrinsic_wo_chain:{ *:[i32] } 3848:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /*  42823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42840 */     GIR_RootConstrainSelectedInstOperands,
     /*  42841 */     // GIR_Coverage, 110,
     /*  42841 */     GIR_EraseRootFromParent_Done,
     /*  42842 */   // Label 965: @42842
     /*  42842 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(42926), // Rule ID 2132 //
     /*  42847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42880 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42883 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42897 */     // MIs[1] Rn
     /*  42897 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42904 */     // (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42924 */     GIR_RootConstrainSelectedInstOperands,
     /*  42925 */     // GIR_Coverage, 2132,
     /*  42925 */     GIR_EraseRootFromParent_Done,
     /*  42926 */   // Label 966: @42926
     /*  42926 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(43010), // Rule ID 2133 //
     /*  42931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42964 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42967 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42981 */     // MIs[1] Rn
     /*  42981 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42988 */     // (intrinsic_wo_chain:{ *:[i32] } 3848:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /*  42991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  43002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43008 */     GIR_RootConstrainSelectedInstOperands,
     /*  43009 */     // GIR_Coverage, 2133,
     /*  43009 */     GIR_EraseRootFromParent_Done,
     /*  43010 */   // Label 967: @43010
     /*  43010 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(43083), // Rule ID 4058 //
     /*  43015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43044 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3599:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16a),
     /*  43059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43061 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43081 */     GIR_RootConstrainSelectedInstOperands,
     /*  43082 */     // GIR_Coverage, 4058,
     /*  43082 */     GIR_EraseRootFromParent_Done,
     /*  43083 */   // Label 968: @43083
     /*  43083 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(43156), // Rule ID 4060 //
     /*  43088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43117 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3603:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16n),
     /*  43132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43134 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43154 */     GIR_RootConstrainSelectedInstOperands,
     /*  43155 */     // GIR_Coverage, 4060,
     /*  43155 */     GIR_EraseRootFromParent_Done,
     /*  43156 */   // Label 969: @43156
     /*  43156 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(43229), // Rule ID 4062 //
     /*  43161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43190 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16p),
     /*  43205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43207 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43227 */     GIR_RootConstrainSelectedInstOperands,
     /*  43228 */     // GIR_Coverage, 4062,
     /*  43228 */     GIR_EraseRootFromParent_Done,
     /*  43229 */   // Label 970: @43229
     /*  43229 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(43302), // Rule ID 4064 //
     /*  43234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43263 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3601:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16m),
     /*  43278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43280 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43300 */     GIR_RootConstrainSelectedInstOperands,
     /*  43301 */     // GIR_Coverage, 4064,
     /*  43301 */     GIR_EraseRootFromParent_Done,
     /*  43302 */   // Label 971: @43302
     /*  43302 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(43375), // Rule ID 4066 //
     /*  43307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43336 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3599:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16a),
     /*  43351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43353 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43373 */     GIR_RootConstrainSelectedInstOperands,
     /*  43374 */     // GIR_Coverage, 4066,
     /*  43374 */     GIR_EraseRootFromParent_Done,
     /*  43375 */   // Label 972: @43375
     /*  43375 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(43448), // Rule ID 4068 //
     /*  43380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43409 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3603:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16n),
     /*  43424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43426 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43446 */     GIR_RootConstrainSelectedInstOperands,
     /*  43447 */     // GIR_Coverage, 4068,
     /*  43447 */     GIR_EraseRootFromParent_Done,
     /*  43448 */   // Label 973: @43448
     /*  43448 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(43521), // Rule ID 4070 //
     /*  43453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43482 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16p),
     /*  43497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43499 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43519 */     GIR_RootConstrainSelectedInstOperands,
     /*  43520 */     // GIR_Coverage, 4070,
     /*  43520 */     GIR_EraseRootFromParent_Done,
     /*  43521 */   // Label 974: @43521
     /*  43521 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(43594), // Rule ID 4072 //
     /*  43526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43555 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3601:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16m),
     /*  43570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43572 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43592 */     GIR_RootConstrainSelectedInstOperands,
     /*  43593 */     // GIR_Coverage, 4072,
     /*  43593 */     GIR_EraseRootFromParent_Done,
     /*  43594 */   // Label 975: @43594
     /*  43594 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(43667), // Rule ID 4074 //
     /*  43599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43628 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3599:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32a),
     /*  43643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43645 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43665 */     GIR_RootConstrainSelectedInstOperands,
     /*  43666 */     // GIR_Coverage, 4074,
     /*  43666 */     GIR_EraseRootFromParent_Done,
     /*  43667 */   // Label 976: @43667
     /*  43667 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(43740), // Rule ID 4076 //
     /*  43672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43701 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3603:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32n),
     /*  43716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43718 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43738 */     GIR_RootConstrainSelectedInstOperands,
     /*  43739 */     // GIR_Coverage, 4076,
     /*  43739 */     GIR_EraseRootFromParent_Done,
     /*  43740 */   // Label 977: @43740
     /*  43740 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(43813), // Rule ID 4078 //
     /*  43745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43774 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32p),
     /*  43789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43791 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43811 */     GIR_RootConstrainSelectedInstOperands,
     /*  43812 */     // GIR_Coverage, 4078,
     /*  43812 */     GIR_EraseRootFromParent_Done,
     /*  43813 */   // Label 978: @43813
     /*  43813 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(43886), // Rule ID 4080 //
     /*  43818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43847 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3601:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32m),
     /*  43862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43864 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43884 */     GIR_RootConstrainSelectedInstOperands,
     /*  43885 */     // GIR_Coverage, 4080,
     /*  43885 */     GIR_EraseRootFromParent_Done,
     /*  43886 */   // Label 979: @43886
     /*  43886 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(43959), // Rule ID 4082 //
     /*  43891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43920 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3599:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32a),
     /*  43935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43937 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43957 */     GIR_RootConstrainSelectedInstOperands,
     /*  43958 */     // GIR_Coverage, 4082,
     /*  43958 */     GIR_EraseRootFromParent_Done,
     /*  43959 */   // Label 980: @43959
     /*  43959 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(44032), // Rule ID 4084 //
     /*  43964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43993 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3603:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32n),
     /*  44008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44010 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  44012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44030 */     GIR_RootConstrainSelectedInstOperands,
     /*  44031 */     // GIR_Coverage, 4084,
     /*  44031 */     GIR_EraseRootFromParent_Done,
     /*  44032 */   // Label 981: @44032
     /*  44032 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(44105), // Rule ID 4086 //
     /*  44037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  44045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  44054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  44062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44066 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  44066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32p),
     /*  44081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44083 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  44085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44103 */     GIR_RootConstrainSelectedInstOperands,
     /*  44104 */     // GIR_Coverage, 4086,
     /*  44104 */     GIR_EraseRootFromParent_Done,
     /*  44105 */   // Label 982: @44105
     /*  44105 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(44178), // Rule ID 4088 //
     /*  44110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  44118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  44127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  44135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44139 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3601:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  44139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32m),
     /*  44154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44156 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  44158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44176 */     GIR_RootConstrainSelectedInstOperands,
     /*  44177 */     // GIR_Coverage, 4088,
     /*  44177 */     GIR_EraseRootFromParent_Done,
     /*  44178 */   // Label 983: @44178
     /*  44178 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(44251), // Rule ID 4532 //
     /*  44183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  44212 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3597:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf32f16bh:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16bh),
     /*  44227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44249 */     GIR_RootConstrainSelectedInstOperands,
     /*  44250 */     // GIR_Coverage, 4532,
     /*  44250 */     GIR_EraseRootFromParent_Done,
     /*  44251 */   // Label 984: @44251
     /*  44251 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(44324), // Rule ID 4538 //
     /*  44256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  44285 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3597:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf32f16th:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16th),
     /*  44300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44322 */     GIR_RootConstrainSelectedInstOperands,
     /*  44323 */     // GIR_Coverage, 4538,
     /*  44323 */     GIR_EraseRootFromParent_Done,
     /*  44324 */   // Label 985: @44324
     /*  44324 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(44392), // Rule ID 1881 //
     /*  44329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44366 */     // MIs[1] Operand 1
     /*  44366 */     // No operand predicates
     /*  44366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44368 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  44371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44376 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44390 */     GIR_RootConstrainSelectedInstOperands,
     /*  44391 */     // GIR_Coverage, 1881,
     /*  44391 */     GIR_EraseRootFromParent_Done,
     /*  44392 */   // Label 986: @44392
     /*  44392 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(44457), // Rule ID 1885 //
     /*  44397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44434 */     // MIs[1] Operand 1
     /*  44434 */     // No operand predicates
     /*  44434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44436 */     // (intrinsic_wo_chain:{ *:[i32] } 3921:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPRnopc:{ *:[i32] }:$a)
     /*  44436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT16),
     /*  44439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44444 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44455 */     GIR_RootConstrainSelectedInstOperands,
     /*  44456 */     // GIR_Coverage, 1885,
     /*  44456 */     GIR_EraseRootFromParent_Done,
     /*  44457 */   // Label 987: @44457
     /*  44457 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(44525), // Rule ID 2149 //
     /*  44462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44499 */     // MIs[1] Operand 1
     /*  44499 */     // No operand predicates
     /*  44499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44501 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  44504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44509 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44523 */     GIR_RootConstrainSelectedInstOperands,
     /*  44524 */     // GIR_Coverage, 2149,
     /*  44524 */     GIR_EraseRootFromParent_Done,
     /*  44525 */   // Label 988: @44525
     /*  44525 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(44590), // Rule ID 2151 //
     /*  44530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44567 */     // MIs[1] Operand 1
     /*  44567 */     // No operand predicates
     /*  44567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44569 */     // (intrinsic_wo_chain:{ *:[i32] } 3921:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (t2USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPR:{ *:[i32] }:$a)
     /*  44569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT16),
     /*  44572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44577 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44588 */     GIR_RootConstrainSelectedInstOperands,
     /*  44589 */     // GIR_Coverage, 2151,
     /*  44589 */     GIR_EraseRootFromParent_Done,
     /*  44590 */   // Label 989: @44590
     /*  44590 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(44673), // Rule ID 3928 //
     /*  44595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  44603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  44606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  44629 */     // MIs[1] Operand 1
     /*  44629 */     // No operand predicates
     /*  44629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44631 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3658:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VQSHLU_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  44631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms8),
     /*  44646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44671 */     GIR_RootConstrainSelectedInstOperands,
     /*  44672 */     // GIR_Coverage, 3928,
     /*  44672 */     GIR_EraseRootFromParent_Done,
     /*  44673 */   // Label 990: @44673
     /*  44673 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(44756), // Rule ID 3930 //
     /*  44678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44712 */     // MIs[1] Operand 1
     /*  44712 */     // No operand predicates
     /*  44712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44714 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3658:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VQSHLU_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  44714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms16),
     /*  44729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44731 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44754 */     GIR_RootConstrainSelectedInstOperands,
     /*  44755 */     // GIR_Coverage, 3930,
     /*  44755 */     GIR_EraseRootFromParent_Done,
     /*  44756 */   // Label 991: @44756
     /*  44756 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(44839), // Rule ID 3932 //
     /*  44761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44795 */     // MIs[1] Operand 1
     /*  44795 */     // No operand predicates
     /*  44795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44797 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3658:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VQSHLU_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  44797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms32),
     /*  44812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44837 */     GIR_RootConstrainSelectedInstOperands,
     /*  44838 */     // GIR_Coverage, 3932,
     /*  44838 */     GIR_EraseRootFromParent_Done,
     /*  44839 */   // Label 992: @44839
     /*  44839 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(44900), // Rule ID 1652 //
     /*  44844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44877 */     // MIs[1] Operand 1
     /*  44877 */     // No operand predicates
     /*  44877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44879 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3736:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsd),
     /*  44882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44898 */     GIR_RootConstrainSelectedInstOperands,
     /*  44899 */     // GIR_Coverage, 1652,
     /*  44899 */     GIR_EraseRootFromParent_Done,
     /*  44900 */   // Label 993: @44900
     /*  44900 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(44961), // Rule ID 1653 //
     /*  44905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44938 */     // MIs[1] Operand 1
     /*  44938 */     // No operand predicates
     /*  44938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44940 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3737:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xud),
     /*  44943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44959 */     GIR_RootConstrainSelectedInstOperands,
     /*  44960 */     // GIR_Coverage, 1653,
     /*  44960 */     GIR_EraseRootFromParent_Done,
     /*  44961 */   // Label 994: @44961
     /*  44961 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(45022), // Rule ID 1654 //
     /*  44966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44999 */     // MIs[1] Operand 1
     /*  44999 */     // No operand predicates
     /*  44999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45001 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3739:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fd),
     /*  45004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45020 */     GIR_RootConstrainSelectedInstOperands,
     /*  45021 */     // GIR_Coverage, 1654,
     /*  45021 */     GIR_EraseRootFromParent_Done,
     /*  45022 */   // Label 995: @45022
     /*  45022 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(45083), // Rule ID 1655 //
     /*  45027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  45038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45060 */     // MIs[1] Operand 1
     /*  45060 */     // No operand predicates
     /*  45060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45062 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3740:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fd),
     /*  45065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45081 */     GIR_RootConstrainSelectedInstOperands,
     /*  45082 */     // GIR_Coverage, 1655,
     /*  45082 */     GIR_EraseRootFromParent_Done,
     /*  45083 */   // Label 996: @45083
     /*  45083 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(45144), // Rule ID 1656 //
     /*  45088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45121 */     // MIs[1] Operand 1
     /*  45121 */     // No operand predicates
     /*  45121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45123 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3736:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsd),
     /*  45126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45142 */     GIR_RootConstrainSelectedInstOperands,
     /*  45143 */     // GIR_Coverage, 1656,
     /*  45143 */     GIR_EraseRootFromParent_Done,
     /*  45144 */   // Label 997: @45144
     /*  45144 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(45205), // Rule ID 1657 //
     /*  45149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45182 */     // MIs[1] Operand 1
     /*  45182 */     // No operand predicates
     /*  45182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45184 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3737:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xud),
     /*  45187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45203 */     GIR_RootConstrainSelectedInstOperands,
     /*  45204 */     // GIR_Coverage, 1657,
     /*  45204 */     GIR_EraseRootFromParent_Done,
     /*  45205 */   // Label 998: @45205
     /*  45205 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(45266), // Rule ID 1658 //
     /*  45210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45243 */     // MIs[1] Operand 1
     /*  45243 */     // No operand predicates
     /*  45243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45245 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3739:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hd),
     /*  45248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45264 */     GIR_RootConstrainSelectedInstOperands,
     /*  45265 */     // GIR_Coverage, 1658,
     /*  45265 */     GIR_EraseRootFromParent_Done,
     /*  45266 */   // Label 999: @45266
     /*  45266 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(45327), // Rule ID 1659 //
     /*  45271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45304 */     // MIs[1] Operand 1
     /*  45304 */     // No operand predicates
     /*  45304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45306 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3740:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hd),
     /*  45309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45325 */     GIR_RootConstrainSelectedInstOperands,
     /*  45326 */     // GIR_Coverage, 1659,
     /*  45326 */     GIR_EraseRootFromParent_Done,
     /*  45327 */   // Label 1000: @45327
     /*  45327 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(45388), // Rule ID 1660 //
     /*  45332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45365 */     // MIs[1] Operand 1
     /*  45365 */     // No operand predicates
     /*  45365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45367 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3736:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsq),
     /*  45370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45386 */     GIR_RootConstrainSelectedInstOperands,
     /*  45387 */     // GIR_Coverage, 1660,
     /*  45387 */     GIR_EraseRootFromParent_Done,
     /*  45388 */   // Label 1001: @45388
     /*  45388 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(45449), // Rule ID 1661 //
     /*  45393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45426 */     // MIs[1] Operand 1
     /*  45426 */     // No operand predicates
     /*  45426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45428 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3737:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xuq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xuq),
     /*  45431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45447 */     GIR_RootConstrainSelectedInstOperands,
     /*  45448 */     // GIR_Coverage, 1661,
     /*  45448 */     GIR_EraseRootFromParent_Done,
     /*  45449 */   // Label 1002: @45449
     /*  45449 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(45510), // Rule ID 1662 //
     /*  45454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45487 */     // MIs[1] Operand 1
     /*  45487 */     // No operand predicates
     /*  45487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45489 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3739:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fq),
     /*  45492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45508 */     GIR_RootConstrainSelectedInstOperands,
     /*  45509 */     // GIR_Coverage, 1662,
     /*  45509 */     GIR_EraseRootFromParent_Done,
     /*  45510 */   // Label 1003: @45510
     /*  45510 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(45571), // Rule ID 1663 //
     /*  45515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45548 */     // MIs[1] Operand 1
     /*  45548 */     // No operand predicates
     /*  45548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45550 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3740:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fq),
     /*  45553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45569 */     GIR_RootConstrainSelectedInstOperands,
     /*  45570 */     // GIR_Coverage, 1663,
     /*  45570 */     GIR_EraseRootFromParent_Done,
     /*  45571 */   // Label 1004: @45571
     /*  45571 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(45632), // Rule ID 1664 //
     /*  45576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45609 */     // MIs[1] Operand 1
     /*  45609 */     // No operand predicates
     /*  45609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45611 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3736:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsq),
     /*  45614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45630 */     GIR_RootConstrainSelectedInstOperands,
     /*  45631 */     // GIR_Coverage, 1664,
     /*  45631 */     GIR_EraseRootFromParent_Done,
     /*  45632 */   // Label 1005: @45632
     /*  45632 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(45693), // Rule ID 1665 //
     /*  45637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45670 */     // MIs[1] Operand 1
     /*  45670 */     // No operand predicates
     /*  45670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45672 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3737:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xuq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xuq),
     /*  45675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45691 */     GIR_RootConstrainSelectedInstOperands,
     /*  45692 */     // GIR_Coverage, 1665,
     /*  45692 */     GIR_EraseRootFromParent_Done,
     /*  45693 */   // Label 1006: @45693
     /*  45693 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(45754), // Rule ID 1666 //
     /*  45698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45731 */     // MIs[1] Operand 1
     /*  45731 */     // No operand predicates
     /*  45731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45733 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3739:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hq),
     /*  45736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45752 */     GIR_RootConstrainSelectedInstOperands,
     /*  45753 */     // GIR_Coverage, 1666,
     /*  45753 */     GIR_EraseRootFromParent_Done,
     /*  45754 */   // Label 1007: @45754
     /*  45754 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(45815), // Rule ID 1667 //
     /*  45759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45792 */     // MIs[1] Operand 1
     /*  45792 */     // No operand predicates
     /*  45792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45794 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3740:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hq),
     /*  45797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45813 */     GIR_RootConstrainSelectedInstOperands,
     /*  45814 */     // GIR_Coverage, 1667,
     /*  45814 */     GIR_EraseRootFromParent_Done,
     /*  45815 */   // Label 1008: @45815
     /*  45815 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(45876), // Rule ID 1725 //
     /*  45820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqshl),
     /*  45828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45853 */     // MIs[1] Operand 1
     /*  45853 */     // No operand predicates
     /*  45853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45855 */     // (intrinsic_wo_chain:{ *:[i32] } 3563:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQSHL),
     /*  45858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45860 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45874 */     GIR_RootConstrainSelectedInstOperands,
     /*  45875 */     // GIR_Coverage, 1725,
     /*  45875 */     GIR_EraseRootFromParent_Done,
     /*  45876 */   // Label 1009: @45876
     /*  45876 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(45937), // Rule ID 1726 //
     /*  45881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_srshr),
     /*  45889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45914 */     // MIs[1] Operand 1
     /*  45914 */     // No operand predicates
     /*  45914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45916 */     // (intrinsic_wo_chain:{ *:[i32] } 3565:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SRSHR),
     /*  45919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45921 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45935 */     GIR_RootConstrainSelectedInstOperands,
     /*  45936 */     // GIR_Coverage, 1726,
     /*  45936 */     GIR_EraseRootFromParent_Done,
     /*  45937 */   // Label 1010: @45937
     /*  45937 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(45998), // Rule ID 1727 //
     /*  45942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqshl),
     /*  45950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45975 */     // MIs[1] Operand 1
     /*  45975 */     // No operand predicates
     /*  45975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45977 */     // (intrinsic_wo_chain:{ *:[i32] } 3570:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_UQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQSHL),
     /*  45980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45982 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45996 */     GIR_RootConstrainSelectedInstOperands,
     /*  45997 */     // GIR_Coverage, 1727,
     /*  45997 */     GIR_EraseRootFromParent_Done,
     /*  45998 */   // Label 1011: @45998
     /*  45998 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(46059), // Rule ID 1728 //
     /*  46003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  46006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_urshr),
     /*  46011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  46024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  46028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  46032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46036 */     // MIs[1] Operand 1
     /*  46036 */     // No operand predicates
     /*  46036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46038 */     // (intrinsic_wo_chain:{ *:[i32] } 3572:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_URSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  46038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_URSHR),
     /*  46041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  46043 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  46045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  46048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46057 */     GIR_RootConstrainSelectedInstOperands,
     /*  46058 */     // GIR_Coverage, 1728,
     /*  46058 */     GIR_EraseRootFromParent_Done,
     /*  46059 */   // Label 1012: @46059
     /*  46059 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(46113), // Rule ID 105 //
     /*  46064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  46072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46093 */     // (intrinsic_wo_chain:{ *:[i32] } 3845:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD8),
     /*  46096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46105 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46111 */     GIR_RootConstrainSelectedInstOperands,
     /*  46112 */     // GIR_Coverage, 105,
     /*  46112 */     GIR_EraseRootFromParent_Done,
     /*  46113 */   // Label 1013: @46113
     /*  46113 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(46167), // Rule ID 106 //
     /*  46118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  46126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46147 */     // (intrinsic_wo_chain:{ *:[i32] } 3844:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD16),
     /*  46150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46165 */     GIR_RootConstrainSelectedInstOperands,
     /*  46166 */     // GIR_Coverage, 106,
     /*  46166 */     GIR_EraseRootFromParent_Done,
     /*  46167 */   // Label 1014: @46167
     /*  46167 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(46221), // Rule ID 107 //
     /*  46172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  46180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46201 */     // (intrinsic_wo_chain:{ *:[i32] } 3849:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB16),
     /*  46204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46213 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46219 */     GIR_RootConstrainSelectedInstOperands,
     /*  46220 */     // GIR_Coverage, 107,
     /*  46220 */     GIR_EraseRootFromParent_Done,
     /*  46221 */   // Label 1015: @46221
     /*  46221 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(46275), // Rule ID 108 //
     /*  46226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  46234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46255 */     // (intrinsic_wo_chain:{ *:[i32] } 3850:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB8),
     /*  46258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46273 */     GIR_RootConstrainSelectedInstOperands,
     /*  46274 */     // GIR_Coverage, 108,
     /*  46274 */     GIR_EraseRootFromParent_Done,
     /*  46275 */   // Label 1016: @46275
     /*  46275 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(46329), // Rule ID 111 //
     /*  46280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  46288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46309 */     // (intrinsic_wo_chain:{ *:[i32] } 3848:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /*  46312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46327 */     GIR_RootConstrainSelectedInstOperands,
     /*  46328 */     // GIR_Coverage, 111,
     /*  46328 */     GIR_EraseRootFromParent_Done,
     /*  46329 */   // Label 1017: @46329
     /*  46329 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(46383), // Rule ID 112 //
     /*  46334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  46342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46363 */     // (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /*  46366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46381 */     GIR_RootConstrainSelectedInstOperands,
     /*  46382 */     // GIR_Coverage, 112,
     /*  46382 */     GIR_EraseRootFromParent_Done,
     /*  46383 */   // Label 1018: @46383
     /*  46383 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(46437), // Rule ID 113 //
     /*  46388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  46396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46417 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD16),
     /*  46420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46435 */     GIR_RootConstrainSelectedInstOperands,
     /*  46436 */     // GIR_Coverage, 113,
     /*  46436 */     GIR_EraseRootFromParent_Done,
     /*  46437 */   // Label 1019: @46437
     /*  46437 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(46491), // Rule ID 114 //
     /*  46442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  46450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46471 */     // (intrinsic_wo_chain:{ *:[i32] } 3913:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD8),
     /*  46474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46489 */     GIR_RootConstrainSelectedInstOperands,
     /*  46490 */     // GIR_Coverage, 114,
     /*  46490 */     GIR_EraseRootFromParent_Done,
     /*  46491 */   // Label 1020: @46491
     /*  46491 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(46545), // Rule ID 115 //
     /*  46496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  46504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46525 */     // (intrinsic_wo_chain:{ *:[i32] } 3916:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB16),
     /*  46528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46543 */     GIR_RootConstrainSelectedInstOperands,
     /*  46544 */     // GIR_Coverage, 115,
     /*  46544 */     GIR_EraseRootFromParent_Done,
     /*  46545 */   // Label 1021: @46545
     /*  46545 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(46599), // Rule ID 116 //
     /*  46550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  46558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46579 */     // (intrinsic_wo_chain:{ *:[i32] } 3917:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB8),
     /*  46582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46597 */     GIR_RootConstrainSelectedInstOperands,
     /*  46598 */     // GIR_Coverage, 116,
     /*  46598 */     GIR_EraseRootFromParent_Done,
     /*  46599 */   // Label 1022: @46599
     /*  46599 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(46653), // Rule ID 117 //
     /*  46604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  46612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46633 */     // (intrinsic_wo_chain:{ *:[i32] } 3846:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QASX),
     /*  46636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46651 */     GIR_RootConstrainSelectedInstOperands,
     /*  46652 */     // GIR_Coverage, 117,
     /*  46652 */     GIR_EraseRootFromParent_Done,
     /*  46653 */   // Label 1023: @46653
     /*  46653 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(46707), // Rule ID 118 //
     /*  46658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  46666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46687 */     // (intrinsic_wo_chain:{ *:[i32] } 3847:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSAX),
     /*  46690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46705 */     GIR_RootConstrainSelectedInstOperands,
     /*  46706 */     // GIR_Coverage, 118,
     /*  46706 */     GIR_EraseRootFromParent_Done,
     /*  46707 */   // Label 1024: @46707
     /*  46707 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(46761), // Rule ID 119 //
     /*  46712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  46720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46741 */     // (intrinsic_wo_chain:{ *:[i32] } 3914:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQASX),
     /*  46744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46759 */     GIR_RootConstrainSelectedInstOperands,
     /*  46760 */     // GIR_Coverage, 119,
     /*  46760 */     GIR_EraseRootFromParent_Done,
     /*  46761 */   // Label 1025: @46761
     /*  46761 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(46815), // Rule ID 120 //
     /*  46766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  46774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46795 */     // (intrinsic_wo_chain:{ *:[i32] } 3915:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSAX),
     /*  46798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46813 */     GIR_RootConstrainSelectedInstOperands,
     /*  46814 */     // GIR_Coverage, 120,
     /*  46814 */     GIR_EraseRootFromParent_Done,
     /*  46815 */   // Label 1026: @46815
     /*  46815 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(46869), // Rule ID 133 //
     /*  46820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  46828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46849 */     // (intrinsic_wo_chain:{ *:[i32] } 3858:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHASX),
     /*  46852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46867 */     GIR_RootConstrainSelectedInstOperands,
     /*  46868 */     // GIR_Coverage, 133,
     /*  46868 */     GIR_EraseRootFromParent_Done,
     /*  46869 */   // Label 1027: @46869
     /*  46869 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(46923), // Rule ID 134 //
     /*  46874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  46882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46903 */     // (intrinsic_wo_chain:{ *:[i32] } 3856:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD16),
     /*  46906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46921 */     GIR_RootConstrainSelectedInstOperands,
     /*  46922 */     // GIR_Coverage, 134,
     /*  46922 */     GIR_EraseRootFromParent_Done,
     /*  46923 */   // Label 1028: @46923
     /*  46923 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(46977), // Rule ID 135 //
     /*  46928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  46936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46957 */     // (intrinsic_wo_chain:{ *:[i32] } 3857:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD8),
     /*  46960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46975 */     GIR_RootConstrainSelectedInstOperands,
     /*  46976 */     // GIR_Coverage, 135,
     /*  46976 */     GIR_EraseRootFromParent_Done,
     /*  46977 */   // Label 1029: @46977
     /*  46977 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(47031), // Rule ID 136 //
     /*  46982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  46990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47011 */     // (intrinsic_wo_chain:{ *:[i32] } 3859:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSAX),
     /*  47014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47029 */     GIR_RootConstrainSelectedInstOperands,
     /*  47030 */     // GIR_Coverage, 136,
     /*  47030 */     GIR_EraseRootFromParent_Done,
     /*  47031 */   // Label 1030: @47031
     /*  47031 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(47085), // Rule ID 137 //
     /*  47036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  47044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47065 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB16),
     /*  47068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47083 */     GIR_RootConstrainSelectedInstOperands,
     /*  47084 */     // GIR_Coverage, 137,
     /*  47084 */     GIR_EraseRootFromParent_Done,
     /*  47085 */   // Label 1031: @47085
     /*  47085 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(47139), // Rule ID 138 //
     /*  47090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  47098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47119 */     // (intrinsic_wo_chain:{ *:[i32] } 3861:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB8),
     /*  47122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47137 */     GIR_RootConstrainSelectedInstOperands,
     /*  47138 */     // GIR_Coverage, 138,
     /*  47138 */     GIR_EraseRootFromParent_Done,
     /*  47139 */   // Label 1032: @47139
     /*  47139 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(47193), // Rule ID 139 //
     /*  47144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  47152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47173 */     // (intrinsic_wo_chain:{ *:[i32] } 3907:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHASX),
     /*  47176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47191 */     GIR_RootConstrainSelectedInstOperands,
     /*  47192 */     // GIR_Coverage, 139,
     /*  47192 */     GIR_EraseRootFromParent_Done,
     /*  47193 */   // Label 1033: @47193
     /*  47193 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(47247), // Rule ID 140 //
     /*  47198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  47206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47227 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD16),
     /*  47230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47245 */     GIR_RootConstrainSelectedInstOperands,
     /*  47246 */     // GIR_Coverage, 140,
     /*  47246 */     GIR_EraseRootFromParent_Done,
     /*  47247 */   // Label 1034: @47247
     /*  47247 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(47301), // Rule ID 141 //
     /*  47252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  47260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47281 */     // (intrinsic_wo_chain:{ *:[i32] } 3906:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD8),
     /*  47284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47299 */     GIR_RootConstrainSelectedInstOperands,
     /*  47300 */     // GIR_Coverage, 141,
     /*  47300 */     GIR_EraseRootFromParent_Done,
     /*  47301 */   // Label 1035: @47301
     /*  47301 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(47355), // Rule ID 142 //
     /*  47306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  47314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47335 */     // (intrinsic_wo_chain:{ *:[i32] } 3908:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSAX),
     /*  47338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47353 */     GIR_RootConstrainSelectedInstOperands,
     /*  47354 */     // GIR_Coverage, 142,
     /*  47354 */     GIR_EraseRootFromParent_Done,
     /*  47355 */   // Label 1036: @47355
     /*  47355 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(47409), // Rule ID 143 //
     /*  47360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  47368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47389 */     // (intrinsic_wo_chain:{ *:[i32] } 3909:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB16),
     /*  47392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47407 */     GIR_RootConstrainSelectedInstOperands,
     /*  47408 */     // GIR_Coverage, 143,
     /*  47408 */     GIR_EraseRootFromParent_Done,
     /*  47409 */   // Label 1037: @47409
     /*  47409 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(47463), // Rule ID 144 //
     /*  47414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  47422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47443 */     // (intrinsic_wo_chain:{ *:[i32] } 3910:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB8),
     /*  47446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47461 */     GIR_RootConstrainSelectedInstOperands,
     /*  47462 */     // GIR_Coverage, 144,
     /*  47462 */     GIR_EraseRootFromParent_Done,
     /*  47463 */   // Label 1038: @47463
     /*  47463 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(47517), // Rule ID 145 //
     /*  47468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  47471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  47476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47497 */     // (intrinsic_wo_chain:{ *:[i32] } 3918:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (USAD8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  47497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAD8),
     /*  47500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47515 */     GIR_RootConstrainSelectedInstOperands,
     /*  47516 */     // GIR_Coverage, 145,
     /*  47516 */     GIR_EraseRootFromParent_Done,
     /*  47517 */   // Label 1039: @47517
     /*  47517 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(47562), // Rule ID 204 //
     /*  47522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  47530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47551 */     // (intrinsic_wo_chain:{ *:[i32] } 3477:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32B:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32B),
     /*  47554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47560 */     GIR_RootConstrainSelectedInstOperands,
     /*  47561 */     // GIR_Coverage, 204,
     /*  47561 */     GIR_EraseRootFromParent_Done,
     /*  47562 */   // Label 1040: @47562
     /*  47562 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(47607), // Rule ID 205 //
     /*  47567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  47575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47596 */     // (intrinsic_wo_chain:{ *:[i32] } 3478:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CB),
     /*  47599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47605 */     GIR_RootConstrainSelectedInstOperands,
     /*  47606 */     // GIR_Coverage, 205,
     /*  47606 */     GIR_EraseRootFromParent_Done,
     /*  47607 */   // Label 1041: @47607
     /*  47607 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(47652), // Rule ID 206 //
     /*  47612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  47620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47641 */     // (intrinsic_wo_chain:{ *:[i32] } 3481:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32H:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32H),
     /*  47644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47650 */     GIR_RootConstrainSelectedInstOperands,
     /*  47651 */     // GIR_Coverage, 206,
     /*  47651 */     GIR_EraseRootFromParent_Done,
     /*  47652 */   // Label 1042: @47652
     /*  47652 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(47697), // Rule ID 207 //
     /*  47657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  47665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47686 */     // (intrinsic_wo_chain:{ *:[i32] } 3479:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CH:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CH),
     /*  47689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47695 */     GIR_RootConstrainSelectedInstOperands,
     /*  47696 */     // GIR_Coverage, 207,
     /*  47696 */     GIR_EraseRootFromParent_Done,
     /*  47697 */   // Label 1043: @47697
     /*  47697 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(47742), // Rule ID 208 //
     /*  47702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  47710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47731 */     // (intrinsic_wo_chain:{ *:[i32] } 3482:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32W:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32W),
     /*  47734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47740 */     GIR_RootConstrainSelectedInstOperands,
     /*  47741 */     // GIR_Coverage, 208,
     /*  47741 */     GIR_EraseRootFromParent_Done,
     /*  47742 */   // Label 1044: @47742
     /*  47742 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(47787), // Rule ID 209 //
     /*  47747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  47755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47776 */     // (intrinsic_wo_chain:{ *:[i32] } 3480:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CW:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CW),
     /*  47779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47785 */     GIR_RootConstrainSelectedInstOperands,
     /*  47786 */     // GIR_Coverage, 209,
     /*  47786 */     GIR_EraseRootFromParent_Done,
     /*  47787 */   // Label 1045: @47787
     /*  47787 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(47841), // Rule ID 432 //
     /*  47792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  47800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47821 */     // (intrinsic_wo_chain:{ *:[i32] } 3844:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD16),
     /*  47824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47839 */     GIR_RootConstrainSelectedInstOperands,
     /*  47840 */     // GIR_Coverage, 432,
     /*  47840 */     GIR_EraseRootFromParent_Done,
     /*  47841 */   // Label 1046: @47841
     /*  47841 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(47895), // Rule ID 433 //
     /*  47846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  47854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47875 */     // (intrinsic_wo_chain:{ *:[i32] } 3845:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD8),
     /*  47878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47893 */     GIR_RootConstrainSelectedInstOperands,
     /*  47894 */     // GIR_Coverage, 433,
     /*  47894 */     GIR_EraseRootFromParent_Done,
     /*  47895 */   // Label 1047: @47895
     /*  47895 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(47949), // Rule ID 434 //
     /*  47900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  47908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47929 */     // (intrinsic_wo_chain:{ *:[i32] } 3846:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QASX),
     /*  47932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47947 */     GIR_RootConstrainSelectedInstOperands,
     /*  47948 */     // GIR_Coverage, 434,
     /*  47948 */     GIR_EraseRootFromParent_Done,
     /*  47949 */   // Label 1048: @47949
     /*  47949 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(48003), // Rule ID 435 //
     /*  47954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  47962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47983 */     // (intrinsic_wo_chain:{ *:[i32] } 3917:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB8),
     /*  47986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48001 */     GIR_RootConstrainSelectedInstOperands,
     /*  48002 */     // GIR_Coverage, 435,
     /*  48002 */     GIR_EraseRootFromParent_Done,
     /*  48003 */   // Label 1049: @48003
     /*  48003 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(48057), // Rule ID 436 //
     /*  48008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  48016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48037 */     // (intrinsic_wo_chain:{ *:[i32] } 3847:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSAX),
     /*  48040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48055 */     GIR_RootConstrainSelectedInstOperands,
     /*  48056 */     // GIR_Coverage, 436,
     /*  48056 */     GIR_EraseRootFromParent_Done,
     /*  48057 */   // Label 1050: @48057
     /*  48057 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(48111), // Rule ID 437 //
     /*  48062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  48070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48091 */     // (intrinsic_wo_chain:{ *:[i32] } 3849:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB16),
     /*  48094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48109 */     GIR_RootConstrainSelectedInstOperands,
     /*  48110 */     // GIR_Coverage, 437,
     /*  48110 */     GIR_EraseRootFromParent_Done,
     /*  48111 */   // Label 1051: @48111
     /*  48111 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(48165), // Rule ID 438 //
     /*  48116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  48124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48145 */     // (intrinsic_wo_chain:{ *:[i32] } 3850:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB8),
     /*  48148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48163 */     GIR_RootConstrainSelectedInstOperands,
     /*  48164 */     // GIR_Coverage, 438,
     /*  48164 */     GIR_EraseRootFromParent_Done,
     /*  48165 */   // Label 1052: @48165
     /*  48165 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(48219), // Rule ID 439 //
     /*  48170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  48178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48199 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD16),
     /*  48202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48217 */     GIR_RootConstrainSelectedInstOperands,
     /*  48218 */     // GIR_Coverage, 439,
     /*  48218 */     GIR_EraseRootFromParent_Done,
     /*  48219 */   // Label 1053: @48219
     /*  48219 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(48273), // Rule ID 440 //
     /*  48224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  48232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48253 */     // (intrinsic_wo_chain:{ *:[i32] } 3913:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD8),
     /*  48256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48271 */     GIR_RootConstrainSelectedInstOperands,
     /*  48272 */     // GIR_Coverage, 440,
     /*  48272 */     GIR_EraseRootFromParent_Done,
     /*  48273 */   // Label 1054: @48273
     /*  48273 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(48327), // Rule ID 441 //
     /*  48278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  48286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48307 */     // (intrinsic_wo_chain:{ *:[i32] } 3914:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQASX),
     /*  48310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48325 */     GIR_RootConstrainSelectedInstOperands,
     /*  48326 */     // GIR_Coverage, 441,
     /*  48326 */     GIR_EraseRootFromParent_Done,
     /*  48327 */   // Label 1055: @48327
     /*  48327 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(48381), // Rule ID 442 //
     /*  48332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  48340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48361 */     // (intrinsic_wo_chain:{ *:[i32] } 3915:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSAX),
     /*  48364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48379 */     GIR_RootConstrainSelectedInstOperands,
     /*  48380 */     // GIR_Coverage, 442,
     /*  48380 */     GIR_EraseRootFromParent_Done,
     /*  48381 */   // Label 1056: @48381
     /*  48381 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(48435), // Rule ID 443 //
     /*  48386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  48394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48415 */     // (intrinsic_wo_chain:{ *:[i32] } 3916:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB16),
     /*  48418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48433 */     GIR_RootConstrainSelectedInstOperands,
     /*  48434 */     // GIR_Coverage, 443,
     /*  48434 */     GIR_EraseRootFromParent_Done,
     /*  48435 */   // Label 1057: @48435
     /*  48435 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(48489), // Rule ID 456 //
     /*  48440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  48448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48469 */     // (intrinsic_wo_chain:{ *:[i32] } 3858:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHASX),
     /*  48472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48487 */     GIR_RootConstrainSelectedInstOperands,
     /*  48488 */     // GIR_Coverage, 456,
     /*  48488 */     GIR_EraseRootFromParent_Done,
     /*  48489 */   // Label 1058: @48489
     /*  48489 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(48543), // Rule ID 457 //
     /*  48494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  48502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48523 */     // (intrinsic_wo_chain:{ *:[i32] } 3856:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD16),
     /*  48526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48541 */     GIR_RootConstrainSelectedInstOperands,
     /*  48542 */     // GIR_Coverage, 457,
     /*  48542 */     GIR_EraseRootFromParent_Done,
     /*  48543 */   // Label 1059: @48543
     /*  48543 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(48597), // Rule ID 458 //
     /*  48548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  48556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48577 */     // (intrinsic_wo_chain:{ *:[i32] } 3857:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD8),
     /*  48580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48595 */     GIR_RootConstrainSelectedInstOperands,
     /*  48596 */     // GIR_Coverage, 458,
     /*  48596 */     GIR_EraseRootFromParent_Done,
     /*  48597 */   // Label 1060: @48597
     /*  48597 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(48651), // Rule ID 459 //
     /*  48602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  48610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48631 */     // (intrinsic_wo_chain:{ *:[i32] } 3859:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSAX),
     /*  48634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48649 */     GIR_RootConstrainSelectedInstOperands,
     /*  48650 */     // GIR_Coverage, 459,
     /*  48650 */     GIR_EraseRootFromParent_Done,
     /*  48651 */   // Label 1061: @48651
     /*  48651 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(48705), // Rule ID 460 //
     /*  48656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  48664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48685 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB16),
     /*  48688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48703 */     GIR_RootConstrainSelectedInstOperands,
     /*  48704 */     // GIR_Coverage, 460,
     /*  48704 */     GIR_EraseRootFromParent_Done,
     /*  48705 */   // Label 1062: @48705
     /*  48705 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(48759), // Rule ID 461 //
     /*  48710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  48718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48739 */     // (intrinsic_wo_chain:{ *:[i32] } 3861:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB8),
     /*  48742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48757 */     GIR_RootConstrainSelectedInstOperands,
     /*  48758 */     // GIR_Coverage, 461,
     /*  48758 */     GIR_EraseRootFromParent_Done,
     /*  48759 */   // Label 1063: @48759
     /*  48759 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(48813), // Rule ID 462 //
     /*  48764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  48772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48793 */     // (intrinsic_wo_chain:{ *:[i32] } 3907:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHASX),
     /*  48796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48811 */     GIR_RootConstrainSelectedInstOperands,
     /*  48812 */     // GIR_Coverage, 462,
     /*  48812 */     GIR_EraseRootFromParent_Done,
     /*  48813 */   // Label 1064: @48813
     /*  48813 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(48867), // Rule ID 463 //
     /*  48818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  48826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48847 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD16),
     /*  48850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48865 */     GIR_RootConstrainSelectedInstOperands,
     /*  48866 */     // GIR_Coverage, 463,
     /*  48866 */     GIR_EraseRootFromParent_Done,
     /*  48867 */   // Label 1065: @48867
     /*  48867 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(48921), // Rule ID 464 //
     /*  48872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  48880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48901 */     // (intrinsic_wo_chain:{ *:[i32] } 3906:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD8),
     /*  48904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48919 */     GIR_RootConstrainSelectedInstOperands,
     /*  48920 */     // GIR_Coverage, 464,
     /*  48920 */     GIR_EraseRootFromParent_Done,
     /*  48921 */   // Label 1066: @48921
     /*  48921 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(48975), // Rule ID 465 //
     /*  48926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  48934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48955 */     // (intrinsic_wo_chain:{ *:[i32] } 3908:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSAX),
     /*  48958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48973 */     GIR_RootConstrainSelectedInstOperands,
     /*  48974 */     // GIR_Coverage, 465,
     /*  48974 */     GIR_EraseRootFromParent_Done,
     /*  48975 */   // Label 1067: @48975
     /*  48975 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(49029), // Rule ID 466 //
     /*  48980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  48988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49009 */     // (intrinsic_wo_chain:{ *:[i32] } 3909:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB16),
     /*  49012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49027 */     GIR_RootConstrainSelectedInstOperands,
     /*  49028 */     // GIR_Coverage, 466,
     /*  49028 */     GIR_EraseRootFromParent_Done,
     /*  49029 */   // Label 1068: @49029
     /*  49029 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(49083), // Rule ID 467 //
     /*  49034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  49042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49063 */     // (intrinsic_wo_chain:{ *:[i32] } 3910:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB8),
     /*  49066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49081 */     GIR_RootConstrainSelectedInstOperands,
     /*  49082 */     // GIR_Coverage, 467,
     /*  49082 */     GIR_EraseRootFromParent_Done,
     /*  49083 */   // Label 1069: @49083
     /*  49083 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(49137), // Rule ID 468 //
     /*  49088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  49096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49117 */     // (intrinsic_wo_chain:{ *:[i32] } 3918:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAD8),
     /*  49120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49135 */     GIR_RootConstrainSelectedInstOperands,
     /*  49136 */     // GIR_Coverage, 468,
     /*  49136 */     GIR_EraseRootFromParent_Done,
     /*  49137 */   // Label 1070: @49137
     /*  49137 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(49191), // Rule ID 524 //
     /*  49142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  49150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49171 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUAD),
     /*  49174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49189 */     GIR_RootConstrainSelectedInstOperands,
     /*  49190 */     // GIR_Coverage, 524,
     /*  49190 */     GIR_EraseRootFromParent_Done,
     /*  49191 */   // Label 1071: @49191
     /*  49191 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(49245), // Rule ID 525 //
     /*  49196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  49204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49225 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUADX),
     /*  49228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49243 */     GIR_RootConstrainSelectedInstOperands,
     /*  49244 */     // GIR_Coverage, 525,
     /*  49244 */     GIR_EraseRootFromParent_Done,
     /*  49245 */   // Label 1072: @49245
     /*  49245 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(49299), // Rule ID 526 //
     /*  49250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  49258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49279 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSD),
     /*  49282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49297 */     GIR_RootConstrainSelectedInstOperands,
     /*  49298 */     // GIR_Coverage, 526,
     /*  49298 */     GIR_EraseRootFromParent_Done,
     /*  49299 */   // Label 1073: @49299
     /*  49299 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(49353), // Rule ID 527 //
     /*  49304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  49312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49333 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSDX),
     /*  49336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49351 */     GIR_RootConstrainSelectedInstOperands,
     /*  49352 */     // GIR_Coverage, 527,
     /*  49352 */     GIR_EraseRootFromParent_Done,
     /*  49353 */   // Label 1074: @49353
     /*  49353 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(49398), // Rule ID 541 //
     /*  49358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  49366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49387 */     // (intrinsic_wo_chain:{ *:[i32] } 3477:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32B:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32B),
     /*  49390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49396 */     GIR_RootConstrainSelectedInstOperands,
     /*  49397 */     // GIR_Coverage, 541,
     /*  49397 */     GIR_EraseRootFromParent_Done,
     /*  49398 */   // Label 1075: @49398
     /*  49398 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(49443), // Rule ID 542 //
     /*  49403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  49411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49432 */     // (intrinsic_wo_chain:{ *:[i32] } 3478:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CB),
     /*  49435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49441 */     GIR_RootConstrainSelectedInstOperands,
     /*  49442 */     // GIR_Coverage, 542,
     /*  49442 */     GIR_EraseRootFromParent_Done,
     /*  49443 */   // Label 1076: @49443
     /*  49443 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(49488), // Rule ID 543 //
     /*  49448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  49456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49477 */     // (intrinsic_wo_chain:{ *:[i32] } 3481:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32H:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32H),
     /*  49480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49486 */     GIR_RootConstrainSelectedInstOperands,
     /*  49487 */     // GIR_Coverage, 543,
     /*  49487 */     GIR_EraseRootFromParent_Done,
     /*  49488 */   // Label 1077: @49488
     /*  49488 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(49533), // Rule ID 544 //
     /*  49493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  49501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49522 */     // (intrinsic_wo_chain:{ *:[i32] } 3479:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CH),
     /*  49525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49531 */     GIR_RootConstrainSelectedInstOperands,
     /*  49532 */     // GIR_Coverage, 544,
     /*  49532 */     GIR_EraseRootFromParent_Done,
     /*  49533 */   // Label 1078: @49533
     /*  49533 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(49578), // Rule ID 545 //
     /*  49538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  49546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49567 */     // (intrinsic_wo_chain:{ *:[i32] } 3482:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32W:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32W),
     /*  49570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49576 */     GIR_RootConstrainSelectedInstOperands,
     /*  49577 */     // GIR_Coverage, 545,
     /*  49577 */     GIR_EraseRootFromParent_Done,
     /*  49578 */   // Label 1079: @49578
     /*  49578 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(49623), // Rule ID 546 //
     /*  49583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  49591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49612 */     // (intrinsic_wo_chain:{ *:[i32] } 3480:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CW:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CW),
     /*  49615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49621 */     GIR_RootConstrainSelectedInstOperands,
     /*  49622 */     // GIR_Coverage, 546,
     /*  49622 */     GIR_EraseRootFromParent_Done,
     /*  49623 */   // Label 1080: @49623
     /*  49623 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(49677), // Rule ID 792 //
     /*  49628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49657 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3748:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i16),
     /*  49660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49675 */     GIR_RootConstrainSelectedInstOperands,
     /*  49676 */     // GIR_Coverage, 792,
     /*  49676 */     GIR_EraseRootFromParent_Done,
     /*  49677 */   // Label 1081: @49677
     /*  49677 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(49731), // Rule ID 793 //
     /*  49682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49711 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3748:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv2i32),
     /*  49714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49729 */     GIR_RootConstrainSelectedInstOperands,
     /*  49730 */     // GIR_Coverage, 793,
     /*  49730 */     GIR_EraseRootFromParent_Done,
     /*  49731 */   // Label 1082: @49731
     /*  49731 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(49785), // Rule ID 794 //
     /*  49736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49765 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3748:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i16),
     /*  49768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49783 */     GIR_RootConstrainSelectedInstOperands,
     /*  49784 */     // GIR_Coverage, 794,
     /*  49784 */     GIR_EraseRootFromParent_Done,
     /*  49785 */   // Label 1083: @49785
     /*  49785 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(49839), // Rule ID 795 //
     /*  49790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49819 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3748:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i32),
     /*  49822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49837 */     GIR_RootConstrainSelectedInstOperands,
     /*  49838 */     // GIR_Coverage, 795,
     /*  49838 */     GIR_EraseRootFromParent_Done,
     /*  49839 */   // Label 1084: @49839
     /*  49839 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(49893), // Rule ID 796 //
     /*  49844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49873 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3748:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i8),
     /*  49876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49891 */     GIR_RootConstrainSelectedInstOperands,
     /*  49892 */     // GIR_Coverage, 796,
     /*  49892 */     GIR_EraseRootFromParent_Done,
     /*  49893 */   // Label 1085: @49893
     /*  49893 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(49947), // Rule ID 797 //
     /*  49898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49927 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3748:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv16i8),
     /*  49930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49945 */     GIR_RootConstrainSelectedInstOperands,
     /*  49946 */     // GIR_Coverage, 797,
     /*  49946 */     GIR_EraseRootFromParent_Done,
     /*  49947 */   // Label 1086: @49947
     /*  49947 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(50001), // Rule ID 798 //
     /*  49952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49981 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3749:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i16),
     /*  49984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49999 */     GIR_RootConstrainSelectedInstOperands,
     /*  50000 */     // GIR_Coverage, 798,
     /*  50000 */     GIR_EraseRootFromParent_Done,
     /*  50001 */   // Label 1087: @50001
     /*  50001 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(50055), // Rule ID 799 //
     /*  50006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50035 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3749:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv2i32),
     /*  50038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50053 */     GIR_RootConstrainSelectedInstOperands,
     /*  50054 */     // GIR_Coverage, 799,
     /*  50054 */     GIR_EraseRootFromParent_Done,
     /*  50055 */   // Label 1088: @50055
     /*  50055 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(50109), // Rule ID 800 //
     /*  50060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50089 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3749:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i16),
     /*  50092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50107 */     GIR_RootConstrainSelectedInstOperands,
     /*  50108 */     // GIR_Coverage, 800,
     /*  50108 */     GIR_EraseRootFromParent_Done,
     /*  50109 */   // Label 1089: @50109
     /*  50109 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(50163), // Rule ID 801 //
     /*  50114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50143 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3749:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i32),
     /*  50146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50161 */     GIR_RootConstrainSelectedInstOperands,
     /*  50162 */     // GIR_Coverage, 801,
     /*  50162 */     GIR_EraseRootFromParent_Done,
     /*  50163 */   // Label 1090: @50163
     /*  50163 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(50217), // Rule ID 802 //
     /*  50168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50197 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3749:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i8),
     /*  50200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50215 */     GIR_RootConstrainSelectedInstOperands,
     /*  50216 */     // GIR_Coverage, 802,
     /*  50216 */     GIR_EraseRootFromParent_Done,
     /*  50217 */   // Label 1091: @50217
     /*  50217 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(50271), // Rule ID 803 //
     /*  50222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50251 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3749:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv16i8),
     /*  50254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50269 */     GIR_RootConstrainSelectedInstOperands,
     /*  50270 */     // GIR_Coverage, 803,
     /*  50270 */     GIR_EraseRootFromParent_Done,
     /*  50271 */   // Label 1092: @50271
     /*  50271 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(50325), // Rule ID 804 //
     /*  50276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50305 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3808:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i16),
     /*  50308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50323 */     GIR_RootConstrainSelectedInstOperands,
     /*  50324 */     // GIR_Coverage, 804,
     /*  50324 */     GIR_EraseRootFromParent_Done,
     /*  50325 */   // Label 1093: @50325
     /*  50325 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(50379), // Rule ID 805 //
     /*  50330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50359 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3808:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv2i32),
     /*  50362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50377 */     GIR_RootConstrainSelectedInstOperands,
     /*  50378 */     // GIR_Coverage, 805,
     /*  50378 */     GIR_EraseRootFromParent_Done,
     /*  50379 */   // Label 1094: @50379
     /*  50379 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(50433), // Rule ID 806 //
     /*  50384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50413 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3808:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i16),
     /*  50416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50431 */     GIR_RootConstrainSelectedInstOperands,
     /*  50432 */     // GIR_Coverage, 806,
     /*  50432 */     GIR_EraseRootFromParent_Done,
     /*  50433 */   // Label 1095: @50433
     /*  50433 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(50487), // Rule ID 807 //
     /*  50438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50467 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3808:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i32),
     /*  50470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50485 */     GIR_RootConstrainSelectedInstOperands,
     /*  50486 */     // GIR_Coverage, 807,
     /*  50486 */     GIR_EraseRootFromParent_Done,
     /*  50487 */   // Label 1096: @50487
     /*  50487 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(50541), // Rule ID 808 //
     /*  50492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50521 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3808:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i8),
     /*  50524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50539 */     GIR_RootConstrainSelectedInstOperands,
     /*  50540 */     // GIR_Coverage, 808,
     /*  50540 */     GIR_EraseRootFromParent_Done,
     /*  50541 */   // Label 1097: @50541
     /*  50541 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(50595), // Rule ID 809 //
     /*  50546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50575 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3808:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv16i8),
     /*  50578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50593 */     GIR_RootConstrainSelectedInstOperands,
     /*  50594 */     // GIR_Coverage, 809,
     /*  50594 */     GIR_EraseRootFromParent_Done,
     /*  50595 */   // Label 1098: @50595
     /*  50595 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(50649), // Rule ID 810 //
     /*  50600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50629 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i16),
     /*  50632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50647 */     GIR_RootConstrainSelectedInstOperands,
     /*  50648 */     // GIR_Coverage, 810,
     /*  50648 */     GIR_EraseRootFromParent_Done,
     /*  50649 */   // Label 1099: @50649
     /*  50649 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(50703), // Rule ID 811 //
     /*  50654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50683 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv2i32),
     /*  50686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50701 */     GIR_RootConstrainSelectedInstOperands,
     /*  50702 */     // GIR_Coverage, 811,
     /*  50702 */     GIR_EraseRootFromParent_Done,
     /*  50703 */   // Label 1100: @50703
     /*  50703 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(50757), // Rule ID 812 //
     /*  50708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50737 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3809:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i16),
     /*  50740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50755 */     GIR_RootConstrainSelectedInstOperands,
     /*  50756 */     // GIR_Coverage, 812,
     /*  50756 */     GIR_EraseRootFromParent_Done,
     /*  50757 */   // Label 1101: @50757
     /*  50757 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(50811), // Rule ID 813 //
     /*  50762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50791 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i32),
     /*  50794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50809 */     GIR_RootConstrainSelectedInstOperands,
     /*  50810 */     // GIR_Coverage, 813,
     /*  50810 */     GIR_EraseRootFromParent_Done,
     /*  50811 */   // Label 1102: @50811
     /*  50811 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(50865), // Rule ID 814 //
     /*  50816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50845 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3809:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i8),
     /*  50848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50863 */     GIR_RootConstrainSelectedInstOperands,
     /*  50864 */     // GIR_Coverage, 814,
     /*  50864 */     GIR_EraseRootFromParent_Done,
     /*  50865 */   // Label 1103: @50865
     /*  50865 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(50919), // Rule ID 815 //
     /*  50870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50899 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3809:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv16i8),
     /*  50902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50917 */     GIR_RootConstrainSelectedInstOperands,
     /*  50918 */     // GIR_Coverage, 815,
     /*  50918 */     GIR_EraseRootFromParent_Done,
     /*  50919 */   // Label 1104: @50919
     /*  50919 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(50973), // Rule ID 832 //
     /*  50924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50953 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3805:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRADDHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv8i8),
     /*  50956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50971 */     GIR_RootConstrainSelectedInstOperands,
     /*  50972 */     // GIR_Coverage, 832,
     /*  50972 */     GIR_EraseRootFromParent_Done,
     /*  50973 */   // Label 1105: @50973
     /*  50973 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(51027), // Rule ID 833 //
     /*  50978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51007 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3805:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRADDHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv4i16),
     /*  51010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51025 */     GIR_RootConstrainSelectedInstOperands,
     /*  51026 */     // GIR_Coverage, 833,
     /*  51026 */     GIR_EraseRootFromParent_Done,
     /*  51027 */   // Label 1106: @51027
     /*  51027 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(51081), // Rule ID 834 //
     /*  51032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  51040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  51046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  51049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51061 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3805:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRADDHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  51061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv2i32),
     /*  51064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51079 */     GIR_RootConstrainSelectedInstOperands,
     /*  51080 */     // GIR_Coverage, 834,
     /*  51080 */     GIR_EraseRootFromParent_Done,
     /*  51081 */   // Label 1107: @51081
     /*  51081 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(51135), // Rule ID 841 //
     /*  51086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  51094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51115 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3774:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULpd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpd),
     /*  51118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51133 */     GIR_RootConstrainSelectedInstOperands,
     /*  51134 */     // GIR_Coverage, 841,
     /*  51134 */     GIR_EraseRootFromParent_Done,
     /*  51135 */   // Label 1108: @51135
     /*  51135 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(51189), // Rule ID 842 //
     /*  51140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  51148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51169 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3774:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULpq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpq),
     /*  51172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51187 */     GIR_RootConstrainSelectedInstOperands,
     /*  51188 */     // GIR_Coverage, 842,
     /*  51188 */     GIR_EraseRootFromParent_Done,
     /*  51189 */   // Label 1109: @51189
     /*  51189 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(51243), // Rule ID 855 //
     /*  51194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51223 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3785:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i16),
     /*  51226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51241 */     GIR_RootConstrainSelectedInstOperands,
     /*  51242 */     // GIR_Coverage, 855,
     /*  51242 */     GIR_EraseRootFromParent_Done,
     /*  51243 */   // Label 1110: @51243
     /*  51243 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(51297), // Rule ID 856 //
     /*  51248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51277 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3785:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv2i32),
     /*  51280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51295 */     GIR_RootConstrainSelectedInstOperands,
     /*  51296 */     // GIR_Coverage, 856,
     /*  51296 */     GIR_EraseRootFromParent_Done,
     /*  51297 */   // Label 1111: @51297
     /*  51297 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(51351), // Rule ID 857 //
     /*  51302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51331 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3785:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv8i16),
     /*  51334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51349 */     GIR_RootConstrainSelectedInstOperands,
     /*  51350 */     // GIR_Coverage, 857,
     /*  51350 */     GIR_EraseRootFromParent_Done,
     /*  51351 */   // Label 1112: @51351
     /*  51351 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(51405), // Rule ID 858 //
     /*  51356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51385 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3785:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i32),
     /*  51388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51403 */     GIR_RootConstrainSelectedInstOperands,
     /*  51404 */     // GIR_Coverage, 858,
     /*  51404 */     GIR_EraseRootFromParent_Done,
     /*  51405 */   // Label 1113: @51405
     /*  51405 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(51459), // Rule ID 863 //
     /*  51410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51439 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3793:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i16),
     /*  51442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51457 */     GIR_RootConstrainSelectedInstOperands,
     /*  51458 */     // GIR_Coverage, 863,
     /*  51458 */     GIR_EraseRootFromParent_Done,
     /*  51459 */   // Label 1114: @51459
     /*  51459 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(51513), // Rule ID 864 //
     /*  51464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51493 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3793:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv2i32),
     /*  51496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51511 */     GIR_RootConstrainSelectedInstOperands,
     /*  51512 */     // GIR_Coverage, 864,
     /*  51512 */     GIR_EraseRootFromParent_Done,
     /*  51513 */   // Label 1115: @51513
     /*  51513 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(51567), // Rule ID 865 //
     /*  51518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51547 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3793:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv8i16),
     /*  51550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51565 */     GIR_RootConstrainSelectedInstOperands,
     /*  51566 */     // GIR_Coverage, 865,
     /*  51566 */     GIR_EraseRootFromParent_Done,
     /*  51567 */   // Label 1116: @51567
     /*  51567 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(51621), // Rule ID 866 //
     /*  51572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51601 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3793:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i32),
     /*  51604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51619 */     GIR_RootConstrainSelectedInstOperands,
     /*  51620 */     // GIR_Coverage, 866,
     /*  51620 */     GIR_EraseRootFromParent_Done,
     /*  51621 */   // Label 1117: @51621
     /*  51621 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(51675), // Rule ID 877 //
     /*  51626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51655 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3771:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULLp8:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp8),
     /*  51658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51673 */     GIR_RootConstrainSelectedInstOperands,
     /*  51674 */     // GIR_Coverage, 877,
     /*  51674 */     GIR_EraseRootFromParent_Done,
     /*  51675 */   // Label 1118: @51675
     /*  51675 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(51720), // Rule ID 878 //
     /*  51680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  51683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  51697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51709 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3771:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VMULLp64:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  51709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp64),
     /*  51712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51718 */     GIR_RootConstrainSelectedInstOperands,
     /*  51719 */     // GIR_Coverage, 878,
     /*  51719 */     GIR_EraseRootFromParent_Done,
     /*  51720 */   // Label 1119: @51720
     /*  51720 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(51774), // Rule ID 883 //
     /*  51725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51754 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3786:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULLv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv4i32),
     /*  51757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51772 */     GIR_RootConstrainSelectedInstOperands,
     /*  51773 */     // GIR_Coverage, 883,
     /*  51773 */     GIR_EraseRootFromParent_Done,
     /*  51774 */   // Label 1120: @51774
     /*  51774 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(51828), // Rule ID 884 //
     /*  51779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51808 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3786:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULLv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv2i64),
     /*  51811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51826 */     GIR_RootConstrainSelectedInstOperands,
     /*  51827 */     // GIR_Coverage, 884,
     /*  51827 */     GIR_EraseRootFromParent_Done,
     /*  51828 */   // Label 1121: @51828
     /*  51828 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(51882), // Rule ID 996 //
     /*  51833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51862 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3750:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i16),
     /*  51865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51880 */     GIR_RootConstrainSelectedInstOperands,
     /*  51881 */     // GIR_Coverage, 996,
     /*  51881 */     GIR_EraseRootFromParent_Done,
     /*  51882 */   // Label 1122: @51882
     /*  51882 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(51936), // Rule ID 997 //
     /*  51887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51916 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3750:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv2i32),
     /*  51919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51934 */     GIR_RootConstrainSelectedInstOperands,
     /*  51935 */     // GIR_Coverage, 997,
     /*  51935 */     GIR_EraseRootFromParent_Done,
     /*  51936 */   // Label 1123: @51936
     /*  51936 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(51990), // Rule ID 998 //
     /*  51941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51970 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3750:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i16),
     /*  51973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51988 */     GIR_RootConstrainSelectedInstOperands,
     /*  51989 */     // GIR_Coverage, 998,
     /*  51989 */     GIR_EraseRootFromParent_Done,
     /*  51990 */   // Label 1124: @51990
     /*  51990 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(52044), // Rule ID 999 //
     /*  51995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  52003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52024 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3750:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i32),
     /*  52027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52042 */     GIR_RootConstrainSelectedInstOperands,
     /*  52043 */     // GIR_Coverage, 999,
     /*  52043 */     GIR_EraseRootFromParent_Done,
     /*  52044 */   // Label 1125: @52044
     /*  52044 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(52098), // Rule ID 1000 //
     /*  52049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  52057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52078 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3750:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i8),
     /*  52081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52096 */     GIR_RootConstrainSelectedInstOperands,
     /*  52097 */     // GIR_Coverage, 1000,
     /*  52097 */     GIR_EraseRootFromParent_Done,
     /*  52098 */   // Label 1126: @52098
     /*  52098 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(52152), // Rule ID 1001 //
     /*  52103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  52111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52132 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3750:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv16i8),
     /*  52135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52150 */     GIR_RootConstrainSelectedInstOperands,
     /*  52151 */     // GIR_Coverage, 1001,
     /*  52151 */     GIR_EraseRootFromParent_Done,
     /*  52152 */   // Label 1127: @52152
     /*  52152 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(52206), // Rule ID 1002 //
     /*  52157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52186 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3751:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  52186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i16),
     /*  52189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52204 */     GIR_RootConstrainSelectedInstOperands,
     /*  52205 */     // GIR_Coverage, 1002,
     /*  52205 */     GIR_EraseRootFromParent_Done,
     /*  52206 */   // Label 1128: @52206
     /*  52206 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(52260), // Rule ID 1003 //
     /*  52211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52240 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3751:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  52240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv2i32),
     /*  52243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52258 */     GIR_RootConstrainSelectedInstOperands,
     /*  52259 */     // GIR_Coverage, 1003,
     /*  52259 */     GIR_EraseRootFromParent_Done,
     /*  52260 */   // Label 1129: @52260
     /*  52260 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(52314), // Rule ID 1004 //
     /*  52265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52294 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3751:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i16),
     /*  52297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52312 */     GIR_RootConstrainSelectedInstOperands,
     /*  52313 */     // GIR_Coverage, 1004,
     /*  52313 */     GIR_EraseRootFromParent_Done,
     /*  52314 */   // Label 1130: @52314
     /*  52314 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(52368), // Rule ID 1005 //
     /*  52319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52348 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3751:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i32),
     /*  52351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52366 */     GIR_RootConstrainSelectedInstOperands,
     /*  52367 */     // GIR_Coverage, 1005,
     /*  52367 */     GIR_EraseRootFromParent_Done,
     /*  52368 */   // Label 1131: @52368
     /*  52368 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(52422), // Rule ID 1006 //
     /*  52373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52402 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3751:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i8),
     /*  52405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52420 */     GIR_RootConstrainSelectedInstOperands,
     /*  52421 */     // GIR_Coverage, 1006,
     /*  52421 */     GIR_EraseRootFromParent_Done,
     /*  52422 */   // Label 1132: @52422
     /*  52422 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(52476), // Rule ID 1007 //
     /*  52427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52456 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3751:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv16i8),
     /*  52459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52474 */     GIR_RootConstrainSelectedInstOperands,
     /*  52475 */     // GIR_Coverage, 1007,
     /*  52475 */     GIR_EraseRootFromParent_Done,
     /*  52476 */   // Label 1133: @52476
     /*  52476 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(52530), // Rule ID 1024 //
     /*  52481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52510 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3821:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRSUBHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv8i8),
     /*  52513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52528 */     GIR_RootConstrainSelectedInstOperands,
     /*  52529 */     // GIR_Coverage, 1024,
     /*  52529 */     GIR_EraseRootFromParent_Done,
     /*  52530 */   // Label 1134: @52530
     /*  52530 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(52584), // Rule ID 1025 //
     /*  52535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52564 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3821:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSUBHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv4i16),
     /*  52567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52582 */     GIR_RootConstrainSelectedInstOperands,
     /*  52583 */     // GIR_Coverage, 1025,
     /*  52583 */     GIR_EraseRootFromParent_Done,
     /*  52584 */   // Label 1135: @52584
     /*  52584 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(52638), // Rule ID 1026 //
     /*  52589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  52606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52618 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3821:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRSUBHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  52618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv2i32),
     /*  52621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52636 */     GIR_RootConstrainSelectedInstOperands,
     /*  52637 */     // GIR_Coverage, 1026,
     /*  52637 */     GIR_EraseRootFromParent_Done,
     /*  52638 */   // Label 1136: @52638
     /*  52638 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(52692), // Rule ID 1119 //
     /*  52643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52672 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3726:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGEfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfd),
     /*  52675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52690 */     GIR_RootConstrainSelectedInstOperands,
     /*  52691 */     // GIR_Coverage, 1119,
     /*  52691 */     GIR_EraseRootFromParent_Done,
     /*  52692 */   // Label 1137: @52692
     /*  52692 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(52746), // Rule ID 1120 //
     /*  52697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52726 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3726:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGEfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfq),
     /*  52729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52744 */     GIR_RootConstrainSelectedInstOperands,
     /*  52745 */     // GIR_Coverage, 1120,
     /*  52745 */     GIR_EraseRootFromParent_Done,
     /*  52746 */   // Label 1138: @52746
     /*  52746 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(52800), // Rule ID 1121 //
     /*  52751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52780 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3726:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGEhd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhd),
     /*  52783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52798 */     GIR_RootConstrainSelectedInstOperands,
     /*  52799 */     // GIR_Coverage, 1121,
     /*  52799 */     GIR_EraseRootFromParent_Done,
     /*  52800 */   // Label 1139: @52800
     /*  52800 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(52854), // Rule ID 1122 //
     /*  52805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52834 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3726:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGEhq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhq),
     /*  52837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52852 */     GIR_RootConstrainSelectedInstOperands,
     /*  52853 */     // GIR_Coverage, 1122,
     /*  52853 */     GIR_EraseRootFromParent_Done,
     /*  52854 */   // Label 1140: @52854
     /*  52854 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(52908), // Rule ID 1123 //
     /*  52859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52888 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3727:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGTfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfd),
     /*  52891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52906 */     GIR_RootConstrainSelectedInstOperands,
     /*  52907 */     // GIR_Coverage, 1123,
     /*  52907 */     GIR_EraseRootFromParent_Done,
     /*  52908 */   // Label 1141: @52908
     /*  52908 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(52962), // Rule ID 1124 //
     /*  52913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52942 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3727:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGTfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfq),
     /*  52945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52960 */     GIR_RootConstrainSelectedInstOperands,
     /*  52961 */     // GIR_Coverage, 1124,
     /*  52961 */     GIR_EraseRootFromParent_Done,
     /*  52962 */   // Label 1142: @52962
     /*  52962 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(53016), // Rule ID 1125 //
     /*  52967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52996 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3727:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGThd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThd),
     /*  52999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53014 */     GIR_RootConstrainSelectedInstOperands,
     /*  53015 */     // GIR_Coverage, 1125,
     /*  53015 */     GIR_EraseRootFromParent_Done,
     /*  53016 */   // Label 1143: @53016
     /*  53016 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(53070), // Rule ID 1126 //
     /*  53021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  53029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53050 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3727:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGThq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  53050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThq),
     /*  53053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53068 */     GIR_RootConstrainSelectedInstOperands,
     /*  53069 */     // GIR_Coverage, 1126,
     /*  53069 */     GIR_EraseRootFromParent_Done,
     /*  53070 */   // Label 1144: @53070
     /*  53070 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(53124), // Rule ID 1169 //
     /*  53075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53104 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3723:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VABDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfd),
     /*  53107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53122 */     GIR_RootConstrainSelectedInstOperands,
     /*  53123 */     // GIR_Coverage, 1169,
     /*  53123 */     GIR_EraseRootFromParent_Done,
     /*  53124 */   // Label 1145: @53124
     /*  53124 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(53178), // Rule ID 1170 //
     /*  53129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53158 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3723:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VABDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  53158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfq),
     /*  53161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53176 */     GIR_RootConstrainSelectedInstOperands,
     /*  53177 */     // GIR_Coverage, 1170,
     /*  53177 */     GIR_EraseRootFromParent_Done,
     /*  53178 */   // Label 1146: @53178
     /*  53178 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(53232), // Rule ID 1171 //
     /*  53183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53212 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3723:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VABDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhd),
     /*  53215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53230 */     GIR_RootConstrainSelectedInstOperands,
     /*  53231 */     // GIR_Coverage, 1171,
     /*  53231 */     GIR_EraseRootFromParent_Done,
     /*  53232 */   // Label 1147: @53232
     /*  53232 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(53286), // Rule ID 1172 //
     /*  53237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53266 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3723:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VABDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  53266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhq),
     /*  53269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53284 */     GIR_RootConstrainSelectedInstOperands,
     /*  53285 */     // GIR_Coverage, 1172,
     /*  53285 */     GIR_EraseRootFromParent_Done,
     /*  53286 */   // Label 1148: @53286
     /*  53286 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(53340), // Rule ID 1237 //
     /*  53291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53320 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3777:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi8),
     /*  53323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53338 */     GIR_RootConstrainSelectedInstOperands,
     /*  53339 */     // GIR_Coverage, 1237,
     /*  53339 */     GIR_EraseRootFromParent_Done,
     /*  53340 */   // Label 1149: @53340
     /*  53340 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(53394), // Rule ID 1238 //
     /*  53345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53374 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3777:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi16),
     /*  53377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53392 */     GIR_RootConstrainSelectedInstOperands,
     /*  53393 */     // GIR_Coverage, 1238,
     /*  53393 */     GIR_EraseRootFromParent_Done,
     /*  53394 */   // Label 1150: @53394
     /*  53394 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(53448), // Rule ID 1239 //
     /*  53399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53428 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3777:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDi32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi32),
     /*  53431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53446 */     GIR_RootConstrainSelectedInstOperands,
     /*  53447 */     // GIR_Coverage, 1239,
     /*  53447 */     GIR_EraseRootFromParent_Done,
     /*  53448 */   // Label 1151: @53448
     /*  53448 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(53502), // Rule ID 1240 //
     /*  53453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53482 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3777:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPADDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDf),
     /*  53485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53500 */     GIR_RootConstrainSelectedInstOperands,
     /*  53501 */     // GIR_Coverage, 1240,
     /*  53501 */     GIR_EraseRootFromParent_Done,
     /*  53502 */   // Label 1152: @53502
     /*  53502 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(53556), // Rule ID 1241 //
     /*  53507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53536 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3777:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPADDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDh),
     /*  53539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53554 */     GIR_RootConstrainSelectedInstOperands,
     /*  53555 */     // GIR_Coverage, 1241,
     /*  53555 */     GIR_EraseRootFromParent_Done,
     /*  53556 */   // Label 1153: @53556
     /*  53556 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(53610), // Rule ID 1254 //
     /*  53561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53590 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3775:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALsv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i8),
     /*  53593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53595 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53608 */     GIR_RootConstrainSelectedInstOperands,
     /*  53609 */     // GIR_Coverage, 1254,
     /*  53609 */     GIR_EraseRootFromParent_Done,
     /*  53610 */   // Label 1154: @53610
     /*  53610 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(53664), // Rule ID 1255 //
     /*  53615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53644 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3775:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALsv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i16),
     /*  53647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53662 */     GIR_RootConstrainSelectedInstOperands,
     /*  53663 */     // GIR_Coverage, 1255,
     /*  53663 */     GIR_EraseRootFromParent_Done,
     /*  53664 */   // Label 1155: @53664
     /*  53664 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(53718), // Rule ID 1256 //
     /*  53669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53698 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3775:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALsv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv2i32),
     /*  53701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53703 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53716 */     GIR_RootConstrainSelectedInstOperands,
     /*  53717 */     // GIR_Coverage, 1256,
     /*  53717 */     GIR_EraseRootFromParent_Done,
     /*  53718 */   // Label 1156: @53718
     /*  53718 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(53772), // Rule ID 1257 //
     /*  53723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53752 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3775:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALsv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv16i8),
     /*  53755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53770 */     GIR_RootConstrainSelectedInstOperands,
     /*  53771 */     // GIR_Coverage, 1257,
     /*  53771 */     GIR_EraseRootFromParent_Done,
     /*  53772 */   // Label 1157: @53772
     /*  53772 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(53826), // Rule ID 1258 //
     /*  53777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53806 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3775:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALsv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i16),
     /*  53809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53811 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53824 */     GIR_RootConstrainSelectedInstOperands,
     /*  53825 */     // GIR_Coverage, 1258,
     /*  53825 */     GIR_EraseRootFromParent_Done,
     /*  53826 */   // Label 1158: @53826
     /*  53826 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(53880), // Rule ID 1259 //
     /*  53831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53860 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3775:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALsv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i32),
     /*  53863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53878 */     GIR_RootConstrainSelectedInstOperands,
     /*  53879 */     // GIR_Coverage, 1259,
     /*  53879 */     GIR_EraseRootFromParent_Done,
     /*  53880 */   // Label 1159: @53880
     /*  53880 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(53934), // Rule ID 1260 //
     /*  53885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53914 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3776:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALuv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i8),
     /*  53917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53919 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53932 */     GIR_RootConstrainSelectedInstOperands,
     /*  53933 */     // GIR_Coverage, 1260,
     /*  53933 */     GIR_EraseRootFromParent_Done,
     /*  53934 */   // Label 1160: @53934
     /*  53934 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(53988), // Rule ID 1261 //
     /*  53939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53968 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3776:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALuv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i16),
     /*  53971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53973 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53986 */     GIR_RootConstrainSelectedInstOperands,
     /*  53987 */     // GIR_Coverage, 1261,
     /*  53987 */     GIR_EraseRootFromParent_Done,
     /*  53988 */   // Label 1161: @53988
     /*  53988 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(54042), // Rule ID 1262 //
     /*  53993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  54004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54022 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3776:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALuv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  54022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv2i32),
     /*  54025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54027 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54040 */     GIR_RootConstrainSelectedInstOperands,
     /*  54041 */     // GIR_Coverage, 1262,
     /*  54041 */     GIR_EraseRootFromParent_Done,
     /*  54042 */   // Label 1162: @54042
     /*  54042 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(54096), // Rule ID 1263 //
     /*  54047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  54058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  54064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54076 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3776:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALuv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  54076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv16i8),
     /*  54079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54094 */     GIR_RootConstrainSelectedInstOperands,
     /*  54095 */     // GIR_Coverage, 1263,
     /*  54095 */     GIR_EraseRootFromParent_Done,
     /*  54096 */   // Label 1163: @54096
     /*  54096 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(54150), // Rule ID 1264 //
     /*  54101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  54112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  54118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54130 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3776:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALuv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  54130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i16),
     /*  54133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54135 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54148 */     GIR_RootConstrainSelectedInstOperands,
     /*  54149 */     // GIR_Coverage, 1264,
     /*  54149 */     GIR_EraseRootFromParent_Done,
     /*  54150 */   // Label 1164: @54150
     /*  54150 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(54204), // Rule ID 1265 //
     /*  54155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  54166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54184 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3776:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALuv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  54184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i32),
     /*  54187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54189 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54202 */     GIR_RootConstrainSelectedInstOperands,
     /*  54203 */     // GIR_Coverage, 1265,
     /*  54203 */     GIR_EraseRootFromParent_Done,
     /*  54204 */   // Label 1165: @54204
     /*  54204 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(54258), // Rule ID 1266 //
     /*  54209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54238 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3780:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs8),
     /*  54241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54256 */     GIR_RootConstrainSelectedInstOperands,
     /*  54257 */     // GIR_Coverage, 1266,
     /*  54257 */     GIR_EraseRootFromParent_Done,
     /*  54258 */   // Label 1166: @54258
     /*  54258 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(54312), // Rule ID 1267 //
     /*  54263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54292 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3780:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs16),
     /*  54295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54310 */     GIR_RootConstrainSelectedInstOperands,
     /*  54311 */     // GIR_Coverage, 1267,
     /*  54311 */     GIR_EraseRootFromParent_Done,
     /*  54312 */   // Label 1167: @54312
     /*  54312 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(54366), // Rule ID 1268 //
     /*  54317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54346 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3780:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs32),
     /*  54349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54364 */     GIR_RootConstrainSelectedInstOperands,
     /*  54365 */     // GIR_Coverage, 1268,
     /*  54365 */     GIR_EraseRootFromParent_Done,
     /*  54366 */   // Label 1168: @54366
     /*  54366 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(54420), // Rule ID 1269 //
     /*  54371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54400 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3781:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu8),
     /*  54403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54418 */     GIR_RootConstrainSelectedInstOperands,
     /*  54419 */     // GIR_Coverage, 1269,
     /*  54419 */     GIR_EraseRootFromParent_Done,
     /*  54420 */   // Label 1169: @54420
     /*  54420 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(54474), // Rule ID 1270 //
     /*  54425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54454 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3781:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu16),
     /*  54457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54472 */     GIR_RootConstrainSelectedInstOperands,
     /*  54473 */     // GIR_Coverage, 1270,
     /*  54473 */     GIR_EraseRootFromParent_Done,
     /*  54474 */   // Label 1170: @54474
     /*  54474 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(54528), // Rule ID 1271 //
     /*  54479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54508 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3781:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu32),
     /*  54511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54526 */     GIR_RootConstrainSelectedInstOperands,
     /*  54527 */     // GIR_Coverage, 1271,
     /*  54527 */     GIR_EraseRootFromParent_Done,
     /*  54528 */   // Label 1171: @54528
     /*  54528 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(54582), // Rule ID 1272 //
     /*  54533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54562 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3780:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMAXf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXf),
     /*  54565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54580 */     GIR_RootConstrainSelectedInstOperands,
     /*  54581 */     // GIR_Coverage, 1272,
     /*  54581 */     GIR_EraseRootFromParent_Done,
     /*  54582 */   // Label 1172: @54582
     /*  54582 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(54636), // Rule ID 1273 //
     /*  54587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54616 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3780:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMAXh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXh),
     /*  54619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54634 */     GIR_RootConstrainSelectedInstOperands,
     /*  54635 */     // GIR_Coverage, 1273,
     /*  54635 */     GIR_EraseRootFromParent_Done,
     /*  54636 */   // Label 1173: @54636
     /*  54636 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(54690), // Rule ID 1274 //
     /*  54641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54670 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3782:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs8),
     /*  54673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54688 */     GIR_RootConstrainSelectedInstOperands,
     /*  54689 */     // GIR_Coverage, 1274,
     /*  54689 */     GIR_EraseRootFromParent_Done,
     /*  54690 */   // Label 1174: @54690
     /*  54690 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(54744), // Rule ID 1275 //
     /*  54695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54724 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3782:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs16),
     /*  54727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54742 */     GIR_RootConstrainSelectedInstOperands,
     /*  54743 */     // GIR_Coverage, 1275,
     /*  54743 */     GIR_EraseRootFromParent_Done,
     /*  54744 */   // Label 1175: @54744
     /*  54744 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(54798), // Rule ID 1276 //
     /*  54749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54778 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3782:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs32),
     /*  54781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54796 */     GIR_RootConstrainSelectedInstOperands,
     /*  54797 */     // GIR_Coverage, 1276,
     /*  54797 */     GIR_EraseRootFromParent_Done,
     /*  54798 */   // Label 1176: @54798
     /*  54798 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(54852), // Rule ID 1277 //
     /*  54803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54832 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3783:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu8),
     /*  54835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54850 */     GIR_RootConstrainSelectedInstOperands,
     /*  54851 */     // GIR_Coverage, 1277,
     /*  54851 */     GIR_EraseRootFromParent_Done,
     /*  54852 */   // Label 1177: @54852
     /*  54852 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(54906), // Rule ID 1278 //
     /*  54857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54886 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3783:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu16),
     /*  54889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54904 */     GIR_RootConstrainSelectedInstOperands,
     /*  54905 */     // GIR_Coverage, 1278,
     /*  54905 */     GIR_EraseRootFromParent_Done,
     /*  54906 */   // Label 1178: @54906
     /*  54906 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(54960), // Rule ID 1279 //
     /*  54911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54940 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3783:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu32),
     /*  54943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54958 */     GIR_RootConstrainSelectedInstOperands,
     /*  54959 */     // GIR_Coverage, 1279,
     /*  54959 */     GIR_EraseRootFromParent_Done,
     /*  54960 */   // Label 1179: @54960
     /*  54960 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(55014), // Rule ID 1280 //
     /*  54965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54994 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3782:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMINf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINf),
     /*  54997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55012 */     GIR_RootConstrainSelectedInstOperands,
     /*  55013 */     // GIR_Coverage, 1280,
     /*  55013 */     GIR_EraseRootFromParent_Done,
     /*  55014 */   // Label 1180: @55014
     /*  55014 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(55068), // Rule ID 1281 //
     /*  55019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  55027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55048 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3782:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMINh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINh),
     /*  55051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55066 */     GIR_RootConstrainSelectedInstOperands,
     /*  55067 */     // GIR_Coverage, 1281,
     /*  55067 */     GIR_EraseRootFromParent_Done,
     /*  55068 */   // Label 1181: @55068
     /*  55068 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(55122), // Rule ID 1288 //
     /*  55073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55102 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3807:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  55102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfd),
     /*  55105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55120 */     GIR_RootConstrainSelectedInstOperands,
     /*  55121 */     // GIR_Coverage, 1288,
     /*  55121 */     GIR_EraseRootFromParent_Done,
     /*  55122 */   // Label 1182: @55122
     /*  55122 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(55176), // Rule ID 1289 //
     /*  55127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55156 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3807:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfq),
     /*  55159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55174 */     GIR_RootConstrainSelectedInstOperands,
     /*  55175 */     // GIR_Coverage, 1289,
     /*  55175 */     GIR_EraseRootFromParent_Done,
     /*  55176 */   // Label 1183: @55176
     /*  55176 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(55230), // Rule ID 1290 //
     /*  55181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55210 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3807:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShd),
     /*  55213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55228 */     GIR_RootConstrainSelectedInstOperands,
     /*  55229 */     // GIR_Coverage, 1290,
     /*  55229 */     GIR_EraseRootFromParent_Done,
     /*  55230 */   // Label 1184: @55230
     /*  55230 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(55284), // Rule ID 1291 //
     /*  55235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55264 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3807:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShq),
     /*  55267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55282 */     GIR_RootConstrainSelectedInstOperands,
     /*  55283 */     // GIR_Coverage, 1291,
     /*  55283 */     GIR_EraseRootFromParent_Done,
     /*  55284 */   // Label 1185: @55284
     /*  55284 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(55338), // Rule ID 1298 //
     /*  55289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55318 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3820:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  55318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfd),
     /*  55321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55336 */     GIR_RootConstrainSelectedInstOperands,
     /*  55337 */     // GIR_Coverage, 1298,
     /*  55337 */     GIR_EraseRootFromParent_Done,
     /*  55338 */   // Label 1186: @55338
     /*  55338 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(55392), // Rule ID 1299 //
     /*  55343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55372 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3820:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfq),
     /*  55375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55390 */     GIR_RootConstrainSelectedInstOperands,
     /*  55391 */     // GIR_Coverage, 1299,
     /*  55391 */     GIR_EraseRootFromParent_Done,
     /*  55392 */   // Label 1187: @55392
     /*  55392 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(55446), // Rule ID 1300 //
     /*  55397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55426 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3820:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShd),
     /*  55429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55444 */     GIR_RootConstrainSelectedInstOperands,
     /*  55445 */     // GIR_Coverage, 1300,
     /*  55445 */     GIR_EraseRootFromParent_Done,
     /*  55446 */   // Label 1188: @55446
     /*  55446 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(55500), // Rule ID 1301 //
     /*  55451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55480 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3820:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShq),
     /*  55483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55498 */     GIR_RootConstrainSelectedInstOperands,
     /*  55499 */     // GIR_Coverage, 1301,
     /*  55499 */     GIR_EraseRootFromParent_Done,
     /*  55500 */   // Label 1189: @55500
     /*  55500 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(55554), // Rule ID 1302 //
     /*  55505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55534 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3823:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i16),
     /*  55537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55552 */     GIR_RootConstrainSelectedInstOperands,
     /*  55553 */     // GIR_Coverage, 1302,
     /*  55553 */     GIR_EraseRootFromParent_Done,
     /*  55554 */   // Label 1190: @55554
     /*  55554 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(55608), // Rule ID 1303 //
     /*  55559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55588 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3823:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i32),
     /*  55591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55606 */     GIR_RootConstrainSelectedInstOperands,
     /*  55607 */     // GIR_Coverage, 1303,
     /*  55607 */     GIR_EraseRootFromParent_Done,
     /*  55608 */   // Label 1191: @55608
     /*  55608 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(55662), // Rule ID 1304 //
     /*  55613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55642 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3823:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i16),
     /*  55645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55660 */     GIR_RootConstrainSelectedInstOperands,
     /*  55661 */     // GIR_Coverage, 1304,
     /*  55661 */     GIR_EraseRootFromParent_Done,
     /*  55662 */   // Label 1192: @55662
     /*  55662 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(55716), // Rule ID 1305 //
     /*  55667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55696 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3823:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i32),
     /*  55699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55714 */     GIR_RootConstrainSelectedInstOperands,
     /*  55715 */     // GIR_Coverage, 1305,
     /*  55715 */     GIR_EraseRootFromParent_Done,
     /*  55716 */   // Label 1193: @55716
     /*  55716 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(55770), // Rule ID 1306 //
     /*  55721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55750 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3823:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i8),
     /*  55753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55768 */     GIR_RootConstrainSelectedInstOperands,
     /*  55769 */     // GIR_Coverage, 1306,
     /*  55769 */     GIR_EraseRootFromParent_Done,
     /*  55770 */   // Label 1194: @55770
     /*  55770 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(55824), // Rule ID 1307 //
     /*  55775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55804 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3823:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv16i8),
     /*  55807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55822 */     GIR_RootConstrainSelectedInstOperands,
     /*  55823 */     // GIR_Coverage, 1307,
     /*  55823 */     GIR_EraseRootFromParent_Done,
     /*  55824 */   // Label 1195: @55824
     /*  55824 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(55878), // Rule ID 1308 //
     /*  55829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55858 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3823:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv1i64),
     /*  55861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55876 */     GIR_RootConstrainSelectedInstOperands,
     /*  55877 */     // GIR_Coverage, 1308,
     /*  55877 */     GIR_EraseRootFromParent_Done,
     /*  55878 */   // Label 1196: @55878
     /*  55878 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(55932), // Rule ID 1309 //
     /*  55883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55912 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3823:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i64),
     /*  55915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55930 */     GIR_RootConstrainSelectedInstOperands,
     /*  55931 */     // GIR_Coverage, 1309,
     /*  55931 */     GIR_EraseRootFromParent_Done,
     /*  55932 */   // Label 1197: @55932
     /*  55932 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(55986), // Rule ID 1310 //
     /*  55937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55966 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3824:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i16),
     /*  55969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55984 */     GIR_RootConstrainSelectedInstOperands,
     /*  55985 */     // GIR_Coverage, 1310,
     /*  55985 */     GIR_EraseRootFromParent_Done,
     /*  55986 */   // Label 1198: @55986
     /*  55986 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(56040), // Rule ID 1311 //
     /*  55991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56020 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3824:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i32),
     /*  56023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56038 */     GIR_RootConstrainSelectedInstOperands,
     /*  56039 */     // GIR_Coverage, 1311,
     /*  56039 */     GIR_EraseRootFromParent_Done,
     /*  56040 */   // Label 1199: @56040
     /*  56040 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(56094), // Rule ID 1312 //
     /*  56045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56074 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3824:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i16),
     /*  56077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56092 */     GIR_RootConstrainSelectedInstOperands,
     /*  56093 */     // GIR_Coverage, 1312,
     /*  56093 */     GIR_EraseRootFromParent_Done,
     /*  56094 */   // Label 1200: @56094
     /*  56094 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(56148), // Rule ID 1313 //
     /*  56099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56128 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3824:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i32),
     /*  56131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56146 */     GIR_RootConstrainSelectedInstOperands,
     /*  56147 */     // GIR_Coverage, 1313,
     /*  56147 */     GIR_EraseRootFromParent_Done,
     /*  56148 */   // Label 1201: @56148
     /*  56148 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(56202), // Rule ID 1314 //
     /*  56153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56182 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3824:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i8),
     /*  56185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56200 */     GIR_RootConstrainSelectedInstOperands,
     /*  56201 */     // GIR_Coverage, 1314,
     /*  56201 */     GIR_EraseRootFromParent_Done,
     /*  56202 */   // Label 1202: @56202
     /*  56202 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(56256), // Rule ID 1315 //
     /*  56207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56236 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3824:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv16i8),
     /*  56239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56254 */     GIR_RootConstrainSelectedInstOperands,
     /*  56255 */     // GIR_Coverage, 1315,
     /*  56255 */     GIR_EraseRootFromParent_Done,
     /*  56256 */   // Label 1203: @56256
     /*  56256 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(56310), // Rule ID 1316 //
     /*  56261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56290 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3824:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv1i64),
     /*  56293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56308 */     GIR_RootConstrainSelectedInstOperands,
     /*  56309 */     // GIR_Coverage, 1316,
     /*  56309 */     GIR_EraseRootFromParent_Done,
     /*  56310 */   // Label 1204: @56310
     /*  56310 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(56364), // Rule ID 1317 //
     /*  56315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56344 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3824:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i64),
     /*  56347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56362 */     GIR_RootConstrainSelectedInstOperands,
     /*  56363 */     // GIR_Coverage, 1317,
     /*  56363 */     GIR_EraseRootFromParent_Done,
     /*  56364 */   // Label 1205: @56364
     /*  56364 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(56418), // Rule ID 1351 //
     /*  56369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56398 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3817:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i16),
     /*  56401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56416 */     GIR_RootConstrainSelectedInstOperands,
     /*  56417 */     // GIR_Coverage, 1351,
     /*  56417 */     GIR_EraseRootFromParent_Done,
     /*  56418 */   // Label 1206: @56418
     /*  56418 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(56472), // Rule ID 1352 //
     /*  56423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56452 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3817:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i32),
     /*  56455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56470 */     GIR_RootConstrainSelectedInstOperands,
     /*  56471 */     // GIR_Coverage, 1352,
     /*  56471 */     GIR_EraseRootFromParent_Done,
     /*  56472 */   // Label 1207: @56472
     /*  56472 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(56526), // Rule ID 1353 //
     /*  56477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56506 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3817:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i16),
     /*  56509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56524 */     GIR_RootConstrainSelectedInstOperands,
     /*  56525 */     // GIR_Coverage, 1353,
     /*  56525 */     GIR_EraseRootFromParent_Done,
     /*  56526 */   // Label 1208: @56526
     /*  56526 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(56580), // Rule ID 1354 //
     /*  56531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56560 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3817:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i32),
     /*  56563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56578 */     GIR_RootConstrainSelectedInstOperands,
     /*  56579 */     // GIR_Coverage, 1354,
     /*  56579 */     GIR_EraseRootFromParent_Done,
     /*  56580 */   // Label 1209: @56580
     /*  56580 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(56634), // Rule ID 1355 //
     /*  56585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56614 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3817:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i8),
     /*  56617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56632 */     GIR_RootConstrainSelectedInstOperands,
     /*  56633 */     // GIR_Coverage, 1355,
     /*  56633 */     GIR_EraseRootFromParent_Done,
     /*  56634 */   // Label 1210: @56634
     /*  56634 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(56688), // Rule ID 1356 //
     /*  56639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56668 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3817:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv16i8),
     /*  56671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56686 */     GIR_RootConstrainSelectedInstOperands,
     /*  56687 */     // GIR_Coverage, 1356,
     /*  56687 */     GIR_EraseRootFromParent_Done,
     /*  56688 */   // Label 1211: @56688
     /*  56688 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(56742), // Rule ID 1357 //
     /*  56693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56722 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3817:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv1i64),
     /*  56725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56740 */     GIR_RootConstrainSelectedInstOperands,
     /*  56741 */     // GIR_Coverage, 1357,
     /*  56741 */     GIR_EraseRootFromParent_Done,
     /*  56742 */   // Label 1212: @56742
     /*  56742 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(56796), // Rule ID 1358 //
     /*  56747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56776 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3817:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i64),
     /*  56779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56794 */     GIR_RootConstrainSelectedInstOperands,
     /*  56795 */     // GIR_Coverage, 1358,
     /*  56795 */     GIR_EraseRootFromParent_Done,
     /*  56796 */   // Label 1213: @56796
     /*  56796 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(56850), // Rule ID 1359 //
     /*  56801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56830 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3818:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i16),
     /*  56833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56848 */     GIR_RootConstrainSelectedInstOperands,
     /*  56849 */     // GIR_Coverage, 1359,
     /*  56849 */     GIR_EraseRootFromParent_Done,
     /*  56850 */   // Label 1214: @56850
     /*  56850 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(56904), // Rule ID 1360 //
     /*  56855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56884 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3818:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i32),
     /*  56887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56902 */     GIR_RootConstrainSelectedInstOperands,
     /*  56903 */     // GIR_Coverage, 1360,
     /*  56903 */     GIR_EraseRootFromParent_Done,
     /*  56904 */   // Label 1215: @56904
     /*  56904 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(56958), // Rule ID 1361 //
     /*  56909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56938 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3818:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i16),
     /*  56941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56956 */     GIR_RootConstrainSelectedInstOperands,
     /*  56957 */     // GIR_Coverage, 1361,
     /*  56957 */     GIR_EraseRootFromParent_Done,
     /*  56958 */   // Label 1216: @56958
     /*  56958 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(57012), // Rule ID 1362 //
     /*  56963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56992 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3818:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i32),
     /*  56995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57010 */     GIR_RootConstrainSelectedInstOperands,
     /*  57011 */     // GIR_Coverage, 1362,
     /*  57011 */     GIR_EraseRootFromParent_Done,
     /*  57012 */   // Label 1217: @57012
     /*  57012 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(57066), // Rule ID 1363 //
     /*  57017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57046 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3818:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i8),
     /*  57049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57064 */     GIR_RootConstrainSelectedInstOperands,
     /*  57065 */     // GIR_Coverage, 1363,
     /*  57065 */     GIR_EraseRootFromParent_Done,
     /*  57066 */   // Label 1218: @57066
     /*  57066 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(57120), // Rule ID 1364 //
     /*  57071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57100 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3818:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv16i8),
     /*  57103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57118 */     GIR_RootConstrainSelectedInstOperands,
     /*  57119 */     // GIR_Coverage, 1364,
     /*  57119 */     GIR_EraseRootFromParent_Done,
     /*  57120 */   // Label 1219: @57120
     /*  57120 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(57174), // Rule ID 1365 //
     /*  57125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57154 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3818:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv1i64),
     /*  57157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57172 */     GIR_RootConstrainSelectedInstOperands,
     /*  57173 */     // GIR_Coverage, 1365,
     /*  57173 */     GIR_EraseRootFromParent_Done,
     /*  57174 */   // Label 1220: @57174
     /*  57174 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(57228), // Rule ID 1366 //
     /*  57179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57208 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3818:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i64),
     /*  57211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57226 */     GIR_RootConstrainSelectedInstOperands,
     /*  57227 */     // GIR_Coverage, 1366,
     /*  57227 */     GIR_EraseRootFromParent_Done,
     /*  57228 */   // Label 1221: @57228
     /*  57228 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(57282), // Rule ID 1386 //
     /*  57233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57262 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3802:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i16),
     /*  57265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57280 */     GIR_RootConstrainSelectedInstOperands,
     /*  57281 */     // GIR_Coverage, 1386,
     /*  57281 */     GIR_EraseRootFromParent_Done,
     /*  57282 */   // Label 1222: @57282
     /*  57282 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(57336), // Rule ID 1387 //
     /*  57287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57316 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3802:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i32),
     /*  57319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57334 */     GIR_RootConstrainSelectedInstOperands,
     /*  57335 */     // GIR_Coverage, 1387,
     /*  57335 */     GIR_EraseRootFromParent_Done,
     /*  57336 */   // Label 1223: @57336
     /*  57336 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(57390), // Rule ID 1388 //
     /*  57341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57370 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3802:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i16),
     /*  57373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57388 */     GIR_RootConstrainSelectedInstOperands,
     /*  57389 */     // GIR_Coverage, 1388,
     /*  57389 */     GIR_EraseRootFromParent_Done,
     /*  57390 */   // Label 1224: @57390
     /*  57390 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(57444), // Rule ID 1389 //
     /*  57395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57424 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3802:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i32),
     /*  57427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57442 */     GIR_RootConstrainSelectedInstOperands,
     /*  57443 */     // GIR_Coverage, 1389,
     /*  57443 */     GIR_EraseRootFromParent_Done,
     /*  57444 */   // Label 1225: @57444
     /*  57444 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(57498), // Rule ID 1390 //
     /*  57449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57478 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3802:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i8),
     /*  57481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57496 */     GIR_RootConstrainSelectedInstOperands,
     /*  57497 */     // GIR_Coverage, 1390,
     /*  57497 */     GIR_EraseRootFromParent_Done,
     /*  57498 */   // Label 1226: @57498
     /*  57498 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(57552), // Rule ID 1391 //
     /*  57503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57532 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3802:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv16i8),
     /*  57535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57550 */     GIR_RootConstrainSelectedInstOperands,
     /*  57551 */     // GIR_Coverage, 1391,
     /*  57551 */     GIR_EraseRootFromParent_Done,
     /*  57552 */   // Label 1227: @57552
     /*  57552 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(57606), // Rule ID 1392 //
     /*  57557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57586 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3802:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv1i64),
     /*  57589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57604 */     GIR_RootConstrainSelectedInstOperands,
     /*  57605 */     // GIR_Coverage, 1392,
     /*  57605 */     GIR_EraseRootFromParent_Done,
     /*  57606 */   // Label 1228: @57606
     /*  57606 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(57660), // Rule ID 1393 //
     /*  57611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57640 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3802:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i64),
     /*  57643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57658 */     GIR_RootConstrainSelectedInstOperands,
     /*  57659 */     // GIR_Coverage, 1393,
     /*  57659 */     GIR_EraseRootFromParent_Done,
     /*  57660 */   // Label 1229: @57660
     /*  57660 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(57714), // Rule ID 1394 //
     /*  57665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57694 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3804:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i16),
     /*  57697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57712 */     GIR_RootConstrainSelectedInstOperands,
     /*  57713 */     // GIR_Coverage, 1394,
     /*  57713 */     GIR_EraseRootFromParent_Done,
     /*  57714 */   // Label 1230: @57714
     /*  57714 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(57768), // Rule ID 1395 //
     /*  57719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57748 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3804:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i32),
     /*  57751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57766 */     GIR_RootConstrainSelectedInstOperands,
     /*  57767 */     // GIR_Coverage, 1395,
     /*  57767 */     GIR_EraseRootFromParent_Done,
     /*  57768 */   // Label 1231: @57768
     /*  57768 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(57822), // Rule ID 1396 //
     /*  57773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57802 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3804:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i16),
     /*  57805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57820 */     GIR_RootConstrainSelectedInstOperands,
     /*  57821 */     // GIR_Coverage, 1396,
     /*  57821 */     GIR_EraseRootFromParent_Done,
     /*  57822 */   // Label 1232: @57822
     /*  57822 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(57876), // Rule ID 1397 //
     /*  57827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57856 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3804:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i32),
     /*  57859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57874 */     GIR_RootConstrainSelectedInstOperands,
     /*  57875 */     // GIR_Coverage, 1397,
     /*  57875 */     GIR_EraseRootFromParent_Done,
     /*  57876 */   // Label 1233: @57876
     /*  57876 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(57930), // Rule ID 1398 //
     /*  57881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57910 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3804:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i8),
     /*  57913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57928 */     GIR_RootConstrainSelectedInstOperands,
     /*  57929 */     // GIR_Coverage, 1398,
     /*  57929 */     GIR_EraseRootFromParent_Done,
     /*  57930 */   // Label 1234: @57930
     /*  57930 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(57984), // Rule ID 1399 //
     /*  57935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57964 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3804:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv16i8),
     /*  57967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57982 */     GIR_RootConstrainSelectedInstOperands,
     /*  57983 */     // GIR_Coverage, 1399,
     /*  57983 */     GIR_EraseRootFromParent_Done,
     /*  57984 */   // Label 1235: @57984
     /*  57984 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(58038), // Rule ID 1400 //
     /*  57989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58018 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3804:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv1i64),
     /*  58021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58036 */     GIR_RootConstrainSelectedInstOperands,
     /*  58037 */     // GIR_Coverage, 1400,
     /*  58037 */     GIR_EraseRootFromParent_Done,
     /*  58038 */   // Label 1236: @58038
     /*  58038 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(58092), // Rule ID 1401 //
     /*  58043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  58051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58072 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3804:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i64),
     /*  58075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58090 */     GIR_RootConstrainSelectedInstOperands,
     /*  58091 */     // GIR_Coverage, 1401,
     /*  58091 */     GIR_EraseRootFromParent_Done,
     /*  58092 */   // Label 1237: @58092
     /*  58092 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(58146), // Rule ID 1435 //
     /*  58097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58126 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3797:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i16),
     /*  58129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58144 */     GIR_RootConstrainSelectedInstOperands,
     /*  58145 */     // GIR_Coverage, 1435,
     /*  58145 */     GIR_EraseRootFromParent_Done,
     /*  58146 */   // Label 1238: @58146
     /*  58146 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(58200), // Rule ID 1436 //
     /*  58151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58180 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3797:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i32),
     /*  58183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58198 */     GIR_RootConstrainSelectedInstOperands,
     /*  58199 */     // GIR_Coverage, 1436,
     /*  58199 */     GIR_EraseRootFromParent_Done,
     /*  58200 */   // Label 1239: @58200
     /*  58200 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(58254), // Rule ID 1437 //
     /*  58205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58234 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3797:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i16),
     /*  58237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58252 */     GIR_RootConstrainSelectedInstOperands,
     /*  58253 */     // GIR_Coverage, 1437,
     /*  58253 */     GIR_EraseRootFromParent_Done,
     /*  58254 */   // Label 1240: @58254
     /*  58254 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(58308), // Rule ID 1438 //
     /*  58259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58288 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3797:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i32),
     /*  58291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58306 */     GIR_RootConstrainSelectedInstOperands,
     /*  58307 */     // GIR_Coverage, 1438,
     /*  58307 */     GIR_EraseRootFromParent_Done,
     /*  58308 */   // Label 1241: @58308
     /*  58308 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(58362), // Rule ID 1439 //
     /*  58313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58342 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3797:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i8),
     /*  58345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58360 */     GIR_RootConstrainSelectedInstOperands,
     /*  58361 */     // GIR_Coverage, 1439,
     /*  58361 */     GIR_EraseRootFromParent_Done,
     /*  58362 */   // Label 1242: @58362
     /*  58362 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(58416), // Rule ID 1440 //
     /*  58367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58396 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3797:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv16i8),
     /*  58399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58414 */     GIR_RootConstrainSelectedInstOperands,
     /*  58415 */     // GIR_Coverage, 1440,
     /*  58415 */     GIR_EraseRootFromParent_Done,
     /*  58416 */   // Label 1243: @58416
     /*  58416 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(58470), // Rule ID 1441 //
     /*  58421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58450 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3797:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv1i64),
     /*  58453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58468 */     GIR_RootConstrainSelectedInstOperands,
     /*  58469 */     // GIR_Coverage, 1441,
     /*  58469 */     GIR_EraseRootFromParent_Done,
     /*  58470 */   // Label 1244: @58470
     /*  58470 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(58524), // Rule ID 1442 //
     /*  58475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58504 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3797:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i64),
     /*  58507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58522 */     GIR_RootConstrainSelectedInstOperands,
     /*  58523 */     // GIR_Coverage, 1442,
     /*  58523 */     GIR_EraseRootFromParent_Done,
     /*  58524 */   // Label 1245: @58524
     /*  58524 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(58578), // Rule ID 1443 //
     /*  58529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58558 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3798:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i16),
     /*  58561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58576 */     GIR_RootConstrainSelectedInstOperands,
     /*  58577 */     // GIR_Coverage, 1443,
     /*  58577 */     GIR_EraseRootFromParent_Done,
     /*  58578 */   // Label 1246: @58578
     /*  58578 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(58632), // Rule ID 1444 //
     /*  58583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58612 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3798:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i32),
     /*  58615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58630 */     GIR_RootConstrainSelectedInstOperands,
     /*  58631 */     // GIR_Coverage, 1444,
     /*  58631 */     GIR_EraseRootFromParent_Done,
     /*  58632 */   // Label 1247: @58632
     /*  58632 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(58686), // Rule ID 1445 //
     /*  58637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58666 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3798:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i16),
     /*  58669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58684 */     GIR_RootConstrainSelectedInstOperands,
     /*  58685 */     // GIR_Coverage, 1445,
     /*  58685 */     GIR_EraseRootFromParent_Done,
     /*  58686 */   // Label 1248: @58686
     /*  58686 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(58740), // Rule ID 1446 //
     /*  58691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58720 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3798:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i32),
     /*  58723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58738 */     GIR_RootConstrainSelectedInstOperands,
     /*  58739 */     // GIR_Coverage, 1446,
     /*  58739 */     GIR_EraseRootFromParent_Done,
     /*  58740 */   // Label 1249: @58740
     /*  58740 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(58794), // Rule ID 1447 //
     /*  58745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58774 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3798:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i8),
     /*  58777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58792 */     GIR_RootConstrainSelectedInstOperands,
     /*  58793 */     // GIR_Coverage, 1447,
     /*  58793 */     GIR_EraseRootFromParent_Done,
     /*  58794 */   // Label 1250: @58794
     /*  58794 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(58848), // Rule ID 1448 //
     /*  58799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58828 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3798:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv16i8),
     /*  58831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58846 */     GIR_RootConstrainSelectedInstOperands,
     /*  58847 */     // GIR_Coverage, 1448,
     /*  58847 */     GIR_EraseRootFromParent_Done,
     /*  58848 */   // Label 1251: @58848
     /*  58848 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(58902), // Rule ID 1449 //
     /*  58853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58882 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3798:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv1i64),
     /*  58885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58900 */     GIR_RootConstrainSelectedInstOperands,
     /*  58901 */     // GIR_Coverage, 1449,
     /*  58901 */     GIR_EraseRootFromParent_Done,
     /*  58902 */   // Label 1252: @58902
     /*  58902 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(58956), // Rule ID 1450 //
     /*  58907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58936 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3798:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i64),
     /*  58939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58954 */     GIR_RootConstrainSelectedInstOperands,
     /*  58955 */     // GIR_Coverage, 1450,
     /*  58955 */     GIR_EraseRootFromParent_Done,
     /*  58956 */   // Label 1253: @58956
     /*  58956 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(59001), // Rule ID 1715 //
     /*  58961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesd),
     /*  58969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58990 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3699:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESD:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESD),
     /*  58993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58995 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58999 */     GIR_RootConstrainSelectedInstOperands,
     /*  59000 */     // GIR_Coverage, 1715,
     /*  59000 */     GIR_EraseRootFromParent_Done,
     /*  59001 */   // Label 1254: @59001
     /*  59001 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(59046), // Rule ID 1716 //
     /*  59006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  59009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aese),
     /*  59014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  59017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  59020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  59023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59035 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESE:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  59035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESE),
     /*  59038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59040 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  59042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  59044 */     GIR_RootConstrainSelectedInstOperands,
     /*  59045 */     // GIR_Coverage, 1716,
     /*  59045 */     GIR_EraseRootFromParent_Done,
     /*  59046 */   // Label 1255: @59046
     /*  59046 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(59091), // Rule ID 1719 //
     /*  59051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  59054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su1),
     /*  59059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  59062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  59065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  59068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59080 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3713:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  59080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU1),
     /*  59083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59085 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  59087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  59089 */     GIR_RootConstrainSelectedInstOperands,
     /*  59090 */     // GIR_Coverage, 1719,
     /*  59090 */     GIR_EraseRootFromParent_Done,
     /*  59091 */   // Label 1256: @59091
     /*  59091 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(59136), // Rule ID 1720 //
     /*  59096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  59099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su0),
     /*  59104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  59107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  59110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  59113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59125 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3716:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  59125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU0),
     /*  59128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  59132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  59134 */     GIR_RootConstrainSelectedInstOperands,
     /*  59135 */     // GIR_Coverage, 1720,
     /*  59135 */     GIR_EraseRootFromParent_Done,
     /*  59136 */   // Label 1257: @59136
     /*  59136 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(59190), // Rule ID 1729 //
     /*  59141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqrshr),
     /*  59149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59170 */     // (intrinsic_wo_chain:{ *:[i32] } 3561:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_SQRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQRSHR),
     /*  59173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59175 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59188 */     GIR_RootConstrainSelectedInstOperands,
     /*  59189 */     // GIR_Coverage, 1729,
     /*  59189 */     GIR_EraseRootFromParent_Done,
     /*  59190 */   // Label 1258: @59190
     /*  59190 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(59244), // Rule ID 1730 //
     /*  59195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqrshl),
     /*  59203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59224 */     // (intrinsic_wo_chain:{ *:[i32] } 3568:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_UQRSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQRSHL),
     /*  59227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59229 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59242 */     GIR_RootConstrainSelectedInstOperands,
     /*  59243 */     // GIR_Coverage, 1730,
     /*  59243 */     GIR_EraseRootFromParent_Done,
     /*  59244 */   // Label 1259: @59244
     /*  59244 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(59301), // Rule ID 1853 //
     /*  59249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59278 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (SXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB16),
     /*  59281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59283 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59285 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59299 */     GIR_RootConstrainSelectedInstOperands,
     /*  59300 */     // GIR_Coverage, 1853,
     /*  59300 */     GIR_EraseRootFromParent_Done,
     /*  59301 */   // Label 1260: @59301
     /*  59301 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(59358), // Rule ID 1860 //
     /*  59306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  59314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59335 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (UXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB16),
     /*  59338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59340 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59342 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59356 */     GIR_RootConstrainSelectedInstOperands,
     /*  59357 */     // GIR_Coverage, 1860,
     /*  59357 */     GIR_EraseRootFromParent_Done,
     /*  59358 */   // Label 1261: @59358
     /*  59358 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(59412), // Rule ID 1907 //
     /*  59363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  59371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59392 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUAD),
     /*  59395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59410 */     GIR_RootConstrainSelectedInstOperands,
     /*  59411 */     // GIR_Coverage, 1907,
     /*  59411 */     GIR_EraseRootFromParent_Done,
     /*  59412 */   // Label 1262: @59412
     /*  59412 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(59466), // Rule ID 1908 //
     /*  59417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  59425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59446 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUADX),
     /*  59449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59464 */     GIR_RootConstrainSelectedInstOperands,
     /*  59465 */     // GIR_Coverage, 1908,
     /*  59465 */     GIR_EraseRootFromParent_Done,
     /*  59466 */   // Label 1263: @59466
     /*  59466 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(59520), // Rule ID 1909 //
     /*  59471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  59479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59500 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSD),
     /*  59503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59518 */     GIR_RootConstrainSelectedInstOperands,
     /*  59519 */     // GIR_Coverage, 1909,
     /*  59519 */     GIR_EraseRootFromParent_Done,
     /*  59520 */   // Label 1264: @59520
     /*  59520 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(59574), // Rule ID 1910 //
     /*  59525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  59533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59554 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSDX),
     /*  59557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59572 */     GIR_RootConstrainSelectedInstOperands,
     /*  59573 */     // GIR_Coverage, 1910,
     /*  59573 */     GIR_EraseRootFromParent_Done,
     /*  59574 */   // Label 1265: @59574
     /*  59574 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(59628), // Rule ID 1984 //
     /*  59579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59608 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  59611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59613 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59615 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59626 */     GIR_RootConstrainSelectedInstOperands,
     /*  59627 */     // GIR_Coverage, 1984,
     /*  59627 */     GIR_EraseRootFromParent_Done,
     /*  59628 */   // Label 1266: @59628
     /*  59628 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(59682), // Rule ID 1985 //
     /*  59633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59662 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  59665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59667 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59669 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59680 */     GIR_RootConstrainSelectedInstOperands,
     /*  59681 */     // GIR_Coverage, 1985,
     /*  59681 */     GIR_EraseRootFromParent_Done,
     /*  59682 */   // Label 1267: @59682
     /*  59682 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(59736), // Rule ID 1986 //
     /*  59687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59716 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  59719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59721 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59723 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59734 */     GIR_RootConstrainSelectedInstOperands,
     /*  59735 */     // GIR_Coverage, 1986,
     /*  59735 */     GIR_EraseRootFromParent_Done,
     /*  59736 */   // Label 1268: @59736
     /*  59736 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(59790), // Rule ID 1987 //
     /*  59741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59770 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  59773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59775 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59777 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59788 */     GIR_RootConstrainSelectedInstOperands,
     /*  59789 */     // GIR_Coverage, 1987,
     /*  59789 */     GIR_EraseRootFromParent_Done,
     /*  59790 */   // Label 1269: @59790
     /*  59790 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(59844), // Rule ID 1988 //
     /*  59795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59824 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWB),
     /*  59827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59829 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59831 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59842 */     GIR_RootConstrainSelectedInstOperands,
     /*  59843 */     // GIR_Coverage, 1988,
     /*  59843 */     GIR_EraseRootFromParent_Done,
     /*  59844 */   // Label 1270: @59844
     /*  59844 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(59898), // Rule ID 1989 //
     /*  59849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59878 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWT),
     /*  59881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59883 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59885 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59896 */     GIR_RootConstrainSelectedInstOperands,
     /*  59897 */     // GIR_Coverage, 1989,
     /*  59897 */     GIR_EraseRootFromParent_Done,
     /*  59898 */   // Label 1271: @59898
     /*  59898 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(59955), // Rule ID 2100 //
     /*  59903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59932 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  59932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB16),
     /*  59935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59953 */     GIR_RootConstrainSelectedInstOperands,
     /*  59954 */     // GIR_Coverage, 2100,
     /*  59954 */     GIR_EraseRootFromParent_Done,
     /*  59955 */   // Label 1272: @59955
     /*  59955 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(60009), // Rule ID 2130 //
     /*  59960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  59968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59989 */     // (intrinsic_wo_chain:{ *:[i32] } 3843:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /*  59992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60007 */     GIR_RootConstrainSelectedInstOperands,
     /*  60008 */     // GIR_Coverage, 2130,
     /*  60008 */     GIR_EraseRootFromParent_Done,
     /*  60009 */   // Label 1273: @60009
     /*  60009 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(60063), // Rule ID 2131 //
     /*  60014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  60022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60043 */     // (intrinsic_wo_chain:{ *:[i32] } 3848:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  60043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /*  60046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  60050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  60052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60061 */     GIR_RootConstrainSelectedInstOperands,
     /*  60062 */     // GIR_Coverage, 2131,
     /*  60062 */     GIR_EraseRootFromParent_Done,
     /*  60063 */   // Label 1274: @60063
     /*  60063 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(60117), // Rule ID 2171 //
     /*  60068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  60076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60097 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  60100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60115 */     GIR_RootConstrainSelectedInstOperands,
     /*  60116 */     // GIR_Coverage, 2171,
     /*  60116 */     GIR_EraseRootFromParent_Done,
     /*  60117 */   // Label 1275: @60117
     /*  60117 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(60171), // Rule ID 2172 //
     /*  60122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  60130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60151 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  60154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60169 */     GIR_RootConstrainSelectedInstOperands,
     /*  60170 */     // GIR_Coverage, 2172,
     /*  60170 */     GIR_EraseRootFromParent_Done,
     /*  60171 */   // Label 1276: @60171
     /*  60171 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(60225), // Rule ID 2173 //
     /*  60176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  60184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60205 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  60208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60223 */     GIR_RootConstrainSelectedInstOperands,
     /*  60224 */     // GIR_Coverage, 2173,
     /*  60224 */     GIR_EraseRootFromParent_Done,
     /*  60225 */   // Label 1277: @60225
     /*  60225 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(60279), // Rule ID 2174 //
     /*  60230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  60238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60259 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  60262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60271 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60277 */     GIR_RootConstrainSelectedInstOperands,
     /*  60278 */     // GIR_Coverage, 2174,
     /*  60278 */     GIR_EraseRootFromParent_Done,
     /*  60279 */   // Label 1278: @60279
     /*  60279 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(60333), // Rule ID 2175 //
     /*  60284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  60292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60313 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWB),
     /*  60316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60331 */     GIR_RootConstrainSelectedInstOperands,
     /*  60332 */     // GIR_Coverage, 2175,
     /*  60332 */     GIR_EraseRootFromParent_Done,
     /*  60333 */   // Label 1279: @60333
     /*  60333 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(60387), // Rule ID 2176 //
     /*  60338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  60346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60367 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWT),
     /*  60370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60385 */     GIR_RootConstrainSelectedInstOperands,
     /*  60386 */     // GIR_Coverage, 2176,
     /*  60386 */     GIR_EraseRootFromParent_Done,
     /*  60387 */   // Label 1280: @60387
     /*  60387 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(60435), // Rule ID 2513 //
     /*  60392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60421 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3730:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /*  60421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60433 */     GIR_RootConstrainSelectedInstOperands,
     /*  60434 */     // GIR_Coverage, 2513,
     /*  60434 */     GIR_EraseRootFromParent_Done,
     /*  60435 */   // Label 1281: @60435
     /*  60435 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(60483), // Rule ID 2514 //
     /*  60440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60469 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3729:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /*  60469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60481 */     GIR_RootConstrainSelectedInstOperands,
     /*  60482 */     // GIR_Coverage, 2514,
     /*  60482 */     GIR_EraseRootFromParent_Done,
     /*  60483 */   // Label 1282: @60483
     /*  60483 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(60531), // Rule ID 2515 //
     /*  60488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60517 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3730:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /*  60517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60529 */     GIR_RootConstrainSelectedInstOperands,
     /*  60530 */     // GIR_Coverage, 2515,
     /*  60530 */     GIR_EraseRootFromParent_Done,
     /*  60531 */   // Label 1283: @60531
     /*  60531 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(60579), // Rule ID 2516 //
     /*  60536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60565 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3729:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /*  60565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60577 */     GIR_RootConstrainSelectedInstOperands,
     /*  60578 */     // GIR_Coverage, 2516,
     /*  60578 */     GIR_EraseRootFromParent_Done,
     /*  60579 */   // Label 1284: @60579
     /*  60579 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(60627), // Rule ID 2517 //
     /*  60584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60613 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3730:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /*  60613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60625 */     GIR_RootConstrainSelectedInstOperands,
     /*  60626 */     // GIR_Coverage, 2517,
     /*  60626 */     GIR_EraseRootFromParent_Done,
     /*  60627 */   // Label 1285: @60627
     /*  60627 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(60675), // Rule ID 2518 //
     /*  60632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60661 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3729:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /*  60661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60673 */     GIR_RootConstrainSelectedInstOperands,
     /*  60674 */     // GIR_Coverage, 2518,
     /*  60674 */     GIR_EraseRootFromParent_Done,
     /*  60675 */   // Label 1286: @60675
     /*  60675 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(60723), // Rule ID 2519 //
     /*  60680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60709 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3730:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /*  60709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60721 */     GIR_RootConstrainSelectedInstOperands,
     /*  60722 */     // GIR_Coverage, 2519,
     /*  60722 */     GIR_EraseRootFromParent_Done,
     /*  60723 */   // Label 1287: @60723
     /*  60723 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(60771), // Rule ID 2520 //
     /*  60728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60757 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3729:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /*  60757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60769 */     GIR_RootConstrainSelectedInstOperands,
     /*  60770 */     // GIR_Coverage, 2520,
     /*  60770 */     GIR_EraseRootFromParent_Done,
     /*  60771 */   // Label 1288: @60771
     /*  60771 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(60876), // Rule ID 3105 //
     /*  60776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60805 */     // (intrinsic_wo_chain:{ *:[f32] } 3537:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60805 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60808 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60812 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60817 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60821 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf32),
     /*  60833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60838 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60845 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60848 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60854 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60875 */     // GIR_Coverage, 3105,
     /*  60875 */     GIR_EraseRootFromParent_Done,
     /*  60876 */   // Label 1289: @60876
     /*  60876 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(60981), // Rule ID 3107 //
     /*  60881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60910 */     // (intrinsic_wo_chain:{ *:[f16] } 3537:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60922 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60926 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf16),
     /*  60938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60943 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60950 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60953 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60959 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60980 */     // GIR_Coverage, 3107,
     /*  60980 */     GIR_EraseRootFromParent_Done,
     /*  60981 */   // Label 1290: @60981
     /*  60981 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(61086), // Rule ID 3109 //
     /*  60986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61015 */     // (intrinsic_wo_chain:{ *:[f32] } 3528:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61015 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61018 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61022 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61027 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf32),
     /*  61043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61048 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61051 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61055 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61058 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61064 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61085 */     // GIR_Coverage, 3109,
     /*  61085 */     GIR_EraseRootFromParent_Done,
     /*  61086 */   // Label 1291: @61086
     /*  61086 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(61191), // Rule ID 3111 //
     /*  61091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  61099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61120 */     // (intrinsic_wo_chain:{ *:[f16] } 3528:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61120 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61123 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61127 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61132 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61136 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf16),
     /*  61148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61153 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61160 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61163 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61169 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61190 */     // GIR_Coverage, 3111,
     /*  61190 */     GIR_EraseRootFromParent_Done,
     /*  61191 */   // Label 1292: @61191
     /*  61191 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(61296), // Rule ID 3113 //
     /*  61196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61225 */     // (intrinsic_wo_chain:{ *:[f32] } 3535:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61225 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61228 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61232 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61237 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61241 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf32),
     /*  61253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61258 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61268 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61274 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61295 */     // GIR_Coverage, 3113,
     /*  61295 */     GIR_EraseRootFromParent_Done,
     /*  61296 */   // Label 1293: @61296
     /*  61296 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(61401), // Rule ID 3115 //
     /*  61301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61330 */     // (intrinsic_wo_chain:{ *:[f16] } 3535:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61342 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf16),
     /*  61358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61370 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61373 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61379 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61400 */     // GIR_Coverage, 3115,
     /*  61400 */     GIR_EraseRootFromParent_Done,
     /*  61401 */   // Label 1294: @61401
     /*  61401 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(61506), // Rule ID 3117 //
     /*  61406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61435 */     // (intrinsic_wo_chain:{ *:[f32] } 3526:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61435 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61438 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61442 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61447 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61451 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf32),
     /*  61463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61468 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61475 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61478 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61484 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61505 */     // GIR_Coverage, 3117,
     /*  61505 */     GIR_EraseRootFromParent_Done,
     /*  61506 */   // Label 1295: @61506
     /*  61506 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(61611), // Rule ID 3119 //
     /*  61511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61540 */     // (intrinsic_wo_chain:{ *:[f16] } 3526:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61540 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61543 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61547 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf16),
     /*  61568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61583 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61589 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61610 */     // GIR_Coverage, 3119,
     /*  61610 */     GIR_EraseRootFromParent_Done,
     /*  61611 */   // Label 1296: @61611
     /*  61611 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(61671), // Rule ID 3169 //
     /*  61616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61645 */     // (intrinsic_wo_chain:{ *:[i32] } 3533:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMINAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs8),
     /*  61648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61650 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61652 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61669 */     GIR_RootConstrainSelectedInstOperands,
     /*  61670 */     // GIR_Coverage, 3169,
     /*  61670 */     GIR_EraseRootFromParent_Done,
     /*  61671 */   // Label 1297: @61671
     /*  61671 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(61731), // Rule ID 3171 //
     /*  61676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61705 */     // (intrinsic_wo_chain:{ *:[i32] } 3533:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMINAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs16),
     /*  61708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61710 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61712 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61729 */     GIR_RootConstrainSelectedInstOperands,
     /*  61730 */     // GIR_Coverage, 3171,
     /*  61730 */     GIR_EraseRootFromParent_Done,
     /*  61731 */   // Label 1298: @61731
     /*  61731 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(61791), // Rule ID 3173 //
     /*  61736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61765 */     // (intrinsic_wo_chain:{ *:[i32] } 3533:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMINAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs32),
     /*  61768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61770 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61772 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61789 */     GIR_RootConstrainSelectedInstOperands,
     /*  61790 */     // GIR_Coverage, 3173,
     /*  61790 */     GIR_EraseRootFromParent_Done,
     /*  61791 */   // Label 1299: @61791
     /*  61791 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(61851), // Rule ID 3175 //
     /*  61796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61825 */     // (intrinsic_wo_chain:{ *:[i32] } 3524:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMAXAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs8),
     /*  61828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61830 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61832 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61849 */     GIR_RootConstrainSelectedInstOperands,
     /*  61850 */     // GIR_Coverage, 3175,
     /*  61850 */     GIR_EraseRootFromParent_Done,
     /*  61851 */   // Label 1300: @61851
     /*  61851 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(61911), // Rule ID 3177 //
     /*  61856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61885 */     // (intrinsic_wo_chain:{ *:[i32] } 3524:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMAXAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs16),
     /*  61888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61890 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61892 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61909 */     GIR_RootConstrainSelectedInstOperands,
     /*  61910 */     // GIR_Coverage, 3177,
     /*  61910 */     GIR_EraseRootFromParent_Done,
     /*  61911 */   // Label 1301: @61911
     /*  61911 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(61971), // Rule ID 3179 //
     /*  61916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61945 */     // (intrinsic_wo_chain:{ *:[i32] } 3524:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMAXAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs32),
     /*  61948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61950 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61952 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61969 */     GIR_RootConstrainSelectedInstOperands,
     /*  61970 */     // GIR_Coverage, 3179,
     /*  61970 */     GIR_EraseRootFromParent_Done,
     /*  61971 */   // Label 1302: @61971
     /*  61971 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(62046), // Rule ID 3470 //
     /*  61976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62005 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3646:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  62005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi8),
     /*  62020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62029 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62044 */     GIR_RootConstrainSelectedInstOperands,
     /*  62045 */     // GIR_Coverage, 3470,
     /*  62045 */     GIR_EraseRootFromParent_Done,
     /*  62046 */   // Label 1303: @62046
     /*  62046 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(62121), // Rule ID 3477 //
     /*  62051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  62059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  62068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62080 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3646:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  62080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi16),
     /*  62095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62119 */     GIR_RootConstrainSelectedInstOperands,
     /*  62120 */     // GIR_Coverage, 3477,
     /*  62120 */     GIR_EraseRootFromParent_Done,
     /*  62121 */   // Label 1304: @62121
     /*  62121 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(62196), // Rule ID 3481 //
     /*  62126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  62134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62155 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3646:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi32),
     /*  62170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62194 */     GIR_RootConstrainSelectedInstOperands,
     /*  62195 */     // GIR_Coverage, 3481,
     /*  62195 */     GIR_EraseRootFromParent_Done,
     /*  62196 */   // Label 1305: @62196
     /*  62196 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(62271), // Rule ID 3483 //
     /*  62201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  62218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62230 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3655:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQRDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  62230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi8),
     /*  62245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62269 */     GIR_RootConstrainSelectedInstOperands,
     /*  62270 */     // GIR_Coverage, 3483,
     /*  62270 */     GIR_EraseRootFromParent_Done,
     /*  62271 */   // Label 1306: @62271
     /*  62271 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(62346), // Rule ID 3485 //
     /*  62276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  62293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62305 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3655:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQRDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  62305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi16),
     /*  62320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62344 */     GIR_RootConstrainSelectedInstOperands,
     /*  62345 */     // GIR_Coverage, 3485,
     /*  62345 */     GIR_EraseRootFromParent_Done,
     /*  62346 */   // Label 1307: @62346
     /*  62346 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(62421), // Rule ID 3487 //
     /*  62351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62380 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3655:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQRDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi32),
     /*  62395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62419 */     GIR_RootConstrainSelectedInstOperands,
     /*  62420 */     // GIR_Coverage, 3487,
     /*  62420 */     GIR_EraseRootFromParent_Done,
     /*  62421 */   // Label 1308: @62421
     /*  62421 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(62496), // Rule ID 4755 //
     /*  62426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62455 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3579:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /*  62470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62494 */     GIR_RootConstrainSelectedInstOperands,
     /*  62495 */     // GIR_Coverage, 4755,
     /*  62495 */     GIR_EraseRootFromParent_Done,
     /*  62496 */   // Label 1309: @62496
     /*  62496 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(62571), // Rule ID 4760 //
     /*  62501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62530 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3579:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62569 */     GIR_RootConstrainSelectedInstOperands,
     /*  62570 */     // GIR_Coverage, 4760,
     /*  62570 */     GIR_EraseRootFromParent_Done,
     /*  62571 */   // Label 1310: @62571
     /*  62571 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(62646), // Rule ID 4762 //
     /*  62576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62605 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3579:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62644 */     GIR_RootConstrainSelectedInstOperands,
     /*  62645 */     // GIR_Coverage, 4762,
     /*  62645 */     GIR_EraseRootFromParent_Done,
     /*  62646 */   // Label 1311: @62646
     /*  62646 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(62721), // Rule ID 4764 //
     /*  62651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62680 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3579:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62719 */     GIR_RootConstrainSelectedInstOperands,
     /*  62720 */     // GIR_Coverage, 4764,
     /*  62720 */     GIR_EraseRootFromParent_Done,
     /*  62721 */   // Label 1312: @62721
     /*  62721 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(62796), // Rule ID 4766 //
     /*  62726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62755 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3579:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62794 */     GIR_RootConstrainSelectedInstOperands,
     /*  62795 */     // GIR_Coverage, 4766,
     /*  62795 */     GIR_EraseRootFromParent_Done,
     /*  62796 */   // Label 1313: @62796
     /*  62796 */   GIM_Reject,
     /*  62797 */ // Label 958: @62797
     /*  62797 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(73720),
     /*  62802 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  62805 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(62895), // Rule ID 3916 //
     /*  62810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62847 */     // MIs[1] Operand 1
     /*  62847 */     // No operand predicates
     /*  62847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62853 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3656:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms8),
     /*  62868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62870 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62893 */     GIR_RootConstrainSelectedInstOperands,
     /*  62894 */     // GIR_Coverage, 3916,
     /*  62894 */     GIR_EraseRootFromParent_Done,
     /*  62895 */   // Label 1315: @62895
     /*  62895 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(62985), // Rule ID 3918 //
     /*  62900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62937 */     // MIs[1] Operand 1
     /*  62937 */     // No operand predicates
     /*  62937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62943 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3656:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu8),
     /*  62958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62983 */     GIR_RootConstrainSelectedInstOperands,
     /*  62984 */     // GIR_Coverage, 3918,
     /*  62984 */     GIR_EraseRootFromParent_Done,
     /*  62985 */   // Label 1316: @62985
     /*  62985 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(63075), // Rule ID 3920 //
     /*  62990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  63027 */     // MIs[1] Operand 1
     /*  63027 */     // No operand predicates
     /*  63027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63033 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3656:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  63033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms16),
     /*  63048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63050 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63073 */     GIR_RootConstrainSelectedInstOperands,
     /*  63074 */     // GIR_Coverage, 3920,
     /*  63074 */     GIR_EraseRootFromParent_Done,
     /*  63075 */   // Label 1317: @63075
     /*  63075 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(63165), // Rule ID 3922 //
     /*  63080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  63117 */     // MIs[1] Operand 1
     /*  63117 */     // No operand predicates
     /*  63117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63123 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3656:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  63123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu16),
     /*  63138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63140 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63163 */     GIR_RootConstrainSelectedInstOperands,
     /*  63164 */     // GIR_Coverage, 3922,
     /*  63164 */     GIR_EraseRootFromParent_Done,
     /*  63165 */   // Label 1318: @63165
     /*  63165 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(63255), // Rule ID 3924 //
     /*  63170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63207 */     // MIs[1] Operand 1
     /*  63207 */     // No operand predicates
     /*  63207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63213 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3656:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms32),
     /*  63228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63230 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63253 */     GIR_RootConstrainSelectedInstOperands,
     /*  63254 */     // GIR_Coverage, 3924,
     /*  63254 */     GIR_EraseRootFromParent_Done,
     /*  63255 */   // Label 1319: @63255
     /*  63255 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(63345), // Rule ID 3926 //
     /*  63260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63297 */     // MIs[1] Operand 1
     /*  63297 */     // No operand predicates
     /*  63297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63303 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3656:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu32),
     /*  63318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63320 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63343 */     GIR_RootConstrainSelectedInstOperands,
     /*  63344 */     // GIR_Coverage, 3926,
     /*  63344 */     GIR_EraseRootFromParent_Done,
     /*  63345 */   // Label 1320: @63345
     /*  63345 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(63435), // Rule ID 3934 //
     /*  63350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63387 */     // MIs[1] Operand 1
     /*  63387 */     // No operand predicates
     /*  63387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63393 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms8),
     /*  63408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63410 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63433 */     GIR_RootConstrainSelectedInstOperands,
     /*  63434 */     // GIR_Coverage, 3934,
     /*  63434 */     GIR_EraseRootFromParent_Done,
     /*  63435 */   // Label 1321: @63435
     /*  63435 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(63525), // Rule ID 3936 //
     /*  63440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63477 */     // MIs[1] Operand 1
     /*  63477 */     // No operand predicates
     /*  63477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63483 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu8),
     /*  63498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63500 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63523 */     GIR_RootConstrainSelectedInstOperands,
     /*  63524 */     // GIR_Coverage, 3936,
     /*  63524 */     GIR_EraseRootFromParent_Done,
     /*  63525 */   // Label 1322: @63525
     /*  63525 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(63615), // Rule ID 3938 //
     /*  63530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63567 */     // MIs[1] Operand 1
     /*  63567 */     // No operand predicates
     /*  63567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63573 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms16),
     /*  63588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63590 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63613 */     GIR_RootConstrainSelectedInstOperands,
     /*  63614 */     // GIR_Coverage, 3938,
     /*  63614 */     GIR_EraseRootFromParent_Done,
     /*  63615 */   // Label 1323: @63615
     /*  63615 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(63705), // Rule ID 3940 //
     /*  63620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63657 */     // MIs[1] Operand 1
     /*  63657 */     // No operand predicates
     /*  63657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63663 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu16),
     /*  63678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63680 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63703 */     GIR_RootConstrainSelectedInstOperands,
     /*  63704 */     // GIR_Coverage, 3940,
     /*  63704 */     GIR_EraseRootFromParent_Done,
     /*  63705 */   // Label 1324: @63705
     /*  63705 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(63795), // Rule ID 3942 //
     /*  63710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63747 */     // MIs[1] Operand 1
     /*  63747 */     // No operand predicates
     /*  63747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63753 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3673:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms32),
     /*  63768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63770 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63793 */     GIR_RootConstrainSelectedInstOperands,
     /*  63794 */     // GIR_Coverage, 3942,
     /*  63794 */     GIR_EraseRootFromParent_Done,
     /*  63795 */   // Label 1325: @63795
     /*  63795 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(63885), // Rule ID 3944 //
     /*  63800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63837 */     // MIs[1] Operand 1
     /*  63837 */     // No operand predicates
     /*  63837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63843 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3673:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu32),
     /*  63858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63883 */     GIR_RootConstrainSelectedInstOperands,
     /*  63884 */     // GIR_Coverage, 3944,
     /*  63884 */     GIR_EraseRootFromParent_Done,
     /*  63885 */   // Label 1326: @63885
     /*  63885 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(63974), // Rule ID 4042 //
     /*  63890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63930 */     // MIs[1] Operand 1
     /*  63930 */     // No operand predicates
     /*  63930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63932 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3592:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16s16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16_fix),
     /*  63947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63972 */     GIR_RootConstrainSelectedInstOperands,
     /*  63973 */     // GIR_Coverage, 4042,
     /*  63973 */     GIR_EraseRootFromParent_Done,
     /*  63974 */   // Label 1327: @63974
     /*  63974 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(64063), // Rule ID 4044 //
     /*  63979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64019 */     // MIs[1] Operand 1
     /*  64019 */     // No operand predicates
     /*  64019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64021 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3592:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16_fix),
     /*  64036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64061 */     GIR_RootConstrainSelectedInstOperands,
     /*  64062 */     // GIR_Coverage, 4044,
     /*  64062 */     GIR_EraseRootFromParent_Done,
     /*  64063 */   // Label 1328: @64063
     /*  64063 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(64152), // Rule ID 4046 //
     /*  64068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64108 */     // MIs[1] Operand 1
     /*  64108 */     // No operand predicates
     /*  64108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64110 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3592:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16u16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16_fix),
     /*  64125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64150 */     GIR_RootConstrainSelectedInstOperands,
     /*  64151 */     // GIR_Coverage, 4046,
     /*  64151 */     GIR_EraseRootFromParent_Done,
     /*  64152 */   // Label 1329: @64152
     /*  64152 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(64241), // Rule ID 4048 //
     /*  64157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64197 */     // MIs[1] Operand 1
     /*  64197 */     // No operand predicates
     /*  64197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64199 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3592:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16_fix),
     /*  64214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64239 */     GIR_RootConstrainSelectedInstOperands,
     /*  64240 */     // GIR_Coverage, 4048,
     /*  64240 */     GIR_EraseRootFromParent_Done,
     /*  64241 */   // Label 1330: @64241
     /*  64241 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(64330), // Rule ID 4050 //
     /*  64246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64286 */     // MIs[1] Operand 1
     /*  64286 */     // No operand predicates
     /*  64286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64288 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3592:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32s32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32_fix),
     /*  64303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64328 */     GIR_RootConstrainSelectedInstOperands,
     /*  64329 */     // GIR_Coverage, 4050,
     /*  64329 */     GIR_EraseRootFromParent_Done,
     /*  64330 */   // Label 1331: @64330
     /*  64330 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(64419), // Rule ID 4052 //
     /*  64335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64375 */     // MIs[1] Operand 1
     /*  64375 */     // No operand predicates
     /*  64375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64377 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3592:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32_fix),
     /*  64392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64417 */     GIR_RootConstrainSelectedInstOperands,
     /*  64418 */     // GIR_Coverage, 4052,
     /*  64418 */     GIR_EraseRootFromParent_Done,
     /*  64419 */   // Label 1332: @64419
     /*  64419 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(64508), // Rule ID 4054 //
     /*  64424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64464 */     // MIs[1] Operand 1
     /*  64464 */     // No operand predicates
     /*  64464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64466 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3592:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32u32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32_fix),
     /*  64481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64497 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64506 */     GIR_RootConstrainSelectedInstOperands,
     /*  64507 */     // GIR_Coverage, 4054,
     /*  64507 */     GIR_EraseRootFromParent_Done,
     /*  64508 */   // Label 1333: @64508
     /*  64508 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(64597), // Rule ID 4056 //
     /*  64513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64553 */     // MIs[1] Operand 1
     /*  64553 */     // No operand predicates
     /*  64553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64555 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3592:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32_fix),
     /*  64570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64595 */     GIR_RootConstrainSelectedInstOperands,
     /*  64596 */     // GIR_Coverage, 4056,
     /*  64596 */     GIR_EraseRootFromParent_Done,
     /*  64597 */   // Label 1334: @64597
     /*  64597 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(64664), // Rule ID 3121 //
     /*  64602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64638 */     // (intrinsic_wo_chain:{ *:[i32] } 3539:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /*  64641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64643 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64645 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64662 */     GIR_RootConstrainSelectedInstOperands,
     /*  64663 */     // GIR_Coverage, 3121,
     /*  64663 */     GIR_EraseRootFromParent_Done,
     /*  64664 */   // Label 1335: @64664
     /*  64664 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(64731), // Rule ID 3123 //
     /*  64669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64705 */     // (intrinsic_wo_chain:{ *:[i32] } 3539:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /*  64708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64710 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64712 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64729 */     GIR_RootConstrainSelectedInstOperands,
     /*  64730 */     // GIR_Coverage, 3123,
     /*  64730 */     GIR_EraseRootFromParent_Done,
     /*  64731 */   // Label 1336: @64731
     /*  64731 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(64798), // Rule ID 3125 //
     /*  64736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64772 */     // (intrinsic_wo_chain:{ *:[i32] } 3539:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /*  64775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64777 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64779 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64796 */     GIR_RootConstrainSelectedInstOperands,
     /*  64797 */     // GIR_Coverage, 3125,
     /*  64797 */     GIR_EraseRootFromParent_Done,
     /*  64798 */   // Label 1337: @64798
     /*  64798 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(64865), // Rule ID 3127 //
     /*  64803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64839 */     // (intrinsic_wo_chain:{ *:[i32] } 3539:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /*  64842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64844 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64846 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64863 */     GIR_RootConstrainSelectedInstOperands,
     /*  64864 */     // GIR_Coverage, 3127,
     /*  64864 */     GIR_EraseRootFromParent_Done,
     /*  64865 */   // Label 1338: @64865
     /*  64865 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(64932), // Rule ID 3129 //
     /*  64870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64906 */     // (intrinsic_wo_chain:{ *:[i32] } 3539:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /*  64909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64911 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64913 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64930 */     GIR_RootConstrainSelectedInstOperands,
     /*  64931 */     // GIR_Coverage, 3129,
     /*  64931 */     GIR_EraseRootFromParent_Done,
     /*  64932 */   // Label 1339: @64932
     /*  64932 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(64999), // Rule ID 3131 //
     /*  64937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64973 */     // (intrinsic_wo_chain:{ *:[i32] } 3539:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /*  64976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64978 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64980 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64997 */     GIR_RootConstrainSelectedInstOperands,
     /*  64998 */     // GIR_Coverage, 3131,
     /*  64998 */     GIR_EraseRootFromParent_Done,
     /*  64999 */   // Label 1340: @64999
     /*  64999 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(65066), // Rule ID 3133 //
     /*  65004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65040 */     // (intrinsic_wo_chain:{ *:[i32] } 3530:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  65040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /*  65043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65045 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65047 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65064 */     GIR_RootConstrainSelectedInstOperands,
     /*  65065 */     // GIR_Coverage, 3133,
     /*  65065 */     GIR_EraseRootFromParent_Done,
     /*  65066 */   // Label 1341: @65066
     /*  65066 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(65133), // Rule ID 3135 //
     /*  65071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65107 */     // (intrinsic_wo_chain:{ *:[i32] } 3530:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  65107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /*  65110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65112 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65114 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65131 */     GIR_RootConstrainSelectedInstOperands,
     /*  65132 */     // GIR_Coverage, 3135,
     /*  65132 */     GIR_EraseRootFromParent_Done,
     /*  65133 */   // Label 1342: @65133
     /*  65133 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(65200), // Rule ID 3137 //
     /*  65138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65174 */     // (intrinsic_wo_chain:{ *:[i32] } 3530:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /*  65177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65179 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65181 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65198 */     GIR_RootConstrainSelectedInstOperands,
     /*  65199 */     // GIR_Coverage, 3137,
     /*  65199 */     GIR_EraseRootFromParent_Done,
     /*  65200 */   // Label 1343: @65200
     /*  65200 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(65267), // Rule ID 3139 //
     /*  65205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65241 */     // (intrinsic_wo_chain:{ *:[i32] } 3530:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  65241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /*  65244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65246 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65248 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65265 */     GIR_RootConstrainSelectedInstOperands,
     /*  65266 */     // GIR_Coverage, 3139,
     /*  65266 */     GIR_EraseRootFromParent_Done,
     /*  65267 */   // Label 1344: @65267
     /*  65267 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(65334), // Rule ID 3141 //
     /*  65272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65308 */     // (intrinsic_wo_chain:{ *:[i32] } 3530:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  65308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /*  65311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65313 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65315 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65332 */     GIR_RootConstrainSelectedInstOperands,
     /*  65333 */     // GIR_Coverage, 3141,
     /*  65333 */     GIR_EraseRootFromParent_Done,
     /*  65334 */   // Label 1345: @65334
     /*  65334 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(65401), // Rule ID 3143 //
     /*  65339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65375 */     // (intrinsic_wo_chain:{ *:[i32] } 3530:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /*  65378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65380 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65382 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65399 */     GIR_RootConstrainSelectedInstOperands,
     /*  65400 */     // GIR_Coverage, 3143,
     /*  65400 */     GIR_EraseRootFromParent_Done,
     /*  65401 */   // Label 1346: @65401
     /*  65401 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(65483), // Rule ID 3548 //
     /*  65406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65442 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3576:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs8),
     /*  65457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65481 */     GIR_RootConstrainSelectedInstOperands,
     /*  65482 */     // GIR_Coverage, 3548,
     /*  65482 */     GIR_EraseRootFromParent_Done,
     /*  65483 */   // Label 1347: @65483
     /*  65483 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(65565), // Rule ID 3555 //
     /*  65488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65524 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3576:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs16),
     /*  65539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65563 */     GIR_RootConstrainSelectedInstOperands,
     /*  65564 */     // GIR_Coverage, 3555,
     /*  65564 */     GIR_EraseRootFromParent_Done,
     /*  65565 */   // Label 1348: @65565
     /*  65565 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(65647), // Rule ID 3559 //
     /*  65570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65606 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3576:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs32),
     /*  65621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65645 */     GIR_RootConstrainSelectedInstOperands,
     /*  65646 */     // GIR_Coverage, 3559,
     /*  65646 */     GIR_EraseRootFromParent_Done,
     /*  65647 */   // Label 1349: @65647
     /*  65647 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(65729), // Rule ID 3563 //
     /*  65652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65688 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3576:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu8),
     /*  65703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65727 */     GIR_RootConstrainSelectedInstOperands,
     /*  65728 */     // GIR_Coverage, 3563,
     /*  65728 */     GIR_EraseRootFromParent_Done,
     /*  65729 */   // Label 1350: @65729
     /*  65729 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(65811), // Rule ID 3567 //
     /*  65734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65770 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3576:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu16),
     /*  65785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65809 */     GIR_RootConstrainSelectedInstOperands,
     /*  65810 */     // GIR_Coverage, 3567,
     /*  65810 */     GIR_EraseRootFromParent_Done,
     /*  65811 */   // Label 1351: @65811
     /*  65811 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(65893), // Rule ID 3571 //
     /*  65816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65852 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3576:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu32),
     /*  65867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65876 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65891 */     GIR_RootConstrainSelectedInstOperands,
     /*  65892 */     // GIR_Coverage, 3571,
     /*  65892 */     GIR_EraseRootFromParent_Done,
     /*  65893 */   // Label 1352: @65893
     /*  65893 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(65975), // Rule ID 3572 //
     /*  65898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65934 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs8),
     /*  65949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65973 */     GIR_RootConstrainSelectedInstOperands,
     /*  65974 */     // GIR_Coverage, 3572,
     /*  65974 */     GIR_EraseRootFromParent_Done,
     /*  65975 */   // Label 1353: @65975
     /*  65975 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(66057), // Rule ID 3579 //
     /*  65980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66016 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs16),
     /*  66031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66055 */     GIR_RootConstrainSelectedInstOperands,
     /*  66056 */     // GIR_Coverage, 3579,
     /*  66056 */     GIR_EraseRootFromParent_Done,
     /*  66057 */   // Label 1354: @66057
     /*  66057 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(66139), // Rule ID 3583 //
     /*  66062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66098 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs32),
     /*  66113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66137 */     GIR_RootConstrainSelectedInstOperands,
     /*  66138 */     // GIR_Coverage, 3583,
     /*  66138 */     GIR_EraseRootFromParent_Done,
     /*  66139 */   // Label 1355: @66139
     /*  66139 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(66221), // Rule ID 3587 //
     /*  66144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66180 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu8),
     /*  66195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66219 */     GIR_RootConstrainSelectedInstOperands,
     /*  66220 */     // GIR_Coverage, 3587,
     /*  66220 */     GIR_EraseRootFromParent_Done,
     /*  66221 */   // Label 1356: @66221
     /*  66221 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(66303), // Rule ID 3591 //
     /*  66226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66262 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu16),
     /*  66277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66301 */     GIR_RootConstrainSelectedInstOperands,
     /*  66302 */     // GIR_Coverage, 3591,
     /*  66302 */     GIR_EraseRootFromParent_Done,
     /*  66303 */   // Label 1357: @66303
     /*  66303 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(66385), // Rule ID 3595 //
     /*  66308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66344 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu32),
     /*  66359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66383 */     GIR_RootConstrainSelectedInstOperands,
     /*  66384 */     // GIR_Coverage, 3595,
     /*  66384 */     GIR_EraseRootFromParent_Done,
     /*  66385 */   // Label 1358: @66385
     /*  66385 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(66467), // Rule ID 3596 //
     /*  66390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66426 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3611:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs8),
     /*  66441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66465 */     GIR_RootConstrainSelectedInstOperands,
     /*  66466 */     // GIR_Coverage, 3596,
     /*  66466 */     GIR_EraseRootFromParent_Done,
     /*  66467 */   // Label 1359: @66467
     /*  66467 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(66549), // Rule ID 3603 //
     /*  66472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66508 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3611:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs16),
     /*  66523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66547 */     GIR_RootConstrainSelectedInstOperands,
     /*  66548 */     // GIR_Coverage, 3603,
     /*  66548 */     GIR_EraseRootFromParent_Done,
     /*  66549 */   // Label 1360: @66549
     /*  66549 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(66631), // Rule ID 3607 //
     /*  66554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66590 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3611:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs32),
     /*  66605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66629 */     GIR_RootConstrainSelectedInstOperands,
     /*  66630 */     // GIR_Coverage, 3607,
     /*  66630 */     GIR_EraseRootFromParent_Done,
     /*  66631 */   // Label 1361: @66631
     /*  66631 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(66713), // Rule ID 3611 //
     /*  66636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66672 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3611:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu8),
     /*  66687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66711 */     GIR_RootConstrainSelectedInstOperands,
     /*  66712 */     // GIR_Coverage, 3611,
     /*  66712 */     GIR_EraseRootFromParent_Done,
     /*  66713 */   // Label 1362: @66713
     /*  66713 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(66795), // Rule ID 3615 //
     /*  66718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66754 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3611:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu16),
     /*  66769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66793 */     GIR_RootConstrainSelectedInstOperands,
     /*  66794 */     // GIR_Coverage, 3615,
     /*  66794 */     GIR_EraseRootFromParent_Done,
     /*  66795 */   // Label 1363: @66795
     /*  66795 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(66877), // Rule ID 3619 //
     /*  66800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66836 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3611:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu32),
     /*  66851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66875 */     GIR_RootConstrainSelectedInstOperands,
     /*  66876 */     // GIR_Coverage, 3619,
     /*  66876 */     GIR_EraseRootFromParent_Done,
     /*  66877 */   // Label 1364: @66877
     /*  66877 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(66959), // Rule ID 3620 //
     /*  66882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66918 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3612:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs8),
     /*  66933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66957 */     GIR_RootConstrainSelectedInstOperands,
     /*  66958 */     // GIR_Coverage, 3620,
     /*  66958 */     GIR_EraseRootFromParent_Done,
     /*  66959 */   // Label 1365: @66959
     /*  66959 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(67041), // Rule ID 3623 //
     /*  66964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67000 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3612:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs16),
     /*  67015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67039 */     GIR_RootConstrainSelectedInstOperands,
     /*  67040 */     // GIR_Coverage, 3623,
     /*  67040 */     GIR_EraseRootFromParent_Done,
     /*  67041 */   // Label 1366: @67041
     /*  67041 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(67123), // Rule ID 3626 //
     /*  67046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67082 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3612:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs32),
     /*  67097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67121 */     GIR_RootConstrainSelectedInstOperands,
     /*  67122 */     // GIR_Coverage, 3626,
     /*  67122 */     GIR_EraseRootFromParent_Done,
     /*  67123 */   // Label 1367: @67123
     /*  67123 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(67205), // Rule ID 3629 //
     /*  67128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67164 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3612:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu8),
     /*  67179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67203 */     GIR_RootConstrainSelectedInstOperands,
     /*  67204 */     // GIR_Coverage, 3629,
     /*  67204 */     GIR_EraseRootFromParent_Done,
     /*  67205 */   // Label 1368: @67205
     /*  67205 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(67287), // Rule ID 3632 //
     /*  67210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67246 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3612:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu16),
     /*  67261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67285 */     GIR_RootConstrainSelectedInstOperands,
     /*  67286 */     // GIR_Coverage, 3632,
     /*  67286 */     GIR_EraseRootFromParent_Done,
     /*  67287 */   // Label 1369: @67287
     /*  67287 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(67369), // Rule ID 3635 //
     /*  67292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67328 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3612:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu32),
     /*  67343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67367 */     GIR_RootConstrainSelectedInstOperands,
     /*  67368 */     // GIR_Coverage, 3635,
     /*  67368 */     GIR_EraseRootFromParent_Done,
     /*  67369 */   // Label 1370: @67369
     /*  67369 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(67451), // Rule ID 4036 //
     /*  67374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67410 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3576:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /*  67410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /*  67425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67449 */     GIR_RootConstrainSelectedInstOperands,
     /*  67450 */     // GIR_Coverage, 4036,
     /*  67450 */     GIR_EraseRootFromParent_Done,
     /*  67451 */   // Label 1371: @67451
     /*  67451 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(67533), // Rule ID 4038 //
     /*  67456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67492 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3576:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /*  67492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /*  67507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67531 */     GIR_RootConstrainSelectedInstOperands,
     /*  67532 */     // GIR_Coverage, 4038,
     /*  67532 */     GIR_EraseRootFromParent_Done,
     /*  67533 */   // Label 1372: @67533
     /*  67533 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(67615), // Rule ID 4411 //
     /*  67538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67574 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3639:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp8),
     /*  67589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67613 */     GIR_RootConstrainSelectedInstOperands,
     /*  67614 */     // GIR_Coverage, 4411,
     /*  67614 */     GIR_EraseRootFromParent_Done,
     /*  67615 */   // Label 1373: @67615
     /*  67615 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(67697), // Rule ID 4413 //
     /*  67620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67656 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3639:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp8),
     /*  67671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67695 */     GIR_RootConstrainSelectedInstOperands,
     /*  67696 */     // GIR_Coverage, 4413,
     /*  67696 */     GIR_EraseRootFromParent_Done,
     /*  67697 */   // Label 1374: @67697
     /*  67697 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(67779), // Rule ID 4415 //
     /*  67702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67738 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3639:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp16),
     /*  67753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67777 */     GIR_RootConstrainSelectedInstOperands,
     /*  67778 */     // GIR_Coverage, 4415,
     /*  67778 */     GIR_EraseRootFromParent_Done,
     /*  67779 */   // Label 1375: @67779
     /*  67779 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(67861), // Rule ID 4417 //
     /*  67784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67820 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3639:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp16),
     /*  67835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67859 */     GIR_RootConstrainSelectedInstOperands,
     /*  67860 */     // GIR_Coverage, 4417,
     /*  67860 */     GIR_EraseRootFromParent_Done,
     /*  67861 */   // Label 1376: @67861
     /*  67861 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(67943), // Rule ID 4444 //
     /*  67866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67902 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3637:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /*  67917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67941 */     GIR_RootConstrainSelectedInstOperands,
     /*  67942 */     // GIR_Coverage, 4444,
     /*  67942 */     GIR_EraseRootFromParent_Done,
     /*  67943 */   // Label 1377: @67943
     /*  67943 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(68025), // Rule ID 4451 //
     /*  67948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67984 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3637:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /*  67999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68023 */     GIR_RootConstrainSelectedInstOperands,
     /*  68024 */     // GIR_Coverage, 4451,
     /*  68024 */     GIR_EraseRootFromParent_Done,
     /*  68025 */   // Label 1378: @68025
     /*  68025 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(68107), // Rule ID 4455 //
     /*  68030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68066 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3637:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /*  68081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68105 */     GIR_RootConstrainSelectedInstOperands,
     /*  68106 */     // GIR_Coverage, 4455,
     /*  68106 */     GIR_EraseRootFromParent_Done,
     /*  68107 */   // Label 1379: @68107
     /*  68107 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(68189), // Rule ID 4459 //
     /*  68112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68148 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3637:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /*  68163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68187 */     GIR_RootConstrainSelectedInstOperands,
     /*  68188 */     // GIR_Coverage, 4459,
     /*  68188 */     GIR_EraseRootFromParent_Done,
     /*  68189 */   // Label 1380: @68189
     /*  68189 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(68271), // Rule ID 4463 //
     /*  68194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68230 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3637:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /*  68245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68269 */     GIR_RootConstrainSelectedInstOperands,
     /*  68270 */     // GIR_Coverage, 4463,
     /*  68270 */     GIR_EraseRootFromParent_Done,
     /*  68271 */   // Label 1381: @68271
     /*  68271 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(68353), // Rule ID 4467 //
     /*  68276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68312 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3637:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /*  68327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68351 */     GIR_RootConstrainSelectedInstOperands,
     /*  68352 */     // GIR_Coverage, 4467,
     /*  68352 */     GIR_EraseRootFromParent_Done,
     /*  68353 */   // Label 1382: @68353
     /*  68353 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(68435), // Rule ID 4468 //
     /*  68358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68394 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3672:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs8),
     /*  68409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68433 */     GIR_RootConstrainSelectedInstOperands,
     /*  68434 */     // GIR_Coverage, 4468,
     /*  68434 */     GIR_EraseRootFromParent_Done,
     /*  68435 */   // Label 1383: @68435
     /*  68435 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(68517), // Rule ID 4470 //
     /*  68440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68476 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3672:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs16),
     /*  68491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68515 */     GIR_RootConstrainSelectedInstOperands,
     /*  68516 */     // GIR_Coverage, 4470,
     /*  68516 */     GIR_EraseRootFromParent_Done,
     /*  68517 */   // Label 1384: @68517
     /*  68517 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(68599), // Rule ID 4472 //
     /*  68522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68558 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3672:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs32),
     /*  68573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68597 */     GIR_RootConstrainSelectedInstOperands,
     /*  68598 */     // GIR_Coverage, 4472,
     /*  68598 */     GIR_EraseRootFromParent_Done,
     /*  68599 */   // Label 1385: @68599
     /*  68599 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(68681), // Rule ID 4474 //
     /*  68604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68640 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3672:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu8),
     /*  68655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68679 */     GIR_RootConstrainSelectedInstOperands,
     /*  68680 */     // GIR_Coverage, 4474,
     /*  68680 */     GIR_EraseRootFromParent_Done,
     /*  68681 */   // Label 1386: @68681
     /*  68681 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(68763), // Rule ID 4476 //
     /*  68686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68722 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3672:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu16),
     /*  68737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68761 */     GIR_RootConstrainSelectedInstOperands,
     /*  68762 */     // GIR_Coverage, 4476,
     /*  68762 */     GIR_EraseRootFromParent_Done,
     /*  68763 */   // Label 1387: @68763
     /*  68763 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(68845), // Rule ID 4478 //
     /*  68768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68804 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3672:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu32),
     /*  68819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68843 */     GIR_RootConstrainSelectedInstOperands,
     /*  68844 */     // GIR_Coverage, 4478,
     /*  68844 */     GIR_EraseRootFromParent_Done,
     /*  68845 */   // Label 1388: @68845
     /*  68845 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(68912), // Rule ID 4529 //
     /*  68850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68886 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3595:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf16f32bh:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32bh),
     /*  68889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68910 */     GIR_RootConstrainSelectedInstOperands,
     /*  68911 */     // GIR_Coverage, 4529,
     /*  68911 */     GIR_EraseRootFromParent_Done,
     /*  68912 */   // Label 1389: @68912
     /*  68912 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(68979), // Rule ID 4535 //
     /*  68917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68953 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3595:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf16f32th:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32th),
     /*  68956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68971 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68977 */     GIR_RootConstrainSelectedInstOperands,
     /*  68978 */     // GIR_Coverage, 4535,
     /*  68978 */     GIR_EraseRootFromParent_Done,
     /*  68979 */   // Label 1390: @68979
     /*  68979 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(69061), // Rule ID 4553 //
     /*  68984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  69020 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  69020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16bh),
     /*  69035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69059 */     GIR_RootConstrainSelectedInstOperands,
     /*  69060 */     // GIR_Coverage, 4553,
     /*  69060 */     GIR_EraseRootFromParent_Done,
     /*  69061 */   // Label 1391: @69061
     /*  69061 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(69143), // Rule ID 4555 //
     /*  69066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  69102 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  69102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16th),
     /*  69117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69141 */     GIR_RootConstrainSelectedInstOperands,
     /*  69142 */     // GIR_Coverage, 4555,
     /*  69142 */     GIR_EraseRootFromParent_Done,
     /*  69143 */   // Label 1392: @69143
     /*  69143 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(69225), // Rule ID 4557 //
     /*  69148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  69184 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs32bh:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32bh),
     /*  69199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69223 */     GIR_RootConstrainSelectedInstOperands,
     /*  69224 */     // GIR_Coverage, 4557,
     /*  69224 */     GIR_EraseRootFromParent_Done,
     /*  69225 */   // Label 1393: @69225
     /*  69225 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(69307), // Rule ID 4559 //
     /*  69230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  69266 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs32th:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32th),
     /*  69281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69305 */     GIR_RootConstrainSelectedInstOperands,
     /*  69306 */     // GIR_Coverage, 4559,
     /*  69306 */     GIR_EraseRootFromParent_Done,
     /*  69307 */   // Label 1394: @69307
     /*  69307 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(69384), // Rule ID 3904 //
     /*  69312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  69353 */     // MIs[1] Operand 1
     /*  69353 */     // No operand predicates
     /*  69353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69355 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3687:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VSLIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  69355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm8),
     /*  69358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69360 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69382 */     GIR_RootConstrainSelectedInstOperands,
     /*  69383 */     // GIR_Coverage, 3904,
     /*  69383 */     GIR_EraseRootFromParent_Done,
     /*  69384 */   // Label 1395: @69384
     /*  69384 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(69461), // Rule ID 3906 //
     /*  69389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  69430 */     // MIs[1] Operand 1
     /*  69430 */     // No operand predicates
     /*  69430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69432 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3687:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VSLIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  69432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm16),
     /*  69435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69437 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69459 */     GIR_RootConstrainSelectedInstOperands,
     /*  69460 */     // GIR_Coverage, 3906,
     /*  69460 */     GIR_EraseRootFromParent_Done,
     /*  69461 */   // Label 1396: @69461
     /*  69461 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(69538), // Rule ID 3908 //
     /*  69466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  69507 */     // MIs[1] Operand 1
     /*  69507 */     // No operand predicates
     /*  69507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69509 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3687:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VSLIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  69509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm32),
     /*  69512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69514 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69536 */     GIR_RootConstrainSelectedInstOperands,
     /*  69537 */     // GIR_Coverage, 3908,
     /*  69537 */     GIR_EraseRootFromParent_Done,
     /*  69538 */   // Label 1397: @69538
     /*  69538 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(69615), // Rule ID 3910 //
     /*  69543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  69584 */     // MIs[1] Operand 1
     /*  69584 */     // No operand predicates
     /*  69584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69586 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3689:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)  =>  (MVE_VSRIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  69586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm8),
     /*  69589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69591 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69613 */     GIR_RootConstrainSelectedInstOperands,
     /*  69614 */     // GIR_Coverage, 3910,
     /*  69614 */     GIR_EraseRootFromParent_Done,
     /*  69615 */   // Label 1398: @69615
     /*  69615 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(69692), // Rule ID 3912 //
     /*  69620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  69661 */     // MIs[1] Operand 1
     /*  69661 */     // No operand predicates
     /*  69661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69663 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3689:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)  =>  (MVE_VSRIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  69663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm16),
     /*  69666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69668 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69690 */     GIR_RootConstrainSelectedInstOperands,
     /*  69691 */     // GIR_Coverage, 3912,
     /*  69691 */     GIR_EraseRootFromParent_Done,
     /*  69692 */   // Label 1399: @69692
     /*  69692 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(69769), // Rule ID 3914 //
     /*  69697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  69738 */     // MIs[1] Operand 1
     /*  69738 */     // No operand predicates
     /*  69738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69740 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3689:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)  =>  (MVE_VSRIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  69740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm32),
     /*  69743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69745 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69767 */     GIR_RootConstrainSelectedInstOperands,
     /*  69768 */     // GIR_Coverage, 3914,
     /*  69768 */     GIR_EraseRootFromParent_Done,
     /*  69769 */   // Label 1400: @69769
     /*  69769 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(69860), // Rule ID 4383 //
     /*  69774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  69794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69806 */     // MIs[1] Operand 1
     /*  69806 */     // No operand predicates
     /*  69806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69816 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3586:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf16),
     /*  69831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69858 */     GIR_RootConstrainSelectedInstOperands,
     /*  69859 */     // GIR_Coverage, 4383,
     /*  69859 */     GIR_EraseRootFromParent_Done,
     /*  69860 */   // Label 1401: @69860
     /*  69860 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(69951), // Rule ID 4385 //
     /*  69865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  69885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69897 */     // MIs[1] Operand 1
     /*  69897 */     // No operand predicates
     /*  69897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69907 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3586:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf32),
     /*  69922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69949 */     GIR_RootConstrainSelectedInstOperands,
     /*  69950 */     // GIR_Coverage, 4385,
     /*  69950 */     GIR_EraseRootFromParent_Done,
     /*  69951 */   // Label 1402: @69951
     /*  69951 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(70014), // Rule ID 146 //
     /*  69956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  69959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69992 */     // (intrinsic_wo_chain:{ *:[i32] } 3919:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (USADA8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  69992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USADA8),
     /*  69995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70012 */     GIR_RootConstrainSelectedInstOperands,
     /*  70013 */     // GIR_Coverage, 146,
     /*  70013 */     GIR_EraseRootFromParent_Done,
     /*  70014 */   // Label 1403: @70014
     /*  70014 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(70077), // Rule ID 469 //
     /*  70019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  70027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70055 */     // (intrinsic_wo_chain:{ *:[i32] } 3919:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2USADA8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USADA8),
     /*  70058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70075 */     GIR_RootConstrainSelectedInstOperands,
     /*  70076 */     // GIR_Coverage, 469,
     /*  70076 */     GIR_EraseRootFromParent_Done,
     /*  70077 */   // Label 1404: @70077
     /*  70077 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(70140), // Rule ID 528 //
     /*  70082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  70090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70118 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAD),
     /*  70121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70138 */     GIR_RootConstrainSelectedInstOperands,
     /*  70139 */     // GIR_Coverage, 528,
     /*  70139 */     GIR_EraseRootFromParent_Done,
     /*  70140 */   // Label 1405: @70140
     /*  70140 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(70203), // Rule ID 529 //
     /*  70145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  70153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70181 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLADX),
     /*  70184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70201 */     GIR_RootConstrainSelectedInstOperands,
     /*  70202 */     // GIR_Coverage, 529,
     /*  70202 */     GIR_EraseRootFromParent_Done,
     /*  70203 */   // Label 1406: @70203
     /*  70203 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(70266), // Rule ID 530 //
     /*  70208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  70216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70244 */     // (intrinsic_wo_chain:{ *:[i32] } 3872:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSD),
     /*  70247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70264 */     GIR_RootConstrainSelectedInstOperands,
     /*  70265 */     // GIR_Coverage, 530,
     /*  70265 */     GIR_EraseRootFromParent_Done,
     /*  70266 */   // Label 1407: @70266
     /*  70266 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(70329), // Rule ID 531 //
     /*  70271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  70279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70307 */     // (intrinsic_wo_chain:{ *:[i32] } 3873:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSDX),
     /*  70310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70327 */     GIR_RootConstrainSelectedInstOperands,
     /*  70328 */     // GIR_Coverage, 531,
     /*  70328 */     GIR_EraseRootFromParent_Done,
     /*  70329 */   // Label 1408: @70329
     /*  70329 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(70383), // Rule ID 951 //
     /*  70334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70370 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3719:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTD),
     /*  70373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70381 */     GIR_RootConstrainSelectedInstOperands,
     /*  70382 */     // GIR_Coverage, 951,
     /*  70382 */     GIR_EraseRootFromParent_Done,
     /*  70383 */   // Label 1409: @70383
     /*  70383 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(70437), // Rule ID 952 //
     /*  70388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70424 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3707:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTD),
     /*  70427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70435 */     GIR_RootConstrainSelectedInstOperands,
     /*  70436 */     // GIR_Coverage, 952,
     /*  70436 */     GIR_EraseRootFromParent_Done,
     /*  70437 */   // Label 1410: @70437
     /*  70437 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(70491), // Rule ID 953 //
     /*  70442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70478 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3719:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTQ),
     /*  70481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70489 */     GIR_RootConstrainSelectedInstOperands,
     /*  70490 */     // GIR_Coverage, 953,
     /*  70490 */     GIR_EraseRootFromParent_Done,
     /*  70491 */   // Label 1411: @70491
     /*  70491 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(70545), // Rule ID 954 //
     /*  70496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70532 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTQ),
     /*  70535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70543 */     GIR_RootConstrainSelectedInstOperands,
     /*  70544 */     // GIR_Coverage, 954,
     /*  70544 */     GIR_EraseRootFromParent_Done,
     /*  70545 */   // Label 1412: @70545
     /*  70545 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(70599), // Rule ID 955 //
     /*  70550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_smmla),
     /*  70558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70586 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3718:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSMMLA),
     /*  70589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70597 */     GIR_RootConstrainSelectedInstOperands,
     /*  70598 */     // GIR_Coverage, 955,
     /*  70598 */     GIR_EraseRootFromParent_Done,
     /*  70599 */   // Label 1413: @70599
     /*  70599 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(70653), // Rule ID 956 //
     /*  70604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_ummla),
     /*  70612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70640 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3720:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUMMLA),
     /*  70643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70651 */     GIR_RootConstrainSelectedInstOperands,
     /*  70652 */     // GIR_Coverage, 956,
     /*  70652 */     GIR_EraseRootFromParent_Done,
     /*  70653 */   // Label 1414: @70653
     /*  70653 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(70707), // Rule ID 957 //
     /*  70658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usmmla),
     /*  70666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70694 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3722:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSMMLA),
     /*  70697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70705 */     GIR_RootConstrainSelectedInstOperands,
     /*  70706 */     // GIR_Coverage, 957,
     /*  70706 */     GIR_EraseRootFromParent_Done,
     /*  70707 */   // Label 1415: @70707
     /*  70707 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(70761), // Rule ID 958 //
     /*  70712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70748 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3721:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTD),
     /*  70751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70759 */     GIR_RootConstrainSelectedInstOperands,
     /*  70760 */     // GIR_Coverage, 958,
     /*  70760 */     GIR_EraseRootFromParent_Done,
     /*  70761 */   // Label 1416: @70761
     /*  70761 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(70815), // Rule ID 959 //
     /*  70766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70802 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3721:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTQ),
     /*  70805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70813 */     GIR_RootConstrainSelectedInstOperands,
     /*  70814 */     // GIR_Coverage, 959,
     /*  70814 */     GIR_EraseRootFromParent_Done,
     /*  70815 */   // Label 1417: @70815
     /*  70815 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(70878), // Rule ID 1690 //
     /*  70820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx1),
     /*  70828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  70831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70856 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3839:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VTBX1:{ *:[v8i8] } DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX1),
     /*  70859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70861 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  70863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70876 */     GIR_RootConstrainSelectedInstOperands,
     /*  70877 */     // GIR_Coverage, 1690,
     /*  70877 */     GIR_EraseRootFromParent_Done,
     /*  70878 */   // Label 1418: @70878
     /*  70878 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(70932), // Rule ID 1721 //
     /*  70883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su0),
     /*  70891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70919 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3712:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU0),
     /*  70922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70924 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70930 */     GIR_RootConstrainSelectedInstOperands,
     /*  70931 */     // GIR_Coverage, 1721,
     /*  70931 */     GIR_EraseRootFromParent_Done,
     /*  70932 */   // Label 1419: @70932
     /*  70932 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(70986), // Rule ID 1722 //
     /*  70937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h),
     /*  70945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70973 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3714:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H),
     /*  70976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70978 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70984 */     GIR_RootConstrainSelectedInstOperands,
     /*  70985 */     // GIR_Coverage, 1722,
     /*  70985 */     GIR_EraseRootFromParent_Done,
     /*  70986 */   // Label 1420: @70986
     /*  70986 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(71040), // Rule ID 1723 //
     /*  70991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h2),
     /*  70999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  71011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71027 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3715:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H2:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  71027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H2),
     /*  71030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71032 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  71034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71038 */     GIR_RootConstrainSelectedInstOperands,
     /*  71039 */     // GIR_Coverage, 1723,
     /*  71039 */     GIR_EraseRootFromParent_Done,
     /*  71040 */   // Label 1421: @71040
     /*  71040 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(71094), // Rule ID 1724 //
     /*  71045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  71048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su1),
     /*  71053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  71065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71081 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3717:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  71081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU1),
     /*  71084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71086 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  71088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71092 */     GIR_RootConstrainSelectedInstOperands,
     /*  71093 */     // GIR_Coverage, 1724,
     /*  71093 */     GIR_EraseRootFromParent_Done,
     /*  71094 */   // Label 1422: @71094
     /*  71094 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(71157), // Rule ID 1899 //
     /*  71099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  71107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71135 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAD),
     /*  71138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71155 */     GIR_RootConstrainSelectedInstOperands,
     /*  71156 */     // GIR_Coverage, 1899,
     /*  71156 */     GIR_EraseRootFromParent_Done,
     /*  71157 */   // Label 1423: @71157
     /*  71157 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(71220), // Rule ID 1900 //
     /*  71162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  71170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71198 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLADX),
     /*  71201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71218 */     GIR_RootConstrainSelectedInstOperands,
     /*  71219 */     // GIR_Coverage, 1900,
     /*  71219 */     GIR_EraseRootFromParent_Done,
     /*  71220 */   // Label 1424: @71220
     /*  71220 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(71283), // Rule ID 1901 //
     /*  71225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  71233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71261 */     // (intrinsic_wo_chain:{ *:[i32] } 3872:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSD),
     /*  71264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71281 */     GIR_RootConstrainSelectedInstOperands,
     /*  71282 */     // GIR_Coverage, 1901,
     /*  71282 */     GIR_EraseRootFromParent_Done,
     /*  71283 */   // Label 1425: @71283
     /*  71283 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(71346), // Rule ID 1902 //
     /*  71288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  71296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71324 */     // (intrinsic_wo_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSDX),
     /*  71327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71344 */     GIR_RootConstrainSelectedInstOperands,
     /*  71345 */     // GIR_Coverage, 1902,
     /*  71345 */     GIR_EraseRootFromParent_Done,
     /*  71346 */   // Label 1426: @71346
     /*  71346 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(71409), // Rule ID 1990 //
     /*  71351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71387 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*  71390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71392 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71394 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71396 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71407 */     GIR_RootConstrainSelectedInstOperands,
     /*  71408 */     // GIR_Coverage, 1990,
     /*  71408 */     GIR_EraseRootFromParent_Done,
     /*  71409 */   // Label 1427: @71409
     /*  71409 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(71472), // Rule ID 1991 //
     /*  71414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71450 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*  71453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71455 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71457 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71459 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71470 */     GIR_RootConstrainSelectedInstOperands,
     /*  71471 */     // GIR_Coverage, 1991,
     /*  71471 */     GIR_EraseRootFromParent_Done,
     /*  71472 */   // Label 1428: @71472
     /*  71472 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(71535), // Rule ID 1992 //
     /*  71477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71513 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*  71516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71518 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71520 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71522 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71527 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71533 */     GIR_RootConstrainSelectedInstOperands,
     /*  71534 */     // GIR_Coverage, 1992,
     /*  71534 */     GIR_EraseRootFromParent_Done,
     /*  71535 */   // Label 1429: @71535
     /*  71535 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(71598), // Rule ID 1993 //
     /*  71540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71576 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*  71579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71581 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71583 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71585 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71596 */     GIR_RootConstrainSelectedInstOperands,
     /*  71597 */     // GIR_Coverage, 1993,
     /*  71597 */     GIR_EraseRootFromParent_Done,
     /*  71598 */   // Label 1430: @71598
     /*  71598 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(71661), // Rule ID 1994 //
     /*  71603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71639 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWB),
     /*  71642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71644 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71646 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71648 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71659 */     GIR_RootConstrainSelectedInstOperands,
     /*  71660 */     // GIR_Coverage, 1994,
     /*  71660 */     GIR_EraseRootFromParent_Done,
     /*  71661 */   // Label 1431: @71661
     /*  71661 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(71724), // Rule ID 1995 //
     /*  71666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71702 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWT),
     /*  71705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71707 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71709 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71711 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71722 */     GIR_RootConstrainSelectedInstOperands,
     /*  71723 */     // GIR_Coverage, 1995,
     /*  71723 */     GIR_EraseRootFromParent_Done,
     /*  71724 */   // Label 1432: @71724
     /*  71724 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(71787), // Rule ID 2181 //
     /*  71729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71765 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*  71768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71770 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71772 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71774 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71785 */     GIR_RootConstrainSelectedInstOperands,
     /*  71786 */     // GIR_Coverage, 2181,
     /*  71786 */     GIR_EraseRootFromParent_Done,
     /*  71787 */   // Label 1433: @71787
     /*  71787 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(71850), // Rule ID 2182 //
     /*  71792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71828 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*  71831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71833 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71835 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71837 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71848 */     GIR_RootConstrainSelectedInstOperands,
     /*  71849 */     // GIR_Coverage, 2182,
     /*  71849 */     GIR_EraseRootFromParent_Done,
     /*  71850 */   // Label 1434: @71850
     /*  71850 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(71913), // Rule ID 2183 //
     /*  71855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71891 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*  71894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71896 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71898 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71900 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71911 */     GIR_RootConstrainSelectedInstOperands,
     /*  71912 */     // GIR_Coverage, 2183,
     /*  71912 */     GIR_EraseRootFromParent_Done,
     /*  71913 */   // Label 1435: @71913
     /*  71913 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(71976), // Rule ID 2184 //
     /*  71918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71954 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*  71957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71959 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71961 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71963 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71974 */     GIR_RootConstrainSelectedInstOperands,
     /*  71975 */     // GIR_Coverage, 2184,
     /*  71975 */     GIR_EraseRootFromParent_Done,
     /*  71976 */   // Label 1436: @71976
     /*  71976 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(72039), // Rule ID 2185 //
     /*  71981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72017 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  72017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWB),
     /*  72020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72022 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  72024 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  72026 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  72028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72037 */     GIR_RootConstrainSelectedInstOperands,
     /*  72038 */     // GIR_Coverage, 2185,
     /*  72038 */     GIR_EraseRootFromParent_Done,
     /*  72039 */   // Label 1437: @72039
     /*  72039 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(72102), // Rule ID 2186 //
     /*  72044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  72047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  72052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  72055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  72058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  72080 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  72080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWT),
     /*  72083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72085 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  72087 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  72089 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  72091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72100 */     GIR_RootConstrainSelectedInstOperands,
     /*  72101 */     // GIR_Coverage, 2186,
     /*  72101 */     GIR_EraseRootFromParent_Done,
     /*  72102 */   // Label 1438: @72102
     /*  72102 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(72165), // Rule ID 2472 //
     /*  72107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72143 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3791:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLAHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i16),
     /*  72146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72163 */     GIR_RootConstrainSelectedInstOperands,
     /*  72164 */     // GIR_Coverage, 2472,
     /*  72164 */     GIR_EraseRootFromParent_Done,
     /*  72165 */   // Label 1439: @72165
     /*  72165 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(72228), // Rule ID 2473 //
     /*  72170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72206 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3791:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLAHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv2i32),
     /*  72209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72211 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72226 */     GIR_RootConstrainSelectedInstOperands,
     /*  72227 */     // GIR_Coverage, 2473,
     /*  72227 */     GIR_EraseRootFromParent_Done,
     /*  72228 */   // Label 1440: @72228
     /*  72228 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(72291), // Rule ID 2474 //
     /*  72233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72269 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3791:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLAHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv8i16),
     /*  72272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72274 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72289 */     GIR_RootConstrainSelectedInstOperands,
     /*  72290 */     // GIR_Coverage, 2474,
     /*  72290 */     GIR_EraseRootFromParent_Done,
     /*  72291 */   // Label 1441: @72291
     /*  72291 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(72354), // Rule ID 2475 //
     /*  72296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72332 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3791:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLAHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i32),
     /*  72335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72337 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72352 */     GIR_RootConstrainSelectedInstOperands,
     /*  72353 */     // GIR_Coverage, 2475,
     /*  72353 */     GIR_EraseRootFromParent_Done,
     /*  72354 */   // Label 1442: @72354
     /*  72354 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(72417), // Rule ID 2480 //
     /*  72359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72395 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3792:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLSHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i16),
     /*  72398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72400 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72415 */     GIR_RootConstrainSelectedInstOperands,
     /*  72416 */     // GIR_Coverage, 2480,
     /*  72416 */     GIR_EraseRootFromParent_Done,
     /*  72417 */   // Label 1443: @72417
     /*  72417 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(72480), // Rule ID 2481 //
     /*  72422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72458 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3792:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLSHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv2i32),
     /*  72461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72478 */     GIR_RootConstrainSelectedInstOperands,
     /*  72479 */     // GIR_Coverage, 2481,
     /*  72479 */     GIR_EraseRootFromParent_Done,
     /*  72480 */   // Label 1444: @72480
     /*  72480 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(72543), // Rule ID 2482 //
     /*  72485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72521 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3792:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLSHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv8i16),
     /*  72524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72526 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72541 */     GIR_RootConstrainSelectedInstOperands,
     /*  72542 */     // GIR_Coverage, 2482,
     /*  72542 */     GIR_EraseRootFromParent_Done,
     /*  72543 */   // Label 1445: @72543
     /*  72543 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(72606), // Rule ID 2483 //
     /*  72548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72584 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3792:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLSHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i32),
     /*  72587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72589 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72604 */     GIR_RootConstrainSelectedInstOperands,
     /*  72605 */     // GIR_Coverage, 2483,
     /*  72605 */     GIR_EraseRootFromParent_Done,
     /*  72606 */   // Label 1446: @72606
     /*  72606 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(72675), // Rule ID 4840 //
     /*  72611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72647 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3642:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs8),
     /*  72650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72652 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72654 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72656 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72673 */     GIR_RootConstrainSelectedInstOperands,
     /*  72674 */     // GIR_Coverage, 4840,
     /*  72674 */     GIR_EraseRootFromParent_Done,
     /*  72675 */   // Label 1447: @72675
     /*  72675 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(72744), // Rule ID 4842 //
     /*  72680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72716 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3642:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs16),
     /*  72719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72721 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72723 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72725 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72742 */     GIR_RootConstrainSelectedInstOperands,
     /*  72743 */     // GIR_Coverage, 4842,
     /*  72743 */     GIR_EraseRootFromParent_Done,
     /*  72744 */   // Label 1448: @72744
     /*  72744 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(72813), // Rule ID 4844 //
     /*  72749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72785 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3642:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs32),
     /*  72788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72790 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72792 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72794 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72811 */     GIR_RootConstrainSelectedInstOperands,
     /*  72812 */     // GIR_Coverage, 4844,
     /*  72812 */     GIR_EraseRootFromParent_Done,
     /*  72813 */   // Label 1449: @72813
     /*  72813 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(72882), // Rule ID 4846 //
     /*  72818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72854 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3651:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs8),
     /*  72857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72859 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72861 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72863 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72880 */     GIR_RootConstrainSelectedInstOperands,
     /*  72881 */     // GIR_Coverage, 4846,
     /*  72881 */     GIR_EraseRootFromParent_Done,
     /*  72882 */   // Label 1450: @72882
     /*  72882 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(72951), // Rule ID 4848 //
     /*  72887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72923 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs16),
     /*  72926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72928 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72930 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72932 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72949 */     GIR_RootConstrainSelectedInstOperands,
     /*  72950 */     // GIR_Coverage, 4848,
     /*  72950 */     GIR_EraseRootFromParent_Done,
     /*  72951 */   // Label 1451: @72951
     /*  72951 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(73020), // Rule ID 4850 //
     /*  72956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72992 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs32),
     /*  72995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72997 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72999 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73001 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73018 */     GIR_RootConstrainSelectedInstOperands,
     /*  73019 */     // GIR_Coverage, 4850,
     /*  73019 */     GIR_EraseRootFromParent_Done,
     /*  73020 */   // Label 1452: @73020
     /*  73020 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(73089), // Rule ID 4852 //
     /*  73025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  73033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  73036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73061 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3644:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs8),
     /*  73064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73066 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73068 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73070 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73087 */     GIR_RootConstrainSelectedInstOperands,
     /*  73088 */     // GIR_Coverage, 4852,
     /*  73088 */     GIR_EraseRootFromParent_Done,
     /*  73089 */   // Label 1453: @73089
     /*  73089 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(73158), // Rule ID 4854 //
     /*  73094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  73102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73130 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3644:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs16),
     /*  73133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73135 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73137 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73139 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73156 */     GIR_RootConstrainSelectedInstOperands,
     /*  73157 */     // GIR_Coverage, 4854,
     /*  73157 */     GIR_EraseRootFromParent_Done,
     /*  73158 */   // Label 1454: @73158
     /*  73158 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(73227), // Rule ID 4856 //
     /*  73163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  73171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73199 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3644:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs32),
     /*  73202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73204 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73206 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73208 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73213 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73219 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73225 */     GIR_RootConstrainSelectedInstOperands,
     /*  73226 */     // GIR_Coverage, 4856,
     /*  73226 */     GIR_EraseRootFromParent_Done,
     /*  73227 */   // Label 1455: @73227
     /*  73227 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(73296), // Rule ID 4858 //
     /*  73232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  73243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73268 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3653:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs8),
     /*  73271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73273 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73275 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73277 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73294 */     GIR_RootConstrainSelectedInstOperands,
     /*  73295 */     // GIR_Coverage, 4858,
     /*  73295 */     GIR_EraseRootFromParent_Done,
     /*  73296 */   // Label 1456: @73296
     /*  73296 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(73365), // Rule ID 4860 //
     /*  73301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73337 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3653:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs16),
     /*  73340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73342 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73344 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73346 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73363 */     GIR_RootConstrainSelectedInstOperands,
     /*  73364 */     // GIR_Coverage, 4860,
     /*  73364 */     GIR_EraseRootFromParent_Done,
     /*  73365 */   // Label 1457: @73365
     /*  73365 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(73434), // Rule ID 4862 //
     /*  73370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73406 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3653:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs32),
     /*  73409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73411 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73413 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73415 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73426 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73432 */     GIR_RootConstrainSelectedInstOperands,
     /*  73433 */     // GIR_Coverage, 4862,
     /*  73433 */     GIR_EraseRootFromParent_Done,
     /*  73434 */   // Label 1458: @73434
     /*  73434 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(73529), // Rule ID 2694 //
     /*  73439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1c),
     /*  73447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73463 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3708:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1C:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73463 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73466 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73470 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73475 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73479 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73496 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73499 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73502 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1C),
     /*  73518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73520 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73525 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73527 */     GIR_RootConstrainSelectedInstOperands,
     /*  73528 */     // GIR_Coverage, 2694,
     /*  73528 */     GIR_EraseRootFromParent_Done,
     /*  73529 */   // Label 1459: @73529
     /*  73529 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(73624), // Rule ID 2695 //
     /*  73534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1m),
     /*  73542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73558 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3710:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1M:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73558 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73561 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73565 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73570 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73574 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73591 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73594 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73597 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1M),
     /*  73613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73615 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73620 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73622 */     GIR_RootConstrainSelectedInstOperands,
     /*  73623 */     // GIR_Coverage, 2695,
     /*  73623 */     GIR_EraseRootFromParent_Done,
     /*  73624 */   // Label 1460: @73624
     /*  73624 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(73719), // Rule ID 2696 //
     /*  73629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1p),
     /*  73637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73653 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3711:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1P:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73653 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73656 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73660 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73665 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73686 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73689 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73692 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1P),
     /*  73708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73710 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73715 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73717 */     GIR_RootConstrainSelectedInstOperands,
     /*  73718 */     // GIR_Coverage, 2696,
     /*  73718 */     GIR_EraseRootFromParent_Done,
     /*  73719 */   // Label 1461: @73719
     /*  73719 */   GIM_Reject,
     /*  73720 */ // Label 1314: @73720
     /*  73720 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(77106),
     /*  73725 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  73728 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(73812), // Rule ID 3727 //
     /*  73733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73773 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3683:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8bh),
     /*  73788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73790 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73795 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73810 */     GIR_RootConstrainSelectedInstOperands,
     /*  73811 */     // GIR_Coverage, 3727,
     /*  73811 */     GIR_EraseRootFromParent_Done,
     /*  73812 */   // Label 1463: @73812
     /*  73812 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(73896), // Rule ID 3731 //
     /*  73817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73857 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3683:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8th),
     /*  73872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73874 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73894 */     GIR_RootConstrainSelectedInstOperands,
     /*  73895 */     // GIR_Coverage, 3731,
     /*  73895 */     GIR_EraseRootFromParent_Done,
     /*  73896 */   // Label 1464: @73896
     /*  73896 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(73980), // Rule ID 3735 //
     /*  73901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73941 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3683:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16bh),
     /*  73956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73958 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73978 */     GIR_RootConstrainSelectedInstOperands,
     /*  73979 */     // GIR_Coverage, 3735,
     /*  73979 */     GIR_EraseRootFromParent_Done,
     /*  73980 */   // Label 1465: @73980
     /*  73980 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(74064), // Rule ID 3739 //
     /*  73985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74025 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3683:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16th),
     /*  74040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74042 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74062 */     GIR_RootConstrainSelectedInstOperands,
     /*  74063 */     // GIR_Coverage, 3739,
     /*  74063 */     GIR_EraseRootFromParent_Done,
     /*  74064 */   // Label 1466: @74064
     /*  74064 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(74148), // Rule ID 3743 //
     /*  74069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  74101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74109 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3683:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  74109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8bh),
     /*  74124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74126 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74146 */     GIR_RootConstrainSelectedInstOperands,
     /*  74147 */     // GIR_Coverage, 3743,
     /*  74147 */     GIR_EraseRootFromParent_Done,
     /*  74148 */   // Label 1467: @74148
     /*  74148 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(74232), // Rule ID 3747 //
     /*  74153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  74185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74189 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74193 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3683:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  74193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8th),
     /*  74208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74210 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74230 */     GIR_RootConstrainSelectedInstOperands,
     /*  74231 */     // GIR_Coverage, 3747,
     /*  74231 */     GIR_EraseRootFromParent_Done,
     /*  74232 */   // Label 1468: @74232
     /*  74232 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(74316), // Rule ID 3751 //
     /*  74237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74277 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3683:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16bh),
     /*  74292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74294 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74314 */     GIR_RootConstrainSelectedInstOperands,
     /*  74315 */     // GIR_Coverage, 3751,
     /*  74315 */     GIR_EraseRootFromParent_Done,
     /*  74316 */   // Label 1469: @74316
     /*  74316 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(74400), // Rule ID 3755 //
     /*  74321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74361 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3683:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16th),
     /*  74376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74378 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74398 */     GIR_RootConstrainSelectedInstOperands,
     /*  74399 */     // GIR_Coverage, 3755,
     /*  74399 */     GIR_EraseRootFromParent_Done,
     /*  74400 */   // Label 1470: @74400
     /*  74400 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(74489), // Rule ID 4387 //
     /*  74405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74448 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3638:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  74463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74487 */     GIR_RootConstrainSelectedInstOperands,
     /*  74488 */     // GIR_Coverage, 4387,
     /*  74488 */     GIR_EraseRootFromParent_Done,
     /*  74489 */   // Label 1471: @74489
     /*  74489 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(74578), // Rule ID 4389 //
     /*  74494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74537 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3638:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs8),
     /*  74552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74576 */     GIR_RootConstrainSelectedInstOperands,
     /*  74577 */     // GIR_Coverage, 4389,
     /*  74577 */     GIR_EraseRootFromParent_Done,
     /*  74578 */   // Label 1472: @74578
     /*  74578 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(74667), // Rule ID 4391 //
     /*  74583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74626 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3638:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  74641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74665 */     GIR_RootConstrainSelectedInstOperands,
     /*  74666 */     // GIR_Coverage, 4391,
     /*  74666 */     GIR_EraseRootFromParent_Done,
     /*  74667 */   // Label 1473: @74667
     /*  74667 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(74756), // Rule ID 4393 //
     /*  74672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74715 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3638:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs16),
     /*  74730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74754 */     GIR_RootConstrainSelectedInstOperands,
     /*  74755 */     // GIR_Coverage, 4393,
     /*  74755 */     GIR_EraseRootFromParent_Done,
     /*  74756 */   // Label 1474: @74756
     /*  74756 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(74845), // Rule ID 4395 //
     /*  74761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74804 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3638:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs32),
     /*  74819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74843 */     GIR_RootConstrainSelectedInstOperands,
     /*  74844 */     // GIR_Coverage, 4395,
     /*  74844 */     GIR_EraseRootFromParent_Done,
     /*  74845 */   // Label 1475: @74845
     /*  74845 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(74934), // Rule ID 4397 //
     /*  74850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74889 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74893 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3638:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs32),
     /*  74908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74932 */     GIR_RootConstrainSelectedInstOperands,
     /*  74933 */     // GIR_Coverage, 4397,
     /*  74933 */     GIR_EraseRootFromParent_Done,
     /*  74934 */   // Label 1476: @74934
     /*  74934 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(75023), // Rule ID 4399 //
     /*  74939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74982 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3638:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu8),
     /*  74997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75021 */     GIR_RootConstrainSelectedInstOperands,
     /*  75022 */     // GIR_Coverage, 4399,
     /*  75022 */     GIR_EraseRootFromParent_Done,
     /*  75023 */   // Label 1477: @75023
     /*  75023 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(75112), // Rule ID 4401 //
     /*  75028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75071 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3638:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  75071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu8),
     /*  75086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75110 */     GIR_RootConstrainSelectedInstOperands,
     /*  75111 */     // GIR_Coverage, 4401,
     /*  75111 */     GIR_EraseRootFromParent_Done,
     /*  75112 */   // Label 1478: @75112
     /*  75112 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(75201), // Rule ID 4403 //
     /*  75117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75160 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3638:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu16),
     /*  75175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75199 */     GIR_RootConstrainSelectedInstOperands,
     /*  75200 */     // GIR_Coverage, 4403,
     /*  75200 */     GIR_EraseRootFromParent_Done,
     /*  75201 */   // Label 1479: @75201
     /*  75201 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(75290), // Rule ID 4405 //
     /*  75206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75249 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3638:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu16),
     /*  75264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75288 */     GIR_RootConstrainSelectedInstOperands,
     /*  75289 */     // GIR_Coverage, 4405,
     /*  75289 */     GIR_EraseRootFromParent_Done,
     /*  75290 */   // Label 1480: @75290
     /*  75290 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(75379), // Rule ID 4407 //
     /*  75295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75338 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3638:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu32),
     /*  75353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75377 */     GIR_RootConstrainSelectedInstOperands,
     /*  75378 */     // GIR_Coverage, 4407,
     /*  75378 */     GIR_EraseRootFromParent_Done,
     /*  75379 */   // Label 1481: @75379
     /*  75379 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(75468), // Rule ID 4409 //
     /*  75384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75427 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3638:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu32),
     /*  75442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75466 */     GIR_RootConstrainSelectedInstOperands,
     /*  75467 */     // GIR_Coverage, 4409,
     /*  75467 */     GIR_EraseRootFromParent_Done,
     /*  75468 */   // Label 1482: @75468
     /*  75468 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(75566), // Rule ID 4032 //
     /*  75473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75512 */     // MIs[1] Operand 1
     /*  75512 */     // No operand predicates
     /*  75512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75522 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3581:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf16),
     /*  75537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75541 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75564 */     GIR_RootConstrainSelectedInstOperands,
     /*  75565 */     // GIR_Coverage, 4032,
     /*  75565 */     GIR_EraseRootFromParent_Done,
     /*  75566 */   // Label 1483: @75566
     /*  75566 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(75664), // Rule ID 4034 //
     /*  75571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75610 */     // MIs[1] Operand 1
     /*  75610 */     // No operand predicates
     /*  75610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75620 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3581:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf32),
     /*  75635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75639 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75662 */     GIR_RootConstrainSelectedInstOperands,
     /*  75663 */     // GIR_Coverage, 4034,
     /*  75663 */     GIR_EraseRootFromParent_Done,
     /*  75664 */   // Label 1484: @75664
     /*  75664 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(75762), // Rule ID 4541 //
     /*  75669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75708 */     // MIs[1] Operand 1
     /*  75708 */     // No operand predicates
     /*  75708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75718 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3581:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VCADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi8),
     /*  75733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75737 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75760 */     GIR_RootConstrainSelectedInstOperands,
     /*  75761 */     // GIR_Coverage, 4541,
     /*  75761 */     GIR_EraseRootFromParent_Done,
     /*  75762 */   // Label 1485: @75762
     /*  75762 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(75860), // Rule ID 4543 //
     /*  75767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75806 */     // MIs[1] Operand 1
     /*  75806 */     // No operand predicates
     /*  75806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75816 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3581:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VCADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi16),
     /*  75831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75835 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75858 */     GIR_RootConstrainSelectedInstOperands,
     /*  75859 */     // GIR_Coverage, 4543,
     /*  75859 */     GIR_EraseRootFromParent_Done,
     /*  75860 */   // Label 1486: @75860
     /*  75860 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(75958), // Rule ID 4545 //
     /*  75865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75904 */     // MIs[1] Operand 1
     /*  75904 */     // No operand predicates
     /*  75904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75914 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3581:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VCADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi32),
     /*  75929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75933 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75956 */     GIR_RootConstrainSelectedInstOperands,
     /*  75957 */     // GIR_Coverage, 4545,
     /*  75957 */     GIR_EraseRootFromParent_Done,
     /*  75958 */   // Label 1487: @75958
     /*  75958 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(76056), // Rule ID 4547 //
     /*  75963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76002 */     // MIs[1] Operand 1
     /*  76002 */     // No operand predicates
     /*  76002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76012 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3581:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VHCADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs8),
     /*  76027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76031 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76054 */     GIR_RootConstrainSelectedInstOperands,
     /*  76055 */     // GIR_Coverage, 4547,
     /*  76055 */     GIR_EraseRootFromParent_Done,
     /*  76056 */   // Label 1488: @76056
     /*  76056 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(76154), // Rule ID 4549 //
     /*  76061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  76069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  76096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76100 */     // MIs[1] Operand 1
     /*  76100 */     // No operand predicates
     /*  76100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76110 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3581:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VHCADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs16),
     /*  76125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76129 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76152 */     GIR_RootConstrainSelectedInstOperands,
     /*  76153 */     // GIR_Coverage, 4549,
     /*  76153 */     GIR_EraseRootFromParent_Done,
     /*  76154 */   // Label 1489: @76154
     /*  76154 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(76252), // Rule ID 4551 //
     /*  76159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  76167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  76194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76198 */     // MIs[1] Operand 1
     /*  76198 */     // No operand predicates
     /*  76198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76208 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3581:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VHCADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs32),
     /*  76223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76227 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76250 */     GIR_RootConstrainSelectedInstOperands,
     /*  76251 */     // GIR_Coverage, 4551,
     /*  76251 */     GIR_EraseRootFromParent_Done,
     /*  76252 */   // Label 1490: @76252
     /*  76252 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(76328), // Rule ID 3037 //
     /*  76257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76300 */     // (intrinsic_wo_chain:{ *:[i32] } 3574:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs8),
     /*  76303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76309 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76326 */     GIR_RootConstrainSelectedInstOperands,
     /*  76327 */     // GIR_Coverage, 3037,
     /*  76327 */     GIR_EraseRootFromParent_Done,
     /*  76328 */   // Label 1491: @76328
     /*  76328 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(76404), // Rule ID 3039 //
     /*  76333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76376 */     // (intrinsic_wo_chain:{ *:[i32] } 3574:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs16),
     /*  76379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76385 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76402 */     GIR_RootConstrainSelectedInstOperands,
     /*  76403 */     // GIR_Coverage, 3039,
     /*  76403 */     GIR_EraseRootFromParent_Done,
     /*  76404 */   // Label 1492: @76404
     /*  76404 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(76480), // Rule ID 3041 //
     /*  76409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76452 */     // (intrinsic_wo_chain:{ *:[i32] } 3574:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs32),
     /*  76455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76461 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76478 */     GIR_RootConstrainSelectedInstOperands,
     /*  76479 */     // GIR_Coverage, 3041,
     /*  76479 */     GIR_EraseRootFromParent_Done,
     /*  76480 */   // Label 1493: @76480
     /*  76480 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(76556), // Rule ID 3043 //
     /*  76485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76528 */     // (intrinsic_wo_chain:{ *:[i32] } 3574:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVu8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu8),
     /*  76531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76537 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76554 */     GIR_RootConstrainSelectedInstOperands,
     /*  76555 */     // GIR_Coverage, 3043,
     /*  76555 */     GIR_EraseRootFromParent_Done,
     /*  76556 */   // Label 1494: @76556
     /*  76556 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(76632), // Rule ID 3045 //
     /*  76561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76604 */     // (intrinsic_wo_chain:{ *:[i32] } 3574:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVu16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu16),
     /*  76607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76613 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76630 */     GIR_RootConstrainSelectedInstOperands,
     /*  76631 */     // GIR_Coverage, 3045,
     /*  76631 */     GIR_EraseRootFromParent_Done,
     /*  76632 */   // Label 1495: @76632
     /*  76632 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(76708), // Rule ID 3047 //
     /*  76637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76680 */     // (intrinsic_wo_chain:{ *:[i32] } 3574:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVu32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu32),
     /*  76683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76689 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76706 */     GIR_RootConstrainSelectedInstOperands,
     /*  76707 */     // GIR_Coverage, 3047,
     /*  76707 */     GIR_EraseRootFromParent_Done,
     /*  76708 */   // Label 1496: @76708
     /*  76708 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(76793), // Rule ID 3996 //
     /*  76713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76748 */     // MIs[1] Operand 1
     /*  76748 */     // No operand predicates
     /*  76748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76762 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3584:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMLAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf16),
     /*  76765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76771 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76791 */     GIR_RootConstrainSelectedInstOperands,
     /*  76792 */     // GIR_Coverage, 3996,
     /*  76792 */     GIR_EraseRootFromParent_Done,
     /*  76793 */   // Label 1497: @76793
     /*  76793 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(76878), // Rule ID 3999 //
     /*  76798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76833 */     // MIs[1] Operand 1
     /*  76833 */     // No operand predicates
     /*  76833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76847 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3584:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMLAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf32),
     /*  76850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76856 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76876 */     GIR_RootConstrainSelectedInstOperands,
     /*  76877 */     // GIR_Coverage, 3999,
     /*  76877 */     GIR_EraseRootFromParent_Done,
     /*  76878 */   // Label 1498: @76878
     /*  76878 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(76974), // Rule ID 2688 //
     /*  76883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx2),
     /*  76891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76910 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3840:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX2:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v16i8] } DPair:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  76913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  76926 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76929 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  76933 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPairRegClassID),
     /*  76941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX2),
     /*  76954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76956 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  76958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76961 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76972 */     GIR_RootConstrainSelectedInstOperands,
     /*  76973 */     // GIR_Coverage, 2688,
     /*  76973 */     GIR_EraseRootFromParent_Done,
     /*  76974 */   // Label 1499: @76974
     /*  76974 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(77105), // Rule ID 2689 //
     /*  76979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl3),
     /*  76987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  77002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  77006 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3837:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL3Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  77006 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  77009 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77013 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  77023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  77027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77032 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  77036 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  77039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  77043 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  77046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  77050 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  77053 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77056 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  77059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  77064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  77069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  77074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  77079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  77084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL3Pseudo),
     /*  77087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77092 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  77094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  77097 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77103 */     GIR_RootConstrainSelectedInstOperands,
     /*  77104 */     // GIR_Coverage, 2689,
     /*  77104 */     GIR_EraseRootFromParent_Done,
     /*  77105 */   // Label 1500: @77105
     /*  77105 */   GIM_Reject,
     /*  77106 */ // Label 1462: @77106
     /*  77106 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(82412),
     /*  77111 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  77114 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(77207), // Rule ID 3838 //
     /*  77119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77166 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs8),
     /*  77181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77183 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77185 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77205 */     GIR_RootConstrainSelectedInstOperands,
     /*  77206 */     // GIR_Coverage, 3838,
     /*  77206 */     GIR_EraseRootFromParent_Done,
     /*  77207 */   // Label 1502: @77207
     /*  77207 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(77300), // Rule ID 3840 //
     /*  77212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77251 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77259 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs16),
     /*  77274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77276 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77278 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77298 */     GIR_RootConstrainSelectedInstOperands,
     /*  77299 */     // GIR_Coverage, 3840,
     /*  77299 */     GIR_EraseRootFromParent_Done,
     /*  77300 */   // Label 1503: @77300
     /*  77300 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(77393), // Rule ID 3842 //
     /*  77305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77352 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs32),
     /*  77367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77369 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77371 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77391 */     GIR_RootConstrainSelectedInstOperands,
     /*  77392 */     // GIR_Coverage, 3842,
     /*  77392 */     GIR_EraseRootFromParent_Done,
     /*  77393 */   // Label 1504: @77393
     /*  77393 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(77486), // Rule ID 3844 //
     /*  77398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77445 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu8),
     /*  77460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77462 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77464 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77484 */     GIR_RootConstrainSelectedInstOperands,
     /*  77485 */     // GIR_Coverage, 3844,
     /*  77485 */     GIR_EraseRootFromParent_Done,
     /*  77486 */   // Label 1505: @77486
     /*  77486 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(77579), // Rule ID 3846 //
     /*  77491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77538 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu16),
     /*  77553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77555 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77557 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77577 */     GIR_RootConstrainSelectedInstOperands,
     /*  77578 */     // GIR_Coverage, 3846,
     /*  77578 */     GIR_EraseRootFromParent_Done,
     /*  77579 */   // Label 1506: @77579
     /*  77579 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(77672), // Rule ID 3848 //
     /*  77584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77631 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu32),
     /*  77646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77648 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77650 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77670 */     GIR_RootConstrainSelectedInstOperands,
     /*  77671 */     // GIR_Coverage, 3848,
     /*  77671 */     GIR_EraseRootFromParent_Done,
     /*  77672 */   // Label 1507: @77672
     /*  77672 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(77765), // Rule ID 3850 //
     /*  77677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77724 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs8),
     /*  77739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77741 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77743 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77763 */     GIR_RootConstrainSelectedInstOperands,
     /*  77764 */     // GIR_Coverage, 3850,
     /*  77764 */     GIR_EraseRootFromParent_Done,
     /*  77765 */   // Label 1508: @77765
     /*  77765 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(77858), // Rule ID 3852 //
     /*  77770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77817 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs16),
     /*  77832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77834 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77836 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77856 */     GIR_RootConstrainSelectedInstOperands,
     /*  77857 */     // GIR_Coverage, 3852,
     /*  77857 */     GIR_EraseRootFromParent_Done,
     /*  77858 */   // Label 1509: @77858
     /*  77858 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(77951), // Rule ID 3854 //
     /*  77863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77910 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs32),
     /*  77925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77927 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77929 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77949 */     GIR_RootConstrainSelectedInstOperands,
     /*  77950 */     // GIR_Coverage, 3854,
     /*  77950 */     GIR_EraseRootFromParent_Done,
     /*  77951 */   // Label 1510: @77951
     /*  77951 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(78044), // Rule ID 3856 //
     /*  77956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78003 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu8),
     /*  78018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78020 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78022 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78042 */     GIR_RootConstrainSelectedInstOperands,
     /*  78043 */     // GIR_Coverage, 3856,
     /*  78043 */     GIR_EraseRootFromParent_Done,
     /*  78044 */   // Label 1511: @78044
     /*  78044 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(78137), // Rule ID 3858 //
     /*  78049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78096 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu16),
     /*  78111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78113 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78115 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78135 */     GIR_RootConstrainSelectedInstOperands,
     /*  78136 */     // GIR_Coverage, 3858,
     /*  78136 */     GIR_EraseRootFromParent_Done,
     /*  78137 */   // Label 1512: @78137
     /*  78137 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(78230), // Rule ID 3860 //
     /*  78142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78189 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu32),
     /*  78204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78206 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78208 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78213 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78219 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78228 */     GIR_RootConstrainSelectedInstOperands,
     /*  78229 */     // GIR_Coverage, 3860,
     /*  78229 */     GIR_EraseRootFromParent_Done,
     /*  78230 */   // Label 1513: @78230
     /*  78230 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(78323), // Rule ID 3862 //
     /*  78235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78282 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs8),
     /*  78297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78299 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78301 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78321 */     GIR_RootConstrainSelectedInstOperands,
     /*  78322 */     // GIR_Coverage, 3862,
     /*  78322 */     GIR_EraseRootFromParent_Done,
     /*  78323 */   // Label 1514: @78323
     /*  78323 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(78416), // Rule ID 3864 //
     /*  78328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78375 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs16),
     /*  78390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78392 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78394 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78414 */     GIR_RootConstrainSelectedInstOperands,
     /*  78415 */     // GIR_Coverage, 3864,
     /*  78415 */     GIR_EraseRootFromParent_Done,
     /*  78416 */   // Label 1515: @78416
     /*  78416 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(78509), // Rule ID 3866 //
     /*  78421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78468 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs32),
     /*  78483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78485 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78487 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78507 */     GIR_RootConstrainSelectedInstOperands,
     /*  78508 */     // GIR_Coverage, 3866,
     /*  78508 */     GIR_EraseRootFromParent_Done,
     /*  78509 */   // Label 1516: @78509
     /*  78509 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(78602), // Rule ID 3868 //
     /*  78514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78561 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu8),
     /*  78576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78578 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78580 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78600 */     GIR_RootConstrainSelectedInstOperands,
     /*  78601 */     // GIR_Coverage, 3868,
     /*  78601 */     GIR_EraseRootFromParent_Done,
     /*  78602 */   // Label 1517: @78602
     /*  78602 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(78695), // Rule ID 3870 //
     /*  78607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78654 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu16),
     /*  78669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78671 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78673 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78693 */     GIR_RootConstrainSelectedInstOperands,
     /*  78694 */     // GIR_Coverage, 3870,
     /*  78694 */     GIR_EraseRootFromParent_Done,
     /*  78695 */   // Label 1518: @78695
     /*  78695 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(78788), // Rule ID 3872 //
     /*  78700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78747 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu32),
     /*  78762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78764 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78766 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78786 */     GIR_RootConstrainSelectedInstOperands,
     /*  78787 */     // GIR_Coverage, 3872,
     /*  78787 */     GIR_EraseRootFromParent_Done,
     /*  78788 */   // Label 1519: @78788
     /*  78788 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(78881), // Rule ID 3874 //
     /*  78793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78840 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs8),
     /*  78855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78857 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78859 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78879 */     GIR_RootConstrainSelectedInstOperands,
     /*  78880 */     // GIR_Coverage, 3874,
     /*  78880 */     GIR_EraseRootFromParent_Done,
     /*  78881 */   // Label 1520: @78881
     /*  78881 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(78974), // Rule ID 3876 //
     /*  78886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78933 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs16),
     /*  78948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78950 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78952 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78972 */     GIR_RootConstrainSelectedInstOperands,
     /*  78973 */     // GIR_Coverage, 3876,
     /*  78973 */     GIR_EraseRootFromParent_Done,
     /*  78974 */   // Label 1521: @78974
     /*  78974 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(79067), // Rule ID 3878 //
     /*  78979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79026 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  79026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs32),
     /*  79041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79043 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79045 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79065 */     GIR_RootConstrainSelectedInstOperands,
     /*  79066 */     // GIR_Coverage, 3878,
     /*  79066 */     GIR_EraseRootFromParent_Done,
     /*  79067 */   // Label 1522: @79067
     /*  79067 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(79160), // Rule ID 3880 //
     /*  79072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79119 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  79119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu8),
     /*  79134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79136 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79138 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79158 */     GIR_RootConstrainSelectedInstOperands,
     /*  79159 */     // GIR_Coverage, 3880,
     /*  79159 */     GIR_EraseRootFromParent_Done,
     /*  79160 */   // Label 1523: @79160
     /*  79160 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(79253), // Rule ID 3882 //
     /*  79165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79212 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  79212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu16),
     /*  79227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79229 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79231 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79251 */     GIR_RootConstrainSelectedInstOperands,
     /*  79252 */     // GIR_Coverage, 3882,
     /*  79252 */     GIR_EraseRootFromParent_Done,
     /*  79253 */   // Label 1524: @79253
     /*  79253 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(79346), // Rule ID 3884 //
     /*  79258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  79266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79305 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  79305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu32),
     /*  79320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79322 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79324 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79344 */     GIR_RootConstrainSelectedInstOperands,
     /*  79345 */     // GIR_Coverage, 3884,
     /*  79345 */     GIR_EraseRootFromParent_Done,
     /*  79346 */   // Label 1525: @79346
     /*  79346 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(79424), // Rule ID 4489 //
     /*  79351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79398 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3649:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32bh),
     /*  79401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79422 */     GIR_RootConstrainSelectedInstOperands,
     /*  79423 */     // GIR_Coverage, 4489,
     /*  79423 */     GIR_EraseRootFromParent_Done,
     /*  79424 */   // Label 1526: @79424
     /*  79424 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(79502), // Rule ID 4491 //
     /*  79429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79476 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3649:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32th),
     /*  79479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79500 */     GIR_RootConstrainSelectedInstOperands,
     /*  79501 */     // GIR_Coverage, 4491,
     /*  79501 */     GIR_EraseRootFromParent_Done,
     /*  79502 */   // Label 1527: @79502
     /*  79502 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(79580), // Rule ID 4493 //
     /*  79507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79554 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3649:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16bh),
     /*  79557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79578 */     GIR_RootConstrainSelectedInstOperands,
     /*  79579 */     // GIR_Coverage, 4493,
     /*  79579 */     GIR_EraseRootFromParent_Done,
     /*  79580 */   // Label 1528: @79580
     /*  79580 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(79658), // Rule ID 4495 //
     /*  79585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79632 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3649:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16th),
     /*  79635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79656 */     GIR_RootConstrainSelectedInstOperands,
     /*  79657 */     // GIR_Coverage, 4495,
     /*  79657 */     GIR_EraseRootFromParent_Done,
     /*  79658 */   // Label 1529: @79658
     /*  79658 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(79736), // Rule ID 4497 //
     /*  79663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79710 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3649:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32bh),
     /*  79713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79734 */     GIR_RootConstrainSelectedInstOperands,
     /*  79735 */     // GIR_Coverage, 4497,
     /*  79735 */     GIR_EraseRootFromParent_Done,
     /*  79736 */   // Label 1530: @79736
     /*  79736 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(79814), // Rule ID 4499 //
     /*  79741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79788 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3649:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32th),
     /*  79791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79812 */     GIR_RootConstrainSelectedInstOperands,
     /*  79813 */     // GIR_Coverage, 4499,
     /*  79813 */     GIR_EraseRootFromParent_Done,
     /*  79814 */   // Label 1531: @79814
     /*  79814 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(79892), // Rule ID 4501 //
     /*  79819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79866 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3649:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16bh),
     /*  79869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79890 */     GIR_RootConstrainSelectedInstOperands,
     /*  79891 */     // GIR_Coverage, 4501,
     /*  79891 */     GIR_EraseRootFromParent_Done,
     /*  79892 */   // Label 1532: @79892
     /*  79892 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(79970), // Rule ID 4503 //
     /*  79897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79944 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3649:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16th),
     /*  79947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79968 */     GIR_RootConstrainSelectedInstOperands,
     /*  79969 */     // GIR_Coverage, 4503,
     /*  79969 */     GIR_EraseRootFromParent_Done,
     /*  79970 */   // Label 1533: @79970
     /*  79970 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(80048), // Rule ID 4505 //
     /*  79975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80022 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3649:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  80022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32bh),
     /*  80025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80046 */     GIR_RootConstrainSelectedInstOperands,
     /*  80047 */     // GIR_Coverage, 4505,
     /*  80047 */     GIR_EraseRootFromParent_Done,
     /*  80048 */   // Label 1534: @80048
     /*  80048 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(80126), // Rule ID 4507 //
     /*  80053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  80067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80100 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3649:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  80100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32th),
     /*  80103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80124 */     GIR_RootConstrainSelectedInstOperands,
     /*  80125 */     // GIR_Coverage, 4507,
     /*  80125 */     GIR_EraseRootFromParent_Done,
     /*  80126 */   // Label 1535: @80126
     /*  80126 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(80204), // Rule ID 4509 //
     /*  80131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80178 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3649:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16bh),
     /*  80181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80202 */     GIR_RootConstrainSelectedInstOperands,
     /*  80203 */     // GIR_Coverage, 4509,
     /*  80203 */     GIR_EraseRootFromParent_Done,
     /*  80204 */   // Label 1536: @80204
     /*  80204 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(80282), // Rule ID 4511 //
     /*  80209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80256 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3649:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16th),
     /*  80259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80280 */     GIR_RootConstrainSelectedInstOperands,
     /*  80281 */     // GIR_Coverage, 4511,
     /*  80281 */     GIR_EraseRootFromParent_Done,
     /*  80282 */   // Label 1537: @80282
     /*  80282 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(80360), // Rule ID 4701 //
     /*  80287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80334 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs8),
     /*  80337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80339 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80341 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80358 */     GIR_RootConstrainSelectedInstOperands,
     /*  80359 */     // GIR_Coverage, 4701,
     /*  80359 */     GIR_EraseRootFromParent_Done,
     /*  80360 */   // Label 1538: @80360
     /*  80360 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(80438), // Rule ID 4703 //
     /*  80365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80412 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs16),
     /*  80415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80417 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80419 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80436 */     GIR_RootConstrainSelectedInstOperands,
     /*  80437 */     // GIR_Coverage, 4703,
     /*  80437 */     GIR_EraseRootFromParent_Done,
     /*  80438 */   // Label 1539: @80438
     /*  80438 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(80516), // Rule ID 4705 //
     /*  80443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80490 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs32),
     /*  80493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80495 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80497 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80514 */     GIR_RootConstrainSelectedInstOperands,
     /*  80515 */     // GIR_Coverage, 4705,
     /*  80515 */     GIR_EraseRootFromParent_Done,
     /*  80516 */   // Label 1540: @80516
     /*  80516 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(80594), // Rule ID 4707 //
     /*  80521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80568 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru8),
     /*  80571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80573 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80575 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80592 */     GIR_RootConstrainSelectedInstOperands,
     /*  80593 */     // GIR_Coverage, 4707,
     /*  80593 */     GIR_EraseRootFromParent_Done,
     /*  80594 */   // Label 1541: @80594
     /*  80594 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(80672), // Rule ID 4709 //
     /*  80599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80646 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru16),
     /*  80649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80651 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80653 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80670 */     GIR_RootConstrainSelectedInstOperands,
     /*  80671 */     // GIR_Coverage, 4709,
     /*  80671 */     GIR_EraseRootFromParent_Done,
     /*  80672 */   // Label 1542: @80672
     /*  80672 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(80750), // Rule ID 4711 //
     /*  80677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80724 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru32),
     /*  80727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80729 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80731 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80748 */     GIR_RootConstrainSelectedInstOperands,
     /*  80749 */     // GIR_Coverage, 4711,
     /*  80749 */     GIR_EraseRootFromParent_Done,
     /*  80750 */   // Label 1543: @80750
     /*  80750 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(80828), // Rule ID 4713 //
     /*  80755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80802 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs8),
     /*  80805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80807 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80809 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80826 */     GIR_RootConstrainSelectedInstOperands,
     /*  80827 */     // GIR_Coverage, 4713,
     /*  80827 */     GIR_EraseRootFromParent_Done,
     /*  80828 */   // Label 1544: @80828
     /*  80828 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(80906), // Rule ID 4715 //
     /*  80833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80880 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs16),
     /*  80883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80885 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80887 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80904 */     GIR_RootConstrainSelectedInstOperands,
     /*  80905 */     // GIR_Coverage, 4715,
     /*  80905 */     GIR_EraseRootFromParent_Done,
     /*  80906 */   // Label 1545: @80906
     /*  80906 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(80984), // Rule ID 4717 //
     /*  80911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80958 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs32),
     /*  80961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80963 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80965 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80982 */     GIR_RootConstrainSelectedInstOperands,
     /*  80983 */     // GIR_Coverage, 4717,
     /*  80983 */     GIR_EraseRootFromParent_Done,
     /*  80984 */   // Label 1546: @80984
     /*  80984 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(81062), // Rule ID 4719 //
     /*  80989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81036 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru8),
     /*  81039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81041 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81043 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81060 */     GIR_RootConstrainSelectedInstOperands,
     /*  81061 */     // GIR_Coverage, 4719,
     /*  81061 */     GIR_EraseRootFromParent_Done,
     /*  81062 */   // Label 1547: @81062
     /*  81062 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(81140), // Rule ID 4721 //
     /*  81067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81114 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru16),
     /*  81117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81119 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81121 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81138 */     GIR_RootConstrainSelectedInstOperands,
     /*  81139 */     // GIR_Coverage, 4721,
     /*  81139 */     GIR_EraseRootFromParent_Done,
     /*  81140 */   // Label 1548: @81140
     /*  81140 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(81218), // Rule ID 4723 //
     /*  81145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81192 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru32),
     /*  81195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81197 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81199 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81216 */     GIR_RootConstrainSelectedInstOperands,
     /*  81217 */     // GIR_Coverage, 4723,
     /*  81217 */     GIR_EraseRootFromParent_Done,
     /*  81218 */   // Label 1549: @81218
     /*  81218 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(81296), // Rule ID 4725 //
     /*  81223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81270 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs8),
     /*  81273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81275 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81277 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81294 */     GIR_RootConstrainSelectedInstOperands,
     /*  81295 */     // GIR_Coverage, 4725,
     /*  81295 */     GIR_EraseRootFromParent_Done,
     /*  81296 */   // Label 1550: @81296
     /*  81296 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(81374), // Rule ID 4727 //
     /*  81301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81348 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs16),
     /*  81351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81353 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81355 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81372 */     GIR_RootConstrainSelectedInstOperands,
     /*  81373 */     // GIR_Coverage, 4727,
     /*  81373 */     GIR_EraseRootFromParent_Done,
     /*  81374 */   // Label 1551: @81374
     /*  81374 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(81452), // Rule ID 4729 //
     /*  81379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81426 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs32),
     /*  81429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81431 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81433 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81450 */     GIR_RootConstrainSelectedInstOperands,
     /*  81451 */     // GIR_Coverage, 4729,
     /*  81451 */     GIR_EraseRootFromParent_Done,
     /*  81452 */   // Label 1552: @81452
     /*  81452 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(81530), // Rule ID 4731 //
     /*  81457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81504 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru8),
     /*  81507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81509 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81511 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81528 */     GIR_RootConstrainSelectedInstOperands,
     /*  81529 */     // GIR_Coverage, 4731,
     /*  81529 */     GIR_EraseRootFromParent_Done,
     /*  81530 */   // Label 1553: @81530
     /*  81530 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(81608), // Rule ID 4733 //
     /*  81535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81582 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru16),
     /*  81585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81587 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81589 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81606 */     GIR_RootConstrainSelectedInstOperands,
     /*  81607 */     // GIR_Coverage, 4733,
     /*  81607 */     GIR_EraseRootFromParent_Done,
     /*  81608 */   // Label 1554: @81608
     /*  81608 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(81686), // Rule ID 4735 //
     /*  81613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81660 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru32),
     /*  81663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81665 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81667 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81684 */     GIR_RootConstrainSelectedInstOperands,
     /*  81685 */     // GIR_Coverage, 4735,
     /*  81685 */     GIR_EraseRootFromParent_Done,
     /*  81686 */   // Label 1555: @81686
     /*  81686 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(81764), // Rule ID 4737 //
     /*  81691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81738 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs8),
     /*  81741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81743 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81745 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81762 */     GIR_RootConstrainSelectedInstOperands,
     /*  81763 */     // GIR_Coverage, 4737,
     /*  81763 */     GIR_EraseRootFromParent_Done,
     /*  81764 */   // Label 1556: @81764
     /*  81764 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(81842), // Rule ID 4739 //
     /*  81769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81816 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs16),
     /*  81819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81821 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81823 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81840 */     GIR_RootConstrainSelectedInstOperands,
     /*  81841 */     // GIR_Coverage, 4739,
     /*  81841 */     GIR_EraseRootFromParent_Done,
     /*  81842 */   // Label 1557: @81842
     /*  81842 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(81920), // Rule ID 4741 //
     /*  81847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81894 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs32),
     /*  81897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81899 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81901 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81918 */     GIR_RootConstrainSelectedInstOperands,
     /*  81919 */     // GIR_Coverage, 4741,
     /*  81919 */     GIR_EraseRootFromParent_Done,
     /*  81920 */   // Label 1558: @81920
     /*  81920 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(81998), // Rule ID 4743 //
     /*  81925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81972 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru8),
     /*  81975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81977 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81979 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81996 */     GIR_RootConstrainSelectedInstOperands,
     /*  81997 */     // GIR_Coverage, 4743,
     /*  81997 */     GIR_EraseRootFromParent_Done,
     /*  81998 */   // Label 1559: @81998
     /*  81998 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(82076), // Rule ID 4745 //
     /*  82003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  82008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  82011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  82038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  82046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  82050 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  82050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru16),
     /*  82053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  82055 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  82057 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  82059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82074 */     GIR_RootConstrainSelectedInstOperands,
     /*  82075 */     // GIR_Coverage, 4745,
     /*  82075 */     GIR_EraseRootFromParent_Done,
     /*  82076 */   // Label 1560: @82076
     /*  82076 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(82154), // Rule ID 4747 //
     /*  82081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  82086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  82089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  82116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  82124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  82128 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  82128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru32),
     /*  82131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  82133 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  82135 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  82137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82152 */     GIR_RootConstrainSelectedInstOperands,
     /*  82153 */     // GIR_Coverage, 4747,
     /*  82153 */     GIR_EraseRootFromParent_Done,
     /*  82154 */   // Label 1561: @82154
     /*  82154 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(82290), // Rule ID 2690 //
     /*  82159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx3),
     /*  82167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82189 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3841:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX3Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82189 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  82192 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82196 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  82219 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  82226 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82229 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  82233 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82236 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82239 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX3Pseudo),
     /*  82270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82272 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  82274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82277 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82288 */     GIR_RootConstrainSelectedInstOperands,
     /*  82289 */     // GIR_Coverage, 2690,
     /*  82289 */     GIR_EraseRootFromParent_Done,
     /*  82290 */   // Label 1562: @82290
     /*  82290 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(82411), // Rule ID 2691 //
     /*  82295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl4),
     /*  82303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82325 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3838:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL4Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82337 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  82341 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  82348 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  82355 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn3
     /*  82362 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL4Pseudo),
     /*  82393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82398 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82409 */     GIR_RootConstrainSelectedInstOperands,
     /*  82410 */     // GIR_Coverage, 2691,
     /*  82410 */     GIR_EraseRootFromParent_Done,
     /*  82411 */   // Label 1563: @82411
     /*  82411 */   GIM_Reject,
     /*  82412 */ // Label 1501: @82412
     /*  82412 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(87305),
     /*  82417 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  82420 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(82508), // Rule ID 3181 //
     /*  82425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82474 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82478 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82482 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs8),
     /*  82485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82487 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82489 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82506 */     GIR_RootConstrainSelectedInstOperands,
     /*  82507 */     // GIR_Coverage, 3181,
     /*  82507 */     GIR_EraseRootFromParent_Done,
     /*  82508 */   // Label 1565: @82508
     /*  82508 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(82596), // Rule ID 3185 //
     /*  82513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82562 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82566 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82570 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs8),
     /*  82573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82575 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82577 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82594 */     GIR_RootConstrainSelectedInstOperands,
     /*  82595 */     // GIR_Coverage, 3185,
     /*  82595 */     GIR_EraseRootFromParent_Done,
     /*  82596 */   // Label 1566: @82596
     /*  82596 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(82684), // Rule ID 3189 //
     /*  82601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82650 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82654 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82658 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVu8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /*  82661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82663 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82665 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82682 */     GIR_RootConstrainSelectedInstOperands,
     /*  82683 */     // GIR_Coverage, 3189,
     /*  82683 */     GIR_EraseRootFromParent_Done,
     /*  82684 */   // Label 1567: @82684
     /*  82684 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(82772), // Rule ID 3193 //
     /*  82689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82738 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82742 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82746 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs16),
     /*  82749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82751 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82753 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82770 */     GIR_RootConstrainSelectedInstOperands,
     /*  82771 */     // GIR_Coverage, 3193,
     /*  82771 */     GIR_EraseRootFromParent_Done,
     /*  82772 */   // Label 1568: @82772
     /*  82772 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(82860), // Rule ID 3197 //
     /*  82777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82822 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82826 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82830 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82834 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs16),
     /*  82837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82839 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82841 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82858 */     GIR_RootConstrainSelectedInstOperands,
     /*  82859 */     // GIR_Coverage, 3197,
     /*  82859 */     GIR_EraseRootFromParent_Done,
     /*  82860 */   // Label 1569: @82860
     /*  82860 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(82948), // Rule ID 3201 //
     /*  82865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82914 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82918 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82922 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVu16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /*  82925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82927 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82929 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82946 */     GIR_RootConstrainSelectedInstOperands,
     /*  82947 */     // GIR_Coverage, 3201,
     /*  82947 */     GIR_EraseRootFromParent_Done,
     /*  82948 */   // Label 1570: @82948
     /*  82948 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(83036), // Rule ID 3205 //
     /*  82953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83002 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83006 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83010 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs32),
     /*  83013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83015 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83017 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83034 */     GIR_RootConstrainSelectedInstOperands,
     /*  83035 */     // GIR_Coverage, 3205,
     /*  83035 */     GIR_EraseRootFromParent_Done,
     /*  83036 */   // Label 1571: @83036
     /*  83036 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(83124), // Rule ID 3209 //
     /*  83041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83090 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83094 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83098 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs32),
     /*  83101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83103 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83105 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83122 */     GIR_RootConstrainSelectedInstOperands,
     /*  83123 */     // GIR_Coverage, 3209,
     /*  83123 */     GIR_EraseRootFromParent_Done,
     /*  83124 */   // Label 1572: @83124
     /*  83124 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(83212), // Rule ID 3213 //
     /*  83129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83178 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83182 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83186 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVu32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /*  83189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83191 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83193 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83210 */     GIR_RootConstrainSelectedInstOperands,
     /*  83211 */     // GIR_Coverage, 3213,
     /*  83211 */     GIR_EraseRootFromParent_Done,
     /*  83212 */   // Label 1573: @83212
     /*  83212 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(83300), // Rule ID 3217 //
     /*  83217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83266 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83270 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83274 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs8),
     /*  83277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83279 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83281 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83298 */     GIR_RootConstrainSelectedInstOperands,
     /*  83299 */     // GIR_Coverage, 3217,
     /*  83299 */     GIR_EraseRootFromParent_Done,
     /*  83300 */   // Label 1574: @83300
     /*  83300 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(83388), // Rule ID 3221 //
     /*  83305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83354 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83358 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83362 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs8),
     /*  83365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83367 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83369 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83386 */     GIR_RootConstrainSelectedInstOperands,
     /*  83387 */     // GIR_Coverage, 3221,
     /*  83387 */     GIR_EraseRootFromParent_Done,
     /*  83388 */   // Label 1575: @83388
     /*  83388 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(83476), // Rule ID 3225 //
     /*  83393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83442 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83446 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83450 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs16),
     /*  83453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83455 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83457 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83474 */     GIR_RootConstrainSelectedInstOperands,
     /*  83475 */     // GIR_Coverage, 3225,
     /*  83475 */     GIR_EraseRootFromParent_Done,
     /*  83476 */   // Label 1576: @83476
     /*  83476 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(83564), // Rule ID 3229 //
     /*  83481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83530 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83534 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83538 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs16),
     /*  83541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83543 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83545 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83562 */     GIR_RootConstrainSelectedInstOperands,
     /*  83563 */     // GIR_Coverage, 3229,
     /*  83563 */     GIR_EraseRootFromParent_Done,
     /*  83564 */   // Label 1577: @83564
     /*  83564 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(83652), // Rule ID 3233 //
     /*  83569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83618 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83622 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83626 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs32),
     /*  83629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83631 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83633 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83650 */     GIR_RootConstrainSelectedInstOperands,
     /*  83651 */     // GIR_Coverage, 3233,
     /*  83651 */     GIR_EraseRootFromParent_Done,
     /*  83652 */   // Label 1578: @83652
     /*  83652 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(83740), // Rule ID 3237 //
     /*  83657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83706 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83710 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83714 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs32),
     /*  83717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83719 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83721 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83738 */     GIR_RootConstrainSelectedInstOperands,
     /*  83739 */     // GIR_Coverage, 3237,
     /*  83739 */     GIR_EraseRootFromParent_Done,
     /*  83740 */   // Label 1579: @83740
     /*  83740 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(83830), // Rule ID 3183 //
     /*  83745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83794 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83798 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83802 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas8),
     /*  83805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83807 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83809 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83811 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83828 */     GIR_RootConstrainSelectedInstOperands,
     /*  83829 */     // GIR_Coverage, 3183,
     /*  83829 */     GIR_EraseRootFromParent_Done,
     /*  83830 */   // Label 1580: @83830
     /*  83830 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(83920), // Rule ID 3187 //
     /*  83835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83884 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83888 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83892 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs8),
     /*  83895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83897 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83899 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83901 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83918 */     GIR_RootConstrainSelectedInstOperands,
     /*  83919 */     // GIR_Coverage, 3187,
     /*  83919 */     GIR_EraseRootFromParent_Done,
     /*  83920 */   // Label 1581: @83920
     /*  83920 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(84010), // Rule ID 3191 //
     /*  83925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83974 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83978 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83982 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVau8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*  83985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83987 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83989 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83991 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84008 */     GIR_RootConstrainSelectedInstOperands,
     /*  84009 */     // GIR_Coverage, 3191,
     /*  84009 */     GIR_EraseRootFromParent_Done,
     /*  84010 */   // Label 1582: @84010
     /*  84010 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(84100), // Rule ID 3195 //
     /*  84015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84064 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84068 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84072 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas16),
     /*  84075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84077 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84079 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84081 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84098 */     GIR_RootConstrainSelectedInstOperands,
     /*  84099 */     // GIR_Coverage, 3195,
     /*  84099 */     GIR_EraseRootFromParent_Done,
     /*  84100 */   // Label 1583: @84100
     /*  84100 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(84190), // Rule ID 3199 //
     /*  84105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84154 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84158 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84162 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs16),
     /*  84165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84167 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84169 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84171 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84188 */     GIR_RootConstrainSelectedInstOperands,
     /*  84189 */     // GIR_Coverage, 3199,
     /*  84189 */     GIR_EraseRootFromParent_Done,
     /*  84190 */   // Label 1584: @84190
     /*  84190 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(84280), // Rule ID 3203 //
     /*  84195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84244 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84248 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84252 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVau16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*  84255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84257 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84259 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84261 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84278 */     GIR_RootConstrainSelectedInstOperands,
     /*  84279 */     // GIR_Coverage, 3203,
     /*  84279 */     GIR_EraseRootFromParent_Done,
     /*  84280 */   // Label 1585: @84280
     /*  84280 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(84370), // Rule ID 3207 //
     /*  84285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84334 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84338 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84342 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas32),
     /*  84345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84347 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84349 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84351 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84368 */     GIR_RootConstrainSelectedInstOperands,
     /*  84369 */     // GIR_Coverage, 3207,
     /*  84369 */     GIR_EraseRootFromParent_Done,
     /*  84370 */   // Label 1586: @84370
     /*  84370 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(84460), // Rule ID 3211 //
     /*  84375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84424 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84428 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84432 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs32),
     /*  84435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84437 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84439 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84441 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84458 */     GIR_RootConstrainSelectedInstOperands,
     /*  84459 */     // GIR_Coverage, 3211,
     /*  84459 */     GIR_EraseRootFromParent_Done,
     /*  84460 */   // Label 1587: @84460
     /*  84460 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(84550), // Rule ID 3215 //
     /*  84465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84514 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84518 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84522 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVau32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*  84525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84527 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84529 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84531 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84548 */     GIR_RootConstrainSelectedInstOperands,
     /*  84549 */     // GIR_Coverage, 3215,
     /*  84549 */     GIR_EraseRootFromParent_Done,
     /*  84550 */   // Label 1588: @84550
     /*  84550 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(84640), // Rule ID 3219 //
     /*  84555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84604 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84608 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84612 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas8),
     /*  84615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84617 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84619 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84621 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84638 */     GIR_RootConstrainSelectedInstOperands,
     /*  84639 */     // GIR_Coverage, 3219,
     /*  84639 */     GIR_EraseRootFromParent_Done,
     /*  84640 */   // Label 1589: @84640
     /*  84640 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(84730), // Rule ID 3223 //
     /*  84645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84694 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84698 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84702 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs8),
     /*  84705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84707 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84709 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84711 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84728 */     GIR_RootConstrainSelectedInstOperands,
     /*  84729 */     // GIR_Coverage, 3223,
     /*  84729 */     GIR_EraseRootFromParent_Done,
     /*  84730 */   // Label 1590: @84730
     /*  84730 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(84820), // Rule ID 3227 //
     /*  84735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84784 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84788 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84792 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas16),
     /*  84795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84797 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84799 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84801 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84818 */     GIR_RootConstrainSelectedInstOperands,
     /*  84819 */     // GIR_Coverage, 3227,
     /*  84819 */     GIR_EraseRootFromParent_Done,
     /*  84820 */   // Label 1591: @84820
     /*  84820 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(84910), // Rule ID 3231 //
     /*  84825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84874 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84878 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84882 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs16),
     /*  84885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84887 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84889 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84891 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84908 */     GIR_RootConstrainSelectedInstOperands,
     /*  84909 */     // GIR_Coverage, 3231,
     /*  84909 */     GIR_EraseRootFromParent_Done,
     /*  84910 */   // Label 1592: @84910
     /*  84910 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(85000), // Rule ID 3235 //
     /*  84915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84964 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84968 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84972 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas32),
     /*  84975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84977 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84979 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84981 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84998 */     GIR_RootConstrainSelectedInstOperands,
     /*  84999 */     // GIR_Coverage, 3235,
     /*  84999 */     GIR_EraseRootFromParent_Done,
     /*  85000 */   // Label 1593: @85000
     /*  85000 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(85090), // Rule ID 3239 //
     /*  85005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  85008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  85013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  85016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  85019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  85022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  85025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  85031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  85034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  85038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  85042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  85046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  85050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  85054 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85058 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85062 */     // (intrinsic_wo_chain:{ *:[i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  85062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs32),
     /*  85065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  85067 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  85069 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  85071 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  85073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85088 */     GIR_RootConstrainSelectedInstOperands,
     /*  85089 */     // GIR_Coverage, 3239,
     /*  85089 */     GIR_EraseRootFromParent_Done,
     /*  85090 */   // Label 1594: @85090
     /*  85090 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(85177), // Rule ID 4335 //
     /*  85095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85149 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs8),
     /*  85152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85154 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85156 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85158 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85175 */     GIR_RootConstrainSelectedInstOperands,
     /*  85176 */     // GIR_Coverage, 4335,
     /*  85176 */     GIR_EraseRootFromParent_Done,
     /*  85177 */   // Label 1595: @85177
     /*  85177 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(85264), // Rule ID 4337 //
     /*  85182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85236 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs16),
     /*  85239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85241 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85243 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85245 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85262 */     GIR_RootConstrainSelectedInstOperands,
     /*  85263 */     // GIR_Coverage, 4337,
     /*  85263 */     GIR_EraseRootFromParent_Done,
     /*  85264 */   // Label 1596: @85264
     /*  85264 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(85351), // Rule ID 4339 //
     /*  85269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85323 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs32),
     /*  85326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85328 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85330 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85332 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85349 */     GIR_RootConstrainSelectedInstOperands,
     /*  85350 */     // GIR_Coverage, 4339,
     /*  85350 */     GIR_EraseRootFromParent_Done,
     /*  85351 */   // Label 1597: @85351
     /*  85351 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(85438), // Rule ID 4341 //
     /*  85356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85410 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs8),
     /*  85413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85415 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85417 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85419 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85436 */     GIR_RootConstrainSelectedInstOperands,
     /*  85437 */     // GIR_Coverage, 4341,
     /*  85437 */     GIR_EraseRootFromParent_Done,
     /*  85438 */   // Label 1598: @85438
     /*  85438 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(85525), // Rule ID 4343 //
     /*  85443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85497 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs16),
     /*  85500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85502 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85504 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85506 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85523 */     GIR_RootConstrainSelectedInstOperands,
     /*  85524 */     // GIR_Coverage, 4343,
     /*  85524 */     GIR_EraseRootFromParent_Done,
     /*  85525 */   // Label 1599: @85525
     /*  85525 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(85612), // Rule ID 4345 //
     /*  85530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85584 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs32),
     /*  85587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85589 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85591 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85593 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85610 */     GIR_RootConstrainSelectedInstOperands,
     /*  85611 */     // GIR_Coverage, 4345,
     /*  85611 */     GIR_EraseRootFromParent_Done,
     /*  85612 */   // Label 1600: @85612
     /*  85612 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(85699), // Rule ID 4347 //
     /*  85617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85671 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs8),
     /*  85674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85676 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85678 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85680 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85697 */     GIR_RootConstrainSelectedInstOperands,
     /*  85698 */     // GIR_Coverage, 4347,
     /*  85698 */     GIR_EraseRootFromParent_Done,
     /*  85699 */   // Label 1601: @85699
     /*  85699 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(85786), // Rule ID 4349 //
     /*  85704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85758 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs16),
     /*  85761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85763 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85765 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85767 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85784 */     GIR_RootConstrainSelectedInstOperands,
     /*  85785 */     // GIR_Coverage, 4349,
     /*  85785 */     GIR_EraseRootFromParent_Done,
     /*  85786 */   // Label 1602: @85786
     /*  85786 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(85873), // Rule ID 4351 //
     /*  85791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85845 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs32),
     /*  85848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85850 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85852 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85854 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85871 */     GIR_RootConstrainSelectedInstOperands,
     /*  85872 */     // GIR_Coverage, 4351,
     /*  85872 */     GIR_EraseRootFromParent_Done,
     /*  85873 */   // Label 1603: @85873
     /*  85873 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(85960), // Rule ID 4353 //
     /*  85878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85932 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs8),
     /*  85935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85937 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85939 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85941 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85958 */     GIR_RootConstrainSelectedInstOperands,
     /*  85959 */     // GIR_Coverage, 4353,
     /*  85959 */     GIR_EraseRootFromParent_Done,
     /*  85960 */   // Label 1604: @85960
     /*  85960 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(86047), // Rule ID 4355 //
     /*  85965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  86019 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs16),
     /*  86022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86024 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86026 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86028 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86045 */     GIR_RootConstrainSelectedInstOperands,
     /*  86046 */     // GIR_Coverage, 4355,
     /*  86046 */     GIR_EraseRootFromParent_Done,
     /*  86047 */   // Label 1605: @86047
     /*  86047 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(86134), // Rule ID 4357 //
     /*  86052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  86106 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs32),
     /*  86109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86111 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86113 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86115 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86132 */     GIR_RootConstrainSelectedInstOperands,
     /*  86133 */     // GIR_Coverage, 4357,
     /*  86133 */     GIR_EraseRootFromParent_Done,
     /*  86134 */   // Label 1606: @86134
     /*  86134 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(86221), // Rule ID 4359 //
     /*  86139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86189 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86193 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs8),
     /*  86196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86198 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86200 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86202 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86213 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86219 */     GIR_RootConstrainSelectedInstOperands,
     /*  86220 */     // GIR_Coverage, 4359,
     /*  86220 */     GIR_EraseRootFromParent_Done,
     /*  86221 */   // Label 1607: @86221
     /*  86221 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(86308), // Rule ID 4361 //
     /*  86226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86280 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs16),
     /*  86283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86285 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86287 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86289 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86306 */     GIR_RootConstrainSelectedInstOperands,
     /*  86307 */     // GIR_Coverage, 4361,
     /*  86307 */     GIR_EraseRootFromParent_Done,
     /*  86308 */   // Label 1608: @86308
     /*  86308 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(86395), // Rule ID 4363 //
     /*  86313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86355 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86367 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs32),
     /*  86370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86372 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86374 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86376 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86393 */     GIR_RootConstrainSelectedInstOperands,
     /*  86394 */     // GIR_Coverage, 4363,
     /*  86394 */     GIR_EraseRootFromParent_Done,
     /*  86395 */   // Label 1609: @86395
     /*  86395 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(86482), // Rule ID 4365 //
     /*  86400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86454 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs8),
     /*  86457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86459 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86461 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86463 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86480 */     GIR_RootConstrainSelectedInstOperands,
     /*  86481 */     // GIR_Coverage, 4365,
     /*  86481 */     GIR_EraseRootFromParent_Done,
     /*  86482 */   // Label 1610: @86482
     /*  86482 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(86569), // Rule ID 4367 //
     /*  86487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86541 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs16),
     /*  86544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86546 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86548 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86550 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86567 */     GIR_RootConstrainSelectedInstOperands,
     /*  86568 */     // GIR_Coverage, 4367,
     /*  86568 */     GIR_EraseRootFromParent_Done,
     /*  86569 */   // Label 1611: @86569
     /*  86569 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(86656), // Rule ID 4369 //
     /*  86574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86628 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs32),
     /*  86631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86633 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86635 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86637 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86654 */     GIR_RootConstrainSelectedInstOperands,
     /*  86655 */     // GIR_Coverage, 4369,
     /*  86655 */     GIR_EraseRootFromParent_Done,
     /*  86656 */   // Label 1612: @86656
     /*  86656 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(86743), // Rule ID 4371 //
     /*  86661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86715 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs8),
     /*  86718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86720 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86722 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86724 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86741 */     GIR_RootConstrainSelectedInstOperands,
     /*  86742 */     // GIR_Coverage, 4371,
     /*  86742 */     GIR_EraseRootFromParent_Done,
     /*  86743 */   // Label 1613: @86743
     /*  86743 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(86830), // Rule ID 4373 //
     /*  86748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86802 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs16),
     /*  86805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86807 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86809 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86811 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86828 */     GIR_RootConstrainSelectedInstOperands,
     /*  86829 */     // GIR_Coverage, 4373,
     /*  86829 */     GIR_EraseRootFromParent_Done,
     /*  86830 */   // Label 1614: @86830
     /*  86830 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(86917), // Rule ID 4375 //
     /*  86835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86889 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs32),
     /*  86892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86894 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86896 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86898 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86915 */     GIR_RootConstrainSelectedInstOperands,
     /*  86916 */     // GIR_Coverage, 4375,
     /*  86916 */     GIR_EraseRootFromParent_Done,
     /*  86917 */   // Label 1615: @86917
     /*  86917 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(87004), // Rule ID 4377 //
     /*  86922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86976 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs8),
     /*  86979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86981 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86983 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86985 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87002 */     GIR_RootConstrainSelectedInstOperands,
     /*  87003 */     // GIR_Coverage, 4377,
     /*  87003 */     GIR_EraseRootFromParent_Done,
     /*  87004 */   // Label 1616: @87004
     /*  87004 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(87091), // Rule ID 4379 //
     /*  87009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  87014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  87026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  87055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87063 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  87063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs16),
     /*  87066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87068 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  87070 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  87072 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  87074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87089 */     GIR_RootConstrainSelectedInstOperands,
     /*  87090 */     // GIR_Coverage, 4379,
     /*  87090 */     GIR_EraseRootFromParent_Done,
     /*  87091 */   // Label 1617: @87091
     /*  87091 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(87178), // Rule ID 4381 //
     /*  87096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  87101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  87113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  87142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87150 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  87150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs32),
     /*  87153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87155 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  87157 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  87159 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  87161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87176 */     GIR_RootConstrainSelectedInstOperands,
     /*  87177 */     // GIR_Coverage, 4381,
     /*  87177 */     GIR_EraseRootFromParent_Done,
     /*  87178 */   // Label 1618: @87178
     /*  87178 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(87304), // Rule ID 2692 //
     /*  87183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx4),
     /*  87191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  87194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  87197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  87200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  87203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  87206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  87209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s8,
     /*  87212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  87216 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3842:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX4Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  87216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  87219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  87223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  87232 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  87235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  87239 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  87242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  87246 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  87249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // Vn3
     /*  87253 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  87256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  87261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX4Pseudo),
     /*  87284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87286 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  87288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87291 */     GIR_RootToRootCopy, /*OpIdx*/7, // Vm
     /*  87293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  87296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87302 */     GIR_RootConstrainSelectedInstOperands,
     /*  87303 */     // GIR_Coverage, 2692,
     /*  87303 */     GIR_EraseRootFromParent_Done,
     /*  87304 */   // Label 1619: @87304
     /*  87304 */   GIM_Reject,
     /*  87305 */ // Label 1564: @87305
     /*  87305 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(91599),
     /*  87310 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/10,
     /*  87313 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshrn),
     /*  87318 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(87425), // Rule ID 3758 //
     /*  87323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87344 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87347 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87374 */     // MIs[1] Operand 1
     /*  87374 */     // No operand predicates
     /*  87374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87396 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87401 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87423 */     GIR_RootConstrainSelectedInstOperands,
     /*  87424 */     // GIR_Coverage, 3758,
     /*  87424 */     GIR_EraseRootFromParent_Done,
     /*  87425 */   // Label 1621: @87425
     /*  87425 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(87532), // Rule ID 3760 //
     /*  87430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87451 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87454 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87481 */     // MIs[1] Operand 1
     /*  87481 */     // No operand predicates
     /*  87481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87503 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87508 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87530 */     GIR_RootConstrainSelectedInstOperands,
     /*  87531 */     // GIR_Coverage, 3760,
     /*  87531 */     GIR_EraseRootFromParent_Done,
     /*  87532 */   // Label 1622: @87532
     /*  87532 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(87639), // Rule ID 3762 //
     /*  87537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87558 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87561 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87588 */     // MIs[1] Operand 1
     /*  87588 */     // No operand predicates
     /*  87588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87610 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87615 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87625 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87637 */     GIR_RootConstrainSelectedInstOperands,
     /*  87638 */     // GIR_Coverage, 3762,
     /*  87638 */     GIR_EraseRootFromParent_Done,
     /*  87639 */   // Label 1623: @87639
     /*  87639 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(87746), // Rule ID 3764 //
     /*  87644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87665 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87668 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87695 */     // MIs[1] Operand 1
     /*  87695 */     // No operand predicates
     /*  87695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87717 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87722 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87744 */     GIR_RootConstrainSelectedInstOperands,
     /*  87745 */     // GIR_Coverage, 3764,
     /*  87745 */     GIR_EraseRootFromParent_Done,
     /*  87746 */   // Label 1624: @87746
     /*  87746 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(87853), // Rule ID 3766 //
     /*  87751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87772 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87775 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87802 */     // MIs[1] Operand 1
     /*  87802 */     // No operand predicates
     /*  87802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87824 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87829 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87851 */     GIR_RootConstrainSelectedInstOperands,
     /*  87852 */     // GIR_Coverage, 3766,
     /*  87852 */     GIR_EraseRootFromParent_Done,
     /*  87853 */   // Label 1625: @87853
     /*  87853 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(87960), // Rule ID 3768 //
     /*  87858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87879 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87882 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87909 */     // MIs[1] Operand 1
     /*  87909 */     // No operand predicates
     /*  87909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87931 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87936 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87958 */     GIR_RootConstrainSelectedInstOperands,
     /*  87959 */     // GIR_Coverage, 3768,
     /*  87959 */     GIR_EraseRootFromParent_Done,
     /*  87960 */   // Label 1626: @87960
     /*  87960 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(88067), // Rule ID 3770 //
     /*  87965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87986 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87989 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88016 */     // MIs[1] Operand 1
     /*  88016 */     // No operand predicates
     /*  88016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88038 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  88041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88043 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88065 */     GIR_RootConstrainSelectedInstOperands,
     /*  88066 */     // GIR_Coverage, 3770,
     /*  88066 */     GIR_EraseRootFromParent_Done,
     /*  88067 */   // Label 1627: @88067
     /*  88067 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(88174), // Rule ID 3772 //
     /*  88072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88093 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88096 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88123 */     // MIs[1] Operand 1
     /*  88123 */     // No operand predicates
     /*  88123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88139 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88145 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  88148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88150 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88160 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88172 */     GIR_RootConstrainSelectedInstOperands,
     /*  88173 */     // GIR_Coverage, 3772,
     /*  88173 */     GIR_EraseRootFromParent_Done,
     /*  88174 */   // Label 1628: @88174
     /*  88174 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(88281), // Rule ID 3774 //
     /*  88179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88200 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88203 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88230 */     // MIs[1] Operand 1
     /*  88230 */     // No operand predicates
     /*  88230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88252 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88257 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88279 */     GIR_RootConstrainSelectedInstOperands,
     /*  88280 */     // GIR_Coverage, 3774,
     /*  88280 */     GIR_EraseRootFromParent_Done,
     /*  88281 */   // Label 1629: @88281
     /*  88281 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(88388), // Rule ID 3776 //
     /*  88286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88307 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88310 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88337 */     // MIs[1] Operand 1
     /*  88337 */     // No operand predicates
     /*  88337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88359 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88364 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88386 */     GIR_RootConstrainSelectedInstOperands,
     /*  88387 */     // GIR_Coverage, 3776,
     /*  88387 */     GIR_EraseRootFromParent_Done,
     /*  88388 */   // Label 1630: @88388
     /*  88388 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(88495), // Rule ID 3778 //
     /*  88393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88414 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88417 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88444 */     // MIs[1] Operand 1
     /*  88444 */     // No operand predicates
     /*  88444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88466 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88471 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88493 */     GIR_RootConstrainSelectedInstOperands,
     /*  88494 */     // GIR_Coverage, 3778,
     /*  88494 */     GIR_EraseRootFromParent_Done,
     /*  88495 */   // Label 1631: @88495
     /*  88495 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(88602), // Rule ID 3780 //
     /*  88500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88521 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88524 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88551 */     // MIs[1] Operand 1
     /*  88551 */     // No operand predicates
     /*  88551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88573 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88578 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88600 */     GIR_RootConstrainSelectedInstOperands,
     /*  88601 */     // GIR_Coverage, 3780,
     /*  88601 */     GIR_EraseRootFromParent_Done,
     /*  88602 */   // Label 1632: @88602
     /*  88602 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(88709), // Rule ID 3782 //
     /*  88607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88628 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88631 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88658 */     // MIs[1] Operand 1
     /*  88658 */     // No operand predicates
     /*  88658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88680 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88685 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88707 */     GIR_RootConstrainSelectedInstOperands,
     /*  88708 */     // GIR_Coverage, 3782,
     /*  88708 */     GIR_EraseRootFromParent_Done,
     /*  88709 */   // Label 1633: @88709
     /*  88709 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(88816), // Rule ID 3784 //
     /*  88714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88735 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88738 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88765 */     // MIs[1] Operand 1
     /*  88765 */     // No operand predicates
     /*  88765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88787 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88792 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88814 */     GIR_RootConstrainSelectedInstOperands,
     /*  88815 */     // GIR_Coverage, 3784,
     /*  88815 */     GIR_EraseRootFromParent_Done,
     /*  88816 */   // Label 1634: @88816
     /*  88816 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(88923), // Rule ID 3786 //
     /*  88821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88842 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88845 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88872 */     // MIs[1] Operand 1
     /*  88872 */     // No operand predicates
     /*  88872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88894 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88899 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88921 */     GIR_RootConstrainSelectedInstOperands,
     /*  88922 */     // GIR_Coverage, 3786,
     /*  88922 */     GIR_EraseRootFromParent_Done,
     /*  88923 */   // Label 1635: @88923
     /*  88923 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(89030), // Rule ID 3788 //
     /*  88928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88949 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88952 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88979 */     // MIs[1] Operand 1
     /*  88979 */     // No operand predicates
     /*  88979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89001 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  89004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89006 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89028 */     GIR_RootConstrainSelectedInstOperands,
     /*  89029 */     // GIR_Coverage, 3788,
     /*  89029 */     GIR_EraseRootFromParent_Done,
     /*  89030 */   // Label 1636: @89030
     /*  89030 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(89137), // Rule ID 3790 //
     /*  89035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89056 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89059 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89086 */     // MIs[1] Operand 1
     /*  89086 */     // No operand predicates
     /*  89086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89108 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs16),
     /*  89111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89113 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89135 */     GIR_RootConstrainSelectedInstOperands,
     /*  89136 */     // GIR_Coverage, 3790,
     /*  89136 */     GIR_EraseRootFromParent_Done,
     /*  89137 */   // Label 1637: @89137
     /*  89137 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(89244), // Rule ID 3792 //
     /*  89142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89163 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89166 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89193 */     // MIs[1] Operand 1
     /*  89193 */     // No operand predicates
     /*  89193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89205 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89215 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths16),
     /*  89218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89220 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89242 */     GIR_RootConstrainSelectedInstOperands,
     /*  89243 */     // GIR_Coverage, 3792,
     /*  89243 */     GIR_EraseRootFromParent_Done,
     /*  89244 */   // Label 1638: @89244
     /*  89244 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(89351), // Rule ID 3794 //
     /*  89249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89270 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89273 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89300 */     // MIs[1] Operand 1
     /*  89300 */     // No operand predicates
     /*  89300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89322 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs32),
     /*  89325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89327 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89349 */     GIR_RootConstrainSelectedInstOperands,
     /*  89350 */     // GIR_Coverage, 3794,
     /*  89350 */     GIR_EraseRootFromParent_Done,
     /*  89351 */   // Label 1639: @89351
     /*  89351 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(89458), // Rule ID 3796 //
     /*  89356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89377 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89380 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89407 */     // MIs[1] Operand 1
     /*  89407 */     // No operand predicates
     /*  89407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89429 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths32),
     /*  89432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89434 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89456 */     GIR_RootConstrainSelectedInstOperands,
     /*  89457 */     // GIR_Coverage, 3796,
     /*  89457 */     GIR_EraseRootFromParent_Done,
     /*  89458 */   // Label 1640: @89458
     /*  89458 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(89565), // Rule ID 3798 //
     /*  89463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89484 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89487 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89514 */     // MIs[1] Operand 1
     /*  89514 */     // No operand predicates
     /*  89514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89536 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu16),
     /*  89539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89541 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89563 */     GIR_RootConstrainSelectedInstOperands,
     /*  89564 */     // GIR_Coverage, 3798,
     /*  89564 */     GIR_EraseRootFromParent_Done,
     /*  89565 */   // Label 1641: @89565
     /*  89565 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(89672), // Rule ID 3800 //
     /*  89570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89591 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89594 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89621 */     // MIs[1] Operand 1
     /*  89621 */     // No operand predicates
     /*  89621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89643 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu16),
     /*  89646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89648 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89670 */     GIR_RootConstrainSelectedInstOperands,
     /*  89671 */     // GIR_Coverage, 3800,
     /*  89671 */     GIR_EraseRootFromParent_Done,
     /*  89672 */   // Label 1642: @89672
     /*  89672 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(89779), // Rule ID 3802 //
     /*  89677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89698 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89701 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89728 */     // MIs[1] Operand 1
     /*  89728 */     // No operand predicates
     /*  89728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89750 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu32),
     /*  89753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89755 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89777 */     GIR_RootConstrainSelectedInstOperands,
     /*  89778 */     // GIR_Coverage, 3802,
     /*  89778 */     GIR_EraseRootFromParent_Done,
     /*  89779 */   // Label 1643: @89779
     /*  89779 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(89886), // Rule ID 3804 //
     /*  89784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89805 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89808 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89835 */     // MIs[1] Operand 1
     /*  89835 */     // No operand predicates
     /*  89835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89843 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89857 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu32),
     /*  89860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89862 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89884 */     GIR_RootConstrainSelectedInstOperands,
     /*  89885 */     // GIR_Coverage, 3804,
     /*  89885 */     GIR_EraseRootFromParent_Done,
     /*  89886 */   // Label 1644: @89886
     /*  89886 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(89993), // Rule ID 3806 //
     /*  89891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89912 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89915 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89942 */     // MIs[1] Operand 1
     /*  89942 */     // No operand predicates
     /*  89942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89964 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs16),
     /*  89967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89969 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89991 */     GIR_RootConstrainSelectedInstOperands,
     /*  89992 */     // GIR_Coverage, 3806,
     /*  89992 */     GIR_EraseRootFromParent_Done,
     /*  89993 */   // Label 1645: @89993
     /*  89993 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(90100), // Rule ID 3808 //
     /*  89998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90019 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90022 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90049 */     // MIs[1] Operand 1
     /*  90049 */     // No operand predicates
     /*  90049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90071 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths16),
     /*  90074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90076 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90098 */     GIR_RootConstrainSelectedInstOperands,
     /*  90099 */     // GIR_Coverage, 3808,
     /*  90099 */     GIR_EraseRootFromParent_Done,
     /*  90100 */   // Label 1646: @90100
     /*  90100 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(90207), // Rule ID 3810 //
     /*  90105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90126 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90129 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90156 */     // MIs[1] Operand 1
     /*  90156 */     // No operand predicates
     /*  90156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90178 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs32),
     /*  90181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90183 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90205 */     GIR_RootConstrainSelectedInstOperands,
     /*  90206 */     // GIR_Coverage, 3810,
     /*  90206 */     GIR_EraseRootFromParent_Done,
     /*  90207 */   // Label 1647: @90207
     /*  90207 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(90314), // Rule ID 3812 //
     /*  90212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90233 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90236 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90263 */     // MIs[1] Operand 1
     /*  90263 */     // No operand predicates
     /*  90263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90285 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths32),
     /*  90288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90290 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90312 */     GIR_RootConstrainSelectedInstOperands,
     /*  90313 */     // GIR_Coverage, 3812,
     /*  90313 */     GIR_EraseRootFromParent_Done,
     /*  90314 */   // Label 1648: @90314
     /*  90314 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(90421), // Rule ID 3814 //
     /*  90319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90340 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90343 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90370 */     // MIs[1] Operand 1
     /*  90370 */     // No operand predicates
     /*  90370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90392 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu16),
     /*  90395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90397 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90407 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90419 */     GIR_RootConstrainSelectedInstOperands,
     /*  90420 */     // GIR_Coverage, 3814,
     /*  90420 */     GIR_EraseRootFromParent_Done,
     /*  90421 */   // Label 1649: @90421
     /*  90421 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(90528), // Rule ID 3816 //
     /*  90426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90447 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90450 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90477 */     // MIs[1] Operand 1
     /*  90477 */     // No operand predicates
     /*  90477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90499 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu16),
     /*  90502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90504 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90526 */     GIR_RootConstrainSelectedInstOperands,
     /*  90527 */     // GIR_Coverage, 3816,
     /*  90527 */     GIR_EraseRootFromParent_Done,
     /*  90528 */   // Label 1650: @90528
     /*  90528 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(90635), // Rule ID 3818 //
     /*  90533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90554 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90557 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90584 */     // MIs[1] Operand 1
     /*  90584 */     // No operand predicates
     /*  90584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90606 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu32),
     /*  90609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90611 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90633 */     GIR_RootConstrainSelectedInstOperands,
     /*  90634 */     // GIR_Coverage, 3818,
     /*  90634 */     GIR_EraseRootFromParent_Done,
     /*  90635 */   // Label 1651: @90635
     /*  90635 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(90742), // Rule ID 3820 //
     /*  90640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90661 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90664 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90691 */     // MIs[1] Operand 1
     /*  90691 */     // No operand predicates
     /*  90691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90713 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu32),
     /*  90716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90718 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90740 */     GIR_RootConstrainSelectedInstOperands,
     /*  90741 */     // GIR_Coverage, 3820,
     /*  90741 */     GIR_EraseRootFromParent_Done,
     /*  90742 */   // Label 1652: @90742
     /*  90742 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(90849), // Rule ID 3822 //
     /*  90747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90768 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90771 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90798 */     // MIs[1] Operand 1
     /*  90798 */     // No operand predicates
     /*  90798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90820 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16bh),
     /*  90823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90825 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90847 */     GIR_RootConstrainSelectedInstOperands,
     /*  90848 */     // GIR_Coverage, 3822,
     /*  90848 */     GIR_EraseRootFromParent_Done,
     /*  90849 */   // Label 1653: @90849
     /*  90849 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(90956), // Rule ID 3824 //
     /*  90854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90875 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90878 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90905 */     // MIs[1] Operand 1
     /*  90905 */     // No operand predicates
     /*  90905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90927 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16th),
     /*  90930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90932 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90954 */     GIR_RootConstrainSelectedInstOperands,
     /*  90955 */     // GIR_Coverage, 3824,
     /*  90955 */     GIR_EraseRootFromParent_Done,
     /*  90956 */   // Label 1654: @90956
     /*  90956 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(91063), // Rule ID 3826 //
     /*  90961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90982 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90985 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91012 */     // MIs[1] Operand 1
     /*  91012 */     // No operand predicates
     /*  91012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  91020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91034 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32bh),
     /*  91037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91039 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91061 */     GIR_RootConstrainSelectedInstOperands,
     /*  91062 */     // GIR_Coverage, 3826,
     /*  91062 */     GIR_EraseRootFromParent_Done,
     /*  91063 */   // Label 1655: @91063
     /*  91063 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(91170), // Rule ID 3828 //
     /*  91068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91089 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91092 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91119 */     // MIs[1] Operand 1
     /*  91119 */     // No operand predicates
     /*  91119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  91127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91141 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32th),
     /*  91144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91146 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91168 */     GIR_RootConstrainSelectedInstOperands,
     /*  91169 */     // GIR_Coverage, 3828,
     /*  91169 */     GIR_EraseRootFromParent_Done,
     /*  91170 */   // Label 1656: @91170
     /*  91170 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91277), // Rule ID 3830 //
     /*  91175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91196 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91199 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91226 */     // MIs[1] Operand 1
     /*  91226 */     // No operand predicates
     /*  91226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91248 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16bh),
     /*  91251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91253 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91275 */     GIR_RootConstrainSelectedInstOperands,
     /*  91276 */     // GIR_Coverage, 3830,
     /*  91276 */     GIR_EraseRootFromParent_Done,
     /*  91277 */   // Label 1657: @91277
     /*  91277 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91384), // Rule ID 3832 //
     /*  91282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91303 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91306 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91333 */     // MIs[1] Operand 1
     /*  91333 */     // No operand predicates
     /*  91333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91355 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16th),
     /*  91358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91360 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91382 */     GIR_RootConstrainSelectedInstOperands,
     /*  91383 */     // GIR_Coverage, 3832,
     /*  91383 */     GIR_EraseRootFromParent_Done,
     /*  91384 */   // Label 1658: @91384
     /*  91384 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91491), // Rule ID 3834 //
     /*  91389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91410 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91413 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91440 */     // MIs[1] Operand 1
     /*  91440 */     // No operand predicates
     /*  91440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91462 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32bh),
     /*  91465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91467 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91489 */     GIR_RootConstrainSelectedInstOperands,
     /*  91490 */     // GIR_Coverage, 3834,
     /*  91490 */     GIR_EraseRootFromParent_Done,
     /*  91491 */   // Label 1659: @91491
     /*  91491 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91598), // Rule ID 3836 //
     /*  91496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91517 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91520 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91547 */     // MIs[1] Operand 1
     /*  91547 */     // No operand predicates
     /*  91547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91569 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32th),
     /*  91572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91574 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91596 */     GIR_RootConstrainSelectedInstOperands,
     /*  91597 */     // GIR_Coverage, 3836,
     /*  91597 */     GIR_EraseRootFromParent_Done,
     /*  91598 */   // Label 1660: @91598
     /*  91598 */   GIM_Reject,
     /*  91599 */ // Label 1620: @91599
     /*  91599 */ GIM_Reject,
     /*  91600 */ // Label 16: @91600
     /*  91600 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91657),
     /*  91605 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91608 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_clrex),
     /*  91613 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91630), // Rule ID 245 //
     /*  91618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6K_IsARM),
     /*  91621 */     // (intrinsic_void 3470:{ *:[iPTR] })  =>  (CLREX)
     /*  91621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLREX),
     /*  91624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91628 */     GIR_RootConstrainSelectedInstOperands,
     /*  91629 */     // GIR_Coverage, 245,
     /*  91629 */     GIR_EraseRootFromParent_Done,
     /*  91630 */   // Label 1662: @91630
     /*  91630 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91656), // Rule ID 574 //
     /*  91635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7Clrex_IsThumb),
     /*  91638 */     // (intrinsic_void 3470:{ *:[iPTR] })  =>  (t2CLREX)
     /*  91638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLREX),
     /*  91641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91654 */     GIR_RootConstrainSelectedInstOperands,
     /*  91655 */     // GIR_Coverage, 574,
     /*  91655 */     GIR_EraseRootFromParent_Done,
     /*  91656 */   // Label 1663: @91656
     /*  91656 */   GIM_Reject,
     /*  91657 */ // Label 1661: @91657
     /*  91657 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(92459),
     /*  91662 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91665 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91701), // Rule ID 344 //
     /*  91670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsWindows),
     /*  91673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91678 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91681 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/1, GIMT_Encode8(249),
     /*  91692 */     // (intrinsic_void 3911:{ *:[iPTR] }, 249:{ *:[i32] })  =>  (t__brkdiv0)
     /*  91692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t__brkdiv0),
     /*  91695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91699 */     GIR_RootConstrainSelectedInstOperands,
     /*  91700 */     // GIR_Coverage, 344,
     /*  91700 */     GIR_EraseRootFromParent_Done,
     /*  91701 */   // Label 1665: @91701
     /*  91701 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(91753), // Rule ID 2 //
     /*  91706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  91709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91714 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91729 */     // MIs[1] Operand 1
     /*  91729 */     // No operand predicates
     /*  91729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91731 */     // (intrinsic_void 3488:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /*  91731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::HINT),
     /*  91734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91751 */     GIR_RootConstrainSelectedInstOperands,
     /*  91752 */     // GIR_Coverage, 2,
     /*  91752 */     GIR_EraseRootFromParent_Done,
     /*  91753 */   // Label 1666: @91753
     /*  91753 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91805), // Rule ID 10 //
     /*  91758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7_IsARM),
     /*  91761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91766 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91781 */     // MIs[1] Operand 1
     /*  91781 */     // No operand predicates
     /*  91781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91783 */     // (intrinsic_void 3483:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DBG (imm:{ *:[i32] }):$opt)
     /*  91783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DBG),
     /*  91786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91803 */     GIR_RootConstrainSelectedInstOperands,
     /*  91804 */     // GIR_Coverage, 10,
     /*  91804 */     GIR_EraseRootFromParent_Done,
     /*  91805 */   // Label 1667: @91805
     /*  91805 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91848), // Rule ID 11 //
     /*  91810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  91813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91818 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91833 */     // MIs[1] Operand 1
     /*  91833 */     // No operand predicates
     /*  91833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91835 */     // (intrinsic_void 3911:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (UDF (imm:{ *:[i32] }):$imm16)
     /*  91835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /*  91838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91846 */     GIR_RootConstrainSelectedInstOperands,
     /*  91847 */     // GIR_Coverage, 11,
     /*  91847 */     GIR_EraseRootFromParent_Done,
     /*  91848 */   // Label 1668: @91848
     /*  91848 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91891), // Rule ID 228 //
     /*  91853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91861 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91876 */     // MIs[1] Operand 1
     /*  91876 */     // No operand predicates
     /*  91876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91878 */     // (intrinsic_void 3484:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DMB (imm:{ *:[i32] }):$opt)
     /*  91878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DMB),
     /*  91881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91889 */     GIR_RootConstrainSelectedInstOperands,
     /*  91890 */     // GIR_Coverage, 228,
     /*  91890 */     GIR_EraseRootFromParent_Done,
     /*  91891 */   // Label 1669: @91891
     /*  91891 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91934), // Rule ID 229 //
     /*  91896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91904 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91919 */     // MIs[1] Operand 1
     /*  91919 */     // No operand predicates
     /*  91919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91921 */     // (intrinsic_void 3485:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DSB (imm:{ *:[i32] }):$opt)
     /*  91921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DSB),
     /*  91924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91932 */     GIR_RootConstrainSelectedInstOperands,
     /*  91933 */     // GIR_Coverage, 229,
     /*  91933 */     GIR_EraseRootFromParent_Done,
     /*  91934 */   // Label 1670: @91934
     /*  91934 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91977), // Rule ID 230 //
     /*  91939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91947 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91962 */     // MIs[1] Operand 1
     /*  91962 */     // No operand predicates
     /*  91962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91964 */     // (intrinsic_void 3489:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (ISB (imm:{ *:[i32] }):$opt)
     /*  91964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ISB),
     /*  91967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91975 */     GIR_RootConstrainSelectedInstOperands,
     /*  91976 */     // GIR_Coverage, 230,
     /*  91976 */     GIR_EraseRootFromParent_Done,
     /*  91977 */   // Label 1671: @91977
     /*  91977 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(92029), // Rule ID 276 //
     /*  91982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6M_IsThumb),
     /*  91985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91990 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92005 */     // MIs[1] Operand 1
     /*  92005 */     // No operand predicates
     /*  92005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92007 */     // (intrinsic_void 3488:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (tHINT (imm:{ *:[i32] }):$imm)
     /*  92007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tHINT),
     /*  92010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  92013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92027 */     GIR_RootConstrainSelectedInstOperands,
     /*  92028 */     // GIR_Coverage, 276,
     /*  92028 */     GIR_EraseRootFromParent_Done,
     /*  92029 */   // Label 1672: @92029
     /*  92029 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(92072), // Rule ID 343 //
     /*  92034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /*  92037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  92042 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /*  92057 */     // MIs[1] Operand 1
     /*  92057 */     // No operand predicates
     /*  92057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92059 */     // (intrinsic_void 3911:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$imm8)  =>  (tUDF (imm:{ *:[i32] }):$imm8)
     /*  92059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /*  92062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*  92065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92070 */     GIR_RootConstrainSelectedInstOperands,
     /*  92071 */     // GIR_Coverage, 343,
     /*  92071 */     GIR_EraseRootFromParent_Done,
     /*  92072 */   // Label 1673: @92072
     /*  92072 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(92115), // Rule ID 494 //
     /*  92077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  92085 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  92100 */     // MIs[1] Operand 1
     /*  92100 */     // No operand predicates
     /*  92100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92102 */     // (intrinsic_void 3911:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (t2UDF (imm:{ *:[i32] }):$imm16)
     /*  92102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDF),
     /*  92105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  92108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92113 */     GIR_RootConstrainSelectedInstOperands,
     /*  92114 */     // GIR_Coverage, 494,
     /*  92114 */     GIR_EraseRootFromParent_Done,
     /*  92115 */   // Label 1674: @92115
     /*  92115 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(92167), // Rule ID 559 //
     /*  92120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  92128 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92143 */     // MIs[1] Operand 1
     /*  92143 */     // No operand predicates
     /*  92143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92145 */     // (intrinsic_void 3484:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DMB (imm:{ *:[i32] }):$opt)
     /*  92145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DMB),
     /*  92148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92165 */     GIR_RootConstrainSelectedInstOperands,
     /*  92166 */     // GIR_Coverage, 559,
     /*  92166 */     GIR_EraseRootFromParent_Done,
     /*  92167 */   // Label 1675: @92167
     /*  92167 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(92219), // Rule ID 560 //
     /*  92172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  92180 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92195 */     // MIs[1] Operand 1
     /*  92195 */     // No operand predicates
     /*  92195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92197 */     // (intrinsic_void 3485:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DSB (imm:{ *:[i32] }):$opt)
     /*  92197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DSB),
     /*  92200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92217 */     GIR_RootConstrainSelectedInstOperands,
     /*  92218 */     // GIR_Coverage, 560,
     /*  92218 */     GIR_EraseRootFromParent_Done,
     /*  92219 */   // Label 1676: @92219
     /*  92219 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92271), // Rule ID 561 //
     /*  92224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  92232 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92247 */     // MIs[1] Operand 1
     /*  92247 */     // No operand predicates
     /*  92247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92249 */     // (intrinsic_void 3489:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2ISB (imm:{ *:[i32] }):$opt)
     /*  92249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ISB),
     /*  92252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92269 */     GIR_RootConstrainSelectedInstOperands,
     /*  92270 */     // GIR_Coverage, 561,
     /*  92270 */     GIR_EraseRootFromParent_Done,
     /*  92271 */   // Label 1677: @92271
     /*  92271 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92323), // Rule ID 579 //
     /*  92276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  92284 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  92299 */     // MIs[1] Operand 1
     /*  92299 */     // No operand predicates
     /*  92299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92301 */     // (intrinsic_void 3488:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (t2HINT (imm:{ *:[i32] }):$imm)
     /*  92301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2HINT),
     /*  92304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  92307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92321 */     GIR_RootConstrainSelectedInstOperands,
     /*  92322 */     // GIR_Coverage, 579,
     /*  92322 */     GIR_EraseRootFromParent_Done,
     /*  92323 */   // Label 1678: @92323
     /*  92323 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92375), // Rule ID 580 //
     /*  92328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  92336 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92351 */     // MIs[1] Operand 1
     /*  92351 */     // No operand predicates
     /*  92351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92353 */     // (intrinsic_void 3483:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DBG (imm:{ *:[i32] }):$opt)
     /*  92353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DBG),
     /*  92356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92373 */     GIR_RootConstrainSelectedInstOperands,
     /*  92374 */     // GIR_Coverage, 580,
     /*  92374 */     GIR_EraseRootFromParent_Done,
     /*  92375 */   // Label 1679: @92375
     /*  92375 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92415), // Rule ID 725 //
     /*  92380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_get_fpscr),
     /*  92388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92395 */     // (intrinsic_w_chain:{ *:[i32] } 3486:{ *:[iPTR] })  =>  (VMRS:{ *:[i32] })
     /*  92395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /*  92398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  92400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92413 */     GIR_RootConstrainSelectedInstOperands,
     /*  92414 */     // GIR_Coverage, 725,
     /*  92414 */     GIR_EraseRootFromParent_Done,
     /*  92415 */   // Label 1680: @92415
     /*  92415 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(92458), // Rule ID 726 //
     /*  92420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_set_fpscr),
     /*  92428 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92435 */     // (intrinsic_void 3855:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /*  92435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /*  92438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  92440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /*  92452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92456 */     GIR_RootConstrainSelectedInstOperands,
     /*  92457 */     // GIR_Coverage, 726,
     /*  92457 */     GIR_EraseRootFromParent_Done,
     /*  92458 */   // Label 1681: @92458
     /*  92458 */   GIM_Reject,
     /*  92459 */ // Label 1664: @92459
     /*  92459 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92502), // Rule ID 604 //
     /*  92464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLOB_HasV8_1MMainline_IsThumb2),
     /*  92467 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92470 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::start_loop_iterations),
     /*  92475 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRlrRegClassID),
     /*  92485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  92489 */   // (intrinsic_w_chain:{ *:[i32] } 345:{ *:[iPTR] }, rGPR:{ *:[i32] }:$tc)  =>  (t2DoLoopStart:{ *:[i32] } rGPR:{ *:[i32] }:$tc)
     /*  92489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DoLoopStart),
     /*  92492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[X]
     /*  92494 */   GIR_RootToRootCopy, /*OpIdx*/2, // tc
     /*  92496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92500 */   GIR_RootConstrainSelectedInstOperands,
     /*  92501 */   // GIR_Coverage, 604,
     /*  92501 */   GIR_EraseRootFromParent_Done,
     /*  92502 */ // Label 1682: @92502
     /*  92502 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(94493),
     /*  92507 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92510 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92564), // Rule ID 5051 //
     /*  92515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92545 */     // MIs[1] Operand 1
     /*  92545 */     // No operand predicates
     /*  92545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92547 */     // (intrinsic_w_chain:{ *:[v4i32] } 3619:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92552 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92562 */     GIR_RootConstrainSelectedInstOperands,
     /*  92563 */     // GIR_Coverage, 5051,
     /*  92563 */     GIR_EraseRootFromParent_Done,
     /*  92564 */   // Label 1684: @92564
     /*  92564 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92618), // Rule ID 5057 //
     /*  92569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92599 */     // MIs[1] Operand 1
     /*  92599 */     // No operand predicates
     /*  92599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92601 */     // (intrinsic_w_chain:{ *:[v4f32] } 3619:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92606 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92616 */     GIR_RootConstrainSelectedInstOperands,
     /*  92617 */     // GIR_Coverage, 5057,
     /*  92617 */     GIR_EraseRootFromParent_Done,
     /*  92618 */   // Label 1685: @92618
     /*  92618 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92672), // Rule ID 5059 //
     /*  92623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92653 */     // MIs[1] Operand 1
     /*  92653 */     // No operand predicates
     /*  92653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92655 */     // (intrinsic_w_chain:{ *:[v2i64] } 3619:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92660 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92670 */     GIR_RootConstrainSelectedInstOperands,
     /*  92671 */     // GIR_Coverage, 5059,
     /*  92671 */     GIR_EraseRootFromParent_Done,
     /*  92672 */   // Label 1686: @92672
     /*  92672 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92726), // Rule ID 5061 //
     /*  92677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92707 */     // MIs[1] Operand 1
     /*  92707 */     // No operand predicates
     /*  92707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92709 */     // (intrinsic_w_chain:{ *:[v2f64] } 3619:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92714 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92724 */     GIR_RootConstrainSelectedInstOperands,
     /*  92725 */     // GIR_Coverage, 5061,
     /*  92725 */     GIR_EraseRootFromParent_Done,
     /*  92726 */   // Label 1687: @92726
     /*  92726 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92768), // Rule ID 1741 //
     /*  92731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_space),
     /*  92736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92746 */     // MIs[0] size
     /*  92746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92753 */     // (intrinsic_w_chain:{ *:[i32] } 3886:{ *:[iPTR] }, (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)  =>  (SPACE:{ *:[i32] } (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)
     /*  92753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SPACE),
     /*  92756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92758 */     GIR_RootToRootCopy, /*OpIdx*/2, // size
     /*  92760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  92762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92766 */     GIR_RootConstrainSelectedInstOperands,
     /*  92767 */     // GIR_Coverage, 1741,
     /*  92767 */     GIR_EraseRootFromParent_Done,
     /*  92768 */   // Label 1688: @92768
     /*  92768 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92822), // Rule ID 5053 //
     /*  92773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92778 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92799 */     // MIs[1] Operand 1
     /*  92799 */     // No operand predicates
     /*  92799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92805 */     // (intrinsic_void 3693:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92808 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92810 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92820 */     GIR_RootConstrainSelectedInstOperands,
     /*  92821 */     // GIR_Coverage, 5053,
     /*  92821 */     GIR_EraseRootFromParent_Done,
     /*  92822 */   // Label 1689: @92822
     /*  92822 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92876), // Rule ID 5063 //
     /*  92827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92832 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92853 */     // MIs[1] Operand 1
     /*  92853 */     // No operand predicates
     /*  92853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92859 */     // (intrinsic_void 3693:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92862 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92864 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92874 */     GIR_RootConstrainSelectedInstOperands,
     /*  92875 */     // GIR_Coverage, 5063,
     /*  92875 */     GIR_EraseRootFromParent_Done,
     /*  92876 */   // Label 1690: @92876
     /*  92876 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92930), // Rule ID 5067 //
     /*  92881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92886 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92907 */     // MIs[1] Operand 1
     /*  92907 */     // No operand predicates
     /*  92907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92913 */     // (intrinsic_void 3693:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92916 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92918 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92928 */     GIR_RootConstrainSelectedInstOperands,
     /*  92929 */     // GIR_Coverage, 5067,
     /*  92929 */     GIR_EraseRootFromParent_Done,
     /*  92930 */   // Label 1691: @92930
     /*  92930 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92984), // Rule ID 5071 //
     /*  92935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92940 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92961 */     // MIs[1] Operand 1
     /*  92961 */     // No operand predicates
     /*  92961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92967 */     // (intrinsic_void 3693:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92970 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92972 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92982 */     GIR_RootConstrainSelectedInstOperands,
     /*  92983 */     // GIR_Coverage, 5071,
     /*  92983 */     GIR_EraseRootFromParent_Done,
     /*  92984 */   // Label 1692: @92984
     /*  92984 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(93042), // Rule ID 3 //
     /*  92989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  92992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  92997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93018 */     // (intrinsic_w_chain:{ *:[i32] } 3854:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SEL),
     /*  93021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93040 */     GIR_RootConstrainSelectedInstOperands,
     /*  93041 */     // GIR_Coverage, 3,
     /*  93041 */     GIR_EraseRootFromParent_Done,
     /*  93042 */   // Label 1693: @93042
     /*  93042 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(93100), // Rule ID 121 //
     /*  93047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93076 */     // (intrinsic_w_chain:{ *:[i32] } 3853:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SASX),
     /*  93079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93098 */     GIR_RootConstrainSelectedInstOperands,
     /*  93099 */     // GIR_Coverage, 121,
     /*  93099 */     GIR_EraseRootFromParent_Done,
     /*  93100 */   // Label 1694: @93100
     /*  93100 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(93158), // Rule ID 122 //
     /*  93105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93134 */     // (intrinsic_w_chain:{ *:[i32] } 3851:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD16),
     /*  93137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93156 */     GIR_RootConstrainSelectedInstOperands,
     /*  93157 */     // GIR_Coverage, 122,
     /*  93157 */     GIR_EraseRootFromParent_Done,
     /*  93158 */   // Label 1695: @93158
     /*  93158 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(93216), // Rule ID 123 //
     /*  93163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93192 */     // (intrinsic_w_chain:{ *:[i32] } 3852:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD8),
     /*  93195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93214 */     GIR_RootConstrainSelectedInstOperands,
     /*  93215 */     // GIR_Coverage, 123,
     /*  93215 */     GIR_EraseRootFromParent_Done,
     /*  93216 */   // Label 1696: @93216
     /*  93216 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(93274), // Rule ID 124 //
     /*  93221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93250 */     // (intrinsic_w_chain:{ *:[i32] } 3889:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSAX),
     /*  93253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93272 */     GIR_RootConstrainSelectedInstOperands,
     /*  93273 */     // GIR_Coverage, 124,
     /*  93273 */     GIR_EraseRootFromParent_Done,
     /*  93274 */   // Label 1697: @93274
     /*  93274 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(93332), // Rule ID 125 //
     /*  93279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93308 */     // (intrinsic_w_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB16),
     /*  93311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93330 */     GIR_RootConstrainSelectedInstOperands,
     /*  93331 */     // GIR_Coverage, 125,
     /*  93331 */     GIR_EraseRootFromParent_Done,
     /*  93332 */   // Label 1698: @93332
     /*  93332 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(93390), // Rule ID 126 //
     /*  93337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93366 */     // (intrinsic_w_chain:{ *:[i32] } 3891:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB8),
     /*  93369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93388 */     GIR_RootConstrainSelectedInstOperands,
     /*  93389 */     // GIR_Coverage, 126,
     /*  93389 */     GIR_EraseRootFromParent_Done,
     /*  93390 */   // Label 1699: @93390
     /*  93390 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(93448), // Rule ID 127 //
     /*  93395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93424 */     // (intrinsic_w_chain:{ *:[i32] } 3904:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UASX),
     /*  93427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93446 */     GIR_RootConstrainSelectedInstOperands,
     /*  93447 */     // GIR_Coverage, 127,
     /*  93447 */     GIR_EraseRootFromParent_Done,
     /*  93448 */   // Label 1700: @93448
     /*  93448 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(93506), // Rule ID 128 //
     /*  93453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93482 */     // (intrinsic_w_chain:{ *:[i32] } 3902:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD16),
     /*  93485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93504 */     GIR_RootConstrainSelectedInstOperands,
     /*  93505 */     // GIR_Coverage, 128,
     /*  93505 */     GIR_EraseRootFromParent_Done,
     /*  93506 */   // Label 1701: @93506
     /*  93506 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(93564), // Rule ID 129 //
     /*  93511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93540 */     // (intrinsic_w_chain:{ *:[i32] } 3903:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD8),
     /*  93543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93562 */     GIR_RootConstrainSelectedInstOperands,
     /*  93563 */     // GIR_Coverage, 129,
     /*  93563 */     GIR_EraseRootFromParent_Done,
     /*  93564 */   // Label 1702: @93564
     /*  93564 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(93622), // Rule ID 130 //
     /*  93569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  93577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93598 */     // (intrinsic_w_chain:{ *:[i32] } 3922:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAX),
     /*  93601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93620 */     GIR_RootConstrainSelectedInstOperands,
     /*  93621 */     // GIR_Coverage, 130,
     /*  93621 */     GIR_EraseRootFromParent_Done,
     /*  93622 */   // Label 1703: @93622
     /*  93622 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(93680), // Rule ID 131 //
     /*  93627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93656 */     // (intrinsic_w_chain:{ *:[i32] } 3923:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB16),
     /*  93659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93678 */     GIR_RootConstrainSelectedInstOperands,
     /*  93679 */     // GIR_Coverage, 131,
     /*  93679 */     GIR_EraseRootFromParent_Done,
     /*  93680 */   // Label 1704: @93680
     /*  93680 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(93738), // Rule ID 132 //
     /*  93685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93714 */     // (intrinsic_w_chain:{ *:[i32] } 3924:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB8),
     /*  93717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93736 */     GIR_RootConstrainSelectedInstOperands,
     /*  93737 */     // GIR_Coverage, 132,
     /*  93737 */     GIR_EraseRootFromParent_Done,
     /*  93738 */   // Label 1705: @93738
     /*  93738 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(93796), // Rule ID 431 //
     /*  93743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93772 */     // (intrinsic_w_chain:{ *:[i32] } 3854:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (t2SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SEL),
     /*  93775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93794 */     GIR_RootConstrainSelectedInstOperands,
     /*  93795 */     // GIR_Coverage, 431,
     /*  93795 */     GIR_EraseRootFromParent_Done,
     /*  93796 */   // Label 1706: @93796
     /*  93796 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(93854), // Rule ID 444 //
     /*  93801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93830 */     // (intrinsic_w_chain:{ *:[i32] } 3853:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SASX),
     /*  93833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93852 */     GIR_RootConstrainSelectedInstOperands,
     /*  93853 */     // GIR_Coverage, 444,
     /*  93853 */     GIR_EraseRootFromParent_Done,
     /*  93854 */   // Label 1707: @93854
     /*  93854 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93912), // Rule ID 445 //
     /*  93859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93888 */     // (intrinsic_w_chain:{ *:[i32] } 3851:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD16),
     /*  93891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93910 */     GIR_RootConstrainSelectedInstOperands,
     /*  93911 */     // GIR_Coverage, 445,
     /*  93911 */     GIR_EraseRootFromParent_Done,
     /*  93912 */   // Label 1708: @93912
     /*  93912 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93970), // Rule ID 446 //
     /*  93917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93946 */     // (intrinsic_w_chain:{ *:[i32] } 3852:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD8),
     /*  93949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93968 */     GIR_RootConstrainSelectedInstOperands,
     /*  93969 */     // GIR_Coverage, 446,
     /*  93969 */     GIR_EraseRootFromParent_Done,
     /*  93970 */   // Label 1709: @93970
     /*  93970 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(94028), // Rule ID 447 //
     /*  93975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94004 */     // (intrinsic_w_chain:{ *:[i32] } 3889:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSAX),
     /*  94007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94026 */     GIR_RootConstrainSelectedInstOperands,
     /*  94027 */     // GIR_Coverage, 447,
     /*  94027 */     GIR_EraseRootFromParent_Done,
     /*  94028 */   // Label 1710: @94028
     /*  94028 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(94086), // Rule ID 448 //
     /*  94033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  94041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94062 */     // (intrinsic_w_chain:{ *:[i32] } 3890:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB16),
     /*  94065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94084 */     GIR_RootConstrainSelectedInstOperands,
     /*  94085 */     // GIR_Coverage, 448,
     /*  94085 */     GIR_EraseRootFromParent_Done,
     /*  94086 */   // Label 1711: @94086
     /*  94086 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(94144), // Rule ID 449 //
     /*  94091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  94099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94120 */     // (intrinsic_w_chain:{ *:[i32] } 3891:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB8),
     /*  94123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94142 */     GIR_RootConstrainSelectedInstOperands,
     /*  94143 */     // GIR_Coverage, 449,
     /*  94143 */     GIR_EraseRootFromParent_Done,
     /*  94144 */   // Label 1712: @94144
     /*  94144 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(94202), // Rule ID 450 //
     /*  94149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  94157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94178 */     // (intrinsic_w_chain:{ *:[i32] } 3904:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UASX),
     /*  94181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94200 */     GIR_RootConstrainSelectedInstOperands,
     /*  94201 */     // GIR_Coverage, 450,
     /*  94201 */     GIR_EraseRootFromParent_Done,
     /*  94202 */   // Label 1713: @94202
     /*  94202 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(94260), // Rule ID 451 //
     /*  94207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  94215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94236 */     // (intrinsic_w_chain:{ *:[i32] } 3902:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD16),
     /*  94239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94258 */     GIR_RootConstrainSelectedInstOperands,
     /*  94259 */     // GIR_Coverage, 451,
     /*  94259 */     GIR_EraseRootFromParent_Done,
     /*  94260 */   // Label 1714: @94260
     /*  94260 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(94318), // Rule ID 452 //
     /*  94265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  94273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94294 */     // (intrinsic_w_chain:{ *:[i32] } 3903:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD8),
     /*  94297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94316 */     GIR_RootConstrainSelectedInstOperands,
     /*  94317 */     // GIR_Coverage, 452,
     /*  94317 */     GIR_EraseRootFromParent_Done,
     /*  94318 */   // Label 1715: @94318
     /*  94318 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(94376), // Rule ID 453 //
     /*  94323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  94331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94352 */     // (intrinsic_w_chain:{ *:[i32] } 3922:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAX),
     /*  94355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94374 */     GIR_RootConstrainSelectedInstOperands,
     /*  94375 */     // GIR_Coverage, 453,
     /*  94375 */     GIR_EraseRootFromParent_Done,
     /*  94376 */   // Label 1716: @94376
     /*  94376 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(94434), // Rule ID 454 //
     /*  94381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  94389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94410 */     // (intrinsic_w_chain:{ *:[i32] } 3923:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB16),
     /*  94413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94432 */     GIR_RootConstrainSelectedInstOperands,
     /*  94433 */     // GIR_Coverage, 454,
     /*  94433 */     GIR_EraseRootFromParent_Done,
     /*  94434 */   // Label 1717: @94434
     /*  94434 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(94492), // Rule ID 455 //
     /*  94439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  94447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94468 */     // (intrinsic_w_chain:{ *:[i32] } 3924:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB8),
     /*  94471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94490 */     GIR_RootConstrainSelectedInstOperands,
     /*  94491 */     // GIR_Coverage, 455,
     /*  94491 */     GIR_EraseRootFromParent_Done,
     /*  94492 */   // Label 1718: @94492
     /*  94492 */   GIM_Reject,
     /*  94493 */ // Label 1683: @94493
     /*  94493 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(94739),
     /*  94498 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  94501 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base_wb),
     /*  94506 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(94564), // Rule ID 5055 //
     /*  94511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94539 */     // MIs[1] Operand 1
     /*  94539 */     // No operand predicates
     /*  94539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94545 */     // (intrinsic_w_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94550 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94552 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94562 */     GIR_RootConstrainSelectedInstOperands,
     /*  94563 */     // GIR_Coverage, 5055,
     /*  94563 */     GIR_EraseRootFromParent_Done,
     /*  94564 */   // Label 1720: @94564
     /*  94564 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(94622), // Rule ID 5065 //
     /*  94569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94597 */     // MIs[1] Operand 1
     /*  94597 */     // No operand predicates
     /*  94597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94603 */     // (intrinsic_w_chain:{ *:[v4i32] } 3695:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94608 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94610 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94620 */     GIR_RootConstrainSelectedInstOperands,
     /*  94621 */     // GIR_Coverage, 5065,
     /*  94621 */     GIR_EraseRootFromParent_Done,
     /*  94622 */   // Label 1721: @94622
     /*  94622 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(94680), // Rule ID 5069 //
     /*  94627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94655 */     // MIs[1] Operand 1
     /*  94655 */     // No operand predicates
     /*  94655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94661 */     // (intrinsic_w_chain:{ *:[v2i64] } 3695:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94666 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94668 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94678 */     GIR_RootConstrainSelectedInstOperands,
     /*  94679 */     // GIR_Coverage, 5069,
     /*  94679 */     GIR_EraseRootFromParent_Done,
     /*  94680 */   // Label 1722: @94680
     /*  94680 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(94738), // Rule ID 5073 //
     /*  94685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94713 */     // MIs[1] Operand 1
     /*  94713 */     // No operand predicates
     /*  94713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94719 */     // (intrinsic_w_chain:{ *:[v2i64] } 3695:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94724 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94726 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94736 */     GIR_RootConstrainSelectedInstOperands,
     /*  94737 */     // GIR_Coverage, 5073,
     /*  94737 */     GIR_EraseRootFromParent_Done,
     /*  94738 */   // Label 1723: @94738
     /*  94738 */   GIM_Reject,
     /*  94739 */ // Label 1719: @94739
     /*  94739 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(95910),
     /*  94744 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  94747 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(94808), // Rule ID 4943 //
     /*  94752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94769 */     // MIs[0] base
     /*  94769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94793 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94796 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94798 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94800 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94806 */     GIR_RootConstrainSelectedInstOperands,
     /*  94807 */     // GIR_Coverage, 4943,
     /*  94807 */     GIR_EraseRootFromParent_Done,
     /*  94808 */   // Label 1725: @94808
     /*  94808 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(94869), // Rule ID 4944 //
     /*  94813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94830 */     // MIs[0] base
     /*  94830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94854 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94857 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94859 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94861 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94867 */     GIR_RootConstrainSelectedInstOperands,
     /*  94868 */     // GIR_Coverage, 4944,
     /*  94868 */     GIR_EraseRootFromParent_Done,
     /*  94869 */   // Label 1726: @94869
     /*  94869 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(94930), // Rule ID 4947 //
     /*  94874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  94882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94891 */     // MIs[0] base
     /*  94891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94915 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, MQPR:{ *:[v16i8] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB8_rq MQPR:{ *:[v16i8] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  94915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB8_rq),
     /*  94918 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94920 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94922 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94928 */     GIR_RootConstrainSelectedInstOperands,
     /*  94929 */     // GIR_Coverage, 4947,
     /*  94929 */     GIR_EraseRootFromParent_Done,
     /*  94930 */   // Label 1727: @94930
     /*  94930 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(94991), // Rule ID 5027 //
     /*  94935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94952 */     // MIs[0] base
     /*  94952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94976 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB16_rq),
     /*  94979 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94981 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94983 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94989 */     GIR_RootConstrainSelectedInstOperands,
     /*  94990 */     // GIR_Coverage, 5027,
     /*  94990 */     GIR_EraseRootFromParent_Done,
     /*  94991 */   // Label 1728: @94991
     /*  94991 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(95052), // Rule ID 5029 //
     /*  94996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95013 */     // MIs[0] base
     /*  95013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  95033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95037 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB32_rq),
     /*  95040 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95042 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95044 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95050 */     GIR_RootConstrainSelectedInstOperands,
     /*  95051 */     // GIR_Coverage, 5029,
     /*  95051 */     GIR_EraseRootFromParent_Done,
     /*  95052 */   // Label 1729: @95052
     /*  95052 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(95113), // Rule ID 5031 //
     /*  95057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  95065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95074 */     // MIs[0] base
     /*  95074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95098 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  95101 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95103 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95105 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95111 */     GIR_RootConstrainSelectedInstOperands,
     /*  95112 */     // GIR_Coverage, 5031,
     /*  95112 */     GIR_EraseRootFromParent_Done,
     /*  95113 */   // Label 1730: @95113
     /*  95113 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(95174), // Rule ID 5032 //
     /*  95118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  95126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95135 */     // MIs[0] base
     /*  95135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95159 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  95162 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95164 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95166 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95172 */     GIR_RootConstrainSelectedInstOperands,
     /*  95173 */     // GIR_Coverage, 5032,
     /*  95173 */     GIR_EraseRootFromParent_Done,
     /*  95174 */   // Label 1731: @95174
     /*  95174 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(95235), // Rule ID 5035 //
     /*  95179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95196 */     // MIs[0] base
     /*  95196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95220 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq_u),
     /*  95223 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95225 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95227 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95233 */     GIR_RootConstrainSelectedInstOperands,
     /*  95234 */     // GIR_Coverage, 5035,
     /*  95234 */     GIR_EraseRootFromParent_Done,
     /*  95235 */   // Label 1732: @95235
     /*  95235 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(95296), // Rule ID 5036 //
     /*  95240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95257 */     // MIs[0] base
     /*  95257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95281 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq),
     /*  95284 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95286 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95288 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95294 */     GIR_RootConstrainSelectedInstOperands,
     /*  95295 */     // GIR_Coverage, 5036,
     /*  95295 */     GIR_EraseRootFromParent_Done,
     /*  95296 */   // Label 1733: @95296
     /*  95296 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(95357), // Rule ID 5039 //
     /*  95301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95318 */     // MIs[0] base
     /*  95318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95342 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95345 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95347 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95349 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95355 */     GIR_RootConstrainSelectedInstOperands,
     /*  95356 */     // GIR_Coverage, 5039,
     /*  95356 */     GIR_EraseRootFromParent_Done,
     /*  95357 */   // Label 1734: @95357
     /*  95357 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(95418), // Rule ID 5040 //
     /*  95362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95379 */     // MIs[0] base
     /*  95379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95403 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95406 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95408 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95410 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95416 */     GIR_RootConstrainSelectedInstOperands,
     /*  95417 */     // GIR_Coverage, 5040,
     /*  95417 */     GIR_EraseRootFromParent_Done,
     /*  95418 */   // Label 1735: @95418
     /*  95418 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(95479), // Rule ID 5043 //
     /*  95423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95440 */     // MIs[0] base
     /*  95440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95464 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95467 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95469 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95471 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95477 */     GIR_RootConstrainSelectedInstOperands,
     /*  95478 */     // GIR_Coverage, 5043,
     /*  95478 */     GIR_EraseRootFromParent_Done,
     /*  95479 */   // Label 1736: @95479
     /*  95479 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(95540), // Rule ID 5044 //
     /*  95484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95501 */     // MIs[0] base
     /*  95501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95525 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95528 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95530 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95532 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95538 */     GIR_RootConstrainSelectedInstOperands,
     /*  95539 */     // GIR_Coverage, 5044,
     /*  95539 */     GIR_EraseRootFromParent_Done,
     /*  95540 */   // Label 1737: @95540
     /*  95540 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(95601), // Rule ID 5047 //
     /*  95545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95562 */     // MIs[0] base
     /*  95562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95586 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRD64_rq_u MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq_u),
     /*  95589 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95591 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95593 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95599 */     GIR_RootConstrainSelectedInstOperands,
     /*  95600 */     // GIR_Coverage, 5047,
     /*  95600 */     GIR_EraseRootFromParent_Done,
     /*  95601 */   // Label 1738: @95601
     /*  95601 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(95662), // Rule ID 5048 //
     /*  95606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95623 */     // MIs[0] base
     /*  95623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  95647 */     // (intrinsic_void 3697:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 3:{ *:[i32] })  =>  (MVE_VSTRD64_rq MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq),
     /*  95650 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95652 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95654 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95660 */     GIR_RootConstrainSelectedInstOperands,
     /*  95661 */     // GIR_Coverage, 5048,
     /*  95661 */     GIR_EraseRootFromParent_Done,
     /*  95662 */   // Label 1739: @95662
     /*  95662 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(95726), // Rule ID 258 //
     /*  95667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  95670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95681 */     // MIs[0] cop
     /*  95681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95684 */     // MIs[0] opc1
     /*  95684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95695 */     // MIs[0] CRm
     /*  95695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95698 */     // (intrinsic_void 3500:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR),
     /*  95701 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95703 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95709 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95724 */     GIR_RootConstrainSelectedInstOperands,
     /*  95725 */     // GIR_Coverage, 258,
     /*  95725 */     GIR_EraseRootFromParent_Done,
     /*  95726 */   // Label 1740: @95726
     /*  95726 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(95781), // Rule ID 259 //
     /*  95731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95745 */     // MIs[0] cop
     /*  95745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95748 */     // MIs[0] opc1
     /*  95748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95759 */     // MIs[0] CRm
     /*  95759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95762 */     // (intrinsic_void 3501:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR2),
     /*  95765 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95767 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95773 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95779 */     GIR_RootConstrainSelectedInstOperands,
     /*  95780 */     // GIR_Coverage, 259,
     /*  95780 */     GIR_EraseRootFromParent_Done,
     /*  95781 */   // Label 1741: @95781
     /*  95781 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(95845), // Rule ID 596 //
     /*  95786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  95789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95800 */     // MIs[0] cop
     /*  95800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95803 */     // MIs[0] opc1
     /*  95803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95814 */     // MIs[0] CRm
     /*  95814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95817 */     // (intrinsic_void 3500:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR),
     /*  95820 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95822 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95828 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95843 */     GIR_RootConstrainSelectedInstOperands,
     /*  95844 */     // GIR_Coverage, 596,
     /*  95844 */     GIR_EraseRootFromParent_Done,
     /*  95845 */   // Label 1742: @95845
     /*  95845 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(95909), // Rule ID 597 //
     /*  95850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95864 */     // MIs[0] cop
     /*  95864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95867 */     // MIs[0] opc1
     /*  95867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95878 */     // MIs[0] CRm
     /*  95878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95881 */     // (intrinsic_void 3501:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR2),
     /*  95884 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95886 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95892 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95907 */     GIR_RootConstrainSelectedInstOperands,
     /*  95908 */     // GIR_Coverage, 597,
     /*  95908 */     GIR_EraseRootFromParent_Done,
     /*  95909 */   // Label 1743: @95909
     /*  95909 */   GIM_Reject,
     /*  95910 */ // Label 1724: @95910
     /*  95910 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(99261),
     /*  95915 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  95918 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(95979), // Rule ID 246 //
     /*  95923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95931 */     // MIs[0] cop
     /*  95931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95934 */     // MIs[0] opc1
     /*  95934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95937 */     // MIs[0] CRd
     /*  95937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95940 */     // MIs[0] CRn
     /*  95940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95943 */     // MIs[0] CRm
     /*  95943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95946 */     // MIs[0] opc2
     /*  95946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95949 */     // (intrinsic_void 3468:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP),
     /*  95952 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95954 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95956 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95958 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95960 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95962 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95977 */     GIR_RootConstrainSelectedInstOperands,
     /*  95978 */     // GIR_Coverage, 246,
     /*  95978 */     GIR_EraseRootFromParent_Done,
     /*  95979 */   // Label 1745: @95979
     /*  95979 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(96031), // Rule ID 247 //
     /*  95984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95992 */     // MIs[0] cop
     /*  95992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95995 */     // MIs[0] opc1
     /*  95995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95998 */     // MIs[0] CRd
     /*  95998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  96001 */     // MIs[0] CRn
     /*  96001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96004 */     // MIs[0] CRm
     /*  96004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  96007 */     // MIs[0] opc2
     /*  96007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  96010 */     // (intrinsic_void 3469:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  96010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP2),
     /*  96013 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  96015 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  96017 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  96019 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  96021 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  96023 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  96025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96029 */     GIR_RootConstrainSelectedInstOperands,
     /*  96030 */     // GIR_Coverage, 247,
     /*  96030 */     GIR_EraseRootFromParent_Done,
     /*  96031 */   // Label 1746: @96031
     /*  96031 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(96092), // Rule ID 598 //
     /*  96036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  96039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  96044 */     // MIs[0] cop
     /*  96044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  96047 */     // MIs[0] opc1
     /*  96047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  96050 */     // MIs[0] CRd
     /*  96050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  96053 */     // MIs[0] CRn
     /*  96053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96056 */     // MIs[0] CRm
     /*  96056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  96059 */     // MIs[0] opc2
     /*  96059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  96062 */     // (intrinsic_void 3468:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  96062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP),
     /*  96065 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  96067 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  96069 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  96071 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  96073 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  96075 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  96077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  96080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  96086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96090 */     GIR_RootConstrainSelectedInstOperands,
     /*  96091 */     // GIR_Coverage, 598,
     /*  96091 */     GIR_EraseRootFromParent_Done,
     /*  96092 */   // Label 1747: @96092
     /*  96092 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(96153), // Rule ID 599 //
     /*  96097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  96100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  96105 */     // MIs[0] cop
     /*  96105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  96108 */     // MIs[0] opc1
     /*  96108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  96111 */     // MIs[0] CRd
     /*  96111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  96114 */     // MIs[0] CRn
     /*  96114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96117 */     // MIs[0] CRm
     /*  96117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  96120 */     // MIs[0] opc2
     /*  96120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  96123 */     // (intrinsic_void 3469:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  96123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP2),
     /*  96126 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  96128 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  96130 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  96132 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  96134 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  96136 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  96138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  96141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  96147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96151 */     GIR_RootConstrainSelectedInstOperands,
     /*  96152 */     // GIR_Coverage, 599,
     /*  96152 */     GIR_EraseRootFromParent_Done,
     /*  96153 */   // Label 1748: @96153
     /*  96153 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(96221), // Rule ID 4937 //
     /*  96158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96182 */     // MIs[0] base
     /*  96182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96206 */     // (intrinsic_w_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96211 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96213 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96219 */     GIR_RootConstrainSelectedInstOperands,
     /*  96220 */     // GIR_Coverage, 4937,
     /*  96220 */     GIR_EraseRootFromParent_Done,
     /*  96221 */   // Label 1749: @96221
     /*  96221 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(96289), // Rule ID 4938 //
     /*  96226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96250 */     // MIs[0] base
     /*  96250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96274 */     // (intrinsic_w_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96279 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96281 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96287 */     GIR_RootConstrainSelectedInstOperands,
     /*  96288 */     // GIR_Coverage, 4938,
     /*  96288 */     GIR_EraseRootFromParent_Done,
     /*  96289 */   // Label 1750: @96289
     /*  96289 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(96357), // Rule ID 4941 //
     /*  96294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96318 */     // MIs[0] base
     /*  96318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96342 */     // (intrinsic_w_chain:{ *:[v16i8] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96347 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96349 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96355 */     GIR_RootConstrainSelectedInstOperands,
     /*  96356 */     // GIR_Coverage, 4941,
     /*  96356 */     GIR_EraseRootFromParent_Done,
     /*  96357 */   // Label 1751: @96357
     /*  96357 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(96425), // Rule ID 4949 //
     /*  96362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96386 */     // MIs[0] base
     /*  96386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96410 */     // (intrinsic_w_chain:{ *:[v16i8] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96415 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96417 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96423 */     GIR_RootConstrainSelectedInstOperands,
     /*  96424 */     // GIR_Coverage, 4949,
     /*  96424 */     GIR_EraseRootFromParent_Done,
     /*  96425 */   // Label 1752: @96425
     /*  96425 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(96493), // Rule ID 4951 //
     /*  96430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96454 */     // MIs[0] base
     /*  96454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96478 */     // (intrinsic_w_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU16_rq),
     /*  96481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96483 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96485 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96491 */     GIR_RootConstrainSelectedInstOperands,
     /*  96492 */     // GIR_Coverage, 4951,
     /*  96492 */     GIR_EraseRootFromParent_Done,
     /*  96493 */   // Label 1753: @96493
     /*  96493 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(96561), // Rule ID 4953 //
     /*  96498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96522 */     // MIs[0] base
     /*  96522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96546 */     // (intrinsic_w_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS16_rq),
     /*  96549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96551 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96553 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96559 */     GIR_RootConstrainSelectedInstOperands,
     /*  96560 */     // GIR_Coverage, 4953,
     /*  96560 */     GIR_EraseRootFromParent_Done,
     /*  96561 */   // Label 1754: @96561
     /*  96561 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(96629), // Rule ID 4955 //
     /*  96566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96590 */     // MIs[0] base
     /*  96590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96614 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU32_rq),
     /*  96617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96619 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96621 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96627 */     GIR_RootConstrainSelectedInstOperands,
     /*  96628 */     // GIR_Coverage, 4955,
     /*  96628 */     GIR_EraseRootFromParent_Done,
     /*  96629 */   // Label 1755: @96629
     /*  96629 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(96697), // Rule ID 4957 //
     /*  96634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96658 */     // MIs[0] base
     /*  96658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96682 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS32_rq),
     /*  96685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96687 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96689 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96695 */     GIR_RootConstrainSelectedInstOperands,
     /*  96696 */     // GIR_Coverage, 4957,
     /*  96696 */     GIR_EraseRootFromParent_Done,
     /*  96697 */   // Label 1756: @96697
     /*  96697 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(96765), // Rule ID 4959 //
     /*  96702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96726 */     // MIs[0] base
     /*  96726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96750 */     // (intrinsic_w_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96755 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96757 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96763 */     GIR_RootConstrainSelectedInstOperands,
     /*  96764 */     // GIR_Coverage, 4959,
     /*  96764 */     GIR_EraseRootFromParent_Done,
     /*  96765 */   // Label 1757: @96765
     /*  96765 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(96833), // Rule ID 4960 //
     /*  96770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96794 */     // MIs[0] base
     /*  96794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96818 */     // (intrinsic_w_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96823 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96825 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96831 */     GIR_RootConstrainSelectedInstOperands,
     /*  96832 */     // GIR_Coverage, 4960,
     /*  96832 */     GIR_EraseRootFromParent_Done,
     /*  96833 */   // Label 1758: @96833
     /*  96833 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(96901), // Rule ID 4963 //
     /*  96838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96862 */     // MIs[0] base
     /*  96862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96886 */     // (intrinsic_w_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96891 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96893 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96899 */     GIR_RootConstrainSelectedInstOperands,
     /*  96900 */     // GIR_Coverage, 4963,
     /*  96900 */     GIR_EraseRootFromParent_Done,
     /*  96901 */   // Label 1759: @96901
     /*  96901 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(96969), // Rule ID 4964 //
     /*  96906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96930 */     // MIs[0] base
     /*  96930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96954 */     // (intrinsic_w_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96959 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96961 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96967 */     GIR_RootConstrainSelectedInstOperands,
     /*  96968 */     // GIR_Coverage, 4964,
     /*  96968 */     GIR_EraseRootFromParent_Done,
     /*  96969 */   // Label 1760: @96969
     /*  96969 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(97037), // Rule ID 4967 //
     /*  96974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96998 */     // MIs[0] base
     /*  96998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97022 */     // (intrinsic_w_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97027 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97029 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97035 */     GIR_RootConstrainSelectedInstOperands,
     /*  97036 */     // GIR_Coverage, 4967,
     /*  97036 */     GIR_EraseRootFromParent_Done,
     /*  97037 */   // Label 1761: @97037
     /*  97037 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(97105), // Rule ID 4968 //
     /*  97042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97066 */     // MIs[0] base
     /*  97066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97090 */     // (intrinsic_w_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97095 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97097 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97103 */     GIR_RootConstrainSelectedInstOperands,
     /*  97104 */     // GIR_Coverage, 4968,
     /*  97104 */     GIR_EraseRootFromParent_Done,
     /*  97105 */   // Label 1762: @97105
     /*  97105 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97173), // Rule ID 4971 //
     /*  97110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97134 */     // MIs[0] base
     /*  97134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97158 */     // (intrinsic_w_chain:{ *:[v8f16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97163 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97165 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97171 */     GIR_RootConstrainSelectedInstOperands,
     /*  97172 */     // GIR_Coverage, 4971,
     /*  97172 */     GIR_EraseRootFromParent_Done,
     /*  97173 */   // Label 1763: @97173
     /*  97173 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97241), // Rule ID 4972 //
     /*  97178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97202 */     // MIs[0] base
     /*  97202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97214 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97226 */     // (intrinsic_w_chain:{ *:[v8f16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97231 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97233 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97239 */     GIR_RootConstrainSelectedInstOperands,
     /*  97240 */     // GIR_Coverage, 4972,
     /*  97240 */     GIR_EraseRootFromParent_Done,
     /*  97241 */   // Label 1764: @97241
     /*  97241 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(97309), // Rule ID 4975 //
     /*  97246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97270 */     // MIs[0] base
     /*  97270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97282 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97294 */     // (intrinsic_w_chain:{ *:[v8f16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97299 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97301 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97307 */     GIR_RootConstrainSelectedInstOperands,
     /*  97308 */     // GIR_Coverage, 4975,
     /*  97308 */     GIR_EraseRootFromParent_Done,
     /*  97309 */   // Label 1765: @97309
     /*  97309 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(97377), // Rule ID 4976 //
     /*  97314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97338 */     // MIs[0] base
     /*  97338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97362 */     // (intrinsic_w_chain:{ *:[v8f16] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97367 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97369 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97375 */     GIR_RootConstrainSelectedInstOperands,
     /*  97376 */     // GIR_Coverage, 4976,
     /*  97376 */     GIR_EraseRootFromParent_Done,
     /*  97377 */   // Label 1766: @97377
     /*  97377 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(97445), // Rule ID 4979 //
     /*  97382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97406 */     // MIs[0] base
     /*  97406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97430 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq_u),
     /*  97433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97435 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97437 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97443 */     GIR_RootConstrainSelectedInstOperands,
     /*  97444 */     // GIR_Coverage, 4979,
     /*  97444 */     GIR_EraseRootFromParent_Done,
     /*  97445 */   // Label 1767: @97445
     /*  97445 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(97513), // Rule ID 4980 //
     /*  97450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97474 */     // MIs[0] base
     /*  97474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97498 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq),
     /*  97501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97503 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97505 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97511 */     GIR_RootConstrainSelectedInstOperands,
     /*  97512 */     // GIR_Coverage, 4980,
     /*  97512 */     GIR_EraseRootFromParent_Done,
     /*  97513 */   // Label 1768: @97513
     /*  97513 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(97581), // Rule ID 4983 //
     /*  97518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97542 */     // MIs[0] base
     /*  97542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97566 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq_u),
     /*  97569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97571 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97573 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97579 */     GIR_RootConstrainSelectedInstOperands,
     /*  97580 */     // GIR_Coverage, 4983,
     /*  97580 */     GIR_EraseRootFromParent_Done,
     /*  97581 */   // Label 1769: @97581
     /*  97581 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(97649), // Rule ID 4984 //
     /*  97586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97610 */     // MIs[0] base
     /*  97610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97634 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq),
     /*  97637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97639 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97641 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97647 */     GIR_RootConstrainSelectedInstOperands,
     /*  97648 */     // GIR_Coverage, 4984,
     /*  97648 */     GIR_EraseRootFromParent_Done,
     /*  97649 */   // Label 1770: @97649
     /*  97649 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(97717), // Rule ID 4987 //
     /*  97654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97678 */     // MIs[0] base
     /*  97678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97702 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97707 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97709 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97715 */     GIR_RootConstrainSelectedInstOperands,
     /*  97716 */     // GIR_Coverage, 4987,
     /*  97716 */     GIR_EraseRootFromParent_Done,
     /*  97717 */   // Label 1771: @97717
     /*  97717 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(97785), // Rule ID 4988 //
     /*  97722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97746 */     // MIs[0] base
     /*  97746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97770 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97775 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97777 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97783 */     GIR_RootConstrainSelectedInstOperands,
     /*  97784 */     // GIR_Coverage, 4988,
     /*  97784 */     GIR_EraseRootFromParent_Done,
     /*  97785 */   // Label 1772: @97785
     /*  97785 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(97853), // Rule ID 4991 //
     /*  97790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97814 */     // MIs[0] base
     /*  97814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97838 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97843 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97845 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97851 */     GIR_RootConstrainSelectedInstOperands,
     /*  97852 */     // GIR_Coverage, 4991,
     /*  97852 */     GIR_EraseRootFromParent_Done,
     /*  97853 */   // Label 1773: @97853
     /*  97853 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97921), // Rule ID 4992 //
     /*  97858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97882 */     // MIs[0] base
     /*  97882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97906 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97911 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97913 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97919 */     GIR_RootConstrainSelectedInstOperands,
     /*  97920 */     // GIR_Coverage, 4992,
     /*  97920 */     GIR_EraseRootFromParent_Done,
     /*  97921 */   // Label 1774: @97921
     /*  97921 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(97989), // Rule ID 4995 //
     /*  97926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97950 */     // MIs[0] base
     /*  97950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97974 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97979 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97981 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97987 */     GIR_RootConstrainSelectedInstOperands,
     /*  97988 */     // GIR_Coverage, 4995,
     /*  97988 */     GIR_EraseRootFromParent_Done,
     /*  97989 */   // Label 1775: @97989
     /*  97989 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(98057), // Rule ID 4996 //
     /*  97994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98018 */     // MIs[0] base
     /*  98018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98042 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98047 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98049 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98055 */     GIR_RootConstrainSelectedInstOperands,
     /*  98056 */     // GIR_Coverage, 4996,
     /*  98056 */     GIR_EraseRootFromParent_Done,
     /*  98057 */   // Label 1776: @98057
     /*  98057 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(98125), // Rule ID 4999 //
     /*  98062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98086 */     // MIs[0] base
     /*  98086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98110 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98115 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98117 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98123 */     GIR_RootConstrainSelectedInstOperands,
     /*  98124 */     // GIR_Coverage, 4999,
     /*  98124 */     GIR_EraseRootFromParent_Done,
     /*  98125 */   // Label 1777: @98125
     /*  98125 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(98193), // Rule ID 5000 //
     /*  98130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98154 */     // MIs[0] base
     /*  98154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98178 */     // (intrinsic_w_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98183 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98185 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98191 */     GIR_RootConstrainSelectedInstOperands,
     /*  98192 */     // GIR_Coverage, 5000,
     /*  98192 */     GIR_EraseRootFromParent_Done,
     /*  98193 */   // Label 1778: @98193
     /*  98193 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(98261), // Rule ID 5003 //
     /*  98198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98222 */     // MIs[0] base
     /*  98222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98246 */     // (intrinsic_w_chain:{ *:[v4f32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98251 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98253 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98259 */     GIR_RootConstrainSelectedInstOperands,
     /*  98260 */     // GIR_Coverage, 5003,
     /*  98260 */     GIR_EraseRootFromParent_Done,
     /*  98261 */   // Label 1779: @98261
     /*  98261 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(98329), // Rule ID 5004 //
     /*  98266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98290 */     // MIs[0] base
     /*  98290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98314 */     // (intrinsic_w_chain:{ *:[v4f32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98319 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98321 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98327 */     GIR_RootConstrainSelectedInstOperands,
     /*  98328 */     // GIR_Coverage, 5004,
     /*  98328 */     GIR_EraseRootFromParent_Done,
     /*  98329 */   // Label 1780: @98329
     /*  98329 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(98397), // Rule ID 5007 //
     /*  98334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98358 */     // MIs[0] base
     /*  98358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98382 */     // (intrinsic_w_chain:{ *:[v4f32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98387 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98389 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98395 */     GIR_RootConstrainSelectedInstOperands,
     /*  98396 */     // GIR_Coverage, 5007,
     /*  98396 */     GIR_EraseRootFromParent_Done,
     /*  98397 */   // Label 1781: @98397
     /*  98397 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98465), // Rule ID 5008 //
     /*  98402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98426 */     // MIs[0] base
     /*  98426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98450 */     // (intrinsic_w_chain:{ *:[v4f32] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98455 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98457 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98463 */     GIR_RootConstrainSelectedInstOperands,
     /*  98464 */     // GIR_Coverage, 5008,
     /*  98464 */     GIR_EraseRootFromParent_Done,
     /*  98465 */   // Label 1782: @98465
     /*  98465 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98533), // Rule ID 5011 //
     /*  98470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98494 */     // MIs[0] base
     /*  98494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98518 */     // (intrinsic_w_chain:{ *:[v2i64] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98523 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98525 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98531 */     GIR_RootConstrainSelectedInstOperands,
     /*  98532 */     // GIR_Coverage, 5011,
     /*  98532 */     GIR_EraseRootFromParent_Done,
     /*  98533 */   // Label 1783: @98533
     /*  98533 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(98601), // Rule ID 5012 //
     /*  98538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98562 */     // MIs[0] base
     /*  98562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98586 */     // (intrinsic_w_chain:{ *:[v2i64] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98591 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98593 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98599 */     GIR_RootConstrainSelectedInstOperands,
     /*  98600 */     // GIR_Coverage, 5012,
     /*  98600 */     GIR_EraseRootFromParent_Done,
     /*  98601 */   // Label 1784: @98601
     /*  98601 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(98669), // Rule ID 5015 //
     /*  98606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98630 */     // MIs[0] base
     /*  98630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98654 */     // (intrinsic_w_chain:{ *:[v2i64] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98659 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98661 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98667 */     GIR_RootConstrainSelectedInstOperands,
     /*  98668 */     // GIR_Coverage, 5015,
     /*  98668 */     GIR_EraseRootFromParent_Done,
     /*  98669 */   // Label 1785: @98669
     /*  98669 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(98737), // Rule ID 5016 //
     /*  98674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98698 */     // MIs[0] base
     /*  98698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98722 */     // (intrinsic_w_chain:{ *:[v2i64] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98727 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98729 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98735 */     GIR_RootConstrainSelectedInstOperands,
     /*  98736 */     // GIR_Coverage, 5016,
     /*  98736 */     GIR_EraseRootFromParent_Done,
     /*  98737 */   // Label 1786: @98737
     /*  98737 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(98805), // Rule ID 5019 //
     /*  98742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98766 */     // MIs[0] base
     /*  98766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98790 */     // (intrinsic_w_chain:{ *:[v2i64] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98795 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98797 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98803 */     GIR_RootConstrainSelectedInstOperands,
     /*  98804 */     // GIR_Coverage, 5019,
     /*  98804 */     GIR_EraseRootFromParent_Done,
     /*  98805 */   // Label 1787: @98805
     /*  98805 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(98873), // Rule ID 5020 //
     /*  98810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98834 */     // MIs[0] base
     /*  98834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98858 */     // (intrinsic_w_chain:{ *:[v2i64] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98863 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98865 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98871 */     GIR_RootConstrainSelectedInstOperands,
     /*  98872 */     // GIR_Coverage, 5020,
     /*  98872 */     GIR_EraseRootFromParent_Done,
     /*  98873 */   // Label 1788: @98873
     /*  98873 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(98941), // Rule ID 5023 //
     /*  98878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98902 */     // MIs[0] base
     /*  98902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98926 */     // (intrinsic_w_chain:{ *:[v2i64] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98931 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98933 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98939 */     GIR_RootConstrainSelectedInstOperands,
     /*  98940 */     // GIR_Coverage, 5023,
     /*  98940 */     GIR_EraseRootFromParent_Done,
     /*  98941 */   // Label 1789: @98941
     /*  98941 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(99009), // Rule ID 5024 //
     /*  98946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98970 */     // MIs[0] base
     /*  98970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98994 */     // (intrinsic_w_chain:{ *:[v2i64] } 3623:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98999 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  99001 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  99003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99007 */     GIR_RootConstrainSelectedInstOperands,
     /*  99008 */     // GIR_Coverage, 5024,
     /*  99008 */     GIR_EraseRootFromParent_Done,
     /*  99009 */   // Label 1790: @99009
     /*  99009 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(99074), // Rule ID 256 //
     /*  99014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  99022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99025 */     // MIs[0] cop
     /*  99025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99028 */     // MIs[0] opc1
     /*  99028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99035 */     // MIs[0] CRn
     /*  99035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99038 */     // MIs[0] CRm
     /*  99038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99041 */     // MIs[0] opc2
     /*  99041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99044 */     // (intrinsic_void 3498:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR),
     /*  99047 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99049 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99053 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99055 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99057 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99072 */     GIR_RootConstrainSelectedInstOperands,
     /*  99073 */     // GIR_Coverage, 256,
     /*  99073 */     GIR_EraseRootFromParent_Done,
     /*  99074 */   // Label 1791: @99074
     /*  99074 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(99130), // Rule ID 257 //
     /*  99079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  99082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  99087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99090 */     // MIs[0] cop
     /*  99090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99093 */     // MIs[0] opc1
     /*  99093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99100 */     // MIs[0] CRn
     /*  99100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99103 */     // MIs[0] CRm
     /*  99103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99106 */     // MIs[0] opc2
     /*  99106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99109 */     // (intrinsic_void 3499:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR2),
     /*  99112 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99114 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99118 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99120 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99122 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99128 */     GIR_RootConstrainSelectedInstOperands,
     /*  99129 */     // GIR_Coverage, 257,
     /*  99129 */     GIR_EraseRootFromParent_Done,
     /*  99130 */   // Label 1792: @99130
     /*  99130 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(99195), // Rule ID 594 //
     /*  99135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  99143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99146 */     // MIs[0] cop
     /*  99146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99149 */     // MIs[0] opc1
     /*  99149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99156 */     // MIs[0] CRn
     /*  99156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99159 */     // MIs[0] CRm
     /*  99159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99162 */     // MIs[0] opc2
     /*  99162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99165 */     // (intrinsic_void 3498:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR),
     /*  99168 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99170 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99174 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99176 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99178 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99193 */     GIR_RootConstrainSelectedInstOperands,
     /*  99194 */     // GIR_Coverage, 594,
     /*  99194 */     GIR_EraseRootFromParent_Done,
     /*  99195 */   // Label 1793: @99195
     /*  99195 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(99260), // Rule ID 595 //
     /*  99200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  99203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  99208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99211 */     // MIs[0] cop
     /*  99211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99214 */     // MIs[0] opc1
     /*  99214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99221 */     // MIs[0] CRn
     /*  99221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99224 */     // MIs[0] CRm
     /*  99224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99227 */     // MIs[0] opc2
     /*  99227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99230 */     // (intrinsic_void 3499:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR2),
     /*  99233 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99235 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99239 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99241 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99243 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99258 */     GIR_RootConstrainSelectedInstOperands,
     /*  99259 */     // GIR_Coverage, 595,
     /*  99259 */     GIR_EraseRootFromParent_Done,
     /*  99260 */   // Label 1794: @99260
     /*  99260 */   GIM_Reject,
     /*  99261 */ // Label 1744: @99261
     /*  99261 */ GIM_Reject,
     /*  99262 */ // Label 17: @99262
     /*  99262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1798*/ GIMT_Encode4(99419),
     /*  99273 */ /*GILLT_v2s64*//*Label 1795*/ GIMT_Encode4(99305), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99285 */ /*GILLT_v4s32*//*Label 1796*/ GIMT_Encode4(99343), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99301 */ /*GILLT_v8s16*//*Label 1797*/ GIMT_Encode4(99381),
     /*  99305 */ // Label 1795: @99305
     /*  99305 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(99342), // Rule ID 2668 //
     /*  99310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99324 */   // (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /*  99327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99329 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99334 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99340 */   GIR_RootConstrainSelectedInstOperands,
     /*  99341 */   // GIR_Coverage, 2668,
     /*  99341 */   GIR_EraseRootFromParent_Done,
     /*  99342 */ // Label 1799: @99342
     /*  99342 */ GIM_Reject,
     /*  99343 */ // Label 1796: @99343
     /*  99343 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(99380), // Rule ID 2667 //
     /*  99348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99362 */   // (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /*  99365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99367 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99372 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99378 */   GIR_RootConstrainSelectedInstOperands,
     /*  99379 */   // GIR_Coverage, 2667,
     /*  99379 */   GIR_EraseRootFromParent_Done,
     /*  99380 */ // Label 1800: @99380
     /*  99380 */ GIM_Reject,
     /*  99381 */ // Label 1797: @99381
     /*  99381 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(99418), // Rule ID 2666 //
     /*  99386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99400 */   // (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /*  99403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99405 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99410 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99416 */   GIR_RootConstrainSelectedInstOperands,
     /*  99417 */   // GIR_Coverage, 2666,
     /*  99417 */   GIR_EraseRootFromParent_Done,
     /*  99418 */ // Label 1801: @99418
     /*  99418 */ GIM_Reject,
     /*  99419 */ // Label 1798: @99419
     /*  99419 */ GIM_Reject,
     /*  99420 */ // Label 18: @99420
     /*  99420 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(12), /*)*//*default:*//*Label 1805*/ GIMT_Encode4(99577),
     /*  99431 */ /*GILLT_v2s32*//*Label 1802*/ GIMT_Encode4(99463), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99443 */ /*GILLT_v4s16*//*Label 1803*/ GIMT_Encode4(99501), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99459 */ /*GILLT_v8s8*//*Label 1804*/ GIMT_Encode4(99539),
     /*  99463 */ // Label 1802: @99463
     /*  99463 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(99500), // Rule ID 1588 //
     /*  99468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99482 */   // (trunc:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)  =>  (VMOVNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  99482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv2i32),
     /*  99485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99487 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99492 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99498 */   GIR_RootConstrainSelectedInstOperands,
     /*  99499 */   // GIR_Coverage, 1588,
     /*  99499 */   GIR_EraseRootFromParent_Done,
     /*  99500 */ // Label 1806: @99500
     /*  99500 */ GIM_Reject,
     /*  99501 */ // Label 1803: @99501
     /*  99501 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(99538), // Rule ID 1587 //
     /*  99506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99520 */   // (trunc:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)  =>  (VMOVNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  99520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv4i16),
     /*  99523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99525 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99530 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99536 */   GIR_RootConstrainSelectedInstOperands,
     /*  99537 */   // GIR_Coverage, 1587,
     /*  99537 */   GIR_EraseRootFromParent_Done,
     /*  99538 */ // Label 1807: @99538
     /*  99538 */ GIM_Reject,
     /*  99539 */ // Label 1804: @99539
     /*  99539 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(99576), // Rule ID 1586 //
     /*  99544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99558 */   // (trunc:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)  =>  (VMOVNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  99558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv8i8),
     /*  99561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99563 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99568 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99574 */   GIR_RootConstrainSelectedInstOperands,
     /*  99575 */   // GIR_Coverage, 1586,
     /*  99575 */   GIR_EraseRootFromParent_Done,
     /*  99576 */ // Label 1808: @99576
     /*  99576 */ GIM_Reject,
     /*  99577 */ // Label 1805: @99577
     /*  99577 */ GIM_Reject,
     /*  99578 */ // Label 19: @99578
     /*  99578 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(99898),
     /*  99583 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  99586 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(99627), // Rule ID 404 //
     /*  99591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99594 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  99598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99602 */     // MIs[0] Operand 1
     /*  99602 */     // No operand predicates
     /*  99602 */     // (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm  =>  (t2MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /*  99605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99625 */     GIR_RootConstrainSelectedInstOperands,
     /*  99626 */     // GIR_Coverage, 404,
     /*  99626 */     GIR_EraseRootFromParent_Done,
     /*  99627 */   // Label 1810: @99627
     /*  99627 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(99668), // Rule ID 57 //
     /*  99632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99635 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  99639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99643 */     // MIs[0] Operand 1
     /*  99643 */     // No operand predicates
     /*  99643 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm  =>  (MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /*  99646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99666 */     GIR_RootConstrainSelectedInstOperands,
     /*  99667 */     // GIR_Coverage, 57,
     /*  99667 */     GIR_EraseRootFromParent_Done,
     /*  99668 */   // Label 1811: @99668
     /*  99668 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(99703), // Rule ID 58 //
     /*  99673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  99676 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99684 */     // MIs[0] Operand 1
     /*  99684 */     // No operand predicates
     /*  99684 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi16),
     /*  99687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99701 */     GIR_RootConstrainSelectedInstOperands,
     /*  99702 */     // GIR_Coverage, 58,
     /*  99702 */     GIR_EraseRootFromParent_Done,
     /*  99703 */   // Label 1812: @99703
     /*  99703 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(99746), // Rule ID 168 //
     /*  99708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99711 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  99715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99719 */     // MIs[0] Operand 1
     /*  99719 */     // No operand predicates
     /*  99719 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm  =>  (MVNi:{ *:[i32] } (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  99719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNi),
     /*  99722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99724 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  99729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99744 */     GIR_RootConstrainSelectedInstOperands,
     /*  99745 */     // GIR_Coverage, 168,
     /*  99745 */     GIR_EraseRootFromParent_Done,
     /*  99746 */   // Label 1813: @99746
     /*  99746 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(99772), // Rule ID 268 //
     /*  99751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99754 */     GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_arm_i32imm),
     /*  99758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99762 */     // MIs[0] Operand 1
     /*  99762 */     // No operand predicates
     /*  99762 */     // (imm:{ *:[i32] })<<P:Predicate_arm_i32imm>>:$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi32imm),
     /*  99765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99770 */     GIR_RootConstrainSelectedInstOperands,
     /*  99771 */     // GIR_Coverage, 268,
     /*  99771 */     GIR_EraseRootFromParent_Done,
     /*  99772 */   // Label 1814: @99772
     /*  99772 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99813), // Rule ID 322 //
     /*  99777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  99780 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*  99784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99788 */     // MIs[0] Operand 1
     /*  99788 */     // No operand predicates
     /*  99788 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8  =>  (tMOVi8:{ *:[i32] } (imm:{ *:[i32] }):$imm8)
     /*  99788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  99791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  99799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm8
     /*  99802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99811 */     GIR_RootConstrainSelectedInstOperands,
     /*  99812 */     // GIR_Coverage, 322,
     /*  99812 */     GIR_EraseRootFromParent_Done,
     /*  99813 */   // Label 1815: @99813
     /*  99813 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99848), // Rule ID 405 //
     /*  99818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /*  99821 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99829 */     // MIs[0] Operand 1
     /*  99829 */     // No operand predicates
     /*  99829 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (t2MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /*  99832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99846 */     GIR_RootConstrainSelectedInstOperands,
     /*  99847 */     // GIR_Coverage, 405,
     /*  99847 */     GIR_EraseRootFromParent_Done,
     /*  99848 */   // Label 1816: @99848
     /*  99848 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(99897),
     /*  99853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99857 */     GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(99878), // Rule ID 353 //
     /*  99862 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only),
     /*  99865 */       // MIs[0] Operand 1
     /*  99865 */       // No operand predicates
     /*  99865 */       // (imm:{ *:[i32] }):$src  =>  (tMOVi32imm:{ *:[i32] }:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99865 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi32imm),
     /*  99868 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99870 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99873 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::CPSR*/0,
     /*  99876 */       GIR_RootConstrainSelectedInstOperands,
     /*  99877 */       // GIR_Coverage, 353,
     /*  99877 */       GIR_EraseRootFromParent_Done,
     /*  99878 */     // Label 1818: @99878
     /*  99878 */     GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(99896), // Rule ID 582 //
     /*  99883 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_UseMovt),
     /*  99886 */       // MIs[0] Operand 1
     /*  99886 */       // No operand predicates
     /*  99886 */       // (imm:{ *:[i32] }):$src  =>  (t2MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99886 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /*  99889 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99891 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99894 */       GIR_RootConstrainSelectedInstOperands,
     /*  99895 */       // GIR_Coverage, 582,
     /*  99895 */       GIR_EraseRootFromParent_Done,
     /*  99896 */     // Label 1819: @99896
     /*  99896 */     GIM_Reject,
     /*  99897 */   // Label 1817: @99897
     /*  99897 */   GIM_Reject,
     /*  99898 */ // Label 1809: @99898
     /*  99898 */ GIM_Reject,
     /*  99899 */ // Label 20: @99899
     /*  99899 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1822*/ GIMT_Encode4(99994),
     /*  99910 */ /*GILLT_s32*//*Label 1820*/ GIMT_Encode4(99918),
     /*  99914 */ /*GILLT_s64*//*Label 1821*/ GIMT_Encode4(99956),
     /*  99918 */ // Label 1820: @99918
     /*  99918 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(99955), // Rule ID 728 //
     /*  99923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP3),
     /*  99926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  99930 */   // MIs[0] Operand 1
     /*  99930 */   // No operand predicates
     /*  99930 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f32imm),
     /*  99934 */   // (fpimm:{ *:[f32] })<<P:Predicate_vfp_f32imm>><<X:vfp_f32imm_xform>>:$imm  =>  (FCONSTS:{ *:[f32] } (vfp_f32imm_xform:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /*  99934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTS),
     /*  99937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  99939 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF32Imm), // imm
     /*  99944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99947 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99953 */   GIR_RootConstrainSelectedInstOperands,
     /*  99954 */   // GIR_Coverage, 728,
     /*  99954 */   GIR_EraseRootFromParent_Done,
     /*  99955 */ // Label 1823: @99955
     /*  99955 */ GIM_Reject,
     /*  99956 */ // Label 1821: @99956
     /*  99956 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(99993), // Rule ID 727 //
     /*  99961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP3),
     /*  99964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99968 */   // MIs[0] Operand 1
     /*  99968 */   // No operand predicates
     /*  99968 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f64imm),
     /*  99972 */   // (fpimm:{ *:[f64] })<<P:Predicate_vfp_f64imm>><<X:vfp_f64imm_xform>>:$imm  =>  (FCONSTD:{ *:[f64] } (vfp_f64imm_xform:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /*  99972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTD),
     /*  99975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  99977 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF64Imm), // imm
     /*  99982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99985 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99991 */   GIR_RootConstrainSelectedInstOperands,
     /*  99992 */   // GIR_Coverage, 727,
     /*  99992 */   GIR_EraseRootFromParent_Done,
     /*  99993 */ // Label 1824: @99993
     /*  99993 */ GIM_Reject,
     /*  99994 */ // Label 1822: @99994
     /*  99994 */ GIM_Reject,
     /*  99995 */ // Label 21: @99995
     /*  99995 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1828*/ GIMT_Encode4(100152),
     /* 100006 */ /*GILLT_v2s64*//*Label 1825*/ GIMT_Encode4(100038), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100018 */ /*GILLT_v4s32*//*Label 1826*/ GIMT_Encode4(100076), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100034 */ /*GILLT_v8s16*//*Label 1827*/ GIMT_Encode4(100114),
     /* 100038 */ // Label 1825: @100038
     /* 100038 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(100075), // Rule ID 1600 //
     /* 100043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100057 */   // (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv2i64),
     /* 100060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100062 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100067 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100073 */   GIR_RootConstrainSelectedInstOperands,
     /* 100074 */   // GIR_Coverage, 1600,
     /* 100074 */   GIR_EraseRootFromParent_Done,
     /* 100075 */ // Label 1829: @100075
     /* 100075 */ GIM_Reject,
     /* 100076 */ // Label 1826: @100076
     /* 100076 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(100113), // Rule ID 1599 //
     /* 100081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100095 */   // (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv4i32),
     /* 100098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100100 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100105 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100111 */   GIR_RootConstrainSelectedInstOperands,
     /* 100112 */   // GIR_Coverage, 1599,
     /* 100112 */   GIR_EraseRootFromParent_Done,
     /* 100113 */ // Label 1830: @100113
     /* 100113 */ GIM_Reject,
     /* 100114 */ // Label 1827: @100114
     /* 100114 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(100151), // Rule ID 1598 //
     /* 100119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100133 */   // (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv8i16),
     /* 100136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100138 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100143 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100149 */   GIR_RootConstrainSelectedInstOperands,
     /* 100150 */   // GIR_Coverage, 1598,
     /* 100150 */   GIR_EraseRootFromParent_Done,
     /* 100151 */ // Label 1831: @100151
     /* 100151 */ GIM_Reject,
     /* 100152 */ // Label 1828: @100152
     /* 100152 */ GIM_Reject,
     /* 100153 */ // Label 22: @100153
     /* 100153 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 1835*/ GIMT_Encode4(100757),
     /* 100164 */ /*GILLT_s32*//*Label 1832*/ GIMT_Encode4(100212), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100192 */ /*GILLT_v4s32*//*Label 1833*/ GIMT_Encode4(100504), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100208 */ /*GILLT_v8s16*//*Label 1834*/ GIMT_Encode4(100687),
     /* 100212 */ // Label 1832: @100212
     /* 100212 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(100503),
     /* 100217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100220 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(100265), // Rule ID 340 //
     /* 100225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100236 */     // MIs[0] Operand 2
     /* 100236 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100247 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] })  =>  (tSXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTB),
     /* 100250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100263 */     GIR_RootConstrainSelectedInstOperands,
     /* 100264 */     // GIR_Coverage, 340,
     /* 100264 */     GIR_EraseRootFromParent_Done,
     /* 100265 */   // Label 1837: @100265
     /* 100265 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(100310), // Rule ID 341 //
     /* 100270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100281 */     // MIs[0] Operand 2
     /* 100281 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100292 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })  =>  (tSXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTH),
     /* 100295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100308 */     GIR_RootConstrainSelectedInstOperands,
     /* 100309 */     // GIR_Coverage, 341,
     /* 100309 */     GIR_EraseRootFromParent_Done,
     /* 100310 */   // Label 1838: @100310
     /* 100310 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(100358), // Rule ID 2002 //
     /* 100315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100326 */     // MIs[0] Operand 2
     /* 100326 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100337 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (SXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB),
     /* 100340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100356 */     GIR_RootConstrainSelectedInstOperands,
     /* 100357 */     // GIR_Coverage, 2002,
     /* 100357 */     GIR_EraseRootFromParent_Done,
     /* 100358 */   // Label 1839: @100358
     /* 100358 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(100406), // Rule ID 2003 //
     /* 100363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100374 */     // MIs[0] Operand 2
     /* 100374 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100385 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (SXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTH),
     /* 100388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100404 */     GIR_RootConstrainSelectedInstOperands,
     /* 100405 */     // GIR_Coverage, 2003,
     /* 100405 */     GIR_EraseRootFromParent_Done,
     /* 100406 */   // Label 1840: @100406
     /* 100406 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(100454), // Rule ID 2241 //
     /* 100411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100422 */     // MIs[0] Operand 2
     /* 100422 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100433 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (t2SXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB),
     /* 100436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100452 */     GIR_RootConstrainSelectedInstOperands,
     /* 100453 */     // GIR_Coverage, 2241,
     /* 100453 */     GIR_EraseRootFromParent_Done,
     /* 100454 */   // Label 1841: @100454
     /* 100454 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(100502), // Rule ID 2242 //
     /* 100459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100470 */     // MIs[0] Operand 2
     /* 100470 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100481 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (t2SXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTH),
     /* 100484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100500 */     GIR_RootConstrainSelectedInstOperands,
     /* 100501 */     // GIR_Coverage, 2242,
     /* 100501 */     GIR_EraseRootFromParent_Done,
     /* 100502 */   // Label 1842: @100502
     /* 100502 */   GIM_Reject,
     /* 100503 */ // Label 1836: @100503
     /* 100503 */ GIM_Reject,
     /* 100504 */ // Label 1833: @100504
     /* 100504 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(100686),
     /* 100509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100520 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(100578), // Rule ID 3713 //
     /* 100525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100528 */     // MIs[0] Operand 2
     /* 100528 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100539 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i16:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 100539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100556 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100576 */     GIR_RootConstrainSelectedInstOperands,
     /* 100577 */     // GIR_Coverage, 3713,
     /* 100577 */     GIR_EraseRootFromParent_Done,
     /* 100578 */   // Label 1844: @100578
     /* 100578 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(100685), // Rule ID 3715 //
     /* 100583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100586 */     // MIs[0] Operand 2
     /* 100586 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100597 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i8:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } (MVE_VMOVLs8bh:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src))
     /* 100597 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 100600 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100604 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100609 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100612 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100616 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 100624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 100637 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100640 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100646 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100652 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100683 */     GIR_RootConstrainSelectedInstOperands,
     /* 100684 */     // GIR_Coverage, 3715,
     /* 100684 */     GIR_EraseRootFromParent_Done,
     /* 100685 */   // Label 1845: @100685
     /* 100685 */   GIM_Reject,
     /* 100686 */ // Label 1843: @100686
     /* 100686 */ GIM_Reject,
     /* 100687 */ // Label 1834: @100687
     /* 100687 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(100756), // Rule ID 3714 //
     /* 100692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 100698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100706 */   // MIs[0] Operand 2
     /* 100706 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100717 */   // (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, v8i8:{ *:[Other] })  =>  (MVE_VMOVLs8bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 100717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100734 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100739 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100745 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100751 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100754 */   GIR_RootConstrainSelectedInstOperands,
     /* 100755 */   // GIR_Coverage, 3714,
     /* 100755 */   GIR_EraseRootFromParent_Done,
     /* 100756 */ // Label 1846: @100756
     /* 100756 */ GIM_Reject,
     /* 100757 */ // Label 1835: @100757
     /* 100757 */ GIM_Reject,
     /* 100758 */ // Label 23: @100758
     /* 100758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1850*/ GIMT_Encode4(100915),
     /* 100769 */ /*GILLT_v2s64*//*Label 1847*/ GIMT_Encode4(100801), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100781 */ /*GILLT_v4s32*//*Label 1848*/ GIMT_Encode4(100839), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100797 */ /*GILLT_v8s16*//*Label 1849*/ GIMT_Encode4(100877),
     /* 100801 */ // Label 1847: @100801
     /* 100801 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(100838), // Rule ID 1603 //
     /* 100806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100820 */   // (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /* 100823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100825 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100830 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100836 */   GIR_RootConstrainSelectedInstOperands,
     /* 100837 */   // GIR_Coverage, 1603,
     /* 100837 */   GIR_EraseRootFromParent_Done,
     /* 100838 */ // Label 1851: @100838
     /* 100838 */ GIM_Reject,
     /* 100839 */ // Label 1848: @100839
     /* 100839 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(100876), // Rule ID 1602 //
     /* 100844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100858 */   // (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /* 100861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100863 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100868 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100874 */   GIR_RootConstrainSelectedInstOperands,
     /* 100875 */   // GIR_Coverage, 1602,
     /* 100875 */   GIR_EraseRootFromParent_Done,
     /* 100876 */ // Label 1852: @100876
     /* 100876 */ GIM_Reject,
     /* 100877 */ // Label 1849: @100877
     /* 100877 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(100914), // Rule ID 1601 //
     /* 100882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100896 */   // (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /* 100899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100901 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100906 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100912 */   GIR_RootConstrainSelectedInstOperands,
     /* 100913 */   // GIR_Coverage, 1601,
     /* 100913 */   GIR_EraseRootFromParent_Done,
     /* 100914 */ // Label 1853: @100914
     /* 100914 */ GIM_Reject,
     /* 100915 */ // Label 1850: @100915
     /* 100915 */ GIM_Reject,
     /* 100916 */ // Label 24: @100916
     /* 100916 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(101131),
     /* 100921 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100930 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(100987), // Rule ID 470 //
     /* 100935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 100958 */     // MIs[1] Operand 1
     /* 100958 */     // No operand predicates
     /* 100958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100960 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2LSLri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 100960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLri),
     /* 100963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 100970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100985 */     GIR_RootConstrainSelectedInstOperands,
     /* 100986 */     // GIR_Coverage, 470,
     /* 100986 */     GIR_EraseRootFromParent_Done,
     /* 100987 */   // Label 1855: @100987
     /* 100987 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(101084),
     /* 100992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101000 */     GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(101045), // Rule ID 318 //
     /* 101005 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101008 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101012 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101016 */       // MIs[1] Operand 1
     /* 101016 */       // No operand predicates
     /* 101016 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101018 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)  =>  (tLSLri:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)
     /* 101018 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLri),
     /* 101021 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101023 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101029 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101031 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm5
     /* 101034 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101037 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101043 */       GIR_RootConstrainSelectedInstOperands,
     /* 101044 */       // GIR_Coverage, 318,
     /* 101044 */       GIR_EraseRootFromParent_Done,
     /* 101045 */     // Label 1857: @101045
     /* 101045 */     GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(101083), // Rule ID 319 //
     /* 101050 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101053 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101057 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSLrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101057 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLrr),
     /* 101060 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101062 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101068 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101070 */       GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101072 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101075 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101081 */       GIR_RootConstrainSelectedInstOperands,
     /* 101082 */       // GIR_Coverage, 319,
     /* 101082 */       GIR_EraseRootFromParent_Done,
     /* 101083 */     // Label 1858: @101083
     /* 101083 */     GIM_Reject,
     /* 101084 */   // Label 1856: @101084
     /* 101084 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(101130), // Rule ID 471 //
     /* 101089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101104 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSLrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLrr),
     /* 101107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101128 */     GIR_RootConstrainSelectedInstOperands,
     /* 101129 */     // GIR_Coverage, 471,
     /* 101129 */     GIR_EraseRootFromParent_Done,
     /* 101130 */   // Label 1859: @101130
     /* 101130 */   GIM_Reject,
     /* 101131 */ // Label 1854: @101131
     /* 101131 */ GIM_Reject,
     /* 101132 */ // Label 25: @101132
     /* 101132 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(101239),
     /* 101137 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101146 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(101192), // Rule ID 321 //
     /* 101151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101166 */     // (srl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSRrr),
     /* 101169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101190 */     GIR_RootConstrainSelectedInstOperands,
     /* 101191 */     // GIR_Coverage, 321,
     /* 101191 */     GIR_EraseRootFromParent_Done,
     /* 101192 */   // Label 1861: @101192
     /* 101192 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(101238), // Rule ID 473 //
     /* 101197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101212 */     // (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSRrr),
     /* 101215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101236 */     GIR_RootConstrainSelectedInstOperands,
     /* 101237 */     // GIR_Coverage, 473,
     /* 101237 */     GIR_EraseRootFromParent_Done,
     /* 101238 */   // Label 1862: @101238
     /* 101238 */   GIM_Reject,
     /* 101239 */ // Label 1860: @101239
     /* 101239 */ GIM_Reject,
     /* 101240 */ // Label 26: @101240
     /* 101240 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(101512),
     /* 101245 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101254 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(101309), // Rule ID 201 //
     /* 101259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101289 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /* 101292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101307 */     GIR_RootConstrainSelectedInstOperands,
     /* 101308 */     // GIR_Coverage, 201,
     /* 101308 */     GIR_EraseRootFromParent_Done,
     /* 101309 */   // Label 1864: @101309
     /* 101309 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(101364), // Rule ID 328 //
     /* 101314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101344 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREVSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREVSH),
     /* 101347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101362 */     GIR_RootConstrainSelectedInstOperands,
     /* 101363 */     // GIR_Coverage, 328,
     /* 101363 */     GIR_EraseRootFromParent_Done,
     /* 101364 */   // Label 1865: @101364
     /* 101364 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(101419), // Rule ID 538 //
     /* 101369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101399 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /* 101402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101417 */     GIR_RootConstrainSelectedInstOperands,
     /* 101418 */     // GIR_Coverage, 538,
     /* 101418 */     GIR_EraseRootFromParent_Done,
     /* 101419 */   // Label 1866: @101419
     /* 101419 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(101465), // Rule ID 312 //
     /* 101424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101439 */     // (sra:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tASRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tASRrr),
     /* 101442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101463 */     GIR_RootConstrainSelectedInstOperands,
     /* 101464 */     // GIR_Coverage, 312,
     /* 101464 */     GIR_EraseRootFromParent_Done,
     /* 101465 */   // Label 1867: @101465
     /* 101465 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(101511), // Rule ID 475 //
     /* 101470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101485 */     // (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ASRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ASRrr),
     /* 101488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101497 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101509 */     GIR_RootConstrainSelectedInstOperands,
     /* 101510 */     // GIR_Coverage, 475,
     /* 101510 */     GIR_EraseRootFromParent_Done,
     /* 101511 */   // Label 1868: @101511
     /* 101511 */   GIM_Reject,
     /* 101512 */ // Label 1863: @101512
     /* 101512 */ GIM_Reject,
     /* 101513 */ // Label 27: @101513
     /* 101513 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(101844),
     /* 101518 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101527 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(101582), // Rule ID 200 //
     /* 101532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101562 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REV16:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV16),
     /* 101565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101580 */     GIR_RootConstrainSelectedInstOperands,
     /* 101581 */     // GIR_Coverage, 200,
     /* 101581 */     GIR_EraseRootFromParent_Done,
     /* 101582 */   // Label 1870: @101582
     /* 101582 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(101637), // Rule ID 327 //
     /* 101587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101617 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREV16:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV16),
     /* 101620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101635 */     GIR_RootConstrainSelectedInstOperands,
     /* 101636 */     // GIR_Coverage, 327,
     /* 101636 */     GIR_EraseRootFromParent_Done,
     /* 101637 */   // Label 1871: @101637
     /* 101637 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(101751),
     /* 101642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101646 */     GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101697), // Rule ID 537 //
     /* 101651 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101654 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101658 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101662 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101666 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101671 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101675 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101677 */       // (rotr:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REV16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101677 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV16),
     /* 101680 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101682 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101686 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101689 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101695 */       GIR_RootConstrainSelectedInstOperands,
     /* 101696 */       // GIR_Coverage, 537,
     /* 101696 */       GIR_EraseRootFromParent_Done,
     /* 101697 */     // Label 1873: @101697
     /* 101697 */     GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101750), // Rule ID 476 //
     /* 101702 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101705 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101709 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101713 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101717 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 101721 */       // MIs[1] Operand 1
     /* 101721 */       // No operand predicates
     /* 101721 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101723 */       // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2RORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 101723 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORri),
     /* 101726 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101728 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101730 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 101733 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101736 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101742 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101748 */       GIR_RootConstrainSelectedInstOperands,
     /* 101749 */       // GIR_Coverage, 476,
     /* 101749 */       GIR_EraseRootFromParent_Done,
     /* 101750 */     // Label 1874: @101750
     /* 101750 */     GIM_Reject,
     /* 101751 */   // Label 1872: @101751
     /* 101751 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101797), // Rule ID 329 //
     /* 101756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101771 */     // (rotr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tROR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tROR),
     /* 101774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101795 */     GIR_RootConstrainSelectedInstOperands,
     /* 101796 */     // GIR_Coverage, 329,
     /* 101796 */     GIR_EraseRootFromParent_Done,
     /* 101797 */   // Label 1875: @101797
     /* 101797 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(101843), // Rule ID 477 //
     /* 101802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101817 */     // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2RORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORrr),
     /* 101820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101841 */     GIR_RootConstrainSelectedInstOperands,
     /* 101842 */     // GIR_Coverage, 477,
     /* 101842 */     GIR_EraseRootFromParent_Done,
     /* 101843 */   // Label 1876: @101843
     /* 101843 */   GIM_Reject,
     /* 101844 */ // Label 1869: @101844
     /* 101844 */ GIM_Reject,
     /* 101845 */ // Label 28: @101845
     /* 101845 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 1880*/ GIMT_Encode4(102092),
     /* 101856 */ /*GILLT_v4s32*//*Label 1877*/ GIMT_Encode4(101888), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101872 */ /*GILLT_v8s16*//*Label 1878*/ GIMT_Encode4(101956), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101884 */ /*GILLT_v16s8*//*Label 1879*/ GIMT_Encode4(102024),
     /* 101888 */ // Label 1877: @101888
     /* 101888 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(101955), // Rule ID 4464 //
     /* 101893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101914 */   // (mulhu:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /* 101929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101931 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101933 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101938 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101944 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101950 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101953 */   GIR_RootConstrainSelectedInstOperands,
     /* 101954 */   // GIR_Coverage, 4464,
     /* 101954 */   GIR_EraseRootFromParent_Done,
     /* 101955 */ // Label 1881: @101955
     /* 101955 */ GIM_Reject,
     /* 101956 */ // Label 1878: @101956
     /* 101956 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(102023), // Rule ID 4460 //
     /* 101961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101982 */   // (mulhu:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /* 101997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101999 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102001 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102012 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102021 */   GIR_RootConstrainSelectedInstOperands,
     /* 102022 */   // GIR_Coverage, 4460,
     /* 102022 */   GIR_EraseRootFromParent_Done,
     /* 102023 */ // Label 1882: @102023
     /* 102023 */ GIM_Reject,
     /* 102024 */ // Label 1879: @102024
     /* 102024 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(102091), // Rule ID 4456 //
     /* 102029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102050 */   // (mulhu:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102050 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102053 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102057 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /* 102065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102067 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102069 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102074 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102080 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102089 */   GIR_RootConstrainSelectedInstOperands,
     /* 102090 */   // GIR_Coverage, 4456,
     /* 102090 */   GIR_EraseRootFromParent_Done,
     /* 102091 */ // Label 1883: @102091
     /* 102091 */ GIM_Reject,
     /* 102092 */ // Label 1880: @102092
     /* 102092 */ GIM_Reject,
     /* 102093 */ // Label 29: @102093
     /* 102093 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1888*/ GIMT_Encode4(102461),
     /* 102104 */ /*GILLT_s32*//*Label 1884*/ GIMT_Encode4(102164), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102132 */ /*GILLT_v4s32*//*Label 1885*/ GIMT_Encode4(102257), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102148 */ /*GILLT_v8s16*//*Label 1886*/ GIMT_Encode4(102325), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102160 */ /*GILLT_v16s8*//*Label 1887*/ GIMT_Encode4(102393),
     /* 102164 */ // Label 1884: @102164
     /* 102164 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(102256),
     /* 102169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 102175 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(102215), // Rule ID 178 //
     /* 102180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 102183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102195 */     // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SMMUL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /* 102195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMUL),
     /* 102198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102213 */     GIR_RootConstrainSelectedInstOperands,
     /* 102214 */     // GIR_Coverage, 178,
     /* 102214 */     GIR_EraseRootFromParent_Done,
     /* 102215 */   // Label 1890: @102215
     /* 102215 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(102255), // Rule ID 507 //
     /* 102220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102235 */     // (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMMUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 102235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMUL),
     /* 102238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102253 */     GIR_RootConstrainSelectedInstOperands,
     /* 102254 */     // GIR_Coverage, 507,
     /* 102254 */     GIR_EraseRootFromParent_Done,
     /* 102255 */   // Label 1891: @102255
     /* 102255 */   GIM_Reject,
     /* 102256 */ // Label 1889: @102256
     /* 102256 */ GIM_Reject,
     /* 102257 */ // Label 1885: @102257
     /* 102257 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(102324), // Rule ID 4452 //
     /* 102262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102283 */   // (mulhs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102283 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102286 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102290 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /* 102298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102300 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102302 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102307 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102313 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102322 */   GIR_RootConstrainSelectedInstOperands,
     /* 102323 */   // GIR_Coverage, 4452,
     /* 102323 */   GIR_EraseRootFromParent_Done,
     /* 102324 */ // Label 1892: @102324
     /* 102324 */ GIM_Reject,
     /* 102325 */ // Label 1886: @102325
     /* 102325 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(102392), // Rule ID 4448 //
     /* 102330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102351 */   // (mulhs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /* 102366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102368 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102370 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102375 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102381 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102390 */   GIR_RootConstrainSelectedInstOperands,
     /* 102391 */   // GIR_Coverage, 4448,
     /* 102391 */   GIR_EraseRootFromParent_Done,
     /* 102392 */ // Label 1893: @102392
     /* 102392 */ GIM_Reject,
     /* 102393 */ // Label 1887: @102393
     /* 102393 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(102460), // Rule ID 4445 //
     /* 102398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102419 */   // (mulhs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /* 102434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102436 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102438 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102443 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102449 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102458 */   GIR_RootConstrainSelectedInstOperands,
     /* 102459 */   // GIR_Coverage, 4445,
     /* 102459 */   GIR_EraseRootFromParent_Done,
     /* 102460 */ // Label 1894: @102460
     /* 102460 */ GIM_Reject,
     /* 102461 */ // Label 1888: @102461
     /* 102461 */ GIM_Reject,
     /* 102462 */ // Label 30: @102462
     /* 102462 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1903*/ GIMT_Encode4(103106),
     /* 102473 */ /*GILLT_s64*//*Label 1895*/ GIMT_Encode4(102529), GIMT_Encode4(0),
     /* 102481 */ /*GILLT_v2s32*//*Label 1896*/ GIMT_Encode4(102576),
     /* 102485 */ /*GILLT_v2s64*//*Label 1897*/ GIMT_Encode4(102623), GIMT_Encode4(0),
     /* 102493 */ /*GILLT_v4s16*//*Label 1898*/ GIMT_Encode4(102670),
     /* 102497 */ /*GILLT_v4s32*//*Label 1899*/ GIMT_Encode4(102717), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102509 */ /*GILLT_v8s8*//*Label 1900*/ GIMT_Encode4(102831),
     /* 102513 */ /*GILLT_v8s16*//*Label 1901*/ GIMT_Encode4(102878), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102525 */ /*GILLT_v16s8*//*Label 1902*/ GIMT_Encode4(102992),
     /* 102529 */ // Label 1895: @102529
     /* 102529 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102575), // Rule ID 830 //
     /* 102534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 102543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102555 */   // (uaddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 102555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv1i64),
     /* 102558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102560 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102562 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102567 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102573 */   GIR_RootConstrainSelectedInstOperands,
     /* 102574 */   // GIR_Coverage, 830,
     /* 102574 */   GIR_EraseRootFromParent_Done,
     /* 102575 */ // Label 1904: @102575
     /* 102575 */ GIM_Reject,
     /* 102576 */ // Label 1896: @102576
     /* 102576 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102622), // Rule ID 825 //
     /* 102581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 102587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 102590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102602 */   // (uaddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i32),
     /* 102605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102607 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102609 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102620 */   GIR_RootConstrainSelectedInstOperands,
     /* 102621 */   // GIR_Coverage, 825,
     /* 102621 */   GIR_EraseRootFromParent_Done,
     /* 102622 */ // Label 1905: @102622
     /* 102622 */ GIM_Reject,
     /* 102623 */ // Label 1897: @102623
     /* 102623 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102669), // Rule ID 831 //
     /* 102628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 102634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 102637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102649 */   // (uaddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 102649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i64),
     /* 102652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102654 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102656 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102661 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102667 */   GIR_RootConstrainSelectedInstOperands,
     /* 102668 */   // GIR_Coverage, 831,
     /* 102668 */   GIR_EraseRootFromParent_Done,
     /* 102669 */ // Label 1906: @102669
     /* 102669 */ GIM_Reject,
     /* 102670 */ // Label 1898: @102670
     /* 102670 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102716), // Rule ID 824 //
     /* 102675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102696 */   // (uaddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 102696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i16),
     /* 102699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102701 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102703 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102714 */   GIR_RootConstrainSelectedInstOperands,
     /* 102715 */   // GIR_Coverage, 824,
     /* 102715 */   GIR_EraseRootFromParent_Done,
     /* 102716 */ // Label 1907: @102716
     /* 102716 */ GIM_Reject,
     /* 102717 */ // Label 1899: @102717
     /* 102717 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102830),
     /* 102722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102728 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102768), // Rule ID 827 //
     /* 102733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102748 */     // (uaddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 102748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i32),
     /* 102751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102766 */     GIR_RootConstrainSelectedInstOperands,
     /* 102767 */     // GIR_Coverage, 827,
     /* 102767 */     GIR_EraseRootFromParent_Done,
     /* 102768 */   // Label 1909: @102768
     /* 102768 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102829), // Rule ID 3527 //
     /* 102773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102788 */     // (uaddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu32),
     /* 102803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102827 */     GIR_RootConstrainSelectedInstOperands,
     /* 102828 */     // GIR_Coverage, 3527,
     /* 102828 */     GIR_EraseRootFromParent_Done,
     /* 102829 */   // Label 1910: @102829
     /* 102829 */   GIM_Reject,
     /* 102830 */ // Label 1908: @102830
     /* 102830 */ GIM_Reject,
     /* 102831 */ // Label 1900: @102831
     /* 102831 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102877), // Rule ID 828 //
     /* 102836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102857 */   // (uaddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 102857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i8),
     /* 102860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102862 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102864 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102869 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102875 */   GIR_RootConstrainSelectedInstOperands,
     /* 102876 */   // GIR_Coverage, 828,
     /* 102876 */   GIR_EraseRootFromParent_Done,
     /* 102877 */ // Label 1911: @102877
     /* 102877 */ GIM_Reject,
     /* 102878 */ // Label 1901: @102878
     /* 102878 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102991),
     /* 102883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102889 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102929), // Rule ID 826 //
     /* 102894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102909 */     // (uaddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 102909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i16),
     /* 102912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102914 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102927 */     GIR_RootConstrainSelectedInstOperands,
     /* 102928 */     // GIR_Coverage, 826,
     /* 102928 */     GIR_EraseRootFromParent_Done,
     /* 102929 */   // Label 1913: @102929
     /* 102929 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(102990), // Rule ID 3524 //
     /* 102934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102949 */     // (uaddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu16),
     /* 102964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102988 */     GIR_RootConstrainSelectedInstOperands,
     /* 102989 */     // GIR_Coverage, 3524,
     /* 102989 */     GIR_EraseRootFromParent_Done,
     /* 102990 */   // Label 1914: @102990
     /* 102990 */   GIM_Reject,
     /* 102991 */ // Label 1912: @102991
     /* 102991 */ GIM_Reject,
     /* 102992 */ // Label 1902: @102992
     /* 102992 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(103105),
     /* 102997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 103000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 103003 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(103043), // Rule ID 829 //
     /* 103008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103023 */     // (uaddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 103023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv16i8),
     /* 103026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103041 */     GIR_RootConstrainSelectedInstOperands,
     /* 103042 */     // GIR_Coverage, 829,
     /* 103042 */     GIR_EraseRootFromParent_Done,
     /* 103043 */   // Label 1916: @103043
     /* 103043 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(103104), // Rule ID 3521 //
     /* 103048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103063 */     // (uaddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 103063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu8),
     /* 103078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103102 */     GIR_RootConstrainSelectedInstOperands,
     /* 103103 */     // GIR_Coverage, 3521,
     /* 103103 */     GIR_EraseRootFromParent_Done,
     /* 103104 */   // Label 1917: @103104
     /* 103104 */   GIM_Reject,
     /* 103105 */ // Label 1915: @103105
     /* 103105 */ GIM_Reject,
     /* 103106 */ // Label 1903: @103106
     /* 103106 */ GIM_Reject,
     /* 103107 */ // Label 31: @103107
     /* 103107 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1927*/ GIMT_Encode4(104406),
     /* 103118 */ /*GILLT_s32*//*Label 1918*/ GIMT_Encode4(103178),
     /* 103122 */ /*GILLT_s64*//*Label 1919*/ GIMT_Encode4(103519), GIMT_Encode4(0),
     /* 103130 */ /*GILLT_v2s32*//*Label 1920*/ GIMT_Encode4(103566),
     /* 103134 */ /*GILLT_v2s64*//*Label 1921*/ GIMT_Encode4(103613), GIMT_Encode4(0),
     /* 103142 */ /*GILLT_v4s16*//*Label 1922*/ GIMT_Encode4(103814),
     /* 103146 */ /*GILLT_v4s32*//*Label 1923*/ GIMT_Encode4(103861), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103158 */ /*GILLT_v8s8*//*Label 1924*/ GIMT_Encode4(104131),
     /* 103162 */ /*GILLT_v8s16*//*Label 1925*/ GIMT_Encode4(104178), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103174 */ /*GILLT_v16s8*//*Label 1926*/ GIMT_Encode4(104292),
     /* 103178 */ // Label 1918: @103178
     /* 103178 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(103518),
     /* 103183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 103186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 103189 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(103251), // Rule ID 5654 //
     /* 103194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103218 */     // MIs[1] Rn
     /* 103218 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103229 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103249 */     GIR_RootConstrainSelectedInstOperands,
     /* 103250 */     // GIR_Coverage, 5654,
     /* 103250 */     GIR_EraseRootFromParent_Done,
     /* 103251 */   // Label 1929: @103251
     /* 103251 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103313), // Rule ID 5688 //
     /* 103256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103280 */     // MIs[1] Rn
     /* 103280 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103291 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103311 */     GIR_RootConstrainSelectedInstOperands,
     /* 103312 */     // GIR_Coverage, 5688,
     /* 103312 */     GIR_EraseRootFromParent_Done,
     /* 103313 */   // Label 1930: @103313
     /* 103313 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103375), // Rule ID 1870 //
     /* 103318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103346 */     // MIs[1] Rn
     /* 103346 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103353 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103373 */     GIR_RootConstrainSelectedInstOperands,
     /* 103374 */     // GIR_Coverage, 1870,
     /* 103374 */     GIR_EraseRootFromParent_Done,
     /* 103375 */   // Label 1931: @103375
     /* 103375 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103437), // Rule ID 2136 //
     /* 103380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103408 */     // MIs[1] Rn
     /* 103408 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103415 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103435 */     GIR_RootConstrainSelectedInstOperands,
     /* 103436 */     // GIR_Coverage, 2136,
     /* 103436 */     GIR_EraseRootFromParent_Done,
     /* 103437 */   // Label 1932: @103437
     /* 103437 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(103477), // Rule ID 1868 //
     /* 103442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103457 */     // (saddsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QADD:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 103457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /* 103460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103462 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 103464 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 103466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103475 */     GIR_RootConstrainSelectedInstOperands,
     /* 103476 */     // GIR_Coverage, 1868,
     /* 103476 */     GIR_EraseRootFromParent_Done,
     /* 103477 */   // Label 1933: @103477
     /* 103477 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(103517), // Rule ID 2134 //
     /* 103482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103497 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /* 103500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 103506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103515 */     GIR_RootConstrainSelectedInstOperands,
     /* 103516 */     // GIR_Coverage, 2134,
     /* 103516 */     GIR_EraseRootFromParent_Done,
     /* 103517 */   // Label 1934: @103517
     /* 103517 */   GIM_Reject,
     /* 103518 */ // Label 1928: @103518
     /* 103518 */ GIM_Reject,
     /* 103519 */ // Label 1919: @103519
     /* 103519 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103565), // Rule ID 822 //
     /* 103524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 103533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103545 */   // (saddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 103545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv1i64),
     /* 103548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103550 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103552 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103557 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103563 */   GIR_RootConstrainSelectedInstOperands,
     /* 103564 */   // GIR_Coverage, 822,
     /* 103564 */   GIR_EraseRootFromParent_Done,
     /* 103565 */ // Label 1935: @103565
     /* 103565 */ GIM_Reject,
     /* 103566 */ // Label 1920: @103566
     /* 103566 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103612), // Rule ID 817 //
     /* 103571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 103577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103592 */   // (saddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i32),
     /* 103595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103597 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103599 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103604 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103610 */   GIR_RootConstrainSelectedInstOperands,
     /* 103611 */   // GIR_Coverage, 817,
     /* 103611 */   GIR_EraseRootFromParent_Done,
     /* 103612 */ // Label 1936: @103612
     /* 103612 */ GIM_Reject,
     /* 103613 */ // Label 1921: @103613
     /* 103613 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103813),
     /* 103618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103628 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(103702), // Rule ID 5745 //
     /* 103633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103644 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103647 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103656 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103676 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 3786:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$src1)  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103681 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103700 */     GIR_RootConstrainSelectedInstOperands,
     /* 103701 */     // GIR_Coverage, 5745,
     /* 103701 */     GIR_EraseRootFromParent_Done,
     /* 103702 */   // Label 1938: @103702
     /* 103702 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(103776), // Rule ID 2489 //
     /* 103707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103722 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103725 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103734 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103750 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3786:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103755 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103774 */     GIR_RootConstrainSelectedInstOperands,
     /* 103775 */     // GIR_Coverage, 2489,
     /* 103775 */     GIR_EraseRootFromParent_Done,
     /* 103776 */   // Label 1939: @103776
     /* 103776 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(103812), // Rule ID 823 //
     /* 103781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103792 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i64),
     /* 103795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103810 */     GIR_RootConstrainSelectedInstOperands,
     /* 103811 */     // GIR_Coverage, 823,
     /* 103811 */     GIR_EraseRootFromParent_Done,
     /* 103812 */   // Label 1940: @103812
     /* 103812 */   GIM_Reject,
     /* 103813 */ // Label 1937: @103813
     /* 103813 */ GIM_Reject,
     /* 103814 */ // Label 1922: @103814
     /* 103814 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(103860), // Rule ID 816 //
     /* 103819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 103825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103840 */   // (saddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i16),
     /* 103843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103845 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103847 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103852 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103858 */   GIR_RootConstrainSelectedInstOperands,
     /* 103859 */   // GIR_Coverage, 816,
     /* 103859 */   GIR_EraseRootFromParent_Done,
     /* 103860 */ // Label 1941: @103860
     /* 103860 */ GIM_Reject,
     /* 103861 */ // Label 1923: @103861
     /* 103861 */ GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(104130),
     /* 103866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103872 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(103950), // Rule ID 5744 //
     /* 103877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103892 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103895 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103904 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103924 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 3786:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103929 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103948 */     GIR_RootConstrainSelectedInstOperands,
     /* 103949 */     // GIR_Coverage, 5744,
     /* 103949 */     GIR_EraseRootFromParent_Done,
     /* 103950 */   // Label 1943: @103950
     /* 103950 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(104028), // Rule ID 2488 //
     /* 103955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103974 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103977 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103986 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104002 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3786:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 104005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 104009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 104013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 104017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104026 */     GIR_RootConstrainSelectedInstOperands,
     /* 104027 */     // GIR_Coverage, 2488,
     /* 104027 */     GIR_EraseRootFromParent_Done,
     /* 104028 */   // Label 1944: @104028
     /* 104028 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(104068), // Rule ID 819 //
     /* 104033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104048 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i32),
     /* 104051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104066 */     GIR_RootConstrainSelectedInstOperands,
     /* 104067 */     // GIR_Coverage, 819,
     /* 104067 */     GIR_EraseRootFromParent_Done,
     /* 104068 */   // Label 1945: @104068
     /* 104068 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(104129), // Rule ID 3518 //
     /* 104073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104088 */     // (saddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs32),
     /* 104103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104127 */     GIR_RootConstrainSelectedInstOperands,
     /* 104128 */     // GIR_Coverage, 3518,
     /* 104128 */     GIR_EraseRootFromParent_Done,
     /* 104129 */   // Label 1946: @104129
     /* 104129 */   GIM_Reject,
     /* 104130 */ // Label 1942: @104130
     /* 104130 */ GIM_Reject,
     /* 104131 */ // Label 1924: @104131
     /* 104131 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(104177), // Rule ID 820 //
     /* 104136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104157 */   // (saddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i8),
     /* 104160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104162 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104164 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104169 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104175 */   GIR_RootConstrainSelectedInstOperands,
     /* 104176 */   // GIR_Coverage, 820,
     /* 104176 */   GIR_EraseRootFromParent_Done,
     /* 104177 */ // Label 1947: @104177
     /* 104177 */ GIM_Reject,
     /* 104178 */ // Label 1925: @104178
     /* 104178 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(104291),
     /* 104183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104189 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(104229), // Rule ID 818 //
     /* 104194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104209 */     // (saddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i16),
     /* 104212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104227 */     GIR_RootConstrainSelectedInstOperands,
     /* 104228 */     // GIR_Coverage, 818,
     /* 104228 */     GIR_EraseRootFromParent_Done,
     /* 104229 */   // Label 1949: @104229
     /* 104229 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(104290), // Rule ID 3515 //
     /* 104234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104249 */     // (saddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs16),
     /* 104264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104288 */     GIR_RootConstrainSelectedInstOperands,
     /* 104289 */     // GIR_Coverage, 3515,
     /* 104289 */     GIR_EraseRootFromParent_Done,
     /* 104290 */   // Label 1950: @104290
     /* 104290 */   GIM_Reject,
     /* 104291 */ // Label 1948: @104291
     /* 104291 */ GIM_Reject,
     /* 104292 */ // Label 1926: @104292
     /* 104292 */ GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(104405),
     /* 104297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104303 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(104343), // Rule ID 821 //
     /* 104308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104323 */     // (saddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv16i8),
     /* 104326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104341 */     GIR_RootConstrainSelectedInstOperands,
     /* 104342 */     // GIR_Coverage, 821,
     /* 104342 */     GIR_EraseRootFromParent_Done,
     /* 104343 */   // Label 1952: @104343
     /* 104343 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(104404), // Rule ID 3512 //
     /* 104348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104363 */     // (saddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs8),
     /* 104378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104402 */     GIR_RootConstrainSelectedInstOperands,
     /* 104403 */     // GIR_Coverage, 3512,
     /* 104403 */     GIR_EraseRootFromParent_Done,
     /* 104404 */   // Label 1953: @104404
     /* 104404 */   GIM_Reject,
     /* 104405 */ // Label 1951: @104405
     /* 104405 */ GIM_Reject,
     /* 104406 */ // Label 1927: @104406
     /* 104406 */ GIM_Reject,
     /* 104407 */ // Label 32: @104407
     /* 104407 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1962*/ GIMT_Encode4(105051),
     /* 104418 */ /*GILLT_s64*//*Label 1954*/ GIMT_Encode4(104474), GIMT_Encode4(0),
     /* 104426 */ /*GILLT_v2s32*//*Label 1955*/ GIMT_Encode4(104521),
     /* 104430 */ /*GILLT_v2s64*//*Label 1956*/ GIMT_Encode4(104568), GIMT_Encode4(0),
     /* 104438 */ /*GILLT_v4s16*//*Label 1957*/ GIMT_Encode4(104615),
     /* 104442 */ /*GILLT_v4s32*//*Label 1958*/ GIMT_Encode4(104662), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104454 */ /*GILLT_v8s8*//*Label 1959*/ GIMT_Encode4(104776),
     /* 104458 */ /*GILLT_v8s16*//*Label 1960*/ GIMT_Encode4(104823), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104470 */ /*GILLT_v16s8*//*Label 1961*/ GIMT_Encode4(104937),
     /* 104474 */ // Label 1954: @104474
     /* 104474 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(104520), // Rule ID 1022 //
     /* 104479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104500 */   // (usubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 104500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv1i64),
     /* 104503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104505 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104507 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104512 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104518 */   GIR_RootConstrainSelectedInstOperands,
     /* 104519 */   // GIR_Coverage, 1022,
     /* 104519 */   GIR_EraseRootFromParent_Done,
     /* 104520 */ // Label 1963: @104520
     /* 104520 */ GIM_Reject,
     /* 104521 */ // Label 1955: @104521
     /* 104521 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(104567), // Rule ID 1017 //
     /* 104526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 104532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104547 */   // (usubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i32),
     /* 104550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104552 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104554 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104559 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104565 */   GIR_RootConstrainSelectedInstOperands,
     /* 104566 */   // GIR_Coverage, 1017,
     /* 104566 */   GIR_EraseRootFromParent_Done,
     /* 104567 */ // Label 1964: @104567
     /* 104567 */ GIM_Reject,
     /* 104568 */ // Label 1956: @104568
     /* 104568 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104614), // Rule ID 1023 //
     /* 104573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 104579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 104582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104594 */   // (usubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 104594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i64),
     /* 104597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104599 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104601 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104612 */   GIR_RootConstrainSelectedInstOperands,
     /* 104613 */   // GIR_Coverage, 1023,
     /* 104613 */   GIR_EraseRootFromParent_Done,
     /* 104614 */ // Label 1965: @104614
     /* 104614 */ GIM_Reject,
     /* 104615 */ // Label 1957: @104615
     /* 104615 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(104661), // Rule ID 1016 //
     /* 104620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104641 */   // (usubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i16),
     /* 104644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104646 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104648 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104653 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104659 */   GIR_RootConstrainSelectedInstOperands,
     /* 104660 */   // GIR_Coverage, 1016,
     /* 104660 */   GIR_EraseRootFromParent_Done,
     /* 104661 */ // Label 1966: @104661
     /* 104661 */ GIM_Reject,
     /* 104662 */ // Label 1958: @104662
     /* 104662 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104775),
     /* 104667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 104670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 104673 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104713), // Rule ID 1019 //
     /* 104678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104693 */     // (usubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i32),
     /* 104696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104705 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104711 */     GIR_RootConstrainSelectedInstOperands,
     /* 104712 */     // GIR_Coverage, 1019,
     /* 104712 */     GIR_EraseRootFromParent_Done,
     /* 104713 */   // Label 1968: @104713
     /* 104713 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(104774), // Rule ID 3545 //
     /* 104718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104733 */     // (usubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu32),
     /* 104748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104772 */     GIR_RootConstrainSelectedInstOperands,
     /* 104773 */     // GIR_Coverage, 3545,
     /* 104773 */     GIR_EraseRootFromParent_Done,
     /* 104774 */   // Label 1969: @104774
     /* 104774 */   GIM_Reject,
     /* 104775 */ // Label 1967: @104775
     /* 104775 */ GIM_Reject,
     /* 104776 */ // Label 1959: @104776
     /* 104776 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(104822), // Rule ID 1020 //
     /* 104781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104802 */   // (usubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i8),
     /* 104805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104807 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104809 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104814 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104820 */   GIR_RootConstrainSelectedInstOperands,
     /* 104821 */   // GIR_Coverage, 1020,
     /* 104821 */   GIR_EraseRootFromParent_Done,
     /* 104822 */ // Label 1970: @104822
     /* 104822 */ GIM_Reject,
     /* 104823 */ // Label 1960: @104823
     /* 104823 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(104936),
     /* 104828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104834 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(104874), // Rule ID 1018 //
     /* 104839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104854 */     // (usubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i16),
     /* 104857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104872 */     GIR_RootConstrainSelectedInstOperands,
     /* 104873 */     // GIR_Coverage, 1018,
     /* 104873 */     GIR_EraseRootFromParent_Done,
     /* 104874 */   // Label 1972: @104874
     /* 104874 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(104935), // Rule ID 3542 //
     /* 104879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104894 */     // (usubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu16),
     /* 104909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104933 */     GIR_RootConstrainSelectedInstOperands,
     /* 104934 */     // GIR_Coverage, 3542,
     /* 104934 */     GIR_EraseRootFromParent_Done,
     /* 104935 */   // Label 1973: @104935
     /* 104935 */   GIM_Reject,
     /* 104936 */ // Label 1971: @104936
     /* 104936 */ GIM_Reject,
     /* 104937 */ // Label 1961: @104937
     /* 104937 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(105050),
     /* 104942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104948 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(104988), // Rule ID 1021 //
     /* 104953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104968 */     // (usubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv16i8),
     /* 104971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104986 */     GIR_RootConstrainSelectedInstOperands,
     /* 104987 */     // GIR_Coverage, 1021,
     /* 104987 */     GIR_EraseRootFromParent_Done,
     /* 104988 */   // Label 1975: @104988
     /* 104988 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(105049), // Rule ID 3539 //
     /* 104993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105008 */     // (usubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 105008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu8),
     /* 105023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105047 */     GIR_RootConstrainSelectedInstOperands,
     /* 105048 */     // GIR_Coverage, 3539,
     /* 105048 */     GIR_EraseRootFromParent_Done,
     /* 105049 */   // Label 1976: @105049
     /* 105049 */   GIM_Reject,
     /* 105050 */ // Label 1974: @105050
     /* 105050 */ GIM_Reject,
     /* 105051 */ // Label 1962: @105051
     /* 105051 */ GIM_Reject,
     /* 105052 */ // Label 33: @105052
     /* 105052 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1986*/ GIMT_Encode4(106071),
     /* 105063 */ /*GILLT_s32*//*Label 1977*/ GIMT_Encode4(105123),
     /* 105067 */ /*GILLT_s64*//*Label 1978*/ GIMT_Encode4(105340), GIMT_Encode4(0),
     /* 105075 */ /*GILLT_v2s32*//*Label 1979*/ GIMT_Encode4(105387),
     /* 105079 */ /*GILLT_v2s64*//*Label 1980*/ GIMT_Encode4(105434), GIMT_Encode4(0),
     /* 105087 */ /*GILLT_v4s16*//*Label 1981*/ GIMT_Encode4(105557),
     /* 105091 */ /*GILLT_v4s32*//*Label 1982*/ GIMT_Encode4(105604), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105103 */ /*GILLT_v8s8*//*Label 1983*/ GIMT_Encode4(105796),
     /* 105107 */ /*GILLT_v8s16*//*Label 1984*/ GIMT_Encode4(105843), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105119 */ /*GILLT_v16s8*//*Label 1985*/ GIMT_Encode4(105957),
     /* 105123 */ // Label 1977: @105123
     /* 105123 */ GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(105339),
     /* 105128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105134 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(105196), // Rule ID 1871 //
     /* 105139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105167 */     // MIs[1] Rn
     /* 105167 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105174 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /* 105177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105194 */     GIR_RootConstrainSelectedInstOperands,
     /* 105195 */     // GIR_Coverage, 1871,
     /* 105195 */     GIR_EraseRootFromParent_Done,
     /* 105196 */   // Label 1988: @105196
     /* 105196 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(105258), // Rule ID 2137 //
     /* 105201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105229 */     // MIs[1] Rn
     /* 105229 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105236 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /* 105239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105256 */     GIR_RootConstrainSelectedInstOperands,
     /* 105257 */     // GIR_Coverage, 2137,
     /* 105257 */     GIR_EraseRootFromParent_Done,
     /* 105258 */   // Label 1989: @105258
     /* 105258 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(105298), // Rule ID 1869 //
     /* 105263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105278 */     // (ssubsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QSUB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 105278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /* 105281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105283 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 105285 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 105287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105296 */     GIR_RootConstrainSelectedInstOperands,
     /* 105297 */     // GIR_Coverage, 1869,
     /* 105297 */     GIR_EraseRootFromParent_Done,
     /* 105298 */   // Label 1990: @105298
     /* 105298 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(105338), // Rule ID 2135 //
     /* 105303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105318 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /* 105321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 105327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105336 */     GIR_RootConstrainSelectedInstOperands,
     /* 105337 */     // GIR_Coverage, 2135,
     /* 105337 */     GIR_EraseRootFromParent_Done,
     /* 105338 */   // Label 1991: @105338
     /* 105338 */   GIM_Reject,
     /* 105339 */ // Label 1987: @105339
     /* 105339 */ GIM_Reject,
     /* 105340 */ // Label 1978: @105340
     /* 105340 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(105386), // Rule ID 1014 //
     /* 105345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105366 */   // (ssubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 105366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv1i64),
     /* 105369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105371 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105373 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105378 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105384 */   GIR_RootConstrainSelectedInstOperands,
     /* 105385 */   // GIR_Coverage, 1014,
     /* 105385 */   GIR_EraseRootFromParent_Done,
     /* 105386 */ // Label 1992: @105386
     /* 105386 */ GIM_Reject,
     /* 105387 */ // Label 1979: @105387
     /* 105387 */ GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(105433), // Rule ID 1009 //
     /* 105392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105413 */   // (ssubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i32),
     /* 105416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105418 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105420 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105425 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105431 */   GIR_RootConstrainSelectedInstOperands,
     /* 105432 */   // GIR_Coverage, 1009,
     /* 105432 */   GIR_EraseRootFromParent_Done,
     /* 105433 */ // Label 1993: @105433
     /* 105433 */ GIM_Reject,
     /* 105434 */ // Label 1980: @105434
     /* 105434 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(105556),
     /* 105439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 105445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105453 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(105523), // Rule ID 2496 //
     /* 105458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105469 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105472 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105481 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 105485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105497 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3786:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLSLv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv2i64),
     /* 105500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105521 */     GIR_RootConstrainSelectedInstOperands,
     /* 105522 */     // GIR_Coverage, 2496,
     /* 105522 */     GIR_EraseRootFromParent_Done,
     /* 105523 */   // Label 1995: @105523
     /* 105523 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105555), // Rule ID 1015 //
     /* 105528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105535 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 105535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i64),
     /* 105538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105553 */     GIR_RootConstrainSelectedInstOperands,
     /* 105554 */     // GIR_Coverage, 1015,
     /* 105554 */     GIR_EraseRootFromParent_Done,
     /* 105555 */   // Label 1996: @105555
     /* 105555 */   GIM_Reject,
     /* 105556 */ // Label 1994: @105556
     /* 105556 */ GIM_Reject,
     /* 105557 */ // Label 1981: @105557
     /* 105557 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105603), // Rule ID 1008 //
     /* 105562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105583 */   // (ssubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i16),
     /* 105586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105588 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105590 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105595 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105601 */   GIR_RootConstrainSelectedInstOperands,
     /* 105602 */   // GIR_Coverage, 1008,
     /* 105602 */   GIR_EraseRootFromParent_Done,
     /* 105603 */ // Label 1997: @105603
     /* 105603 */ GIM_Reject,
     /* 105604 */ // Label 1982: @105604
     /* 105604 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105795),
     /* 105609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105615 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105693), // Rule ID 2495 //
     /* 105620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105639 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105642 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105651 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 105655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105667 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3786:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLSLv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv4i32),
     /* 105670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105672 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105691 */     GIR_RootConstrainSelectedInstOperands,
     /* 105692 */     // GIR_Coverage, 2495,
     /* 105692 */     GIR_EraseRootFromParent_Done,
     /* 105693 */   // Label 1999: @105693
     /* 105693 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105733), // Rule ID 1011 //
     /* 105698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105713 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 105713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i32),
     /* 105716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105731 */     GIR_RootConstrainSelectedInstOperands,
     /* 105732 */     // GIR_Coverage, 1011,
     /* 105732 */     GIR_EraseRootFromParent_Done,
     /* 105733 */   // Label 2000: @105733
     /* 105733 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(105794), // Rule ID 3536 //
     /* 105738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105753 */     // (ssubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 105753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs32),
     /* 105768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105792 */     GIR_RootConstrainSelectedInstOperands,
     /* 105793 */     // GIR_Coverage, 3536,
     /* 105793 */     GIR_EraseRootFromParent_Done,
     /* 105794 */   // Label 2001: @105794
     /* 105794 */   GIM_Reject,
     /* 105795 */ // Label 1998: @105795
     /* 105795 */ GIM_Reject,
     /* 105796 */ // Label 1983: @105796
     /* 105796 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(105842), // Rule ID 1012 //
     /* 105801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 105810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105822 */   // (ssubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 105822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i8),
     /* 105825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105827 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105829 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105834 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105840 */   GIR_RootConstrainSelectedInstOperands,
     /* 105841 */   // GIR_Coverage, 1012,
     /* 105841 */   GIR_EraseRootFromParent_Done,
     /* 105842 */ // Label 2002: @105842
     /* 105842 */ GIM_Reject,
     /* 105843 */ // Label 1984: @105843
     /* 105843 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(105956),
     /* 105848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105854 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(105894), // Rule ID 1010 //
     /* 105859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105874 */     // (ssubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 105874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i16),
     /* 105877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105892 */     GIR_RootConstrainSelectedInstOperands,
     /* 105893 */     // GIR_Coverage, 1010,
     /* 105893 */     GIR_EraseRootFromParent_Done,
     /* 105894 */   // Label 2004: @105894
     /* 105894 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(105955), // Rule ID 3533 //
     /* 105899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105914 */     // (ssubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 105914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs16),
     /* 105929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105953 */     GIR_RootConstrainSelectedInstOperands,
     /* 105954 */     // GIR_Coverage, 3533,
     /* 105954 */     GIR_EraseRootFromParent_Done,
     /* 105955 */   // Label 2005: @105955
     /* 105955 */   GIM_Reject,
     /* 105956 */ // Label 2003: @105956
     /* 105956 */ GIM_Reject,
     /* 105957 */ // Label 1985: @105957
     /* 105957 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(106070),
     /* 105962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 105968 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(106008), // Rule ID 1013 //
     /* 105973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105988 */     // (ssubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 105988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv16i8),
     /* 105991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 106000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106006 */     GIR_RootConstrainSelectedInstOperands,
     /* 106007 */     // GIR_Coverage, 1013,
     /* 106007 */     GIR_EraseRootFromParent_Done,
     /* 106008 */   // Label 2007: @106008
     /* 106008 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(106069), // Rule ID 3530 //
     /* 106013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 106016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 106020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 106024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 106028 */     // (ssubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 106028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 106031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs8),
     /* 106043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 106045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 106047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 106049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106067 */     GIR_RootConstrainSelectedInstOperands,
     /* 106068 */     // GIR_Coverage, 3530,
     /* 106068 */     GIR_EraseRootFromParent_Done,
     /* 106069 */   // Label 2008: @106069
     /* 106069 */   GIM_Reject,
     /* 106070 */ // Label 2006: @106070
     /* 106070 */ GIM_Reject,
     /* 106071 */ // Label 1986: @106071
     /* 106071 */ GIM_Reject,
     /* 106072 */ // Label 34: @106072
     /* 106072 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2016*/ GIMT_Encode4(108424),
     /* 106083 */ /*GILLT_s16*//*Label 2009*/ GIMT_Encode4(106135),
     /* 106087 */ /*GILLT_s32*//*Label 2010*/ GIMT_Encode4(106182),
     /* 106091 */ /*GILLT_s64*//*Label 2011*/ GIMT_Encode4(107777), GIMT_Encode4(0),
     /* 106099 */ /*GILLT_v2s32*//*Label 2012*/ GIMT_Encode4(107824), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106111 */ /*GILLT_v4s16*//*Label 2013*/ GIMT_Encode4(107871),
     /* 106115 */ /*GILLT_v4s32*//*Label 2014*/ GIMT_Encode4(108056), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106131 */ /*GILLT_v8s16*//*Label 2015*/ GIMT_Encode4(108170),
     /* 106135 */ // Label 2009: @106135
     /* 106135 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(106181), // Rule ID 614 //
     /* 106140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 106143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 106146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 106149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106161 */   // (fadd:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VADDH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 106161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDH),
     /* 106164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 106166 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 106168 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 106170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 106173 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106179 */   GIR_RootConstrainSelectedInstOperands,
     /* 106180 */   // GIR_Coverage, 614,
     /* 106180 */   GIR_EraseRootFromParent_Done,
     /* 106181 */ // Label 2017: @106181
     /* 106181 */ GIM_Reject,
     /* 106182 */ // Label 2010: @106182
     /* 106182 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(107776),
     /* 106187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106197 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(106525), // Rule ID 5921 //
     /* 106202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106237 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106237 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106240 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106244 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106251 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106254 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106258 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106263 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106266 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106271 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106274 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106278 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106283 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106286 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106290 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106293 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106298 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106303 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106308 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106311 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106315 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106322 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106325 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106329 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106334 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106337 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106342 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106345 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106349 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106354 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106357 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106361 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106364 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106369 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106374 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106379 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106382 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106386 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106393 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106396 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106400 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106405 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106408 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106413 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106416 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106420 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106425 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106428 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106432 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106435 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106440 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106445 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106462 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106465 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106468 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106471 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106474 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106494 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106507 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106524 */     // GIR_Coverage, 5921,
     /* 106524 */     GIR_EraseRootFromParent_Done,
     /* 106525 */   // Label 2019: @106525
     /* 106525 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(106853), // Rule ID 5922 //
     /* 106530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106565 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106565 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106568 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106572 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106579 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106582 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106586 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106591 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106594 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106599 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106602 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106606 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106611 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106614 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106618 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106621 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106626 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106631 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106636 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106639 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106643 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106650 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106653 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106657 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106662 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106665 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106670 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106673 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106677 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106682 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106685 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106689 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106692 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106697 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106702 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106707 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106710 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106714 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106721 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106724 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106728 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106733 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106736 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106741 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106744 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106748 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106753 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106756 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106760 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106763 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106768 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106773 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106778 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106781 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106785 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106790 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106793 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106796 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106799 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106802 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106835 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106852 */     // GIR_Coverage, 5922,
     /* 106852 */     GIR_EraseRootFromParent_Done,
     /* 106853 */   // Label 2020: @106853
     /* 106853 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(107181), // Rule ID 2700 //
     /* 106858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106893 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106893 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106896 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106900 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106907 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106910 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106914 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106919 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106922 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106927 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106930 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106934 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106939 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106942 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106946 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106949 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106954 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106959 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106964 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106967 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106971 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106978 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106981 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106985 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106990 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106993 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106998 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107001 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107005 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107010 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107013 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 107017 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107020 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107025 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107030 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107035 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107038 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107042 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107049 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107052 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107056 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107061 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107064 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107069 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107072 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107076 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107081 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107084 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 107088 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107091 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107096 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107101 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107106 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107109 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 107113 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107118 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107121 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107124 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107127 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107130 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107150 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107163 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107170 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107180 */     // GIR_Coverage, 2700,
     /* 107180 */     GIR_EraseRootFromParent_Done,
     /* 107181 */   // Label 2021: @107181
     /* 107181 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(107509), // Rule ID 2702 //
     /* 107186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 107189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 107205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107221 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107221 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 107224 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107228 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 107235 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 107238 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107242 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107247 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 107250 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107255 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 107258 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107262 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107267 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 107270 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 107274 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 107277 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107282 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107287 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107292 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107295 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107299 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107306 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107309 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107313 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107318 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107321 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107326 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107329 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107333 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107338 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107341 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 107345 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107348 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107353 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107358 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107363 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107366 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107370 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107377 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107380 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107384 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107389 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107392 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107397 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107400 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107404 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107409 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107412 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 107416 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107419 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107424 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107429 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107434 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107437 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 107441 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107446 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107449 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107452 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107455 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107458 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107478 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107491 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107508 */     // GIR_Coverage, 2702,
     /* 107508 */     GIR_EraseRootFromParent_Done,
     /* 107509 */   // Label 2022: @107509
     /* 107509 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(107545), // Rule ID 613 //
     /* 107514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 107517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107525 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VADDS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 107525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDS),
     /* 107528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 107530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 107532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 107534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107543 */     GIR_RootConstrainSelectedInstOperands,
     /* 107544 */     // GIR_Coverage, 613,
     /* 107544 */     GIR_EraseRootFromParent_Done,
     /* 107545 */   // Label 2023: @107545
     /* 107545 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107775), // Rule ID 2697 //
     /* 107550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 107553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107561 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VADDfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107561 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107564 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107568 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107575 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107578 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107582 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107587 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107590 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107595 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107598 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107602 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107607 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107610 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 107614 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107617 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107622 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107627 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107632 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107635 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107639 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107646 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107649 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107653 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107658 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107661 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107666 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107669 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107673 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107678 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107681 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 107685 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107688 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107693 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107698 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107703 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107706 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107710 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107715 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107718 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107721 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107724 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107744 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107757 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107774 */     // GIR_Coverage, 2697,
     /* 107774 */     GIR_EraseRootFromParent_Done,
     /* 107775 */   // Label 2024: @107775
     /* 107775 */   GIM_Reject,
     /* 107776 */ // Label 2018: @107776
     /* 107776 */ GIM_Reject,
     /* 107777 */ // Label 2011: @107777
     /* 107777 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107823), // Rule ID 612 //
     /* 107782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 107785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 107791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107803 */   // (fadd:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VADDD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 107803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDD),
     /* 107806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 107808 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 107810 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 107812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107815 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107821 */   GIR_RootConstrainSelectedInstOperands,
     /* 107822 */   // GIR_Coverage, 612,
     /* 107822 */   GIR_EraseRootFromParent_Done,
     /* 107823 */ // Label 2025: @107823
     /* 107823 */ GIM_Reject,
     /* 107824 */ // Label 2012: @107824
     /* 107824 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107870), // Rule ID 764 //
     /* 107829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 107838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107850 */   // (fadd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VADDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 107850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107855 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107857 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107862 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107868 */   GIR_RootConstrainSelectedInstOperands,
     /* 107869 */   // GIR_Coverage, 764,
     /* 107869 */   GIR_EraseRootFromParent_Done,
     /* 107870 */ // Label 2026: @107870
     /* 107870 */ GIM_Reject,
     /* 107871 */ // Label 2013: @107871
     /* 107871 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(108055),
     /* 107876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107886 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(107952), // Rule ID 5584 //
     /* 107891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107926 */     // (fadd:{ *:[v4f16] } (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm), DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107931 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107950 */     GIR_RootConstrainSelectedInstOperands,
     /* 107951 */     // GIR_Coverage, 5584,
     /* 107951 */     GIR_EraseRootFromParent_Done,
     /* 107952 */   // Label 2028: @107952
     /* 107952 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(108018), // Rule ID 945 //
     /* 107957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107992 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107997 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108016 */     GIR_RootConstrainSelectedInstOperands,
     /* 108017 */     // GIR_Coverage, 945,
     /* 108017 */     GIR_EraseRootFromParent_Done,
     /* 108018 */   // Label 2029: @108018
     /* 108018 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(108054), // Rule ID 766 //
     /* 108023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 108026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108034 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VADDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 108034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhd),
     /* 108037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108052 */     GIR_RootConstrainSelectedInstOperands,
     /* 108053 */     // GIR_Coverage, 766,
     /* 108053 */     GIR_EraseRootFromParent_Done,
     /* 108054 */   // Label 2030: @108054
     /* 108054 */   GIM_Reject,
     /* 108055 */ // Label 2027: @108055
     /* 108055 */ GIM_Reject,
     /* 108056 */ // Label 2014: @108056
     /* 108056 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(108169),
     /* 108061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 108067 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(108107), // Rule ID 765 //
     /* 108072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 108075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108087 */     // (fadd:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VADDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 108087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfq),
     /* 108090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108105 */     GIR_RootConstrainSelectedInstOperands,
     /* 108106 */     // GIR_Coverage, 765,
     /* 108106 */     GIR_EraseRootFromParent_Done,
     /* 108107 */   // Label 2032: @108107
     /* 108107 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(108168), // Rule ID 4016 //
     /* 108112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108127 */     // (fadd:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 108127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf32),
     /* 108142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108166 */     GIR_RootConstrainSelectedInstOperands,
     /* 108167 */     // GIR_Coverage, 4016,
     /* 108167 */     GIR_EraseRootFromParent_Done,
     /* 108168 */   // Label 2033: @108168
     /* 108168 */   GIM_Reject,
     /* 108169 */ // Label 2031: @108169
     /* 108169 */ GIM_Reject,
     /* 108170 */ // Label 2015: @108170
     /* 108170 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(108423),
     /* 108175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108181 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(108251), // Rule ID 5585 //
     /* 108186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108225 */     // (fadd:{ *:[v8f16] } (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm), QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108230 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108249 */     GIR_RootConstrainSelectedInstOperands,
     /* 108250 */     // GIR_Coverage, 5585,
     /* 108250 */     GIR_EraseRootFromParent_Done,
     /* 108251 */   // Label 2035: @108251
     /* 108251 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(108321), // Rule ID 946 //
     /* 108256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108295 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108300 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108319 */     GIR_RootConstrainSelectedInstOperands,
     /* 108320 */     // GIR_Coverage, 946,
     /* 108320 */     GIR_EraseRootFromParent_Done,
     /* 108321 */   // Label 2036: @108321
     /* 108321 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(108361), // Rule ID 767 //
     /* 108326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 108329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108341 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VADDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhq),
     /* 108344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108359 */     GIR_RootConstrainSelectedInstOperands,
     /* 108360 */     // GIR_Coverage, 767,
     /* 108360 */     GIR_EraseRootFromParent_Done,
     /* 108361 */   // Label 2037: @108361
     /* 108361 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(108422), // Rule ID 4020 //
     /* 108366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108381 */     // (fadd:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 108381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf16),
     /* 108396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108420 */     GIR_RootConstrainSelectedInstOperands,
     /* 108421 */     // GIR_Coverage, 4020,
     /* 108421 */     GIR_EraseRootFromParent_Done,
     /* 108422 */   // Label 2038: @108422
     /* 108422 */   GIM_Reject,
     /* 108423 */ // Label 2034: @108423
     /* 108423 */ GIM_Reject,
     /* 108424 */ // Label 2016: @108424
     /* 108424 */ GIM_Reject,
     /* 108425 */ // Label 35: @108425
     /* 108425 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2046*/ GIMT_Encode4(110101),
     /* 108436 */ /*GILLT_s16*//*Label 2039*/ GIMT_Encode4(108488),
     /* 108440 */ /*GILLT_s32*//*Label 2040*/ GIMT_Encode4(108535),
     /* 108444 */ /*GILLT_s64*//*Label 2041*/ GIMT_Encode4(109462), GIMT_Encode4(0),
     /* 108452 */ /*GILLT_v2s32*//*Label 2042*/ GIMT_Encode4(109509), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108464 */ /*GILLT_v4s16*//*Label 2043*/ GIMT_Encode4(109556),
     /* 108468 */ /*GILLT_v4s32*//*Label 2044*/ GIMT_Encode4(109733), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108484 */ /*GILLT_v8s16*//*Label 2045*/ GIMT_Encode4(109847),
     /* 108488 */ // Label 2039: @108488
     /* 108488 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(108534), // Rule ID 617 //
     /* 108493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 108496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 108499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 108502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108514 */   // (fsub:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VSUBH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 108514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBH),
     /* 108517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108519 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108521 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108526 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108532 */   GIR_RootConstrainSelectedInstOperands,
     /* 108533 */   // GIR_Coverage, 617,
     /* 108533 */   GIR_EraseRootFromParent_Done,
     /* 108534 */ // Label 2047: @108534
     /* 108534 */ GIM_Reject,
     /* 108535 */ // Label 2040: @108535
     /* 108535 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(109461),
     /* 108540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108554 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(108878), // Rule ID 2701 //
     /* 108559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 108562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108590 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108590 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108593 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108597 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108604 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108607 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108611 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108616 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108619 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108624 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108627 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108631 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108636 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108639 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108643 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108646 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108651 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108656 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108661 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108664 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108668 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108675 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108678 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108682 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108687 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108690 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108695 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108698 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108702 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108707 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108710 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108714 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108717 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108722 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108727 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108732 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108735 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108739 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108746 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108749 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108753 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108758 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108761 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108766 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108769 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108773 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108778 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108781 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108785 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108788 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108793 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108798 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLSfd),
     /* 108810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108815 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108818 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108821 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108824 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108827 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108847 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108860 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108877 */     // GIR_Coverage, 2701,
     /* 108877 */     GIR_EraseRootFromParent_Done,
     /* 108878 */   // Label 2049: @108878
     /* 108878 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109202), // Rule ID 2703 //
     /* 108883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 108886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108914 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108914 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108917 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108921 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108928 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108931 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108935 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108940 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108943 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108948 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108951 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108955 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108960 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108963 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108967 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108970 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108975 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108980 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108985 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108988 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108992 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108999 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 109002 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109006 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109011 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 109014 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109019 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 109022 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109026 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109031 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109034 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 109038 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109041 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109046 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109051 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109056 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109059 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109063 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109070 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109073 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109077 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109082 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109085 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109090 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109093 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109097 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109102 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109105 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 109109 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109112 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109117 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109122 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109127 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109130 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 109134 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109139 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109142 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109145 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 109148 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109151 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109171 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109184 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109201 */     // GIR_Coverage, 2703,
     /* 109201 */     GIR_EraseRootFromParent_Done,
     /* 109202 */   // Label 2050: @109202
     /* 109202 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(109234), // Rule ID 616 //
     /* 109207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 109210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109214 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VSUBS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 109214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBS),
     /* 109217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109232 */     GIR_RootConstrainSelectedInstOperands,
     /* 109233 */     // GIR_Coverage, 616,
     /* 109233 */     GIR_EraseRootFromParent_Done,
     /* 109234 */   // Label 2051: @109234
     /* 109234 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(109460), // Rule ID 2698 //
     /* 109239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 109242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109246 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VSUBfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 109246 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 109249 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109253 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 109260 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 109263 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109267 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109272 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 109275 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109280 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 109283 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109287 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109292 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109295 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 109299 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109302 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109307 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109312 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109317 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109320 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109324 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109331 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109334 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109338 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109343 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109346 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109351 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109354 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109358 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109363 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109366 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 109370 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109373 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109378 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109383 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109388 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109391 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109395 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109400 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109403 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109406 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109409 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109429 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109442 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109459 */     // GIR_Coverage, 2698,
     /* 109459 */     GIR_EraseRootFromParent_Done,
     /* 109460 */   // Label 2052: @109460
     /* 109460 */   GIM_Reject,
     /* 109461 */ // Label 2048: @109461
     /* 109461 */ GIM_Reject,
     /* 109462 */ // Label 2041: @109462
     /* 109462 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(109508), // Rule ID 615 //
     /* 109467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 109470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 109476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109488 */   // (fsub:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VSUBD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 109488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBD),
     /* 109491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 109493 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 109495 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 109497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109500 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109506 */   GIR_RootConstrainSelectedInstOperands,
     /* 109507 */   // GIR_Coverage, 615,
     /* 109507 */   GIR_EraseRootFromParent_Done,
     /* 109508 */ // Label 2053: @109508
     /* 109508 */ GIM_Reject,
     /* 109509 */ // Label 2042: @109509
     /* 109509 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109555), // Rule ID 968 //
     /* 109514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 109523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109535 */   // (fsub:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VSUBfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 109535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109540 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109542 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109547 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109553 */   GIR_RootConstrainSelectedInstOperands,
     /* 109554 */   // GIR_Coverage, 968,
     /* 109554 */   GIR_EraseRootFromParent_Done,
     /* 109555 */ // Label 2054: @109555
     /* 109555 */ GIM_Reject,
     /* 109556 */ // Label 2043: @109556
     /* 109556 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(109732),
     /* 109561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109575 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109637), // Rule ID 923 //
     /* 109580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109611 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VMLShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShd),
     /* 109614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109616 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109635 */     GIR_RootConstrainSelectedInstOperands,
     /* 109636 */     // GIR_Coverage, 923,
     /* 109636 */     GIR_EraseRootFromParent_Done,
     /* 109637 */   // Label 2056: @109637
     /* 109637 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109699), // Rule ID 949 //
     /* 109642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109673 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShd),
     /* 109676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109678 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109697 */     GIR_RootConstrainSelectedInstOperands,
     /* 109698 */     // GIR_Coverage, 949,
     /* 109698 */     GIR_EraseRootFromParent_Done,
     /* 109699 */   // Label 2057: @109699
     /* 109699 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109731), // Rule ID 970 //
     /* 109704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109711 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VSUBhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhd),
     /* 109714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109729 */     GIR_RootConstrainSelectedInstOperands,
     /* 109730 */     // GIR_Coverage, 970,
     /* 109730 */     GIR_EraseRootFromParent_Done,
     /* 109731 */   // Label 2058: @109731
     /* 109731 */   GIM_Reject,
     /* 109732 */ // Label 2055: @109732
     /* 109732 */ GIM_Reject,
     /* 109733 */ // Label 2044: @109733
     /* 109733 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109846),
     /* 109738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 109744 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109784), // Rule ID 969 //
     /* 109749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109764 */     // (fsub:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VSUBfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 109764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfq),
     /* 109767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109782 */     GIR_RootConstrainSelectedInstOperands,
     /* 109783 */     // GIR_Coverage, 969,
     /* 109783 */     GIR_EraseRootFromParent_Done,
     /* 109784 */   // Label 2060: @109784
     /* 109784 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109845), // Rule ID 4024 //
     /* 109789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109804 */     // (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VSUBf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 109804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf32),
     /* 109819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109843 */     GIR_RootConstrainSelectedInstOperands,
     /* 109844 */     // GIR_Coverage, 4024,
     /* 109844 */     GIR_EraseRootFromParent_Done,
     /* 109845 */   // Label 2061: @109845
     /* 109845 */   GIM_Reject,
     /* 109846 */ // Label 2059: @109846
     /* 109846 */ GIM_Reject,
     /* 109847 */ // Label 2045: @109847
     /* 109847 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(110100),
     /* 109852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109858 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109928), // Rule ID 924 //
     /* 109863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109902 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VMLShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShq),
     /* 109905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109907 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109926 */     GIR_RootConstrainSelectedInstOperands,
     /* 109927 */     // GIR_Coverage, 924,
     /* 109927 */     GIR_EraseRootFromParent_Done,
     /* 109928 */   // Label 2063: @109928
     /* 109928 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109998), // Rule ID 950 //
     /* 109933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109972 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShq),
     /* 109975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109977 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109996 */     GIR_RootConstrainSelectedInstOperands,
     /* 109997 */     // GIR_Coverage, 950,
     /* 109997 */     GIR_EraseRootFromParent_Done,
     /* 109998 */   // Label 2064: @109998
     /* 109998 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(110038), // Rule ID 971 //
     /* 110003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110018 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VSUBhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhq),
     /* 110021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110036 */     GIR_RootConstrainSelectedInstOperands,
     /* 110037 */     // GIR_Coverage, 971,
     /* 110037 */     GIR_EraseRootFromParent_Done,
     /* 110038 */   // Label 2065: @110038
     /* 110038 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(110099), // Rule ID 4028 //
     /* 110043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110058 */     // (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VSUBf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 110058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf16),
     /* 110073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110097 */     GIR_RootConstrainSelectedInstOperands,
     /* 110098 */     // GIR_Coverage, 4028,
     /* 110098 */     GIR_EraseRootFromParent_Done,
     /* 110099 */   // Label 2066: @110099
     /* 110099 */   GIM_Reject,
     /* 110100 */ // Label 2062: @110100
     /* 110100 */ GIM_Reject,
     /* 110101 */ // Label 2046: @110101
     /* 110101 */ GIM_Reject,
     /* 110102 */ // Label 36: @110102
     /* 110102 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2074*/ GIMT_Encode4(111082),
     /* 110113 */ /*GILLT_s16*//*Label 2067*/ GIMT_Encode4(110165),
     /* 110117 */ /*GILLT_s32*//*Label 2068*/ GIMT_Encode4(110212),
     /* 110121 */ /*GILLT_s64*//*Label 2069*/ GIMT_Encode4(110601), GIMT_Encode4(0),
     /* 110129 */ /*GILLT_v2s32*//*Label 2070*/ GIMT_Encode4(110760), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110141 */ /*GILLT_v4s16*//*Label 2071*/ GIMT_Encode4(110807),
     /* 110145 */ /*GILLT_v4s32*//*Label 2072*/ GIMT_Encode4(110854), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110161 */ /*GILLT_v8s16*//*Label 2073*/ GIMT_Encode4(110968),
     /* 110165 */ // Label 2067: @110165
     /* 110165 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(110211), // Rule ID 623 //
     /* 110170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 110179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110191 */   // (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULH),
     /* 110194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110196 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110198 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110203 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110209 */   GIR_RootConstrainSelectedInstOperands,
     /* 110210 */   // GIR_Coverage, 623,
     /* 110210 */   GIR_EraseRootFromParent_Done,
     /* 110211 */ // Label 2075: @110211
     /* 110211 */ GIM_Reject,
     /* 110212 */ // Label 2068: @110212
     /* 110212 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(110600),
     /* 110217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 110223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110227 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110280), // Rule ID 2302 //
     /* 110232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110258 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a), SPR:{ *:[f32] }:$b)  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110267 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110278 */     GIR_RootConstrainSelectedInstOperands,
     /* 110279 */     // GIR_Coverage, 2302,
     /* 110279 */     GIR_EraseRootFromParent_Done,
     /* 110280 */   // Label 2077: @110280
     /* 110280 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110333), // Rule ID 5711 //
     /* 110285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110311 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$b, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110320 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110331 */     GIR_RootConstrainSelectedInstOperands,
     /* 110332 */     // GIR_Coverage, 5711,
     /* 110332 */     GIR_EraseRootFromParent_Done,
     /* 110333 */   // Label 2078: @110333
     /* 110333 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110369), // Rule ID 622 //
     /* 110338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 110341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110349 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 110349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULS),
     /* 110352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110367 */     GIR_RootConstrainSelectedInstOperands,
     /* 110368 */     // GIR_Coverage, 622,
     /* 110368 */     GIR_EraseRootFromParent_Done,
     /* 110369 */   // Label 2079: @110369
     /* 110369 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110599), // Rule ID 2699 //
     /* 110374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 110377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110385 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMULfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 110385 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 110388 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110392 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 110399 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 110402 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110406 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110411 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 110414 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110419 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 110422 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110426 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110431 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 110434 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 110438 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 110441 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110446 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110451 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110456 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 110459 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110463 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 110470 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 110473 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110477 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110482 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 110485 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110490 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 110493 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110497 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110502 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 110505 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 110509 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 110512 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110517 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110522 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110527 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 110530 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110534 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110539 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110542 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 110545 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 110548 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 110559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110568 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110581 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 110588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110598 */     // GIR_Coverage, 2699,
     /* 110598 */     GIR_EraseRootFromParent_Done,
     /* 110599 */   // Label 2080: @110599
     /* 110599 */   GIM_Reject,
     /* 110600 */ // Label 2076: @110600
     /* 110600 */ GIM_Reject,
     /* 110601 */ // Label 2069: @110601
     /* 110601 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110759),
     /* 110606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 110612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110616 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110669), // Rule ID 2301 //
     /* 110621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110647 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a), DPR:{ *:[f64] }:$b)  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110656 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110667 */     GIR_RootConstrainSelectedInstOperands,
     /* 110668 */     // GIR_Coverage, 2301,
     /* 110668 */     GIR_EraseRootFromParent_Done,
     /* 110669 */   // Label 2082: @110669
     /* 110669 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110722), // Rule ID 5710 //
     /* 110674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110700 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$b, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110709 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110720 */     GIR_RootConstrainSelectedInstOperands,
     /* 110721 */     // GIR_Coverage, 5710,
     /* 110721 */     GIR_EraseRootFromParent_Done,
     /* 110722 */   // Label 2083: @110722
     /* 110722 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110758), // Rule ID 621 //
     /* 110727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 110730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110738 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 110738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULD),
     /* 110741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 110745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 110747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110756 */     GIR_RootConstrainSelectedInstOperands,
     /* 110757 */     // GIR_Coverage, 621,
     /* 110757 */     GIR_EraseRootFromParent_Done,
     /* 110758 */   // Label 2084: @110758
     /* 110758 */   GIM_Reject,
     /* 110759 */ // Label 2081: @110759
     /* 110759 */ GIM_Reject,
     /* 110760 */ // Label 2070: @110760
     /* 110760 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110806), // Rule ID 843 //
     /* 110765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 110774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110786 */   // (fmul:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMULfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 110786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110791 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110793 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110798 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110804 */   GIR_RootConstrainSelectedInstOperands,
     /* 110805 */   // GIR_Coverage, 843,
     /* 110805 */   GIR_EraseRootFromParent_Done,
     /* 110806 */ // Label 2085: @110806
     /* 110806 */ GIM_Reject,
     /* 110807 */ // Label 2071: @110807
     /* 110807 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110853), // Rule ID 845 //
     /* 110812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 110821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110833 */   // (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMULhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 110833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhd),
     /* 110836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110838 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110840 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110845 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110851 */   GIR_RootConstrainSelectedInstOperands,
     /* 110852 */   // GIR_Coverage, 845,
     /* 110852 */   GIR_EraseRootFromParent_Done,
     /* 110853 */ // Label 2086: @110853
     /* 110853 */ GIM_Reject,
     /* 110854 */ // Label 2072: @110854
     /* 110854 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110967),
     /* 110859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 110865 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110905), // Rule ID 844 //
     /* 110870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110885 */     // (fmul:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMULfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 110885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfq),
     /* 110888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110903 */     GIR_RootConstrainSelectedInstOperands,
     /* 110904 */     // GIR_Coverage, 844,
     /* 110904 */     GIR_EraseRootFromParent_Done,
     /* 110905 */   // Label 2088: @110905
     /* 110905 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110966), // Rule ID 3988 //
     /* 110910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110925 */     // (fmul:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 110925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf32),
     /* 110940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110964 */     GIR_RootConstrainSelectedInstOperands,
     /* 110965 */     // GIR_Coverage, 3988,
     /* 110965 */     GIR_EraseRootFromParent_Done,
     /* 110966 */   // Label 2089: @110966
     /* 110966 */   GIM_Reject,
     /* 110967 */ // Label 2087: @110967
     /* 110967 */ GIM_Reject,
     /* 110968 */ // Label 2073: @110968
     /* 110968 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(111081),
     /* 110973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 110979 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(111019), // Rule ID 846 //
     /* 110984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110999 */     // (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMULhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhq),
     /* 111002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 111004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 111006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 111008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111017 */     GIR_RootConstrainSelectedInstOperands,
     /* 111018 */     // GIR_Coverage, 846,
     /* 111018 */     GIR_EraseRootFromParent_Done,
     /* 111019 */   // Label 2091: @111019
     /* 111019 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(111080), // Rule ID 3992 //
     /* 111024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 111027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 111031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 111035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 111039 */     // (fmul:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 111039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 111042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 111046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf16),
     /* 111054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 111056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 111058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 111060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111078 */     GIR_RootConstrainSelectedInstOperands,
     /* 111079 */     // GIR_Coverage, 3992,
     /* 111079 */     GIR_EraseRootFromParent_Done,
     /* 111080 */   // Label 2092: @111080
     /* 111080 */   GIM_Reject,
     /* 111081 */ // Label 2090: @111081
     /* 111081 */ GIM_Reject,
     /* 111082 */ // Label 2074: @111082
     /* 111082 */ GIM_Reject,
     /* 111083 */ // Label 37: @111083
     /* 111083 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2100*/ GIMT_Encode4(113173),
     /* 111094 */ /*GILLT_s16*//*Label 2093*/ GIMT_Encode4(111146),
     /* 111098 */ /*GILLT_s32*//*Label 2094*/ GIMT_Encode4(111533),
     /* 111102 */ /*GILLT_s64*//*Label 2095*/ GIMT_Encode4(111920), GIMT_Encode4(0),
     /* 111110 */ /*GILLT_v2s32*//*Label 2096*/ GIMT_Encode4(112307), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111122 */ /*GILLT_v4s16*//*Label 2097*/ GIMT_Encode4(112487),
     /* 111126 */ /*GILLT_v4s32*//*Label 2098*/ GIMT_Encode4(112543), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111142 */ /*GILLT_v8s16*//*Label 2099*/ GIMT_Encode4(112921),
     /* 111146 */ // Label 2093: @111146
     /* 111146 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(111532),
     /* 111151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 111154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 111157 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 111160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111164 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(111238), // Rule ID 2406 //
     /* 111169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111212 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111236 */     GIR_RootConstrainSelectedInstOperands,
     /* 111237 */     // GIR_Coverage, 2406,
     /* 111237 */     GIR_EraseRootFromParent_Done,
     /* 111238 */   // Label 2102: @111238
     /* 111238 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(111312), // Rule ID 5719 //
     /* 111243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111286 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111310 */     GIR_RootConstrainSelectedInstOperands,
     /* 111311 */     // GIR_Coverage, 5719,
     /* 111311 */     GIR_EraseRootFromParent_Done,
     /* 111312 */   // Label 2103: @111312
     /* 111312 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(111371), // Rule ID 2398 //
     /* 111317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111347 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111369 */     GIR_RootConstrainSelectedInstOperands,
     /* 111370 */     // GIR_Coverage, 2398,
     /* 111370 */     GIR_EraseRootFromParent_Done,
     /* 111371 */   // Label 2104: @111371
     /* 111371 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(111430), // Rule ID 5716 //
     /* 111376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111406 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111428 */     GIR_RootConstrainSelectedInstOperands,
     /* 111429 */     // GIR_Coverage, 5716,
     /* 111429 */     GIR_EraseRootFromParent_Done,
     /* 111430 */   // Label 2105: @111430
     /* 111430 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(111489), // Rule ID 2411 //
     /* 111435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111465 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 111468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111487 */     GIR_RootConstrainSelectedInstOperands,
     /* 111488 */     // GIR_Coverage, 2411,
     /* 111488 */     GIR_EraseRootFromParent_Done,
     /* 111489 */   // Label 2106: @111489
     /* 111489 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(111531), // Rule ID 2392 //
     /* 111494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111509 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAH),
     /* 111512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111529 */     GIR_RootConstrainSelectedInstOperands,
     /* 111530 */     // GIR_Coverage, 2392,
     /* 111530 */     GIR_EraseRootFromParent_Done,
     /* 111531 */   // Label 2107: @111531
     /* 111531 */   GIM_Reject,
     /* 111532 */ // Label 2101: @111532
     /* 111532 */ GIM_Reject,
     /* 111533 */ // Label 2094: @111533
     /* 111533 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111919),
     /* 111538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 111541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 111544 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 111547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111551 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(111625), // Rule ID 2405 //
     /* 111556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111599 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111623 */     GIR_RootConstrainSelectedInstOperands,
     /* 111624 */     // GIR_Coverage, 2405,
     /* 111624 */     GIR_EraseRootFromParent_Done,
     /* 111625 */   // Label 2109: @111625
     /* 111625 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(111699), // Rule ID 5718 //
     /* 111630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111673 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111697 */     GIR_RootConstrainSelectedInstOperands,
     /* 111698 */     // GIR_Coverage, 5718,
     /* 111698 */     GIR_EraseRootFromParent_Done,
     /* 111699 */   // Label 2110: @111699
     /* 111699 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(111758), // Rule ID 2397 //
     /* 111704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111734 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111756 */     GIR_RootConstrainSelectedInstOperands,
     /* 111757 */     // GIR_Coverage, 2397,
     /* 111757 */     GIR_EraseRootFromParent_Done,
     /* 111758 */   // Label 2111: @111758
     /* 111758 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(111817), // Rule ID 5715 //
     /* 111763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111793 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111809 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111815 */     GIR_RootConstrainSelectedInstOperands,
     /* 111816 */     // GIR_Coverage, 5715,
     /* 111816 */     GIR_EraseRootFromParent_Done,
     /* 111817 */   // Label 2112: @111817
     /* 111817 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(111876), // Rule ID 2410 //
     /* 111822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111852 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 111855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111874 */     GIR_RootConstrainSelectedInstOperands,
     /* 111875 */     // GIR_Coverage, 2410,
     /* 111875 */     GIR_EraseRootFromParent_Done,
     /* 111876 */   // Label 2113: @111876
     /* 111876 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(111918), // Rule ID 2391 //
     /* 111881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111896 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAS),
     /* 111899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111916 */     GIR_RootConstrainSelectedInstOperands,
     /* 111917 */     // GIR_Coverage, 2391,
     /* 111917 */     GIR_EraseRootFromParent_Done,
     /* 111918 */   // Label 2114: @111918
     /* 111918 */   GIM_Reject,
     /* 111919 */ // Label 2108: @111919
     /* 111919 */ GIM_Reject,
     /* 111920 */ // Label 2095: @111920
     /* 111920 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(112306),
     /* 111925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 111931 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 111934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111938 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(112012), // Rule ID 2404 //
     /* 111943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111986 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112010 */     GIR_RootConstrainSelectedInstOperands,
     /* 112011 */     // GIR_Coverage, 2404,
     /* 112011 */     GIR_EraseRootFromParent_Done,
     /* 112012 */   // Label 2116: @112012
     /* 112012 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(112086), // Rule ID 5717 //
     /* 112017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 112045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 112053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112060 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 112063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 112069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 112075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112084 */     GIR_RootConstrainSelectedInstOperands,
     /* 112085 */     // GIR_Coverage, 5717,
     /* 112085 */     GIR_EraseRootFromParent_Done,
     /* 112086 */   // Label 2117: @112086
     /* 112086 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(112145), // Rule ID 2396 //
     /* 112091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112121 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112143 */     GIR_RootConstrainSelectedInstOperands,
     /* 112144 */     // GIR_Coverage, 2396,
     /* 112144 */     GIR_EraseRootFromParent_Done,
     /* 112145 */   // Label 2118: @112145
     /* 112145 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(112204), // Rule ID 5714 //
     /* 112150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112180 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 112193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112202 */     GIR_RootConstrainSelectedInstOperands,
     /* 112203 */     // GIR_Coverage, 5714,
     /* 112203 */     GIR_EraseRootFromParent_Done,
     /* 112204 */   // Label 2119: @112204
     /* 112204 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(112263), // Rule ID 2409 //
     /* 112209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 112224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112239 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 112242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ddin
     /* 112248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112261 */     GIR_RootConstrainSelectedInstOperands,
     /* 112262 */     // GIR_Coverage, 2409,
     /* 112262 */     GIR_EraseRootFromParent_Done,
     /* 112263 */   // Label 2120: @112263
     /* 112263 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(112305), // Rule ID 2390 //
     /* 112268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112283 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAD),
     /* 112286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112303 */     GIR_RootConstrainSelectedInstOperands,
     /* 112304 */     // GIR_Coverage, 2390,
     /* 112304 */     GIR_EraseRootFromParent_Done,
     /* 112305 */   // Label 2121: @112305
     /* 112305 */   GIM_Reject,
     /* 112306 */ // Label 2115: @112306
     /* 112306 */ GIM_Reject,
     /* 112307 */ // Label 2096: @112307
     /* 112307 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(112486),
     /* 112312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 112318 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 112321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112325 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(112384), // Rule ID 2503 //
     /* 112330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112360 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112365 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112382 */     GIR_RootConstrainSelectedInstOperands,
     /* 112383 */     // GIR_Coverage, 2503,
     /* 112383 */     GIR_EraseRootFromParent_Done,
     /* 112384 */   // Label 2123: @112384
     /* 112384 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(112443), // Rule ID 5757 //
     /* 112389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112419 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm, (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112424 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112441 */     GIR_RootConstrainSelectedInstOperands,
     /* 112442 */     // GIR_Coverage, 5757,
     /* 112442 */     GIR_EraseRootFromParent_Done,
     /* 112443 */   // Label 2124: @112443
     /* 112443 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(112485), // Rule ID 2501 //
     /* 112448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112463 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMAfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 112466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112468 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112483 */     GIR_RootConstrainSelectedInstOperands,
     /* 112484 */     // GIR_Coverage, 2501,
     /* 112484 */     GIR_EraseRootFromParent_Done,
     /* 112485 */   // Label 2125: @112485
     /* 112485 */   GIM_Reject,
     /* 112486 */ // Label 2122: @112486
     /* 112486 */ GIM_Reject,
     /* 112487 */ // Label 2097: @112487
     /* 112487 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(112542), // Rule ID 2499 //
     /* 112492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 112501 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 112504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112516 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112520 */   // (fma:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm, DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 112520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 112523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112525 */   GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112527 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112529 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112534 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112540 */   GIR_RootConstrainSelectedInstOperands,
     /* 112541 */   // GIR_Coverage, 2499,
     /* 112541 */   GIR_EraseRootFromParent_Done,
     /* 112542 */ // Label 2126: @112542
     /* 112542 */ GIM_Reject,
     /* 112543 */ // Label 2098: @112543
     /* 112543 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112920),
     /* 112548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 112554 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 112557 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112620), // Rule ID 2504 //
     /* 112562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112596 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112601 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112618 */     GIR_RootConstrainSelectedInstOperands,
     /* 112619 */     // GIR_Coverage, 2504,
     /* 112619 */     GIR_EraseRootFromParent_Done,
     /* 112620 */   // Label 2128: @112620
     /* 112620 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112689), // Rule ID 4002 //
     /* 112625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112659 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112664 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112670 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112687 */     GIR_RootConstrainSelectedInstOperands,
     /* 112688 */     // GIR_Coverage, 4002,
     /* 112688 */     GIR_EraseRootFromParent_Done,
     /* 112689 */   // Label 2129: @112689
     /* 112689 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112752), // Rule ID 5758 //
     /* 112694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112728 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm, (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112733 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112750 */     GIR_RootConstrainSelectedInstOperands,
     /* 112751 */     // GIR_Coverage, 5758,
     /* 112751 */     GIR_EraseRootFromParent_Done,
     /* 112752 */   // Label 2130: @112752
     /* 112752 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112821), // Rule ID 6038 //
     /* 112757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112791 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m2, (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112796 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112802 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112819 */     GIR_RootConstrainSelectedInstOperands,
     /* 112820 */     // GIR_Coverage, 6038,
     /* 112820 */     GIR_EraseRootFromParent_Done,
     /* 112821 */   // Label 2131: @112821
     /* 112821 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112867), // Rule ID 2502 //
     /* 112826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112845 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMAfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfq),
     /* 112848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112850 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112865 */     GIR_RootConstrainSelectedInstOperands,
     /* 112866 */     // GIR_Coverage, 2502,
     /* 112866 */     GIR_EraseRootFromParent_Done,
     /* 112867 */   // Label 2132: @112867
     /* 112867 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112919), // Rule ID 4006 //
     /* 112872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112891 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1, MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMAf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf32),
     /* 112894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112896 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112898 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112900 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112917 */     GIR_RootConstrainSelectedInstOperands,
     /* 112918 */     // GIR_Coverage, 4006,
     /* 112918 */     GIR_EraseRootFromParent_Done,
     /* 112919 */   // Label 2133: @112919
     /* 112919 */   GIM_Reject,
     /* 112920 */ // Label 2127: @112920
     /* 112920 */ GIM_Reject,
     /* 112921 */ // Label 2099: @112921
     /* 112921 */ GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(113172),
     /* 112926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 112932 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 112935 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(113004), // Rule ID 4012 //
     /* 112940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112974 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112979 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112985 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113002 */     GIR_RootConstrainSelectedInstOperands,
     /* 113003 */     // GIR_Coverage, 4012,
     /* 113003 */     GIR_EraseRootFromParent_Done,
     /* 113004 */   // Label 2135: @113004
     /* 113004 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(113073), // Rule ID 6040 //
     /* 113009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 113012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 113024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113043 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m2, (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 113043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 113046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 113048 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 113050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 113054 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 113056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113071 */     GIR_RootConstrainSelectedInstOperands,
     /* 113072 */     // GIR_Coverage, 6040,
     /* 113072 */     GIR_EraseRootFromParent_Done,
     /* 113073 */   // Label 2136: @113073
     /* 113073 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(113119), // Rule ID 2500 //
     /* 113078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 113081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 113085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 113089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 113093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 113097 */     // (fma:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm, QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 113097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 113100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 113102 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 113104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 113106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 113108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113117 */     GIR_RootConstrainSelectedInstOperands,
     /* 113118 */     // GIR_Coverage, 2500,
     /* 113118 */     GIR_EraseRootFromParent_Done,
     /* 113119 */   // Label 2137: @113119
     /* 113119 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(113171), // Rule ID 4009 //
     /* 113124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 113127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113143 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1, MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMAf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 113143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf16),
     /* 113146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 113148 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 113150 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 113152 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 113154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113169 */     GIR_RootConstrainSelectedInstOperands,
     /* 113170 */     // GIR_Coverage, 4009,
     /* 113170 */     GIR_EraseRootFromParent_Done,
     /* 113171 */   // Label 2138: @113171
     /* 113171 */   GIM_Reject,
     /* 113172 */ // Label 2134: @113172
     /* 113172 */ GIM_Reject,
     /* 113173 */ // Label 2100: @113173
     /* 113173 */ GIM_Reject,
     /* 113174 */ // Label 38: @113174
     /* 113174 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2142*/ GIMT_Encode4(113338),
     /* 113185 */ /*GILLT_s16*//*Label 2139*/ GIMT_Encode4(113197),
     /* 113189 */ /*GILLT_s32*//*Label 2140*/ GIMT_Encode4(113244),
     /* 113193 */ /*GILLT_s64*//*Label 2141*/ GIMT_Encode4(113291),
     /* 113197 */ // Label 2139: @113197
     /* 113197 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(113243), // Rule ID 620 //
     /* 113202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 113211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113223 */   // (fdiv:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VDIVH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVH),
     /* 113226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113228 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113230 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113235 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113241 */   GIR_RootConstrainSelectedInstOperands,
     /* 113242 */   // GIR_Coverage, 620,
     /* 113242 */   GIR_EraseRootFromParent_Done,
     /* 113243 */ // Label 2143: @113243
     /* 113243 */ GIM_Reject,
     /* 113244 */ // Label 2140: @113244
     /* 113244 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(113290), // Rule ID 619 //
     /* 113249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 113258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113270 */   // (fdiv:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VDIVS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVS),
     /* 113273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113275 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113277 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113282 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113288 */   GIR_RootConstrainSelectedInstOperands,
     /* 113289 */   // GIR_Coverage, 619,
     /* 113289 */   GIR_EraseRootFromParent_Done,
     /* 113290 */ // Label 2144: @113290
     /* 113290 */ GIM_Reject,
     /* 113291 */ // Label 2141: @113291
     /* 113291 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(113337), // Rule ID 618 //
     /* 113296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 113305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113317 */   // (fdiv:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VDIVD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVD),
     /* 113320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113322 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 113324 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 113326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113335 */   GIR_RootConstrainSelectedInstOperands,
     /* 113336 */   // GIR_Coverage, 618,
     /* 113336 */   GIR_EraseRootFromParent_Done,
     /* 113337 */ // Label 2145: @113337
     /* 113337 */ GIM_Reject,
     /* 113338 */ // Label 2142: @113338
     /* 113338 */ GIM_Reject,
     /* 113339 */ // Label 39: @113339
     /* 113339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2153*/ GIMT_Encode4(114869),
     /* 113350 */ /*GILLT_s16*//*Label 2146*/ GIMT_Encode4(113402),
     /* 113354 */ /*GILLT_s32*//*Label 2147*/ GIMT_Encode4(113749),
     /* 113358 */ /*GILLT_s64*//*Label 2148*/ GIMT_Encode4(114248), GIMT_Encode4(0),
     /* 113366 */ /*GILLT_v2s32*//*Label 2149*/ GIMT_Encode4(114595), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113378 */ /*GILLT_v4s16*//*Label 2150*/ GIMT_Encode4(114633),
     /* 113382 */ /*GILLT_v4s32*//*Label 2151*/ GIMT_Encode4(114671), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113398 */ /*GILLT_v8s16*//*Label 2152*/ GIMT_Encode4(114770),
     /* 113402 */ // Label 2146: @113402
     /* 113402 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113748),
     /* 113407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113414 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113499), // Rule ID 2414 //
     /* 113419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113438 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113471 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113497 */     GIR_RootConstrainSelectedInstOperands,
     /* 113498 */     // GIR_Coverage, 2414,
     /* 113498 */     GIR_EraseRootFromParent_Done,
     /* 113499 */   // Label 2155: @113499
     /* 113499 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113584), // Rule ID 5722 //
     /* 113504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113523 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113556 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113582 */     GIR_RootConstrainSelectedInstOperands,
     /* 113583 */     // GIR_Coverage, 5722,
     /* 113583 */     GIR_EraseRootFromParent_Done,
     /* 113584 */   // Label 2156: @113584
     /* 113584 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113657), // Rule ID 2403 //
     /* 113589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113608 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113629 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 113632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113655 */     GIR_RootConstrainSelectedInstOperands,
     /* 113656 */     // GIR_Coverage, 2403,
     /* 113656 */     GIR_EraseRootFromParent_Done,
     /* 113657 */   // Label 2157: @113657
     /* 113657 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113717), // Rule ID 626 //
     /* 113662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113693 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm))  =>  (VNMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULH),
     /* 113696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113715 */     GIR_RootConstrainSelectedInstOperands,
     /* 113716 */     // GIR_Coverage, 626,
     /* 113716 */     GIR_EraseRootFromParent_Done,
     /* 113717 */   // Label 2158: @113717
     /* 113717 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113747), // Rule ID 664 //
     /* 113722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113729 */     // (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VNEGH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 113729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGH),
     /* 113732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113745 */     GIR_RootConstrainSelectedInstOperands,
     /* 113746 */     // GIR_Coverage, 664,
     /* 113746 */     GIR_EraseRootFromParent_Done,
     /* 113747 */   // Label 2159: @113747
     /* 113747 */   GIM_Reject,
     /* 113748 */ // Label 2154: @113748
     /* 113748 */ GIM_Reject,
     /* 113749 */ // Label 2147: @113749
     /* 113749 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(114247),
     /* 113754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113761 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113846), // Rule ID 2413 //
     /* 113766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113785 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113818 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113844 */     GIR_RootConstrainSelectedInstOperands,
     /* 113845 */     // GIR_Coverage, 2413,
     /* 113845 */     GIR_EraseRootFromParent_Done,
     /* 113846 */   // Label 2161: @113846
     /* 113846 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113931), // Rule ID 5721 //
     /* 113851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113870 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113903 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113929 */     GIR_RootConstrainSelectedInstOperands,
     /* 113930 */     // GIR_Coverage, 5721,
     /* 113930 */     GIR_EraseRootFromParent_Done,
     /* 113931 */   // Label 2162: @113931
     /* 113931 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(114004), // Rule ID 2402 //
     /* 113936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113955 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113976 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 113979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114002 */     GIR_RootConstrainSelectedInstOperands,
     /* 114003 */     // GIR_Coverage, 2402,
     /* 114003 */     GIR_EraseRootFromParent_Done,
     /* 114004 */   // Label 2163: @114004
     /* 114004 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(114064), // Rule ID 625 //
     /* 114009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 114012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 114020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 114024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114040 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 114040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 114043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 114049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 114053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114062 */     GIR_RootConstrainSelectedInstOperands,
     /* 114063 */     // GIR_Coverage, 625,
     /* 114063 */     GIR_EraseRootFromParent_Done,
     /* 114064 */   // Label 2164: @114064
     /* 114064 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(114094), // Rule ID 663 //
     /* 114069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 114072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114076 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VNEGS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 114076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGS),
     /* 114079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114092 */     GIR_RootConstrainSelectedInstOperands,
     /* 114093 */     // GIR_Coverage, 663,
     /* 114093 */     GIR_EraseRootFromParent_Done,
     /* 114094 */   // Label 2165: @114094
     /* 114094 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(114246), // Rule ID 2705 //
     /* 114099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 114102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114106 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VNEGfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 114106 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 114109 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114113 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 114120 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 114123 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114127 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114132 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 114135 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114140 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 114143 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 114147 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114152 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 114155 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 114159 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 114162 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114167 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114172 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114177 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 114180 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114184 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114189 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 114192 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 114195 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 114206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114215 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114228 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 114235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114245 */     // GIR_Coverage, 2705,
     /* 114245 */     GIR_EraseRootFromParent_Done,
     /* 114246 */   // Label 2166: @114246
     /* 114246 */   GIM_Reject,
     /* 114247 */ // Label 2160: @114247
     /* 114247 */ GIM_Reject,
     /* 114248 */ // Label 2148: @114248
     /* 114248 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(114594),
     /* 114253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114260 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(114345), // Rule ID 2412 //
     /* 114265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114284 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114317 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114343 */     GIR_RootConstrainSelectedInstOperands,
     /* 114344 */     // GIR_Coverage, 2412,
     /* 114344 */     GIR_EraseRootFromParent_Done,
     /* 114345 */   // Label 2168: @114345
     /* 114345 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114430), // Rule ID 5720 //
     /* 114350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114369 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114402 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dm
     /* 114419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114428 */     GIR_RootConstrainSelectedInstOperands,
     /* 114429 */     // GIR_Coverage, 5720,
     /* 114429 */     GIR_EraseRootFromParent_Done,
     /* 114430 */   // Label 2169: @114430
     /* 114430 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114503), // Rule ID 2401 //
     /* 114435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114454 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114475 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 114478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114501 */     GIR_RootConstrainSelectedInstOperands,
     /* 114502 */     // GIR_Coverage, 2401,
     /* 114502 */     GIR_EraseRootFromParent_Done,
     /* 114503 */   // Label 2170: @114503
     /* 114503 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114563), // Rule ID 624 //
     /* 114508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 114519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114539 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 114542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114561 */     GIR_RootConstrainSelectedInstOperands,
     /* 114562 */     // GIR_Coverage, 624,
     /* 114562 */     GIR_EraseRootFromParent_Done,
     /* 114563 */   // Label 2171: @114563
     /* 114563 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114593), // Rule ID 662 //
     /* 114568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114575 */     // (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VNEGD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 114575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGD),
     /* 114578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 114582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114591 */     GIR_RootConstrainSelectedInstOperands,
     /* 114592 */     // GIR_Coverage, 662,
     /* 114592 */     GIR_EraseRootFromParent_Done,
     /* 114593 */   // Label 2172: @114593
     /* 114593 */   GIM_Reject,
     /* 114594 */ // Label 2167: @114594
     /* 114594 */ GIM_Reject,
     /* 114595 */ // Label 2149: @114595
     /* 114595 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114632), // Rule ID 1530 //
     /* 114600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114614 */   // (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VNEGfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 114614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114619 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114624 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114630 */   GIR_RootConstrainSelectedInstOperands,
     /* 114631 */   // GIR_Coverage, 1530,
     /* 114631 */   GIR_EraseRootFromParent_Done,
     /* 114632 */ // Label 2173: @114632
     /* 114632 */ GIM_Reject,
     /* 114633 */ // Label 2150: @114633
     /* 114633 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114670), // Rule ID 1532 //
     /* 114638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114652 */   // (fneg:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VNEGhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 114652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhd),
     /* 114655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114657 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114662 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114668 */   GIR_RootConstrainSelectedInstOperands,
     /* 114669 */   // GIR_Coverage, 1532,
     /* 114669 */   GIR_EraseRootFromParent_Done,
     /* 114670 */ // Label 2174: @114670
     /* 114670 */ GIM_Reject,
     /* 114671 */ // Label 2151: @114671
     /* 114671 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114769),
     /* 114676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114679 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(114713), // Rule ID 1531 //
     /* 114684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114695 */     // (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VNEGf32q:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 114695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGf32q),
     /* 114698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114705 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114711 */     GIR_RootConstrainSelectedInstOperands,
     /* 114712 */     // GIR_Coverage, 1531,
     /* 114712 */     GIR_EraseRootFromParent_Done,
     /* 114713 */   // Label 2176: @114713
     /* 114713 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114768), // Rule ID 4116 //
     /* 114718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114729 */     // (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VNEGf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 114729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf32),
     /* 114744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114746 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114766 */     GIR_RootConstrainSelectedInstOperands,
     /* 114767 */     // GIR_Coverage, 4116,
     /* 114767 */     GIR_EraseRootFromParent_Done,
     /* 114768 */   // Label 2177: @114768
     /* 114768 */   GIM_Reject,
     /* 114769 */ // Label 2175: @114769
     /* 114769 */ GIM_Reject,
     /* 114770 */ // Label 2152: @114770
     /* 114770 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114868),
     /* 114775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114778 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114812), // Rule ID 1533 //
     /* 114783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114794 */     // (fneg:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VNEGhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 114794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhq),
     /* 114797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114810 */     GIR_RootConstrainSelectedInstOperands,
     /* 114811 */     // GIR_Coverage, 1533,
     /* 114811 */     GIR_EraseRootFromParent_Done,
     /* 114812 */   // Label 2179: @114812
     /* 114812 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(114867), // Rule ID 4114 //
     /* 114817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114828 */     // (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VNEGf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 114828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf16),
     /* 114843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114845 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114865 */     GIR_RootConstrainSelectedInstOperands,
     /* 114866 */     // GIR_Coverage, 4114,
     /* 114866 */     GIR_EraseRootFromParent_Done,
     /* 114867 */   // Label 2180: @114867
     /* 114867 */   GIM_Reject,
     /* 114868 */ // Label 2178: @114868
     /* 114868 */ GIM_Reject,
     /* 114869 */ // Label 2153: @114869
     /* 114869 */ GIM_Reject,
     /* 114870 */ // Label 40: @114870
     /* 114870 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 2184*/ GIMT_Encode4(115105),
     /* 114881 */ /*GILLT_s32*//*Label 2181*/ GIMT_Encode4(114913),
     /* 114885 */ /*GILLT_s64*//*Label 2182*/ GIMT_Encode4(114973), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114909 */ /*GILLT_v4s32*//*Label 2183*/ GIMT_Encode4(115070),
     /* 114913 */ // Label 2181: @114913
     /* 114913 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(114972), // Rule ID 2303 //
     /* 114918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114932 */   // (fpextend:{ *:[f32] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114944 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114948 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHS),
     /* 114956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114964 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114970 */   GIR_RootConstrainSelectedInstOperands,
     /* 114971 */   // GIR_Coverage, 2303,
     /* 114971 */   GIR_EraseRootFromParent_Done,
     /* 114972 */ // Label 2185: @114972
     /* 114972 */ GIM_Reject,
     /* 114973 */ // Label 2182: @114973
     /* 114973 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(115010), // Rule ID 660 //
     /* 114978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114992 */   // (fpextend:{ *:[f64] } SPR:{ *:[f32] }:$Sm)  =>  (VCVTDS:{ *:[f64] } SPR:{ *:[f32] }:$Sm)
     /* 114992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTDS),
     /* 114995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114997 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115002 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115008 */   GIR_RootConstrainSelectedInstOperands,
     /* 115009 */   // GIR_Coverage, 660,
     /* 115009 */   GIR_EraseRootFromParent_Done,
     /* 115010 */ // Label 2186: @115010
     /* 115010 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(115069), // Rule ID 2313 //
     /* 115015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115029 */   // (fpextend:{ *:[f64] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 115029 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115032 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115036 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115041 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 115045 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 115050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHD),
     /* 115053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 115055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115061 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115067 */   GIR_RootConstrainSelectedInstOperands,
     /* 115068 */   // GIR_Coverage, 2313,
     /* 115068 */   GIR_EraseRootFromParent_Done,
     /* 115069 */ // Label 2187: @115069
     /* 115069 */ GIM_Reject,
     /* 115070 */ // Label 2183: @115070
     /* 115070 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(115104), // Rule ID 2670 //
     /* 115075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115086 */   // (fpextend:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)
     /* 115086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /* 115089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115091 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115096 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115102 */   GIR_RootConstrainSelectedInstOperands,
     /* 115103 */   // GIR_Coverage, 2670,
     /* 115103 */   GIR_EraseRootFromParent_Done,
     /* 115104 */ // Label 2188: @115104
     /* 115104 */ GIM_Reject,
     /* 115105 */ // Label 2184: @115105
     /* 115105 */ GIM_Reject,
     /* 115106 */ // Label 41: @115106
     /* 115106 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2192*/ GIMT_Encode4(115377),
     /* 115117 */ /*GILLT_s16*//*Label 2189*/ GIMT_Encode4(115149),
     /* 115121 */ /*GILLT_s32*//*Label 2190*/ GIMT_Encode4(115304), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115145 */ /*GILLT_v4s16*//*Label 2191*/ GIMT_Encode4(115342),
     /* 115149 */ // Label 2189: @115149
     /* 115149 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(115226), // Rule ID 2305 //
     /* 115154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 115157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115168 */   // (fpround:{ *:[f16] } SPR:{ *:[f32] }:$Sm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBSH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), SPR:{ *:[f32] }:$Sm), HPR:{ *:[i32] })
     /* 115168 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115171 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115175 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115182 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115185 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBSH),
     /* 115189 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115194 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115197 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 115201 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115204 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115220 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115225 */   // GIR_Coverage, 2305,
     /* 115225 */   GIR_EraseRootFromParent_Done,
     /* 115226 */ // Label 2193: @115226
     /* 115226 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(115303), // Rule ID 2315 //
     /* 115231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115245 */   // (fpround:{ *:[f16] } DPR:{ *:[f64] }:$Dm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBDH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), DPR:{ *:[f64] }:$Dm), HPR:{ *:[i32] })
     /* 115245 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115248 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115252 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115259 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115262 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBDH),
     /* 115266 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115271 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115274 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Dm
     /* 115278 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115281 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115302 */   // GIR_Coverage, 2315,
     /* 115302 */   GIR_EraseRootFromParent_Done,
     /* 115303 */ // Label 2194: @115303
     /* 115303 */ GIM_Reject,
     /* 115304 */ // Label 2190: @115304
     /* 115304 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(115341), // Rule ID 661 //
     /* 115309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115323 */   // (fpround:{ *:[f32] } DPR:{ *:[f64] }:$Dm)  =>  (VCVTSD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /* 115323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTSD),
     /* 115326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 115328 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 115330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115333 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115339 */   GIR_RootConstrainSelectedInstOperands,
     /* 115340 */   // GIR_Coverage, 661,
     /* 115340 */   GIR_EraseRootFromParent_Done,
     /* 115341 */ // Label 2195: @115341
     /* 115341 */ GIM_Reject,
     /* 115342 */ // Label 2191: @115342
     /* 115342 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(115376), // Rule ID 2669 //
     /* 115347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115358 */   // (fpround:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)  =>  (VCVTf2h:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)
     /* 115358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /* 115361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115368 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115374 */   GIR_RootConstrainSelectedInstOperands,
     /* 115375 */   // GIR_Coverage, 2669,
     /* 115375 */   GIR_EraseRootFromParent_Done,
     /* 115376 */ // Label 2196: @115376
     /* 115376 */ GIM_Reject,
     /* 115377 */ // Label 2192: @115377
     /* 115377 */ GIM_Reject,
     /* 115378 */ // Label 42: @115378
     /* 115378 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2204*/ GIMT_Encode4(116711),
     /* 115389 */ /*GILLT_s32*//*Label 2197*/ GIMT_Encode4(115437), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115401 */ /*GILLT_v2s32*//*Label 2198*/ GIMT_Encode4(116331), GIMT_Encode4(0),
     /* 115409 */ /*GILLT_v4s1*//*Label 2199*/ GIMT_Encode4(116369),
     /* 115413 */ /*GILLT_v4s16*//*Label 2200*/ GIMT_Encode4(116422),
     /* 115417 */ /*GILLT_v4s32*//*Label 2201*/ GIMT_Encode4(116460), GIMT_Encode4(0),
     /* 115425 */ /*GILLT_v8s1*//*Label 2202*/ GIMT_Encode4(116559), GIMT_Encode4(0),
     /* 115433 */ /*GILLT_v8s16*//*Label 2203*/ GIMT_Encode4(116612),
     /* 115437 */ // Label 2197: @115437
     /* 115437 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(115503), // Rule ID 2323 //
     /* 115442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115452 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115456 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115460 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115464 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115471 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSH),
     /* 115478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115483 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115497 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115502 */   // GIR_Coverage, 2323,
     /* 115502 */   GIR_EraseRootFromParent_Done,
     /* 115503 */ // Label 2205: @115503
     /* 115503 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(115569), // Rule ID 2325 //
     /* 115508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115518 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115522 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115526 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115530 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115535 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115537 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSS),
     /* 115544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115549 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115563 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115568 */   // GIR_Coverage, 2325,
     /* 115568 */   GIR_EraseRootFromParent_Done,
     /* 115569 */ // Label 2206: @115569
     /* 115569 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(115635), // Rule ID 2327 //
     /* 115574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115584 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115592 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115596 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115603 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSD),
     /* 115610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115615 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115629 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115634 */   // GIR_Coverage, 2327,
     /* 115634 */   GIR_EraseRootFromParent_Done,
     /* 115635 */ // Label 2207: @115635
     /* 115635 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(115701), // Rule ID 2329 //
     /* 115640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115658 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115662 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115667 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115669 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSH),
     /* 115676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115681 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115700 */   // GIR_Coverage, 2329,
     /* 115700 */   GIR_EraseRootFromParent_Done,
     /* 115701 */ // Label 2208: @115701
     /* 115701 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(115767), // Rule ID 2331 //
     /* 115706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115716 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115720 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115724 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115728 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115735 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSS),
     /* 115742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115747 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115761 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115766 */   // GIR_Coverage, 2331,
     /* 115766 */   GIR_EraseRootFromParent_Done,
     /* 115767 */ // Label 2209: @115767
     /* 115767 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(115833), // Rule ID 2333 //
     /* 115772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115782 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115786 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115790 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115794 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115799 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115801 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSD),
     /* 115808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115813 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115824 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115832 */   // GIR_Coverage, 2333,
     /* 115832 */   GIR_EraseRootFromParent_Done,
     /* 115833 */ // Label 2210: @115833
     /* 115833 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(115899), // Rule ID 2317 //
     /* 115838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115856 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115860 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115865 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115867 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASH),
     /* 115874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115879 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115898 */   // GIR_Coverage, 2317,
     /* 115898 */   GIR_EraseRootFromParent_Done,
     /* 115899 */ // Label 2211: @115899
     /* 115899 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(115965), // Rule ID 2319 //
     /* 115904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115914 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115918 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115922 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115926 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115933 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASS),
     /* 115940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115945 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115959 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115964 */   // GIR_Coverage, 2319,
     /* 115964 */   GIR_EraseRootFromParent_Done,
     /* 115965 */ // Label 2212: @115965
     /* 115965 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(116031), // Rule ID 2321 //
     /* 115970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115988 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115992 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115999 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASD),
     /* 116006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116011 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116025 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116030 */   // GIR_Coverage, 2321,
     /* 116030 */   GIR_EraseRootFromParent_Done,
     /* 116031 */ // Label 2213: @116031
     /* 116031 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(116091), // Rule ID 2352 //
     /* 116036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 116039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116050 */   // (fp_to_sint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116050 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116053 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZD),
     /* 116057 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116062 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116066 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116069 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116090 */   // GIR_Coverage, 2352,
     /* 116090 */   GIR_EraseRootFromParent_Done,
     /* 116091 */ // Label 2214: @116091
     /* 116091 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(116151), // Rule ID 2356 //
     /* 116096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116110 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZS),
     /* 116117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116122 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116126 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116129 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116145 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116150 */   // GIR_Coverage, 2356,
     /* 116150 */   GIR_EraseRootFromParent_Done,
     /* 116151 */ // Label 2215: @116151
     /* 116151 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(116211), // Rule ID 2360 //
     /* 116156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116170 */   // (fp_to_sint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZH),
     /* 116177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116182 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116186 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116189 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116202 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116210 */   // GIR_Coverage, 2360,
     /* 116210 */   GIR_EraseRootFromParent_Done,
     /* 116211 */ // Label 2216: @116211
     /* 116211 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(116330), // Rule ID 2710 //
     /* 116216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 116219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116230 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2sd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 116230 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 116233 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116237 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116244 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 116247 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116251 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116256 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 116259 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116263 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 116266 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116271 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116276 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 116284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116293 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116296 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116299 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116312 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 116319 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116329 */   // GIR_Coverage, 2710,
     /* 116329 */   GIR_EraseRootFromParent_Done,
     /* 116330 */ // Label 2217: @116330
     /* 116330 */ GIM_Reject,
     /* 116331 */ // Label 2198: @116331
     /* 116331 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(116368), // Rule ID 1604 //
     /* 116336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116350 */   // (fp_to_sint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2sd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 116350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116355 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116360 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116366 */   GIR_RootConstrainSelectedInstOperands,
     /* 116367 */   // GIR_Coverage, 1604,
     /* 116367 */   GIR_EraseRootFromParent_Done,
     /* 116368 */ // Label 2218: @116368
     /* 116368 */ GIM_Reject,
     /* 116369 */ // Label 2199: @116369
     /* 116369 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(116421), // Rule ID 5105 //
     /* 116374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116388 */   // (fp_to_sint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 116391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116393 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116395 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116413 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116419 */   GIR_RootConstrainSelectedInstOperands,
     /* 116420 */   // GIR_Coverage, 5105,
     /* 116420 */   GIR_EraseRootFromParent_Done,
     /* 116421 */ // Label 2219: @116421
     /* 116421 */ GIM_Reject,
     /* 116422 */ // Label 2200: @116422
     /* 116422 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(116459), // Rule ID 1612 //
     /* 116427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116441 */   // (fp_to_sint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2sd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 116441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sd),
     /* 116444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116446 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116457 */   GIR_RootConstrainSelectedInstOperands,
     /* 116458 */   // GIR_Coverage, 1612,
     /* 116458 */   GIR_EraseRootFromParent_Done,
     /* 116459 */ // Label 2220: @116459
     /* 116459 */ GIM_Reject,
     /* 116460 */ // Label 2201: @116460
     /* 116460 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(116558),
     /* 116465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116468 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(116502), // Rule ID 1608 //
     /* 116473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116484 */     // (fp_to_sint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2sq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 116484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sq),
     /* 116487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116500 */     GIR_RootConstrainSelectedInstOperands,
     /* 116501 */     // GIR_Coverage, 1608,
     /* 116501 */     GIR_EraseRootFromParent_Done,
     /* 116502 */   // Label 2222: @116502
     /* 116502 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(116557), // Rule ID 4094 //
     /* 116507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116518 */     // (fp_to_sint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTs32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 116518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32z),
     /* 116533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116555 */     GIR_RootConstrainSelectedInstOperands,
     /* 116556 */     // GIR_Coverage, 4094,
     /* 116556 */     GIR_EraseRootFromParent_Done,
     /* 116557 */   // Label 2223: @116557
     /* 116557 */   GIM_Reject,
     /* 116558 */ // Label 2221: @116558
     /* 116558 */ GIM_Reject,
     /* 116559 */ // Label 2202: @116559
     /* 116559 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(116611), // Rule ID 5106 //
     /* 116564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116578 */   // (fp_to_sint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 116581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116583 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116585 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116597 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116603 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116609 */   GIR_RootConstrainSelectedInstOperands,
     /* 116610 */   // GIR_Coverage, 5106,
     /* 116610 */   GIR_EraseRootFromParent_Done,
     /* 116611 */ // Label 2224: @116611
     /* 116611 */ GIM_Reject,
     /* 116612 */ // Label 2203: @116612
     /* 116612 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(116710),
     /* 116617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116620 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(116654), // Rule ID 1616 //
     /* 116625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116636 */     // (fp_to_sint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2sq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 116636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sq),
     /* 116639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116652 */     GIR_RootConstrainSelectedInstOperands,
     /* 116653 */     // GIR_Coverage, 1616,
     /* 116653 */     GIR_EraseRootFromParent_Done,
     /* 116654 */   // Label 2226: @116654
     /* 116654 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(116709), // Rule ID 4090 //
     /* 116659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116670 */     // (fp_to_sint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTs16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 116670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16z),
     /* 116685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116707 */     GIR_RootConstrainSelectedInstOperands,
     /* 116708 */     // GIR_Coverage, 4090,
     /* 116708 */     GIR_EraseRootFromParent_Done,
     /* 116709 */   // Label 2227: @116709
     /* 116709 */   GIM_Reject,
     /* 116710 */ // Label 2225: @116710
     /* 116710 */ GIM_Reject,
     /* 116711 */ // Label 2204: @116711
     /* 116711 */ GIM_Reject,
     /* 116712 */ // Label 43: @116712
     /* 116712 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2235*/ GIMT_Encode4(118045),
     /* 116723 */ /*GILLT_s32*//*Label 2228*/ GIMT_Encode4(116771), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116735 */ /*GILLT_v2s32*//*Label 2229*/ GIMT_Encode4(117665), GIMT_Encode4(0),
     /* 116743 */ /*GILLT_v4s1*//*Label 2230*/ GIMT_Encode4(117703),
     /* 116747 */ /*GILLT_v4s16*//*Label 2231*/ GIMT_Encode4(117756),
     /* 116751 */ /*GILLT_v4s32*//*Label 2232*/ GIMT_Encode4(117794), GIMT_Encode4(0),
     /* 116759 */ /*GILLT_v8s1*//*Label 2233*/ GIMT_Encode4(117893), GIMT_Encode4(0),
     /* 116767 */ /*GILLT_v8s16*//*Label 2234*/ GIMT_Encode4(117946),
     /* 116771 */ // Label 2228: @116771
     /* 116771 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(116837), // Rule ID 2324 //
     /* 116776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116786 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116790 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116794 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116798 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116805 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUH),
     /* 116812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116817 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116828 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116831 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116836 */   // GIR_Coverage, 2324,
     /* 116836 */   GIR_EraseRootFromParent_Done,
     /* 116837 */ // Label 2236: @116837
     /* 116837 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(116903), // Rule ID 2326 //
     /* 116842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116860 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116864 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116869 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116871 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116871 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116874 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUS),
     /* 116878 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116883 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116897 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116902 */   // GIR_Coverage, 2326,
     /* 116902 */   GIR_EraseRootFromParent_Done,
     /* 116903 */ // Label 2237: @116903
     /* 116903 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(116969), // Rule ID 2328 //
     /* 116908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116918 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116922 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116926 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116930 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116937 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116937 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116940 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUD),
     /* 116944 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116949 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116968 */   // GIR_Coverage, 2328,
     /* 116968 */   GIR_EraseRootFromParent_Done,
     /* 116969 */ // Label 2238: @116969
     /* 116969 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(117035), // Rule ID 2330 //
     /* 116974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116984 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116988 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116992 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116996 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117001 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117003 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUH),
     /* 117010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117015 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117026 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117029 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117034 */   // GIR_Coverage, 2330,
     /* 117034 */   GIR_EraseRootFromParent_Done,
     /* 117035 */ // Label 2239: @117035
     /* 117035 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(117101), // Rule ID 2332 //
     /* 117040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117050 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117054 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 117058 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117062 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117069 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117069 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117072 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUS),
     /* 117076 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117081 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117095 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117100 */   // GIR_Coverage, 2332,
     /* 117100 */   GIR_EraseRootFromParent_Done,
     /* 117101 */ // Label 2240: @117101
     /* 117101 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(117167), // Rule ID 2334 //
     /* 117106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 117109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 117124 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117128 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117133 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117135 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUD),
     /* 117142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117147 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117166 */   // GIR_Coverage, 2334,
     /* 117166 */   GIR_EraseRootFromParent_Done,
     /* 117167 */ // Label 2241: @117167
     /* 117167 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(117233), // Rule ID 2318 //
     /* 117172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117182 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117190 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 117194 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117199 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117201 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUH),
     /* 117208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117213 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117232 */   // GIR_Coverage, 2318,
     /* 117232 */   GIR_EraseRootFromParent_Done,
     /* 117233 */ // Label 2242: @117233
     /* 117233 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(117299), // Rule ID 2320 //
     /* 117238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117256 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117260 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117265 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117267 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117267 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117270 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUS),
     /* 117274 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117279 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117290 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117293 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117298 */   // GIR_Coverage, 2320,
     /* 117298 */   GIR_EraseRootFromParent_Done,
     /* 117299 */ // Label 2243: @117299
     /* 117299 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(117365), // Rule ID 2322 //
     /* 117304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 117307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117314 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117318 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117322 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117326 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117331 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117333 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUD),
     /* 117340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117345 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117356 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117364 */   // GIR_Coverage, 2322,
     /* 117364 */   GIR_EraseRootFromParent_Done,
     /* 117365 */ // Label 2244: @117365
     /* 117365 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(117425), // Rule ID 2362 //
     /* 117370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 117373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117384 */   // (fp_to_uint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZD),
     /* 117391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117396 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117400 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117403 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117424 */   // GIR_Coverage, 2362,
     /* 117424 */   GIR_EraseRootFromParent_Done,
     /* 117425 */ // Label 2245: @117425
     /* 117425 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(117485), // Rule ID 2366 //
     /* 117430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117444 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117444 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117447 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZS),
     /* 117451 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117456 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117460 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117463 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117484 */   // GIR_Coverage, 2366,
     /* 117484 */   GIR_EraseRootFromParent_Done,
     /* 117485 */ // Label 2246: @117485
     /* 117485 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(117545), // Rule ID 2370 //
     /* 117490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117504 */   // (fp_to_uint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZH),
     /* 117511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117516 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117520 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117523 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117536 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117544 */   // GIR_Coverage, 2370,
     /* 117544 */   GIR_EraseRootFromParent_Done,
     /* 117545 */ // Label 2247: @117545
     /* 117545 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(117664), // Rule ID 2711 //
     /* 117550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117564 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2ud:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117564 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117567 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117571 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117578 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117581 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117585 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117590 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117593 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117597 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117600 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117605 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117610 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117615 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117618 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117622 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117627 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117630 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117633 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117646 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117663 */   // GIR_Coverage, 2711,
     /* 117663 */   GIR_EraseRootFromParent_Done,
     /* 117664 */ // Label 2248: @117664
     /* 117664 */ GIM_Reject,
     /* 117665 */ // Label 2229: @117665
     /* 117665 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(117702), // Rule ID 1605 //
     /* 117670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117684 */   // (fp_to_uint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2ud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 117684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117689 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117694 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117700 */   GIR_RootConstrainSelectedInstOperands,
     /* 117701 */   // GIR_Coverage, 1605,
     /* 117701 */   GIR_EraseRootFromParent_Done,
     /* 117702 */ // Label 2249: @117702
     /* 117702 */ GIM_Reject,
     /* 117703 */ // Label 2230: @117703
     /* 117703 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(117755), // Rule ID 5103 //
     /* 117708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117722 */   // (fp_to_uint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 117725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117727 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117729 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117741 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117753 */   GIR_RootConstrainSelectedInstOperands,
     /* 117754 */   // GIR_Coverage, 5103,
     /* 117754 */   GIR_EraseRootFromParent_Done,
     /* 117755 */ // Label 2250: @117755
     /* 117755 */ GIM_Reject,
     /* 117756 */ // Label 2231: @117756
     /* 117756 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(117793), // Rule ID 1613 //
     /* 117761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117775 */   // (fp_to_uint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2ud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 117775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2ud),
     /* 117778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117780 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117791 */   GIR_RootConstrainSelectedInstOperands,
     /* 117792 */   // GIR_Coverage, 1613,
     /* 117792 */   GIR_EraseRootFromParent_Done,
     /* 117793 */ // Label 2251: @117793
     /* 117793 */ GIM_Reject,
     /* 117794 */ // Label 2232: @117794
     /* 117794 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(117892),
     /* 117799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117802 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(117836), // Rule ID 1609 //
     /* 117807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117818 */     // (fp_to_uint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2uq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 117818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2uq),
     /* 117821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117834 */     GIR_RootConstrainSelectedInstOperands,
     /* 117835 */     // GIR_Coverage, 1609,
     /* 117835 */     GIR_EraseRootFromParent_Done,
     /* 117836 */   // Label 2253: @117836
     /* 117836 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(117891), // Rule ID 4096 //
     /* 117841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117852 */     // (fp_to_uint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTu32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 117852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32z),
     /* 117867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117869 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117889 */     GIR_RootConstrainSelectedInstOperands,
     /* 117890 */     // GIR_Coverage, 4096,
     /* 117890 */     GIR_EraseRootFromParent_Done,
     /* 117891 */   // Label 2254: @117891
     /* 117891 */   GIM_Reject,
     /* 117892 */ // Label 2252: @117892
     /* 117892 */ GIM_Reject,
     /* 117893 */ // Label 2233: @117893
     /* 117893 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(117945), // Rule ID 5104 //
     /* 117898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117912 */   // (fp_to_uint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 117915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117917 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117919 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117931 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117937 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117943 */   GIR_RootConstrainSelectedInstOperands,
     /* 117944 */   // GIR_Coverage, 5104,
     /* 117944 */   GIR_EraseRootFromParent_Done,
     /* 117945 */ // Label 2255: @117945
     /* 117945 */ GIM_Reject,
     /* 117946 */ // Label 2234: @117946
     /* 117946 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(118044),
     /* 117951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117954 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(117988), // Rule ID 1617 //
     /* 117959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117970 */     // (fp_to_uint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2uq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 117970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2uq),
     /* 117973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117986 */     GIR_RootConstrainSelectedInstOperands,
     /* 117987 */     // GIR_Coverage, 1617,
     /* 117987 */     GIR_EraseRootFromParent_Done,
     /* 117988 */   // Label 2257: @117988
     /* 117988 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(118043), // Rule ID 4092 //
     /* 117993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118004 */     // (fp_to_uint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTu16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 118004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16z),
     /* 118019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118041 */     GIR_RootConstrainSelectedInstOperands,
     /* 118042 */     // GIR_Coverage, 4092,
     /* 118042 */     GIR_EraseRootFromParent_Done,
     /* 118043 */   // Label 2258: @118043
     /* 118043 */   GIM_Reject,
     /* 118044 */ // Label 2256: @118044
     /* 118044 */ GIM_Reject,
     /* 118045 */ // Label 2235: @118045
     /* 118045 */ GIM_Reject,
     /* 118046 */ // Label 44: @118046
     /* 118046 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2266*/ GIMT_Encode4(118697),
     /* 118057 */ /*GILLT_s16*//*Label 2259*/ GIMT_Encode4(118109),
     /* 118061 */ /*GILLT_s32*//*Label 2260*/ GIMT_Encode4(118169),
     /* 118065 */ /*GILLT_s64*//*Label 2261*/ GIMT_Encode4(118363), GIMT_Encode4(0),
     /* 118073 */ /*GILLT_v2s32*//*Label 2262*/ GIMT_Encode4(118423), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118085 */ /*GILLT_v4s16*//*Label 2263*/ GIMT_Encode4(118461),
     /* 118089 */ /*GILLT_v4s32*//*Label 2264*/ GIMT_Encode4(118499), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118105 */ /*GILLT_v8s16*//*Label 2265*/ GIMT_Encode4(118598),
     /* 118109 */ // Label 2259: @118109
     /* 118109 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(118168), // Rule ID 2346 //
     /* 118114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118128 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VSITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118140 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118144 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOH),
     /* 118152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118160 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118166 */   GIR_RootConstrainSelectedInstOperands,
     /* 118167 */   // GIR_Coverage, 2346,
     /* 118167 */   GIR_EraseRootFromParent_Done,
     /* 118168 */ // Label 2267: @118168
     /* 118168 */ GIM_Reject,
     /* 118169 */ // Label 2260: @118169
     /* 118169 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(118362),
     /* 118174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118185 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(118233), // Rule ID 2344 //
     /* 118190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118193 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VSITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOS),
     /* 118217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118231 */     GIR_RootConstrainSelectedInstOperands,
     /* 118232 */     // GIR_Coverage, 2344,
     /* 118232 */     GIR_EraseRootFromParent_Done,
     /* 118233 */   // Label 2269: @118233
     /* 118233 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(118361), // Rule ID 2712 //
     /* 118238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118241 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTs2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118241 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118244 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118248 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118253 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118257 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118262 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118265 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118269 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118276 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118279 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118283 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118288 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118291 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118294 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118297 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118302 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118307 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118324 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118327 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118330 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118343 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118360 */     // GIR_Coverage, 2712,
     /* 118360 */     GIR_EraseRootFromParent_Done,
     /* 118361 */   // Label 2270: @118361
     /* 118361 */   GIM_Reject,
     /* 118362 */ // Label 2268: @118362
     /* 118362 */ GIM_Reject,
     /* 118363 */ // Label 2261: @118363
     /* 118363 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(118422), // Rule ID 2342 //
     /* 118368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118382 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VSITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118394 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118398 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOD),
     /* 118406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118420 */   GIR_RootConstrainSelectedInstOperands,
     /* 118421 */   // GIR_Coverage, 2342,
     /* 118421 */   GIR_EraseRootFromParent_Done,
     /* 118422 */ // Label 2271: @118422
     /* 118422 */ GIM_Reject,
     /* 118423 */ // Label 2262: @118423
     /* 118423 */ GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(118460), // Rule ID 1606 //
     /* 118428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118442 */   // (sint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118447 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118452 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118458 */   GIR_RootConstrainSelectedInstOperands,
     /* 118459 */   // GIR_Coverage, 1606,
     /* 118459 */   GIR_EraseRootFromParent_Done,
     /* 118460 */ // Label 2272: @118460
     /* 118460 */ GIM_Reject,
     /* 118461 */ // Label 2263: @118461
     /* 118461 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(118498), // Rule ID 1614 //
     /* 118466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118480 */   // (sint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hd),
     /* 118483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118485 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118496 */   GIR_RootConstrainSelectedInstOperands,
     /* 118497 */   // GIR_Coverage, 1614,
     /* 118497 */   GIR_EraseRootFromParent_Done,
     /* 118498 */ // Label 2273: @118498
     /* 118498 */ GIM_Reject,
     /* 118499 */ // Label 2264: @118499
     /* 118499 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(118597),
     /* 118504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118507 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(118541), // Rule ID 1610 //
     /* 118512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118523 */     // (sint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fq),
     /* 118526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118539 */     GIR_RootConstrainSelectedInstOperands,
     /* 118540 */     // GIR_Coverage, 1610,
     /* 118540 */     GIR_EraseRootFromParent_Done,
     /* 118541 */   // Label 2275: @118541
     /* 118541 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(118596), // Rule ID 4102 //
     /* 118546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118557 */     // (sint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32s32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32n),
     /* 118572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118574 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118594 */     GIR_RootConstrainSelectedInstOperands,
     /* 118595 */     // GIR_Coverage, 4102,
     /* 118595 */     GIR_EraseRootFromParent_Done,
     /* 118596 */   // Label 2276: @118596
     /* 118596 */   GIM_Reject,
     /* 118597 */ // Label 2274: @118597
     /* 118597 */ GIM_Reject,
     /* 118598 */ // Label 2265: @118598
     /* 118598 */ GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(118696),
     /* 118603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118606 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(118640), // Rule ID 1618 //
     /* 118611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118622 */     // (sint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hq),
     /* 118625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118638 */     GIR_RootConstrainSelectedInstOperands,
     /* 118639 */     // GIR_Coverage, 1618,
     /* 118639 */     GIR_EraseRootFromParent_Done,
     /* 118640 */   // Label 2278: @118640
     /* 118640 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(118695), // Rule ID 4098 //
     /* 118645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118656 */     // (sint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16s16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16n),
     /* 118671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118673 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118693 */     GIR_RootConstrainSelectedInstOperands,
     /* 118694 */     // GIR_Coverage, 4098,
     /* 118694 */     GIR_EraseRootFromParent_Done,
     /* 118695 */   // Label 2279: @118695
     /* 118695 */   GIM_Reject,
     /* 118696 */ // Label 2277: @118696
     /* 118696 */ GIM_Reject,
     /* 118697 */ // Label 2266: @118697
     /* 118697 */ GIM_Reject,
     /* 118698 */ // Label 45: @118698
     /* 118698 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2287*/ GIMT_Encode4(119349),
     /* 118709 */ /*GILLT_s16*//*Label 2280*/ GIMT_Encode4(118761),
     /* 118713 */ /*GILLT_s32*//*Label 2281*/ GIMT_Encode4(118821),
     /* 118717 */ /*GILLT_s64*//*Label 2282*/ GIMT_Encode4(119015), GIMT_Encode4(0),
     /* 118725 */ /*GILLT_v2s32*//*Label 2283*/ GIMT_Encode4(119075), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118737 */ /*GILLT_v4s16*//*Label 2284*/ GIMT_Encode4(119113),
     /* 118741 */ /*GILLT_v4s32*//*Label 2285*/ GIMT_Encode4(119151), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118757 */ /*GILLT_v8s16*//*Label 2286*/ GIMT_Encode4(119250),
     /* 118761 */ // Label 2280: @118761
     /* 118761 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(118820), // Rule ID 2351 //
     /* 118766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118780 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VUITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118792 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118796 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOH),
     /* 118804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118806 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118812 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118818 */   GIR_RootConstrainSelectedInstOperands,
     /* 118819 */   // GIR_Coverage, 2351,
     /* 118819 */   GIR_EraseRootFromParent_Done,
     /* 118820 */ // Label 2288: @118820
     /* 118820 */ GIM_Reject,
     /* 118821 */ // Label 2281: @118821
     /* 118821 */ GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(119014),
     /* 118826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118837 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(118885), // Rule ID 2349 //
     /* 118842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118845 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VUITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOS),
     /* 118869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118883 */     GIR_RootConstrainSelectedInstOperands,
     /* 118884 */     // GIR_Coverage, 2349,
     /* 118884 */     GIR_EraseRootFromParent_Done,
     /* 118885 */   // Label 2290: @118885
     /* 118885 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(119013), // Rule ID 2713 //
     /* 118890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118893 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTu2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118893 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118896 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118900 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118905 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118909 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118914 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118917 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118921 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118928 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118931 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118935 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118940 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118943 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118946 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118949 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118954 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118976 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118979 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118982 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118995 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119012 */     // GIR_Coverage, 2713,
     /* 119012 */     GIR_EraseRootFromParent_Done,
     /* 119013 */   // Label 2291: @119013
     /* 119013 */   GIM_Reject,
     /* 119014 */ // Label 2289: @119014
     /* 119014 */ GIM_Reject,
     /* 119015 */ // Label 2282: @119015
     /* 119015 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(119074), // Rule ID 2347 //
     /* 119020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 119034 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VUITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 119034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119046 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 119050 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOD),
     /* 119058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119060 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119072 */   GIR_RootConstrainSelectedInstOperands,
     /* 119073 */   // GIR_Coverage, 2347,
     /* 119073 */   GIR_EraseRootFromParent_Done,
     /* 119074 */ // Label 2292: @119074
     /* 119074 */ GIM_Reject,
     /* 119075 */ // Label 2283: @119075
     /* 119075 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(119112), // Rule ID 1607 //
     /* 119080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119094 */   // (uint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 119094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 119097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119099 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119104 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119110 */   GIR_RootConstrainSelectedInstOperands,
     /* 119111 */   // GIR_Coverage, 1607,
     /* 119111 */   GIR_EraseRootFromParent_Done,
     /* 119112 */ // Label 2293: @119112
     /* 119112 */ GIM_Reject,
     /* 119113 */ // Label 2284: @119113
     /* 119113 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(119150), // Rule ID 1615 //
     /* 119118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119132 */   // (uint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 119132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hd),
     /* 119135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119137 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119148 */   GIR_RootConstrainSelectedInstOperands,
     /* 119149 */   // GIR_Coverage, 1615,
     /* 119149 */   GIR_EraseRootFromParent_Done,
     /* 119150 */ // Label 2294: @119150
     /* 119150 */ GIM_Reject,
     /* 119151 */ // Label 2285: @119151
     /* 119151 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(119249),
     /* 119156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119159 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(119193), // Rule ID 1611 //
     /* 119164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119175 */     // (uint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 119175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fq),
     /* 119178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119191 */     GIR_RootConstrainSelectedInstOperands,
     /* 119192 */     // GIR_Coverage, 1611,
     /* 119192 */     GIR_EraseRootFromParent_Done,
     /* 119193 */   // Label 2296: @119193
     /* 119193 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(119248), // Rule ID 4104 //
     /* 119198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119209 */     // (uint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32u32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 119209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32n),
     /* 119224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119246 */     GIR_RootConstrainSelectedInstOperands,
     /* 119247 */     // GIR_Coverage, 4104,
     /* 119247 */     GIR_EraseRootFromParent_Done,
     /* 119248 */   // Label 2297: @119248
     /* 119248 */   GIM_Reject,
     /* 119249 */ // Label 2295: @119249
     /* 119249 */ GIM_Reject,
     /* 119250 */ // Label 2286: @119250
     /* 119250 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(119348),
     /* 119255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119258 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(119292), // Rule ID 1619 //
     /* 119263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119274 */     // (uint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 119274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hq),
     /* 119277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119290 */     GIR_RootConstrainSelectedInstOperands,
     /* 119291 */     // GIR_Coverage, 1619,
     /* 119291 */     GIR_EraseRootFromParent_Done,
     /* 119292 */   // Label 2299: @119292
     /* 119292 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(119347), // Rule ID 4100 //
     /* 119297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119308 */     // (uint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16u16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 119308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16n),
     /* 119323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119345 */     GIR_RootConstrainSelectedInstOperands,
     /* 119346 */     // GIR_Coverage, 4100,
     /* 119346 */     GIR_EraseRootFromParent_Done,
     /* 119347 */   // Label 2300: @119347
     /* 119347 */   GIM_Reject,
     /* 119348 */ // Label 2298: @119348
     /* 119348 */ GIM_Reject,
     /* 119349 */ // Label 2287: @119349
     /* 119349 */ GIM_Reject,
     /* 119350 */ // Label 46: @119350
     /* 119350 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2308*/ GIMT_Encode4(120125),
     /* 119361 */ /*GILLT_s16*//*Label 2301*/ GIMT_Encode4(119413),
     /* 119365 */ /*GILLT_s32*//*Label 2302*/ GIMT_Encode4(119451),
     /* 119369 */ /*GILLT_s64*//*Label 2303*/ GIMT_Encode4(119643), GIMT_Encode4(0),
     /* 119377 */ /*GILLT_v2s32*//*Label 2304*/ GIMT_Encode4(119681), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119389 */ /*GILLT_v4s16*//*Label 2305*/ GIMT_Encode4(119719),
     /* 119393 */ /*GILLT_v4s32*//*Label 2306*/ GIMT_Encode4(119757), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119409 */ /*GILLT_v8s16*//*Label 2307*/ GIMT_Encode4(119941),
     /* 119413 */ // Label 2301: @119413
     /* 119413 */ GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(119450), // Rule ID 653 //
     /* 119418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119432 */   // (fabs:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VABSH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 119432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSH),
     /* 119435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119437 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119442 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119448 */   GIR_RootConstrainSelectedInstOperands,
     /* 119449 */   // GIR_Coverage, 653,
     /* 119449 */   GIR_EraseRootFromParent_Done,
     /* 119450 */ // Label 2309: @119450
     /* 119450 */ GIM_Reject,
     /* 119451 */ // Label 2302: @119451
     /* 119451 */ GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(119642),
     /* 119456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119467 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(119493), // Rule ID 652 //
     /* 119472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 119475 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VABSS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 119475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSS),
     /* 119478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119491 */     GIR_RootConstrainSelectedInstOperands,
     /* 119492 */     // GIR_Coverage, 652,
     /* 119492 */     GIR_EraseRootFromParent_Done,
     /* 119493 */   // Label 2311: @119493
     /* 119493 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(119641), // Rule ID 2704 //
     /* 119498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 119501 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VABSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 119501 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 119504 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119508 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 119515 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 119518 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119522 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119527 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 119530 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119535 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 119538 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119542 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119547 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 119550 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 119554 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 119557 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119562 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119567 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119572 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119575 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119579 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119584 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 119587 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 119590 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 119601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119610 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119623 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119640 */     // GIR_Coverage, 2704,
     /* 119640 */     GIR_EraseRootFromParent_Done,
     /* 119641 */   // Label 2312: @119641
     /* 119641 */   GIM_Reject,
     /* 119642 */ // Label 2310: @119642
     /* 119642 */ GIM_Reject,
     /* 119643 */ // Label 2303: @119643
     /* 119643 */ GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(119680), // Rule ID 651 //
     /* 119648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119662 */   // (fabs:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VABSD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 119662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSD),
     /* 119665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 119669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119678 */   GIR_RootConstrainSelectedInstOperands,
     /* 119679 */   // GIR_Coverage, 651,
     /* 119679 */   GIR_EraseRootFromParent_Done,
     /* 119680 */ // Label 2313: @119680
     /* 119680 */ GIM_Reject,
     /* 119681 */ // Label 2304: @119681
     /* 119681 */ GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(119718), // Rule ID 1514 //
     /* 119686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119700 */   // (fabs:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VABSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 119700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119716 */   GIR_RootConstrainSelectedInstOperands,
     /* 119717 */   // GIR_Coverage, 1514,
     /* 119717 */   GIR_EraseRootFromParent_Done,
     /* 119718 */ // Label 2314: @119718
     /* 119718 */ GIM_Reject,
     /* 119719 */ // Label 2305: @119719
     /* 119719 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(119756), // Rule ID 1516 //
     /* 119724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119738 */   // (fabs:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VABShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 119738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShd),
     /* 119741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119743 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119754 */   GIR_RootConstrainSelectedInstOperands,
     /* 119755 */   // GIR_Coverage, 1516,
     /* 119755 */   GIR_EraseRootFromParent_Done,
     /* 119756 */ // Label 2315: @119756
     /* 119756 */ GIM_Reject,
     /* 119757 */ // Label 2306: @119757
     /* 119757 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(119940),
     /* 119762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119765 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(119850), // Rule ID 4041 //
     /* 119770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119805 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn))  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /* 119820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119848 */     GIR_RootConstrainSelectedInstOperands,
     /* 119849 */     // GIR_Coverage, 4041,
     /* 119849 */     GIR_EraseRootFromParent_Done,
     /* 119850 */   // Label 2317: @119850
     /* 119850 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(119884), // Rule ID 1515 //
     /* 119855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119866 */     // (fabs:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VABSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 119866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfq),
     /* 119869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119876 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119882 */     GIR_RootConstrainSelectedInstOperands,
     /* 119883 */     // GIR_Coverage, 1515,
     /* 119883 */     GIR_EraseRootFromParent_Done,
     /* 119884 */   // Label 2318: @119884
     /* 119884 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(119939), // Rule ID 4112 //
     /* 119889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119900 */     // (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VABSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 119900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf32),
     /* 119915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119917 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119937 */     GIR_RootConstrainSelectedInstOperands,
     /* 119938 */     // GIR_Coverage, 4112,
     /* 119938 */     GIR_EraseRootFromParent_Done,
     /* 119939 */   // Label 2319: @119939
     /* 119939 */   GIM_Reject,
     /* 119940 */ // Label 2316: @119940
     /* 119940 */ GIM_Reject,
     /* 119941 */ // Label 2307: @119941
     /* 119941 */ GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(120124),
     /* 119946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119949 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(120034), // Rule ID 4040 //
     /* 119954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119989 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn))  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 119989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /* 120004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 120010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 120014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120032 */     GIR_RootConstrainSelectedInstOperands,
     /* 120033 */     // GIR_Coverage, 4040,
     /* 120033 */     GIR_EraseRootFromParent_Done,
     /* 120034 */   // Label 2321: @120034
     /* 120034 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(120068), // Rule ID 1517 //
     /* 120039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 120042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120050 */     // (fabs:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VABShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 120050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShq),
     /* 120053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 120055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 120057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 120060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120066 */     GIR_RootConstrainSelectedInstOperands,
     /* 120067 */     // GIR_Coverage, 1517,
     /* 120067 */     GIR_EraseRootFromParent_Done,
     /* 120068 */   // Label 2322: @120068
     /* 120068 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(120123), // Rule ID 4110 //
     /* 120073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120084 */     // (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VABSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 120084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf16),
     /* 120099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120101 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 120103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120121 */     GIR_RootConstrainSelectedInstOperands,
     /* 120122 */     // GIR_Coverage, 4110,
     /* 120122 */     GIR_EraseRootFromParent_Done,
     /* 120123 */   // Label 2323: @120123
     /* 120123 */   GIM_Reject,
     /* 120124 */ // Label 2320: @120124
     /* 120124 */ GIM_Reject,
     /* 120125 */ // Label 2308: @120125
     /* 120125 */ GIM_Reject,
     /* 120126 */ // Label 47: @120126
     /* 120126 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2331*/ GIMT_Encode4(120717),
     /* 120137 */ /*GILLT_s16*//*Label 2324*/ GIMT_Encode4(120189),
     /* 120141 */ /*GILLT_s32*//*Label 2325*/ GIMT_Encode4(120223),
     /* 120145 */ /*GILLT_s64*//*Label 2326*/ GIMT_Encode4(120257), GIMT_Encode4(0),
     /* 120153 */ /*GILLT_v2s32*//*Label 2327*/ GIMT_Encode4(120291), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120165 */ /*GILLT_v4s16*//*Label 2328*/ GIMT_Encode4(120325),
     /* 120169 */ /*GILLT_v4s32*//*Label 2329*/ GIMT_Encode4(120359), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120185 */ /*GILLT_v8s16*//*Label 2330*/ GIMT_Encode4(120538),
     /* 120189 */ // Label 2324: @120189
     /* 120189 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(120222), // Rule ID 642 //
     /* 120194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120215 */   // (fminnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMINNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMH),
     /* 120220 */   GIR_RootConstrainSelectedInstOperands,
     /* 120221 */   // GIR_Coverage, 642,
     /* 120221 */   GIR_Done,
     /* 120222 */ // Label 2332: @120222
     /* 120222 */ GIM_Reject,
     /* 120223 */ // Label 2325: @120223
     /* 120223 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(120256), // Rule ID 643 //
     /* 120228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120249 */   // (fminnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMINNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMS),
     /* 120254 */   GIR_RootConstrainSelectedInstOperands,
     /* 120255 */   // GIR_Coverage, 643,
     /* 120255 */   GIR_Done,
     /* 120256 */ // Label 2333: @120256
     /* 120256 */ GIM_Reject,
     /* 120257 */ // Label 2326: @120257
     /* 120257 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(120290), // Rule ID 644 //
     /* 120262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120283 */   // (fminnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMINNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMD),
     /* 120288 */   GIR_RootConstrainSelectedInstOperands,
     /* 120289 */   // GIR_Coverage, 644,
     /* 120289 */   GIR_Done,
     /* 120290 */ // Label 2334: @120290
     /* 120290 */ GIM_Reject,
     /* 120291 */ // Label 2327: @120291
     /* 120291 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(120324), // Rule ID 1233 //
     /* 120296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120317 */   // (fminnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMINNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDf),
     /* 120322 */   GIR_RootConstrainSelectedInstOperands,
     /* 120323 */   // GIR_Coverage, 1233,
     /* 120323 */   GIR_Done,
     /* 120324 */ // Label 2335: @120324
     /* 120324 */ GIM_Reject,
     /* 120325 */ // Label 2328: @120325
     /* 120325 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(120358), // Rule ID 1235 //
     /* 120330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120351 */   // (fminnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMINNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDh),
     /* 120356 */   GIR_RootConstrainSelectedInstOperands,
     /* 120357 */   // GIR_Coverage, 1235,
     /* 120357 */   GIR_Done,
     /* 120358 */ // Label 2336: @120358
     /* 120358 */ GIM_Reject,
     /* 120359 */ // Label 2329: @120359
     /* 120359 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(120537),
     /* 120364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120370 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(120448), // Rule ID 4122 //
     /* 120375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120418 */     // (fminnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMINNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf32),
     /* 120421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120446 */     GIR_RootConstrainSelectedInstOperands,
     /* 120447 */     // GIR_Coverage, 4122,
     /* 120447 */     GIR_EraseRootFromParent_Done,
     /* 120448 */   // Label 2338: @120448
     /* 120448 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(120475), // Rule ID 1234 //
     /* 120453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120468 */     // (fminnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMINNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQf),
     /* 120473 */     GIR_RootConstrainSelectedInstOperands,
     /* 120474 */     // GIR_Coverage, 1234,
     /* 120474 */     GIR_Done,
     /* 120475 */   // Label 2339: @120475
     /* 120475 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(120536), // Rule ID 3288 //
     /* 120480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120495 */     // (fminnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMINNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf32),
     /* 120510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120534 */     GIR_RootConstrainSelectedInstOperands,
     /* 120535 */     // GIR_Coverage, 3288,
     /* 120535 */     GIR_EraseRootFromParent_Done,
     /* 120536 */   // Label 2340: @120536
     /* 120536 */   GIM_Reject,
     /* 120537 */ // Label 2337: @120537
     /* 120537 */ GIM_Reject,
     /* 120538 */ // Label 2330: @120538
     /* 120538 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(120716),
     /* 120543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120549 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(120627), // Rule ID 4124 //
     /* 120554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120597 */     // (fminnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMINNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf16),
     /* 120600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120625 */     GIR_RootConstrainSelectedInstOperands,
     /* 120626 */     // GIR_Coverage, 4124,
     /* 120626 */     GIR_EraseRootFromParent_Done,
     /* 120627 */   // Label 2342: @120627
     /* 120627 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(120654), // Rule ID 1236 //
     /* 120632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120647 */     // (fminnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMINNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQh),
     /* 120652 */     GIR_RootConstrainSelectedInstOperands,
     /* 120653 */     // GIR_Coverage, 1236,
     /* 120653 */     GIR_Done,
     /* 120654 */   // Label 2343: @120654
     /* 120654 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(120715), // Rule ID 3291 //
     /* 120659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120674 */     // (fminnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMINNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf16),
     /* 120689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120713 */     GIR_RootConstrainSelectedInstOperands,
     /* 120714 */     // GIR_Coverage, 3291,
     /* 120714 */     GIR_EraseRootFromParent_Done,
     /* 120715 */   // Label 2344: @120715
     /* 120715 */   GIM_Reject,
     /* 120716 */ // Label 2341: @120716
     /* 120716 */ GIM_Reject,
     /* 120717 */ // Label 2331: @120717
     /* 120717 */ GIM_Reject,
     /* 120718 */ // Label 48: @120718
     /* 120718 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2352*/ GIMT_Encode4(121309),
     /* 120729 */ /*GILLT_s16*//*Label 2345*/ GIMT_Encode4(120781),
     /* 120733 */ /*GILLT_s32*//*Label 2346*/ GIMT_Encode4(120815),
     /* 120737 */ /*GILLT_s64*//*Label 2347*/ GIMT_Encode4(120849), GIMT_Encode4(0),
     /* 120745 */ /*GILLT_v2s32*//*Label 2348*/ GIMT_Encode4(120883), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120757 */ /*GILLT_v4s16*//*Label 2349*/ GIMT_Encode4(120917),
     /* 120761 */ /*GILLT_v4s32*//*Label 2350*/ GIMT_Encode4(120951), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120777 */ /*GILLT_v8s16*//*Label 2351*/ GIMT_Encode4(121130),
     /* 120781 */ // Label 2345: @120781
     /* 120781 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(120814), // Rule ID 639 //
     /* 120786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120807 */   // (fmaxnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMAXNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMH),
     /* 120812 */   GIR_RootConstrainSelectedInstOperands,
     /* 120813 */   // GIR_Coverage, 639,
     /* 120813 */   GIR_Done,
     /* 120814 */ // Label 2353: @120814
     /* 120814 */ GIM_Reject,
     /* 120815 */ // Label 2346: @120815
     /* 120815 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(120848), // Rule ID 640 //
     /* 120820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120837 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120841 */   // (fmaxnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMAXNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMS),
     /* 120846 */   GIR_RootConstrainSelectedInstOperands,
     /* 120847 */   // GIR_Coverage, 640,
     /* 120847 */   GIR_Done,
     /* 120848 */ // Label 2354: @120848
     /* 120848 */ GIM_Reject,
     /* 120849 */ // Label 2347: @120849
     /* 120849 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(120882), // Rule ID 641 //
     /* 120854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120875 */   // (fmaxnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMAXNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120875 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMD),
     /* 120880 */   GIR_RootConstrainSelectedInstOperands,
     /* 120881 */   // GIR_Coverage, 641,
     /* 120881 */   GIR_Done,
     /* 120882 */ // Label 2355: @120882
     /* 120882 */ GIM_Reject,
     /* 120883 */ // Label 2348: @120883
     /* 120883 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(120916), // Rule ID 1213 //
     /* 120888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120909 */   // (fmaxnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMAXNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDf),
     /* 120914 */   GIR_RootConstrainSelectedInstOperands,
     /* 120915 */   // GIR_Coverage, 1213,
     /* 120915 */   GIR_Done,
     /* 120916 */ // Label 2356: @120916
     /* 120916 */ GIM_Reject,
     /* 120917 */ // Label 2349: @120917
     /* 120917 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(120950), // Rule ID 1215 //
     /* 120922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120943 */   // (fmaxnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMAXNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120943 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDh),
     /* 120948 */   GIR_RootConstrainSelectedInstOperands,
     /* 120949 */   // GIR_Coverage, 1215,
     /* 120949 */   GIR_Done,
     /* 120950 */ // Label 2357: @120950
     /* 120950 */ GIM_Reject,
     /* 120951 */ // Label 2350: @120951
     /* 120951 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(121129),
     /* 120956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120962 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(121040), // Rule ID 4118 //
     /* 120967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121010 */     // (fmaxnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMAXNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 121010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf32),
     /* 121013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 121019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 121023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121038 */     GIR_RootConstrainSelectedInstOperands,
     /* 121039 */     // GIR_Coverage, 4118,
     /* 121039 */     GIR_EraseRootFromParent_Done,
     /* 121040 */   // Label 2359: @121040
     /* 121040 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(121067), // Rule ID 1214 //
     /* 121045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 121048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121060 */     // (fmaxnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMAXNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQf),
     /* 121065 */     GIR_RootConstrainSelectedInstOperands,
     /* 121066 */     // GIR_Coverage, 1214,
     /* 121066 */     GIR_Done,
     /* 121067 */   // Label 2360: @121067
     /* 121067 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(121128), // Rule ID 3030 //
     /* 121072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 121075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121087 */     // (fmaxnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMAXNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 121087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 121090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf32),
     /* 121102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 121106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 121108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121126 */     GIR_RootConstrainSelectedInstOperands,
     /* 121127 */     // GIR_Coverage, 3030,
     /* 121127 */     GIR_EraseRootFromParent_Done,
     /* 121128 */   // Label 2361: @121128
     /* 121128 */   GIM_Reject,
     /* 121129 */ // Label 2358: @121129
     /* 121129 */ GIM_Reject,
     /* 121130 */ // Label 2351: @121130
     /* 121130 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(121308),
     /* 121135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121141 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(121219), // Rule ID 4120 //
     /* 121146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 121149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121189 */     // (fmaxnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMAXNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 121189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf16),
     /* 121192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 121198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 121202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121205 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121217 */     GIR_RootConstrainSelectedInstOperands,
     /* 121218 */     // GIR_Coverage, 4120,
     /* 121218 */     GIR_EraseRootFromParent_Done,
     /* 121219 */   // Label 2363: @121219
     /* 121219 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(121246), // Rule ID 1216 //
     /* 121224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 121227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121239 */     // (fmaxnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMAXNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQh),
     /* 121244 */     GIR_RootConstrainSelectedInstOperands,
     /* 121245 */     // GIR_Coverage, 1216,
     /* 121245 */     GIR_Done,
     /* 121246 */   // Label 2364: @121246
     /* 121246 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(121307), // Rule ID 3285 //
     /* 121251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 121254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121266 */     // (fmaxnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMAXNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 121266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 121269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf16),
     /* 121281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 121285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 121287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121305 */     GIR_RootConstrainSelectedInstOperands,
     /* 121306 */     // GIR_Coverage, 3285,
     /* 121306 */     GIR_EraseRootFromParent_Done,
     /* 121307 */   // Label 2365: @121307
     /* 121307 */   GIM_Reject,
     /* 121308 */ // Label 2362: @121308
     /* 121308 */ GIM_Reject,
     /* 121309 */ // Label 2352: @121309
     /* 121309 */ GIM_Reject,
     /* 121310 */ // Label 49: @121310
     /* 121310 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2372*/ GIMT_Encode4(122043),
     /* 121321 */ /*GILLT_s16*//*Label 2366*/ GIMT_Encode4(121373),
     /* 121325 */ /*GILLT_s32*//*Label 2367*/ GIMT_Encode4(121614), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121337 */ /*GILLT_v2s32*//*Label 2368*/ GIMT_Encode4(121855), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121349 */ /*GILLT_v4s16*//*Label 2369*/ GIMT_Encode4(121902),
     /* 121353 */ /*GILLT_v4s32*//*Label 2370*/ GIMT_Encode4(121949), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121369 */ /*GILLT_v8s16*//*Label 2371*/ GIMT_Encode4(121996),
     /* 121373 */ // Label 2366: @121373
     /* 121373 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(121613), // Rule ID 2707 //
     /* 121378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121399 */   // (fminimum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMINhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121399 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121402 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121406 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121413 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121416 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121420 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121425 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121428 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121433 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121436 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121440 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121445 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121448 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121452 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121455 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121460 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121465 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121470 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121473 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121477 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121484 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121487 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121491 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121496 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121499 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121504 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121507 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121511 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121516 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121519 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121523 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121526 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121531 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121536 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121541 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121544 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121548 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121553 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121556 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121559 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121562 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121582 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121585 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121595 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121602 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121607 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121612 */   // GIR_Coverage, 2707,
     /* 121612 */   GIR_EraseRootFromParent_Done,
     /* 121613 */ // Label 2373: @121613
     /* 121613 */ GIM_Reject,
     /* 121614 */ // Label 2367: @121614
     /* 121614 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(121854), // Rule ID 2709 //
     /* 121619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121640 */   // (fminimum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMINfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121640 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121643 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121647 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121654 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121657 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121661 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121666 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121669 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121674 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121677 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121681 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121686 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121689 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121693 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121696 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121701 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121706 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121711 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121714 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121718 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121725 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121728 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121732 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121737 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121740 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121745 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121748 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121752 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121757 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121760 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121764 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121767 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121772 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121777 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121782 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121785 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121789 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121794 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121797 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121800 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121803 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121823 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121826 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121836 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121853 */   // GIR_Coverage, 2709,
     /* 121853 */   GIR_EraseRootFromParent_Done,
     /* 121854 */ // Label 2374: @121854
     /* 121854 */ GIM_Reject,
     /* 121855 */ // Label 2368: @121855
     /* 121855 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(121901), // Rule ID 1229 //
     /* 121860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121881 */   // (fminimum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMINfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 121881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121886 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121888 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121893 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121899 */   GIR_RootConstrainSelectedInstOperands,
     /* 121900 */   // GIR_Coverage, 1229,
     /* 121900 */   GIR_EraseRootFromParent_Done,
     /* 121901 */ // Label 2375: @121901
     /* 121901 */ GIM_Reject,
     /* 121902 */ // Label 2369: @121902
     /* 121902 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(121948), // Rule ID 1231 //
     /* 121907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 121913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 121916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121928 */   // (fminimum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMINhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 121928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121933 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121935 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121946 */   GIR_RootConstrainSelectedInstOperands,
     /* 121947 */   // GIR_Coverage, 1231,
     /* 121947 */   GIR_EraseRootFromParent_Done,
     /* 121948 */ // Label 2376: @121948
     /* 121948 */ GIM_Reject,
     /* 121949 */ // Label 2370: @121949
     /* 121949 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(121995), // Rule ID 1230 //
     /* 121954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 121963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121975 */   // (fminimum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMINfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfq),
     /* 121978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121980 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121982 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121987 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121993 */   GIR_RootConstrainSelectedInstOperands,
     /* 121994 */   // GIR_Coverage, 1230,
     /* 121994 */   GIR_EraseRootFromParent_Done,
     /* 121995 */ // Label 2377: @121995
     /* 121995 */ GIM_Reject,
     /* 121996 */ // Label 2371: @121996
     /* 121996 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(122042), // Rule ID 1232 //
     /* 122001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122022 */   // (fminimum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMINhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhq),
     /* 122025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122027 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122029 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122034 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122040 */   GIR_RootConstrainSelectedInstOperands,
     /* 122041 */   // GIR_Coverage, 1232,
     /* 122041 */   GIR_EraseRootFromParent_Done,
     /* 122042 */ // Label 2378: @122042
     /* 122042 */ GIM_Reject,
     /* 122043 */ // Label 2372: @122043
     /* 122043 */ GIM_Reject,
     /* 122044 */ // Label 50: @122044
     /* 122044 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2385*/ GIMT_Encode4(122777),
     /* 122055 */ /*GILLT_s16*//*Label 2379*/ GIMT_Encode4(122107),
     /* 122059 */ /*GILLT_s32*//*Label 2380*/ GIMT_Encode4(122348), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122071 */ /*GILLT_v2s32*//*Label 2381*/ GIMT_Encode4(122589), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122083 */ /*GILLT_v4s16*//*Label 2382*/ GIMT_Encode4(122636),
     /* 122087 */ /*GILLT_v4s32*//*Label 2383*/ GIMT_Encode4(122683), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122103 */ /*GILLT_v8s16*//*Label 2384*/ GIMT_Encode4(122730),
     /* 122107 */ // Label 2379: @122107
     /* 122107 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(122347), // Rule ID 2706 //
     /* 122112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 122115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 122118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 122121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122133 */   // (fmaximum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMAXhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122133 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 122136 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122140 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122147 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 122150 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122154 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122159 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122162 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122167 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 122170 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122174 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122179 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122182 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122186 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122189 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122194 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122199 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122204 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 122207 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122211 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122218 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 122221 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122225 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122230 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122233 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122238 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 122241 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122245 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122250 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122253 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122257 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122260 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122265 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122270 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122275 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122278 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122282 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122287 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122290 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122293 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122296 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 122307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122316 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122319 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122329 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122336 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122341 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122346 */   // GIR_Coverage, 2706,
     /* 122346 */   GIR_EraseRootFromParent_Done,
     /* 122347 */ // Label 2386: @122347
     /* 122347 */ GIM_Reject,
     /* 122348 */ // Label 2380: @122348
     /* 122348 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(122588), // Rule ID 2708 //
     /* 122353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122370 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122374 */   // (fmaximum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMAXfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122374 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 122377 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122381 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122388 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 122391 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122395 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122400 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122403 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122408 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 122411 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122415 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122420 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122423 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122427 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122430 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122435 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122440 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122445 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 122448 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122452 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122459 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 122462 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122466 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122471 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122474 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122479 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 122482 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122486 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122491 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122494 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122498 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122501 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122506 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122511 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122516 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122519 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122523 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122528 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122531 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122534 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122537 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 122548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122557 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122560 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122570 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122577 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122582 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122587 */   // GIR_Coverage, 2708,
     /* 122587 */   GIR_EraseRootFromParent_Done,
     /* 122588 */ // Label 2387: @122588
     /* 122588 */ GIM_Reject,
     /* 122589 */ // Label 2381: @122589
     /* 122589 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(122635), // Rule ID 1209 //
     /* 122594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122615 */   // (fmaximum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMAXfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 122615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122620 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122622 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122627 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122633 */   GIR_RootConstrainSelectedInstOperands,
     /* 122634 */   // GIR_Coverage, 1209,
     /* 122634 */   GIR_EraseRootFromParent_Done,
     /* 122635 */ // Label 2388: @122635
     /* 122635 */ GIM_Reject,
     /* 122636 */ // Label 2382: @122636
     /* 122636 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(122682), // Rule ID 1211 //
     /* 122641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122662 */   // (fmaximum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMAXhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 122662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122669 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122674 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122680 */   GIR_RootConstrainSelectedInstOperands,
     /* 122681 */   // GIR_Coverage, 1211,
     /* 122681 */   GIR_EraseRootFromParent_Done,
     /* 122682 */ // Label 2389: @122682
     /* 122682 */ GIM_Reject,
     /* 122683 */ // Label 2383: @122683
     /* 122683 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(122729), // Rule ID 1210 //
     /* 122688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122709 */   // (fmaximum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMAXfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfq),
     /* 122712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122714 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122716 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122721 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122727 */   GIR_RootConstrainSelectedInstOperands,
     /* 122728 */   // GIR_Coverage, 1210,
     /* 122728 */   GIR_EraseRootFromParent_Done,
     /* 122729 */ // Label 2390: @122729
     /* 122729 */ GIM_Reject,
     /* 122730 */ // Label 2384: @122730
     /* 122730 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(122776), // Rule ID 1212 //
     /* 122735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122756 */   // (fmaximum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMAXhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhq),
     /* 122759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122761 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122763 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122768 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122774 */   GIR_RootConstrainSelectedInstOperands,
     /* 122775 */   // GIR_Coverage, 1212,
     /* 122775 */   GIR_EraseRootFromParent_Done,
     /* 122776 */ // Label 2391: @122776
     /* 122776 */ GIM_Reject,
     /* 122777 */ // Label 2385: @122777
     /* 122777 */ GIM_Reject,
     /* 122778 */ // Label 51: @122778
     /* 122778 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(122810), // Rule ID 2419 //
     /* 122783 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122790 */   // (get_fpenv:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122798 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122808 */   GIR_RootConstrainSelectedInstOperands,
     /* 122809 */   // GIR_Coverage, 2419,
     /* 122809 */   GIR_EraseRootFromParent_Done,
     /* 122810 */ // Label 2392: @122810
     /* 122810 */ GIM_Reject,
     /* 122811 */ // Label 52: @122811
     /* 122811 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(122846), // Rule ID 2420 //
     /* 122816 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122823 */   // (set_fpenv GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /* 122823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122826 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122831 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122837 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122840 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122844 */   GIR_RootConstrainSelectedInstOperands,
     /* 122845 */   // GIR_Coverage, 2420,
     /* 122845 */   GIR_EraseRootFromParent_Done,
     /* 122846 */ // Label 2393: @122846
     /* 122846 */ GIM_Reject,
     /* 122847 */ // Label 53: @122847
     /* 122847 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(122911), // Rule ID 2421 //
     /* 122852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 122855 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (MOVi:{ *:[i32] } 0:{ *:[i32] }))
     /* 122855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /* 122862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122867 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122870 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122873 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122879 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122896 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122902 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122905 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122909 */   GIR_RootConstrainSelectedInstOperands,
     /* 122910 */   // GIR_Coverage, 2421,
     /* 122910 */   GIR_EraseRootFromParent_Done,
     /* 122911 */ // Label 2394: @122911
     /* 122911 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(122975), // Rule ID 2422 //
     /* 122916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 122919 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /* 122919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /* 122926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122931 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 122937 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122940 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122943 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122960 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122966 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122969 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122973 */   GIR_RootConstrainSelectedInstOperands,
     /* 122974 */   // GIR_Coverage, 2422,
     /* 122974 */   GIR_EraseRootFromParent_Done,
     /* 122975 */ // Label 2395: @122975
     /* 122975 */ GIM_Reject,
     /* 122976 */ // Label 54: @122976
     /* 122976 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(123008), // Rule ID 2423 //
     /* 122981 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122988 */   // (get_fpmode:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122996 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123006 */   GIR_RootConstrainSelectedInstOperands,
     /* 123007 */   // GIR_Coverage, 2423,
     /* 123007 */   GIR_EraseRootFromParent_Done,
     /* 123008 */ // Label 2396: @123008
     /* 123008 */ GIM_Reject,
     /* 123009 */ // Label 55: @123009
     /* 123009 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2403*/ GIMT_Encode4(123551),
     /* 123020 */ /*GILLT_v2s32*//*Label 2397*/ GIMT_Encode4(123068), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123032 */ /*GILLT_v4s16*//*Label 2398*/ GIMT_Encode4(123115),
     /* 123036 */ /*GILLT_v4s32*//*Label 2399*/ GIMT_Encode4(123162), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123048 */ /*GILLT_v8s8*//*Label 2400*/ GIMT_Encode4(123276),
     /* 123052 */ /*GILLT_v8s16*//*Label 2401*/ GIMT_Encode4(123323), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123064 */ /*GILLT_v16s8*//*Label 2402*/ GIMT_Encode4(123437),
     /* 123068 */ // Label 2397: @123068
     /* 123068 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(123114), // Rule ID 1218 //
     /* 123073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123094 */   // (smin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv2i32),
     /* 123097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123099 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123101 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123106 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123112 */   GIR_RootConstrainSelectedInstOperands,
     /* 123113 */   // GIR_Coverage, 1218,
     /* 123113 */   GIR_EraseRootFromParent_Done,
     /* 123114 */ // Label 2404: @123114
     /* 123114 */ GIM_Reject,
     /* 123115 */ // Label 2398: @123115
     /* 123115 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(123161), // Rule ID 1217 //
     /* 123120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123141 */   // (smin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i16),
     /* 123144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123146 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123148 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123153 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123159 */   GIR_RootConstrainSelectedInstOperands,
     /* 123160 */   // GIR_Coverage, 1217,
     /* 123160 */   GIR_EraseRootFromParent_Done,
     /* 123161 */ // Label 2405: @123161
     /* 123161 */ GIM_Reject,
     /* 123162 */ // Label 2399: @123162
     /* 123162 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(123275),
     /* 123167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123173 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(123213), // Rule ID 1220 //
     /* 123178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123193 */     // (smin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i32),
     /* 123196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123205 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123211 */     GIR_RootConstrainSelectedInstOperands,
     /* 123212 */     // GIR_Coverage, 1220,
     /* 123212 */     GIR_EraseRootFromParent_Done,
     /* 123213 */   // Label 2407: @123213
     /* 123213 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(123274), // Rule ID 3300 //
     /* 123218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123233 */     // (smin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs32),
     /* 123248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123272 */     GIR_RootConstrainSelectedInstOperands,
     /* 123273 */     // GIR_Coverage, 3300,
     /* 123273 */     GIR_EraseRootFromParent_Done,
     /* 123274 */   // Label 2408: @123274
     /* 123274 */   GIM_Reject,
     /* 123275 */ // Label 2406: @123275
     /* 123275 */ GIM_Reject,
     /* 123276 */ // Label 2400: @123276
     /* 123276 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(123322), // Rule ID 1221 //
     /* 123281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123302 */   // (smin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i8),
     /* 123305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123307 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123309 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123314 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123320 */   GIR_RootConstrainSelectedInstOperands,
     /* 123321 */   // GIR_Coverage, 1221,
     /* 123321 */   GIR_EraseRootFromParent_Done,
     /* 123322 */ // Label 2409: @123322
     /* 123322 */ GIM_Reject,
     /* 123323 */ // Label 2401: @123323
     /* 123323 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(123436),
     /* 123328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123334 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(123374), // Rule ID 1219 //
     /* 123339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123354 */     // (smin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i16),
     /* 123357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123372 */     GIR_RootConstrainSelectedInstOperands,
     /* 123373 */     // GIR_Coverage, 1219,
     /* 123373 */     GIR_EraseRootFromParent_Done,
     /* 123374 */   // Label 2411: @123374
     /* 123374 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(123435), // Rule ID 3297 //
     /* 123379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123394 */     // (smin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs16),
     /* 123409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123433 */     GIR_RootConstrainSelectedInstOperands,
     /* 123434 */     // GIR_Coverage, 3297,
     /* 123434 */     GIR_EraseRootFromParent_Done,
     /* 123435 */   // Label 2412: @123435
     /* 123435 */   GIM_Reject,
     /* 123436 */ // Label 2410: @123436
     /* 123436 */ GIM_Reject,
     /* 123437 */ // Label 2402: @123437
     /* 123437 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(123550),
     /* 123442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123448 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(123488), // Rule ID 1222 //
     /* 123453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123468 */     // (smin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv16i8),
     /* 123471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123486 */     GIR_RootConstrainSelectedInstOperands,
     /* 123487 */     // GIR_Coverage, 1222,
     /* 123487 */     GIR_EraseRootFromParent_Done,
     /* 123488 */   // Label 2414: @123488
     /* 123488 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(123549), // Rule ID 3294 //
     /* 123493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123508 */     // (smin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs8),
     /* 123523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123547 */     GIR_RootConstrainSelectedInstOperands,
     /* 123548 */     // GIR_Coverage, 3294,
     /* 123548 */     GIR_EraseRootFromParent_Done,
     /* 123549 */   // Label 2415: @123549
     /* 123549 */   GIM_Reject,
     /* 123550 */ // Label 2413: @123550
     /* 123550 */ GIM_Reject,
     /* 123551 */ // Label 2403: @123551
     /* 123551 */ GIM_Reject,
     /* 123552 */ // Label 56: @123552
     /* 123552 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2422*/ GIMT_Encode4(124094),
     /* 123563 */ /*GILLT_v2s32*//*Label 2416*/ GIMT_Encode4(123611), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123575 */ /*GILLT_v4s16*//*Label 2417*/ GIMT_Encode4(123658),
     /* 123579 */ /*GILLT_v4s32*//*Label 2418*/ GIMT_Encode4(123705), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123591 */ /*GILLT_v8s8*//*Label 2419*/ GIMT_Encode4(123819),
     /* 123595 */ /*GILLT_v8s16*//*Label 2420*/ GIMT_Encode4(123866), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123607 */ /*GILLT_v16s8*//*Label 2421*/ GIMT_Encode4(123980),
     /* 123611 */ // Label 2416: @123611
     /* 123611 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(123657), // Rule ID 1198 //
     /* 123616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123637 */   // (smax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv2i32),
     /* 123640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123642 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123644 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123649 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123655 */   GIR_RootConstrainSelectedInstOperands,
     /* 123656 */   // GIR_Coverage, 1198,
     /* 123656 */   GIR_EraseRootFromParent_Done,
     /* 123657 */ // Label 2423: @123657
     /* 123657 */ GIM_Reject,
     /* 123658 */ // Label 2417: @123658
     /* 123658 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(123704), // Rule ID 1197 //
     /* 123663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123684 */   // (smax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i16),
     /* 123687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123689 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123691 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123696 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123702 */   GIR_RootConstrainSelectedInstOperands,
     /* 123703 */   // GIR_Coverage, 1197,
     /* 123703 */   GIR_EraseRootFromParent_Done,
     /* 123704 */ // Label 2424: @123704
     /* 123704 */ GIM_Reject,
     /* 123705 */ // Label 2418: @123705
     /* 123705 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(123818),
     /* 123710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123716 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(123756), // Rule ID 1200 //
     /* 123721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123736 */     // (smax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i32),
     /* 123739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123754 */     GIR_RootConstrainSelectedInstOperands,
     /* 123755 */     // GIR_Coverage, 1200,
     /* 123755 */     GIR_EraseRootFromParent_Done,
     /* 123756 */   // Label 2426: @123756
     /* 123756 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(123817), // Rule ID 3318 //
     /* 123761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123776 */     // (smax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs32),
     /* 123791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123815 */     GIR_RootConstrainSelectedInstOperands,
     /* 123816 */     // GIR_Coverage, 3318,
     /* 123816 */     GIR_EraseRootFromParent_Done,
     /* 123817 */   // Label 2427: @123817
     /* 123817 */   GIM_Reject,
     /* 123818 */ // Label 2425: @123818
     /* 123818 */ GIM_Reject,
     /* 123819 */ // Label 2419: @123819
     /* 123819 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(123865), // Rule ID 1201 //
     /* 123824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123845 */   // (smax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i8),
     /* 123848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123850 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123852 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123857 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123863 */   GIR_RootConstrainSelectedInstOperands,
     /* 123864 */   // GIR_Coverage, 1201,
     /* 123864 */   GIR_EraseRootFromParent_Done,
     /* 123865 */ // Label 2428: @123865
     /* 123865 */ GIM_Reject,
     /* 123866 */ // Label 2420: @123866
     /* 123866 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(123979),
     /* 123871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123877 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(123917), // Rule ID 1199 //
     /* 123882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123897 */     // (smax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i16),
     /* 123900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123915 */     GIR_RootConstrainSelectedInstOperands,
     /* 123916 */     // GIR_Coverage, 1199,
     /* 123916 */     GIR_EraseRootFromParent_Done,
     /* 123917 */   // Label 2430: @123917
     /* 123917 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(123978), // Rule ID 3315 //
     /* 123922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123937 */     // (smax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs16),
     /* 123952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123976 */     GIR_RootConstrainSelectedInstOperands,
     /* 123977 */     // GIR_Coverage, 3315,
     /* 123977 */     GIR_EraseRootFromParent_Done,
     /* 123978 */   // Label 2431: @123978
     /* 123978 */   GIM_Reject,
     /* 123979 */ // Label 2429: @123979
     /* 123979 */ GIM_Reject,
     /* 123980 */ // Label 2421: @123980
     /* 123980 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(124093),
     /* 123985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123991 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(124031), // Rule ID 1202 //
     /* 123996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124011 */     // (smax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv16i8),
     /* 124014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124029 */     GIR_RootConstrainSelectedInstOperands,
     /* 124030 */     // GIR_Coverage, 1202,
     /* 124030 */     GIR_EraseRootFromParent_Done,
     /* 124031 */   // Label 2433: @124031
     /* 124031 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(124092), // Rule ID 3312 //
     /* 124036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124051 */     // (smax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs8),
     /* 124066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124090 */     GIR_RootConstrainSelectedInstOperands,
     /* 124091 */     // GIR_Coverage, 3312,
     /* 124091 */     GIR_EraseRootFromParent_Done,
     /* 124092 */   // Label 2434: @124092
     /* 124092 */   GIM_Reject,
     /* 124093 */ // Label 2432: @124093
     /* 124093 */ GIM_Reject,
     /* 124094 */ // Label 2422: @124094
     /* 124094 */ GIM_Reject,
     /* 124095 */ // Label 57: @124095
     /* 124095 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2441*/ GIMT_Encode4(125015),
     /* 124106 */ /*GILLT_v2s32*//*Label 2435*/ GIMT_Encode4(124154), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124118 */ /*GILLT_v4s16*//*Label 2436*/ GIMT_Encode4(124201),
     /* 124122 */ /*GILLT_v4s32*//*Label 2437*/ GIMT_Encode4(124248), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124134 */ /*GILLT_v8s8*//*Label 2438*/ GIMT_Encode4(124488),
     /* 124138 */ /*GILLT_v8s16*//*Label 2439*/ GIMT_Encode4(124535), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124150 */ /*GILLT_v16s8*//*Label 2440*/ GIMT_Encode4(124775),
     /* 124154 */ // Label 2435: @124154
     /* 124154 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(124200), // Rule ID 1224 //
     /* 124159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124180 */   // (umin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv2i32),
     /* 124183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124185 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124187 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124192 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124198 */   GIR_RootConstrainSelectedInstOperands,
     /* 124199 */   // GIR_Coverage, 1224,
     /* 124199 */   GIR_EraseRootFromParent_Done,
     /* 124200 */ // Label 2442: @124200
     /* 124200 */ GIM_Reject,
     /* 124201 */ // Label 2436: @124201
     /* 124201 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(124247), // Rule ID 1223 //
     /* 124206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124227 */   // (umin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i16),
     /* 124230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124232 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124234 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124239 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124245 */   GIR_RootConstrainSelectedInstOperands,
     /* 124246 */   // GIR_Coverage, 1223,
     /* 124246 */   GIR_EraseRootFromParent_Done,
     /* 124247 */ // Label 2443: @124247
     /* 124247 */ GIM_Reject,
     /* 124248 */ // Label 2437: @124248
     /* 124248 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(124487),
     /* 124253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 124259 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(124322), // Rule ID 6027 //
     /* 124264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124294 */     // (umin:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124320 */     GIR_RootConstrainSelectedInstOperands,
     /* 124321 */     // GIR_Coverage, 6027,
     /* 124321 */     GIR_EraseRootFromParent_Done,
     /* 124322 */   // Label 2445: @124322
     /* 124322 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(124385), // Rule ID 3697 //
     /* 124327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124357 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124383 */     GIR_RootConstrainSelectedInstOperands,
     /* 124384 */     // GIR_Coverage, 3697,
     /* 124384 */     GIR_EraseRootFromParent_Done,
     /* 124385 */   // Label 2446: @124385
     /* 124385 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(124425), // Rule ID 1226 //
     /* 124390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124405 */     // (umin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 124405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i32),
     /* 124408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124423 */     GIR_RootConstrainSelectedInstOperands,
     /* 124424 */     // GIR_Coverage, 1226,
     /* 124424 */     GIR_EraseRootFromParent_Done,
     /* 124425 */   // Label 2447: @124425
     /* 124425 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(124486), // Rule ID 3309 //
     /* 124430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124445 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 124445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu32),
     /* 124460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124484 */     GIR_RootConstrainSelectedInstOperands,
     /* 124485 */     // GIR_Coverage, 3309,
     /* 124485 */     GIR_EraseRootFromParent_Done,
     /* 124486 */   // Label 2448: @124486
     /* 124486 */   GIM_Reject,
     /* 124487 */ // Label 2444: @124487
     /* 124487 */ GIM_Reject,
     /* 124488 */ // Label 2438: @124488
     /* 124488 */ GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(124534), // Rule ID 1227 //
     /* 124493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 124499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 124502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124514 */   // (umin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 124514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i8),
     /* 124517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124519 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124521 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124526 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124532 */   GIR_RootConstrainSelectedInstOperands,
     /* 124533 */   // GIR_Coverage, 1227,
     /* 124533 */   GIR_EraseRootFromParent_Done,
     /* 124534 */ // Label 2449: @124534
     /* 124534 */ GIM_Reject,
     /* 124535 */ // Label 2439: @124535
     /* 124535 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(124774),
     /* 124540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 124546 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(124609), // Rule ID 6026 //
     /* 124551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124581 */     // (umin:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124607 */     GIR_RootConstrainSelectedInstOperands,
     /* 124608 */     // GIR_Coverage, 6026,
     /* 124608 */     GIR_EraseRootFromParent_Done,
     /* 124609 */   // Label 2451: @124609
     /* 124609 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(124672), // Rule ID 3695 //
     /* 124614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124644 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124670 */     GIR_RootConstrainSelectedInstOperands,
     /* 124671 */     // GIR_Coverage, 3695,
     /* 124671 */     GIR_EraseRootFromParent_Done,
     /* 124672 */   // Label 2452: @124672
     /* 124672 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(124712), // Rule ID 1225 //
     /* 124677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124692 */     // (umin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 124692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i16),
     /* 124695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124710 */     GIR_RootConstrainSelectedInstOperands,
     /* 124711 */     // GIR_Coverage, 1225,
     /* 124711 */     GIR_EraseRootFromParent_Done,
     /* 124712 */   // Label 2453: @124712
     /* 124712 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(124773), // Rule ID 3306 //
     /* 124717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124732 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 124732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu16),
     /* 124747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124771 */     GIR_RootConstrainSelectedInstOperands,
     /* 124772 */     // GIR_Coverage, 3306,
     /* 124772 */     GIR_EraseRootFromParent_Done,
     /* 124773 */   // Label 2454: @124773
     /* 124773 */   GIM_Reject,
     /* 124774 */ // Label 2450: @124774
     /* 124774 */ GIM_Reject,
     /* 124775 */ // Label 2440: @124775
     /* 124775 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(125014),
     /* 124780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124786 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(124849), // Rule ID 6025 //
     /* 124791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124821 */     // (umin:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124847 */     GIR_RootConstrainSelectedInstOperands,
     /* 124848 */     // GIR_Coverage, 6025,
     /* 124848 */     GIR_EraseRootFromParent_Done,
     /* 124849 */   // Label 2456: @124849
     /* 124849 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(124912), // Rule ID 3693 //
     /* 124854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124884 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124910 */     GIR_RootConstrainSelectedInstOperands,
     /* 124911 */     // GIR_Coverage, 3693,
     /* 124911 */     GIR_EraseRootFromParent_Done,
     /* 124912 */   // Label 2457: @124912
     /* 124912 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(124952), // Rule ID 1228 //
     /* 124917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124932 */     // (umin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv16i8),
     /* 124935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124950 */     GIR_RootConstrainSelectedInstOperands,
     /* 124951 */     // GIR_Coverage, 1228,
     /* 124951 */     GIR_EraseRootFromParent_Done,
     /* 124952 */   // Label 2458: @124952
     /* 124952 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(125013), // Rule ID 3303 //
     /* 124957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124972 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu8),
     /* 124987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125011 */     GIR_RootConstrainSelectedInstOperands,
     /* 125012 */     // GIR_Coverage, 3303,
     /* 125012 */     GIR_EraseRootFromParent_Done,
     /* 125013 */   // Label 2459: @125013
     /* 125013 */   GIM_Reject,
     /* 125014 */ // Label 2455: @125014
     /* 125014 */ GIM_Reject,
     /* 125015 */ // Label 2441: @125015
     /* 125015 */ GIM_Reject,
     /* 125016 */ // Label 58: @125016
     /* 125016 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2466*/ GIMT_Encode4(125936),
     /* 125027 */ /*GILLT_v2s32*//*Label 2460*/ GIMT_Encode4(125075), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125039 */ /*GILLT_v4s16*//*Label 2461*/ GIMT_Encode4(125122),
     /* 125043 */ /*GILLT_v4s32*//*Label 2462*/ GIMT_Encode4(125169), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125055 */ /*GILLT_v8s8*//*Label 2463*/ GIMT_Encode4(125409),
     /* 125059 */ /*GILLT_v8s16*//*Label 2464*/ GIMT_Encode4(125456), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125071 */ /*GILLT_v16s8*//*Label 2465*/ GIMT_Encode4(125696),
     /* 125075 */ // Label 2460: @125075
     /* 125075 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(125121), // Rule ID 1204 //
     /* 125080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 125086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 125089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125101 */   // (umax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 125101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv2i32),
     /* 125104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125106 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125108 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125113 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125119 */   GIR_RootConstrainSelectedInstOperands,
     /* 125120 */   // GIR_Coverage, 1204,
     /* 125120 */   GIR_EraseRootFromParent_Done,
     /* 125121 */ // Label 2467: @125121
     /* 125121 */ GIM_Reject,
     /* 125122 */ // Label 2461: @125122
     /* 125122 */ GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(125168), // Rule ID 1203 //
     /* 125127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 125136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125144 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125148 */   // (umax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 125148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i16),
     /* 125151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125153 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125155 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125160 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125166 */   GIR_RootConstrainSelectedInstOperands,
     /* 125167 */   // GIR_Coverage, 1203,
     /* 125167 */   GIR_EraseRootFromParent_Done,
     /* 125168 */ // Label 2468: @125168
     /* 125168 */ GIM_Reject,
     /* 125169 */ // Label 2462: @125169
     /* 125169 */ GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(125408),
     /* 125174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 125180 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(125243), // Rule ID 6030 //
     /* 125185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125215 */     // (umax:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125241 */     GIR_RootConstrainSelectedInstOperands,
     /* 125242 */     // GIR_Coverage, 6030,
     /* 125242 */     GIR_EraseRootFromParent_Done,
     /* 125243 */   // Label 2470: @125243
     /* 125243 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(125306), // Rule ID 3703 //
     /* 125248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125278 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125304 */     GIR_RootConstrainSelectedInstOperands,
     /* 125305 */     // GIR_Coverage, 3703,
     /* 125305 */     GIR_EraseRootFromParent_Done,
     /* 125306 */   // Label 2471: @125306
     /* 125306 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(125346), // Rule ID 1206 //
     /* 125311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125326 */     // (umax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 125326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i32),
     /* 125329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125344 */     GIR_RootConstrainSelectedInstOperands,
     /* 125345 */     // GIR_Coverage, 1206,
     /* 125345 */     GIR_EraseRootFromParent_Done,
     /* 125346 */   // Label 2472: @125346
     /* 125346 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(125407), // Rule ID 3327 //
     /* 125351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125366 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 125366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu32),
     /* 125381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125405 */     GIR_RootConstrainSelectedInstOperands,
     /* 125406 */     // GIR_Coverage, 3327,
     /* 125406 */     GIR_EraseRootFromParent_Done,
     /* 125407 */   // Label 2473: @125407
     /* 125407 */   GIM_Reject,
     /* 125408 */ // Label 2469: @125408
     /* 125408 */ GIM_Reject,
     /* 125409 */ // Label 2463: @125409
     /* 125409 */ GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(125455), // Rule ID 1207 //
     /* 125414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 125423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125435 */   // (umax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 125435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i8),
     /* 125438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125440 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125442 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125447 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125453 */   GIR_RootConstrainSelectedInstOperands,
     /* 125454 */   // GIR_Coverage, 1207,
     /* 125454 */   GIR_EraseRootFromParent_Done,
     /* 125455 */ // Label 2474: @125455
     /* 125455 */ GIM_Reject,
     /* 125456 */ // Label 2464: @125456
     /* 125456 */ GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(125695),
     /* 125461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 125467 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(125530), // Rule ID 6029 //
     /* 125472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125502 */     // (umax:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125528 */     GIR_RootConstrainSelectedInstOperands,
     /* 125529 */     // GIR_Coverage, 6029,
     /* 125529 */     GIR_EraseRootFromParent_Done,
     /* 125530 */   // Label 2476: @125530
     /* 125530 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(125593), // Rule ID 3701 //
     /* 125535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125565 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125591 */     GIR_RootConstrainSelectedInstOperands,
     /* 125592 */     // GIR_Coverage, 3701,
     /* 125592 */     GIR_EraseRootFromParent_Done,
     /* 125593 */   // Label 2477: @125593
     /* 125593 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(125633), // Rule ID 1205 //
     /* 125598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125613 */     // (umax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 125613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i16),
     /* 125616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125625 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125631 */     GIR_RootConstrainSelectedInstOperands,
     /* 125632 */     // GIR_Coverage, 1205,
     /* 125632 */     GIR_EraseRootFromParent_Done,
     /* 125633 */   // Label 2478: @125633
     /* 125633 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(125694), // Rule ID 3324 //
     /* 125638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125653 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 125653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu16),
     /* 125668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125692 */     GIR_RootConstrainSelectedInstOperands,
     /* 125693 */     // GIR_Coverage, 3324,
     /* 125693 */     GIR_EraseRootFromParent_Done,
     /* 125694 */   // Label 2479: @125694
     /* 125694 */   GIM_Reject,
     /* 125695 */ // Label 2475: @125695
     /* 125695 */ GIM_Reject,
     /* 125696 */ // Label 2465: @125696
     /* 125696 */ GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(125935),
     /* 125701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 125707 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(125770), // Rule ID 6028 //
     /* 125712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125742 */     // (umax:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125768 */     GIR_RootConstrainSelectedInstOperands,
     /* 125769 */     // GIR_Coverage, 6028,
     /* 125769 */     GIR_EraseRootFromParent_Done,
     /* 125770 */   // Label 2481: @125770
     /* 125770 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(125833), // Rule ID 3699 //
     /* 125775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125805 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125831 */     GIR_RootConstrainSelectedInstOperands,
     /* 125832 */     // GIR_Coverage, 3699,
     /* 125832 */     GIR_EraseRootFromParent_Done,
     /* 125833 */   // Label 2482: @125833
     /* 125833 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(125873), // Rule ID 1208 //
     /* 125838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125853 */     // (umax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 125853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv16i8),
     /* 125856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125871 */     GIR_RootConstrainSelectedInstOperands,
     /* 125872 */     // GIR_Coverage, 1208,
     /* 125872 */     GIR_EraseRootFromParent_Done,
     /* 125873 */   // Label 2483: @125873
     /* 125873 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(125934), // Rule ID 3321 //
     /* 125878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125893 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 125893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu8),
     /* 125908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125932 */     GIR_RootConstrainSelectedInstOperands,
     /* 125933 */     // GIR_Coverage, 3321,
     /* 125933 */     GIR_EraseRootFromParent_Done,
     /* 125934 */   // Label 2484: @125934
     /* 125934 */   GIM_Reject,
     /* 125935 */ // Label 2480: @125935
     /* 125935 */ GIM_Reject,
     /* 125936 */ // Label 2466: @125936
     /* 125936 */ GIM_Reject,
     /* 125937 */ // Label 59: @125937
     /* 125937 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2491*/ GIMT_Encode4(126407),
     /* 125948 */ /*GILLT_v2s32*//*Label 2485*/ GIMT_Encode4(125996), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125960 */ /*GILLT_v4s16*//*Label 2486*/ GIMT_Encode4(126034),
     /* 125964 */ /*GILLT_v4s32*//*Label 2487*/ GIMT_Encode4(126072), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125976 */ /*GILLT_v8s8*//*Label 2488*/ GIMT_Encode4(126171),
     /* 125980 */ /*GILLT_v8s16*//*Label 2489*/ GIMT_Encode4(126209), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125992 */ /*GILLT_v16s8*//*Label 2490*/ GIMT_Encode4(126308),
     /* 125996 */ // Label 2485: @125996
     /* 125996 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(126033), // Rule ID 1510 //
     /* 126001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126015 */   // (abs:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 126015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv2i32),
     /* 126018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126020 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126025 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126031 */   GIR_RootConstrainSelectedInstOperands,
     /* 126032 */   // GIR_Coverage, 1510,
     /* 126032 */   GIR_EraseRootFromParent_Done,
     /* 126033 */ // Label 2492: @126033
     /* 126033 */ GIM_Reject,
     /* 126034 */ // Label 2486: @126034
     /* 126034 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(126071), // Rule ID 1509 //
     /* 126039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126053 */   // (abs:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 126053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i16),
     /* 126056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126058 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126063 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126069 */   GIR_RootConstrainSelectedInstOperands,
     /* 126070 */   // GIR_Coverage, 1509,
     /* 126070 */   GIR_EraseRootFromParent_Done,
     /* 126071 */ // Label 2493: @126071
     /* 126071 */ GIM_Reject,
     /* 126072 */ // Label 2487: @126072
     /* 126072 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(126170),
     /* 126077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126080 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(126114), // Rule ID 1513 //
     /* 126085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126096 */     // (abs:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 126096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i32),
     /* 126099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126112 */     GIR_RootConstrainSelectedInstOperands,
     /* 126113 */     // GIR_Coverage, 1513,
     /* 126113 */     GIR_EraseRootFromParent_Done,
     /* 126114 */   // Label 2495: @126114
     /* 126114 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(126169), // Rule ID 3672 //
     /* 126119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126130 */     // (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v)  =>  (MVE_VABSs32:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
     /* 126130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs32),
     /* 126145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126147 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126167 */     GIR_RootConstrainSelectedInstOperands,
     /* 126168 */     // GIR_Coverage, 3672,
     /* 126168 */     GIR_EraseRootFromParent_Done,
     /* 126169 */   // Label 2496: @126169
     /* 126169 */   GIM_Reject,
     /* 126170 */ // Label 2494: @126170
     /* 126170 */ GIM_Reject,
     /* 126171 */ // Label 2488: @126171
     /* 126171 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(126208), // Rule ID 1508 //
     /* 126176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126190 */   // (abs:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i8),
     /* 126193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126195 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126206 */   GIR_RootConstrainSelectedInstOperands,
     /* 126207 */   // GIR_Coverage, 1508,
     /* 126207 */   GIR_EraseRootFromParent_Done,
     /* 126208 */ // Label 2497: @126208
     /* 126208 */ GIM_Reject,
     /* 126209 */ // Label 2489: @126209
     /* 126209 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(126307),
     /* 126214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126217 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(126251), // Rule ID 1512 //
     /* 126222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126233 */     // (abs:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 126233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i16),
     /* 126236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126249 */     GIR_RootConstrainSelectedInstOperands,
     /* 126250 */     // GIR_Coverage, 1512,
     /* 126250 */     GIR_EraseRootFromParent_Done,
     /* 126251 */   // Label 2499: @126251
     /* 126251 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(126306), // Rule ID 3666 //
     /* 126256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126267 */     // (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v)  =>  (MVE_VABSs16:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
     /* 126267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs16),
     /* 126282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126284 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126295 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126304 */     GIR_RootConstrainSelectedInstOperands,
     /* 126305 */     // GIR_Coverage, 3666,
     /* 126305 */     GIR_EraseRootFromParent_Done,
     /* 126306 */   // Label 2500: @126306
     /* 126306 */   GIM_Reject,
     /* 126307 */ // Label 2498: @126307
     /* 126307 */ GIM_Reject,
     /* 126308 */ // Label 2490: @126308
     /* 126308 */ GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(126406),
     /* 126313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126316 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(126350), // Rule ID 1511 //
     /* 126321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126332 */     // (abs:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv16i8),
     /* 126335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126348 */     GIR_RootConstrainSelectedInstOperands,
     /* 126349 */     // GIR_Coverage, 1511,
     /* 126349 */     GIR_EraseRootFromParent_Done,
     /* 126350 */   // Label 2502: @126350
     /* 126350 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(126405), // Rule ID 3660 //
     /* 126355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126366 */     // (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v)  =>  (MVE_VABSs8:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
     /* 126366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs8),
     /* 126381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126383 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126394 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126403 */     GIR_RootConstrainSelectedInstOperands,
     /* 126404 */     // GIR_Coverage, 3660,
     /* 126404 */     GIR_EraseRootFromParent_Done,
     /* 126405 */   // Label 2503: @126405
     /* 126405 */   GIM_Reject,
     /* 126406 */ // Label 2501: @126406
     /* 126406 */ GIM_Reject,
     /* 126407 */ // Label 2491: @126407
     /* 126407 */ GIM_Reject,
     /* 126408 */ // Label 60: @126408
     /* 126408 */ GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(126480),
     /* 126413 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 126416 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(126431), // Rule ID 32 //
     /* 126421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 126424 */     // (br (bb:{ *:[Other] }):$target)  =>  (B (bb:{ *:[Other] }):$target)
     /* 126424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::B),
     /* 126429 */     GIR_RootConstrainSelectedInstOperands,
     /* 126430 */     // GIR_Coverage, 32,
     /* 126430 */     GIR_Done,
     /* 126431 */   // Label 2505: @126431
     /* 126431 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(126455), // Rule ID 283 //
     /* 126436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 126439 */     // (br (bb:{ *:[Other] }):$target)  =>  (tB (bb:{ *:[Other] }):$target)
     /* 126439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tB),
     /* 126442 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126453 */     GIR_RootConstrainSelectedInstOperands,
     /* 126454 */     // GIR_Coverage, 283,
     /* 126454 */     GIR_EraseRootFromParent_Done,
     /* 126455 */   // Label 2506: @126455
     /* 126455 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(126479), // Rule ID 577 //
     /* 126460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /* 126463 */     // (br (bb:{ *:[Other] }):$target)  =>  (t2B (bb:{ *:[Other] }):$target)
     /* 126463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2B),
     /* 126466 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126477 */     GIR_RootConstrainSelectedInstOperands,
     /* 126478 */     // GIR_Coverage, 577,
     /* 126478 */     GIR_EraseRootFromParent_Done,
     /* 126479 */   // Label 2507: @126479
     /* 126479 */   GIM_Reject,
     /* 126480 */ // Label 2504: @126480
     /* 126480 */ GIM_Reject,
     /* 126481 */ // Label 61: @126481
     /* 126481 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(16), /*)*//*default:*//*Label 2512*/ GIMT_Encode4(126780),
     /* 126492 */ /*GILLT_v4s16*//*Label 2508*/ GIMT_Encode4(126528), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126508 */ /*GILLT_v8s8*//*Label 2509*/ GIMT_Encode4(126591),
     /* 126512 */ /*GILLT_v8s16*//*Label 2510*/ GIMT_Encode4(126654), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126524 */ /*GILLT_v16s8*//*Label 2511*/ GIMT_Encode4(126717),
     /* 126528 */ // Label 2508: @126528
     /* 126528 */ GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(126590), // Rule ID 1572 //
     /* 126533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126542 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126557 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126561 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126565 */   // MIs[1] Operand 1
     /* 126565 */   // No operand predicates
     /* 126565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126567 */   // (vector_insert:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi16),
     /* 126570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126574 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126576 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126582 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126588 */   GIR_RootConstrainSelectedInstOperands,
     /* 126589 */   // GIR_Coverage, 1572,
     /* 126589 */   GIR_EraseRootFromParent_Done,
     /* 126590 */ // Label 2513: @126590
     /* 126590 */ GIM_Reject,
     /* 126591 */ // Label 2509: @126591
     /* 126591 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(126653), // Rule ID 1571 //
     /* 126596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126628 */   // MIs[1] Operand 1
     /* 126628 */   // No operand predicates
     /* 126628 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126630 */   // (vector_insert:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi8),
     /* 126633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126635 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126637 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126639 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126645 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126651 */   GIR_RootConstrainSelectedInstOperands,
     /* 126652 */   // GIR_Coverage, 1571,
     /* 126652 */   GIR_EraseRootFromParent_Done,
     /* 126653 */ // Label 2514: @126653
     /* 126653 */ GIM_Reject,
     /* 126654 */ // Label 2510: @126654
     /* 126654 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(126716), // Rule ID 3436 //
     /* 126659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126691 */   // MIs[1] Operand 1
     /* 126691 */   // No operand predicates
     /* 126691 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126693 */   // (vector_insert:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_16),
     /* 126696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126698 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126700 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126702 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126714 */   GIR_RootConstrainSelectedInstOperands,
     /* 126715 */   // GIR_Coverage, 3436,
     /* 126715 */   GIR_EraseRootFromParent_Done,
     /* 126716 */ // Label 2515: @126716
     /* 126716 */ GIM_Reject,
     /* 126717 */ // Label 2511: @126717
     /* 126717 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(126779), // Rule ID 3435 //
     /* 126722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126746 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126750 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126754 */   // MIs[1] Operand 1
     /* 126754 */   // No operand predicates
     /* 126754 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126756 */   // (vector_insert:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_8),
     /* 126759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126761 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126763 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126765 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126771 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126777 */   GIR_RootConstrainSelectedInstOperands,
     /* 126778 */   // GIR_Coverage, 3435,
     /* 126778 */   GIR_EraseRootFromParent_Done,
     /* 126779 */ // Label 2516: @126779
     /* 126779 */ GIM_Reject,
     /* 126780 */ // Label 2512: @126780
     /* 126780 */ GIM_Reject,
     /* 126781 */ // Label 62: @126781
     /* 126781 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(126837), // Rule ID 1570 //
     /* 126786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_HasFastVGETLNi32),
     /* 126789 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 126792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126806 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126810 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126814 */   // MIs[1] Operand 1
     /* 126814 */   // No operand predicates
     /* 126814 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126816 */   // (extractelt:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)  =>  (VGETLNi32:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)
     /* 126816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VGETLNi32),
     /* 126819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[R]
     /* 126821 */   GIR_RootToRootCopy, /*OpIdx*/1, // V
     /* 126823 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126829 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126835 */   GIR_RootConstrainSelectedInstOperands,
     /* 126836 */   // GIR_Coverage, 1570,
     /* 126836 */   GIR_EraseRootFromParent_Done,
     /* 126837 */ // Label 2517: @126837
     /* 126837 */ GIM_Reject,
     /* 126838 */ // Label 63: @126838
     /* 126838 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2525*/ GIMT_Encode4(127398),
     /* 126849 */ /*GILLT_s32*//*Label 2518*/ GIMT_Encode4(126909), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126861 */ /*GILLT_v2s32*//*Label 2519*/ GIMT_Encode4(126987), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126873 */ /*GILLT_v4s16*//*Label 2520*/ GIMT_Encode4(127025),
     /* 126877 */ /*GILLT_v4s32*//*Label 2521*/ GIMT_Encode4(127063), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126889 */ /*GILLT_v8s8*//*Label 2522*/ GIMT_Encode4(127162),
     /* 126893 */ /*GILLT_v8s16*//*Label 2523*/ GIMT_Encode4(127200), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126905 */ /*GILLT_v16s8*//*Label 2524*/ GIMT_Encode4(127299),
     /* 126909 */ // Label 2518: @126909
     /* 126909 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(126986),
     /* 126914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126917 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(126951), // Rule ID 197 //
     /* 126922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 126925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126933 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLZ),
     /* 126936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126949 */     GIR_RootConstrainSelectedInstOperands,
     /* 126950 */     // GIR_Coverage, 197,
     /* 126950 */     GIR_EraseRootFromParent_Done,
     /* 126951 */   // Label 2527: @126951
     /* 126951 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(126985), // Rule ID 534 //
     /* 126956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 126959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126967 */     // (ctlz:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2CLZ:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 126967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLZ),
     /* 126970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126977 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126983 */     GIR_RootConstrainSelectedInstOperands,
     /* 126984 */     // GIR_Coverage, 534,
     /* 126984 */     GIR_EraseRootFromParent_Done,
     /* 126985 */   // Label 2528: @126985
     /* 126985 */   GIM_Reject,
     /* 126986 */ // Label 2526: @126986
     /* 126986 */ GIM_Reject,
     /* 126987 */ // Label 2519: @126987
     /* 126987 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(127024), // Rule ID 1548 //
     /* 126992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127006 */   // (ctlz:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCLZv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 127006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv2i32),
     /* 127009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127011 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127016 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127022 */   GIR_RootConstrainSelectedInstOperands,
     /* 127023 */   // GIR_Coverage, 1548,
     /* 127023 */   GIR_EraseRootFromParent_Done,
     /* 127024 */ // Label 2529: @127024
     /* 127024 */ GIM_Reject,
     /* 127025 */ // Label 2520: @127025
     /* 127025 */ GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(127062), // Rule ID 1547 //
     /* 127030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 127036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127044 */   // (ctlz:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCLZv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 127044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i16),
     /* 127047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127049 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127054 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127060 */   GIR_RootConstrainSelectedInstOperands,
     /* 127061 */   // GIR_Coverage, 1547,
     /* 127061 */   GIR_EraseRootFromParent_Done,
     /* 127062 */ // Label 2530: @127062
     /* 127062 */ GIM_Reject,
     /* 127063 */ // Label 2521: @127063
     /* 127063 */ GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(127161),
     /* 127068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127071 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(127105), // Rule ID 1551 //
     /* 127076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127087 */     // (ctlz:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCLZv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 127087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i32),
     /* 127090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127097 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127103 */     GIR_RootConstrainSelectedInstOperands,
     /* 127104 */     // GIR_Coverage, 1551,
     /* 127104 */     GIR_EraseRootFromParent_Done,
     /* 127105 */   // Label 2532: @127105
     /* 127105 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(127160), // Rule ID 3658 //
     /* 127110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127121 */     // (ctlz:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLZs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /* 127121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs32),
     /* 127136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127138 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127158 */     GIR_RootConstrainSelectedInstOperands,
     /* 127159 */     // GIR_Coverage, 3658,
     /* 127159 */     GIR_EraseRootFromParent_Done,
     /* 127160 */   // Label 2533: @127160
     /* 127160 */   GIM_Reject,
     /* 127161 */ // Label 2531: @127161
     /* 127161 */ GIM_Reject,
     /* 127162 */ // Label 2522: @127162
     /* 127162 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(127199), // Rule ID 1546 //
     /* 127167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127181 */   // (ctlz:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCLZv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i8),
     /* 127184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127186 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127191 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127197 */   GIR_RootConstrainSelectedInstOperands,
     /* 127198 */   // GIR_Coverage, 1546,
     /* 127198 */   GIR_EraseRootFromParent_Done,
     /* 127199 */ // Label 2534: @127199
     /* 127199 */ GIM_Reject,
     /* 127200 */ // Label 2523: @127200
     /* 127200 */ GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(127298),
     /* 127205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127208 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(127242), // Rule ID 1550 //
     /* 127213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127224 */     // (ctlz:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCLZv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 127224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i16),
     /* 127227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127240 */     GIR_RootConstrainSelectedInstOperands,
     /* 127241 */     // GIR_Coverage, 1550,
     /* 127241 */     GIR_EraseRootFromParent_Done,
     /* 127242 */   // Label 2536: @127242
     /* 127242 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(127297), // Rule ID 3656 //
     /* 127247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127258 */     // (ctlz:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLZs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /* 127258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs16),
     /* 127273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127275 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127295 */     GIR_RootConstrainSelectedInstOperands,
     /* 127296 */     // GIR_Coverage, 3656,
     /* 127296 */     GIR_EraseRootFromParent_Done,
     /* 127297 */   // Label 2537: @127297
     /* 127297 */   GIM_Reject,
     /* 127298 */ // Label 2535: @127298
     /* 127298 */ GIM_Reject,
     /* 127299 */ // Label 2524: @127299
     /* 127299 */ GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(127397),
     /* 127304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127307 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(127341), // Rule ID 1549 //
     /* 127312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127323 */     // (ctlz:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCLZv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv16i8),
     /* 127326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127339 */     GIR_RootConstrainSelectedInstOperands,
     /* 127340 */     // GIR_Coverage, 1549,
     /* 127340 */     GIR_EraseRootFromParent_Done,
     /* 127341 */   // Label 2539: @127341
     /* 127341 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(127396), // Rule ID 3654 //
     /* 127346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127357 */     // (ctlz:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLZs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /* 127357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs8),
     /* 127372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127374 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127385 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127394 */     GIR_RootConstrainSelectedInstOperands,
     /* 127395 */     // GIR_Coverage, 3654,
     /* 127395 */     GIR_EraseRootFromParent_Done,
     /* 127396 */   // Label 2540: @127396
     /* 127396 */   GIM_Reject,
     /* 127397 */ // Label 2538: @127397
     /* 127397 */ GIM_Reject,
     /* 127398 */ // Label 2525: @127398
     /* 127398 */ GIM_Reject,
     /* 127399 */ // Label 64: @127399
     /* 127399 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(11), GIMT_Encode2(16), /*)*//*default:*//*Label 2543*/ GIMT_Encode4(127506),
     /* 127410 */ /*GILLT_v8s8*//*Label 2541*/ GIMT_Encode4(127430), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127426 */ /*GILLT_v16s8*//*Label 2542*/ GIMT_Encode4(127468),
     /* 127430 */ // Label 2541: @127430
     /* 127430 */ GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(127467), // Rule ID 1552 //
     /* 127435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127449 */   // (ctpop:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCNTd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTd),
     /* 127452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127454 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127459 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127465 */   GIR_RootConstrainSelectedInstOperands,
     /* 127466 */   // GIR_Coverage, 1552,
     /* 127466 */   GIR_EraseRootFromParent_Done,
     /* 127467 */ // Label 2544: @127467
     /* 127467 */ GIM_Reject,
     /* 127468 */ // Label 2542: @127468
     /* 127468 */ GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(127505), // Rule ID 1553 //
     /* 127473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127487 */   // (ctpop:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCNTq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTq),
     /* 127490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127492 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127497 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127503 */   GIR_RootConstrainSelectedInstOperands,
     /* 127504 */   // GIR_Coverage, 1553,
     /* 127504 */   GIR_EraseRootFromParent_Done,
     /* 127505 */ // Label 2545: @127505
     /* 127505 */ GIM_Reject,
     /* 127506 */ // Label 2543: @127506
     /* 127506 */ GIM_Reject,
     /* 127507 */ // Label 65: @127507
     /* 127507 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2549*/ GIMT_Encode4(127796),
     /* 127518 */ /*GILLT_s32*//*Label 2546*/ GIMT_Encode4(127566), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127546 */ /*GILLT_v4s32*//*Label 2547*/ GIMT_Encode4(127678), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127562 */ /*GILLT_v8s16*//*Label 2548*/ GIMT_Encode4(127737),
     /* 127566 */ // Label 2546: @127566
     /* 127566 */ GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(127677),
     /* 127571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127574 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(127608), // Rule ID 199 //
     /* 127579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 127582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127590 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (REV:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV),
     /* 127593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127606 */     GIR_RootConstrainSelectedInstOperands,
     /* 127607 */     // GIR_Coverage, 199,
     /* 127607 */     GIR_EraseRootFromParent_Done,
     /* 127608 */   // Label 2551: @127608
     /* 127608 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(127642), // Rule ID 326 //
     /* 127613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 127616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127624 */     // (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)  =>  (tREV:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 127624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV),
     /* 127627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127640 */     GIR_RootConstrainSelectedInstOperands,
     /* 127641 */     // GIR_Coverage, 326,
     /* 127641 */     GIR_EraseRootFromParent_Done,
     /* 127642 */   // Label 2552: @127642
     /* 127642 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(127676), // Rule ID 536 //
     /* 127647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127658 */     // (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2REV:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV),
     /* 127661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127674 */     GIR_RootConstrainSelectedInstOperands,
     /* 127675 */     // GIR_Coverage, 536,
     /* 127675 */     GIR_EraseRootFromParent_Done,
     /* 127676 */   // Label 2553: @127676
     /* 127676 */   GIM_Reject,
     /* 127677 */ // Label 2550: @127677
     /* 127677 */ GIM_Reject,
     /* 127678 */ // Label 2547: @127678
     /* 127678 */ GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(127736), // Rule ID 3331 //
     /* 127683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127697 */   // (bswap:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 127697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /* 127712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127714 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127719 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127725 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127734 */   GIR_RootConstrainSelectedInstOperands,
     /* 127735 */   // GIR_Coverage, 3331,
     /* 127735 */   GIR_EraseRootFromParent_Done,
     /* 127736 */ // Label 2554: @127736
     /* 127736 */ GIM_Reject,
     /* 127737 */ // Label 2548: @127737
     /* 127737 */ GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(127795), // Rule ID 3330 //
     /* 127742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127756 */   // (bswap:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 127756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /* 127771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127778 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127784 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127793 */   GIR_RootConstrainSelectedInstOperands,
     /* 127794 */   // GIR_Coverage, 3330,
     /* 127794 */   GIR_EraseRootFromParent_Done,
     /* 127795 */ // Label 2555: @127795
     /* 127795 */ GIM_Reject,
     /* 127796 */ // Label 2549: @127796
     /* 127796 */ GIM_Reject,
     /* 127797 */ // Label 66: @127797
     /* 127797 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2560*/ GIMT_Encode4(128228),
     /* 127808 */ /*GILLT_s32*//*Label 2556*/ GIMT_Encode4(127868), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127836 */ /*GILLT_v4s32*//*Label 2557*/ GIMT_Encode4(127946), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127852 */ /*GILLT_v8s16*//*Label 2558*/ GIMT_Encode4(128040), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127864 */ /*GILLT_v16s8*//*Label 2559*/ GIMT_Encode4(128134),
     /* 127868 */ // Label 2556: @127868
     /* 127868 */ GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(127945),
     /* 127873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127876 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(127910), // Rule ID 198 //
     /* 127881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /* 127884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127892 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (RBIT:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RBIT),
     /* 127895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127908 */     GIR_RootConstrainSelectedInstOperands,
     /* 127909 */     // GIR_Coverage, 198,
     /* 127909 */     GIR_EraseRootFromParent_Done,
     /* 127910 */   // Label 2562: @127910
     /* 127910 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(127944), // Rule ID 535 //
     /* 127915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127926 */     // (bitreverse:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2RBIT:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RBIT),
     /* 127929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127942 */     GIR_RootConstrainSelectedInstOperands,
     /* 127943 */     // GIR_Coverage, 535,
     /* 127943 */     GIR_EraseRootFromParent_Done,
     /* 127944 */   // Label 2563: @127944
     /* 127944 */   GIM_Reject,
     /* 127945 */ // Label 2561: @127945
     /* 127945 */ GIM_Reject,
     /* 127946 */ // Label 2557: @127946
     /* 127946 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(128039), // Rule ID 4758 //
     /* 127951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127965 */   // (bitreverse:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1, (t2MOVi:{ *:[i32] } 32:{ *:[i32] }))
     /* 127965 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127968 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127972 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127977 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127984 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127989 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 127992 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127995 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128001 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /* 128012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128014 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128022 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128028 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128037 */   GIR_RootConstrainSelectedInstOperands,
     /* 128038 */   // GIR_Coverage, 4758,
     /* 128038 */   GIR_EraseRootFromParent_Done,
     /* 128039 */ // Label 2564: @128039
     /* 128039 */ GIM_Reject,
     /* 128040 */ // Label 2558: @128040
     /* 128040 */ GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(128133), // Rule ID 4759 //
     /* 128045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 128048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128059 */   // (bitreverse:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1, (t2MOVi:{ *:[i32] } 16:{ *:[i32] }))
     /* 128059 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 128062 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128066 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 128078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128083 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 128086 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 128089 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128095 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /* 128106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128108 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128116 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128122 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128131 */   GIR_RootConstrainSelectedInstOperands,
     /* 128132 */   // GIR_Coverage, 4759,
     /* 128132 */   GIR_EraseRootFromParent_Done,
     /* 128133 */ // Label 2565: @128133
     /* 128133 */ GIM_Reject,
     /* 128134 */ // Label 2559: @128134
     /* 128134 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(128227), // Rule ID 4757 //
     /* 128139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 128142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 128145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128153 */   // (bitreverse:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1, (t2MOVi:{ *:[i32] } 8:{ *:[i32] }))
     /* 128153 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 128156 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128160 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 128172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128177 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 128180 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 128183 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128189 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /* 128200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128202 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128210 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128216 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128222 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128225 */   GIR_RootConstrainSelectedInstOperands,
     /* 128226 */   // GIR_Coverage, 4757,
     /* 128226 */   GIR_EraseRootFromParent_Done,
     /* 128227 */ // Label 2566: @128227
     /* 128227 */ GIM_Reject,
     /* 128228 */ // Label 2560: @128228
     /* 128228 */ GIM_Reject,
     /* 128229 */ // Label 67: @128229
     /* 128229 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2572*/ GIMT_Encode4(128491),
     /* 128240 */ /*GILLT_s16*//*Label 2567*/ GIMT_Encode4(128292),
     /* 128244 */ /*GILLT_s32*//*Label 2568*/ GIMT_Encode4(128319),
     /* 128248 */ /*GILLT_s64*//*Label 2569*/ GIMT_Encode4(128346), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128272 */ /*GILLT_v4s32*//*Label 2570*/ GIMT_Encode4(128373), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128288 */ /*GILLT_v8s16*//*Label 2571*/ GIMT_Encode4(128432),
     /* 128292 */ // Label 2567: @128292
     /* 128292 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(128318), // Rule ID 683 //
     /* 128297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128311 */   // (fceil:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTPH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPH),
     /* 128316 */   GIR_RootConstrainSelectedInstOperands,
     /* 128317 */   // GIR_Coverage, 683,
     /* 128317 */   GIR_Done,
     /* 128318 */ // Label 2573: @128318
     /* 128318 */ GIM_Reject,
     /* 128319 */ // Label 2568: @128319
     /* 128319 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(128345), // Rule ID 684 //
     /* 128324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128338 */   // (fceil:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTPS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPS),
     /* 128343 */   GIR_RootConstrainSelectedInstOperands,
     /* 128344 */   // GIR_Coverage, 684,
     /* 128344 */   GIR_Done,
     /* 128345 */ // Label 2574: @128345
     /* 128345 */ GIM_Reject,
     /* 128346 */ // Label 2569: @128346
     /* 128346 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(128372), // Rule ID 685 //
     /* 128351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128365 */   // (fceil:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTPD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPD),
     /* 128370 */   GIR_RootConstrainSelectedInstOperands,
     /* 128371 */   // GIR_Coverage, 685,
     /* 128371 */   GIR_Done,
     /* 128372 */ // Label 2575: @128372
     /* 128372 */ GIM_Reject,
     /* 128373 */ // Label 2570: @128373
     /* 128373 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(128431), // Rule ID 3986 //
     /* 128378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128392 */   // (fceil:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32P:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32P),
     /* 128407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128409 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128420 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128429 */   GIR_RootConstrainSelectedInstOperands,
     /* 128430 */   // GIR_Coverage, 3986,
     /* 128430 */   GIR_EraseRootFromParent_Done,
     /* 128431 */ // Label 2576: @128431
     /* 128431 */ GIM_Reject,
     /* 128432 */ // Label 2571: @128432
     /* 128432 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(128490), // Rule ID 3974 //
     /* 128437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128451 */   // (fceil:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16P:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128451 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128454 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128458 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16P),
     /* 128466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128468 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128473 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128479 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128485 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128488 */   GIR_RootConstrainSelectedInstOperands,
     /* 128489 */   // GIR_Coverage, 3974,
     /* 128489 */   GIR_EraseRootFromParent_Done,
     /* 128490 */ // Label 2577: @128490
     /* 128490 */ GIM_Reject,
     /* 128491 */ // Label 2572: @128491
     /* 128491 */ GIM_Reject,
     /* 128492 */ // Label 68: @128492
     /* 128492 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2581*/ GIMT_Encode4(128629),
     /* 128503 */ /*GILLT_s16*//*Label 2578*/ GIMT_Encode4(128515),
     /* 128507 */ /*GILLT_s32*//*Label 2579*/ GIMT_Encode4(128553),
     /* 128511 */ /*GILLT_s64*//*Label 2580*/ GIMT_Encode4(128591),
     /* 128515 */ // Label 2578: @128515
     /* 128515 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(128552), // Rule ID 691 //
     /* 128520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128534 */   // (fsqrt:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VSQRTH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTH),
     /* 128537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128539 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128544 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128550 */   GIR_RootConstrainSelectedInstOperands,
     /* 128551 */   // GIR_Coverage, 691,
     /* 128551 */   GIR_EraseRootFromParent_Done,
     /* 128552 */ // Label 2582: @128552
     /* 128552 */ GIM_Reject,
     /* 128553 */ // Label 2579: @128553
     /* 128553 */ GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(128590), // Rule ID 690 //
     /* 128558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 128561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128572 */   // (fsqrt:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VSQRTS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTS),
     /* 128575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128577 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128582 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128588 */   GIR_RootConstrainSelectedInstOperands,
     /* 128589 */   // GIR_Coverage, 690,
     /* 128589 */   GIR_EraseRootFromParent_Done,
     /* 128590 */ // Label 2583: @128590
     /* 128590 */ GIM_Reject,
     /* 128591 */ // Label 2580: @128591
     /* 128591 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(128628), // Rule ID 689 //
     /* 128596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 128599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128610 */   // (fsqrt:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VSQRTD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTD),
     /* 128613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128615 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128620 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128626 */   GIR_RootConstrainSelectedInstOperands,
     /* 128627 */   // GIR_Coverage, 689,
     /* 128627 */   GIR_EraseRootFromParent_Done,
     /* 128628 */ // Label 2584: @128628
     /* 128628 */ GIM_Reject,
     /* 128629 */ // Label 2581: @128629
     /* 128629 */ GIM_Reject,
     /* 128630 */ // Label 69: @128630
     /* 128630 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2590*/ GIMT_Encode4(128892),
     /* 128641 */ /*GILLT_s16*//*Label 2585*/ GIMT_Encode4(128693),
     /* 128645 */ /*GILLT_s32*//*Label 2586*/ GIMT_Encode4(128720),
     /* 128649 */ /*GILLT_s64*//*Label 2587*/ GIMT_Encode4(128747), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128673 */ /*GILLT_v4s32*//*Label 2588*/ GIMT_Encode4(128774), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128689 */ /*GILLT_v8s16*//*Label 2589*/ GIMT_Encode4(128833),
     /* 128693 */ // Label 2585: @128693
     /* 128693 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(128719), // Rule ID 686 //
     /* 128698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128712 */   // (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTMH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMH),
     /* 128717 */   GIR_RootConstrainSelectedInstOperands,
     /* 128718 */   // GIR_Coverage, 686,
     /* 128718 */   GIR_Done,
     /* 128719 */ // Label 2591: @128719
     /* 128719 */ GIM_Reject,
     /* 128720 */ // Label 2586: @128720
     /* 128720 */ GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(128746), // Rule ID 687 //
     /* 128725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128739 */   // (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTMS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMS),
     /* 128744 */   GIR_RootConstrainSelectedInstOperands,
     /* 128745 */   // GIR_Coverage, 687,
     /* 128745 */   GIR_Done,
     /* 128746 */ // Label 2592: @128746
     /* 128746 */ GIM_Reject,
     /* 128747 */ // Label 2587: @128747
     /* 128747 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(128773), // Rule ID 688 //
     /* 128752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128766 */   // (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTMD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMD),
     /* 128771 */   GIR_RootConstrainSelectedInstOperands,
     /* 128772 */   // GIR_Coverage, 688,
     /* 128772 */   GIR_Done,
     /* 128773 */ // Label 2593: @128773
     /* 128773 */ GIM_Reject,
     /* 128774 */ // Label 2588: @128774
     /* 128774 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(128832), // Rule ID 3984 //
     /* 128779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128793 */   // (ffloor:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32M:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32M),
     /* 128808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128810 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128815 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128821 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128830 */   GIR_RootConstrainSelectedInstOperands,
     /* 128831 */   // GIR_Coverage, 3984,
     /* 128831 */   GIR_EraseRootFromParent_Done,
     /* 128832 */ // Label 2594: @128832
     /* 128832 */ GIM_Reject,
     /* 128833 */ // Label 2589: @128833
     /* 128833 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(128891), // Rule ID 3972 //
     /* 128838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128852 */   // (ffloor:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16M:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128852 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128855 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128859 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16M),
     /* 128867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128869 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128874 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128880 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128889 */   GIR_RootConstrainSelectedInstOperands,
     /* 128890 */   // GIR_Coverage, 3972,
     /* 128890 */   GIR_EraseRootFromParent_Done,
     /* 128891 */ // Label 2595: @128891
     /* 128891 */ GIM_Reject,
     /* 128892 */ // Label 2590: @128892
     /* 128892 */ GIM_Reject,
     /* 128893 */ // Label 70: @128893
     /* 128893 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2601*/ GIMT_Encode4(129188),
     /* 128904 */ /*GILLT_s16*//*Label 2596*/ GIMT_Encode4(128956),
     /* 128908 */ /*GILLT_s32*//*Label 2597*/ GIMT_Encode4(128994),
     /* 128912 */ /*GILLT_s64*//*Label 2598*/ GIMT_Encode4(129032), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128936 */ /*GILLT_v4s32*//*Label 2599*/ GIMT_Encode4(129070), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128952 */ /*GILLT_v8s16*//*Label 2600*/ GIMT_Encode4(129129),
     /* 128956 */ // Label 2596: @128956
     /* 128956 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(128993), // Rule ID 671 //
     /* 128961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128975 */   // (frint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTXH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXH),
     /* 128978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128980 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128985 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128991 */   GIR_RootConstrainSelectedInstOperands,
     /* 128992 */   // GIR_Coverage, 671,
     /* 128992 */   GIR_EraseRootFromParent_Done,
     /* 128993 */ // Label 2602: @128993
     /* 128993 */ GIM_Reject,
     /* 128994 */ // Label 2597: @128994
     /* 128994 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(129031), // Rule ID 672 //
     /* 128999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129013 */   // (frint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTXS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXS),
     /* 129016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129018 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129023 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129029 */   GIR_RootConstrainSelectedInstOperands,
     /* 129030 */   // GIR_Coverage, 672,
     /* 129030 */   GIR_EraseRootFromParent_Done,
     /* 129031 */ // Label 2603: @129031
     /* 129031 */ GIM_Reject,
     /* 129032 */ // Label 2598: @129032
     /* 129032 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(129069), // Rule ID 673 //
     /* 129037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129051 */   // (frint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTXD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXD),
     /* 129054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129056 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129061 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129067 */   GIR_RootConstrainSelectedInstOperands,
     /* 129068 */   // GIR_Coverage, 673,
     /* 129068 */   GIR_EraseRootFromParent_Done,
     /* 129069 */ // Label 2604: @129069
     /* 129069 */ GIM_Reject,
     /* 129070 */ // Label 2599: @129070
     /* 129070 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(129128), // Rule ID 3978 //
     /* 129075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129089 */   // (frint:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32X:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 129089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32X),
     /* 129104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129106 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129111 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129117 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129126 */   GIR_RootConstrainSelectedInstOperands,
     /* 129127 */   // GIR_Coverage, 3978,
     /* 129127 */   GIR_EraseRootFromParent_Done,
     /* 129128 */ // Label 2605: @129128
     /* 129128 */ GIM_Reject,
     /* 129129 */ // Label 2600: @129129
     /* 129129 */ GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(129187), // Rule ID 3966 //
     /* 129134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129148 */   // (frint:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16X:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 129148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16X),
     /* 129163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129165 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129170 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129176 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129185 */   GIR_RootConstrainSelectedInstOperands,
     /* 129186 */   // GIR_Coverage, 3966,
     /* 129186 */   GIR_EraseRootFromParent_Done,
     /* 129187 */ // Label 2606: @129187
     /* 129187 */ GIM_Reject,
     /* 129188 */ // Label 2601: @129188
     /* 129188 */ GIM_Reject,
     /* 129189 */ // Label 71: @129189
     /* 129189 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2610*/ GIMT_Encode4(129326),
     /* 129200 */ /*GILLT_s16*//*Label 2607*/ GIMT_Encode4(129212),
     /* 129204 */ /*GILLT_s32*//*Label 2608*/ GIMT_Encode4(129250),
     /* 129208 */ /*GILLT_s64*//*Label 2609*/ GIMT_Encode4(129288),
     /* 129212 */ // Label 2607: @129212
     /* 129212 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(129249), // Rule ID 668 //
     /* 129217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 129220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 129223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129231 */   // (fnearbyint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTRH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 129231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRH),
     /* 129234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129236 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129241 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129247 */   GIR_RootConstrainSelectedInstOperands,
     /* 129248 */   // GIR_Coverage, 668,
     /* 129248 */   GIR_EraseRootFromParent_Done,
     /* 129249 */ // Label 2611: @129249
     /* 129249 */ GIM_Reject,
     /* 129250 */ // Label 2608: @129250
     /* 129250 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(129287), // Rule ID 669 //
     /* 129255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129269 */   // (fnearbyint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRS),
     /* 129272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129274 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129279 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129285 */   GIR_RootConstrainSelectedInstOperands,
     /* 129286 */   // GIR_Coverage, 669,
     /* 129286 */   GIR_EraseRootFromParent_Done,
     /* 129287 */ // Label 2612: @129287
     /* 129287 */ GIM_Reject,
     /* 129288 */ // Label 2609: @129288
     /* 129288 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(129325), // Rule ID 670 //
     /* 129293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129307 */   // (fnearbyint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTRD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRD),
     /* 129310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129312 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129317 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129323 */   GIR_RootConstrainSelectedInstOperands,
     /* 129324 */   // GIR_Coverage, 670,
     /* 129324 */   GIR_EraseRootFromParent_Done,
     /* 129325 */ // Label 2613: @129325
     /* 129325 */ GIM_Reject,
     /* 129326 */ // Label 2610: @129326
     /* 129326 */ GIM_Reject,
     /* 129327 */ // Label 72: @129327
     /* 129327 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(129342), // Rule ID 12 //
     /* 129332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_UseNaClTrap),
     /* 129335 */   // (trap)  =>  (TRAPNaCl)
     /* 129335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAPNaCl),
     /* 129340 */   GIR_RootConstrainSelectedInstOperands,
     /* 129341 */   // GIR_Coverage, 12,
     /* 129341 */   GIR_Done,
     /* 129342 */ // Label 2614: @129342
     /* 129342 */ GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(129357), // Rule ID 13 //
     /* 129347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNaClTrap_IsARM),
     /* 129350 */   // (trap)  =>  (TRAP)
     /* 129350 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAP),
     /* 129355 */   GIR_RootConstrainSelectedInstOperands,
     /* 129356 */   // GIR_Coverage, 13,
     /* 129356 */   GIR_Done,
     /* 129357 */ // Label 2615: @129357
     /* 129357 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(129372), // Rule ID 285 //
     /* 129362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 129365 */   // (trap)  =>  (tTRAP)
     /* 129365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::tTRAP),
     /* 129370 */   GIR_RootConstrainSelectedInstOperands,
     /* 129371 */   // GIR_Coverage, 285,
     /* 129371 */   GIR_Done,
     /* 129372 */ // Label 2616: @129372
     /* 129372 */ GIM_Reject,
     /* 129373 */ // Label 73: @129373
     /* 129373 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(129389), // Rule ID 1838 //
     /* 129378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 129381 */   // (debugtrap)  =>  (BKPT 0:{ *:[i32] })
     /* 129381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BKPT),
     /* 129384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129387 */   GIR_RootConstrainSelectedInstOperands,
     /* 129388 */   // GIR_Coverage, 1838,
     /* 129388 */   GIR_EraseRootFromParent_Done,
     /* 129389 */ // Label 2617: @129389
     /* 129389 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(129416), // Rule ID 1839 //
     /* 129394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV5T),
     /* 129397 */   // (debugtrap)  =>  (UDF 254:{ *:[i32] })
     /* 129397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /* 129400 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129414 */   GIR_RootConstrainSelectedInstOperands,
     /* 129415 */   // GIR_Coverage, 1839,
     /* 129415 */   GIR_EraseRootFromParent_Done,
     /* 129416 */ // Label 2618: @129416
     /* 129416 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(129432), // Rule ID 2024 //
     /* 129421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsThumb),
     /* 129424 */   // (debugtrap)  =>  (tBKPT 0:{ *:[i32] })
     /* 129424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBKPT),
     /* 129427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129430 */   GIR_RootConstrainSelectedInstOperands,
     /* 129431 */   // GIR_Coverage, 2024,
     /* 129431 */   GIR_EraseRootFromParent_Done,
     /* 129432 */ // Label 2619: @129432
     /* 129432 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(129459), // Rule ID 2025 //
     /* 129437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_NoV5T),
     /* 129440 */   // (debugtrap)  =>  (tUDF 254:{ *:[i32] })
     /* 129440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /* 129443 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129457 */   GIR_RootConstrainSelectedInstOperands,
     /* 129458 */   // GIR_Coverage, 2025,
     /* 129458 */   GIR_EraseRootFromParent_Done,
     /* 129459 */ // Label 2620: @129459
     /* 129459 */ GIM_Reject,
     /* 129460 */ // Label 74: @129460
     /* 129460 */ GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(129880),
     /* 129465 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129468 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2625*/ GIMT_Encode4(129766),
     /* 129479 */   /*GILLT_v4s32*//*Label 2622*/ GIMT_Encode4(129511), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129495 */   /*GILLT_v8s16*//*Label 2623*/ GIMT_Encode4(129582), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129507 */   /*GILLT_v16s8*//*Label 2624*/ GIMT_Encode4(129653),
     /* 129511 */   // Label 2622: @129511
     /* 129511 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(129581), // Rule ID 3241 //
     /* 129516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129551 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2))  =>  (MVE_VMLADAVu32:{ *:[i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 129551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /* 129554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129579 */     GIR_RootConstrainSelectedInstOperands,
     /* 129580 */     // GIR_Coverage, 3241,
     /* 129580 */     GIR_EraseRootFromParent_Done,
     /* 129581 */   // Label 2626: @129581
     /* 129581 */   GIM_Reject,
     /* 129582 */   // Label 2623: @129582
     /* 129582 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(129652), // Rule ID 3242 //
     /* 129587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129622 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2))  =>  (MVE_VMLADAVu16:{ *:[i32] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 129622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /* 129625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129650 */     GIR_RootConstrainSelectedInstOperands,
     /* 129651 */     // GIR_Coverage, 3242,
     /* 129651 */     GIR_EraseRootFromParent_Done,
     /* 129652 */   // Label 2627: @129652
     /* 129652 */   GIM_Reject,
     /* 129653 */   // Label 2624: @129653
     /* 129653 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(129765),
     /* 129658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129662 */     GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(129728), // Rule ID 3245 //
     /* 129667 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129670 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129674 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129678 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129682 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 129686 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129691 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129696 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129698 */       // (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2))  =>  (MVE_VMLADAVu8:{ *:[i32] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 129698 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /* 129701 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129703 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129707 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129711 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129714 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129720 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129726 */       GIR_RootConstrainSelectedInstOperands,
     /* 129727 */       // GIR_Coverage, 3245,
     /* 129727 */       GIR_EraseRootFromParent_Done,
     /* 129728 */     // Label 2629: @129728
     /* 129728 */     GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(129764), // Rule ID 3049 //
     /* 129733 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129736 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129740 */       // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VADDVu8no_acc:{ *:[i32] } ?:{ *:[v16i8] }:$vec)
     /* 129740 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8no_acc),
     /* 129743 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129745 */       GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129747 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129750 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129756 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129762 */       GIR_RootConstrainSelectedInstOperands,
     /* 129763 */       // GIR_Coverage, 3049,
     /* 129763 */       GIR_EraseRootFromParent_Done,
     /* 129764 */     // Label 2630: @129764
     /* 129764 */     GIM_Reject,
     /* 129765 */   // Label 2628: @129765
     /* 129765 */   GIM_Reject,
     /* 129766 */   // Label 2625: @129766
     /* 129766 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 2633*/ GIMT_Encode4(129879),
     /* 129777 */   /*GILLT_v4s32*//*Label 2631*/ GIMT_Encode4(129797), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129793 */   /*GILLT_v8s16*//*Label 2632*/ GIMT_Encode4(129838),
     /* 129797 */   // Label 2631: @129797
     /* 129797 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(129837), // Rule ID 3087 //
     /* 129802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129813 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VADDVu32no_acc:{ *:[i32] } ?:{ *:[v4i32] }:$vec)
     /* 129813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32no_acc),
     /* 129816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129818 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129835 */     GIR_RootConstrainSelectedInstOperands,
     /* 129836 */     // GIR_Coverage, 3087,
     /* 129836 */     GIR_EraseRootFromParent_Done,
     /* 129837 */   // Label 2634: @129837
     /* 129837 */   GIM_Reject,
     /* 129838 */   // Label 2632: @129838
     /* 129838 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(129878), // Rule ID 3077 //
     /* 129843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129854 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VADDVu16no_acc:{ *:[i32] } ?:{ *:[v8i16] }:$vec)
     /* 129854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16no_acc),
     /* 129857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129859 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129876 */     GIR_RootConstrainSelectedInstOperands,
     /* 129877 */     // GIR_Coverage, 3077,
     /* 129877 */     GIR_EraseRootFromParent_Done,
     /* 129878 */   // Label 2635: @129878
     /* 129878 */   GIM_Reject,
     /* 129879 */   // Label 2633: @129879
     /* 129879 */   GIM_Reject,
     /* 129880 */ // Label 2621: @129880
     /* 129880 */ GIM_Reject,
     /* 129881 */ // Label 75: @129881
     /* 129881 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(130160),
     /* 129886 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129889 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2640*/ GIMT_Encode4(130159),
     /* 129900 */   /*GILLT_v4s32*//*Label 2637*/ GIMT_Encode4(129932), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129916 */   /*GILLT_v8s16*//*Label 2638*/ GIMT_Encode4(130015), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129928 */   /*GILLT_v16s8*//*Label 2639*/ GIMT_Encode4(130083),
     /* 129932 */   // Label 2637: @129932
     /* 129932 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(130014), // Rule ID 3147 //
     /* 129937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129948 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVs32:{ *:[i32] } (t2MOVi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 129955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129960 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129970 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129973 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129979 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /* 129990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129995 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130012 */     GIR_RootConstrainSelectedInstOperands,
     /* 130013 */     // GIR_Coverage, 3147,
     /* 130013 */     GIR_EraseRootFromParent_Done,
     /* 130014 */   // Label 2641: @130014
     /* 130014 */   GIM_Reject,
     /* 130015 */   // Label 2638: @130015
     /* 130015 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(130082), // Rule ID 3146 //
     /* 130020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130031 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVs16:{ *:[i32] } (t2MOVi32imm:{ *:[i32] } -32768:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /* 130038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130043 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 130053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /* 130058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130063 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130080 */     GIR_RootConstrainSelectedInstOperands,
     /* 130081 */     // GIR_Coverage, 3146,
     /* 130081 */     GIR_EraseRootFromParent_Done,
     /* 130082 */   // Label 2642: @130082
     /* 130082 */   GIM_Reject,
     /* 130083 */   // Label 2639: @130083
     /* 130083 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(130158), // Rule ID 3145 //
     /* 130088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130099 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVs8:{ *:[i32] } (t2MVNi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130111 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130117 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130123 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /* 130134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130139 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130156 */     GIR_RootConstrainSelectedInstOperands,
     /* 130157 */     // GIR_Coverage, 3145,
     /* 130157 */     GIR_EraseRootFromParent_Done,
     /* 130158 */   // Label 2643: @130158
     /* 130158 */   GIM_Reject,
     /* 130159 */   // Label 2640: @130159
     /* 130159 */   GIM_Reject,
     /* 130160 */ // Label 2636: @130160
     /* 130160 */ GIM_Reject,
     /* 130161 */ // Label 76: @130161
     /* 130161 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(130449),
     /* 130166 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130169 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2648*/ GIMT_Encode4(130448),
     /* 130180 */   /*GILLT_v4s32*//*Label 2645*/ GIMT_Encode4(130212), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130196 */   /*GILLT_v8s16*//*Label 2646*/ GIMT_Encode4(130295), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130208 */   /*GILLT_v16s8*//*Label 2647*/ GIMT_Encode4(130372),
     /* 130212 */   // Label 2645: @130212
     /* 130212 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(130294), // Rule ID 3153 //
     /* 130217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130228 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVs32:{ *:[i32] } (t2MVNi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130240 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 130250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130253 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130259 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /* 130270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130275 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130292 */     GIR_RootConstrainSelectedInstOperands,
     /* 130293 */     // GIR_Coverage, 3153,
     /* 130293 */     GIR_EraseRootFromParent_Done,
     /* 130294 */   // Label 2649: @130294
     /* 130294 */   GIM_Reject,
     /* 130295 */   // Label 2646: @130295
     /* 130295 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(130371), // Rule ID 3152 //
     /* 130300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130311 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVs16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 32767:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130323 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 130333 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130336 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /* 130347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130352 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130369 */     GIR_RootConstrainSelectedInstOperands,
     /* 130370 */     // GIR_Coverage, 3152,
     /* 130370 */     GIR_EraseRootFromParent_Done,
     /* 130371 */   // Label 2650: @130371
     /* 130371 */   GIM_Reject,
     /* 130372 */   // Label 2647: @130372
     /* 130372 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(130447), // Rule ID 3151 //
     /* 130377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130388 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVs8:{ *:[i32] } (t2MOVi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130400 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130403 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130406 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130412 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /* 130423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130445 */     GIR_RootConstrainSelectedInstOperands,
     /* 130446 */     // GIR_Coverage, 3151,
     /* 130446 */     GIR_EraseRootFromParent_Done,
     /* 130447 */   // Label 2651: @130447
     /* 130447 */   GIM_Reject,
     /* 130448 */   // Label 2648: @130448
     /* 130448 */   GIM_Reject,
     /* 130449 */ // Label 2644: @130449
     /* 130449 */ GIM_Reject,
     /* 130450 */ // Label 77: @130450
     /* 130450 */ GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(130730),
     /* 130455 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130458 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2656*/ GIMT_Encode4(130729),
     /* 130469 */   /*GILLT_v4s32*//*Label 2653*/ GIMT_Encode4(130501), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130485 */   /*GILLT_v8s16*//*Label 2654*/ GIMT_Encode4(130577), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130497 */   /*GILLT_v16s8*//*Label 2655*/ GIMT_Encode4(130653),
     /* 130501 */   // Label 2653: @130501
     /* 130501 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(130576), // Rule ID 3150 //
     /* 130506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130517 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130529 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130532 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130535 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130541 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /* 130552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130557 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130574 */     GIR_RootConstrainSelectedInstOperands,
     /* 130575 */     // GIR_Coverage, 3150,
     /* 130575 */     GIR_EraseRootFromParent_Done,
     /* 130576 */   // Label 2657: @130576
     /* 130576 */   GIM_Reject,
     /* 130577 */   // Label 2654: @130577
     /* 130577 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(130652), // Rule ID 3149 //
     /* 130582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130593 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVu16:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130605 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130608 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130611 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130617 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /* 130628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130633 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130650 */     GIR_RootConstrainSelectedInstOperands,
     /* 130651 */     // GIR_Coverage, 3149,
     /* 130651 */     GIR_EraseRootFromParent_Done,
     /* 130652 */   // Label 2658: @130652
     /* 130652 */   GIM_Reject,
     /* 130653 */   // Label 2655: @130653
     /* 130653 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(130728), // Rule ID 3148 //
     /* 130658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130669 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130681 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130684 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130687 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130693 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /* 130704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130709 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130726 */     GIR_RootConstrainSelectedInstOperands,
     /* 130727 */     // GIR_Coverage, 3148,
     /* 130727 */     GIR_EraseRootFromParent_Done,
     /* 130728 */   // Label 2659: @130728
     /* 130728 */   GIM_Reject,
     /* 130729 */   // Label 2656: @130729
     /* 130729 */   GIM_Reject,
     /* 130730 */ // Label 2652: @130730
     /* 130730 */ GIM_Reject,
     /* 130731 */ // Label 78: @130731
     /* 130731 */ GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(131026),
     /* 130736 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130739 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2664*/ GIMT_Encode4(131025),
     /* 130750 */   /*GILLT_v4s32*//*Label 2661*/ GIMT_Encode4(130782), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130766 */   /*GILLT_v8s16*//*Label 2662*/ GIMT_Encode4(130865), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130778 */   /*GILLT_v16s8*//*Label 2663*/ GIMT_Encode4(130942),
     /* 130782 */   // Label 2661: @130782
     /* 130782 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(130864), // Rule ID 3156 //
     /* 130787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130798 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 4294967295:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130810 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(4294967295),
     /* 130820 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130823 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130829 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /* 130840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130845 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130862 */     GIR_RootConstrainSelectedInstOperands,
     /* 130863 */     // GIR_Coverage, 3156,
     /* 130863 */     GIR_EraseRootFromParent_Done,
     /* 130864 */   // Label 2665: @130864
     /* 130864 */   GIM_Reject,
     /* 130865 */   // Label 2662: @130865
     /* 130865 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(130941), // Rule ID 3155 //
     /* 130870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130881 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVu16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130893 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 130903 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130906 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /* 130917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130939 */     GIR_RootConstrainSelectedInstOperands,
     /* 130940 */     // GIR_Coverage, 3155,
     /* 130940 */     GIR_EraseRootFromParent_Done,
     /* 130941 */   // Label 2666: @130941
     /* 130941 */   GIM_Reject,
     /* 130942 */   // Label 2663: @130942
     /* 130942 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(131024), // Rule ID 3154 //
     /* 130947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130958 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 255:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130970 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(255),
     /* 130980 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130983 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130989 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /* 131000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 131002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131005 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 131007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131022 */     GIR_RootConstrainSelectedInstOperands,
     /* 131023 */     // GIR_Coverage, 3154,
     /* 131023 */     GIR_EraseRootFromParent_Done,
     /* 131024 */   // Label 2667: @131024
     /* 131024 */   GIM_Reject,
     /* 131025 */   // Label 2664: @131025
     /* 131025 */   GIM_Reject,
     /* 131026 */ // Label 2660: @131026
     /* 131026 */ GIM_Reject,
     /* 131027 */ // Label 79: @131027
     /* 131027 */ GIM_Reject,
     /* 131028 */ }; // Size: 131028 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
