/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * Sparc Disassembler                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static void insertBits(InsnType &field, InsnType bits, unsigned startBit,
                       unsigned numBits) {
  if constexpr (std::is_integral<InsnType>::value) {
    assert(startBit + numBits <= sizeof field * 8);
    (void)numBits;
    field |= (InsnType)bits << startBit;
  } else {
    field.insertBits(bits, startBit, numBits);
  }
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTableSparc32[] = {
/* 0 */       MCD::OPC_ExtractField, 30, 2,  // Inst{31-30} ...
/* 3 */       MCD::OPC_FilterValue, 0, 205, 1, // Skip to: 468
/* 7 */       MCD::OPC_ExtractField, 22, 3,  // Inst{24-22} ...
/* 10 */      MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 24
/* 14 */      MCD::OPC_CheckField, 25, 5, 0, 235, 26, // Skip to: 6911
/* 20 */      MCD::OPC_Decode, 174, 6, 0, // Opcode: UNIMP
/* 24 */      MCD::OPC_FilterValue, 1, 111, 0, // Skip to: 139
/* 28 */      MCD::OPC_ExtractField, 19, 3,  // Inst{21-19} ...
/* 31 */      MCD::OPC_FilterValue, 0, 27, 0, // Skip to: 62
/* 35 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 38 */      MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 50
/* 42 */      MCD::OPC_CheckPredicate, 0, 209, 26, // Skip to: 6911
/* 46 */      MCD::OPC_Decode, 237, 2, 1, // Opcode: BPICCNT
/* 50 */      MCD::OPC_FilterValue, 1, 201, 26, // Skip to: 6911
/* 54 */      MCD::OPC_CheckPredicate, 0, 197, 26, // Skip to: 6911
/* 58 */      MCD::OPC_Decode, 236, 2, 1, // Opcode: BPICCANT
/* 62 */      MCD::OPC_FilterValue, 1, 27, 0, // Skip to: 93
/* 66 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 69 */      MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 81
/* 73 */      MCD::OPC_CheckPredicate, 0, 178, 26, // Skip to: 6911
/* 77 */      MCD::OPC_Decode, 234, 2, 1, // Opcode: BPICC
/* 81 */      MCD::OPC_FilterValue, 1, 170, 26, // Skip to: 6911
/* 85 */      MCD::OPC_CheckPredicate, 0, 166, 26, // Skip to: 6911
/* 89 */      MCD::OPC_Decode, 235, 2, 1, // Opcode: BPICCA
/* 93 */      MCD::OPC_FilterValue, 4, 19, 0, // Skip to: 116
/* 97 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 100 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 108
/* 104 */     MCD::OPC_Decode, 245, 2, 1, // Opcode: BPXCCNT
/* 108 */     MCD::OPC_FilterValue, 1, 143, 26, // Skip to: 6911
/* 112 */     MCD::OPC_Decode, 244, 2, 1, // Opcode: BPXCCANT
/* 116 */     MCD::OPC_FilterValue, 5, 135, 26, // Skip to: 6911
/* 120 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 123 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 131
/* 127 */     MCD::OPC_Decode, 242, 2, 1, // Opcode: BPXCC
/* 131 */     MCD::OPC_FilterValue, 1, 120, 26, // Skip to: 6911
/* 135 */     MCD::OPC_Decode, 243, 2, 1, // Opcode: BPXCCA
/* 139 */     MCD::OPC_FilterValue, 2, 29, 0, // Skip to: 172
/* 143 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 146 */     MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 164
/* 150 */     MCD::OPC_CheckField, 25, 4, 8, 4, 0, // Skip to: 160
/* 156 */     MCD::OPC_Decode, 224, 2, 2, // Opcode: BA
/* 160 */     MCD::OPC_Decode, 225, 2, 3, // Opcode: BCOND
/* 164 */     MCD::OPC_FilterValue, 1, 87, 26, // Skip to: 6911
/* 168 */     MCD::OPC_Decode, 226, 2, 3, // Opcode: BCONDA
/* 172 */     MCD::OPC_FilterValue, 3, 125, 0, // Skip to: 301
/* 176 */     MCD::OPC_ExtractField, 28, 1,  // Inst{28} ...
/* 179 */     MCD::OPC_FilterValue, 0, 49, 0, // Skip to: 232
/* 183 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 186 */     MCD::OPC_FilterValue, 0, 19, 0, // Skip to: 209
/* 190 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 193 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 201
/* 197 */     MCD::OPC_Decode, 241, 2, 4, // Opcode: BPRNT
/* 201 */     MCD::OPC_FilterValue, 1, 50, 26, // Skip to: 6911
/* 205 */     MCD::OPC_Decode, 240, 2, 4, // Opcode: BPRANT
/* 209 */     MCD::OPC_FilterValue, 1, 42, 26, // Skip to: 6911
/* 213 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 216 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 224
/* 220 */     MCD::OPC_Decode, 238, 2, 4, // Opcode: BPR
/* 224 */     MCD::OPC_FilterValue, 1, 27, 26, // Skip to: 6911
/* 228 */     MCD::OPC_Decode, 239, 2, 4, // Opcode: BPRA
/* 232 */     MCD::OPC_FilterValue, 1, 19, 26, // Skip to: 6911
/* 236 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 239 */     MCD::OPC_FilterValue, 0, 27, 0, // Skip to: 270
/* 243 */     MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 246 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 258
/* 250 */     MCD::OPC_CheckPredicate, 1, 1, 26, // Skip to: 6911
/* 254 */     MCD::OPC_Decode, 135, 3, 5, // Opcode: CWBCONDrr
/* 258 */     MCD::OPC_FilterValue, 1, 249, 25, // Skip to: 6911
/* 262 */     MCD::OPC_CheckPredicate, 1, 245, 25, // Skip to: 6911
/* 266 */     MCD::OPC_Decode, 137, 3, 5, // Opcode: CXBCONDrr
/* 270 */     MCD::OPC_FilterValue, 1, 237, 25, // Skip to: 6911
/* 274 */     MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 277 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 289
/* 281 */     MCD::OPC_CheckPredicate, 1, 226, 25, // Skip to: 6911
/* 285 */     MCD::OPC_Decode, 134, 3, 6, // Opcode: CWBCONDri
/* 289 */     MCD::OPC_FilterValue, 1, 218, 25, // Skip to: 6911
/* 293 */     MCD::OPC_CheckPredicate, 1, 214, 25, // Skip to: 6911
/* 297 */     MCD::OPC_Decode, 136, 3, 6, // Opcode: CXBCONDri
/* 301 */     MCD::OPC_FilterValue, 4, 20, 0, // Skip to: 325
/* 305 */     MCD::OPC_CheckField, 25, 5, 0, 10, 0, // Skip to: 321
/* 311 */     MCD::OPC_CheckField, 0, 22, 0, 4, 0, // Skip to: 321
/* 317 */     MCD::OPC_Decode, 142, 5, 7, // Opcode: NOP
/* 321 */     MCD::OPC_Decode, 185, 5, 8, // Opcode: SETHIi
/* 325 */     MCD::OPC_FilterValue, 5, 93, 0, // Skip to: 422
/* 329 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 332 */     MCD::OPC_FilterValue, 0, 27, 0, // Skip to: 363
/* 336 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 339 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 351
/* 343 */     MCD::OPC_CheckPredicate, 0, 164, 25, // Skip to: 6911
/* 347 */     MCD::OPC_Decode, 233, 2, 9, // Opcode: BPFCCNT
/* 351 */     MCD::OPC_FilterValue, 1, 156, 25, // Skip to: 6911
/* 355 */     MCD::OPC_CheckPredicate, 0, 152, 25, // Skip to: 6911
/* 359 */     MCD::OPC_Decode, 232, 2, 9, // Opcode: BPFCCANT
/* 363 */     MCD::OPC_FilterValue, 1, 144, 25, // Skip to: 6911
/* 367 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 370 */     MCD::OPC_FilterValue, 0, 22, 0, // Skip to: 396
/* 374 */     MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 388
/* 378 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, // Skip to: 388
/* 384 */     MCD::OPC_Decode, 167, 3, 1, // Opcode: FBCOND_V9
/* 388 */     MCD::OPC_CheckPredicate, 0, 119, 25, // Skip to: 6911
/* 392 */     MCD::OPC_Decode, 230, 2, 9, // Opcode: BPFCC
/* 396 */     MCD::OPC_FilterValue, 1, 111, 25, // Skip to: 6911
/* 400 */     MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 414
/* 404 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, // Skip to: 414
/* 410 */     MCD::OPC_Decode, 166, 3, 1, // Opcode: FBCONDA_V9
/* 414 */     MCD::OPC_CheckPredicate, 0, 93, 25, // Skip to: 6911
/* 418 */     MCD::OPC_Decode, 231, 2, 9, // Opcode: BPFCCA
/* 422 */     MCD::OPC_FilterValue, 6, 19, 0, // Skip to: 445
/* 426 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 429 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 437
/* 433 */     MCD::OPC_Decode, 164, 3, 3, // Opcode: FBCOND
/* 437 */     MCD::OPC_FilterValue, 1, 70, 25, // Skip to: 6911
/* 441 */     MCD::OPC_Decode, 165, 3, 3, // Opcode: FBCONDA
/* 445 */     MCD::OPC_FilterValue, 7, 62, 25, // Skip to: 6911
/* 449 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 452 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 460
/* 456 */     MCD::OPC_Decode, 132, 3, 3, // Opcode: CPBCOND
/* 460 */     MCD::OPC_FilterValue, 1, 47, 25, // Skip to: 6911
/* 464 */     MCD::OPC_Decode, 133, 3, 3, // Opcode: CPBCONDA
/* 468 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 476
/* 472 */     MCD::OPC_Decode, 247, 2, 10, // Opcode: CALL
/* 476 */     MCD::OPC_FilterValue, 2, 164, 19, // Skip to: 5508
/* 480 */     MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 483 */     MCD::OPC_FilterValue, 0, 25, 0, // Skip to: 512
/* 487 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 490 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 504
/* 494 */     MCD::OPC_CheckField, 5, 8, 0, 11, 25, // Skip to: 6911
/* 500 */     MCD::OPC_Decode, 209, 2, 11, // Opcode: ADDrr
/* 504 */     MCD::OPC_FilterValue, 1, 3, 25, // Skip to: 6911
/* 508 */     MCD::OPC_Decode, 208, 2, 12, // Opcode: ADDri
/* 512 */     MCD::OPC_FilterValue, 1, 25, 0, // Skip to: 541
/* 516 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 519 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 533
/* 523 */     MCD::OPC_CheckField, 5, 8, 0, 238, 24, // Skip to: 6911
/* 529 */     MCD::OPC_Decode, 220, 2, 11, // Opcode: ANDrr
/* 533 */     MCD::OPC_FilterValue, 1, 230, 24, // Skip to: 6911
/* 537 */     MCD::OPC_Decode, 219, 2, 12, // Opcode: ANDri
/* 541 */     MCD::OPC_FilterValue, 2, 25, 0, // Skip to: 570
/* 545 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 548 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 562
/* 552 */     MCD::OPC_CheckField, 5, 8, 0, 209, 24, // Skip to: 6911
/* 558 */     MCD::OPC_Decode, 151, 5, 11, // Opcode: ORrr
/* 562 */     MCD::OPC_FilterValue, 1, 201, 24, // Skip to: 6911
/* 566 */     MCD::OPC_Decode, 150, 5, 12, // Opcode: ORri
/* 570 */     MCD::OPC_FilterValue, 3, 25, 0, // Skip to: 599
/* 574 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 577 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 591
/* 581 */     MCD::OPC_CheckField, 5, 8, 0, 180, 24, // Skip to: 6911
/* 587 */     MCD::OPC_Decode, 205, 6, 11, // Opcode: XORrr
/* 591 */     MCD::OPC_FilterValue, 1, 172, 24, // Skip to: 6911
/* 595 */     MCD::OPC_Decode, 204, 6, 12, // Opcode: XORri
/* 599 */     MCD::OPC_FilterValue, 4, 25, 0, // Skip to: 628
/* 603 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 606 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 620
/* 610 */     MCD::OPC_CheckField, 5, 8, 0, 151, 24, // Skip to: 6911
/* 616 */     MCD::OPC_Decode, 133, 6, 11, // Opcode: SUBrr
/* 620 */     MCD::OPC_FilterValue, 1, 143, 24, // Skip to: 6911
/* 624 */     MCD::OPC_Decode, 132, 6, 12, // Opcode: SUBri
/* 628 */     MCD::OPC_FilterValue, 5, 25, 0, // Skip to: 657
/* 632 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 635 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 649
/* 639 */     MCD::OPC_CheckField, 5, 8, 0, 122, 24, // Skip to: 6911
/* 645 */     MCD::OPC_Decode, 218, 2, 11, // Opcode: ANDNrr
/* 649 */     MCD::OPC_FilterValue, 1, 114, 24, // Skip to: 6911
/* 653 */     MCD::OPC_Decode, 217, 2, 12, // Opcode: ANDNri
/* 657 */     MCD::OPC_FilterValue, 6, 25, 0, // Skip to: 686
/* 661 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 664 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 678
/* 668 */     MCD::OPC_CheckField, 5, 8, 0, 93, 24, // Skip to: 6911
/* 674 */     MCD::OPC_Decode, 149, 5, 11, // Opcode: ORNrr
/* 678 */     MCD::OPC_FilterValue, 1, 85, 24, // Skip to: 6911
/* 682 */     MCD::OPC_Decode, 148, 5, 12, // Opcode: ORNri
/* 686 */     MCD::OPC_FilterValue, 7, 25, 0, // Skip to: 715
/* 690 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 693 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 707
/* 697 */     MCD::OPC_CheckField, 5, 8, 0, 64, 24, // Skip to: 6911
/* 703 */     MCD::OPC_Decode, 201, 6, 11, // Opcode: XNORrr
/* 707 */     MCD::OPC_FilterValue, 1, 56, 24, // Skip to: 6911
/* 711 */     MCD::OPC_Decode, 200, 6, 12, // Opcode: XNORri
/* 715 */     MCD::OPC_FilterValue, 8, 25, 0, // Skip to: 744
/* 719 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 722 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 736
/* 726 */     MCD::OPC_CheckField, 5, 8, 0, 35, 24, // Skip to: 6911
/* 732 */     MCD::OPC_Decode, 203, 2, 11, // Opcode: ADDCrr
/* 736 */     MCD::OPC_FilterValue, 1, 27, 24, // Skip to: 6911
/* 740 */     MCD::OPC_Decode, 202, 2, 12, // Opcode: ADDCri
/* 744 */     MCD::OPC_FilterValue, 9, 25, 0, // Skip to: 773
/* 748 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 751 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 765
/* 755 */     MCD::OPC_CheckField, 5, 8, 0, 6, 24, // Skip to: 6911
/* 761 */     MCD::OPC_Decode, 141, 5, 13, // Opcode: MULXrr
/* 765 */     MCD::OPC_FilterValue, 1, 254, 23, // Skip to: 6911
/* 769 */     MCD::OPC_Decode, 140, 5, 14, // Opcode: MULXri
/* 773 */     MCD::OPC_FilterValue, 10, 25, 0, // Skip to: 802
/* 777 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 780 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 794
/* 784 */     MCD::OPC_CheckField, 5, 8, 0, 233, 23, // Skip to: 6911
/* 790 */     MCD::OPC_Decode, 173, 6, 11, // Opcode: UMULrr
/* 794 */     MCD::OPC_FilterValue, 1, 225, 23, // Skip to: 6911
/* 798 */     MCD::OPC_Decode, 172, 6, 12, // Opcode: UMULri
/* 802 */     MCD::OPC_FilterValue, 11, 25, 0, // Skip to: 831
/* 806 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 809 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 823
/* 813 */     MCD::OPC_CheckField, 5, 8, 0, 204, 23, // Skip to: 6911
/* 819 */     MCD::OPC_Decode, 198, 5, 11, // Opcode: SMULrr
/* 823 */     MCD::OPC_FilterValue, 1, 196, 23, // Skip to: 6911
/* 827 */     MCD::OPC_Decode, 197, 5, 12, // Opcode: SMULri
/* 831 */     MCD::OPC_FilterValue, 12, 25, 0, // Skip to: 860
/* 835 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 838 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 852
/* 842 */     MCD::OPC_CheckField, 5, 8, 0, 175, 23, // Skip to: 6911
/* 848 */     MCD::OPC_Decode, 129, 6, 11, // Opcode: SUBCrr
/* 852 */     MCD::OPC_FilterValue, 1, 167, 23, // Skip to: 6911
/* 856 */     MCD::OPC_Decode, 128, 6, 12, // Opcode: SUBCri
/* 860 */     MCD::OPC_FilterValue, 13, 25, 0, // Skip to: 889
/* 864 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 867 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 881
/* 871 */     MCD::OPC_CheckField, 5, 8, 0, 146, 23, // Skip to: 6911
/* 877 */     MCD::OPC_Decode, 164, 6, 13, // Opcode: UDIVXrr
/* 881 */     MCD::OPC_FilterValue, 1, 138, 23, // Skip to: 6911
/* 885 */     MCD::OPC_Decode, 163, 6, 14, // Opcode: UDIVXri
/* 889 */     MCD::OPC_FilterValue, 14, 25, 0, // Skip to: 918
/* 893 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 896 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 910
/* 900 */     MCD::OPC_CheckField, 5, 8, 0, 117, 23, // Skip to: 6911
/* 906 */     MCD::OPC_Decode, 166, 6, 11, // Opcode: UDIVrr
/* 910 */     MCD::OPC_FilterValue, 1, 109, 23, // Skip to: 6911
/* 914 */     MCD::OPC_Decode, 165, 6, 12, // Opcode: UDIVri
/* 918 */     MCD::OPC_FilterValue, 15, 25, 0, // Skip to: 947
/* 922 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 925 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 939
/* 929 */     MCD::OPC_CheckField, 5, 8, 0, 88, 23, // Skip to: 6911
/* 935 */     MCD::OPC_Decode, 184, 5, 11, // Opcode: SDIVrr
/* 939 */     MCD::OPC_FilterValue, 1, 80, 23, // Skip to: 6911
/* 943 */     MCD::OPC_Decode, 183, 5, 12, // Opcode: SDIVri
/* 947 */     MCD::OPC_FilterValue, 16, 25, 0, // Skip to: 976
/* 951 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 954 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 968
/* 958 */     MCD::OPC_CheckField, 5, 8, 0, 59, 23, // Skip to: 6911
/* 964 */     MCD::OPC_Decode, 201, 2, 11, // Opcode: ADDCCrr
/* 968 */     MCD::OPC_FilterValue, 1, 51, 23, // Skip to: 6911
/* 972 */     MCD::OPC_Decode, 200, 2, 12, // Opcode: ADDCCri
/* 976 */     MCD::OPC_FilterValue, 17, 25, 0, // Skip to: 1005
/* 980 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 983 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 997
/* 987 */     MCD::OPC_CheckField, 5, 8, 0, 30, 23, // Skip to: 6911
/* 993 */     MCD::OPC_Decode, 214, 2, 11, // Opcode: ANDCCrr
/* 997 */     MCD::OPC_FilterValue, 1, 22, 23, // Skip to: 6911
/* 1001 */    MCD::OPC_Decode, 213, 2, 12, // Opcode: ANDCCri
/* 1005 */    MCD::OPC_FilterValue, 18, 25, 0, // Skip to: 1034
/* 1009 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1012 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1026
/* 1016 */    MCD::OPC_CheckField, 5, 8, 0, 1, 23, // Skip to: 6911
/* 1022 */    MCD::OPC_Decode, 145, 5, 11, // Opcode: ORCCrr
/* 1026 */    MCD::OPC_FilterValue, 1, 249, 22, // Skip to: 6911
/* 1030 */    MCD::OPC_Decode, 144, 5, 12, // Opcode: ORCCri
/* 1034 */    MCD::OPC_FilterValue, 19, 25, 0, // Skip to: 1063
/* 1038 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1041 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1055
/* 1045 */    MCD::OPC_CheckField, 5, 8, 0, 228, 22, // Skip to: 6911
/* 1051 */    MCD::OPC_Decode, 203, 6, 11, // Opcode: XORCCrr
/* 1055 */    MCD::OPC_FilterValue, 1, 220, 22, // Skip to: 6911
/* 1059 */    MCD::OPC_Decode, 202, 6, 12, // Opcode: XORCCri
/* 1063 */    MCD::OPC_FilterValue, 20, 25, 0, // Skip to: 1092
/* 1067 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1070 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1084
/* 1074 */    MCD::OPC_CheckField, 5, 8, 0, 199, 22, // Skip to: 6911
/* 1080 */    MCD::OPC_Decode, 255, 5, 11, // Opcode: SUBCCrr
/* 1084 */    MCD::OPC_FilterValue, 1, 191, 22, // Skip to: 6911
/* 1088 */    MCD::OPC_Decode, 254, 5, 12, // Opcode: SUBCCri
/* 1092 */    MCD::OPC_FilterValue, 21, 25, 0, // Skip to: 1121
/* 1096 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1099 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1113
/* 1103 */    MCD::OPC_CheckField, 5, 8, 0, 170, 22, // Skip to: 6911
/* 1109 */    MCD::OPC_Decode, 216, 2, 11, // Opcode: ANDNCCrr
/* 1113 */    MCD::OPC_FilterValue, 1, 162, 22, // Skip to: 6911
/* 1117 */    MCD::OPC_Decode, 215, 2, 12, // Opcode: ANDNCCri
/* 1121 */    MCD::OPC_FilterValue, 22, 25, 0, // Skip to: 1150
/* 1125 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1128 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1142
/* 1132 */    MCD::OPC_CheckField, 5, 8, 0, 141, 22, // Skip to: 6911
/* 1138 */    MCD::OPC_Decode, 147, 5, 11, // Opcode: ORNCCrr
/* 1142 */    MCD::OPC_FilterValue, 1, 133, 22, // Skip to: 6911
/* 1146 */    MCD::OPC_Decode, 146, 5, 12, // Opcode: ORNCCri
/* 1150 */    MCD::OPC_FilterValue, 23, 25, 0, // Skip to: 1179
/* 1154 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1157 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1171
/* 1161 */    MCD::OPC_CheckField, 5, 8, 0, 112, 22, // Skip to: 6911
/* 1167 */    MCD::OPC_Decode, 199, 6, 11, // Opcode: XNORCCrr
/* 1171 */    MCD::OPC_FilterValue, 1, 104, 22, // Skip to: 6911
/* 1175 */    MCD::OPC_Decode, 198, 6, 12, // Opcode: XNORCCri
/* 1179 */    MCD::OPC_FilterValue, 24, 25, 0, // Skip to: 1208
/* 1183 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1186 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1200
/* 1190 */    MCD::OPC_CheckField, 5, 8, 0, 83, 22, // Skip to: 6911
/* 1196 */    MCD::OPC_Decode, 205, 2, 11, // Opcode: ADDErr
/* 1200 */    MCD::OPC_FilterValue, 1, 75, 22, // Skip to: 6911
/* 1204 */    MCD::OPC_Decode, 204, 2, 12, // Opcode: ADDEri
/* 1208 */    MCD::OPC_FilterValue, 26, 25, 0, // Skip to: 1237
/* 1212 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1215 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1229
/* 1219 */    MCD::OPC_CheckField, 5, 8, 0, 54, 22, // Skip to: 6911
/* 1225 */    MCD::OPC_Decode, 170, 6, 11, // Opcode: UMULCCrr
/* 1229 */    MCD::OPC_FilterValue, 1, 46, 22, // Skip to: 6911
/* 1233 */    MCD::OPC_Decode, 169, 6, 12, // Opcode: UMULCCri
/* 1237 */    MCD::OPC_FilterValue, 27, 25, 0, // Skip to: 1266
/* 1241 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1244 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1258
/* 1248 */    MCD::OPC_CheckField, 5, 8, 0, 25, 22, // Skip to: 6911
/* 1254 */    MCD::OPC_Decode, 196, 5, 11, // Opcode: SMULCCrr
/* 1258 */    MCD::OPC_FilterValue, 1, 17, 22, // Skip to: 6911
/* 1262 */    MCD::OPC_Decode, 195, 5, 12, // Opcode: SMULCCri
/* 1266 */    MCD::OPC_FilterValue, 28, 25, 0, // Skip to: 1295
/* 1270 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1273 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1287
/* 1277 */    MCD::OPC_CheckField, 5, 8, 0, 252, 21, // Skip to: 6911
/* 1283 */    MCD::OPC_Decode, 131, 6, 11, // Opcode: SUBErr
/* 1287 */    MCD::OPC_FilterValue, 1, 244, 21, // Skip to: 6911
/* 1291 */    MCD::OPC_Decode, 130, 6, 12, // Opcode: SUBEri
/* 1295 */    MCD::OPC_FilterValue, 30, 25, 0, // Skip to: 1324
/* 1299 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1302 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1316
/* 1306 */    MCD::OPC_CheckField, 5, 8, 0, 223, 21, // Skip to: 6911
/* 1312 */    MCD::OPC_Decode, 162, 6, 11, // Opcode: UDIVCCrr
/* 1316 */    MCD::OPC_FilterValue, 1, 215, 21, // Skip to: 6911
/* 1320 */    MCD::OPC_Decode, 161, 6, 12, // Opcode: UDIVCCri
/* 1324 */    MCD::OPC_FilterValue, 31, 25, 0, // Skip to: 1353
/* 1328 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1331 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1345
/* 1335 */    MCD::OPC_CheckField, 5, 8, 0, 194, 21, // Skip to: 6911
/* 1341 */    MCD::OPC_Decode, 180, 5, 11, // Opcode: SDIVCCrr
/* 1345 */    MCD::OPC_FilterValue, 1, 186, 21, // Skip to: 6911
/* 1349 */    MCD::OPC_Decode, 179, 5, 12, // Opcode: SDIVCCri
/* 1353 */    MCD::OPC_FilterValue, 32, 25, 0, // Skip to: 1382
/* 1357 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1360 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1374
/* 1364 */    MCD::OPC_CheckField, 5, 8, 0, 165, 21, // Skip to: 6911
/* 1370 */    MCD::OPC_Decode, 144, 6, 11, // Opcode: TADDCCrr
/* 1374 */    MCD::OPC_FilterValue, 1, 157, 21, // Skip to: 6911
/* 1378 */    MCD::OPC_Decode, 143, 6, 12, // Opcode: TADDCCri
/* 1382 */    MCD::OPC_FilterValue, 33, 25, 0, // Skip to: 1411
/* 1386 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1389 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1403
/* 1393 */    MCD::OPC_CheckField, 5, 8, 0, 136, 21, // Skip to: 6911
/* 1399 */    MCD::OPC_Decode, 158, 6, 11, // Opcode: TSUBCCrr
/* 1403 */    MCD::OPC_FilterValue, 1, 128, 21, // Skip to: 6911
/* 1407 */    MCD::OPC_Decode, 157, 6, 12, // Opcode: TSUBCCri
/* 1411 */    MCD::OPC_FilterValue, 34, 25, 0, // Skip to: 1440
/* 1415 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1418 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1432
/* 1422 */    MCD::OPC_CheckField, 5, 8, 0, 107, 21, // Skip to: 6911
/* 1428 */    MCD::OPC_Decode, 142, 6, 11, // Opcode: TADDCCTVrr
/* 1432 */    MCD::OPC_FilterValue, 1, 99, 21, // Skip to: 6911
/* 1436 */    MCD::OPC_Decode, 141, 6, 12, // Opcode: TADDCCTVri
/* 1440 */    MCD::OPC_FilterValue, 35, 25, 0, // Skip to: 1469
/* 1444 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1447 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1461
/* 1451 */    MCD::OPC_CheckField, 5, 8, 0, 78, 21, // Skip to: 6911
/* 1457 */    MCD::OPC_Decode, 156, 6, 11, // Opcode: TSUBCCTVrr
/* 1461 */    MCD::OPC_FilterValue, 1, 70, 21, // Skip to: 6911
/* 1465 */    MCD::OPC_Decode, 155, 6, 12, // Opcode: TSUBCCTVri
/* 1469 */    MCD::OPC_FilterValue, 36, 25, 0, // Skip to: 1498
/* 1473 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1476 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1490
/* 1480 */    MCD::OPC_CheckField, 5, 8, 0, 49, 21, // Skip to: 6911
/* 1486 */    MCD::OPC_Decode, 139, 5, 11, // Opcode: MULSCCrr
/* 1490 */    MCD::OPC_FilterValue, 1, 41, 21, // Skip to: 6911
/* 1494 */    MCD::OPC_Decode, 138, 5, 12, // Opcode: MULSCCri
/* 1498 */    MCD::OPC_FilterValue, 37, 35, 0, // Skip to: 1537
/* 1502 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1505 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1513
/* 1509 */    MCD::OPC_Decode, 192, 5, 11, // Opcode: SLLrr
/* 1513 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1521
/* 1517 */    MCD::OPC_Decode, 190, 5, 15, // Opcode: SLLXrr
/* 1521 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1529
/* 1525 */    MCD::OPC_Decode, 191, 5, 16, // Opcode: SLLri
/* 1529 */    MCD::OPC_FilterValue, 3, 2, 21, // Skip to: 6911
/* 1533 */    MCD::OPC_Decode, 189, 5, 17, // Opcode: SLLXri
/* 1537 */    MCD::OPC_FilterValue, 38, 35, 0, // Skip to: 1576
/* 1541 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1544 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1552
/* 1548 */    MCD::OPC_Decode, 206, 5, 11, // Opcode: SRLrr
/* 1552 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1560
/* 1556 */    MCD::OPC_Decode, 204, 5, 15, // Opcode: SRLXrr
/* 1560 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1568
/* 1564 */    MCD::OPC_Decode, 205, 5, 16, // Opcode: SRLri
/* 1568 */    MCD::OPC_FilterValue, 3, 219, 20, // Skip to: 6911
/* 1572 */    MCD::OPC_Decode, 203, 5, 17, // Opcode: SRLXri
/* 1576 */    MCD::OPC_FilterValue, 39, 35, 0, // Skip to: 1615
/* 1580 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1583 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1591
/* 1587 */    MCD::OPC_Decode, 202, 5, 11, // Opcode: SRArr
/* 1591 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1599
/* 1595 */    MCD::OPC_Decode, 200, 5, 15, // Opcode: SRAXrr
/* 1599 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1607
/* 1603 */    MCD::OPC_Decode, 201, 5, 16, // Opcode: SRAri
/* 1607 */    MCD::OPC_FilterValue, 3, 180, 20, // Skip to: 6911
/* 1611 */    MCD::OPC_Decode, 199, 5, 17, // Opcode: SRAXri
/* 1615 */    MCD::OPC_FilterValue, 40, 58, 0, // Skip to: 1677
/* 1619 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1622 */    MCD::OPC_FilterValue, 0, 27, 0, // Skip to: 1653
/* 1626 */    MCD::OPC_ExtractField, 0, 13,  // Inst{12-0} ...
/* 1629 */    MCD::OPC_FilterValue, 0, 158, 20, // Skip to: 6911
/* 1633 */    MCD::OPC_CheckField, 25, 5, 0, 10, 0, // Skip to: 1649
/* 1639 */    MCD::OPC_CheckField, 14, 5, 15, 4, 0, // Skip to: 1649
/* 1645 */    MCD::OPC_Decode, 209, 5, 7, // Opcode: STBAR
/* 1649 */    MCD::OPC_Decode, 162, 5, 18, // Opcode: RDASR
/* 1653 */    MCD::OPC_FilterValue, 1, 134, 20, // Skip to: 6911
/* 1657 */    MCD::OPC_CheckPredicate, 0, 130, 20, // Skip to: 6911
/* 1661 */    MCD::OPC_CheckField, 25, 5, 0, 124, 20, // Skip to: 6911
/* 1667 */    MCD::OPC_CheckField, 14, 5, 15, 118, 20, // Skip to: 6911
/* 1673 */    MCD::OPC_Decode, 252, 4, 19, // Opcode: MEMBARi
/* 1677 */    MCD::OPC_FilterValue, 41, 10, 0, // Skip to: 1691
/* 1681 */    MCD::OPC_CheckField, 0, 19, 0, 104, 20, // Skip to: 6911
/* 1687 */    MCD::OPC_Decode, 165, 5, 20, // Opcode: RDPSR
/* 1691 */    MCD::OPC_FilterValue, 42, 38, 0, // Skip to: 1733
/* 1695 */    MCD::OPC_ExtractField, 0, 14,  // Inst{13-0} ...
/* 1698 */    MCD::OPC_FilterValue, 0, 89, 20, // Skip to: 6911
/* 1702 */    MCD::OPC_ExtractField, 14, 5,  // Inst{18-14} ...
/* 1705 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1713
/* 1709 */    MCD::OPC_Decode, 167, 5, 20, // Opcode: RDWIM
/* 1713 */    MCD::OPC_FilterValue, 15, 8, 0, // Skip to: 1725
/* 1717 */    MCD::OPC_CheckPredicate, 0, 4, 0, // Skip to: 1725
/* 1721 */    MCD::OPC_Decode, 163, 5, 20, // Opcode: RDFQ
/* 1725 */    MCD::OPC_CheckPredicate, 0, 62, 20, // Skip to: 6911
/* 1729 */    MCD::OPC_Decode, 164, 5, 21, // Opcode: RDPR
/* 1733 */    MCD::OPC_FilterValue, 43, 25, 0, // Skip to: 1762
/* 1737 */    MCD::OPC_ExtractField, 0, 19,  // Inst{18-0} ...
/* 1740 */    MCD::OPC_FilterValue, 0, 47, 20, // Skip to: 6911
/* 1744 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1758
/* 1748 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 1758
/* 1754 */    MCD::OPC_Decode, 202, 3, 7, // Opcode: FLUSHW
/* 1758 */    MCD::OPC_Decode, 166, 5, 20, // Opcode: RDTBR
/* 1762 */    MCD::OPC_FilterValue, 44, 123, 0, // Skip to: 1889
/* 1766 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1769 */    MCD::OPC_FilterValue, 0, 56, 0, // Skip to: 1829
/* 1773 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 1776 */    MCD::OPC_FilterValue, 0, 22, 0, // Skip to: 1802
/* 1780 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1794
/* 1784 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 1794
/* 1790 */    MCD::OPC_Decode, 255, 4, 22, // Opcode: MOVFCCrr
/* 1794 */    MCD::OPC_CheckPredicate, 0, 249, 19, // Skip to: 6911
/* 1798 */    MCD::OPC_Decode, 185, 6, 23, // Opcode: V9MOVFCCrr
/* 1802 */    MCD::OPC_FilterValue, 1, 241, 19, // Skip to: 6911
/* 1806 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 1809 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1821
/* 1813 */    MCD::OPC_CheckPredicate, 0, 230, 19, // Skip to: 6911
/* 1817 */    MCD::OPC_Decode, 129, 5, 22, // Opcode: MOVICCrr
/* 1821 */    MCD::OPC_FilterValue, 2, 222, 19, // Skip to: 6911
/* 1825 */    MCD::OPC_Decode, 136, 5, 22, // Opcode: MOVXCCrr
/* 1829 */    MCD::OPC_FilterValue, 1, 214, 19, // Skip to: 6911
/* 1833 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 1836 */    MCD::OPC_FilterValue, 0, 22, 0, // Skip to: 1862
/* 1840 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1854
/* 1844 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 1854
/* 1850 */    MCD::OPC_Decode, 254, 4, 24, // Opcode: MOVFCCri
/* 1854 */    MCD::OPC_CheckPredicate, 0, 189, 19, // Skip to: 6911
/* 1858 */    MCD::OPC_Decode, 184, 6, 25, // Opcode: V9MOVFCCri
/* 1862 */    MCD::OPC_FilterValue, 1, 181, 19, // Skip to: 6911
/* 1866 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 1869 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1881
/* 1873 */    MCD::OPC_CheckPredicate, 0, 170, 19, // Skip to: 6911
/* 1877 */    MCD::OPC_Decode, 128, 5, 24, // Opcode: MOVICCri
/* 1881 */    MCD::OPC_FilterValue, 2, 162, 19, // Skip to: 6911
/* 1885 */    MCD::OPC_Decode, 135, 5, 24, // Opcode: MOVXCCri
/* 1889 */    MCD::OPC_FilterValue, 45, 25, 0, // Skip to: 1918
/* 1893 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1896 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1910
/* 1900 */    MCD::OPC_CheckField, 5, 8, 0, 141, 19, // Skip to: 6911
/* 1906 */    MCD::OPC_Decode, 182, 5, 13, // Opcode: SDIVXrr
/* 1910 */    MCD::OPC_FilterValue, 1, 133, 19, // Skip to: 6911
/* 1914 */    MCD::OPC_Decode, 181, 5, 14, // Opcode: SDIVXri
/* 1918 */    MCD::OPC_FilterValue, 46, 14, 0, // Skip to: 1936
/* 1922 */    MCD::OPC_CheckPredicate, 0, 121, 19, // Skip to: 6911
/* 1926 */    MCD::OPC_CheckField, 5, 14, 0, 115, 19, // Skip to: 6911
/* 1932 */    MCD::OPC_Decode, 155, 5, 26, // Opcode: POPCrr
/* 1936 */    MCD::OPC_FilterValue, 47, 25, 0, // Skip to: 1965
/* 1940 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1943 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1957
/* 1947 */    MCD::OPC_CheckField, 5, 5, 0, 94, 19, // Skip to: 6911
/* 1953 */    MCD::OPC_Decode, 131, 5, 27, // Opcode: MOVRrr
/* 1957 */    MCD::OPC_FilterValue, 1, 86, 19, // Skip to: 6911
/* 1961 */    MCD::OPC_Decode, 130, 5, 28, // Opcode: MOVRri
/* 1965 */    MCD::OPC_FilterValue, 48, 45, 0, // Skip to: 2014
/* 1969 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1972 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1986
/* 1976 */    MCD::OPC_CheckField, 5, 8, 0, 65, 19, // Skip to: 6911
/* 1982 */    MCD::OPC_Decode, 187, 6, 29, // Opcode: WRASRrr
/* 1986 */    MCD::OPC_FilterValue, 1, 57, 19, // Skip to: 6911
/* 1990 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 2010
/* 1994 */    MCD::OPC_CheckField, 25, 5, 15, 10, 0, // Skip to: 2010
/* 2000 */    MCD::OPC_CheckField, 14, 5, 0, 4, 0, // Skip to: 2010
/* 2006 */    MCD::OPC_Decode, 188, 5, 30, // Opcode: SIR
/* 2010 */    MCD::OPC_Decode, 186, 6, 31, // Opcode: WRASRri
/* 2014 */    MCD::OPC_FilterValue, 49, 183, 0, // Skip to: 2201
/* 2018 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 2021 */    MCD::OPC_FilterValue, 0, 46, 0, // Skip to: 2071
/* 2025 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2028 */    MCD::OPC_FilterValue, 0, 31, 0, // Skip to: 2063
/* 2032 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 2035 */    MCD::OPC_FilterValue, 0, 8, 19, // Skip to: 6911
/* 2039 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 2059
/* 2043 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 2059
/* 2049 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 2059
/* 2055 */    MCD::OPC_Decode, 176, 5, 7, // Opcode: SAVED
/* 2059 */    MCD::OPC_Decode, 191, 6, 32, // Opcode: WRPSRrr
/* 2063 */    MCD::OPC_FilterValue, 1, 236, 18, // Skip to: 6911
/* 2067 */    MCD::OPC_Decode, 190, 6, 33, // Opcode: WRPSRri
/* 2071 */    MCD::OPC_FilterValue, 1, 54, 0, // Skip to: 2129
/* 2075 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2078 */    MCD::OPC_FilterValue, 0, 35, 0, // Skip to: 2117
/* 2082 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 2085 */    MCD::OPC_FilterValue, 0, 214, 18, // Skip to: 6911
/* 2089 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 2109
/* 2093 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 2109
/* 2099 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 2109
/* 2105 */    MCD::OPC_Decode, 168, 5, 7, // Opcode: RESTORED
/* 2109 */    MCD::OPC_CheckPredicate, 2, 190, 18, // Skip to: 6911
/* 2113 */    MCD::OPC_Decode, 161, 5, 32, // Opcode: PWRPSRrr
/* 2117 */    MCD::OPC_FilterValue, 1, 182, 18, // Skip to: 6911
/* 2121 */    MCD::OPC_CheckPredicate, 2, 178, 18, // Skip to: 6911
/* 2125 */    MCD::OPC_Decode, 160, 5, 33, // Opcode: PWRPSRri
/* 2129 */    MCD::OPC_FilterValue, 2, 14, 0, // Skip to: 2147
/* 2133 */    MCD::OPC_CheckPredicate, 3, 166, 18, // Skip to: 6911
/* 2137 */    MCD::OPC_CheckField, 0, 19, 0, 160, 18, // Skip to: 6911
/* 2143 */    MCD::OPC_Decode, 212, 2, 7, // Opcode: ALLCLEAN
/* 2147 */    MCD::OPC_FilterValue, 3, 14, 0, // Skip to: 2165
/* 2151 */    MCD::OPC_CheckPredicate, 3, 148, 18, // Skip to: 6911
/* 2155 */    MCD::OPC_CheckField, 0, 19, 0, 142, 18, // Skip to: 6911
/* 2161 */    MCD::OPC_Decode, 152, 5, 7, // Opcode: OTHERW
/* 2165 */    MCD::OPC_FilterValue, 4, 14, 0, // Skip to: 2183
/* 2169 */    MCD::OPC_CheckPredicate, 3, 130, 18, // Skip to: 6911
/* 2173 */    MCD::OPC_CheckField, 0, 19, 0, 124, 18, // Skip to: 6911
/* 2179 */    MCD::OPC_Decode, 143, 5, 7, // Opcode: NORMALW
/* 2183 */    MCD::OPC_FilterValue, 5, 116, 18, // Skip to: 6911
/* 2187 */    MCD::OPC_CheckPredicate, 3, 112, 18, // Skip to: 6911
/* 2191 */    MCD::OPC_CheckField, 0, 19, 0, 106, 18, // Skip to: 6911
/* 2197 */    MCD::OPC_Decode, 190, 4, 7, // Opcode: INVALW
/* 2201 */    MCD::OPC_FilterValue, 50, 54, 0, // Skip to: 2259
/* 2205 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2208 */    MCD::OPC_FilterValue, 0, 25, 0, // Skip to: 2237
/* 2212 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 2215 */    MCD::OPC_FilterValue, 0, 84, 18, // Skip to: 6911
/* 2219 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 2229
/* 2225 */    MCD::OPC_Decode, 195, 6, 32, // Opcode: WRWIMrr
/* 2229 */    MCD::OPC_CheckPredicate, 0, 70, 18, // Skip to: 6911
/* 2233 */    MCD::OPC_Decode, 189, 6, 34, // Opcode: WRPRrr
/* 2237 */    MCD::OPC_FilterValue, 1, 62, 18, // Skip to: 6911
/* 2241 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 2251
/* 2247 */    MCD::OPC_Decode, 194, 6, 33, // Opcode: WRWIMri
/* 2251 */    MCD::OPC_CheckPredicate, 0, 48, 18, // Skip to: 6911
/* 2255 */    MCD::OPC_Decode, 188, 6, 35, // Opcode: WRPRri
/* 2259 */    MCD::OPC_FilterValue, 51, 37, 0, // Skip to: 2300
/* 2263 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2266 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 2286
/* 2270 */    MCD::OPC_CheckField, 25, 5, 0, 27, 18, // Skip to: 6911
/* 2276 */    MCD::OPC_CheckField, 5, 8, 0, 21, 18, // Skip to: 6911
/* 2282 */    MCD::OPC_Decode, 193, 6, 32, // Opcode: WRTBRrr
/* 2286 */    MCD::OPC_FilterValue, 1, 13, 18, // Skip to: 6911
/* 2290 */    MCD::OPC_CheckField, 25, 5, 0, 7, 18, // Skip to: 6911
/* 2296 */    MCD::OPC_Decode, 192, 6, 33, // Opcode: WRTBRri
/* 2300 */    MCD::OPC_FilterValue, 52, 197, 2, // Skip to: 3013
/* 2304 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 2307 */    MCD::OPC_FilterValue, 1, 10, 0, // Skip to: 2321
/* 2311 */    MCD::OPC_CheckField, 14, 5, 0, 242, 17, // Skip to: 6911
/* 2317 */    MCD::OPC_Decode, 219, 3, 36, // Opcode: FMOVS
/* 2321 */    MCD::OPC_FilterValue, 2, 14, 0, // Skip to: 2339
/* 2325 */    MCD::OPC_CheckPredicate, 0, 230, 17, // Skip to: 6911
/* 2329 */    MCD::OPC_CheckField, 14, 5, 0, 224, 17, // Skip to: 6911
/* 2335 */    MCD::OPC_Decode, 208, 3, 37, // Opcode: FMOVD
/* 2339 */    MCD::OPC_FilterValue, 3, 14, 0, // Skip to: 2357
/* 2343 */    MCD::OPC_CheckPredicate, 0, 212, 17, // Skip to: 6911
/* 2347 */    MCD::OPC_CheckField, 14, 5, 0, 206, 17, // Skip to: 6911
/* 2353 */    MCD::OPC_Decode, 212, 3, 38, // Opcode: FMOVQ
/* 2357 */    MCD::OPC_FilterValue, 5, 10, 0, // Skip to: 2371
/* 2361 */    MCD::OPC_CheckField, 14, 5, 0, 192, 17, // Skip to: 6911
/* 2367 */    MCD::OPC_Decode, 241, 3, 36, // Opcode: FNEGS
/* 2371 */    MCD::OPC_FilterValue, 6, 14, 0, // Skip to: 2389
/* 2375 */    MCD::OPC_CheckPredicate, 0, 180, 17, // Skip to: 6911
/* 2379 */    MCD::OPC_CheckField, 14, 5, 0, 174, 17, // Skip to: 6911
/* 2385 */    MCD::OPC_Decode, 239, 3, 37, // Opcode: FNEGD
/* 2389 */    MCD::OPC_FilterValue, 7, 14, 0, // Skip to: 2407
/* 2393 */    MCD::OPC_CheckPredicate, 0, 162, 17, // Skip to: 6911
/* 2397 */    MCD::OPC_CheckField, 14, 5, 0, 156, 17, // Skip to: 6911
/* 2403 */    MCD::OPC_Decode, 240, 3, 38, // Opcode: FNEGQ
/* 2407 */    MCD::OPC_FilterValue, 9, 10, 0, // Skip to: 2421
/* 2411 */    MCD::OPC_CheckField, 14, 5, 0, 142, 17, // Skip to: 6911
/* 2417 */    MCD::OPC_Decode, 153, 3, 36, // Opcode: FABSS
/* 2421 */    MCD::OPC_FilterValue, 10, 14, 0, // Skip to: 2439
/* 2425 */    MCD::OPC_CheckPredicate, 0, 130, 17, // Skip to: 6911
/* 2429 */    MCD::OPC_CheckField, 14, 5, 0, 124, 17, // Skip to: 6911
/* 2435 */    MCD::OPC_Decode, 151, 3, 37, // Opcode: FABSD
/* 2439 */    MCD::OPC_FilterValue, 11, 14, 0, // Skip to: 2457
/* 2443 */    MCD::OPC_CheckPredicate, 0, 112, 17, // Skip to: 6911
/* 2447 */    MCD::OPC_CheckField, 14, 5, 0, 106, 17, // Skip to: 6911
/* 2453 */    MCD::OPC_Decode, 152, 3, 38, // Opcode: FABSQ
/* 2457 */    MCD::OPC_FilterValue, 41, 10, 0, // Skip to: 2471
/* 2461 */    MCD::OPC_CheckField, 14, 5, 0, 92, 17, // Skip to: 6911
/* 2467 */    MCD::OPC_Decode, 163, 4, 36, // Opcode: FSQRTS
/* 2471 */    MCD::OPC_FilterValue, 42, 10, 0, // Skip to: 2485
/* 2475 */    MCD::OPC_CheckField, 14, 5, 0, 78, 17, // Skip to: 6911
/* 2481 */    MCD::OPC_Decode, 161, 4, 37, // Opcode: FSQRTD
/* 2485 */    MCD::OPC_FilterValue, 43, 10, 0, // Skip to: 2499
/* 2489 */    MCD::OPC_CheckField, 14, 5, 0, 64, 17, // Skip to: 6911
/* 2495 */    MCD::OPC_Decode, 162, 4, 38, // Opcode: FSQRTQ
/* 2499 */    MCD::OPC_FilterValue, 65, 4, 0, // Skip to: 2507
/* 2503 */    MCD::OPC_Decode, 156, 3, 39, // Opcode: FADDS
/* 2507 */    MCD::OPC_FilterValue, 66, 4, 0, // Skip to: 2515
/* 2511 */    MCD::OPC_Decode, 154, 3, 40, // Opcode: FADDD
/* 2515 */    MCD::OPC_FilterValue, 67, 4, 0, // Skip to: 2523
/* 2519 */    MCD::OPC_Decode, 155, 3, 41, // Opcode: FADDQ
/* 2523 */    MCD::OPC_FilterValue, 69, 4, 0, // Skip to: 2531
/* 2527 */    MCD::OPC_Decode, 178, 4, 39, // Opcode: FSUBS
/* 2531 */    MCD::OPC_FilterValue, 70, 4, 0, // Skip to: 2539
/* 2535 */    MCD::OPC_Decode, 176, 4, 40, // Opcode: FSUBD
/* 2539 */    MCD::OPC_FilterValue, 71, 4, 0, // Skip to: 2547
/* 2543 */    MCD::OPC_Decode, 177, 4, 41, // Opcode: FSUBQ
/* 2547 */    MCD::OPC_FilterValue, 73, 4, 0, // Skip to: 2555
/* 2551 */    MCD::OPC_Decode, 234, 3, 39, // Opcode: FMULS
/* 2555 */    MCD::OPC_FilterValue, 74, 4, 0, // Skip to: 2563
/* 2559 */    MCD::OPC_Decode, 230, 3, 40, // Opcode: FMULD
/* 2563 */    MCD::OPC_FilterValue, 75, 4, 0, // Skip to: 2571
/* 2567 */    MCD::OPC_Decode, 233, 3, 41, // Opcode: FMULQ
/* 2571 */    MCD::OPC_FilterValue, 77, 4, 0, // Skip to: 2579
/* 2575 */    MCD::OPC_Decode, 185, 3, 39, // Opcode: FDIVS
/* 2579 */    MCD::OPC_FilterValue, 78, 4, 0, // Skip to: 2587
/* 2583 */    MCD::OPC_Decode, 183, 3, 40, // Opcode: FDIVD
/* 2587 */    MCD::OPC_FilterValue, 79, 4, 0, // Skip to: 2595
/* 2591 */    MCD::OPC_Decode, 184, 3, 41, // Opcode: FDIVQ
/* 2595 */    MCD::OPC_FilterValue, 81, 8, 0, // Skip to: 2607
/* 2599 */    MCD::OPC_CheckPredicate, 4, 212, 16, // Skip to: 6911
/* 2603 */    MCD::OPC_Decode, 236, 3, 39, // Opcode: FNADDS
/* 2607 */    MCD::OPC_FilterValue, 82, 8, 0, // Skip to: 2619
/* 2611 */    MCD::OPC_CheckPredicate, 4, 200, 16, // Skip to: 6911
/* 2615 */    MCD::OPC_Decode, 235, 3, 40, // Opcode: FNADDD
/* 2619 */    MCD::OPC_FilterValue, 89, 8, 0, // Skip to: 2631
/* 2623 */    MCD::OPC_CheckPredicate, 4, 188, 16, // Skip to: 6911
/* 2627 */    MCD::OPC_Decode, 249, 3, 39, // Opcode: FNMULS
/* 2631 */    MCD::OPC_FilterValue, 90, 8, 0, // Skip to: 2643
/* 2635 */    MCD::OPC_CheckPredicate, 4, 176, 16, // Skip to: 6911
/* 2639 */    MCD::OPC_Decode, 248, 3, 40, // Opcode: FNMULD
/* 2643 */    MCD::OPC_FilterValue, 97, 8, 0, // Skip to: 2655
/* 2647 */    MCD::OPC_CheckPredicate, 4, 164, 16, // Skip to: 6911
/* 2651 */    MCD::OPC_Decode, 193, 3, 39, // Opcode: FHADDS
/* 2655 */    MCD::OPC_FilterValue, 98, 8, 0, // Skip to: 2667
/* 2659 */    MCD::OPC_CheckPredicate, 4, 152, 16, // Skip to: 6911
/* 2663 */    MCD::OPC_Decode, 192, 3, 40, // Opcode: FHADDD
/* 2667 */    MCD::OPC_FilterValue, 101, 8, 0, // Skip to: 2679
/* 2671 */    MCD::OPC_CheckPredicate, 4, 140, 16, // Skip to: 6911
/* 2675 */    MCD::OPC_Decode, 195, 3, 39, // Opcode: FHSUBS
/* 2679 */    MCD::OPC_FilterValue, 102, 8, 0, // Skip to: 2691
/* 2683 */    MCD::OPC_CheckPredicate, 4, 128, 16, // Skip to: 6911
/* 2687 */    MCD::OPC_Decode, 194, 3, 40, // Opcode: FHSUBD
/* 2691 */    MCD::OPC_FilterValue, 105, 4, 0, // Skip to: 2699
/* 2695 */    MCD::OPC_Decode, 160, 4, 42, // Opcode: FSMULD
/* 2699 */    MCD::OPC_FilterValue, 110, 4, 0, // Skip to: 2707
/* 2703 */    MCD::OPC_Decode, 186, 3, 43, // Opcode: FDMULQ
/* 2707 */    MCD::OPC_FilterValue, 113, 8, 0, // Skip to: 2719
/* 2711 */    MCD::OPC_CheckPredicate, 4, 100, 16, // Skip to: 6911
/* 2715 */    MCD::OPC_Decode, 243, 3, 39, // Opcode: FNHADDS
/* 2719 */    MCD::OPC_FilterValue, 114, 8, 0, // Skip to: 2731
/* 2723 */    MCD::OPC_CheckPredicate, 4, 88, 16, // Skip to: 6911
/* 2727 */    MCD::OPC_Decode, 242, 3, 40, // Opcode: FNHADDD
/* 2731 */    MCD::OPC_FilterValue, 121, 8, 0, // Skip to: 2743
/* 2735 */    MCD::OPC_CheckPredicate, 4, 76, 16, // Skip to: 6911
/* 2739 */    MCD::OPC_Decode, 128, 4, 42, // Opcode: FNSMULD
/* 2743 */    MCD::OPC_FilterValue, 129, 1, 10, 0, // Skip to: 2758
/* 2748 */    MCD::OPC_CheckField, 14, 5, 0, 61, 16, // Skip to: 6911
/* 2754 */    MCD::OPC_Decode, 175, 4, 44, // Opcode: FSTOX
/* 2758 */    MCD::OPC_FilterValue, 130, 1, 10, 0, // Skip to: 2773
/* 2763 */    MCD::OPC_CheckField, 14, 5, 0, 46, 16, // Skip to: 6911
/* 2769 */    MCD::OPC_Decode, 190, 3, 37, // Opcode: FDTOX
/* 2773 */    MCD::OPC_FilterValue, 131, 1, 10, 0, // Skip to: 2788
/* 2778 */    MCD::OPC_CheckField, 14, 5, 0, 31, 16, // Skip to: 6911
/* 2784 */    MCD::OPC_Decode, 155, 4, 45, // Opcode: FQTOX
/* 2788 */    MCD::OPC_FilterValue, 132, 1, 10, 0, // Skip to: 2803
/* 2793 */    MCD::OPC_CheckField, 14, 5, 0, 16, 16, // Skip to: 6911
/* 2799 */    MCD::OPC_Decode, 185, 4, 46, // Opcode: FXTOS
/* 2803 */    MCD::OPC_FilterValue, 136, 1, 10, 0, // Skip to: 2818
/* 2808 */    MCD::OPC_CheckField, 14, 5, 0, 1, 16, // Skip to: 6911
/* 2814 */    MCD::OPC_Decode, 183, 4, 37, // Opcode: FXTOD
/* 2818 */    MCD::OPC_FilterValue, 140, 1, 10, 0, // Skip to: 2833
/* 2823 */    MCD::OPC_CheckField, 14, 5, 0, 242, 15, // Skip to: 6911
/* 2829 */    MCD::OPC_Decode, 184, 4, 47, // Opcode: FXTOQ
/* 2833 */    MCD::OPC_FilterValue, 196, 1, 10, 0, // Skip to: 2848
/* 2838 */    MCD::OPC_CheckField, 14, 5, 0, 227, 15, // Skip to: 6911
/* 2844 */    MCD::OPC_Decode, 198, 3, 36, // Opcode: FITOS
/* 2848 */    MCD::OPC_FilterValue, 198, 1, 10, 0, // Skip to: 2863
/* 2853 */    MCD::OPC_CheckField, 14, 5, 0, 212, 15, // Skip to: 6911
/* 2859 */    MCD::OPC_Decode, 189, 3, 46, // Opcode: FDTOS
/* 2863 */    MCD::OPC_FilterValue, 199, 1, 10, 0, // Skip to: 2878
/* 2868 */    MCD::OPC_CheckField, 14, 5, 0, 197, 15, // Skip to: 6911
/* 2874 */    MCD::OPC_Decode, 154, 4, 48, // Opcode: FQTOS
/* 2878 */    MCD::OPC_FilterValue, 200, 1, 10, 0, // Skip to: 2893
/* 2883 */    MCD::OPC_CheckField, 14, 5, 0, 182, 15, // Skip to: 6911
/* 2889 */    MCD::OPC_Decode, 196, 3, 44, // Opcode: FITOD
/* 2893 */    MCD::OPC_FilterValue, 201, 1, 10, 0, // Skip to: 2908
/* 2898 */    MCD::OPC_CheckField, 14, 5, 0, 167, 15, // Skip to: 6911
/* 2904 */    MCD::OPC_Decode, 172, 4, 44, // Opcode: FSTOD
/* 2908 */    MCD::OPC_FilterValue, 203, 1, 10, 0, // Skip to: 2923
/* 2913 */    MCD::OPC_CheckField, 14, 5, 0, 152, 15, // Skip to: 6911
/* 2919 */    MCD::OPC_Decode, 152, 4, 45, // Opcode: FQTOD
/* 2923 */    MCD::OPC_FilterValue, 204, 1, 10, 0, // Skip to: 2938
/* 2928 */    MCD::OPC_CheckField, 14, 5, 0, 137, 15, // Skip to: 6911
/* 2934 */    MCD::OPC_Decode, 197, 3, 49, // Opcode: FITOQ
/* 2938 */    MCD::OPC_FilterValue, 205, 1, 10, 0, // Skip to: 2953
/* 2943 */    MCD::OPC_CheckField, 14, 5, 0, 122, 15, // Skip to: 6911
/* 2949 */    MCD::OPC_Decode, 174, 4, 49, // Opcode: FSTOQ
/* 2953 */    MCD::OPC_FilterValue, 206, 1, 10, 0, // Skip to: 2968
/* 2958 */    MCD::OPC_CheckField, 14, 5, 0, 107, 15, // Skip to: 6911
/* 2964 */    MCD::OPC_Decode, 188, 3, 47, // Opcode: FDTOQ
/* 2968 */    MCD::OPC_FilterValue, 209, 1, 10, 0, // Skip to: 2983
/* 2973 */    MCD::OPC_CheckField, 14, 5, 0, 92, 15, // Skip to: 6911
/* 2979 */    MCD::OPC_Decode, 173, 4, 36, // Opcode: FSTOI
/* 2983 */    MCD::OPC_FilterValue, 210, 1, 10, 0, // Skip to: 2998
/* 2988 */    MCD::OPC_CheckField, 14, 5, 0, 77, 15, // Skip to: 6911
/* 2994 */    MCD::OPC_Decode, 187, 3, 46, // Opcode: FDTOI
/* 2998 */    MCD::OPC_FilterValue, 211, 1, 68, 15, // Skip to: 6911
/* 3003 */    MCD::OPC_CheckField, 14, 5, 0, 62, 15, // Skip to: 6911
/* 3009 */    MCD::OPC_Decode, 153, 4, 48, // Opcode: FQTOI
/* 3013 */    MCD::OPC_FilterValue, 53, 131, 1, // Skip to: 3404
/* 3017 */    MCD::OPC_ExtractField, 5, 5,  // Inst{9-5} ...
/* 3020 */    MCD::OPC_FilterValue, 1, 82, 0, // Skip to: 3106
/* 3024 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3027 */    MCD::OPC_FilterValue, 0, 36, 0, // Skip to: 3067
/* 3031 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 3034 */    MCD::OPC_FilterValue, 0, 33, 15, // Skip to: 6911
/* 3038 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3041 */    MCD::OPC_FilterValue, 0, 26, 15, // Skip to: 6911
/* 3045 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 3059
/* 3049 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 3059
/* 3055 */    MCD::OPC_Decode, 220, 3, 50, // Opcode: FMOVS_FCC
/* 3059 */    MCD::OPC_CheckPredicate, 0, 8, 15, // Skip to: 6911
/* 3063 */    MCD::OPC_Decode, 183, 6, 51, // Opcode: V9FMOVS_FCC
/* 3067 */    MCD::OPC_FilterValue, 1, 0, 15, // Skip to: 6911
/* 3071 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 3074 */    MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 3092
/* 3078 */    MCD::OPC_CheckPredicate, 0, 245, 14, // Skip to: 6911
/* 3082 */    MCD::OPC_CheckField, 18, 1, 0, 239, 14, // Skip to: 6911
/* 3088 */    MCD::OPC_Decode, 221, 3, 50, // Opcode: FMOVS_ICC
/* 3092 */    MCD::OPC_FilterValue, 4, 231, 14, // Skip to: 6911
/* 3096 */    MCD::OPC_CheckField, 18, 1, 0, 225, 14, // Skip to: 6911
/* 3102 */    MCD::OPC_Decode, 222, 3, 50, // Opcode: FMOVS_XCC
/* 3106 */    MCD::OPC_FilterValue, 2, 82, 0, // Skip to: 3192
/* 3110 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3113 */    MCD::OPC_FilterValue, 0, 36, 0, // Skip to: 3153
/* 3117 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 3120 */    MCD::OPC_FilterValue, 0, 203, 14, // Skip to: 6911
/* 3124 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3127 */    MCD::OPC_FilterValue, 0, 196, 14, // Skip to: 6911
/* 3131 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 3145
/* 3135 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 3145
/* 3141 */    MCD::OPC_Decode, 209, 3, 52, // Opcode: FMOVD_FCC
/* 3145 */    MCD::OPC_CheckPredicate, 0, 178, 14, // Skip to: 6911
/* 3149 */    MCD::OPC_Decode, 181, 6, 53, // Opcode: V9FMOVD_FCC
/* 3153 */    MCD::OPC_FilterValue, 1, 170, 14, // Skip to: 6911
/* 3157 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 3160 */    MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 3178
/* 3164 */    MCD::OPC_CheckPredicate, 0, 159, 14, // Skip to: 6911
/* 3168 */    MCD::OPC_CheckField, 18, 1, 0, 153, 14, // Skip to: 6911
/* 3174 */    MCD::OPC_Decode, 210, 3, 52, // Opcode: FMOVD_ICC
/* 3178 */    MCD::OPC_FilterValue, 4, 145, 14, // Skip to: 6911
/* 3182 */    MCD::OPC_CheckField, 18, 1, 0, 139, 14, // Skip to: 6911
/* 3188 */    MCD::OPC_Decode, 211, 3, 52, // Opcode: FMOVD_XCC
/* 3192 */    MCD::OPC_FilterValue, 3, 82, 0, // Skip to: 3278
/* 3196 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3199 */    MCD::OPC_FilterValue, 0, 36, 0, // Skip to: 3239
/* 3203 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 3206 */    MCD::OPC_FilterValue, 0, 117, 14, // Skip to: 6911
/* 3210 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3213 */    MCD::OPC_FilterValue, 0, 110, 14, // Skip to: 6911
/* 3217 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 3231
/* 3221 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 3231
/* 3227 */    MCD::OPC_Decode, 213, 3, 54, // Opcode: FMOVQ_FCC
/* 3231 */    MCD::OPC_CheckPredicate, 0, 92, 14, // Skip to: 6911
/* 3235 */    MCD::OPC_Decode, 182, 6, 55, // Opcode: V9FMOVQ_FCC
/* 3239 */    MCD::OPC_FilterValue, 1, 84, 14, // Skip to: 6911
/* 3243 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 3246 */    MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 3264
/* 3250 */    MCD::OPC_CheckPredicate, 0, 73, 14, // Skip to: 6911
/* 3254 */    MCD::OPC_CheckField, 18, 1, 0, 67, 14, // Skip to: 6911
/* 3260 */    MCD::OPC_Decode, 214, 3, 54, // Opcode: FMOVQ_ICC
/* 3264 */    MCD::OPC_FilterValue, 4, 59, 14, // Skip to: 6911
/* 3268 */    MCD::OPC_CheckField, 18, 1, 0, 53, 14, // Skip to: 6911
/* 3274 */    MCD::OPC_Decode, 215, 3, 54, // Opcode: FMOVQ_XCC
/* 3278 */    MCD::OPC_FilterValue, 5, 10, 0, // Skip to: 3292
/* 3282 */    MCD::OPC_CheckField, 13, 1, 0, 39, 14, // Skip to: 6911
/* 3288 */    MCD::OPC_Decode, 218, 3, 56, // Opcode: FMOVRS
/* 3292 */    MCD::OPC_FilterValue, 6, 10, 0, // Skip to: 3306
/* 3296 */    MCD::OPC_CheckField, 13, 1, 0, 25, 14, // Skip to: 6911
/* 3302 */    MCD::OPC_Decode, 216, 3, 57, // Opcode: FMOVRD
/* 3306 */    MCD::OPC_FilterValue, 7, 10, 0, // Skip to: 3320
/* 3310 */    MCD::OPC_CheckField, 13, 1, 0, 11, 14, // Skip to: 6911
/* 3316 */    MCD::OPC_Decode, 217, 3, 58, // Opcode: FMOVRQ
/* 3320 */    MCD::OPC_FilterValue, 17, 10, 0, // Skip to: 3334
/* 3324 */    MCD::OPC_CheckField, 10, 4, 2, 253, 13, // Skip to: 6911
/* 3330 */    MCD::OPC_Decode, 180, 6, 59, // Opcode: V9FCMPS
/* 3334 */    MCD::OPC_FilterValue, 18, 10, 0, // Skip to: 3348
/* 3338 */    MCD::OPC_CheckField, 10, 4, 2, 239, 13, // Skip to: 6911
/* 3344 */    MCD::OPC_Decode, 175, 6, 60, // Opcode: V9FCMPD
/* 3348 */    MCD::OPC_FilterValue, 19, 10, 0, // Skip to: 3362
/* 3352 */    MCD::OPC_CheckField, 10, 4, 2, 225, 13, // Skip to: 6911
/* 3358 */    MCD::OPC_Decode, 179, 6, 61, // Opcode: V9FCMPQ
/* 3362 */    MCD::OPC_FilterValue, 21, 10, 0, // Skip to: 3376
/* 3366 */    MCD::OPC_CheckField, 10, 4, 2, 211, 13, // Skip to: 6911
/* 3372 */    MCD::OPC_Decode, 178, 6, 59, // Opcode: V9FCMPES
/* 3376 */    MCD::OPC_FilterValue, 22, 10, 0, // Skip to: 3390
/* 3380 */    MCD::OPC_CheckField, 10, 4, 2, 197, 13, // Skip to: 6911
/* 3386 */    MCD::OPC_Decode, 176, 6, 60, // Opcode: V9FCMPED
/* 3390 */    MCD::OPC_FilterValue, 23, 189, 13, // Skip to: 6911
/* 3394 */    MCD::OPC_CheckField, 10, 4, 2, 183, 13, // Skip to: 6911
/* 3400 */    MCD::OPC_Decode, 177, 6, 61, // Opcode: V9FCMPEQ
/* 3404 */    MCD::OPC_FilterValue, 54, 32, 6, // Skip to: 4976
/* 3408 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 3411 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 3423
/* 3415 */    MCD::OPC_CheckPredicate, 5, 164, 13, // Skip to: 6911
/* 3419 */    MCD::OPC_Decode, 147, 3, 13, // Opcode: EDGE8
/* 3423 */    MCD::OPC_FilterValue, 1, 8, 0, // Skip to: 3435
/* 3427 */    MCD::OPC_CheckPredicate, 6, 152, 13, // Skip to: 6911
/* 3431 */    MCD::OPC_Decode, 150, 3, 13, // Opcode: EDGE8N
/* 3435 */    MCD::OPC_FilterValue, 2, 8, 0, // Skip to: 3447
/* 3439 */    MCD::OPC_CheckPredicate, 5, 140, 13, // Skip to: 6911
/* 3443 */    MCD::OPC_Decode, 148, 3, 13, // Opcode: EDGE8L
/* 3447 */    MCD::OPC_FilterValue, 3, 8, 0, // Skip to: 3459
/* 3451 */    MCD::OPC_CheckPredicate, 6, 128, 13, // Skip to: 6911
/* 3455 */    MCD::OPC_Decode, 149, 3, 13, // Opcode: EDGE8LN
/* 3459 */    MCD::OPC_FilterValue, 4, 8, 0, // Skip to: 3471
/* 3463 */    MCD::OPC_CheckPredicate, 5, 116, 13, // Skip to: 6911
/* 3467 */    MCD::OPC_Decode, 139, 3, 13, // Opcode: EDGE16
/* 3471 */    MCD::OPC_FilterValue, 5, 8, 0, // Skip to: 3483
/* 3475 */    MCD::OPC_CheckPredicate, 6, 104, 13, // Skip to: 6911
/* 3479 */    MCD::OPC_Decode, 142, 3, 13, // Opcode: EDGE16N
/* 3483 */    MCD::OPC_FilterValue, 6, 8, 0, // Skip to: 3495
/* 3487 */    MCD::OPC_CheckPredicate, 5, 92, 13, // Skip to: 6911
/* 3491 */    MCD::OPC_Decode, 140, 3, 13, // Opcode: EDGE16L
/* 3495 */    MCD::OPC_FilterValue, 7, 8, 0, // Skip to: 3507
/* 3499 */    MCD::OPC_CheckPredicate, 6, 80, 13, // Skip to: 6911
/* 3503 */    MCD::OPC_Decode, 141, 3, 13, // Opcode: EDGE16LN
/* 3507 */    MCD::OPC_FilterValue, 8, 8, 0, // Skip to: 3519
/* 3511 */    MCD::OPC_CheckPredicate, 5, 68, 13, // Skip to: 6911
/* 3515 */    MCD::OPC_Decode, 143, 3, 13, // Opcode: EDGE32
/* 3519 */    MCD::OPC_FilterValue, 9, 8, 0, // Skip to: 3531
/* 3523 */    MCD::OPC_CheckPredicate, 6, 56, 13, // Skip to: 6911
/* 3527 */    MCD::OPC_Decode, 146, 3, 13, // Opcode: EDGE32N
/* 3531 */    MCD::OPC_FilterValue, 10, 8, 0, // Skip to: 3543
/* 3535 */    MCD::OPC_CheckPredicate, 5, 44, 13, // Skip to: 6911
/* 3539 */    MCD::OPC_Decode, 144, 3, 13, // Opcode: EDGE32L
/* 3543 */    MCD::OPC_FilterValue, 11, 8, 0, // Skip to: 3555
/* 3547 */    MCD::OPC_CheckPredicate, 6, 32, 13, // Skip to: 6911
/* 3551 */    MCD::OPC_Decode, 145, 3, 13, // Opcode: EDGE32LN
/* 3555 */    MCD::OPC_FilterValue, 16, 8, 0, // Skip to: 3567
/* 3559 */    MCD::OPC_CheckPredicate, 5, 20, 13, // Skip to: 6911
/* 3563 */    MCD::OPC_Decode, 223, 2, 13, // Opcode: ARRAY8
/* 3567 */    MCD::OPC_FilterValue, 17, 8, 0, // Skip to: 3579
/* 3571 */    MCD::OPC_CheckPredicate, 4, 8, 13, // Skip to: 6911
/* 3575 */    MCD::OPC_Decode, 206, 2, 13, // Opcode: ADDXC
/* 3579 */    MCD::OPC_FilterValue, 18, 8, 0, // Skip to: 3591
/* 3583 */    MCD::OPC_CheckPredicate, 5, 252, 12, // Skip to: 6911
/* 3587 */    MCD::OPC_Decode, 221, 2, 13, // Opcode: ARRAY16
/* 3591 */    MCD::OPC_FilterValue, 19, 8, 0, // Skip to: 3603
/* 3595 */    MCD::OPC_CheckPredicate, 4, 240, 12, // Skip to: 6911
/* 3599 */    MCD::OPC_Decode, 207, 2, 13, // Opcode: ADDXCCC
/* 3603 */    MCD::OPC_FilterValue, 20, 8, 0, // Skip to: 3615
/* 3607 */    MCD::OPC_CheckPredicate, 5, 228, 12, // Skip to: 6911
/* 3611 */    MCD::OPC_Decode, 222, 2, 13, // Opcode: ARRAY32
/* 3615 */    MCD::OPC_FilterValue, 22, 8, 0, // Skip to: 3627
/* 3619 */    MCD::OPC_CheckPredicate, 4, 216, 12, // Skip to: 6911
/* 3623 */    MCD::OPC_Decode, 171, 6, 13, // Opcode: UMULXHI
/* 3627 */    MCD::OPC_FilterValue, 23, 14, 0, // Skip to: 3645
/* 3631 */    MCD::OPC_CheckPredicate, 4, 204, 12, // Skip to: 6911
/* 3635 */    MCD::OPC_CheckField, 14, 5, 0, 198, 12, // Skip to: 6911
/* 3641 */    MCD::OPC_Decode, 251, 4, 62, // Opcode: LZCNT
/* 3645 */    MCD::OPC_FilterValue, 24, 8, 0, // Skip to: 3657
/* 3649 */    MCD::OPC_CheckPredicate, 5, 186, 12, // Skip to: 6911
/* 3653 */    MCD::OPC_Decode, 210, 2, 13, // Opcode: ALIGNADDR
/* 3657 */    MCD::OPC_FilterValue, 25, 8, 0, // Skip to: 3669
/* 3661 */    MCD::OPC_CheckPredicate, 6, 174, 12, // Skip to: 6911
/* 3665 */    MCD::OPC_Decode, 229, 2, 13, // Opcode: BMASK
/* 3669 */    MCD::OPC_FilterValue, 26, 8, 0, // Skip to: 3681
/* 3673 */    MCD::OPC_CheckPredicate, 5, 162, 12, // Skip to: 6911
/* 3677 */    MCD::OPC_Decode, 211, 2, 13, // Opcode: ALIGNADDRL
/* 3681 */    MCD::OPC_FilterValue, 27, 20, 0, // Skip to: 3705
/* 3685 */    MCD::OPC_CheckPredicate, 4, 150, 12, // Skip to: 6911
/* 3689 */    MCD::OPC_CheckField, 25, 5, 0, 144, 12, // Skip to: 6911
/* 3695 */    MCD::OPC_CheckField, 14, 5, 0, 138, 12, // Skip to: 6911
/* 3701 */    MCD::OPC_Decode, 131, 3, 63, // Opcode: CMASK8
/* 3705 */    MCD::OPC_FilterValue, 29, 20, 0, // Skip to: 3729
/* 3709 */    MCD::OPC_CheckPredicate, 4, 126, 12, // Skip to: 6911
/* 3713 */    MCD::OPC_CheckField, 25, 5, 0, 120, 12, // Skip to: 6911
/* 3719 */    MCD::OPC_CheckField, 14, 5, 0, 114, 12, // Skip to: 6911
/* 3725 */    MCD::OPC_Decode, 129, 3, 63, // Opcode: CMASK16
/* 3729 */    MCD::OPC_FilterValue, 31, 20, 0, // Skip to: 3753
/* 3733 */    MCD::OPC_CheckPredicate, 4, 102, 12, // Skip to: 6911
/* 3737 */    MCD::OPC_CheckField, 25, 5, 0, 96, 12, // Skip to: 6911
/* 3743 */    MCD::OPC_CheckField, 14, 5, 0, 90, 12, // Skip to: 6911
/* 3749 */    MCD::OPC_Decode, 130, 3, 63, // Opcode: CMASK32
/* 3753 */    MCD::OPC_FilterValue, 32, 8, 0, // Skip to: 3765
/* 3757 */    MCD::OPC_CheckPredicate, 5, 78, 12, // Skip to: 6911
/* 3761 */    MCD::OPC_Decode, 175, 3, 64, // Opcode: FCMPLE16
/* 3765 */    MCD::OPC_FilterValue, 33, 8, 0, // Skip to: 3777
/* 3769 */    MCD::OPC_CheckPredicate, 4, 66, 12, // Skip to: 6911
/* 3773 */    MCD::OPC_Decode, 158, 4, 40, // Opcode: FSLL16
/* 3777 */    MCD::OPC_FilterValue, 34, 8, 0, // Skip to: 3789
/* 3781 */    MCD::OPC_CheckPredicate, 5, 54, 12, // Skip to: 6911
/* 3785 */    MCD::OPC_Decode, 177, 3, 64, // Opcode: FCMPNE16
/* 3789 */    MCD::OPC_FilterValue, 35, 8, 0, // Skip to: 3801
/* 3793 */    MCD::OPC_CheckPredicate, 4, 42, 12, // Skip to: 6911
/* 3797 */    MCD::OPC_Decode, 170, 4, 40, // Opcode: FSRL16
/* 3801 */    MCD::OPC_FilterValue, 36, 8, 0, // Skip to: 3813
/* 3805 */    MCD::OPC_CheckPredicate, 5, 30, 12, // Skip to: 6911
/* 3809 */    MCD::OPC_Decode, 176, 3, 64, // Opcode: FCMPLE32
/* 3813 */    MCD::OPC_FilterValue, 37, 8, 0, // Skip to: 3825
/* 3817 */    MCD::OPC_CheckPredicate, 4, 18, 12, // Skip to: 6911
/* 3821 */    MCD::OPC_Decode, 159, 4, 40, // Opcode: FSLL32
/* 3825 */    MCD::OPC_FilterValue, 38, 8, 0, // Skip to: 3837
/* 3829 */    MCD::OPC_CheckPredicate, 5, 6, 12, // Skip to: 6911
/* 3833 */    MCD::OPC_Decode, 178, 3, 64, // Opcode: FCMPNE32
/* 3837 */    MCD::OPC_FilterValue, 39, 8, 0, // Skip to: 3849
/* 3841 */    MCD::OPC_CheckPredicate, 4, 250, 11, // Skip to: 6911
/* 3845 */    MCD::OPC_Decode, 171, 4, 40, // Opcode: FSRL32
/* 3849 */    MCD::OPC_FilterValue, 40, 8, 0, // Skip to: 3861
/* 3853 */    MCD::OPC_CheckPredicate, 5, 238, 11, // Skip to: 6911
/* 3857 */    MCD::OPC_Decode, 173, 3, 64, // Opcode: FCMPGT16
/* 3861 */    MCD::OPC_FilterValue, 41, 8, 0, // Skip to: 3873
/* 3865 */    MCD::OPC_CheckPredicate, 4, 226, 11, // Skip to: 6911
/* 3869 */    MCD::OPC_Decode, 156, 4, 40, // Opcode: FSLAS16
/* 3873 */    MCD::OPC_FilterValue, 42, 8, 0, // Skip to: 3885
/* 3877 */    MCD::OPC_CheckPredicate, 5, 214, 11, // Skip to: 6911
/* 3881 */    MCD::OPC_Decode, 171, 3, 64, // Opcode: FCMPEQ16
/* 3885 */    MCD::OPC_FilterValue, 43, 8, 0, // Skip to: 3897
/* 3889 */    MCD::OPC_CheckPredicate, 4, 202, 11, // Skip to: 6911
/* 3893 */    MCD::OPC_Decode, 164, 4, 40, // Opcode: FSRA16
/* 3897 */    MCD::OPC_FilterValue, 44, 8, 0, // Skip to: 3909
/* 3901 */    MCD::OPC_CheckPredicate, 5, 190, 11, // Skip to: 6911
/* 3905 */    MCD::OPC_Decode, 174, 3, 64, // Opcode: FCMPGT32
/* 3909 */    MCD::OPC_FilterValue, 45, 8, 0, // Skip to: 3921
/* 3913 */    MCD::OPC_CheckPredicate, 4, 178, 11, // Skip to: 6911
/* 3917 */    MCD::OPC_Decode, 157, 4, 40, // Opcode: FSLAS32
/* 3921 */    MCD::OPC_FilterValue, 46, 8, 0, // Skip to: 3933
/* 3925 */    MCD::OPC_CheckPredicate, 5, 166, 11, // Skip to: 6911
/* 3929 */    MCD::OPC_Decode, 172, 3, 64, // Opcode: FCMPEQ32
/* 3933 */    MCD::OPC_FilterValue, 47, 8, 0, // Skip to: 3945
/* 3937 */    MCD::OPC_CheckPredicate, 4, 154, 11, // Skip to: 6911
/* 3941 */    MCD::OPC_Decode, 165, 4, 40, // Opcode: FSRA32
/* 3945 */    MCD::OPC_FilterValue, 49, 8, 0, // Skip to: 3957
/* 3949 */    MCD::OPC_CheckPredicate, 5, 142, 11, // Skip to: 6911
/* 3953 */    MCD::OPC_Decode, 227, 3, 65, // Opcode: FMUL8X16
/* 3957 */    MCD::OPC_FilterValue, 51, 8, 0, // Skip to: 3969
/* 3961 */    MCD::OPC_CheckPredicate, 5, 130, 11, // Skip to: 6911
/* 3965 */    MCD::OPC_Decode, 229, 3, 42, // Opcode: FMUL8X16AU
/* 3969 */    MCD::OPC_FilterValue, 53, 8, 0, // Skip to: 3981
/* 3973 */    MCD::OPC_CheckPredicate, 5, 118, 11, // Skip to: 6911
/* 3977 */    MCD::OPC_Decode, 228, 3, 42, // Opcode: FMUL8X16AL
/* 3981 */    MCD::OPC_FilterValue, 54, 8, 0, // Skip to: 3993
/* 3985 */    MCD::OPC_CheckPredicate, 5, 106, 11, // Skip to: 6911
/* 3989 */    MCD::OPC_Decode, 225, 3, 40, // Opcode: FMUL8SUX16
/* 3993 */    MCD::OPC_FilterValue, 55, 8, 0, // Skip to: 4005
/* 3997 */    MCD::OPC_CheckPredicate, 5, 94, 11, // Skip to: 6911
/* 4001 */    MCD::OPC_Decode, 226, 3, 40, // Opcode: FMUL8ULX16
/* 4005 */    MCD::OPC_FilterValue, 56, 8, 0, // Skip to: 4017
/* 4009 */    MCD::OPC_CheckPredicate, 5, 82, 11, // Skip to: 6911
/* 4013 */    MCD::OPC_Decode, 231, 3, 42, // Opcode: FMULD8SUX16
/* 4017 */    MCD::OPC_FilterValue, 57, 8, 0, // Skip to: 4029
/* 4021 */    MCD::OPC_CheckPredicate, 5, 70, 11, // Skip to: 6911
/* 4025 */    MCD::OPC_Decode, 232, 3, 42, // Opcode: FMULD8ULX16
/* 4029 */    MCD::OPC_FilterValue, 58, 8, 0, // Skip to: 4041
/* 4033 */    MCD::OPC_CheckPredicate, 5, 58, 11, // Skip to: 6911
/* 4037 */    MCD::OPC_Decode, 138, 4, 40, // Opcode: FPACK32
/* 4041 */    MCD::OPC_FilterValue, 59, 14, 0, // Skip to: 4059
/* 4045 */    MCD::OPC_CheckPredicate, 5, 46, 11, // Skip to: 6911
/* 4049 */    MCD::OPC_CheckField, 14, 5, 0, 40, 11, // Skip to: 6911
/* 4055 */    MCD::OPC_Decode, 137, 4, 37, // Opcode: FPACK16
/* 4059 */    MCD::OPC_FilterValue, 61, 14, 0, // Skip to: 4077
/* 4063 */    MCD::OPC_CheckPredicate, 5, 28, 11, // Skip to: 6911
/* 4067 */    MCD::OPC_CheckField, 14, 5, 0, 22, 11, // Skip to: 6911
/* 4073 */    MCD::OPC_Decode, 139, 4, 46, // Opcode: FPACKFIX
/* 4077 */    MCD::OPC_FilterValue, 62, 8, 0, // Skip to: 4089
/* 4081 */    MCD::OPC_CheckPredicate, 5, 10, 11, // Skip to: 6911
/* 4085 */    MCD::OPC_Decode, 153, 5, 40, // Opcode: PDIST
/* 4089 */    MCD::OPC_FilterValue, 63, 8, 0, // Skip to: 4101
/* 4093 */    MCD::OPC_CheckPredicate, 4, 254, 10, // Skip to: 6911
/* 4097 */    MCD::OPC_Decode, 154, 5, 64, // Opcode: PDISTN
/* 4101 */    MCD::OPC_FilterValue, 64, 8, 0, // Skip to: 4113
/* 4105 */    MCD::OPC_CheckPredicate, 4, 242, 10, // Skip to: 6911
/* 4109 */    MCD::OPC_Decode, 207, 3, 40, // Opcode: FMEAN16
/* 4113 */    MCD::OPC_FilterValue, 66, 8, 0, // Skip to: 4125
/* 4117 */    MCD::OPC_CheckPredicate, 4, 230, 10, // Skip to: 6911
/* 4121 */    MCD::OPC_Decode, 144, 4, 40, // Opcode: FPADD64
/* 4125 */    MCD::OPC_FilterValue, 68, 8, 0, // Skip to: 4137
/* 4129 */    MCD::OPC_CheckPredicate, 4, 218, 10, // Skip to: 6911
/* 4133 */    MCD::OPC_Decode, 168, 3, 40, // Opcode: FCHKSM16
/* 4137 */    MCD::OPC_FilterValue, 72, 8, 0, // Skip to: 4149
/* 4141 */    MCD::OPC_CheckPredicate, 5, 206, 10, // Skip to: 6911
/* 4145 */    MCD::OPC_Decode, 157, 3, 40, // Opcode: FALIGNADATA
/* 4149 */    MCD::OPC_FilterValue, 75, 8, 0, // Skip to: 4161
/* 4153 */    MCD::OPC_CheckPredicate, 5, 194, 10, // Skip to: 6911
/* 4157 */    MCD::OPC_Decode, 147, 4, 42, // Opcode: FPMERGE
/* 4161 */    MCD::OPC_FilterValue, 76, 8, 0, // Skip to: 4173
/* 4165 */    MCD::OPC_CheckPredicate, 6, 182, 10, // Skip to: 6911
/* 4169 */    MCD::OPC_Decode, 246, 2, 40, // Opcode: BSHUFFLE
/* 4173 */    MCD::OPC_FilterValue, 77, 14, 0, // Skip to: 4191
/* 4177 */    MCD::OPC_CheckPredicate, 5, 170, 10, // Skip to: 6911
/* 4181 */    MCD::OPC_CheckField, 14, 5, 0, 164, 10, // Skip to: 6911
/* 4187 */    MCD::OPC_Decode, 191, 3, 44, // Opcode: FEXPAND
/* 4191 */    MCD::OPC_FilterValue, 80, 8, 0, // Skip to: 4203
/* 4195 */    MCD::OPC_CheckPredicate, 5, 152, 10, // Skip to: 6911
/* 4199 */    MCD::OPC_Decode, 140, 4, 40, // Opcode: FPADD16
/* 4203 */    MCD::OPC_FilterValue, 81, 8, 0, // Skip to: 4215
/* 4207 */    MCD::OPC_CheckPredicate, 5, 140, 10, // Skip to: 6911
/* 4211 */    MCD::OPC_Decode, 141, 4, 39, // Opcode: FPADD16S
/* 4215 */    MCD::OPC_FilterValue, 82, 8, 0, // Skip to: 4227
/* 4219 */    MCD::OPC_CheckPredicate, 5, 128, 10, // Skip to: 6911
/* 4223 */    MCD::OPC_Decode, 142, 4, 40, // Opcode: FPADD32
/* 4227 */    MCD::OPC_FilterValue, 83, 8, 0, // Skip to: 4239
/* 4231 */    MCD::OPC_CheckPredicate, 5, 116, 10, // Skip to: 6911
/* 4235 */    MCD::OPC_Decode, 143, 4, 39, // Opcode: FPADD32S
/* 4239 */    MCD::OPC_FilterValue, 84, 8, 0, // Skip to: 4251
/* 4243 */    MCD::OPC_CheckPredicate, 5, 104, 10, // Skip to: 6911
/* 4247 */    MCD::OPC_Decode, 148, 4, 40, // Opcode: FPSUB16
/* 4251 */    MCD::OPC_FilterValue, 85, 8, 0, // Skip to: 4263
/* 4255 */    MCD::OPC_CheckPredicate, 5, 92, 10, // Skip to: 6911
/* 4259 */    MCD::OPC_Decode, 149, 4, 39, // Opcode: FPSUB16S
/* 4263 */    MCD::OPC_FilterValue, 86, 8, 0, // Skip to: 4275
/* 4267 */    MCD::OPC_CheckPredicate, 5, 80, 10, // Skip to: 6911
/* 4271 */    MCD::OPC_Decode, 150, 4, 40, // Opcode: FPSUB32
/* 4275 */    MCD::OPC_FilterValue, 87, 8, 0, // Skip to: 4287
/* 4279 */    MCD::OPC_CheckPredicate, 5, 68, 10, // Skip to: 6911
/* 4283 */    MCD::OPC_Decode, 151, 4, 39, // Opcode: FPSUB32S
/* 4287 */    MCD::OPC_FilterValue, 96, 20, 0, // Skip to: 4311
/* 4291 */    MCD::OPC_CheckPredicate, 5, 56, 10, // Skip to: 6911
/* 4295 */    MCD::OPC_CheckField, 14, 5, 0, 50, 10, // Skip to: 6911
/* 4301 */    MCD::OPC_CheckField, 0, 5, 0, 44, 10, // Skip to: 6911
/* 4307 */    MCD::OPC_Decode, 186, 4, 66, // Opcode: FZERO
/* 4311 */    MCD::OPC_FilterValue, 97, 20, 0, // Skip to: 4335
/* 4315 */    MCD::OPC_CheckPredicate, 5, 32, 10, // Skip to: 6911
/* 4319 */    MCD::OPC_CheckField, 14, 5, 0, 26, 10, // Skip to: 6911
/* 4325 */    MCD::OPC_CheckField, 0, 5, 0, 20, 10, // Skip to: 6911
/* 4331 */    MCD::OPC_Decode, 187, 4, 67, // Opcode: FZEROS
/* 4335 */    MCD::OPC_FilterValue, 98, 8, 0, // Skip to: 4347
/* 4339 */    MCD::OPC_CheckPredicate, 5, 8, 10, // Skip to: 6911
/* 4343 */    MCD::OPC_Decode, 250, 3, 40, // Opcode: FNOR
/* 4347 */    MCD::OPC_FilterValue, 99, 8, 0, // Skip to: 4359
/* 4351 */    MCD::OPC_CheckPredicate, 5, 252, 9, // Skip to: 6911
/* 4355 */    MCD::OPC_Decode, 251, 3, 39, // Opcode: FNORS
/* 4359 */    MCD::OPC_FilterValue, 100, 8, 0, // Skip to: 4371
/* 4363 */    MCD::OPC_CheckPredicate, 5, 240, 9, // Skip to: 6911
/* 4367 */    MCD::OPC_Decode, 161, 3, 40, // Opcode: FANDNOT2
/* 4371 */    MCD::OPC_FilterValue, 101, 8, 0, // Skip to: 4383
/* 4375 */    MCD::OPC_CheckPredicate, 5, 228, 9, // Skip to: 6911
/* 4379 */    MCD::OPC_Decode, 162, 3, 39, // Opcode: FANDNOT2S
/* 4383 */    MCD::OPC_FilterValue, 102, 14, 0, // Skip to: 4401
/* 4387 */    MCD::OPC_CheckPredicate, 5, 216, 9, // Skip to: 6911
/* 4391 */    MCD::OPC_CheckField, 14, 5, 0, 210, 9, // Skip to: 6911
/* 4397 */    MCD::OPC_Decode, 254, 3, 37, // Opcode: FNOT2
/* 4401 */    MCD::OPC_FilterValue, 103, 14, 0, // Skip to: 4419
/* 4405 */    MCD::OPC_CheckPredicate, 5, 198, 9, // Skip to: 6911
/* 4409 */    MCD::OPC_CheckField, 14, 5, 0, 192, 9, // Skip to: 6911
/* 4415 */    MCD::OPC_Decode, 255, 3, 36, // Opcode: FNOT2S
/* 4419 */    MCD::OPC_FilterValue, 104, 8, 0, // Skip to: 4431
/* 4423 */    MCD::OPC_CheckPredicate, 5, 180, 9, // Skip to: 6911
/* 4427 */    MCD::OPC_Decode, 159, 3, 40, // Opcode: FANDNOT1
/* 4431 */    MCD::OPC_FilterValue, 105, 8, 0, // Skip to: 4443
/* 4435 */    MCD::OPC_CheckPredicate, 5, 168, 9, // Skip to: 6911
/* 4439 */    MCD::OPC_Decode, 160, 3, 39, // Opcode: FANDNOT1S
/* 4443 */    MCD::OPC_FilterValue, 106, 14, 0, // Skip to: 4461
/* 4447 */    MCD::OPC_CheckPredicate, 5, 156, 9, // Skip to: 6911
/* 4451 */    MCD::OPC_CheckField, 0, 5, 0, 150, 9, // Skip to: 6911
/* 4457 */    MCD::OPC_Decode, 252, 3, 68, // Opcode: FNOT1
/* 4461 */    MCD::OPC_FilterValue, 107, 14, 0, // Skip to: 4479
/* 4465 */    MCD::OPC_CheckPredicate, 5, 138, 9, // Skip to: 6911
/* 4469 */    MCD::OPC_CheckField, 0, 5, 0, 132, 9, // Skip to: 6911
/* 4475 */    MCD::OPC_Decode, 253, 3, 69, // Opcode: FNOT1S
/* 4479 */    MCD::OPC_FilterValue, 108, 8, 0, // Skip to: 4491
/* 4483 */    MCD::OPC_CheckPredicate, 5, 120, 9, // Skip to: 6911
/* 4487 */    MCD::OPC_Decode, 181, 4, 40, // Opcode: FXOR
/* 4491 */    MCD::OPC_FilterValue, 109, 8, 0, // Skip to: 4503
/* 4495 */    MCD::OPC_CheckPredicate, 5, 108, 9, // Skip to: 6911
/* 4499 */    MCD::OPC_Decode, 182, 4, 39, // Opcode: FXORS
/* 4503 */    MCD::OPC_FilterValue, 110, 8, 0, // Skip to: 4515
/* 4507 */    MCD::OPC_CheckPredicate, 5, 96, 9, // Skip to: 6911
/* 4511 */    MCD::OPC_Decode, 237, 3, 40, // Opcode: FNAND
/* 4515 */    MCD::OPC_FilterValue, 111, 8, 0, // Skip to: 4527
/* 4519 */    MCD::OPC_CheckPredicate, 5, 84, 9, // Skip to: 6911
/* 4523 */    MCD::OPC_Decode, 238, 3, 39, // Opcode: FNANDS
/* 4527 */    MCD::OPC_FilterValue, 112, 8, 0, // Skip to: 4539
/* 4531 */    MCD::OPC_CheckPredicate, 5, 72, 9, // Skip to: 6911
/* 4535 */    MCD::OPC_Decode, 158, 3, 40, // Opcode: FAND
/* 4539 */    MCD::OPC_FilterValue, 113, 8, 0, // Skip to: 4551
/* 4543 */    MCD::OPC_CheckPredicate, 5, 60, 9, // Skip to: 6911
/* 4547 */    MCD::OPC_Decode, 163, 3, 39, // Opcode: FANDS
/* 4551 */    MCD::OPC_FilterValue, 114, 8, 0, // Skip to: 4563
/* 4555 */    MCD::OPC_CheckPredicate, 5, 48, 9, // Skip to: 6911
/* 4559 */    MCD::OPC_Decode, 179, 4, 40, // Opcode: FXNOR
/* 4563 */    MCD::OPC_FilterValue, 115, 8, 0, // Skip to: 4575
/* 4567 */    MCD::OPC_CheckPredicate, 5, 36, 9, // Skip to: 6911
/* 4571 */    MCD::OPC_Decode, 180, 4, 39, // Opcode: FXNORS
/* 4575 */    MCD::OPC_FilterValue, 116, 14, 0, // Skip to: 4593
/* 4579 */    MCD::OPC_CheckPredicate, 5, 24, 9, // Skip to: 6911
/* 4583 */    MCD::OPC_CheckField, 0, 5, 0, 18, 9, // Skip to: 6911
/* 4589 */    MCD::OPC_Decode, 166, 4, 68, // Opcode: FSRC1
/* 4593 */    MCD::OPC_FilterValue, 117, 14, 0, // Skip to: 4611
/* 4597 */    MCD::OPC_CheckPredicate, 5, 6, 9, // Skip to: 6911
/* 4601 */    MCD::OPC_CheckField, 0, 5, 0, 0, 9, // Skip to: 6911
/* 4607 */    MCD::OPC_Decode, 167, 4, 69, // Opcode: FSRC1S
/* 4611 */    MCD::OPC_FilterValue, 118, 8, 0, // Skip to: 4623
/* 4615 */    MCD::OPC_CheckPredicate, 5, 244, 8, // Skip to: 6911
/* 4619 */    MCD::OPC_Decode, 134, 4, 40, // Opcode: FORNOT2
/* 4623 */    MCD::OPC_FilterValue, 119, 8, 0, // Skip to: 4635
/* 4627 */    MCD::OPC_CheckPredicate, 5, 232, 8, // Skip to: 6911
/* 4631 */    MCD::OPC_Decode, 135, 4, 39, // Opcode: FORNOT2S
/* 4635 */    MCD::OPC_FilterValue, 120, 14, 0, // Skip to: 4653
/* 4639 */    MCD::OPC_CheckPredicate, 5, 220, 8, // Skip to: 6911
/* 4643 */    MCD::OPC_CheckField, 14, 5, 0, 214, 8, // Skip to: 6911
/* 4649 */    MCD::OPC_Decode, 168, 4, 37, // Opcode: FSRC2
/* 4653 */    MCD::OPC_FilterValue, 121, 14, 0, // Skip to: 4671
/* 4657 */    MCD::OPC_CheckPredicate, 5, 202, 8, // Skip to: 6911
/* 4661 */    MCD::OPC_CheckField, 14, 5, 0, 196, 8, // Skip to: 6911
/* 4667 */    MCD::OPC_Decode, 169, 4, 36, // Opcode: FSRC2S
/* 4671 */    MCD::OPC_FilterValue, 122, 8, 0, // Skip to: 4683
/* 4675 */    MCD::OPC_CheckPredicate, 5, 184, 8, // Skip to: 6911
/* 4679 */    MCD::OPC_Decode, 132, 4, 40, // Opcode: FORNOT1
/* 4683 */    MCD::OPC_FilterValue, 123, 8, 0, // Skip to: 4695
/* 4687 */    MCD::OPC_CheckPredicate, 5, 172, 8, // Skip to: 6911
/* 4691 */    MCD::OPC_Decode, 133, 4, 39, // Opcode: FORNOT1S
/* 4695 */    MCD::OPC_FilterValue, 124, 8, 0, // Skip to: 4707
/* 4699 */    MCD::OPC_CheckPredicate, 5, 160, 8, // Skip to: 6911
/* 4703 */    MCD::OPC_Decode, 131, 4, 40, // Opcode: FOR
/* 4707 */    MCD::OPC_FilterValue, 125, 8, 0, // Skip to: 4719
/* 4711 */    MCD::OPC_CheckPredicate, 5, 148, 8, // Skip to: 6911
/* 4715 */    MCD::OPC_Decode, 136, 4, 39, // Opcode: FORS
/* 4719 */    MCD::OPC_FilterValue, 126, 20, 0, // Skip to: 4743
/* 4723 */    MCD::OPC_CheckPredicate, 5, 136, 8, // Skip to: 6911
/* 4727 */    MCD::OPC_CheckField, 14, 5, 0, 130, 8, // Skip to: 6911
/* 4733 */    MCD::OPC_CheckField, 0, 5, 0, 124, 8, // Skip to: 6911
/* 4739 */    MCD::OPC_Decode, 129, 4, 66, // Opcode: FONE
/* 4743 */    MCD::OPC_FilterValue, 127, 20, 0, // Skip to: 4767
/* 4747 */    MCD::OPC_CheckPredicate, 5, 112, 8, // Skip to: 6911
/* 4751 */    MCD::OPC_CheckField, 14, 5, 0, 106, 8, // Skip to: 6911
/* 4757 */    MCD::OPC_CheckField, 0, 5, 0, 100, 8, // Skip to: 6911
/* 4763 */    MCD::OPC_Decode, 130, 4, 67, // Opcode: FONES
/* 4767 */    MCD::OPC_FilterValue, 128, 1, 26, 0, // Skip to: 4798
/* 4772 */    MCD::OPC_CheckPredicate, 5, 87, 8, // Skip to: 6911
/* 4776 */    MCD::OPC_CheckField, 25, 5, 0, 81, 8, // Skip to: 6911
/* 4782 */    MCD::OPC_CheckField, 14, 5, 0, 75, 8, // Skip to: 6911
/* 4788 */    MCD::OPC_CheckField, 0, 5, 0, 69, 8, // Skip to: 6911
/* 4794 */    MCD::OPC_Decode, 186, 5, 7, // Opcode: SHUTDOWN
/* 4798 */    MCD::OPC_FilterValue, 129, 1, 26, 0, // Skip to: 4829
/* 4803 */    MCD::OPC_CheckPredicate, 6, 56, 8, // Skip to: 6911
/* 4807 */    MCD::OPC_CheckField, 25, 5, 0, 50, 8, // Skip to: 6911
/* 4813 */    MCD::OPC_CheckField, 14, 5, 0, 44, 8, // Skip to: 6911
/* 4819 */    MCD::OPC_CheckField, 3, 2, 0, 38, 8, // Skip to: 6911
/* 4825 */    MCD::OPC_Decode, 187, 5, 70, // Opcode: SIAM
/* 4829 */    MCD::OPC_FilterValue, 144, 2, 14, 0, // Skip to: 4848
/* 4834 */    MCD::OPC_CheckPredicate, 4, 25, 8, // Skip to: 6911
/* 4838 */    MCD::OPC_CheckField, 14, 5, 0, 19, 8, // Skip to: 6911
/* 4844 */    MCD::OPC_Decode, 253, 4, 71, // Opcode: MOVDTOX
/* 4848 */    MCD::OPC_FilterValue, 145, 2, 14, 0, // Skip to: 4867
/* 4853 */    MCD::OPC_CheckPredicate, 4, 6, 8, // Skip to: 6911
/* 4857 */    MCD::OPC_CheckField, 14, 5, 0, 0, 8, // Skip to: 6911
/* 4863 */    MCD::OPC_Decode, 133, 5, 72, // Opcode: MOVSTOUW
/* 4867 */    MCD::OPC_FilterValue, 147, 2, 14, 0, // Skip to: 4886
/* 4872 */    MCD::OPC_CheckPredicate, 4, 243, 7, // Skip to: 6911
/* 4876 */    MCD::OPC_CheckField, 14, 5, 0, 237, 7, // Skip to: 6911
/* 4882 */    MCD::OPC_Decode, 132, 5, 72, // Opcode: MOVSTOSW
/* 4886 */    MCD::OPC_FilterValue, 149, 2, 8, 0, // Skip to: 4899
/* 4891 */    MCD::OPC_CheckPredicate, 4, 224, 7, // Skip to: 6911
/* 4895 */    MCD::OPC_Decode, 196, 6, 13, // Opcode: XMULX
/* 4899 */    MCD::OPC_FilterValue, 150, 2, 8, 0, // Skip to: 4912
/* 4904 */    MCD::OPC_CheckPredicate, 4, 211, 7, // Skip to: 6911
/* 4908 */    MCD::OPC_Decode, 197, 6, 13, // Opcode: XMULXHI
/* 4912 */    MCD::OPC_FilterValue, 152, 2, 14, 0, // Skip to: 4931
/* 4917 */    MCD::OPC_CheckPredicate, 4, 198, 7, // Skip to: 6911
/* 4921 */    MCD::OPC_CheckField, 14, 5, 0, 192, 7, // Skip to: 6911
/* 4927 */    MCD::OPC_Decode, 137, 5, 73, // Opcode: MOVXTOD
/* 4931 */    MCD::OPC_FilterValue, 153, 2, 14, 0, // Skip to: 4950
/* 4936 */    MCD::OPC_CheckPredicate, 4, 179, 7, // Skip to: 6911
/* 4940 */    MCD::OPC_CheckField, 14, 5, 0, 173, 7, // Skip to: 6911
/* 4946 */    MCD::OPC_Decode, 134, 5, 74, // Opcode: MOVWTOS
/* 4950 */    MCD::OPC_FilterValue, 209, 2, 8, 0, // Skip to: 4963
/* 4955 */    MCD::OPC_CheckPredicate, 4, 160, 7, // Skip to: 6911
/* 4959 */    MCD::OPC_Decode, 200, 3, 59, // Opcode: FLCMPS
/* 4963 */    MCD::OPC_FilterValue, 210, 2, 151, 7, // Skip to: 6911
/* 4968 */    MCD::OPC_CheckPredicate, 4, 147, 7, // Skip to: 6911
/* 4972 */    MCD::OPC_Decode, 199, 3, 60, // Opcode: FLCMPD
/* 4976 */    MCD::OPC_FilterValue, 55, 123, 0, // Skip to: 5103
/* 4980 */    MCD::OPC_ExtractField, 5, 4,  // Inst{8-5} ...
/* 4983 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4995
/* 4987 */    MCD::OPC_CheckPredicate, 1, 128, 7, // Skip to: 6911
/* 4991 */    MCD::OPC_Decode, 145, 4, 75, // Opcode: FPMADDX
/* 4995 */    MCD::OPC_FilterValue, 1, 8, 0, // Skip to: 5007
/* 4999 */    MCD::OPC_CheckPredicate, 7, 116, 7, // Skip to: 6911
/* 5003 */    MCD::OPC_Decode, 206, 3, 76, // Opcode: FMADDS
/* 5007 */    MCD::OPC_FilterValue, 2, 8, 0, // Skip to: 5019
/* 5011 */    MCD::OPC_CheckPredicate, 7, 104, 7, // Skip to: 6911
/* 5015 */    MCD::OPC_Decode, 205, 3, 75, // Opcode: FMADDD
/* 5019 */    MCD::OPC_FilterValue, 4, 8, 0, // Skip to: 5031
/* 5023 */    MCD::OPC_CheckPredicate, 1, 92, 7, // Skip to: 6911
/* 5027 */    MCD::OPC_Decode, 146, 4, 75, // Opcode: FPMADDXHI
/* 5031 */    MCD::OPC_FilterValue, 5, 8, 0, // Skip to: 5043
/* 5035 */    MCD::OPC_CheckPredicate, 7, 80, 7, // Skip to: 6911
/* 5039 */    MCD::OPC_Decode, 224, 3, 76, // Opcode: FMSUBS
/* 5043 */    MCD::OPC_FilterValue, 6, 8, 0, // Skip to: 5055
/* 5047 */    MCD::OPC_CheckPredicate, 7, 68, 7, // Skip to: 6911
/* 5051 */    MCD::OPC_Decode, 223, 3, 75, // Opcode: FMSUBD
/* 5055 */    MCD::OPC_FilterValue, 9, 8, 0, // Skip to: 5067
/* 5059 */    MCD::OPC_CheckPredicate, 7, 56, 7, // Skip to: 6911
/* 5063 */    MCD::OPC_Decode, 247, 3, 76, // Opcode: FNMSUBS
/* 5067 */    MCD::OPC_FilterValue, 10, 8, 0, // Skip to: 5079
/* 5071 */    MCD::OPC_CheckPredicate, 7, 44, 7, // Skip to: 6911
/* 5075 */    MCD::OPC_Decode, 246, 3, 75, // Opcode: FNMSUBD
/* 5079 */    MCD::OPC_FilterValue, 13, 8, 0, // Skip to: 5091
/* 5083 */    MCD::OPC_CheckPredicate, 7, 32, 7, // Skip to: 6911
/* 5087 */    MCD::OPC_Decode, 245, 3, 76, // Opcode: FNMADDS
/* 5091 */    MCD::OPC_FilterValue, 14, 24, 7, // Skip to: 6911
/* 5095 */    MCD::OPC_CheckPredicate, 7, 20, 7, // Skip to: 6911
/* 5099 */    MCD::OPC_Decode, 244, 3, 75, // Opcode: FNMADDD
/* 5103 */    MCD::OPC_FilterValue, 56, 25, 0, // Skip to: 5132
/* 5107 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5110 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5124
/* 5114 */    MCD::OPC_CheckField, 5, 8, 0, 255, 6, // Skip to: 6911
/* 5120 */    MCD::OPC_Decode, 192, 4, 77, // Opcode: JMPLrr
/* 5124 */    MCD::OPC_FilterValue, 1, 247, 6, // Skip to: 6911
/* 5128 */    MCD::OPC_Decode, 191, 4, 78, // Opcode: JMPLri
/* 5132 */    MCD::OPC_FilterValue, 57, 37, 0, // Skip to: 5173
/* 5136 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5139 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 5159
/* 5143 */    MCD::OPC_CheckField, 25, 5, 0, 226, 6, // Skip to: 6911
/* 5149 */    MCD::OPC_CheckField, 5, 8, 0, 220, 6, // Skip to: 6911
/* 5155 */    MCD::OPC_Decode, 175, 5, 79, // Opcode: RETTrr
/* 5159 */    MCD::OPC_FilterValue, 1, 212, 6, // Skip to: 6911
/* 5163 */    MCD::OPC_CheckField, 25, 5, 0, 206, 6, // Skip to: 6911
/* 5169 */    MCD::OPC_Decode, 174, 5, 80, // Opcode: RETTri
/* 5173 */    MCD::OPC_FilterValue, 58, 104, 0, // Skip to: 5281
/* 5177 */    MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 5180 */    MCD::OPC_FilterValue, 16, 16, 0, // Skip to: 5200
/* 5184 */    MCD::OPC_CheckField, 29, 1, 0, 185, 6, // Skip to: 6911
/* 5190 */    MCD::OPC_CheckField, 5, 3, 0, 179, 6, // Skip to: 6911
/* 5196 */    MCD::OPC_Decode, 160, 6, 81, // Opcode: TXCCrr
/* 5200 */    MCD::OPC_FilterValue, 32, 63, 0, // Skip to: 5267
/* 5204 */    MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 5207 */    MCD::OPC_FilterValue, 1, 16, 0, // Skip to: 5227
/* 5211 */    MCD::OPC_CheckField, 25, 5, 8, 158, 6, // Skip to: 6911
/* 5217 */    MCD::OPC_CheckField, 14, 5, 0, 152, 6, // Skip to: 6911
/* 5223 */    MCD::OPC_Decode, 138, 6, 7, // Opcode: TA1
/* 5227 */    MCD::OPC_FilterValue, 3, 16, 0, // Skip to: 5247
/* 5231 */    MCD::OPC_CheckField, 25, 5, 8, 138, 6, // Skip to: 6911
/* 5237 */    MCD::OPC_CheckField, 14, 5, 0, 132, 6, // Skip to: 6911
/* 5243 */    MCD::OPC_Decode, 139, 6, 7, // Opcode: TA3
/* 5247 */    MCD::OPC_FilterValue, 5, 124, 6, // Skip to: 6911
/* 5251 */    MCD::OPC_CheckField, 25, 5, 8, 118, 6, // Skip to: 6911
/* 5257 */    MCD::OPC_CheckField, 14, 5, 0, 112, 6, // Skip to: 6911
/* 5263 */    MCD::OPC_Decode, 140, 6, 7, // Opcode: TA5
/* 5267 */    MCD::OPC_FilterValue, 48, 104, 6, // Skip to: 6911
/* 5271 */    MCD::OPC_CheckField, 29, 1, 0, 98, 6, // Skip to: 6911
/* 5277 */    MCD::OPC_Decode, 159, 6, 82, // Opcode: TXCCri
/* 5281 */    MCD::OPC_FilterValue, 59, 55, 0, // Skip to: 5340
/* 5285 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5288 */    MCD::OPC_FilterValue, 0, 34, 0, // Skip to: 5326
/* 5292 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 5295 */    MCD::OPC_FilterValue, 0, 76, 6, // Skip to: 6911
/* 5299 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5302 */    MCD::OPC_FilterValue, 0, 69, 6, // Skip to: 6911
/* 5306 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 5322
/* 5312 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 5322
/* 5318 */    MCD::OPC_Decode, 201, 3, 7, // Opcode: FLUSH
/* 5322 */    MCD::OPC_Decode, 204, 3, 79, // Opcode: FLUSHrr
/* 5326 */    MCD::OPC_FilterValue, 1, 45, 6, // Skip to: 6911
/* 5330 */    MCD::OPC_CheckField, 25, 5, 0, 39, 6, // Skip to: 6911
/* 5336 */    MCD::OPC_Decode, 203, 3, 80, // Opcode: FLUSHri
/* 5340 */    MCD::OPC_FilterValue, 60, 25, 0, // Skip to: 5369
/* 5344 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5347 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5361
/* 5351 */    MCD::OPC_CheckField, 5, 8, 0, 18, 6, // Skip to: 6911
/* 5357 */    MCD::OPC_Decode, 178, 5, 11, // Opcode: SAVErr
/* 5361 */    MCD::OPC_FilterValue, 1, 10, 6, // Skip to: 6911
/* 5365 */    MCD::OPC_Decode, 177, 5, 12, // Opcode: SAVEri
/* 5369 */    MCD::OPC_FilterValue, 61, 25, 0, // Skip to: 5398
/* 5373 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5376 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5390
/* 5380 */    MCD::OPC_CheckField, 5, 8, 0, 245, 5, // Skip to: 6911
/* 5386 */    MCD::OPC_Decode, 170, 5, 11, // Opcode: RESTORErr
/* 5390 */    MCD::OPC_FilterValue, 1, 237, 5, // Skip to: 6911
/* 5394 */    MCD::OPC_Decode, 169, 5, 12, // Opcode: RESTOREri
/* 5398 */    MCD::OPC_FilterValue, 62, 77, 0, // Skip to: 5479
/* 5402 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5405 */    MCD::OPC_FilterValue, 0, 62, 0, // Skip to: 5471
/* 5409 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 5412 */    MCD::OPC_FilterValue, 0, 215, 5, // Skip to: 6911
/* 5416 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5419 */    MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 5443
/* 5423 */    MCD::OPC_CheckPredicate, 0, 40, 0, // Skip to: 5467
/* 5427 */    MCD::OPC_CheckField, 14, 5, 0, 34, 0, // Skip to: 5467
/* 5433 */    MCD::OPC_CheckField, 0, 5, 0, 28, 0, // Skip to: 5467
/* 5439 */    MCD::OPC_Decode, 138, 3, 7, // Opcode: DONE
/* 5443 */    MCD::OPC_FilterValue, 1, 20, 0, // Skip to: 5467
/* 5447 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 5467
/* 5451 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 5467
/* 5457 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 5467
/* 5463 */    MCD::OPC_Decode, 173, 5, 7, // Opcode: RETRY
/* 5467 */    MCD::OPC_Decode, 168, 6, 11, // Opcode: UMACrr
/* 5471 */    MCD::OPC_FilterValue, 1, 156, 5, // Skip to: 6911
/* 5475 */    MCD::OPC_Decode, 167, 6, 12, // Opcode: UMACri
/* 5479 */    MCD::OPC_FilterValue, 63, 148, 5, // Skip to: 6911
/* 5483 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5486 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5500
/* 5490 */    MCD::OPC_CheckField, 5, 8, 0, 135, 5, // Skip to: 6911
/* 5496 */    MCD::OPC_Decode, 194, 5, 11, // Opcode: SMACrr
/* 5500 */    MCD::OPC_FilterValue, 1, 127, 5, // Skip to: 6911
/* 5504 */    MCD::OPC_Decode, 193, 5, 12, // Opcode: SMACri
/* 5508 */    MCD::OPC_FilterValue, 3, 119, 5, // Skip to: 6911
/* 5512 */    MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 5515 */    MCD::OPC_FilterValue, 0, 25, 0, // Skip to: 5544
/* 5519 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5522 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5536
/* 5526 */    MCD::OPC_CheckField, 5, 8, 0, 99, 5, // Skip to: 6911
/* 5532 */    MCD::OPC_Decode, 250, 4, 77, // Opcode: LDrr
/* 5536 */    MCD::OPC_FilterValue, 1, 91, 5, // Skip to: 6911
/* 5540 */    MCD::OPC_Decode, 249, 4, 78, // Opcode: LDri
/* 5544 */    MCD::OPC_FilterValue, 1, 25, 0, // Skip to: 5573
/* 5548 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5551 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5565
/* 5555 */    MCD::OPC_CheckField, 5, 8, 0, 70, 5, // Skip to: 6911
/* 5561 */    MCD::OPC_Decode, 238, 4, 77, // Opcode: LDUBrr
/* 5565 */    MCD::OPC_FilterValue, 1, 62, 5, // Skip to: 6911
/* 5569 */    MCD::OPC_Decode, 237, 4, 78, // Opcode: LDUBri
/* 5573 */    MCD::OPC_FilterValue, 2, 25, 0, // Skip to: 5602
/* 5577 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5580 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5594
/* 5584 */    MCD::OPC_CheckField, 5, 8, 0, 41, 5, // Skip to: 6911
/* 5590 */    MCD::OPC_Decode, 242, 4, 77, // Opcode: LDUHrr
/* 5594 */    MCD::OPC_FilterValue, 1, 33, 5, // Skip to: 6911
/* 5598 */    MCD::OPC_Decode, 241, 4, 78, // Opcode: LDUHri
/* 5602 */    MCD::OPC_FilterValue, 3, 25, 0, // Skip to: 5631
/* 5606 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5609 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5623
/* 5613 */    MCD::OPC_CheckField, 5, 8, 0, 12, 5, // Skip to: 6911
/* 5619 */    MCD::OPC_Decode, 208, 4, 83, // Opcode: LDDrr
/* 5623 */    MCD::OPC_FilterValue, 1, 4, 5, // Skip to: 6911
/* 5627 */    MCD::OPC_Decode, 207, 4, 84, // Opcode: LDDri
/* 5631 */    MCD::OPC_FilterValue, 4, 25, 0, // Skip to: 5660
/* 5635 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5638 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5652
/* 5642 */    MCD::OPC_CheckField, 5, 8, 0, 239, 4, // Skip to: 6911
/* 5648 */    MCD::OPC_Decode, 253, 5, 85, // Opcode: STrr
/* 5652 */    MCD::OPC_FilterValue, 1, 231, 4, // Skip to: 6911
/* 5656 */    MCD::OPC_Decode, 252, 5, 86, // Opcode: STri
/* 5660 */    MCD::OPC_FilterValue, 5, 25, 0, // Skip to: 5689
/* 5664 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5667 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5681
/* 5671 */    MCD::OPC_CheckField, 5, 8, 0, 210, 4, // Skip to: 6911
/* 5677 */    MCD::OPC_Decode, 213, 5, 85, // Opcode: STBrr
/* 5681 */    MCD::OPC_FilterValue, 1, 202, 4, // Skip to: 6911
/* 5685 */    MCD::OPC_Decode, 212, 5, 86, // Opcode: STBri
/* 5689 */    MCD::OPC_FilterValue, 6, 25, 0, // Skip to: 5718
/* 5693 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5696 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5710
/* 5700 */    MCD::OPC_CheckField, 5, 8, 0, 181, 4, // Skip to: 6911
/* 5706 */    MCD::OPC_Decode, 241, 5, 85, // Opcode: STHrr
/* 5710 */    MCD::OPC_FilterValue, 1, 173, 4, // Skip to: 6911
/* 5714 */    MCD::OPC_Decode, 240, 5, 86, // Opcode: STHri
/* 5718 */    MCD::OPC_FilterValue, 7, 25, 0, // Skip to: 5747
/* 5722 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5725 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5739
/* 5729 */    MCD::OPC_CheckField, 5, 8, 0, 152, 4, // Skip to: 6911
/* 5735 */    MCD::OPC_Decode, 231, 5, 87, // Opcode: STDrr
/* 5739 */    MCD::OPC_FilterValue, 1, 144, 4, // Skip to: 6911
/* 5743 */    MCD::OPC_Decode, 230, 5, 88, // Opcode: STDri
/* 5747 */    MCD::OPC_FilterValue, 8, 25, 0, // Skip to: 5776
/* 5751 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5754 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5768
/* 5758 */    MCD::OPC_CheckField, 5, 8, 0, 123, 4, // Skip to: 6911
/* 5764 */    MCD::OPC_Decode, 234, 4, 89, // Opcode: LDSWrr
/* 5768 */    MCD::OPC_FilterValue, 1, 115, 4, // Skip to: 6911
/* 5772 */    MCD::OPC_Decode, 233, 4, 90, // Opcode: LDSWri
/* 5776 */    MCD::OPC_FilterValue, 9, 25, 0, // Skip to: 5805
/* 5780 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5783 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5797
/* 5787 */    MCD::OPC_CheckField, 5, 8, 0, 94, 4, // Skip to: 6911
/* 5793 */    MCD::OPC_Decode, 222, 4, 77, // Opcode: LDSBrr
/* 5797 */    MCD::OPC_FilterValue, 1, 86, 4, // Skip to: 6911
/* 5801 */    MCD::OPC_Decode, 221, 4, 78, // Opcode: LDSBri
/* 5805 */    MCD::OPC_FilterValue, 10, 25, 0, // Skip to: 5834
/* 5809 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5812 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5826
/* 5816 */    MCD::OPC_CheckField, 5, 8, 0, 65, 4, // Skip to: 6911
/* 5822 */    MCD::OPC_Decode, 226, 4, 77, // Opcode: LDSHrr
/* 5826 */    MCD::OPC_FilterValue, 1, 57, 4, // Skip to: 6911
/* 5830 */    MCD::OPC_Decode, 225, 4, 78, // Opcode: LDSHri
/* 5834 */    MCD::OPC_FilterValue, 11, 25, 0, // Skip to: 5863
/* 5838 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5841 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5855
/* 5845 */    MCD::OPC_CheckField, 5, 8, 0, 36, 4, // Skip to: 6911
/* 5851 */    MCD::OPC_Decode, 248, 4, 89, // Opcode: LDXrr
/* 5855 */    MCD::OPC_FilterValue, 1, 28, 4, // Skip to: 6911
/* 5859 */    MCD::OPC_Decode, 247, 4, 90, // Opcode: LDXri
/* 5863 */    MCD::OPC_FilterValue, 13, 25, 0, // Skip to: 5892
/* 5867 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5870 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5884
/* 5874 */    MCD::OPC_CheckField, 5, 8, 0, 7, 4, // Skip to: 6911
/* 5880 */    MCD::OPC_Decode, 230, 4, 77, // Opcode: LDSTUBrr
/* 5884 */    MCD::OPC_FilterValue, 1, 255, 3, // Skip to: 6911
/* 5888 */    MCD::OPC_Decode, 229, 4, 78, // Opcode: LDSTUBri
/* 5892 */    MCD::OPC_FilterValue, 14, 25, 0, // Skip to: 5921
/* 5896 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5899 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5913
/* 5903 */    MCD::OPC_CheckField, 5, 8, 0, 234, 3, // Skip to: 6911
/* 5909 */    MCD::OPC_Decode, 251, 5, 91, // Opcode: STXrr
/* 5913 */    MCD::OPC_FilterValue, 1, 226, 3, // Skip to: 6911
/* 5917 */    MCD::OPC_Decode, 250, 5, 92, // Opcode: STXri
/* 5921 */    MCD::OPC_FilterValue, 15, 25, 0, // Skip to: 5950
/* 5925 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5928 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5942
/* 5932 */    MCD::OPC_CheckField, 5, 8, 0, 205, 3, // Skip to: 6911
/* 5938 */    MCD::OPC_Decode, 137, 6, 93, // Opcode: SWAPrr
/* 5942 */    MCD::OPC_FilterValue, 1, 197, 3, // Skip to: 6911
/* 5946 */    MCD::OPC_Decode, 136, 6, 94, // Opcode: SWAPri
/* 5950 */    MCD::OPC_FilterValue, 16, 23, 0, // Skip to: 5977
/* 5954 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5957 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5965
/* 5961 */    MCD::OPC_Decode, 194, 4, 95, // Opcode: LDArr
/* 5965 */    MCD::OPC_FilterValue, 1, 174, 3, // Skip to: 6911
/* 5969 */    MCD::OPC_CheckPredicate, 0, 170, 3, // Skip to: 6911
/* 5973 */    MCD::OPC_Decode, 193, 4, 78, // Opcode: LDAri
/* 5977 */    MCD::OPC_FilterValue, 17, 23, 0, // Skip to: 6004
/* 5981 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5984 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5992
/* 5988 */    MCD::OPC_Decode, 236, 4, 95, // Opcode: LDUBArr
/* 5992 */    MCD::OPC_FilterValue, 1, 147, 3, // Skip to: 6911
/* 5996 */    MCD::OPC_CheckPredicate, 0, 143, 3, // Skip to: 6911
/* 6000 */    MCD::OPC_Decode, 235, 4, 78, // Opcode: LDUBAri
/* 6004 */    MCD::OPC_FilterValue, 18, 23, 0, // Skip to: 6031
/* 6008 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6011 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6019
/* 6015 */    MCD::OPC_Decode, 240, 4, 95, // Opcode: LDUHArr
/* 6019 */    MCD::OPC_FilterValue, 1, 120, 3, // Skip to: 6911
/* 6023 */    MCD::OPC_CheckPredicate, 0, 116, 3, // Skip to: 6911
/* 6027 */    MCD::OPC_Decode, 239, 4, 78, // Opcode: LDUHAri
/* 6031 */    MCD::OPC_FilterValue, 19, 23, 0, // Skip to: 6058
/* 6035 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6038 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6046
/* 6042 */    MCD::OPC_Decode, 200, 4, 96, // Opcode: LDDArr
/* 6046 */    MCD::OPC_FilterValue, 1, 93, 3, // Skip to: 6911
/* 6050 */    MCD::OPC_CheckPredicate, 0, 89, 3, // Skip to: 6911
/* 6054 */    MCD::OPC_Decode, 199, 4, 84, // Opcode: LDDAri
/* 6058 */    MCD::OPC_FilterValue, 20, 23, 0, // Skip to: 6085
/* 6062 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6065 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6073
/* 6069 */    MCD::OPC_Decode, 208, 5, 97, // Opcode: STArr
/* 6073 */    MCD::OPC_FilterValue, 1, 66, 3, // Skip to: 6911
/* 6077 */    MCD::OPC_CheckPredicate, 0, 62, 3, // Skip to: 6911
/* 6081 */    MCD::OPC_Decode, 207, 5, 86, // Opcode: STAri
/* 6085 */    MCD::OPC_FilterValue, 21, 23, 0, // Skip to: 6112
/* 6089 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6092 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6100
/* 6096 */    MCD::OPC_Decode, 211, 5, 97, // Opcode: STBArr
/* 6100 */    MCD::OPC_FilterValue, 1, 39, 3, // Skip to: 6911
/* 6104 */    MCD::OPC_CheckPredicate, 0, 35, 3, // Skip to: 6911
/* 6108 */    MCD::OPC_Decode, 210, 5, 86, // Opcode: STBAri
/* 6112 */    MCD::OPC_FilterValue, 22, 23, 0, // Skip to: 6139
/* 6116 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6119 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6127
/* 6123 */    MCD::OPC_Decode, 239, 5, 97, // Opcode: STHArr
/* 6127 */    MCD::OPC_FilterValue, 1, 12, 3, // Skip to: 6911
/* 6131 */    MCD::OPC_CheckPredicate, 0, 8, 3, // Skip to: 6911
/* 6135 */    MCD::OPC_Decode, 238, 5, 86, // Opcode: STHAri
/* 6139 */    MCD::OPC_FilterValue, 23, 23, 0, // Skip to: 6166
/* 6143 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6146 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6154
/* 6150 */    MCD::OPC_Decode, 219, 5, 98, // Opcode: STDArr
/* 6154 */    MCD::OPC_FilterValue, 1, 241, 2, // Skip to: 6911
/* 6158 */    MCD::OPC_CheckPredicate, 0, 237, 2, // Skip to: 6911
/* 6162 */    MCD::OPC_Decode, 218, 5, 88, // Opcode: STDAri
/* 6166 */    MCD::OPC_FilterValue, 24, 19, 0, // Skip to: 6189
/* 6170 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6173 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6181
/* 6177 */    MCD::OPC_Decode, 232, 4, 99, // Opcode: LDSWArr
/* 6181 */    MCD::OPC_FilterValue, 1, 214, 2, // Skip to: 6911
/* 6185 */    MCD::OPC_Decode, 231, 4, 90, // Opcode: LDSWAri
/* 6189 */    MCD::OPC_FilterValue, 25, 23, 0, // Skip to: 6216
/* 6193 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6196 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6204
/* 6200 */    MCD::OPC_Decode, 220, 4, 95, // Opcode: LDSBArr
/* 6204 */    MCD::OPC_FilterValue, 1, 191, 2, // Skip to: 6911
/* 6208 */    MCD::OPC_CheckPredicate, 0, 187, 2, // Skip to: 6911
/* 6212 */    MCD::OPC_Decode, 219, 4, 78, // Opcode: LDSBAri
/* 6216 */    MCD::OPC_FilterValue, 26, 23, 0, // Skip to: 6243
/* 6220 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6223 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6231
/* 6227 */    MCD::OPC_Decode, 224, 4, 95, // Opcode: LDSHArr
/* 6231 */    MCD::OPC_FilterValue, 1, 164, 2, // Skip to: 6911
/* 6235 */    MCD::OPC_CheckPredicate, 0, 160, 2, // Skip to: 6911
/* 6239 */    MCD::OPC_Decode, 223, 4, 78, // Opcode: LDSHAri
/* 6243 */    MCD::OPC_FilterValue, 27, 19, 0, // Skip to: 6266
/* 6247 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6250 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6258
/* 6254 */    MCD::OPC_Decode, 244, 4, 99, // Opcode: LDXArr
/* 6258 */    MCD::OPC_FilterValue, 1, 137, 2, // Skip to: 6911
/* 6262 */    MCD::OPC_Decode, 243, 4, 90, // Opcode: LDXAri
/* 6266 */    MCD::OPC_FilterValue, 29, 23, 0, // Skip to: 6293
/* 6270 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6273 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6281
/* 6277 */    MCD::OPC_Decode, 228, 4, 95, // Opcode: LDSTUBArr
/* 6281 */    MCD::OPC_FilterValue, 1, 114, 2, // Skip to: 6911
/* 6285 */    MCD::OPC_CheckPredicate, 0, 110, 2, // Skip to: 6911
/* 6289 */    MCD::OPC_Decode, 227, 4, 78, // Opcode: LDSTUBAri
/* 6293 */    MCD::OPC_FilterValue, 30, 19, 0, // Skip to: 6316
/* 6297 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6300 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6308
/* 6304 */    MCD::OPC_Decode, 247, 5, 100, // Opcode: STXArr
/* 6308 */    MCD::OPC_FilterValue, 1, 87, 2, // Skip to: 6911
/* 6312 */    MCD::OPC_Decode, 246, 5, 92, // Opcode: STXAri
/* 6316 */    MCD::OPC_FilterValue, 31, 23, 0, // Skip to: 6343
/* 6320 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6323 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6331
/* 6327 */    MCD::OPC_Decode, 135, 6, 101, // Opcode: SWAPArr
/* 6331 */    MCD::OPC_FilterValue, 1, 64, 2, // Skip to: 6911
/* 6335 */    MCD::OPC_CheckPredicate, 0, 60, 2, // Skip to: 6911
/* 6339 */    MCD::OPC_Decode, 134, 6, 94, // Opcode: SWAPAri
/* 6343 */    MCD::OPC_FilterValue, 32, 25, 0, // Skip to: 6372
/* 6347 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6350 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6364
/* 6354 */    MCD::OPC_CheckField, 5, 8, 0, 39, 2, // Skip to: 6911
/* 6360 */    MCD::OPC_Decode, 214, 4, 102, // Opcode: LDFrr
/* 6364 */    MCD::OPC_FilterValue, 1, 31, 2, // Skip to: 6911
/* 6368 */    MCD::OPC_Decode, 213, 4, 103, // Opcode: LDFri
/* 6372 */    MCD::OPC_FilterValue, 33, 69, 0, // Skip to: 6445
/* 6376 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6379 */    MCD::OPC_FilterValue, 0, 35, 0, // Skip to: 6418
/* 6383 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6386 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6400
/* 6390 */    MCD::OPC_CheckField, 5, 8, 0, 3, 2, // Skip to: 6911
/* 6396 */    MCD::OPC_Decode, 212, 4, 79, // Opcode: LDFSRrr
/* 6400 */    MCD::OPC_FilterValue, 1, 251, 1, // Skip to: 6911
/* 6404 */    MCD::OPC_CheckPredicate, 0, 247, 1, // Skip to: 6911
/* 6408 */    MCD::OPC_CheckField, 5, 8, 0, 241, 1, // Skip to: 6911
/* 6414 */    MCD::OPC_Decode, 246, 4, 79, // Opcode: LDXFSRrr
/* 6418 */    MCD::OPC_FilterValue, 1, 233, 1, // Skip to: 6911
/* 6422 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6425 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6433
/* 6429 */    MCD::OPC_Decode, 211, 4, 80, // Opcode: LDFSRri
/* 6433 */    MCD::OPC_FilterValue, 1, 218, 1, // Skip to: 6911
/* 6437 */    MCD::OPC_CheckPredicate, 0, 214, 1, // Skip to: 6911
/* 6441 */    MCD::OPC_Decode, 245, 4, 80, // Opcode: LDXFSRri
/* 6445 */    MCD::OPC_FilterValue, 35, 25, 0, // Skip to: 6474
/* 6449 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6452 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6466
/* 6456 */    MCD::OPC_CheckField, 5, 8, 0, 193, 1, // Skip to: 6911
/* 6462 */    MCD::OPC_Decode, 206, 4, 104, // Opcode: LDDFrr
/* 6466 */    MCD::OPC_FilterValue, 1, 185, 1, // Skip to: 6911
/* 6470 */    MCD::OPC_Decode, 205, 4, 105, // Opcode: LDDFri
/* 6474 */    MCD::OPC_FilterValue, 36, 25, 0, // Skip to: 6503
/* 6478 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6481 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6495
/* 6485 */    MCD::OPC_CheckField, 5, 8, 0, 164, 1, // Skip to: 6911
/* 6491 */    MCD::OPC_Decode, 237, 5, 106, // Opcode: STFrr
/* 6495 */    MCD::OPC_FilterValue, 1, 156, 1, // Skip to: 6911
/* 6499 */    MCD::OPC_Decode, 236, 5, 107, // Opcode: STFri
/* 6503 */    MCD::OPC_FilterValue, 37, 69, 0, // Skip to: 6576
/* 6507 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6510 */    MCD::OPC_FilterValue, 0, 35, 0, // Skip to: 6549
/* 6514 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6517 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6531
/* 6521 */    MCD::OPC_CheckField, 5, 8, 0, 128, 1, // Skip to: 6911
/* 6527 */    MCD::OPC_Decode, 235, 5, 79, // Opcode: STFSRrr
/* 6531 */    MCD::OPC_FilterValue, 1, 120, 1, // Skip to: 6911
/* 6535 */    MCD::OPC_CheckPredicate, 0, 116, 1, // Skip to: 6911
/* 6539 */    MCD::OPC_CheckField, 5, 8, 0, 110, 1, // Skip to: 6911
/* 6545 */    MCD::OPC_Decode, 249, 5, 79, // Opcode: STXFSRrr
/* 6549 */    MCD::OPC_FilterValue, 1, 102, 1, // Skip to: 6911
/* 6553 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6556 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6564
/* 6560 */    MCD::OPC_Decode, 234, 5, 80, // Opcode: STFSRri
/* 6564 */    MCD::OPC_FilterValue, 1, 87, 1, // Skip to: 6911
/* 6568 */    MCD::OPC_CheckPredicate, 0, 83, 1, // Skip to: 6911
/* 6572 */    MCD::OPC_Decode, 248, 5, 80, // Opcode: STXFSRri
/* 6576 */    MCD::OPC_FilterValue, 38, 37, 0, // Skip to: 6617
/* 6580 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6583 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 6603
/* 6587 */    MCD::OPC_CheckField, 25, 5, 0, 62, 1, // Skip to: 6911
/* 6593 */    MCD::OPC_CheckField, 5, 8, 0, 56, 1, // Skip to: 6911
/* 6599 */    MCD::OPC_Decode, 227, 5, 79, // Opcode: STDFQrr
/* 6603 */    MCD::OPC_FilterValue, 1, 48, 1, // Skip to: 6911
/* 6607 */    MCD::OPC_CheckField, 25, 5, 0, 42, 1, // Skip to: 6911
/* 6613 */    MCD::OPC_Decode, 226, 5, 80, // Opcode: STDFQri
/* 6617 */    MCD::OPC_FilterValue, 39, 25, 0, // Skip to: 6646
/* 6621 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6624 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6638
/* 6628 */    MCD::OPC_CheckField, 5, 8, 0, 21, 1, // Skip to: 6911
/* 6634 */    MCD::OPC_Decode, 229, 5, 108, // Opcode: STDFrr
/* 6638 */    MCD::OPC_FilterValue, 1, 13, 1, // Skip to: 6911
/* 6642 */    MCD::OPC_Decode, 228, 5, 109, // Opcode: STDFri
/* 6646 */    MCD::OPC_FilterValue, 45, 33, 0, // Skip to: 6683
/* 6650 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6653 */    MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 6671
/* 6657 */    MCD::OPC_CheckPredicate, 0, 250, 0, // Skip to: 6911
/* 6661 */    MCD::OPC_CheckField, 5, 8, 0, 244, 0, // Skip to: 6911
/* 6667 */    MCD::OPC_Decode, 159, 5, 110, // Opcode: PREFETCHr
/* 6671 */    MCD::OPC_FilterValue, 1, 236, 0, // Skip to: 6911
/* 6675 */    MCD::OPC_CheckPredicate, 0, 232, 0, // Skip to: 6911
/* 6679 */    MCD::OPC_Decode, 158, 5, 111, // Opcode: PREFETCHi
/* 6683 */    MCD::OPC_FilterValue, 49, 37, 0, // Skip to: 6724
/* 6687 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6690 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 6710
/* 6694 */    MCD::OPC_CheckField, 25, 5, 0, 211, 0, // Skip to: 6911
/* 6700 */    MCD::OPC_CheckField, 5, 8, 0, 205, 0, // Skip to: 6911
/* 6706 */    MCD::OPC_Decode, 196, 4, 79, // Opcode: LDCSRrr
/* 6710 */    MCD::OPC_FilterValue, 1, 197, 0, // Skip to: 6911
/* 6714 */    MCD::OPC_CheckField, 25, 5, 0, 191, 0, // Skip to: 6911
/* 6720 */    MCD::OPC_Decode, 195, 4, 80, // Opcode: LDCSRri
/* 6724 */    MCD::OPC_FilterValue, 53, 37, 0, // Skip to: 6765
/* 6728 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6731 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 6751
/* 6735 */    MCD::OPC_CheckField, 25, 5, 0, 170, 0, // Skip to: 6911
/* 6741 */    MCD::OPC_CheckField, 5, 8, 0, 164, 0, // Skip to: 6911
/* 6747 */    MCD::OPC_Decode, 215, 5, 79, // Opcode: STCSRrr
/* 6751 */    MCD::OPC_FilterValue, 1, 156, 0, // Skip to: 6911
/* 6755 */    MCD::OPC_CheckField, 25, 5, 0, 150, 0, // Skip to: 6911
/* 6761 */    MCD::OPC_Decode, 214, 5, 80, // Opcode: STCSRri
/* 6765 */    MCD::OPC_FilterValue, 54, 37, 0, // Skip to: 6806
/* 6769 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6772 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 6792
/* 6776 */    MCD::OPC_CheckField, 25, 5, 0, 129, 0, // Skip to: 6911
/* 6782 */    MCD::OPC_CheckField, 5, 8, 0, 123, 0, // Skip to: 6911
/* 6788 */    MCD::OPC_Decode, 221, 5, 79, // Opcode: STDCQrr
/* 6792 */    MCD::OPC_FilterValue, 1, 115, 0, // Skip to: 6911
/* 6796 */    MCD::OPC_CheckField, 25, 5, 0, 109, 0, // Skip to: 6911
/* 6802 */    MCD::OPC_Decode, 220, 5, 80, // Opcode: STDCQri
/* 6806 */    MCD::OPC_FilterValue, 60, 33, 0, // Skip to: 6843
/* 6810 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6813 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 6825
/* 6817 */    MCD::OPC_CheckPredicate, 8, 90, 0, // Skip to: 6911
/* 6821 */    MCD::OPC_Decode, 254, 2, 112, // Opcode: CASArr
/* 6825 */    MCD::OPC_FilterValue, 1, 82, 0, // Skip to: 6911
/* 6829 */    MCD::OPC_CheckPredicate, 0, 78, 0, // Skip to: 6911
/* 6833 */    MCD::OPC_CheckField, 5, 8, 0, 72, 0, // Skip to: 6911
/* 6839 */    MCD::OPC_Decode, 253, 2, 113, // Opcode: CASAri
/* 6843 */    MCD::OPC_FilterValue, 61, 27, 0, // Skip to: 6874
/* 6847 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6850 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 6862
/* 6854 */    MCD::OPC_CheckPredicate, 0, 53, 0, // Skip to: 6911
/* 6858 */    MCD::OPC_Decode, 157, 5, 114, // Opcode: PREFETCHAr
/* 6862 */    MCD::OPC_FilterValue, 1, 45, 0, // Skip to: 6911
/* 6866 */    MCD::OPC_CheckPredicate, 0, 41, 0, // Skip to: 6911
/* 6870 */    MCD::OPC_Decode, 156, 5, 111, // Opcode: PREFETCHAi
/* 6874 */    MCD::OPC_FilterValue, 62, 33, 0, // Skip to: 6911
/* 6878 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6881 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 6893
/* 6885 */    MCD::OPC_CheckPredicate, 0, 22, 0, // Skip to: 6911
/* 6889 */    MCD::OPC_Decode, 128, 3, 115, // Opcode: CASXArr
/* 6893 */    MCD::OPC_FilterValue, 1, 14, 0, // Skip to: 6911
/* 6897 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 6911
/* 6901 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, // Skip to: 6911
/* 6907 */    MCD::OPC_Decode, 255, 2, 116, // Opcode: CASXAri
/* 6911 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV832[] = {
/* 0 */       MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 3 */       MCD::OPC_FilterValue, 48, 37, 0, // Skip to: 44
/* 7 */       MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10 */      MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 30
/* 14 */      MCD::OPC_CheckField, 30, 2, 3, 188, 0, // Skip to: 208
/* 20 */      MCD::OPC_CheckField, 5, 8, 0, 182, 0, // Skip to: 208
/* 26 */      MCD::OPC_Decode, 198, 4, 117, // Opcode: LDCrr
/* 30 */      MCD::OPC_FilterValue, 1, 174, 0, // Skip to: 208
/* 34 */      MCD::OPC_CheckField, 30, 2, 3, 168, 0, // Skip to: 208
/* 40 */      MCD::OPC_Decode, 197, 4, 118, // Opcode: LDCri
/* 44 */      MCD::OPC_FilterValue, 51, 37, 0, // Skip to: 85
/* 48 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 51 */      MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 71
/* 55 */      MCD::OPC_CheckField, 30, 2, 3, 147, 0, // Skip to: 208
/* 61 */      MCD::OPC_CheckField, 5, 8, 0, 141, 0, // Skip to: 208
/* 67 */      MCD::OPC_Decode, 202, 4, 119, // Opcode: LDDCrr
/* 71 */      MCD::OPC_FilterValue, 1, 133, 0, // Skip to: 208
/* 75 */      MCD::OPC_CheckField, 30, 2, 3, 127, 0, // Skip to: 208
/* 81 */      MCD::OPC_Decode, 201, 4, 120, // Opcode: LDDCri
/* 85 */      MCD::OPC_FilterValue, 52, 37, 0, // Skip to: 126
/* 89 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 92 */      MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 112
/* 96 */      MCD::OPC_CheckField, 30, 2, 3, 106, 0, // Skip to: 208
/* 102 */     MCD::OPC_CheckField, 5, 8, 0, 100, 0, // Skip to: 208
/* 108 */     MCD::OPC_Decode, 217, 5, 121, // Opcode: STCrr
/* 112 */     MCD::OPC_FilterValue, 1, 92, 0, // Skip to: 208
/* 116 */     MCD::OPC_CheckField, 30, 2, 3, 86, 0, // Skip to: 208
/* 122 */     MCD::OPC_Decode, 216, 5, 122, // Opcode: STCri
/* 126 */     MCD::OPC_FilterValue, 55, 37, 0, // Skip to: 167
/* 130 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 133 */     MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 153
/* 137 */     MCD::OPC_CheckField, 30, 2, 3, 65, 0, // Skip to: 208
/* 143 */     MCD::OPC_CheckField, 5, 8, 0, 59, 0, // Skip to: 208
/* 149 */     MCD::OPC_Decode, 223, 5, 123, // Opcode: STDCrr
/* 153 */     MCD::OPC_FilterValue, 1, 51, 0, // Skip to: 208
/* 157 */     MCD::OPC_CheckField, 30, 2, 3, 45, 0, // Skip to: 208
/* 163 */     MCD::OPC_Decode, 222, 5, 124, // Opcode: STDCri
/* 167 */     MCD::OPC_FilterValue, 58, 37, 0, // Skip to: 208
/* 171 */     MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 174 */     MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 194
/* 178 */     MCD::OPC_CheckField, 29, 3, 4, 24, 0, // Skip to: 208
/* 184 */     MCD::OPC_CheckField, 5, 3, 0, 18, 0, // Skip to: 208
/* 190 */     MCD::OPC_Decode, 154, 6, 81, // Opcode: TRAPrr
/* 194 */     MCD::OPC_FilterValue, 32, 10, 0, // Skip to: 208
/* 198 */     MCD::OPC_CheckField, 29, 3, 4, 4, 0, // Skip to: 208
/* 204 */     MCD::OPC_Decode, 153, 6, 82, // Opcode: TRAPri
/* 208 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV932[] = {
/* 0 */       MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 3 */       MCD::OPC_FilterValue, 34, 45, 0, // Skip to: 52
/* 7 */       MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10 */      MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 34
/* 14 */      MCD::OPC_CheckPredicate, 0, 142, 1, // Skip to: 416
/* 18 */      MCD::OPC_CheckField, 30, 2, 3, 136, 1, // Skip to: 416
/* 24 */      MCD::OPC_CheckField, 5, 8, 0, 130, 1, // Skip to: 416
/* 30 */      MCD::OPC_Decode, 218, 4, 125, // Opcode: LDQFrr
/* 34 */      MCD::OPC_FilterValue, 1, 122, 1, // Skip to: 416
/* 38 */      MCD::OPC_CheckPredicate, 0, 118, 1, // Skip to: 416
/* 42 */      MCD::OPC_CheckField, 30, 2, 3, 112, 1, // Skip to: 416
/* 48 */      MCD::OPC_Decode, 217, 4, 126, // Opcode: LDQFri
/* 52 */      MCD::OPC_FilterValue, 38, 46, 0, // Skip to: 102
/* 56 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 59 */      MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 83
/* 63 */      MCD::OPC_CheckPredicate, 0, 93, 1, // Skip to: 416
/* 67 */      MCD::OPC_CheckField, 30, 2, 3, 87, 1, // Skip to: 416
/* 73 */      MCD::OPC_CheckField, 5, 8, 0, 81, 1, // Skip to: 416
/* 79 */      MCD::OPC_Decode, 245, 5, 127, // Opcode: STQFrr
/* 83 */      MCD::OPC_FilterValue, 1, 73, 1, // Skip to: 416
/* 87 */      MCD::OPC_CheckPredicate, 0, 69, 1, // Skip to: 416
/* 91 */      MCD::OPC_CheckField, 30, 2, 3, 63, 1, // Skip to: 416
/* 97 */      MCD::OPC_Decode, 244, 5, 128, 1, // Opcode: STQFri
/* 102 */     MCD::OPC_FilterValue, 48, 40, 0, // Skip to: 146
/* 106 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 109 */     MCD::OPC_FilterValue, 0, 15, 0, // Skip to: 128
/* 113 */     MCD::OPC_CheckPredicate, 0, 43, 1, // Skip to: 416
/* 117 */     MCD::OPC_CheckField, 30, 2, 3, 37, 1, // Skip to: 416
/* 123 */     MCD::OPC_Decode, 210, 4, 129, 1, // Opcode: LDFArr
/* 128 */     MCD::OPC_FilterValue, 1, 28, 1, // Skip to: 416
/* 132 */     MCD::OPC_CheckPredicate, 0, 24, 1, // Skip to: 416
/* 136 */     MCD::OPC_CheckField, 30, 2, 3, 18, 1, // Skip to: 416
/* 142 */     MCD::OPC_Decode, 209, 4, 103, // Opcode: LDFAri
/* 146 */     MCD::OPC_FilterValue, 50, 40, 0, // Skip to: 190
/* 150 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 153 */     MCD::OPC_FilterValue, 0, 15, 0, // Skip to: 172
/* 157 */     MCD::OPC_CheckPredicate, 0, 255, 0, // Skip to: 416
/* 161 */     MCD::OPC_CheckField, 30, 2, 3, 249, 0, // Skip to: 416
/* 167 */     MCD::OPC_Decode, 216, 4, 130, 1, // Opcode: LDQFArr
/* 172 */     MCD::OPC_FilterValue, 1, 240, 0, // Skip to: 416
/* 176 */     MCD::OPC_CheckPredicate, 0, 236, 0, // Skip to: 416
/* 180 */     MCD::OPC_CheckField, 30, 2, 3, 230, 0, // Skip to: 416
/* 186 */     MCD::OPC_Decode, 215, 4, 126, // Opcode: LDQFAri
/* 190 */     MCD::OPC_FilterValue, 51, 40, 0, // Skip to: 234
/* 194 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 197 */     MCD::OPC_FilterValue, 0, 15, 0, // Skip to: 216
/* 201 */     MCD::OPC_CheckPredicate, 0, 211, 0, // Skip to: 416
/* 205 */     MCD::OPC_CheckField, 30, 2, 3, 205, 0, // Skip to: 416
/* 211 */     MCD::OPC_Decode, 204, 4, 131, 1, // Opcode: LDDFArr
/* 216 */     MCD::OPC_FilterValue, 1, 196, 0, // Skip to: 416
/* 220 */     MCD::OPC_CheckPredicate, 0, 192, 0, // Skip to: 416
/* 224 */     MCD::OPC_CheckField, 30, 2, 3, 186, 0, // Skip to: 416
/* 230 */     MCD::OPC_Decode, 203, 4, 105, // Opcode: LDDFAri
/* 234 */     MCD::OPC_FilterValue, 52, 40, 0, // Skip to: 278
/* 238 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 241 */     MCD::OPC_FilterValue, 0, 15, 0, // Skip to: 260
/* 245 */     MCD::OPC_CheckPredicate, 0, 167, 0, // Skip to: 416
/* 249 */     MCD::OPC_CheckField, 30, 2, 3, 161, 0, // Skip to: 416
/* 255 */     MCD::OPC_Decode, 233, 5, 132, 1, // Opcode: STFArr
/* 260 */     MCD::OPC_FilterValue, 1, 152, 0, // Skip to: 416
/* 264 */     MCD::OPC_CheckPredicate, 0, 148, 0, // Skip to: 416
/* 268 */     MCD::OPC_CheckField, 30, 2, 3, 142, 0, // Skip to: 416
/* 274 */     MCD::OPC_Decode, 232, 5, 107, // Opcode: STFAri
/* 278 */     MCD::OPC_FilterValue, 54, 41, 0, // Skip to: 323
/* 282 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 285 */     MCD::OPC_FilterValue, 0, 15, 0, // Skip to: 304
/* 289 */     MCD::OPC_CheckPredicate, 0, 123, 0, // Skip to: 416
/* 293 */     MCD::OPC_CheckField, 30, 2, 3, 117, 0, // Skip to: 416
/* 299 */     MCD::OPC_Decode, 243, 5, 133, 1, // Opcode: STQFArr
/* 304 */     MCD::OPC_FilterValue, 1, 108, 0, // Skip to: 416
/* 308 */     MCD::OPC_CheckPredicate, 0, 104, 0, // Skip to: 416
/* 312 */     MCD::OPC_CheckField, 30, 2, 3, 98, 0, // Skip to: 416
/* 318 */     MCD::OPC_Decode, 242, 5, 128, 1, // Opcode: STQFAri
/* 323 */     MCD::OPC_FilterValue, 55, 40, 0, // Skip to: 367
/* 327 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 330 */     MCD::OPC_FilterValue, 0, 15, 0, // Skip to: 349
/* 334 */     MCD::OPC_CheckPredicate, 0, 78, 0, // Skip to: 416
/* 338 */     MCD::OPC_CheckField, 30, 2, 3, 72, 0, // Skip to: 416
/* 344 */     MCD::OPC_Decode, 225, 5, 134, 1, // Opcode: STDFArr
/* 349 */     MCD::OPC_FilterValue, 1, 63, 0, // Skip to: 416
/* 353 */     MCD::OPC_CheckPredicate, 0, 59, 0, // Skip to: 416
/* 357 */     MCD::OPC_CheckField, 30, 2, 3, 53, 0, // Skip to: 416
/* 363 */     MCD::OPC_Decode, 224, 5, 109, // Opcode: STDFAri
/* 367 */     MCD::OPC_FilterValue, 58, 45, 0, // Skip to: 416
/* 371 */     MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 374 */     MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 398
/* 378 */     MCD::OPC_CheckPredicate, 0, 34, 0, // Skip to: 416
/* 382 */     MCD::OPC_CheckField, 29, 3, 4, 28, 0, // Skip to: 416
/* 388 */     MCD::OPC_CheckField, 5, 3, 0, 22, 0, // Skip to: 416
/* 394 */     MCD::OPC_Decode, 148, 6, 81, // Opcode: TICCrr
/* 398 */     MCD::OPC_FilterValue, 32, 14, 0, // Skip to: 416
/* 402 */     MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 416
/* 406 */     MCD::OPC_CheckField, 29, 3, 4, 4, 0, // Skip to: 416
/* 412 */     MCD::OPC_Decode, 147, 6, 82, // Opcode: TICCri
/* 416 */     MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[Sparc::FeatureV9]);
  case 1:
    return (Bits[Sparc::FeatureOSA2011]);
  case 2:
    return (Bits[Sparc::FeaturePWRPSR]);
  case 3:
    return (Bits[Sparc::FeatureUA2005]);
  case 4:
    return (Bits[Sparc::FeatureVIS3]);
  case 5:
    return (Bits[Sparc::FeatureVIS]);
  case 6:
    return (Bits[Sparc::FeatureVIS2]);
  case 7:
    return (Bits[Sparc::FeatureUA2007]);
  case 8:
    return (Bits[Sparc::LeonCASA] || Bits[Sparc::FeatureV9]);
  }
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 19);
    if (!Check(S, DecodeDisp<19>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 22);
    if (!Check(S, DecodeDisp<22>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 22);
    if (!Check(S, DecodeDisp<22>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 14), 0, 14);
    insertBits(tmp, fieldFromInstruction(insn, 20, 2), 14, 2);
    if (!Check(S, DecodeDisp<16>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 5, 8), 0, 8);
    insertBits(tmp, fieldFromInstruction(insn, 19, 2), 8, 2);
    if (!Check(S, DecodeDisp<10>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 25, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 29, 1), 3, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 5, 8), 0, 8);
    insertBits(tmp, fieldFromInstruction(insn, 19, 2), 8, 2);
    if (!Check(S, DecodeDisp<10>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 25, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 29, 1), 3, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeSIMM5(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 0, 19);
    if (!Check(S, DecodeDisp<19>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 20, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 0, 30);
    if (!Check(S, DecodeCall(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 98:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 100:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 113:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 115:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 119:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 122:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 123:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 124:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 126:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 127:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 128:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 130:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 131:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 132:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 133:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 134:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  }
}

static unsigned decodeNumToSkip(const uint8_t *&Ptr) {
  unsigned NumToSkip = *Ptr++;
  NumToSkip |= (*Ptr++) << 8;
  return NumToSkip;
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr++) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr++;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      uint64_t Val = decodeULEB128AndIncUnsafe(Ptr);
      bool Failed = Val != CurFieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the filter operation.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << (Failed ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      bool Failed = ExpectedValue != FieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // If the actual and expected values don't match, skip.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << (Failed ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);
      // Check the predicate.
      bool Failed = !checkDecoderPredicate(PIdx, Bits);
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Failed ? "FAIL\n" : "PASS\n"));

      break;
    }
    case MCD::OPC_Decode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      uint64_t PositiveMask = decodeULEB128AndIncUnsafe(Ptr);
      uint64_t NegativeMask = decodeULEB128AndIncUnsafe(Ptr);
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // namespace
